<?php
  // Create menu
  $title = __('Configure', 'adblocker_detector');
  adb_menu($title);
 

  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value
  $enable = mb_param_update('enable', 'plugin_action', 'check', 'plugin-adblocker_detector');
  $only_home = mb_param_update('only_home', 'plugin_action', 'check', 'plugin-adblocker_detector');
  $type = mb_param_update('type', 'plugin_action', 'value', 'plugin-adblocker_detector');
  $custom_text = mb_param_update('custom_text', 'plugin_action', 'value', 'plugin-adblocker_detector');
  $show_image = mb_param_update('show_image', 'plugin_action', 'check', 'plugin-adblocker_detector');


  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'adblocker_detector') );
  }
?>


<div class="mb-body">
  <!-- CONFIGURE SECTION -->

  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-wrench"></i> <?php _e('Configure', 'adblocker_detector'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />


        <div class="mb-row">
          <label for="enable"><span><?php _e('Enable AdBlocker Modal', 'adblocker_detector'); ?></span></label> 
          <input name="enable" id="enable" type="checkbox" class="element-slide" <?php echo ($enable == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled and customer is using some kind of AdBlocker, modal will be shown to customer.', 'adblocker_detector'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="only_home"><span><?php _e('Enable Modal on Home Page Only', 'adblocker_detector'); ?></span></label> 
          <input name="only_home" id="only_home" type="checkbox" class="element-slide" <?php echo ($only_home == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, AdBlocker modal will be shown on home page only.', 'adblocker_detector'); ?></div>
          </div>
        </div>


        <div class="mb-row">
          <label for="type"><span><?php _e('Type of Modal', 'adblocker_detector'); ?></span></label> 
          
          <select name="type">
            <option value="REQUIRED" <?php if($type == 'REQUIRED') { ?>selected="selected"<?php } ?>><?php _e('Required - Modal cannot be closed', 'adblocker_detector'); ?></option>
            <option value="OPTIONAL" <?php if($type == 'OPTIONAL' || $type == '') { ?>selected="selected"<?php } ?>><?php _e('Optional - Modal can be closed', 'adblocker_detector'); ?></option>
          </select>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Select "optional" for more user-friendly reminder. If you are strictly based on income from ads, you may consider "required" option.', 'adblocker_detector'); ?></div>
          </div>
        </div>
        

        <div class="mb-row">
          <label for="custom_text"><span><?php _e('Custom Text in Modal', 'adblocker_detector'); ?></span></label> 
          <textarea name="custom_text" id="custom_text"><?php echo osc_esc_html($custom_text); ?></textarea>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Enter your own text shown to customers in modal box. You can also translate existing to whatever you need. Keep blank to use default text.', 'adblocker_detector'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="show_image"><span><?php _e('Stop Image in Modal', 'adblocker_detector'); ?></span></label> 
          <input name="show_image" id="show_image" type="checkbox" class="element-slide" <?php echo ($show_image == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, stop icon/image will be shown at top of modal.', 'adblocker_detector'); ?></div>
          </div>
        </div>

        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(adb_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'adblocker_detector')); ?>"><?php _e('Save', 'adblocker_detector');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'adblocker_detector');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>



  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'adblocker_detector'); ?></div>

    <div class="mb-inside">
      <div class="mb-row"><?php _e('No theme modification are required to use all functions of plugin.', 'adblocker_detector'); ?></div>
    </div>
  </div>
</div>


<?php echo adb_footer(); ?>