<?php
/*
  Plugin Name: AdBlocker Detector Plugin
  Plugin URI: https://osclasspoint.com/
  Description: Detects if visitor is using AdBlocker extension to hide advertisement and show pop-up to disable it.
  Version: 1.0.0
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: adblocker_detector
  Plugin update URI: adblocker-detector
  Support URI: https://forums.osclasspoint.com/
  Product Key: xQFfpbyJt23FfLDCWz92
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelADB.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';


// osc_enqueue_style('adb-user-style', osc_base_url() . 'oc-content/plugins/adblocker_detector/css/user.css?v=' . date('YmdHis'));
// osc_register_script('adb-user', osc_base_url() . 'oc-content/plugins/adblocker_detector/js/user.js?v=' . date('YmdHis'), array('jquery'));
// osc_enqueue_script('adb-user');


// INSTALL FUNCTION - DEFINE VARIABLES
function adb_call_after_install() {
  osc_set_preference('enable', 1, 'plugin-adblocker_detector', 'INTEGER');
  osc_set_preference('only_home', 0, 'plugin-adblocker_detector', 'INTEGER');
  osc_set_preference('show_image', 1, 'plugin-adblocker_detector', 'INTEGER');
  osc_set_preference('type', 'OPTIONAL', 'plugin-adblocker_detector', 'STRING');
  osc_set_preference('custom_text', '', 'plugin-adblocker_detector', 'STRING');

  ModelADB::newInstance()->install();
}


function adb_call_after_uninstall() {
  ModelADB::newInstance()->uninstall();
}


// ADMIN MENU
function adb_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/adblocker_detector/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/adblocker_detector/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/adblocker_detector/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/adblocker_detector/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/adblocker_detector/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/adblocker_detector/js/bootstrap-switch.js"></script>';

  if( $title == '') { $title = __('Configure', 'adblocker_detector'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>AdBlocker Detector Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=adblocker_detector/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'adblocker_detector') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function adb_footer() {
  $pluginInfo = osc_plugin_get_info('adblocker_detector/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint Market" /> OsclassPoint Market</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'adblocker_detector') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'adblocker_detector') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'adblocker_detector') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function adb_admin_menu() {
echo '<h3><a href="#">AdBlocker Detector Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'adblocker_detector') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','adb_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function adb_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'adb_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'adb_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'adb_call_after_uninstall');

?>