<?php
  // Create menu
  $title = __('Admins', 'admin_permission');
  apm_menu($title);
 

  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  if(Params::getParam('plugin_action') == 'done') {
    message_ok(__('Settings were successfully saved', 'admin_permission'));
  }
  
  $admins = ModelAPM::newInstance()->getAdmins(false);
?>


<div class="mb-body">
  <!-- PERMISSIONS SECTION -->
  
  <div class="mb-notes">
    <div class="mb-line"><?php _e('You can restrict or grant access to admins and moderators here.', 'admin_permission'); ?></div>
  </div>

  <div class="mb-box mb-admins">
    <div class="mb-head">
      <i class="fa fa-user"></i> <?php _e('Admins Permissions Setup', 'admin_permission'); ?>
    </div>

    <div class="mb-inside">
      <div class="mb-table mb-table-admins">
        <div class="mb-table-head">
          <div class="mb-col-3 mb-align-left"><?php _e('Admin (ID)', 'admin_permission');?></div>
          <div class="mb-col-2 mb-align-left"><?php _e('Role', 'admin_permission');?></div>
          <div class="mb-col-2 mb-align-left"><?php _e('Granted by', 'admin_permission');?></div>
          <div class="mb-col-2"><?php _e('Type', 'admin_permission');?></div>
          <div class="mb-col-11 mb-align-left"><?php _e('Permissions', 'admin_permission');?></div>
          <div class="mb-col-4 mb-align-right">&nbsp;</div>
        </div>

        <?php if(count($admins) <= 0) { ?>
          <div class="mb-table-row mb-row-empty">
            <i class="fa fa-warning"></i><span><?php _e('No admins has been found', 'admin_permission'); ?></span>
          </div>
        <?php } else { ?>
          <?php foreach($admins as $a) { ?>
            <?php $perms = ModelAPM::newInstance()->getAdminPerm($a['pk_i_id']); ?>
            
            <div class="mb-table-row">
              <div class="mb-col-3 mb-align-left"><?php echo $a['s_name'] . ' (#' . $a['pk_i_id'] . ')'; ?></div>
              <div class="mb-col-2 mb-align-left"><?php echo $a['b_moderator'] == 1 ? __('Moderator', 'admin_permission') : ($a['pk_i_id'] == apm_param('primary_admin') ? '<strong>' . __('Super admin', 'admin_permission') . '</strong>' : __('Admin', 'admin_permission')); ?></div>
              <div class="mb-col-2 mb-align-left">
                <?php 
                  if(empty($perms)) {
                    echo '<em>-</em>';
                  } else {
                    $adm = array();
                    
                    if(@$perms[0]['i_grantor_id'] > 0) {
                      $adm = Admin::newInstance()->findByPrimaryKey($perms[0]['i_grantor_id']);
                    }
                    
                    echo @$adm['s_name'] != '' ? $adm['s_name'] : '<em>-</em>';
                  }
                ?>
              </div>

              <div class="mb-col-2">
                <?php 
                  if(empty($perms)) {
                    echo '<em>-</em>';
                  } else {
                    echo '<strong>' . (@$perms[0]['s_type'] == 'GRANT' ? __('Grant access', 'admin_permission') : __('Restrict access', 'admin_permission')) . '</strong>';
                  }
                ?>
              </div>
              <div class="mb-col-11 mb-align-left">
                <?php 
                  $text = array();
                  
                  if($a['pk_i_id'] == apm_param('primary_admin')) {
                    echo __('Full access', 'admin_permission');
                  } else if(empty($perms)) {
                    echo '<em>' . __('Not set (standard)', 'admin_permission') . '</em>';
                  } else {
                    if(count($perms) > 0) {
                      foreach($perms as $p) {
                        $text[] = $p['s_name'];
                      }
                    }
                  }
                  
                  echo implode(', ', $text);
                ?>                
              </div>

              <div class="mb-col-4 mb-align-right mb-buts">
                <?php if(apm_is_demo()) { ?>
                  <a href="#" class="mb-btn mb-button-blue mb-has-tooltip-light mb-disabled" onclick="return false;" title="<?php echo osc_esc_html(__('Action cannot be done, this is demo site', 'admin_permission')); ?>"><i class="fa fa-pencil"></i> <?php _e('Configure', 'admin_permission'); ?></a>
                  <a href="#" class="mb-btn mb-button-white mb-has-tooltip-light mb-disabled" onclick="return false;" title="<?php echo osc_esc_html(__('Action cannot be done, this is demo site', 'admin_permission')); ?>"><i class="fa fa-times"></i> <?php _e('Clean', 'admin_permission'); ?></a>
                <?php } else if ($a['pk_i_id'] == apm_param('primary_admin')) { ?>
                  <a href="#" class="mb-btn mb-button-blue mb-has-tooltip-light mb-disabled" onclick="return false;" title="<?php echo osc_esc_html(__('Permissions for primary admin cannot be set', 'admin_permission')); ?>"><i class="fa fa-pencil"></i> <?php _e('Configure', 'admin_permission'); ?></a>
                  <a href="#" class="mb-btn mb-button-white mb-has-tooltip-light mb-disabled" onclick="return false;" title="<?php echo osc_esc_html(__('Permissions for primary admin cannot be set', 'admin_permission')); ?>"><i class="fa fa-times"></i> <?php _e('Clean', 'admin_permission'); ?></a>
                <?php } else { ?>
                  <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=admin_permission/admin/admin_edit.php&what=edit&adminId=<?php echo $a['pk_i_id']; ?>" class="mb-btn mb-button-blue"><i class="fa fa-pencil"></i> <?php _e('Configure', 'admin_permission'); ?></a>
                  <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=admin_permission/admin/admin_edit.php&what=remove&adminId=<?php echo $a['pk_i_id']; ?>" class="mb-btn mb-button-white mb-has-tooltip-light" title="<?php echo osc_esc_html(__('Clean permission', 'admin_permission')); ?>" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to clean permissions for this admin? Action cannot be undone.', 'admin_permission')); ?>')"><i class="fa fa-times"></i> <?php _e('Clean', 'admin_permission'); ?></a>
                <?php } ?>
              </div>
            </div>
          <?php } ?>
        <?php } ?>
      </div>
    </div>

  </div>
</div>


<?php echo apm_footer(); ?>