<?php
  // Create menu
  $title = __('Configure', 'admin_permission');
  apm_menu($title);
 

  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value
  $enable = mb_param_update('enable', 'plugin_action', 'check', 'plugin-admin_permission');
  $primary_admin = mb_param_update('primary_admin', 'plugin_action', 'value', 'plugin-admin_permission');

  
  if(Params::getParam('plugin_action') == 'done') {
    message_ok(__('Settings were successfully saved', 'admin_permission'));
  }
?>


<div class="mb-body">
  <!-- CONFIGURE SECTION -->
  
  <div class="mb-notes">
    <div class="mb-line"><?php _e('Plugin restrict access to administrator users in backoffice, <b>configure with care!</b>', 'admin_permission'); ?></div>
  </div>

  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-wrench"></i> <?php _e('Configure', 'admin_permission'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />

        <div class="mb-row">
          <label for="enable"><span><?php _e('Enable', 'admin_permission'); ?></span></label> 
          <input name="enable" id="enable" type="checkbox" class="element-slide" <?php echo ($enable == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, admin access will be restricted based on their permissions.', 'admin_permission'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="primary_admin"><span><?php _e('Primary Admin Account', 'admin_permission'); ?></span></label> 
          <select name="primary_admin">
            <?php foreach(ModelAPM::newInstance()->getAdmins() as $a) { ?>
              <option value="<?php echo $a['pk_i_id']; ?>" <?php if($a['pk_i_id'] == $primary_admin) { ?>selected="selected"<?php } ?>><?php echo $a['s_name'] . ' (#' . $a['pk_i_id'] . ')'; ?></option>
            <?php } ?>
          </select>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Select primary (master) admin account that is not affected by configuration of permissions.', 'admin_permission'); ?></div>
          </div>
        </div>
        

        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(apm_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'admin_permission')); ?>"><?php _e('Save', 'admin_permission');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'admin_permission');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>



  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'admin_permission'); ?></div>

    <div class="mb-inside">
      <div class="mb-row"><?php _e('No theme modification are required to use all functions of plugin.', 'admin_permission'); ?></div>
    </div>
  </div>
</div>


<?php echo apm_footer(); ?>