<?php
  // Create menu
  $title = __('Permissions', 'admin_permission');
  apm_menu($title);
 

  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  if(Params::getParam('plugin_action') == 'done') {
    message_ok(__('Settings were successfully saved', 'admin_permission'));
  }
  
  $sections = ModelAPM::newInstance()->getSections();
?>


<div class="mb-body">
  <!-- PERMISSIONS SECTION -->
  
  <div class="mb-notes">
    <div class="mb-line"><?php _e('Core permissions cannot be removed. You can add your own permissions for plugins, themes or custom sections.', 'admin_permission'); ?></div>
  </div>

  <?php foreach($sections as $s) { ?>
    <?php $perms = ModelAPM::newInstance()->getPerms($s['s_section']); ?>
    <div class="mb-box mb-perms">
      <div class="mb-head">
        <?php echo sprintf(__('Section: %s', 'admin_permission'), $s['s_section']); ?>
        <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=admin_permission/admin/permission_edit.php&what=add&section=<?php echo $s['s_section']; ?>" class="mb-btn mb-button-white"><i class="fa fa-plus-circle"></i> <?php _e('Add new', 'admin_permission'); ?></a>
      </div>

      <div class="mb-inside">
        <div class="mb-table mb-table-perms">
          <div class="mb-table-head">
            <div class="mb-col-6 mb-align-left"><?php _e('Permission (ID)', 'admin_permission');?></div>
            <div class="mb-col-10 mb-align-left"><?php _e('Parameters', 'admin_permission');?></div>
            <div class="mb-col-2"><?php _e('Core', 'admin_permission');?></div>
            <div class="mb-col-6 mb-align-right">&nbsp;</div>
          </div>

          <?php if(count($perms) <= 0) { ?>
            <div class="mb-table-row mb-row-empty">
              <i class="fa fa-warning"></i><span><?php _e('No permissions has been found', 'admin_permission'); ?></span>
            </div>
          <?php } else { ?>
            <?php foreach($perms as $p) { ?>
              <div class="mb-table-row">
                <div class="mb-col-6 mb-align-left"><?php echo $p['s_name'] . ' (#' . $p['pk_i_id'] . ')'; ?></div>
                <div class="mb-col-10 mb-align-left">
                  <?php 
                    $params = json_decode($p['s_params'], true); 
                    $list = array();
                    
                    if(is_array($params) && count($params) > 0) {
                      foreach($params as $key => $val) {
                        $list[] = '<span class="mb-el"><strong>' . $key . ':</strong> ' . $val . '</span>';
                      }
                    } else {
                      $list[] = '-';
                    }
                    
                    echo implode('', $list);
                  ?>                
                </div>
                <div class="mb-col-2"><?php echo $p['i_core'] == 1 ? __('Yes', 'admin_permission') : __('No', 'admin_permission'); ?></div>
                <div class="mb-col-6 mb-align-right mb-buts">
                  <?php if(apm_is_demo()) { ?>
                    <a href="#" class="mb-btn mb-button-blue mb-has-tooltip-light mb-disabled" onclick="return false;" title="<?php echo osc_esc_html(__('Action cannot be done, this is demo site', 'admin_permission')); ?>"><i class="fa fa-pencil"></i> <?php _e('Edit', 'admin_permission'); ?></a>
                    <a href="#" class="mb-btn mb-button-red mb-has-tooltip-light mb-disabled" onclick="return false;" title="<?php echo osc_esc_html(__('Action cannot be done, this is demo site', 'admin_permission')); ?>"><i class="fa fa-trash"></i> <?php _e('Remove', 'admin_permission'); ?></a>
                  <?php } else if ($p['i_core'] == 1 && !apm_is_debug()) { ?>
                    <a href="#" class="mb-btn mb-button-blue mb-has-tooltip-light mb-disabled" onclick="return false;" title="<?php echo osc_esc_html(__('Core permissions cannot be modified or removed', 'admin_permission')); ?>"><i class="fa fa-pencil"></i> <?php _e('Edit', 'admin_permission'); ?></a>
                    <a href="#" class="mb-btn mb-button-red mb-has-tooltip-light mb-disabled" onclick="return false;" title="<?php echo osc_esc_html(__('Core permissions cannot be modified or removed', 'admin_permission')); ?>"><i class="fa fa-trash"></i> <?php _e('Remove', 'admin_permission'); ?></a>
                  <?php } else { ?>
                    <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=admin_permission/admin/permission_edit.php&what=edit&permId=<?php echo $p['pk_i_id']; ?>" class="mb-btn mb-button-blue"><i class="fa fa-pencil"></i> <?php _e('Edit', 'admin_permission'); ?></a>
                    <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=admin_permission/admin/permission_edit.php&what=remove&permId=<?php echo $p['pk_i_id']; ?>" class="mb-btn mb-button-red mb-has-tooltip-light" title="<?php echo osc_esc_html(__('Remove permission', 'admin_permission')); ?>" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove this permission? Action cannot be undone.', 'admin_permission')); ?>')"><i class="fa fa-trash"></i> <?php _e('Remove', 'admin_permission'); ?></a>
                  <?php } ?>
                </div>
              </div>
            <?php } ?>
          <?php } ?>
        </div>
      </div>
    </div>
  <?php } ?>
  

  <div class="mb-box mb-add">
    <div class="mb-inside">
      <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=admin_permission/admin/permission_edit.php" class="mb-button-green mb-add"><i class="fa fa-plus-circle"></i><?php _e('Add a new permission', 'admin_permission'); ?></a>
    </div>
  </div>
</div>


<?php echo apm_footer(); ?>