<?php
/*
  Plugin Name: Admin Permissions Manager Plugin
  Plugin URI: https://osclasspoint.com/
  Description: Enhance oc-admin access management and allows admin users to create new admin accounts with limited access in backoffice.
  Version: 1.0.0
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: admin_permission
  Plugin update URI: admin-permission
  Support URI: https://forums.osclasspoint.com/
  Product Key: 6uQYzb4Kp3cXe89y2ibc
*/

define('APM_DEBUG', false);

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelAPM.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';


// INSTALL FUNCTION - DEFINE VARIABLES
function apm_call_after_install() {
  osc_set_preference('enable', 1, 'plugin-admin_permission', 'INTEGER');
  osc_set_preference('primary_admin', 1, 'plugin-admin_permission', 'INTEGER');

  ModelAPM::newInstance()->install();
}


function apm_call_after_uninstall() {
  ModelAPM::newInstance()->uninstall();
}


// ADMIN MENU
function apm_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/admin_permission/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/admin_permission/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/admin_permission/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/admin_permission/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/admin_permission/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/admin_permission/js/bootstrap-switch.js"></script>';

  if( $title == '') { $title = __('Configure', 'admin_permission'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Admin Permissions Manager Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=admin_permission/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'admin_permission') . '</span></a></li>';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=admin_permission/admin/permissions.php"><i class="fa fa-key"></i><span>' . __('Permissions', 'admin_permission') . '</span></a></li>';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=admin_permission/admin/admins.php"><i class="fa fa-user"></i><span>' . __('Admins', 'admin_permission') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function apm_footer() {
  $pluginInfo = osc_plugin_get_info('admin_permission/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint Market" /> OsclassPoint Market</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'admin_permission') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'admin_permission') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'admin_permission') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function apm_admin_menu() {
echo '<h3><a href="#">Admin Permissions Manager Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'admin_permission') . '</a></li>
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/permissions.php') . '">&raquo; ' . __('Permissions', 'admin_permission') . '</a></li>
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/admins.php') . '">&raquo; ' . __('Admins', 'admin_permission') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','apm_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function apm_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'apm_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'apm_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'apm_call_after_uninstall');

?>