SET FOREIGN_KEY_CHECKS=0;


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_apm_permission;
CREATE TABLE /*TABLE_PREFIX*/t_apm_permission (
  pk_i_id INT NOT NULL AUTO_INCREMENT,
  s_section VARCHAR(50),
  s_name VARCHAR(50),
  s_params VARCHAR(500),
  i_core TINYINT(1) DEFAULT 1,

  PRIMARY KEY (pk_i_id)
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_apm_admin;
CREATE TABLE /*TABLE_PREFIX*/t_apm_admin (
  fk_i_admin_id INT UNSIGNED NOT NULL,
  fk_i_permission_id INT NOT NULL,
  i_grantor_id INT,
  s_type VARCHAR(20),
  dt_date TIMESTAMP,
  
  PRIMARY KEY (fk_i_admin_id, fk_i_permission_id),
  FOREIGN KEY (fk_i_admin_id) REFERENCES /*TABLE_PREFIX*/t_admin (pk_i_id) ON DELETE CASCADE ON UPDATE CASCADE,
  FOREIGN KEY (fk_i_permission_id) REFERENCES /*TABLE_PREFIX*/t_apm_permission (pk_i_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';


INSERT INTO /*TABLE_PREFIX*/t_apm_permission (s_section, s_name, s_params) VALUES
('Dashboard', 'Home Page', '{"page":"main","action":""}'),
('Dashboard', 'Manage Widgets', '{"page":"dashboard","action":"settings"}'),
('Dashboard', 'View Widget Content', '{"page":"main","action":"widget"}'),
('Listings', 'Manage Listings', '{"page":"items","action":""}'),
('Listings', 'Bulk Actions on Listings', '{"page":"items","action":"bulk_actions"}'),
('Listings', 'Add Listing', '{"page":"items","action":"post,post_item"}'),
('Listings', 'Edit Listing', '{"page":"items","action":"item_edit"}'),
('Listings', 'Delete Listing', '{"page":"items","action":"delete"}'),
('Listings', 'Activate/Deactivate Listing', '{"page":"items","action":"status","value":"ACTIVE,INACTIVE"}'),
('Listings', 'Block/Unblock Listing', '{"page":"items","action":"status","value":"ENABLE,DISABLE"}'),
('Listings', 'Mark/Unmark as Spam', '{"page":"items","action":"status_spam"}'),
('Listings', 'Renew Listing', '{"page":"items","action":"renew"}'),
('Listings', 'Mark/Unmark as Premium', '{"page":"items","action":"status_premium"}'),
('Listings', 'Reported Listings', '{"page":"items","action":"items_reported"}'),
('Listings', 'Manage Media', '{"page":"media","action":""}'),
('Listings', 'Manage Comments', '{"page":"comments","action":""}'),
('Listings', 'Activate/Deactivate Comment', '{"page":"comments","action":"status","value":"ACTIVE,INACTIVE"}'),
('Listings', 'Block/Unblock Comment', '{"page":"comments","action":"status","value":"ENABLE,DISABLE"}'),
('Listings', 'Edit Comment', '{"page":"comments","action":"comment_edit"}'),
('Listings', 'Delete Comment', '{"page":"comments","action":"delete"}'),
('Listings', 'Manage Custom Fields', '{"page":"cfields","action":""}'),
('Listings', 'Listings Settings', '{"page":"items","action":"settings"}'),
('Appearance', 'Manage Themes', '{"page":"appearance","action":""}'),
('Appearance', 'Configure Theme', '{"page":"appearance","action":"render"}'),
('Appearance', 'Upload Theme', '{"page":"appearance","action":"add"}'),
('Appearance', 'Activate Theme', '{"page":"appearance","action":"activate"}'),
('Appearance', 'Delete Theme', '{"page":"appearance","action":"delete"}'),
('Appearance', 'Manage Widgets', '{"page":"appearance","action":"widgets"}'),
('Plugins', 'Manage Plugins', '{"page":"plugins","action":""}'),
('Plugins', 'Bulk Actions on Plugins', '{"page":"plugins","action":"bulk_actions"}'),
('Plugins', 'Configure Plugin', '{"page":"plugins","action":"admin"}'),
('Plugins', 'Upload Plugin', '{"page":"plugins","action":"add"}'),
('Plugins', 'Install Plugin', '{"page":"plugins","action":"install"}'),
('Plugins', 'Uninstall Plugin', '{"page":"plugins","action":"uninstall"}'),
('Plugins', 'Enable Plugin', '{"page":"plugins","action":"enable"}'),
('Plugins', 'Disable Plugin', '{"page":"plugins","action":"disable"}'),
('Plugins', 'Delete Plugin', '{"page":"plugins","action":"delete"}'),
('Market', 'Manage Market', '{"page":"market","action":""}'),
('Market', 'Market Themes', '{"page":"market","action":"themes"}'),
('Market', 'Market Plugins', '{"page":"market","action":"plugins"}'),
('Market', 'Market Languages', '{"page":"market","action":"languages"}'),
('Market', 'Market Locations', '{"page":"market","action":"locations"}'),
('Stats', 'Listings Stats', '{"page":"tools","action":"items"}'),
('Stats', 'Reports Stats', '{"page":"tools","action":"reports"}'),
('Stats', 'Users Stats', '{"page":"tools","action":"users"}'),
('Stats', 'Comments Stats', '{"page":"tools","action":"comments"}'),
('Settings', 'General Settings', '{"page":"settings","action":""}'),
('Settings', 'Optimization', '{"page":"settings","action":"optimization"}'),
('Settings', 'Categories', '{"page":"categories","action":""}'),
('Settings', 'Comments', '{"page":"settings","action":"comments"}'),
('Settings', 'Locations', '{"page":"settings","action":"locations"}'),
('Settings', 'Email Templates', '{"page":"emails","action":""}'),
('Settings', 'Edit Email Template', '{"page":"emails","action":"edit"}'),
('Settings', 'Languages', '{"page":"languages","action":""}'),
('Settings', 'Permalinks', '{"page":"settings","action":"permalink"}'),
('Settings', 'Spam and Bots', '{"page":"settings","action":"spamNbots"}'),
('Settings', 'Currencies', '{"page":"settings","action":"currencies"}'),
('Settings', 'Mail Server', '{"page":"settings","action":"mailserver"}'),
('Settings', 'Media', '{"page":"settings","action":"media"}'),
('Settings', 'Latest Searches', '{"page":"settings","action":"latestsearches"}'),
('Settings', 'Breadcrumbs', '{"page":"settings","action":"breadcrumbs"}'),
('Settings', 'Advanced', '{"page":"settings","action":"advanced"}'),
('Pages', 'Manage Pages', '{"page":"pages","action":""}'),
('Pages', 'Add Page', '{"page":"pages","action":"add"}'),
('Pages', 'Edit Page', '{"page":"pages","action":"edit"}'),
('Pages', 'Delete Page', '{"page":"pages","action":"delete"}'),
('Users', 'Manage Users', '{"page":"users","action":""}'),
('Users', 'Bulk Actions on Users', '{"page":"users","action":"bulk_actions"}'),
('Users', 'Add User', '{"page":"users","action":"add"}'),
('Users', 'Edit User', '{"page":"users","action":"edit"}'),
('Users', 'Delete User', '{"page":"users","action":"delete"}'),
('Users', 'Login as user', '{"page":"users","action":"login"}'),
('Users', 'Activate User', '{"page":"users","action":"activate"}'),
('Users', 'Deactivate User', '{"page":"users","action":"deactivate"}'),
('Users', 'Block User', '{"page":"users","action":"block"}'),
('Users', 'Unblock User', '{"page":"users","action":"unblock"}'),
('Users', 'Resend activation', '{"page":"users","action":"resend_activation"}'),
('Users', 'User settings', '{"page":"users","action":"settings"}'),
('Users', 'Manage Alerts', '{"page":"users","action":"alerts"}'),
('Users', 'Manage Ban Rules', '{"page":"users","action":"ban"}'),
('Admins', 'Manage Admins', '{"page":"admins","action":""}'),
('Admins', 'Add Admin', '{"page":"admins","action":"add"}'),
('Admins', 'Edit Admin', '{"page":"admins","action":"edit"}'),
('Admins', 'Delete Admin', '{"page":"admins","action":"delete"}'),
('Tools', 'Configuration Info', '{"page":"tools","action":"info"}'),
('Tools', 'Data Clean Up', '{"page":"tools","action":"cleanup"}'),
('Tools', 'Debug/Error Log', '{"page":"tools","action":"debug"}'),
('Tools', 'Import Data', '{"page":"tools","action":"import"}'),
('Tools', 'Backup Data', '{"page":"tools","action":"backup"}'),
('Tools', 'Upgrade Osclass', '{"page":"tools","action":"upgrade"}'),
('Tools', 'Location Stats', '{"page":"tools","action":"locations"}'),
('Tools', 'Category Stats', '{"page":"tools","action":"category"}'),
('Tools', 'Maintenance mode', '{"page":"tools","action":"maintenance"}'),
('Tools', 'Changelog', '{"page":"tools","action":"version"}');


SET FOREIGN_KEY_CHECKS=1;