<?php
class ModelAR extends DAO {
  private static $instance;

  public static function newInstance() {
    if( !self::$instance instanceof self ) {
      self::$instance = new self;
    }
    return self::$instance;
  }

  function __construct() { 
    parent::__construct(); 
  }

  public function getTable_User() {
    return DB_TABLE_PREFIX.'t_user';
  }

  public function getTable_Item() {
    return DB_TABLE_PREFIX.'t_item';
  }

  // LOGS
  public function insertUser( $userData ) {
    $aSet = array(
      'dt_reg_date' => date('Y-m-d H:i:s'),
      'dt_access_date' => date('Y-m-d H:i:s'),
      's_name' => trim($userData['s_name']),
      's_password' => osc_hash_password($userData['s_password']),
      's_secret' => $userData['s_secret'],
      's_email' => trim($userData['s_email']),
      'i_items' => (osc_user_validation_enabled() ? 0 : 1),
      'b_enabled' => 1,
      'b_active' => 0,
      'fk_c_country_code' => $userData['countryId'],
      's_country' => $userData['country'],
      'fk_i_region_id' => $userData['regionId'],
      's_region' => $userData['region'],
      'fk_i_city_id' => $userData['cityId'],
      's_city' => $userData['city'],
      's_phone_mobile' => $userData['s_phone_mobile']
    );

    return $this->dao->insert( $this->getTable_User(), $aSet);
  }
  


  public function updateUsername( $user_id, $user_name ) {
    $aSet = array('s_username' => $user_name);
    $aWhere = array('pk_i_id' => $user_id);

    return $this->_update($this->getTable_User(), $aSet, $aWhere);
  }



  public function updateUserActive( $user_id, $active ) {
    $aSet = array('b_active' => $active);
    $aWhere = array('pk_i_id' => $user_id);

    return $this->_update($this->getTable_User(), $aSet, $aWhere);
  }



  public function updateUserId( $item_id, $user_id ) {
    $aSet = array('fk_i_user_id' => $user_id);
    $aWhere = array('pk_i_id' => $item_id);

    return $this->_update($this->getTable_Item(), $aSet, $aWhere);
  }



  public function loginUserById($user_id) {
    $user = User::newInstance()->findByPrimaryKey( $user_id );

    if( !$user ) { return 0; }
    if( !$user['b_active'] ) { return 1; }
    if( !$user['b_enabled'] ) { return 2; }

    //we are logged in... let's go!
    Session::newInstance()->_set('userId', $user['pk_i_id']);
    Session::newInstance()->_set('userName', $user['s_name']);
    Session::newInstance()->_set('userEmail', $user['s_email']);
    $phone = ($user['s_phone_mobile']) ? $user['s_phone_mobile'] : $user['s_phone_land'];
    Session::newInstance()->_set('userPhone', $phone);

    return 3;
  }


  // update
  function _update($table, $values, $where) {
    $this->dao->from($table);
    $this->dao->set($values);
    $this->dao->where($where);
    return $this->dao->update();
  }
}
?>