<?php

$pluginInfo = osc_plugin_get_info('backoffice_manager/index.php');

$dao_preference = new Preference();

//get max value to generate order select
$list = ModelLS::newInstance()->getStatusList();
$max_status = count($list)+1;
$max_status_id = ModelLS::newInstance()->getMaxStatus();

if(Params::getParam('plugin_action')=='new_status') {
  $name = Params::getParam('status_name');
  $order = Params::getParam('status_order');
  $style = Params::getParam('status_style');
  $default = Params::getParam('status_default');
  $email = Params::getParam('status_email');
  $sold = Params::getParam('status_sold');

  $default = ($default == 'on' ? 1 : 0);
  $email = ($email == 'on' ? 1 : 0);
  $sold = ($sold == 'on' ? 1 : 0);

  $max_status++;

  if($name <> '') {
    ModelLS::newInstance()->addStatus( $name, $style, $order, $default, $email, $sold );

    if($default == 1) {
      ModelLS::newInstance()->updateStatusDefault( $max_status_id+1 );
    }
  
    message_ok(__('Status', 'backoffice_manager') . ' <strong>' . $name . '</strong> ' . __('was successfully added!', 'backoffice_manager'));
  } else {
    message_error('<strong>' .__('Name', 'backoffice_manager') . '</strong> ' . __('field cannot be empty!', 'backoffice_manager'));
  }
}

if(Params::getParam('plugin_action')=='edit_status') {
  $status_list = ModelLS::newInstance()->getStatusList();
  foreach($status_list as $status) {
    $name = Params::getParam('status_name_' . $status['status_id']);
    $order = Params::getParam('status_order_' . $status['status_id']);
    $default = (Params::getParam('status_default_' . $status['status_id']) == 'on' ? 1 : 0);
    $email = (Params::getParam('status_email_' . $status['status_id']) == 'on' ? 1 : 0);
    $sold = (Params::getParam('status_sold_' . $status['status_id']) == 'on' ? 1 : 0);
    $style = Params::getParam('status_style_' . $status['status_id']);

    if($name == '') {
      message_error('<strong>' .__('Name', 'backoffice_manager') . '</strong> ' . __('field cannot be empty: Status ID', 'backoffice_manager') . ' ' .$status['status_id']);
    } else {
      ModelLS::newInstance()->updateStatus($status['status_id'], $name, $style, $order, $default, $email, $sold);

      if($default == 1) {
        ModelLS::newInstance()->updateStatusDefault( $status['status_id'] );
      }
      message_ok(__('Status', 'backoffice_manager') . ' <strong>' . $name . '</strong> ' . __('was successfully updated!', 'backoffice_manager'));
    }
  }
}

if(Params::getParam('plugin_action')=='delete_status') {
  $status_id = Params::getParam('status_delete_id');

  if($status_id <> '') {
    ModelLS::newInstance()->deleteStatus($status_id);
    message_ok(__('Status', 'backoffice_manager') . ' <strong>' . $name . '</strong> ' . __('was successfully deleted!', 'backoffice_manager'));
  } else {
    message_error(__('There is no status ID to delete.', 'backoffice_manager'));
  }
}

$autohook_status = '';
if(Params::getParam('autohook_status')=='on') {
  $autohook_status = 1;
} else {
  if(Params::getParam('plugin_action')=='done') {
    $autohook_status = 0;
  } else {
    $autohook_status = (osc_get_preference('bo_mgr_autohook_status', 'plugin-bo_mgr') != '') ? osc_get_preference('bo_mgr_autohook_status', 'plugin-bo_mgr') : '' ;
  }
}

$autohook_status_search = '';
if(Params::getParam('autohook_status_search')=='on') {
  $autohook_status_search = 1;
} else {
  if(Params::getParam('plugin_action')=='done') {
    $autohook_status_search = 0;
  } else {
    $autohook_status_search = (osc_get_preference('bo_mgr_autohook_status_search', 'plugin-bo_mgr') != '') ? osc_get_preference('bo_mgr_autohook_status_search', 'plugin-bo_mgr') : '' ;
  }
}

$status_email = '';
if(Params::getParam('status_email')=='on') {
  $status_email = 1;
} else {
  if(Params::getParam('plugin_action')=='done') {
    $status_email = 0;
  } else {
    $status_email = (osc_get_preference('bo_mgr_status_email', 'plugin-bo_mgr') != '') ? osc_get_preference('bo_mgr_status_email', 'plugin-bo_mgr') : '' ;
  }
}

$status_to_filter = '';
if(Params::getParam('status_to_filter')=='on') {
  $status_to_filter = 1;
} else {
  if(Params::getParam('plugin_action')=='done') {
    $status_to_filter = 0;
  } else {
    $status_to_filter = (osc_get_preference('bo_mgr_status_to_filter', 'plugin-bo_mgr') != '') ? osc_get_preference('bo_mgr_status_to_filter', 'plugin-bo_mgr') : '' ;
  }
}


$status_post_enable = '';
if(Params::getParam('status_post_enable') != '') {
  $status_post_enable = Params::getParam('status_post_enable');
} else {
  $status_post_enable = (osc_get_preference('bo_mgr_status_post_enable', 'plugin-bo_mgr') != '') ? osc_get_preference('bo_mgr_status_post_enable', 'plugin-bo_mgr') : '' ;
}

$status_edit_enable = '';
if(Params::getParam('status_edit_enable') != '') {
  $status_edit_enable = Params::getParam('status_edit_enable');
} else {
  $status_edit_enable = (osc_get_preference('bo_mgr_status_edit_enable', 'plugin-bo_mgr') != '') ? osc_get_preference('bo_mgr_status_edit_enable', 'plugin-bo_mgr') : '' ;
}

if(Params::getParam('plugin_action')=='done') {
  $dao_preference->update(array("s_value" => $autohook_status), array("s_section" => "plugin-bo_mgr", "s_name" => "bo_mgr_autohook_status"));
  $dao_preference->update(array("s_value" => $autohook_status_search), array("s_section" => "plugin-bo_mgr", "s_name" => "bo_mgr_autohook_status_search"));
  $dao_preference->update(array("s_value" => $status_post_enable), array("s_section" => "plugin-bo_mgr", "s_name" => "bo_mgr_status_post_enable"));
  $dao_preference->update(array("s_value" => $status_edit_enable), array("s_section" => "plugin-bo_mgr", "s_name" => "bo_mgr_status_edit_enable"));
  $dao_preference->update(array("s_value" => $status_to_filter), array("s_section" => "plugin-bo_mgr", "s_name" => "bo_mgr_status_to_filter"));
  $dao_preference->update(array("s_value" => $status_email), array("s_section" => "plugin-bo_mgr", "s_name" => "bo_mgr_status_email"));

  osc_reset_preferences();    
  message_ok(__('Settings for statuses were saved.','backoffice_manager'));
}

unset($dao_preference);
?>

<div id="settings_form" class="items">
  <?php echo bo_mgr_config_menu(); ?>

  <form name="promo_form" id="promo_form" class="" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
  <input type="hidden" name="page" value="plugins" />
  <input type="hidden" name="action" value="renderplugin" />
  <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>status.php" />
  <input type="hidden" name="plugin_action" value="done" />
  <br />
  
  <fieldset class="round4">

    <legend class="green round2"><?php _e('Status settings','backoffice_manager'); ?></legend>

    <div class="title"><?php _e('Status manager settings', 'backoffice_manager'); ?></div>
    <div class="del" style="margin:1px 0 10px 0;"></div>

    <input type="checkbox" id="status_to_filter" name="status_to_filter" <?php echo ($status_to_filter == 1 ? 'checked' : ''); ?>/>
    <label for="status_to_filter" class="check"><?php _e('Allow users to search by status', 'backoffice_manager'); ?> <sup class="sup-go go1">(1)</sup></label>

    <div class="clear" style="margin:6px 0;"></div>

    <input type="checkbox" id="status_email" name="status_email" <?php echo ($status_email == 1 ? 'checked' : ''); ?>/>
    <label for="status_email" class="check"><?php _e('When new item is created, send email with possibility to change status anytime', 'backoffice_manager'); ?> <sup class="sup-go go2">(2)</sup></label>

    <div class="clear" style="margin:6px 0;"></div>

    <input type="checkbox" id="autohook_status" name="autohook_status" <?php echo ($autohook_status == 1 ? 'checked' : ''); ?>/>
    <label for="autohook_status" class="check"><?php _e('Autohook listing status select box to item post & edit form', 'backoffice_manager'); ?> <sup class="sup-go go3">(3)</sup></label>

    <div class="clear" style="margin:6px 0;"></div>

    <input type="checkbox" id="autohook_status_search" name="autohook_status_search" <?php echo ($autohook_status_search == 1 ? 'checked' : ''); ?>/>
    <label for="autohook_status_search" class="check"><?php _e('Autohook listing status select box to search form', 'backoffice_manager'); ?> <sup class="sup-go go4">(4)</sup></label>

    <?php if($status_to_filter <> 1) { ?>
      <div class="clear" style="margin:6px 0;"></div>
      <span style="font-size:11px;<?php if($status_to_filter <> 1) { ?>color:red;<?php } ?>"><?php if($status_to_filter <> 1) { _e('(You need to allow to use Status in search filters first.)', 'backoffice_manager'); } ?></span>
    <?php } ?>

    <div class="clear" style="margin:15px 0;"></div>

    <label for="status_post_enable" class="normal sel-sup2"><?php _e('Enable users to add own status to when adding new listing', 'backoffice_manager'); ?>: <sup class="sup-go go5">(5)</sup></label>
    <select id="status_post_enable" name="status_post_enable">
      <option value="0" <?php if($status_post_enable == 0) {?>selected="selected"<?php } ?>><?php _e('Only admin', 'backoffice_manager'); ?></option>
      <option value="1" <?php if($status_post_enable == 1) {?>selected="selected"<?php } ?>><?php _e('Every user', 'backoffice_manager'); ?></option>
      <option value="2" <?php if($status_post_enable == 2) {?>selected="selected"<?php } ?>><?php _e('Registered user', 'backoffice_manager'); ?></option>
    </select>

    <div class="clear" style="margin:6px 0;"></div>

    <label for="status_edit_enable" class="normal sel-sup2"><?php _e('Enable users to add own status to when editing listing', 'backoffice_manager'); ?>: <sup class="sup-go go5">(6)</sup></label>
    <select id="status_edit_enable" name="status_edit_enable">
      <option value="0" <?php if($status_edit_enable == 0) {?>selected="selected"<?php } ?>><?php _e('Only admin', 'backoffice_manager'); ?></option>
      <option value="1" <?php if($status_edit_enable == 1) {?>selected="selected"<?php } ?>><?php _e('Every user', 'backoffice_manager'); ?></option>
      <option value="2" <?php if($status_edit_enable == 2) {?>selected="selected"<?php } ?>><?php _e('Registered user', 'backoffice_manager'); ?></option>
    </select>

    <div class="clear" style="margin:6px 0;"></div>
    <br />

    <div class="code"><?php _e('Place status select to item post & edit page manually using this function: ', 'backoffice_manager'); ?><br /><strong>&lt;?php bo_mgr_status_post_form($item_id); ?&gt;</strong></div>
    <div class="code"><?php _e('Place status select to search page form manually using this function: ', 'backoffice_manager'); ?><br /><strong>&lt;?php bo_mgr_status_search_form(); ?&gt;</strong></div>
    <div class="code"><?php _e('Place status on listings page or search page using function: ', 'backoffice_manager'); ?><br /><strong>&lt;?php echo bo_mgr_show_status(); ?&gt;</strong></div>

  </fieldset>
  <br />

  <button name="theButton" id="theButton" type="submit" style="float: left;" class="btn btn-submit"><?php _e('Save settings', 'backoffice_manager');?></button>
  </form>

  <div class="clear"></div>
  <br /><br />

  <div class="warn"><sup class="sup-go1">(1)</sup> <?php _e('Add status list to search filters so people can filter listing by status.', 'backoffice_manager'); ?></div>
  <div class="warn"><sup class="sup-go2">(2)</sup> <?php _e('When new listing is created, user will receive email with list of statuses and information that status can be changed anytime. Only statuses that are marked as "Email" will be send.', 'backoffice_manager'); ?></div>
  <div class="warn"><sup class="sup-go3">(3)</sup> <?php _e('Autohook listing status select box to item_post.php & item_edit.php. Users will be able to add status to their listings (Reserved, Sold, ...). You can manage statuses in "Status Manager" section.', 'backoffice_manager'); ?></div>
  <div class="warn"><sup class="sup-go4">(4)</sup> <?php _e('Autohook listing status select box to search page form.', 'backoffice_manager'); ?></div>
  <div class="warn"><sup class="sup-go5">(5,6)</sup> <?php _e('Allow users to add own status to listing when posting new listing or editing existing listing', 'backoffice_manager'); ?></div>

  <div class="clear"></div>
  <br /><br />

  <form name="promo_form" id="promo_form" class="status_block" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
  <input type="hidden" name="page" value="plugins" />
  <input type="hidden" name="action" value="renderplugin" />
  <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>status.php" />
  <input type="hidden" name="plugin_action" value="new_status" />
  <br />
  
  <fieldset class="round4 new_status">

    <legend class="green round2"><?php _e('Create new status','backoffice_manager'); ?></legend>

    <label for="status_name" style="font-weight: bold;"><?php _e('Name:', 'backoffice_manager'); ?></label>
    <input type="text" id="status_name" name="status_name" />

    <div class="clear"></div>

    <label for="status_order" style="font-weight: bold;"><?php _e('Order:', 'backoffice_manager'); ?></label>

    <select id="status_order" name="status_order">
      <?php
        for($i=1;$i<=$max_status;$i++) {
          echo '<option value="' .  $i . '" ' . ($max_status == $i ? 'selected="selected"' : '') . '>' . $i . '</option>';
        }
      ?>
    </select>

    <div class="clear"></div>

    <label for="status_style" style="font-weight: bold;"><?php _e('CSS Style:', 'backoffice_manager'); ?></label>
    <textarea id="status_style" name="status_style" ></textarea>
    <div class="code round3"><?php _e('Example: float:left;clear:both;background:#cccccc;width:150px;text-align:center;', 'backoffice_manager'); ?></div>

    <div class="clear del" style="width:61%;margin:12px 0 6px 15%;"></div>
    <div class="clear"></div>

    <input type="checkbox" id="status_default" name="status_default"/>
    <label for="status_default" class="check"><?php _e('Make this status default - on publish / edit page, this status will be default option is select.', 'backoffice_manager'); ?></label>

    <div class="clear" style="margin:0;"></div>

    <input type="checkbox" id="status_email" name="status_email"/>
    <label for="status_email" class="check"><?php _e('Status will be emailed when new listing is published to inform user that status can be set for listing.', 'backoffice_manager'); ?></label>

    <input type="checkbox" id="status_sold" name="status_sold"/>
    <label for="status_sold" class="check"><?php _e('When this status is set, listing will immediately expire and will not be available in front-office ("Sold" status type).', 'backoffice_manager'); ?></label>

    <br /><br />
    

  </fieldset>
  <br />

  <button name="theButton" id="theButton" type="submit" style="float: left;" class="btn btn-submit"><?php _e('Add status', 'backoffice_manager');?></button>
  </form>

  <div class="clear"></div>
  <br /><br /><br /><br />


  <form name="promo_form" id="promo_form" class="status_block" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
  <input type="hidden" name="page" value="plugins" />
  <input type="hidden" name="action" value="renderplugin" />
  <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>status.php" />
  <input type="hidden" name="plugin_action" value="edit_status" />
  <br />
  
  <fieldset class="round4 edit_status">

    <legend class="green round2"><?php _e('Modify status','backoffice_manager'); ?></legend>

    <div class="tbl-row head">
      <div class="name"><?php _e('Name', 'backoffice_manager'); ?></div>
      <div class="order"><?php _e('Order', 'backoffice_manager'); ?></div>
      <div class="style"><?php _e('Style', 'backoffice_manager'); ?></div>
      <div class="default"><?php _e('Default', 'backoffice_manager'); ?></div>
      <div class="email"><?php _e('Email', 'backoffice_manager'); ?></div>
      <div class="sold"><?php _e('Sold', 'backoffice_manager'); ?></div>
      <div class="delete"></div>
    </div>

    <div class="clear del"></div>

    <?php
      $status_list = ModelLS::newInstance()->getStatusList();
      if(empty($status_list)) {
        echo '<div class="tbl-row" style="color:red;margin-top: 5px; font-size: 12px; font-style: italic;">' . __('No status was added yet.', 'backoffice_manager') . '</div>';
      }

      foreach($status_list as $status) {
    ?>

      <div class="tbl-row">
        <div class="name">
          <input type="text" id="status_name" name="status_name_<?php echo $status['status_id']; ?>" value="<?php echo $status['status_name']; ?>" />
        </div>

        <div class="order">
          <select id="status_order" name="status_order_<?php echo $status['status_id']; ?>">
            <?php
              for($i=1;$i<$max_status;$i++) {
                echo '<option value="' .  $i . '" ' . ($status['status_order'] == $i ? 'selected="selected"' : '') . '>' . $i . '</option>';
              }
            ?>
          </select>
        </div>

        <div class="style">
          <input type="text" id="status_style" name="status_style_<?php echo $status['status_id']; ?>" value="<?php echo $status['status_style']; ?>"/>
        </div>

        <div class="default round3">
          <input type="checkbox" id="status_default" name="status_default_<?php echo $status['status_id']; ?>" <?php echo ($status['status_default'] == 1 ? 'checked' : ''); ?>/>
        </div>

        <div class="email round3">
          <input type="checkbox" id="status_email" name="status_email_<?php echo $status['status_id']; ?>" <?php echo ($status['status_email'] == 1 ? 'checked' : ''); ?>/>
        </div>

        <div class="sold round3">
          <input type="checkbox" id="status_sold" name="status_sold_<?php echo $status['status_id']; ?>" <?php echo ($status['status_sold'] == 1 ? 'checked' : ''); ?>/>
        </div>

        <div class="delete round3">
          <a title="<?php _e('Delete this status', 'backoffice_manager'); ?>" class="delete_link" onclick="return confirm('<?php echo __('Are you sure you want to delete status', 'backoffice_manager') . ' ' . $status['status_name'] . ' (id: ' . $status['status_id'] . ')';?>?')" href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=backoffice_manager/admin/status.php&plugin_action=delete_status&status_delete_id=<?php echo $status['status_id']; ?>"><img src="<?php echo osc_base_url();?>oc-content/plugins/backoffice_manager/images/delete.png" /></a>
        </div>
      </div>
    <?php
      }
    ?>

    <br /><br />
    

  </fieldset>
  <br />

  <button name="theButton" id="theButton" type="submit" style="float: left;" class="btn btn-submit"><?php _e('Save changes', 'backoffice_manager');?></button>
  </form>

  <div class="clear"></div>
  <br /><br />

  <div class="warn"><?php _e('Default status is selected when adding new listing instead of option "Select status". Means when user does not change status, default status will be attached to this listing.', 'backoffice_manager'); ?></div>
  <div class="warn"><?php _e('Only 1 status can be default at one time. If you select multiple statuses to be default, just last one will be marked as default.', 'backoffice_manager'); ?></div>
  <div class="warn"><?php _e('When status is set to be emailed, this status will be send in email after new listing is added to inform user that it is possible to change status of his listing anytime (i.e. Sold, Reserved,...).', 'backoffice_manager'); ?></div>
  <div class="warn"><?php _e('Order field is to set order of statuses in select box, you can move to top more important statuses and to bottom less important. Status with lower order number will be placed first.', 'backoffice_manager'); ?></div>
  <div class="warn"><?php _e('When status is marked as Sold, if user select this status and save listing, this item will expire immediately.', 'backoffice_manager'); ?></div>
  <div class="warn"><?php _e('Status of type "Sold" is not shown in search select!', 'backoffice_manager'); ?></div>

  <div class="clear"></div>
  <br /><br />
  <div class="clear"></div>
  <?php echo $pluginInfo['plugin_name'] . ' | ' . __('Version','backoffice_manager') . ' ' . $pluginInfo['version'] . ' | ' . __('Author','backoffice_manager') . ': ' . $pluginInfo['author'] . ' | Cannot be redistributed | &copy; ' . date('Y') . ' <a href="' . $pluginInfo['plugin_uri'] . '" target="_blank">MB Themes</a>'; ?>             
</div>