<?php
//Add keywords to email legend
EmailVariables::newInstance()->add('{PASSWORD_TEXT}', 'If user enter own password to edit/delete listing, text with password is shown. If password was not entered, nothing is shown.');
EmailVariables::newInstance()->add('{STATUS_LIST}', 'Generate list of statuses that were set to be emailed. Each status has link, so when user click on it, listing will change status to clicked one.');
EmailVariables::newInstance()->add('{REPUBLISH_URL}', 'Generate complete republish link (not raw, but text with link).');
EmailVariables::newInstance()->add('{EXPIRE_DAYS}', 'In how many days will listing expire.');
EmailVariables::newInstance()->add('{REMOVE_DAYS}', 'In how many days will be listing removed.');
EmailVariables::newInstance()->add('{REGULAR_VIEWS_TOTAL}', 'How many people seen listing when it was regular one (not premium).');
EmailVariables::newInstance()->add('{PREMIUM_VIEWS_TOTAL}', 'How many people seen listing when it was premium.');
EmailVariables::newInstance()->add('{CONTACT_FORM_USED}', 'How many people used contact form to contact seller.');
EmailVariables::newInstance()->add('{PAYMENT_URL}', 'Generate link where is possible make payment for listing.');

//Create email when listing has expired
function email_expired($item_id) {
  $page = new Page() ;
  $page = $page->findByInternalName('bo_mgr_email_expired');
  if(empty($page)) { exit(); }

  $locale = osc_current_user_locale() ;
  $content = array();
  if(isset($page['locale'][$locale]['s_title'])) {
    $content = $page['locale'][$locale];
  } else {
    $content = current($page['locale']);
  }

  $item = Item::newInstance()->findByPrimaryKey($item_id);

  //$raw_url = osc_base_url() . 'oc-content/plugins/backoffice_manager/republish.php?item_id=' . $item_id;
  $raw_url = osc_route_url('bomgr-republish', array('item_id' => $item_id, 'secret' => $item['s_secret']));

  $url  = '<a href="' .$raw_url . '" >' . __('Republish listing #', 'backoffice_manager') . $item['pk_i_id'] . '</a>';

  $words   = array();
  $words[] = array('{CONTACT_NAME}', '{ITEM_TITLE}', '{WEB_TITLE}', '{REPUBLISH_URL}', '{ITEM_ID}');
  $words[] = array($item['s_contact_name'], stripslashes(strip_tags($item['s_title'])), stripslashes(strip_tags(osc_page_title())), $url, $item['pk_i_id']) ;

  $title = osc_mailBeauty($content['s_title'], $words) ;
  $body  = osc_mailBeauty($content['s_text'], $words) ;

  $email_build = array(
    'subject'  => $title, 
    'to' => $item['s_contact_email'], 
    'to_name'  => $item['s_contact_name'],
    'body' => $body,
    'alt_body' => $body
  );

  osc_sendMail($email_build);
}

//Create email when listing has been auto-republished
function email_autorepublish($item_id) {
  $page = new Page() ;
  $page = $page->findByInternalName('bo_mgr_email_autorepublish');
  if(empty($page)) { exit(); }

  $locale = osc_current_user_locale() ;
  $content = array();
  if(isset($page['locale'][$locale]['s_title'])) {
    $content = $page['locale'][$locale];
  } else {
    $content = current($page['locale']);
  }

  $item = Item::newInstance()->findByPrimaryKey($item_id);

  $url  = '<a href="' . osc_item_url_ns($item['pk_i_id']) . '" >' . $item['s_title'] . '</a>';

  $words   = array();
  $words[] = array('{CONTACT_NAME}', '{ITEM_TITLE}', '{WEB_TITLE}', '{URL}', '{ITEM_ID}');
  $words[] = array($item['s_contact_name'], stripslashes(strip_tags($item['s_title'])), stripslashes(strip_tags(osc_page_title())), $url, $item['pk_i_id']) ;

  $title = osc_mailBeauty($content['s_title'], $words) ;
  $body  = osc_mailBeauty($content['s_text'], $words) ;

  $email_build = array(
    'subject'  => $title, 
    'to' => $item['s_contact_email'], 
    'to_name'  => $item['s_contact_name'],
    'body' => $body,
    'alt_body' => $body
  );

  osc_sendMail($email_build);
}

//Create email when payment for listing is required
function email_payment_required($item_id) {
  $page = new Page() ;
  $page = $page->findByInternalName('bo_mgr_email_payment_required');
  if(empty($page)) { exit(); }

  $locale = osc_current_user_locale() ;
  $content = array();
  if(isset($page['locale'][$locale]['s_title'])) {
    $content = $page['locale'][$locale];
  } else {
    $content = current($page['locale']);
  }

  $item = Item::newInstance()->findByPrimaryKey($item_id);

  $url  = '<a href="' . osc_item_url_ns($item['pk_i_id']) . '" >' . osc_item_url_ns($item['pk_i_id']) . '</a>';

  $words   = array();
  $words[] = array('{CONTACT_NAME}', '{ITEM_TITLE}', '{WEB_TITLE}', '{PAYMENT_URL}', '{ITEM_ID}');
  $words[] = array($item['s_contact_name'], stripslashes(strip_tags($item['s_title'])), stripslashes(strip_tags(osc_page_title())), $url, $item['pk_i_id']) ;

  $title = osc_mailBeauty($content['s_title'], $words) ;
  $body  = osc_mailBeauty($content['s_text'], $words) ;

  $email_build = array(
    'subject'  => $title, 
    'to' => $item['s_contact_email'], 
    'to_name'  => $item['s_contact_name'],
    'body' => $body,
    'alt_body' => $body
  );

  osc_sendMail($email_build);
}

function email_status($item_id) {
  if((int)$item_id <= 0) {
    return false;
  }
  
  $page = new Page() ;
  $page = $page->findByInternalName('bo_mgr_email_status');
  if(empty($page)) { exit(); }

  $locale = osc_current_user_locale() ;
  $content = array();
  if(isset($page['locale'][$locale]['s_title'])) {
    $content = $page['locale'][$locale];
  } else {
    $content = current($page['locale']);
  }

  $item = Item::newInstance()->findByPrimaryKey($item_id);
  $item_s = ModelBO::newInstance()->getItem($item_id);
  $pass = (isset($item_s['passwrd']) ? $item_s['passwrd'] : '');

  if($pass == '') { 
    $pass_text = ''; 
  } else {
    $pass_text = __('If you would like to edit or delete your listing, you can do it directly from listing page using your passsword. You can also login to your account and edit listing from here. <br/>Your password:', 'backoffice_manager') . ' <strong>' . $pass . '</strong>';
  }

  $statuses = ModelLS::newInstance()->getStatusList('', 1);
  $status_list = '';
  
  if(is_array($statuses) && count($statuses) > 0) {
    foreach($statuses as $status) {
      //$status_list .= '<strong><span style="color: #1400ff;"><a href="' . osc_base_url() . 'oc-content/plugins/backoffice_manager/status_change.php?item_id=' . $item_id . '&status_id=' . $status['status_id'] . '&secret=' . $item['s_secret'] . '" target="_blank">' . $status['status_name'] . '</a></span></strong><br />';

      $raw_url = osc_route_url('bomgr-change-status', array('item_id' => $item_id, 'status_id' => $status['status_id'], 'secret' => $item['s_secret']));
      $status_list .= '<strong><span style="color: #1400ff;"><a href="' . $raw_url . '" target="_blank">' . $status['status_name'] . '</a></span></strong><br />';
    }
  }

  $words   = array();
  $words[] = array('{CONTACT_NAME}', '{ITEM_TITLE}', '{WEB_TITLE}', '{STATUS_LIST}', '{ITEM_ID}', '{PASSWORD_TEXT}');
  $words[] = array($item['s_contact_name'], stripslashes(strip_tags($item['s_title'])), stripslashes(strip_tags(osc_page_title())), $status_list, $item['pk_i_id'], $pass_text) ;

  $title = osc_mailBeauty($content['s_title'], $words) ;
  $body  = osc_mailBeauty($content['s_text'], $words) ;

  if(@$item['s_contact_email'] == '') {
    return false;
  }
  
  $email_build = array(
    'subject'  => $title, 
    'to' => $item['s_contact_email'], 
    'to_name'  => $item['s_contact_name'],
    'body' => $body,
    'alt_body' => $body
  );

  osc_sendMail($email_build);
}


//Create email when listing is going to expire
function email_will_expire($item_id, $expire_days) {
  $page = new Page() ;
  $page = $page->findByInternalName('bo_mgr_email_will_expire');
  if(empty($page)) { exit(); }

  $locale = osc_current_user_locale() ;
  $content = array();
  if(isset($page['locale'][$locale]['s_title'])) {
    $content = $page['locale'][$locale];
  } else {
    $content = current($page['locale']);
  }

  $item = Item::newInstance()->findByPrimaryKey($item_id);

  //$raw_url = osc_base_url() . 'oc-content/plugins/backoffice_manager/republish.php?item_id=' . $item_id;
  $raw_url = osc_route_url('bomgr-republish', array('item_id' => $item_id, 'secret' => $item['s_secret']));

  $url  = '<a href="' .$raw_url . '" >' . __('Republish listing #', 'backoffice_manager') . $item['pk_i_id'] . '</a>';

  $words   = array();
  $words[] = array('{CONTACT_NAME}', '{ITEM_TITLE}', '{WEB_TITLE}', '{REPUBLISH_URL}', '{EXPIRE_DAYS}', '{ITEM_ID}');
  $words[] = array($item['s_contact_name'], stripslashes(strip_tags($item['s_title'])), stripslashes(strip_tags(osc_page_title())), $url, $expire_days, $item['pk_i_id']) ;

  $title = osc_mailBeauty($content['s_title'], $words) ;
  $body  = osc_mailBeauty($content['s_text'], $words) ;

  $email_build = array(
    'subject'  => $title, 
    'to' => $item['s_contact_email'], 
    'to_name'  => $item['s_contact_name'],
    'body' => $body,
    'alt_body' => $body
  );

  osc_sendMail($email_build);
}


//Create email when listing has been removed
function email_removed($item_id, $remove_days) {
  $page = new Page() ;
  $page = $page->findByInternalName('bo_mgr_email_removed');
  if(empty($page)) { exit(); }

  $locale = osc_current_user_locale() ;
  $content = array();
  if(isset($page['locale'][$locale]['s_title'])) {
    $content = $page['locale'][$locale];
  } else {
    $content = current($page['locale']);
  }

  $item = Item::newInstance()->findByPrimaryKey($item_id);


  $words   = array();
  $words[] = array('{CONTACT_NAME}', '{ITEM_TITLE}', '{WEB_TITLE}', '{REMOVE_DAYS}', '{ITEM_ID}');
  $words[] = array($item['s_contact_name'], stripslashes(strip_tags($item['s_title'])), stripslashes(strip_tags(osc_page_title())), $remove_days, $item['pk_i_id']) ;

  $title = osc_mailBeauty($content['s_title'], $words) ;
  $body  = osc_mailBeauty($content['s_text'], $words) ;

  $email_build = array(
    'subject'  => $title, 
    'to' => $item['s_contact_email'], 
    'to_name'  => $item['s_contact_name'],
    'body' => $body,
    'alt_body' => $body
  );

  osc_sendMail($email_build);
}

//Create email to confirm that listing was republished
function email_confirm($item_id, $expire_date) {
  $page = new Page() ;
  $page = $page->findByInternalName('bo_mgr_email_confirm');
  if(empty($page)) { exit(); }

  $locale = osc_current_user_locale() ;
  $content = array();
  if(isset($page['locale'][$locale]['s_title'])) {
    $content = $page['locale'][$locale];
  } else {
    $content = current($page['locale']);
  }

  $item = Item::newInstance()->findByPrimaryKey($item_id);

  $url  = '<a href="' . osc_item_url_ns($item['pk_i_id']) . '" >' . $item['s_title'] . '</a>';

  $words   = array();
  $words[] = array('{CONTACT_NAME}', '{ITEM_TITLE}', '{WEB_TITLE}', '{ITEM_URL}', '{EXPIRE_DATE}', '{ITEM_ID}');
  $words[] = array($item['s_contact_name'], stripslashes(strip_tags($item['s_title'])), stripslashes(strip_tags(osc_page_title())), $url, $expire_date, $item['pk_i_id']) ;

  $title = osc_mailBeauty($content['s_title'], $words) ;
  $body  = osc_mailBeauty($content['s_text'], $words) ;

  $email_build = array(
    'subject'  => $title, 
    'to' => $item['s_contact_email'], 
    'to_name'  => $item['s_contact_name'],
    'body' => $body,
    'alt_body' => $body
  );

  osc_sendMail($email_build);
}


//Create email to send stats of listing
function email_send_stats($item_id, $regular_views_total, $premium_views_total, $contact_form) {
  $page = new Page() ;
  $page = $page->findByInternalName('bo_mgr_email_send_stats');
  if(empty($page)) { exit(); }

  $locale = osc_current_user_locale() ;
  $content = array();
  if(isset($page['locale'][$locale]['s_title'])) {
    $content = $page['locale'][$locale];
  } else {
    $content = current($page['locale']);
  }

  $item = Item::newInstance()->findByPrimaryKey($item_id);

  $url  = '<a href="' . osc_item_url_ns($item['pk_i_id']) . '" >' . $item['s_title'] . '</a>';

  $words   = array();
  $words[] = array('{CONTACT_NAME}', '{ITEM_TITLE}', '{WEB_TITLE}', '{ITEM_URL}', '{ITEM_ID}', '{REGULAR_VIEWS_TOTAL}', '{PREMIUM_VIEWS_TOTAL}', '{CONTACT_FORM_USED}');
  $words[] = array($item['s_contact_name'], stripslashes(strip_tags($item['s_title'])), stripslashes(strip_tags(osc_page_title())), $url, $item['pk_i_id'], $regular_views_total, $premium_views_total, $contact_form) ;

  $title = osc_mailBeauty($content['s_title'], $words) ;
  $body  = osc_mailBeauty($content['s_text'], $words) ;

  $email_build = array(
    'subject'  => $title, 
    'to' => $item['s_contact_email'], 
    'to_name'  => $item['s_contact_name'],
    'body' => $body,
    'alt_body' => $body
  );

  osc_sendMail($email_build);
}


//Create email to send note to Admin
function email_admin($item_id, $expire_days) {
  $page = new Page() ;
  $page = $page->findByInternalName('bo_mgr_email_admin');
  if(empty($page)) { exit(); }

  $locale = osc_current_user_locale() ;
  $content = array();
  if(isset($page['locale'][$locale]['s_title'])) {
    $content = $page['locale'][$locale];
  } else {
    $content = current($page['locale']);
  }

  $item = Item::newInstance()->findByPrimaryKey($item_id);
  $url  = '<a href="' . osc_item_url_ns($item['pk_i_id']) . '" >' . $item['s_title'] . '</a>';


  $words   = array();
  $words[] = array('{CONTACT_NAME}', '{USER_NAME}', '{ITEM_TITLE}', '{WEB_TITLE}', '{EXPIRE_DAYS}', '{ITEM_URL}', '{ITEM_ID}');
  $words[] = array('Admin', $item['s_contact_name'], stripslashes(strip_tags($item['s_title'])), osc_page_title(), $expire_days, $url, $item['pk_i_id']) ;

  $title = osc_mailBeauty($content['s_title'], $words) ;
  $body  = osc_mailBeauty($content['s_text'], $words) ;

  $email_build = array(
    'subject'  => $title, 
    'to' => osc_contact_email(),
    'to_name'  => __('Admin confirmation email', 'backoffice_manager'),
    'body' => $body,
    'alt_body' => $body
  );

  osc_sendMail($email_build);
}

?>