<?php
  GLOBAL $bo_mgr_item;
  View::newInstance()->_exportVariableToView('item', $bo_mgr_item);

  $user_id = 0;
  if($user_id == '' or $user_id == 0) {$user_id = osc_item_user_id(); }
  if($user_id == '' or $user_id == 0) { $user_id = osc_user_id(); }
  if(osc_get_osclass_location() == 'user' && ($user_id == '' or $user_id == 0)) { $user_id = Params::getParam('id'); }
  $stop = false;

  $user = User::newInstance()->findByPrimaryKey($user_id);

  $feedback_active = osc_get_preference('bo_mgr_feedback_active', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_feedback_active', 'plugin-bo_mgr') : 0;
  $feedback_active = $feedback_active*(-1)+1;

  $only_reg = osc_get_preference('bo_mgr_feedback_only_reg', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_feedback_only_reg', 'plugin-bo_mgr') : 0;
  $valid_after = osc_get_preference('bo_mgr_feedback_validate_times', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_feedback_validate_times', 'plugin-bo_mgr') : 0;
  $time_between = osc_get_preference('bo_mgr_feedback_time_between', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_feedback_time_between', 'plugin-bo_mgr') : 0;
  $max_count = osc_get_preference('bo_mgr_feedback_max_count', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_feedback_max_count', 'plugin-bo_mgr') : 0;
  $max_period = (osc_get_preference('bo_mgr_feedback_max_period', 'plugin-bo_mgr') != '') ? osc_get_preference('bo_mgr_feedback_max_period', 'plugin-bo_mgr') : '' ;
  $own = (osc_get_preference('bo_mgr_feedback_own', 'plugin-bo_mgr') != '') ? osc_get_preference('bo_mgr_feedback_own', 'plugin-bo_mgr') : 1 ;
  $change_name = (osc_get_preference('bo_mgr_feedback_change_name', 'plugin-bo_mgr') != '') ? osc_get_preference('bo_mgr_feedback_change_name', 'plugin-bo_mgr') : 0 ;

  $logged_user_id = osc_logged_user_id();

  // IF USER IS NOT LOGGED IN, USE RANDOM USER_ID STORED IN USER COOKIES
  if($logged_user_id == '' or $logged_user_id <= 0) {
    $logged_user_id = mb_get_cookie('bo_mgr_fb_user_id');
  }

  $now = date('Y-m-d H:i:s');                                                                           // current datetime
  $now_back = date("Y-m-d H:i:s",strtotime("-" . $time_between . " seconds", strtotime($now)));         // current datetime minus seconds required between publishing 2 feedbacks
  $now_back_period = date("Y-m-d H:i:s",strtotime("-" . $max_period . " hours", strtotime($now)));      // current datetime minus period of hours


  // CALCULATE HOW MANY FEEDBACKS HAS CURRENT LOGGED USER VALIDATED
  $validated_count = ModelFB::newInstance()->countFeedbackByCommentatorId($logged_user_id, 1);
  $validated_count = $validated_count['count'];


  // IF USER TRY TO PUBLISH NEW FEEDBACK AFTER LAST ONE AND MINIMUM TIME BETWEEN 2 FEEDBACKS IS NOT MET, STOP USER
  $last_fb = ModelFB::newInstance()->getFeedbackByCommentatorId($logged_user_id, 1);

  if(isset($last_fb['pub_date']) && $last_fb['pub_date'] <> '' and $last_fb['pub_date'] > $now_back) {
    osc_add_flash_error_message( __('Your last feedback was added few seconds ago, you cannot add 2 or more comments in same time.', 'backoffice_manager'));
    $stop = true;
  }


  // IF USER TRY TO PUBLISH MORE THAN XX FEEDBACKS IN YY HOURS
  $last_fb_list = ModelFB::newInstance()->getFeedbackByCommentatorId($logged_user_id, $max_count, $now_back_period);

  if(count($last_fb_list) >= $max_count) {
    osc_add_flash_error_message( __('Your have added too many feedbacks in last', 'backoffice_manager') . ' ' . $max_period . ' ' . ($max_period == 1 ? __('hour', 'backoffice_manager') : __('hours', 'backoffice_manager')) . '!');
    $stop = true;
  }


  $ip = get_client_ip();
  $ip_v4_valid = filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4);

  if(osc_get_osclass_location() == 'user') { 
    $redirect_url = osc_user_public_profile_url($user_id); 
  } else { 
    if(osc_item_id() <> '') {
      $redirect_url = osc_item_url(); 
    }
  }

  if(Params::getParam('action_bo_mgr') == 'done') {
    if($stop) {
      header('Location: '.$redirect_url);
      exit;
    }

    //ANTI-SPAM CONTROL
    if((Params::getParam('required_what') <> 'selling-stuffs' or 
       Params::getParam('required_to') <> 'selling-stuffs' or 
       Params::getParam('required_stuff') <> '' or 
       Params::getParam('required_fill') <> date("Y") and 
       Params::getParam('action_bo_mgr_check') == 'triple_check') and
       (Params::getParam('required_to') <> '' and
       Params::getParam('required_stuff') <> '' and
       Params::getParam('required_fill') <> '')) 
    {
      $ban_now = true;
    } else {
      $ban_now = false;
    }

    if($user_id == '' or $user_id == 0) {
      osc_add_flash_error_message( __('User ID was not recognized. You are probably trying to add feedback to unregistered user.', 'backoffice_manager'));
    } else if (Params::getParam('f_name') == '') {
      osc_add_flash_error_message( __('Please enter your name.', 'backoffice_manager'));
    } else if (Params::getParam('f_title') == '') {
      osc_add_flash_error_message( __('Please enter feedback title.', 'backoffice_manager'));
    } else if (Params::getParam('f_message') == '') {
      osc_add_flash_error_message( __('Please enter feedback message.', 'backoffice_manager'));
    } else {
      if($ban_now) {
        osc_add_flash_error_message(__('You were permanently banned as spam bot', 'backoffice_manager'));

        if($ip_v4_valid) { ModelFB::newInstance()->insertBan( 'Bot Found > Add feedback > Triple check failed', $ip ); }
        header('Location: '.osc_base_url());
        exit;

      } else {



        if($validated_count >= $valid_after) {
          $feedback_active = 1;
        }

        ModelFB::newInstance()->addFeedback( $user_id, $logged_user_id, Params::getParam('f_name'), Params::getParam('f_title'), Params::getParam('f_message'), Params::getParam('rating-quality'), Params::getParam('rating-delivery'), Params::getParam('rating-communication'), $feedback_active, date('Y-m-d H:i:s') );
        osc_add_flash_ok_message( __('Feedback was successfully send, thank you for your time.', 'backoffice_manager'));
        header('Location: '.$redirect_url);
      }
    }
  }

  $loc = '';
?>

<div id="user-feedback" style="display:none;">
  <div class="inside round4">
    <div class="close"></div>
    <div class="wrap round3">

      <?php if($only_reg == 1 && !osc_is_web_user_logged_in()) { ?>
        <div class="feedback-warn">
          <span><?php _e('Only registered users can leave feedback.', 'backoffice_manager'); ?></span>
          <span><a href="<?php echo osc_register_account_url(); ?>"><?php _e('Register', 'backoffice_manager'); ?></a> <?php _e('for new account or', 'backoffice_manager'); ?> <a href="<?php echo osc_user_login_url(); ?>"><?php _e('Log in', 'backoffice_manager'); ?></a> <?php _e('if you already are registered.', 'backoffice_manager'); ?></span>
        </div>
      <?php } elseif($user_id == $logged_user_id && $own == 0) { ?>
        <div class="feedback-warn">
          <span><?php _e('You cannot leave feedback to yourself!', 'backoffice_manager'); ?></span>
        </div>
      <?php } else if(isset($user['pk_i_id']) && $user['pk_i_id'] > 0) { ?>

        <div class="header"><?php _e('Leave feedback', 'backoffice_manager'); ?></div>
        <ul id="error_list" class="feedback"></ul>
        <div class="row photo">
          <div class="left">
            <?php if(function_exists('profile_picture_show')) { profile_picture_show(); } else { ?><img src="<?php echo osc_base_url(); ?>oc-content/plugins/backoffice_manager/images/picture_default.png" alt="<?php _e('Profile picture', 'backoffice_manager'); ?>"/><?php }?>
          </div>
          <div class="right">
            <div class="row">
              <span class="name"><?php echo $user['s_name']; ?></span> <span class="italic">(<?php echo __('registered since', 'backoffice_manager') . ' <span class="bold">' . $user['dt_reg_date'] . '</span>'; ?>)</span>
            </div>

            <div class="row user_info">
              <?php echo $user['locale'][osc_current_user_locale()]['s_info']; ?>
            </div>

            <div class="row loc">
              <?php 
                if($user['s_country'] <> '' and ($user['s_region'] <> '' or $user['s_city'] <> '')) { $loc .= $user['s_country'] . ', '; } 
                if($user['s_region'] <> '' and $user['s_city'] <> '') { $loc .= $user['s_region'] . ', '; }
                $loc .= $user['s_city'];
                echo $loc;
              ?>
            </div>
          </div>
        </div>

        <div class="del"></div>

        <form id="rating" name="rating" action="<?php echo $redirect_url; ?>" method="post" class="nocsrf">
          <input type="hidden" name="action_bo_mgr" value="done" />
          <?php if($change_name == 0 && osc_is_web_user_logged_in()) { ?>
             <input type="hidden" name="f_name" id="f_name" value="<?php echo osc_logged_user_name(); ?>"/>
          <?php } ?>

          <div id="required_form_special">
            <input type="hidden" name="action_bo_mgr_check" value="triple_check" />
            <label for="required_what">What to sell</label><input value="selling-stuffs" type="text" name="required_what" id="required_what" /><br />
            <label for="required_to">What to buy</label><input value="" type="text" name="required_to" id="required_to" /><br />
            <label for="required_stuff">Stuff</label><input value="" type="text" name="required_stuff" id="required_stuff" />
            <label for="required_fill">Fill</label><input value="" type="text" name="required_fill" id="required_fill" />
          </div>

          <?php if(!($user_id == $logged_user_id && $own == 1)) { ?>
            <div class="row rank-block">
              <div class="row rank">
                <div class="left">
                  <?php _e('Quality', 'backoffice_manager'); ?>
                </div>
                <div class="right">
                  <input name="rating-quality" type="radio" class="star" value="1"/>
                  <input name="rating-quality" type="radio" class="star" value="2"/>
                  <input name="rating-quality" type="radio" class="star" value="3" checked="checked"/>
                  <input name="rating-quality" type="radio" class="star" value="4"/>
                  <input name="rating-quality" type="radio" class="star" value="5"/>
                </div>
              </div>
              <div class="row rank">
                <div class="left">
                   <?php _e('Communication', 'backoffice_manager'); ?>
                </div>
                <div class="right">
                  <input name="rating-communication" type="radio" class="star" value="1"/>
                  <input name="rating-communication" type="radio" class="star" value="2"/>
                  <input name="rating-communication" type="radio" class="star" value="3" checked="checked"/>
                  <input name="rating-communication" type="radio" class="star" value="4"/>
                  <input name="rating-communication" type="radio" class="star" value="5"/>
                </div>
              </div>
              <div class="row rank">
                <div class="left">
                   <?php _e('Delivery', 'backoffice_manager'); ?>
                </div>
                <div class="right">
                  <input name="rating-delivery" type="radio" class="star" value="1"/>
                  <input name="rating-delivery" type="radio" class="star" value="2"/>
                  <input name="rating-delivery" type="radio" class="star" value="3" checked="checked"/>
                  <input name="rating-delivery" type="radio" class="star" value="4"/>
                  <input name="rating-delivery" type="radio" class="star" value="5"/>
                </div>
              </div>
            </div>

            <div class="del"></div>
          <?php } ?>

          <?php if($change_name == 0 && osc_is_web_user_logged_in()) { ?>
            <div class="row text name">
              <div class="left">
                 <?php _e('Your Name', 'backoffice_manager'); ?><sup>*</sup>
              </div>
              <div class="right">
                <span class="round2 name_unchangable"><?php echo osc_logged_user_name(); ?></span>
              </div>
            </div>
          <?php } else { ?>
            <div class="row text name">
              <div class="left">
                 <?php _e('Your Name', 'backoffice_manager'); ?><sup>*</sup>
              </div>
              <div class="right">
                <input type="text" class="round2" name="f_name" id="f_name" maxlength="100" value="<?php echo osc_logged_user_name(); ?>"/>
              </div>
            </div>
          <?php } ?>

          <div class="row text">
            <div class="left">
               <?php _e('Title', 'backoffice_manager'); ?><sup>*</sup>
            </div>
            <div class="right">
              <input type="text" class="round2" name="f_title" id="f_title" maxlength="100"/>
            </div>
          </div>
          <div class="row text">
            <div class="left">
               <?php _e('Message', 'backoffice_manager'); ?><sup>*</sup>
            </div>
            <div class="right">
              <textarea class="round2" name="f_message" id="f_message" maxlength="1000"></textarea>
            </div>
          </div>
          <div class="row">
            <button type="submit" id="button"><?php _e('Send feedback!', 'backoffice_manager'); ?></button>
          </div>

          <div class="clear"></div>
        </form>
      <?php } ?>
    </div>
  </div>
</div>

<script>
$(document).ready(function() {
  var what = $('#required_what').val();
  $('#required_to').val( what );
  $('#required_fill').val( (new Date).getFullYear() );
});
</script>