<?php
  $items = ModelBO::newInstance()->getOtherItemsWithMyComments(osc_logged_user_id());

  View::newInstance()->_exportVariableToView('items', $items);
  $current_page = (Params::getParam('iPage') != '') ? Params::getParam('iPage') : 0;
  $item_per_page = osc_get_preference('defaultResultsPerPage@search', 'osclass') > 0 ? osc_get_preference('defaultResultsPerPage@search', 'osclass') : 12;
  $pages_total  = ceil(osc_count_items()/$item_per_page);
  View::newInstance()->_exportVariableToView('list_total_pages', $pages_total);
  View::newInstance()->_exportVariableToView('list_total_items', osc_count_items());
  View::newInstance()->_exportVariableToView('items_per_page', $item_per_page);
  //View::newInstance()->_exportVariableToView('list_page', $page);
?>

<script type="text/javascript" src="<?php echo osc_base_url(); ?>/oc-includes/osclass/assets/js/jquery.validate.min.js"></script>
<link href="<?php echo osc_base_url(); ?>oc-content/plugins/backoffice_manager/css/list_expired_comments.css" rel="stylesheet" type="text/css" />

<script>
  $(document).ready(function(){
    $('.comment_reply').click(function(){
      $('.reply-form').fadeIn(200);
      $('.reply-form').find('input[name="id"]').val($(this).attr('id'));
      $('html,body').animate({ scrollTop: $('.reply-form').offset().top }, { duration: 500, easing: 'swing'});
    });
  });
</script>

<h2><?php _e('My comments on other people listings', 'backoffice_manager'); ?></h2>
<?php if(osc_count_items() == 0) { ?>
  <div class="empty"><?php _e('You do not have any comments on listings', 'backoffice_manager'); ?></div>
<?php } else { ?>
  <?php while(osc_has_items()) { ?>
    <?php if(!osc_item_is_expired()) { ?>
      <div class="bo_mgr-item-row">
        <h3><a href="<?php echo osc_item_url(); ?>"><?php echo osc_item_field('s_title'); ?></a> <span>(<?php echo osc_item_field('comment_count'); ?> <?php echo osc_item_field('comment_count') == 1 ? __('comment', 'backoffice_manager') : __('comments', 'backoffice_manager'); ?>)</span></h3>

        <?php $comments = ModelBO::newInstance()->getCommentsByItemId(osc_item_id()); ?>
        <?php $i = 1; ?>
        <?php foreach($comments as $c) { ?>
          <div class="bo_mgr-item-elem gray <?php if(osc_logged_user_id() == $c['fk_i_user_id']) { ?>my-reply-flag<?php } ?>">
            <?php if(osc_logged_user_id() == $c['fk_i_user_id']) { ?>
              <div class="my-reply" title="<?php _e('This is your comment', 'backoffice_manager'); ?>"></div>
            <?php } ?>

            <div class="count">#<?php echo $i; ?></div>
            <h4><div><?php echo $c['s_title']; ?></div> <span>(<?php echo osc_format_date($c['dt_pub_date']); ?>)</span></h4>
            <div class="bo_mgr-comment-row"><?php echo $c['s_body']; ?></div>
            <div class="bo_mgr-comment-row author">
              <div><?php _e('Published by', 'backoffice_manager'); ?></div>
              <?php if($c['fk_i_user_id'] <> '' and $c['fk_i_user_id'] > 0) { ?>
                <a target="_blank" title="<?php _e('Check public profile of this user', 'backoffice_manager'); ?>" href="<?php echo osc_user_public_profile_url($c['fk_i_user_id']); ?>"><?php echo $c['s_author_name']; ?></a>
              <?php } else { ?>
                <span><?php echo $c['s_author_name']; ?></span>
              <?php } ?>
            </div>
          </div>

          <?php $i++; ?>
        <?php } ?>

        <div class="bo_mgr-item-elem">
          <a href="javascript:void(0)" class="comment_reply" id="<?php echo osc_item_id(); ?>"><?php _e('Reply to comments', 'backoffice_manager'); ?></a>
        </div>
      </div>
    <?php } ?>
  <?php } ?>

  <div class="bo_mgr-item-row">
    <ul id="comment_error_list"></ul>
    <?php CommentForm::js_validation(); ?>

    <div class="reply-form">
      <form action="<?php echo osc_base_url(true); ?>" method="post" name="comment_form" id="comment_form">
        <h3><?php _e('Leave your comment', 'backoffice_manager'); ?></h3>

        <fieldset>
          <input type="hidden" name="action" value="add_comment" />
          <input type="hidden" name="id" value="" />
          <input type="hidden" name="page" value="item" />
          <input type="hidden" name="authorName" value="<?php echo osc_esc_html( osc_logged_user_name() ); ?>" />
          <input type="hidden" name="authorEmail" value="<?php echo osc_logged_user_email(); ?>" />
          <input type="hidden" name="bo_mgr-from-bo" value="1" />
          <input type="hidden" name="bo_mgr-area" value="other" />

          <div class="reply-row">
            <label for="title"><?php _e('Title', 'backoffice_manager'); ?>:</label><?php CommentForm::title_input_text(); ?>
          </div>

          <div class="reply-row">
            <label for="body"><?php _e('Message', 'backoffice_manager'); ?>:</label><?php CommentForm::body_input_textarea(); ?>
          </div>
          <button type="submit"><?php _e('Send comment', 'backoffice_manager'); ?></button>
        </fieldset>
      </form>
    </div>
  </div>

  <div class="paginate">
    <?php for($i = 0; $i < $pages_total; $i++) { ?>
      <?php if($i == $current_page ) { ?>
        <?php printf('<a class="searchPaginationSelected" href="%s">%d</a>', osc_route_url('bo_mgr-comments-my-listings', array('iPage' => $i)), ($i + 1)); ?>
      <?php } else { ?>
        <?php printf('<a class="searchPaginationNonSelected" href="%s">%d</a>', osc_route_url('bo_mgr-comments-my-listings', array('iPage' => $i)), ($i + 1)); ?>
      <?php } ?>
    <?php } ?>
  </div>
<?php } ?>
