<?php
  $items = ModelBO::newInstance()->getExpiredListingsByUserId(osc_logged_user_id());
  View::newInstance()->_exportVariableToView('items', $items);
  $current_page = (Params::getParam('iPage') != '') ? Params::getParam('iPage') : 0;
  $item_per_page = osc_get_preference('defaultResultsPerPage@search', 'osclass') > 0 ? osc_get_preference('defaultResultsPerPage@search', 'osclass') : 12;
  $pages_total  = ceil(osc_count_items()/$item_per_page);
  View::newInstance()->_exportVariableToView('list_total_pages', $pages_total);
  View::newInstance()->_exportVariableToView('list_total_items', osc_count_items());
  View::newInstance()->_exportVariableToView('items_per_page', $item_per_page);
  //View::newInstance()->_exportVariableToView('list_page', $page);
?>

<link href="<?php echo osc_base_url(); ?>oc-content/plugins/backoffice_manager/css/list_expired_comments.css" rel="stylesheet" type="text/css" />

<h2><?php _e('Expired listings', 'backoffice_manager'); ?></h2>
<?php if(osc_count_items() == 0) { ?>
  <div class="empty"><?php _e('You do not have any expired listings', 'backoffice_manager'); ?></div>
<?php } else { ?>
  <?php while(osc_has_items()) { ?>
    <div class="bo_mgr-item-row">
      <?php $item = Item::newInstance()->findByPrimaryKey(osc_item_id()); ?>
      <h3><a href="<?php echo osc_item_url(); ?>"><?php echo $item['s_title']; ?></a></h3>
      <div class="bo_mgr-item-elem"><label><?php _e('Published', 'backoffice_manager'); ?>:</label> <?php echo osc_format_date(osc_item_pub_date()); ?></div>
      <div class="bo_mgr-item-elem"><label><?php _e('Expired', 'backoffice_manager'); ?>:</label> <?php echo osc_format_date(osc_item_field('dt_expiration')); ?></div>
      <div class="bo_mgr-item-elem"><?php if(function_exists('republish_link')) { republish_link(osc_item_id()); } ?></div>
      <div class="bo_mgr-item-elem"><a href="<?php echo osc_item_delete_url(); ?>" onclick="return confirm('<?php _e('Are you sure you want to delete this listing? This action cannot be undone.', 'backoffice_manager'); ?>?')"><?php _e('Delete listing', 'backoffice_manager'); ?></a></div>
    </div>
  <?php } ?>

  <div class="paginate">
    <?php for($i = 0; $i < $pages_total; $i++) { ?>
      <?php if($i == $current_page ) { ?>
        <?php printf('<a class="searchPaginationSelected" href="%s">%d</a>', osc_route_url('bo_mgr-expired-ads', array('iPage' => $i)), ($i + 1)); ?>
      <?php } else { ?>
        <?php printf('<a class="searchPaginationNonSelected" href="%s">%d</a>', osc_route_url('bo_mgr-expired-ads', array('iPage' => $i)), ($i + 1)); ?>
      <?php } ?>
    <?php } ?>
  </div>
<?php } ?>
