<?php
if(!defined('ABS_PATH')) {
  define('ABS_PATH', dirname(dirname(dirname(dirname(__FILE__)))) . '/');
}


// Cookies work
if(!function_exists('mb_set_cookie')) {
  function mb_set_cookie($name, $val) {
    Cookie::newInstance()->set_expires( 86400 * 30 );
    Cookie::newInstance()->push($name, $val);
    Cookie::newInstance()->set();
  }
}

if(!function_exists('mb_get_cookie')) {
  function mb_get_cookie($name) {
    return Cookie::newInstance()->get_value($name);
  }
}

if(!function_exists('mb_drop_cookie')) {
  function mb_drop_cookie($name) {
    Cookie::newInstance()->pop($name);
  }
}

function generateRandomInt($length = 8) {
  $characters = '0123456789';
  $charactersLength = strlen($characters);
  $randomString = '';
  for ($i = 0; $i < $length; $i++) {
    $randomString .= $characters[rand(0, $charactersLength - 1)];
  }

  return $randomString;
}


// FOR PURPOSE OF FEEDBACK COUNT CHECK, IF USER IS NOT LOGGED IN, USE RANDOM USER_ID THAT IS SAVED IN USER COOKIES
if(mb_get_cookie('bo_mgr_fb_user_id') == '' or mb_get_cookie('bo_mgr_fb_user_id') <= 0) {
  mb_set_cookie('bo_mgr_fb_user_id', generateRandomInt());
} else {
  // KEEP ID IN COOKIES AS LONG AS POSSIBLE
  $current_id = mb_get_cookie('bo_mgr_fb_user_id');
  mb_set_cookie('bo_mgr_fb_user_id', $current_id);
}


$allow_feedback = osc_get_preference('bo_mgr_allow_feedback', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_allow_feedback', 'plugin-bo_mgr') : 1;

function bo_mgr_feedback_form() {
  $loc = osc_get_osclass_location();
  $sec = osc_get_osclass_section();

  if($loc == 'user' and $sec == 'pub_profile' or $loc == 'item' and $sec == '') {
    include_once ABS_PATH . 'oc-content/plugins/backoffice_manager/form/form_feedback_add.php';
  }
}

function bo_mgr_feedback_script() {
  osc_register_script('bo_mgr_feedback_js', osc_base_url() . 'oc-content/plugins/backoffice_manager/js/js_feedback.js', 'jquery');
  osc_register_script('bo_mgr_rating_pack_js', osc_base_url() . 'oc-content/plugins/backoffice_manager/js/js_rating_pack.js', 'jquery');
  osc_register_script('bo_mgr_rating_metadata_js', osc_base_url() . 'oc-content/plugins/backoffice_manager/js/js_rating_metadata.js', 'jquery');
  osc_enqueue_script('bo_mgr_feedback_js');
  osc_enqueue_script('bo_mgr_rating_pack_js');
  osc_enqueue_script('bo_mgr_rating_metadata_js');
  osc_enqueue_style('bo_mgr_feedback_css', osc_base_url() . 'oc-content/plugins/backoffice_manager/css/feedback.css');
  osc_enqueue_style('bo_mgr_rating_css', osc_base_url() . 'oc-content/plugins/backoffice_manager/css/jquery_rating.css');
}


if($allow_feedback == 1) {
  osc_add_hook('after_html', 'bo_mgr_feedback_form');
  osc_add_hook('header', 'bo_mgr_feedback_script');
}

function bo_mgr_feedback_validation() {
  if(!osc_is_home_page() and !osc_is_search_page()) {
    if(osc_get_osclass_location() == 'item' or osc_get_osclass_location() == 'user') {
      include ABS_PATH . 'oc-content/plugins/backoffice_manager/js/js_feedback_required.php';
    }
  }
}

osc_add_hook('footer', 'bo_mgr_feedback_validation');

function leave_feedback($user_id = NULL) {
  if($user_id == '' or $user_id == 0) { $user_id = osc_item_user_id(); }
  if($user_id == '' or $user_id == 0) { $user_id = osc_user_id(); }
  if(($user_id == '' or $user_id == 0) and osc_get_osclass_location() == 'user') { $user_id = Params::getParam('id'); }

  if($user_id <> '' and $user_id <> 0) {
    return '<a href="#" id="leave_feedback">' . __('Leave feedback', 'backoffice_manager') . '</a>';
  } else {
    return false;
  }
}

function show_feedback_overall( $user_id = NULL ) {
  if($user_id == '') { $user_id = osc_item_user_id(); }
  if($user_id == '') { $user_id = osc_user_id(); }
  if(($user_id == '' or $user_id == 0) and osc_get_osclass_location() == 'user') { $user_id = Params::getParam('id'); }

  $i = rand(1,1000);

  $feedback = ModelFB::newInstance()->getFeedbackScoreByUserId( $user_id, 1 );

  if($user_id <> '' and $user_id <> 0) {
    $avg = isset($feedback['score_overall']) ? $feedback['score_overall'] : 0;
    $avg = round($avg*2)/2;

    $text  = '';
    $text .= '<input name="rating-total' . $i . '" type="radio" class="star {split:2}" value="0.5"' . ($avg == 0.5 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-total' . $i . '" type="radio" class="star {split:2}" value="1"' . ($avg == 1 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-total' . $i . '" type="radio" class="star {split:2}" value="1.5"' . ($avg == 1.5 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-total' . $i . '" type="radio" class="star {split:2}" value="2"' . ($avg == 2 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-total' . $i . '" type="radio" class="star {split:2}" value="2.5"' . ($avg == 2.5 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-total' . $i . '" type="radio" class="star {split:2}" value="3"' . ($avg == 3 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-total' . $i . '" type="radio" class="star {split:2}" value="3.5"' . ($avg == 3.5 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-total' . $i . '" type="radio" class="star {split:2}" value="4"' . ($avg == 4 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-total' . $i . '" type="radio" class="star {split:2}" value="4.5"' . ($avg == 4.5 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-total' . $i . '" type="radio" class="star {split:2}" value="5"' . ($avg == 5 ? 'checked' : '') . ' disabled="disabled"/>';

    return $text; 
  }
}

function count_feedback_overall( $user_id = NULL ) {
  if($user_id == '') { $user_id = osc_item_user_id(); }
  if($user_id == '') { $user_id = osc_user_id(); }
  if(($user_id == '' or $user_id == 0) and osc_get_osclass_location() == 'user') { $user_id = Params::getParam('id'); }

  $feedback = ModelFB::newInstance()->getFeedbackByUserId( $user_id, 1 );

  if($user_id <> '' and $user_id <> 0) {
    return count($feedback); 
  }
}

function show_feedback_detail( $user_id = NULL ) {
  if($user_id == '' or $user_id == 0) { $user_id = osc_item_user_id(); }
  if($user_id == '' or $user_id == 0) { $user_id = osc_user_id(); }
  if(($user_id == '' or $user_id == 0) and osc_get_osclass_location() == 'user') { $user_id = Params::getParam('id'); }

  $fb = ModelFB::newInstance()->getFeedbackScoreByUserId( $user_id, 1 );
  $fb['score_quality'] = round($fb['score_quality']);
  $fb['score_delivery'] = round($fb['score_delivery']);
  $fb['score_communication'] = round($fb['score_communication']);
  
  if($user_id <> '' and $user_id <> 0) {
    $text  = '';
    $text .= '<div class="score_detail">';
    $text .= '<div class="score_quality">';
    $text .= '<span class="lab">' . __('Quality:', 'backoffice_manager') . '</span>';
    $text .= '<input name="rating-quality_' . $fb['feedback_id'] . '" type="radio" class="star" value="1"' . ($fb['score_quality'] == 1 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-quality_' . $fb['feedback_id'] . '" type="radio" class="star" value="2"' . ($fb['score_quality'] == 2 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-quality_' . $fb['feedback_id'] . '" type="radio" class="star" value="3"' . ($fb['score_quality'] == 3 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-quality_' . $fb['feedback_id'] . '" type="radio" class="star" value="4"' . ($fb['score_quality'] == 4 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-quality_' . $fb['feedback_id'] . '" type="radio" class="star" value="5"' . ($fb['score_quality'] == 5 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '</div>';

    $text .= '<div class="score_communication">';
    $text .= '<span class="lab">' . __('Communication:', 'backoffice_manager') . '</span>';
    $text .= '<input name="rating-communication_' . $fb['feedback_id'] . '" type="radio" class="star" value="1"' . ($fb['score_communication'] == 1 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-communication_' . $fb['feedback_id'] . '" type="radio" class="star" value="2"' . ($fb['score_communication'] == 2 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-communication_' . $fb['feedback_id'] . '" type="radio" class="star" value="3"' . ($fb['score_communication'] == 3 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-communication_' . $fb['feedback_id'] . '" type="radio" class="star" value="4"' . ($fb['score_communication'] == 4 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-communication_' . $fb['feedback_id'] . '" type="radio" class="star" value="5"' . ($fb['score_communication'] == 5 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '</div>';

    $text .= '<div class="score_delivery">';
    $text .= '<span class="lab">' . __('Delivery:', 'backoffice_manager') . '</span>';
    $text .= '<input name="rating-delivery_' . $fb['feedback_id'] . '" type="radio" class="star" value="1"' . ($fb['score_delivery'] == 1 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-delivery_' . $fb['feedback_id'] . '" type="radio" class="star" value="2"' . ($fb['score_delivery'] == 2 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-delivery_' . $fb['feedback_id'] . '" type="radio" class="star" value="3"' . ($fb['score_delivery'] == 3 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-delivery_' . $fb['feedback_id'] . '" type="radio" class="star" value="4"' . ($fb['score_delivery'] == 4 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '<input name="rating-delivery_' . $fb['feedback_id'] . '" type="radio" class="star" value="5"' . ($fb['score_delivery'] == 5 ? 'checked' : '') . ' disabled="disabled"/>';
    $text .= '</div>';

    $text .= '</div>';
  }

  return $text;
}

function show_feedback_list() {
  include_once ABS_PATH . 'oc-content/plugins/backoffice_manager/form/form_feedback_list.php';
}

function show_latest_feedback($limit = 5) {
  include_once ABS_PATH . 'oc-content/plugins/backoffice_manager/form/form_feedback_latest.php';
}

function show_best_users($limit = 5) {
  include_once ABS_PATH . 'oc-content/plugins/backoffice_manager/form/form_feedback_best.php';
}


//Get IP of user
if(!function_exists('get_client_ip')) {
  function get_client_ip() {
    $ipaddress = '';
    if (@$_SERVER['HTTP_CLIENT_IP'] <> '')
      $ipaddress = $_SERVER['HTTP_CLIENT_IP'];
    else if(@$_SERVER['HTTP_X_FORWARDED_FOR'] <> '')
      $ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
    else if(@$_SERVER['HTTP_X_FORWARDED'] <> '')
      $ipaddress = $_SERVER['HTTP_X_FORWARDED'];
    else if(@$_SERVER['HTTP_FORWARDED_FOR'] <> '')
      $ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
    else if(@$_SERVER['HTTP_FORWARDED'] <> '')
      $ipaddress = $_SERVER['HTTP_FORWARDED'];
    else if(@$_SERVER['REMOTE_ADDR'] <> '')
      $ipaddress = $_SERVER['REMOTE_ADDR'];
    else
      $ipaddress = 'UNKNOWN';
    if(strpos($ipaddress, ',')) {
      return trim(substr($ipaddress, 0, strpos($ipaddress, ','))); 
    } else {
      return trim($ipaddress); 
    }
  }
}
?>