<?php
//Add republish link route
//osc_add_route('republish', 'backoffice_manager/republish/([0-9]+)/([0-9]+)', 'backoffice_manager/republish/{item_id}/{redirect}', osc_plugin_folder(__FILE__).'republish.php');


//Create link to republish in oc-admin
function bo_mgr_item_manage_actions($options, $aRow) {
  $csrf_token_url = osc_csrf_token_url();
  $options[] = '<a href="' . osc_admin_base_url(true) . '?page=items&amp;action=republish_admin&amp;id=' . $aRow['pk_i_id'] . '&amp;' . $csrf_token_url . '&amp;value=DISABLE">' . __('Republish now!', 'backoffice_manager') .'</a>' ;
  return $options;
}
osc_add_hook('more_actions_manage_items', 'bo_mgr_item_manage_actions');



//Create function for republish in oc-admin
function bo_mgr_admin_republish() {
  $action = Params::getParam('action');
  $item_id = Params::getParam('id');
  $item = ModelBO::newInstance()->getItem( $item_id );
  $discard_premium = osc_get_preference('bo_mgr_discard_premium', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_discard_premium', 'plugin-bo_mgr') : 1;

  if(!isset($item['pk_i_id'])) {
    return false;
  }
  
  $category = Category::newInstance()->findByPrimaryKey( $item['fk_i_category_id'] );

  if(date('Y', strtotime($item['dt_expiration'])) == '1970' or date('Y', strtotime($item['dt_expiration'])) == '9999') {
    $infinite = true;
  } else {
    $infinite = false;
  }

  if($action == 'republish_admin' and $item_id <> 0 and $item_id <> '') {
    $today = date('Y-m-d', strtotime(' -1 day', time()));

    if($infinite) {
      $expire_date = date('Y-m-d', strtotime('9999-12-31'));
    } else {
      $expire_date = date('Y-m-d', strtotime($item['dt_expiration']));
    }

    if($item['b_premium'] == 1 && $discard_premium == 1) {
      $premium_set = 0;
    } else {
      $premium_set = $item['b_premium'];
    }

    $expiration_days = osc_get_preference('bo_mgr_default_exp_days', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_default_exp_days', 'plugin-bo_mgr') : '';

    if($expiration_days == '' or $expiration_days == 0) {
      $expiration_days = $category['i_expiration_days'] <> 0 ? $category['i_expiration_days'] : 30;
    }

    $pub_date = date('Y-m-d H:i:s', time());

    if($infinite) {
      $exp_date = date('Y-m-d H:i:s', strtotime('9999-12-31 23:59:59'));
    } else {
      $exp_date = date('Y-m-d H:i:s', strtotime($today . ' + ' . $expiration_days . ' day'));
    }

    ModelBO::newInstance()->republish_item( $item_id, $pub_date, $exp_date, $premium_set, 1 );

    // Flash message is not shown when admin republish listing
    if($action <> 'republish_admin') {
      osc_add_flash_ok_message( __('Listing was successfully republished and will expire in', 'backoffice_manager') . ' ' . $expiration_days . ' ' . __('days on', 'backoffice_manager') . ' ' . date('Y-m-d', strtotime($today . ' + ' . $expiration_days . ' day')));
    }

    header('Location: ' . osc_admin_base_url(true) . '?page=items');
    exit;
  }
}

osc_add_hook('admin_header', 'bo_mgr_admin_republish');



//Create raw url for republishing. Return false if listing is not about expire
function republish_link_raw($item_id) {
  $item = ModelBO::newInstance()->getItem( $item_id );
  $today = date('Y-m-d', strtotime(' -1 day', time()));

  if(date('Y', strtotime($item['dt_expiration'])) == '1970' or date('Y', strtotime($item['dt_expiration'])) == '9999') {
    $expire_date = date('Y-m-d', strtotime('9999-12-31'));
  } else {
    $expire_date = date('Y-m-d', strtotime($item['dt_expiration']));
  }  

  $user_notify_before = osc_get_preference('bo_mgr_user_notify_before', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_user_notify_before', 'plugin-bo_mgr') : 3;

  if(date('Y', strtotime($item['dt_expiration'])) == '1970' or date('Y', strtotime($item['dt_expiration'])) == '9999') {
    $will_expire_date = date('Y-m-d', strtotime('9999-12-31'));
  } else {
    $will_expire_date = date('Y-m-d', strtotime(" - " . $user_notify_before . " day", strtotime($expire_date)));
  }

  $republished = $item['republish_times'] <> '' ? $item['republish_times'] : 0;
  $max_republish = osc_get_preference('bo_mgr_max_republish', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_max_republish', 'plugin-bo_mgr') : 10;
  $republish_anytime = osc_get_preference('bo_mgr_republish_anytime', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_republish_anytime', 'plugin-bo_mgr') : 0;
  
  if(($today >= $will_expire_date or $republish_anytime == 1) and $republished < $max_republish) {
    //return osc_route_url('republish-link', array('item_id' => $item_id. 'redirect' => ''));
    //return osc_base_url() . 'oc-content/plugins/backoffice_manager/republish.php?item_id=' . $item_id;
    return osc_route_url('bomgr-republish', array('item_id' => $item_id, 'secret' => $item['s_secret']));
  } else {
    return false;
  }
}



//Create output link to republish item. When listing is not about expire, link is not shown
function republish_link($item_id, $link_title = NULL, $target = '_blank') {
  $link = republish_link_raw($item_id);
  $link_title = ($link_title == '' ? __('Republish now!', 'backoffice_manager') : $link_title);

  if($link) {
    echo '<a style="color:green;font-weight:bold;" class="bo-mgr-republish" href="' . $link . '" target="' . $target . '" title="' . osc_esc_html(__('This listing is about expire or has expired. Click to republish this item if it is still valid', 'backoffice_manager')) . '">' . $link_title . '</a>';
  }
}


// FUNCTION FOR AUTOMATICAL LISTING REPUBLISH
function republish_item_auto($item_id) {
  $pay_per_post = osc_get_preference('pay_per_post', 'payment') <> '' ? osc_get_preference('pay_per_post', 'payment') : 0;

  if($item_id <> '') {
    $item = ModelBO::newInstance()->getItem( $item_id );
    $discard_premium = osc_get_preference('bo_mgr_discard_premium', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_discard_premium', 'plugin-bo_mgr') : 1;
    $category = Category::newInstance()->findByPrimaryKey( $item['fk_i_category_id'] );

    //Check if listing is infinite or it will expire.
    if(date('Y', strtotime($item['dt_expiration'])) == '1970' or date('Y', strtotime($item['dt_expiration'])) == '9999') {
      $infinite = true;
    } else {
      $infinite = false;
    }
    
    if($item['pk_i_id'] <> '') {
      $today = date('Y-m-d', strtotime(' -1 day', time()));

      if($infinite) {
        $expire_date = date('Y-m-d', strtotime('9999-12-31'));
      } else {
        $expire_date = date('Y-m-d', strtotime($item['dt_expiration']));
      }

      if($item['b_premium'] == 1 && $discard_premium == 1) {
        $premium_set = 0;
      } else {
        $premium_set = $item['b_premium'];
      }

      $expiration_days = osc_get_preference('bo_mgr_default_exp_days', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_default_exp_days', 'plugin-bo_mgr') : '';

      if($expiration_days == '' or $expiration_days == 0) {
        $expiration_days = $category['i_expiration_days'] <> 0 ? $category['i_expiration_days'] : 30;
      }

      $pub_date = date('Y-m-d H:i:s', time());

      if($infinite) {
        $exp_date = date('Y-m-d H:i:s', strtotime('9999-12-31 23:59:59'));
      } else {
        $exp_date = date('Y-m-d H:i:s', strtotime($today . ' + ' . $expiration_days . ' day'));
      }

      $republished = $item['republish_times'] <> '' ? $item['republish_times'] : 0;
      $max_republish = osc_get_preference('bo_mgr_max_republish', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_max_republish', 'plugin-bo_mgr') : 10;
      $republish_inactive = osc_get_preference('bo_mgr_republish_inactive', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_republish_inactive', 'plugin-bo_mgr') : 0;
      $republish_inactive = $republish_inactive*(-1)+1;
      $notify_admin = osc_get_preference('bo_mgr_admin_notify', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_admin_notify', 'plugin-bo_mgr') : 0;
      $republish_anytime = osc_get_preference('bo_mgr_republish_anytime', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_republish_anytime', 'plugin-bo_mgr') : 0;


      if($notify_admin == 1) {
        email_admin($item_id, $expiration_days);
      }

      //Payment is required
      if($pay_per_post == 1) {
        ModelBO::newInstance()->updatePaymentTable($item_id, 0);
        email_payment_required($item_id);
      }

      ModelBO::newInstance()->republish_item( $item_id, $pub_date, $exp_date, $premium_set, $republish_inactive, true );     
    }
  }
}
?>