<?php
/*
  Plugin Name: Backoffice Manager Pro Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/backoffice/backoffice-manager-plugin_i49
  Description: Advanced management functions for listings, comments & users
  Version: 1.5.4
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: backoffice_manager
  Plugin update URI: backoffice-manager-plugin
  Support URI: https://forums.osclasspoint.com/backoffice-manager-plugin/
  Product Key: LacliCEGw3BAf1JlcNdU
*/

require_once 'model/ModelBO.php';
require_once 'model/ModelLS.php';
require_once 'model/ModelFB.php';
require_once 'model/ModelAX.php';
require_once 'email.php';
require_once 'dev/functions.php';
require_once 'function/feedback.php';
require_once 'function/republish.php';
 

osc_add_route('bomgr-republish', 'item/bomgr-republish/([0-9]+)/(.+)', 'item/bomgr-republish/{item_id}/{secret}', osc_plugin_folder(__FILE__).'republish.php', false, 'custom', 'bomgr-republish', __('Republish listing', 'backoffice_manager'));
osc_add_route('bomgr-change-status', 'item/bomgr-change-status/([0-9]+)/([0-9]+)/(.+)', 'item/bomgr-change-status/{item_id}/{status_id}/{secret}', osc_plugin_folder(__FILE__).'status_change.php', false, 'custom', 'bomgr-status-change', __('Change listing status', 'backoffice_manager'));


function bo_mgr_call_after_install($reenable = NULL) {
  if($reenable == '') {
    ModelBO::newInstance()->import('backoffice_manager/model/struct.sql');
  }

  osc_set_preference('bo_mgr_admin_notify', 1, 'plugin-bo_mgr', 'INTEGER');              //notify admin that someone has republished listing
  osc_set_preference('bo_mgr_user_notify', 1, 'plugin-bo_mgr', 'INTEGER');               //notify user that listing has been republished
  osc_set_preference('bo_mgr_user_notify_before', 3, 'plugin-bo_mgr', 'INTEGER');        //how many days before listing will expired will be send notification to user
  osc_set_preference('bo_mgr_delete_days', 30, 'plugin-bo_mgr', 'INTEGER');              //after how many days listing has expired will be deleted
  osc_set_preference('bo_mgr_republish_inactive', 0, 'plugin-bo_mgr', 'INTEGER');        //when listing is republished, it is set to inactive
  osc_set_preference('bo_mgr_max_republish', 10, 'plugin-bo_mgr', 'INTEGER');            //maximum count of republish of particular listing
  osc_set_preference('bo_mgr_send_stats', 1, 'plugin-bo_mgr', 'INTEGER');                //when listing expired, should be detail stats (views) of listing sent to user?
  osc_set_preference('bo_mgr_default_exp_days', 30, 'plugin-bo_mgr', 'INTEGER');         //number of days that will be expiration date extended when republishing listing
  osc_set_preference('bo_mgr_discard_premium', 1, 'plugin-bo_mgr', 'INTEGER');           //when premium listing has expired, should it be premium after republish as well?
  osc_set_preference('bo_mgr_enchance_premium_search', 1, 'plugin-bo_mgr', 'INTEGER');   //enchance search so premium listings are shown first ordered by pub date
  osc_set_preference('bo_mgr_improve_expired_item', 1, 'plugin-bo_mgr', 'INTEGER');      //disable item page when listing has expired and show message that listing is not valid anymore
  osc_set_preference('bo_mgr_allow_delete_user_account', 1, 'plugin-bo_mgr', 'INTEGER'); //add possibility to user to delete it's account
  osc_set_preference('bo_mgr_autohook_password', 1, 'plugin-bo_mgr', 'INTEGER');         //automatically hook password form to item_post.php & item_edit.php
  osc_set_preference('bo_mgr_autohook_mobile', 1, 'plugin-bo_mgr', 'INTEGER');           //automatically hook mobile form to item_post.php & item_edit.php
  osc_set_preference('bo_mgr_autohook_status', 1, 'plugin-bo_mgr', 'INTEGER');           //automatically hook status form to item_post.php & item_edit.php
  osc_set_preference('bo_mgr_autohook_status_search', 1, 'plugin-bo_mgr', 'INTEGER');    //automatically hook status form to search page
  osc_set_preference('bo_mgr_pay_only_republish', 0, 'plugin-bo_mgr', 'INTEGER');        //if pay per post is allowed on payment plugin, only payment for republish will be required
  osc_set_preference('bo_mgr_republish_anytime', 0, 'plugin-bo_mgr', 'INTEGER');         //allow users to republish listing anytime
  osc_set_preference('bo_mgr_allow_autorepublish', 1, 'plugin-bo_mgr', 'INTEGER');       //allow auto-republish feature
  osc_set_preference('bo_mgr_autohook_autorepublish', 1, 'plugin-bo_mgr', 'INTEGER');    //automatically hook autorepublish form to item_post.php & item_edit.php
  osc_set_preference('bo_mgr_times_autorepublish', '1, 3, 5, 10', 'plugin-bo_mgr', 'STRING'); //total number of republish user can choose

  osc_set_preference('bo_mgr_inactive_user_del_days', 7, 'plugin-bo_mgr', 'INTEGER');    //after how many days are inactive users deleted
  osc_set_preference('bo_mgr_not_logged_user_del_days', 90, 'plugin-bo_mgr', 'INTEGER'); //after how many days are users that never logged im deleted
  osc_set_preference('bo_mgr_del_disabled_users', 0, 'plugin-bo_mgr', 'INTEGER');        //disabled users: 0 - do not delete, 1 - delete daily, 2 - delete weekly
  osc_set_preference('bo_mgr_inactive_comments_del_days', 7, 'plugin-bo_mgr', 'INTEGER');//after how many days are inactive comments deleted
  osc_set_preference('bo_mgr_del_disabled_comments', 2, 'plugin-bo_mgr', 'INTEGER');     //disabled & spam comments: 0 - do not delete, 1 - delete daily, 2 - delete weekly
  osc_set_preference('bo_mgr_inactive_listings_del_days', 7, 'plugin-bo_mgr', 'INTEGER');//after how many days are inactive listings deleted
  osc_set_preference('bo_mgr_del_disabled_listings', 0, 'plugin-bo_mgr', 'INTEGER');     //disabled & spam listings: 0 - do not delete, 1 - delete daily, 2 - delete weekly
  osc_set_preference('bo_mgr_status_post_enable', 1, 'plugin-bo_mgr', 'INTEGER');        //user is allowed to add own Listing Status when publishing new listing: 0 - only admin, 1 - everyone, 2 - only registered
  osc_set_preference('bo_mgr_status_edit_enable', 1, 'plugin-bo_mgr', 'INTEGER');        //user is allowed to add own Listing Status when publishing new listing: 0 - only admin, 1 - everyone, 2 - only registered
  osc_set_preference('bo_mgr_status_email', 1, 'plugin-bo_mgr', 'INTEGER');              //when new listing is created, email user possibilities to change status
  osc_set_preference('bo_mgr_status_to_filter', 1, 'plugin-bo_mgr', 'INTEGER');          //add status select to search filters (user can filter by status)

  osc_set_preference('bo_mgr_user_extend_phone', 0, 'plugin-bo_mgr', 'INTEGER');         //add phone number field to user registration
  osc_set_preference('bo_mgr_user_extend_type', 0, 'plugin-bo_mgr', 'INTEGER');          //add user type select to user registration
  osc_set_preference('bo_mgr_user_extend_web', 0, 'plugin-bo_mgr', 'INTEGER');           //add web url field to user registration
  osc_set_preference('bo_mgr_user_extend_country', 0, 'plugin-bo_mgr', 'INTEGER');       //add country select to user registration
  osc_set_preference('bo_mgr_user_extend_region', 0, 'plugin-bo_mgr', 'INTEGER');        //add region select to user registration
  osc_set_preference('bo_mgr_user_extend_city', 0, 'plugin-bo_mgr', 'INTEGER');          //add city select to user registration
  osc_set_preference('bo_mgr_user_required_phone', 0, 'plugin-bo_mgr', 'INTEGER');       //is required phone number field in user registration
  osc_set_preference('bo_mgr_user_required_web', 0, 'plugin-bo_mgr', 'INTEGER');         //is required web url field in user registration
  osc_set_preference('bo_mgr_user_required_country', 0, 'plugin-bo_mgr', 'INTEGER');     //is required country select in user registration
  osc_set_preference('bo_mgr_user_required_region', 0, 'plugin-bo_mgr', 'INTEGER');      //is required region select in user registration
  osc_set_preference('bo_mgr_user_required_city', 0, 'plugin-bo_mgr', 'INTEGER');        //is required city select in user registration

  osc_set_preference('bo_mgr_item_required_name', 0, 'plugin-bo_mgr', 'INTEGER');        //is required country select in item post/edit
  osc_set_preference('bo_mgr_item_required_price', 0, 'plugin-bo_mgr', 'INTEGER');       //is required country select in item post/edit
  osc_set_preference('bo_mgr_item_required_country', 0, 'plugin-bo_mgr', 'INTEGER');     //is required country select in item post/edit
  osc_set_preference('bo_mgr_item_required_region', 0, 'plugin-bo_mgr', 'INTEGER');      //is required region select in item post/edit
  osc_set_preference('bo_mgr_item_required_city', 0, 'plugin-bo_mgr', 'INTEGER');        //is required city select in item post/edit

  osc_set_preference('bo_mgr_allow_feedback', 1, 'plugin-bo_mgr', 'INTEGER');            //allow to leave feedback on sellers
  osc_set_preference('bo_mgr_feedback_active', 1, 'plugin-bo_mgr', 'INTEGER');           //when new feedback is added, it is active or no (?)
  osc_set_preference('bo_mgr_feedback_only_reg', 0, 'plugin-bo_mgr', 'INTEGER');         //only registered users can leave feedback
  osc_set_preference('bo_mgr_feedback_time_between', 30, 'plugin-bo_mgr', 'INTEGER');    //minimum time between 2 feedbacks (in seconds)
  osc_set_preference('bo_mgr_feedback_max_count', 3, 'plugin-bo_mgr', 'INTEGER');        //maximum comments that can user add in period of time - set count
  osc_set_preference('bo_mgr_feedback_max_period', 1, 'plugin-bo_mgr', 'INTEGER');       //maximum comments that can user add in period of time - set period (hours)
  osc_set_preference('bo_mgr_feedback_validate_times', 3, 'plugin-bo_mgr', 'INTEGER');   //after XX validated comments other comments of this user are auto-validated
  osc_set_preference('bo_mgr_feedback_wilson', 1, 'plugin-bo_mgr', 'INTEGER');           //use wilson formula to get best users
  osc_set_preference('bo_mgr_feedback_own', 1, 'plugin-bo_mgr', 'INTEGER');              //user can leave feedback in own profile
  osc_set_preference('bo_mgr_feedback_change_name', 0, 'plugin-bo_mgr', 'INTEGER');      //registered user can change own name

  osc_set_preference('bo_mgr_allow_autocomplete', 1, 'plugin-bo_mgr', 'INTEGER');        //allow autocomplete on search input field


  //upload email templates
  foreach(osc_listLocales() as $loc) {
    //bo_mgr_email_expired template
    $des_expired[$loc['code']]['s_title'] = '{WEB_TITLE} - Your listing #{ITEM_ID} has expired';
    $des_expired[$loc['code']]['s_text'] = '<p>Hi {CONTACT_NAME}!</p> <p>Let us inform you, that your listing: <strong>{ITEM_TITLE} (#{ITEM_ID})</strong> has just expired and is not active on our site anymore.</p> <p>If this listing is still active and you want to continue offering it on our site, please republish this listing on following link:</p> <p><strong><span style="color: #1400ff;">{REPUBLISH_URL}</span></strong></p> <p>Regards, <br />{WEB_TITLE}</p>';

    //bo_mgr_email_autorepublish template
    $des_autorepublish[$loc['code']]['s_title'] = '{WEB_TITLE} - Your listing #{ITEM_ID} has been auto-republished';
    $des_autorepublish[$loc['code']]['s_text'] = '<p>Hi {CONTACT_NAME}!</p> <p>Let us inform you, that your listing: <strong>{ITEM_TITLE} (#{ITEM_ID})</strong> has just been auto-republished.</p> <p>You can find your listing on: {URL}</p> <p>Regards, <br />{WEB_TITLE}</p>';

    //bo_mgr_email_payment_required
    $des_payment_required[$loc['code']]['s_title'] = '{WEB_TITLE} - Your listing #{ITEM_ID} is not active yet';
    $des_payment_required[$loc['code']]['s_text'] = '<p>Hi {CONTACT_NAME}!</p> <p>Let us inform you, that your listing: <strong>{ITEM_TITLE} (#{ITEM_ID})</strong> require payment to be active and visible on our site.</p> <p>You can find your listing on: {URL}</p> <p>Please visit following URL to make payment: {PAYMENT_URL}</p> <p>Regards, <br />{WEB_TITLE}</p>';

    //bo_mgr_status template
    $des_status[$loc['code']]['s_title'] = '{WEB_TITLE} - Change status on your listing #{ITEM_ID}';
    $des_status[$loc['code']]['s_text'] = '<p>Hi {CONTACT_NAME}!</p> <p>Let us inform you, that you can change status on listing: <strong>{ITEM_TITLE} (#{ITEM_ID})</strong> anytime.</p> <p>You can change status when you edit your listing, or simply clicking on following links: </p> <P>{STATUS_LIST}</p> <p>{PASSWORD_TEXT}</p> <p>Regards, <br />{WEB_TITLE}</p>';

    //bo_mgr_email_will_expire template
    $des_will_expire[$loc['code']]['s_title'] = '{WEB_TITLE} - Your listing #{ITEM_ID} will expire in {EXPIRE_DAYS} day(s)';
    $des_will_expire[$loc['code']]['s_text'] = '<p>Hi {CONTACT_NAME}!</p> <p>Let us inform you, that your listing: <strong>{ITEM_TITLE} (#{ITEM_ID})</strong> will expire in <strong>{EXPIRE_DAYS} day(s)</strong> and will not be active on our site anymore.</p> <p>If this listing is still active and you want to continue offering it on our site, please republish this listing on following link:</p> <p><strong><span style="color: #1400ff;">{REPUBLISH_URL}</span></strong></p> <p>Regards, <br />{WEB_TITLE}</p>';

    //bo_mgr_email_removed template
    $des_removed[$loc['code']]['s_title'] = '{WEB_TITLE} - Your listing #{ITEM_ID} has been removed';
    $des_removed[$loc['code']]['s_text'] = '<p>Hi {CONTACT_NAME}!</p> <p>Let us inform you, that your listing: <strong>{ITEM_TITLE} (#{ITEM_ID})</strong> has expired before <strong>{REMOVE_DAYS} day(s)</strong> and was removed from our site.</p> <p>If this listing is still active and you want to continue offering it on our site, please add it again to our site.</p> <p>Regards, <br />{WEB_TITLE}</p> <p> </p>';

    //bo_mgr_email_confirm template
    $des_confirm[$loc['code']]['s_title'] = '{WEB_TITLE} - Your listing #{ITEM_ID} has been republished';
    $des_confirm[$loc['code']]['s_text'] = '<p>Hi {CONTACT_NAME}!</p> <p>Let us inform you, that your listing: <strong>{ITEM_TITLE} (#{ITEM_ID})</strong> has been successfully republished on our site.</p> <p>You can find your listing on following URL:</p> <p><strong><span style="color: #1400ff;">{ITEM_URL}</span></strong></p> <p>Regards, <br />{WEB_TITLE}</p> <p> </p>';

    //bo_mgr_email_send_stats template
    $des_send_stats[$loc['code']]['s_title'] = '{WEB_TITLE} - Statistics of your listing #{ITEM_ID}';
    $des_send_stats[$loc['code']]['s_text'] = '<p>Hi {CONTACT_NAME}!</p> <p>Let\'s check statistics of your listing: <strong>{ITEM_TITLE} (#{ITEM_ID})</strong>.</p> <p>For time your listing was active on our site, it was viewed by <strong>{REGULAR_VIEWS_TOTAL}</strong> people.<br />For time your listing was premium on our site, it was viewed by <strong>{PREMIUM_VIEWS_TOTAL}</strong> people.<br />You were also contacted by <strong>{CONTACT_FORM_USED} </strong>people.</p> <p>You can find you listing on URL:</p> <p><strong><span style="color: #1400ff;">{ITEM_URL}</span></strong></p> <p>Regards, <br />{WEB_TITLE}</p>';
    
    //bo_mgr_email_admin template
    $des_admin[$loc['code']]['s_title'] = '{WEB_TITLE} - Listing #{ITEM_ID} has been republished';
    $des_admin[$loc['code']]['s_text'] = '<p>Hi {CONTACT_NAME}!</p> <p>Listing: <strong>{ITEM_TITLE} (#{ITEM_ID})</strong> was republished today by <strong>{USER_NAME}</strong> and will expire in <strong>{EXPIRE_DAYS}</strong> day(s).</p> <p><span style="line-height: 1.5em;">You can find this listing on URL:</span></p> <p><strong><span style="color: #1400ff;">{ITEM_URL}</span></strong></p> <p>Regards, <br />{WEB_TITLE}</p> <p> </p>';
  }
  
  Page::newInstance()->insert( array('s_internal_name' => 'bo_mgr_email_expired', 'b_indelible' => '1'), $des_expired );
  Page::newInstance()->insert( array('s_internal_name' => 'bo_mgr_email_autorepublish', 'b_indelible' => '1'), $des_autorepublish );
  Page::newInstance()->insert( array('s_internal_name' => 'bo_mgr_email_payment_required', 'b_indelible' => '1'), $des_payment_required );
  Page::newInstance()->insert( array('s_internal_name' => 'bo_mgr_email_status', 'b_indelible' => '1'), $des_status );
  Page::newInstance()->insert( array('s_internal_name' => 'bo_mgr_email_will_expire', 'b_indelible' => '1'), $des_will_expire );
  Page::newInstance()->insert( array('s_internal_name' => 'bo_mgr_email_removed', 'b_indelible' => '1'), $des_removed );
  Page::newInstance()->insert( array('s_internal_name' => 'bo_mgr_email_confirm', 'b_indelible' => '1'), $des_confirm );
  Page::newInstance()->insert( array('s_internal_name' => 'bo_mgr_email_send_stats', 'b_indelible' => '1'), $des_send_stats );
  Page::newInstance()->insert( array('s_internal_name' => 'bo_mgr_email_admin', 'b_indelible' => '1'), $des_admin );
}

function bo_mgr_call_after_uninstall() {
  ModelBO::newInstance()->uninstall();
  osc_delete_preference('bo_mgr_admin_notify', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_user_notify', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_user_notify_before', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_delete_days', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_max_republish', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_republish_inactive', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_send_stats', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_discard_premium', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_default_exp_days', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_enchance_premium_search', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_improve_expired_item', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_autohook_password', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_autohook_mobile', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_autohook_status', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_autohook_status_search', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_pay_only_republish', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_republish_anytime', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_allow_autorepublish', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_autohook_autorepublish', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_times_autorepublish', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_inactive_user_del_days', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_not_logged_user_del_days', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_del_disabled_users', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_inactive_comments_del_days', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_del_disabled_comments', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_inactive_listings_del_days', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_del_disabled_listings', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_user_extend_phone', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_user_extend_type', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_user_extend_web', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_user_extend_country', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_user_extend_region', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_user_extend_city', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_user_required_phone', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_user_required_web', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_user_required_country', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_user_required_region', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_user_required_city', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_item_required_name', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_item_required_price', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_item_required_country', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_item_required_region', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_item_required_city', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_allow_delete_user_account', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_status_post_enable', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_status_edit_enable', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_status_email', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_status_to_filter', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_allow_feedback', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_feedback_active', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_feedback_only_reg', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_feedback_time_between', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_feedback_max_count', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_feedback_max_period', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_feedback_validate_times', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_feedback_wilson', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_feedback_own', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_feedback_change_name', 'plugin-bo_mgr');
  osc_delete_preference('bo_mgr_allow_autocomplete', 'plugin-bo_mgr');

  //get list of primary keys of static pages (emails) that should be deleted on uninstall
  $pages = ModelBO::newInstance()->getPages();  
  foreach($pages as $page) {
    Page::newInstance()->deleteByPrimaryKey($page['pk_i_id']);
  }
}


// CHECK IF RUNNING ON DEMO
function bmr_is_demo() {
  if(osc_logged_admin_username() == 'admin') {
    return false;
  } else if(isset($_SERVER['HTTP_HOST']) && (strpos($_SERVER['HTTP_HOST'],'mb-themes') !== false || strpos($_SERVER['HTTP_HOST'],'abprofitrade') !== false)) {
    return true;
  } else {
    return false;
  }
}

// JAVASCRIPT STRINGS TO FOOTER
function bo_mgr_footer_js() {
?>
<script type="text/javascript">
  var boMgrSelectRegion = "<?php echo osc_esc_html(__('Select a region...', 'backoffice_manager')); ?>";
  var boMgrSelectCity = "<?php echo osc_esc_html(__('Select a city...', 'backoffice_manager')); ?>";
  var boMgrNoResults = "<?php echo osc_esc_html(__('No results', 'backoffice_manager')); ?>";
</script>
<?php  
}

osc_add_hook('footer', 'bo_mgr_footer_js');



//Autocomplete on search field
function bo_mgr_autocomplete() {
  $allow_autocomplete = osc_get_preference('bo_mgr_allow_autocomplete', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_allow_autocomplete', 'plugin-bo_mgr') : 1;

  if($allow_autocomplete == 1) {
    include_once 'js/js_autocomplete.php';
  }
}

osc_add_hook('search_form', 'bo_mgr_autocomplete');


// CHECK IF RUNNING ON DEMO
function bom_is_demo() {
  return bmr_is_demo();
}


/* ------------------------------ Republish & Cleaning functions --------------------------------*/

//Go through listings that Expire, should be Notified or Deleted and do action
function bo_mgr_control_listings() {
  $today = date('Ymd', strtotime(' -1 day', time()));

  $user_notify_before = osc_get_preference('bo_mgr_user_notify_before', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_user_notify_before', 'plugin-bo_mgr') : 3;
  $user_notify_before = $user_notify_before - 1;
  $user_notify_before_date = date('Ymd', strtotime(' +'. $user_notify_before .' day', time()));

  $delete_days = osc_get_preference('bo_mgr_delete_days', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_delete_days', 'plugin-bo_mgr') : 30;
  $delete_days = $delete_days + 1;
  $delete_date = date('Ymd', strtotime(' -'. $delete_days .' day', time()));

  $items = ModelBO::newInstance()->getItems($today, $user_notify_before_date, $delete_date);

  foreach($items as $item) {
    bo_mgr_expired($item['pk_i_id']);
    //echo $item['pk_i_id'];
  }

  //For debug purpose only
  //echo '<br /><br />Delete Date: ' . $delete_date . ' --- User Notify Before Date: ' . $user_notify_before_date;
}

//This function check what action should be done with listing: Notify, Expire or Delete
function bo_mgr_expired($item_id) {
  $item = ModelBO::newInstance()->getItem( $item_id );
  $item_stats = ModelBO::newInstance()->getStats( $item_id );

  //Check if listing is infinite or it will expire.
  if(date('Y', strtotime($item['dt_expiration'])) == '1970' or date('Y', strtotime($item['dt_expiration'])) == '9999') {
    $infinite = true;
  } else {
    $infinite = false;
  }

  $today = date('Y-m-d', strtotime(' -1 day', time()));

  if($infinite) {
    $expire_date = date('Y-m-d', strtotime('9999-12-31'));
  } else {
    $expire_date = date('Y-m-d', strtotime($item['dt_expiration']));
  }  

  $delete_days = osc_get_preference('bo_mgr_delete_days', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_delete_days', 'plugin-bo_mgr') : 30;

  if($infinite) {
    $delete_date = date('Y-m-d', strtotime('9999-12-31'));
  } else {
    $delete_date = date('Y-m-d', strtotime($expire_date . ' + ' . $delete_days . ' day'));
  }

  $max_republish = osc_get_preference('bo_mgr_max_republish', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_max_republish', 'plugin-bo_mgr') : 10;
  $user_notify = osc_get_preference('bo_mgr_user_notify', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_user_notify', 'plugin-bo_mgr') : 1;
  $user_notify_before = osc_get_preference('bo_mgr_user_notify_before', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_user_notify_before', 'plugin-bo_mgr') : 3;
  $admin_notify = osc_get_preference('bo_mgr_admin_notify', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_admin_notify', 'plugin-bo_mgr') : 1;
  $allow_autorepublish = osc_get_preference('bo_mgr_allow_autorepublish', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_allow_autorepublish', 'plugin-bo_mgr') : 1;

  if($infinite) {
    $will_expire_date = date('Y-m-d', strtotime('9999-12-31'));
  } else {
    $will_expire_date = date('Y-m-d', strtotime(" - " . $user_notify_before . " day", strtotime($expire_date)));
  }

  $send_stats = osc_get_preference('bo_mgr_send_stats', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_send_stats', 'plugin-bo_mgr') : 1;

  $regular_views = $item_stats['regular_views_total'];
  $premium_views = $item_stats['premium_views_total'];
  $republish_auto = $item['republish_auto'];

  //Listing will expire in XX days
  if($will_expire_date == $today) {
    if($republished < $max_republish && $user_notify == 1) {
      email_will_expire($item_id, $user_notify_before);
    }
  }

  //Listing expire today
  if($expire_date == $today) {
    if($send_stats == 1) {
      email_send_stats($item_id, $regular_views, $premium_views, $item['form_used']);
    }

    if($republished < $max_republish) {
      if($republish_auto > 0 && $allow_autorepublish == 1) {
        if($user_notify == 1) {
          email_autorepublish($item_id);
        }

        republish_item_auto($item_id);
      } else {
        if($user_notify == 1) {
          email_expired($item_id);
        }
      }
    } else {
      if($user_notify == 1) {
        email_removed($item_id, $delete_days);
      }

      Item::newInstance()->deleteByPrimaryKey( $item_id );
    }
  }

  //Listing is deleted today
  if($delete_date <= $today) {
    if($user_notify == 1) {
      email_removed($item_id, $delete_days);
    }
    Item::newInstance()->deleteByPrimaryKey( $item_id );
  }
}

//Run listing control once a day
osc_add_hook('cron_daily', 'bo_mgr_control_listings');


/* ------------------------------ Add password & mobile for listing edit ------------------------*/

function bo_mgr_pass_form($catId = null, $item_id = null) {
  include_once 'form/form_passwrd.php';
}

function bo_mgr_mobile_form($catId = null, $item_id = null) {
  include_once 'form/form_mobile.php';
}

function bo_mgr_autorepublish_form($catId = null, $item_id = null) {
  include 'form/form_autorepublish.php';
}

function bo_mgr_edit_delete_links() {
  include 'form/form_edit_delete_links.php';
}


function bo_mgr_status_post_form($catId = null, $item_id = null) {
  $status_allow_post = osc_get_preference('bo_mgr_status_post_enable', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_status_post_enable', 'plugin-bo_mgr') : 1;

  if($status_allow_post == 0 and osc_is_admin_user_logged_in()) {
    include_once 'form/form_item_status.php';
  } else if ($status_allow_post == 2 and osc_is_web_user_logged_in()) { 
    include_once 'form/form_item_status.php';
  } else if ($status_allow_post == 1) {
    include_once 'form/form_item_status.php';
  }
}

function bo_mgr_status_edit_form($catId = null, $item_id = null) {
  $status_allow_edit = osc_get_preference('bo_mgr_status_edit_enable', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_status_edit_enable', 'plugin-bo_mgr') : 1;

  if($status_allow_edit == 0 and osc_is_admin_user_logged_in()) {
    include_once 'form/form_item_status.php';
  } else if ($status_allow_edit == 2 and osc_is_web_user_logged_in()) { 
    include_once 'form/form_item_status.php';
  } else if ($status_allow_edit == 1) {
    include_once 'form/form_item_status.php';
  }
}

function bo_mgr_form_post($item) {
  $status_email = osc_get_preference('bo_mgr_status_email', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_status_email', 'plugin-bo_mgr') : 1;
  $detail = ModelBO::newInstance()->getItem( $item['pk_i_id'] );
  $status = array();
  
  if(Params::getParam('bo_mgr_status') <> '') {
    //$status = ModelLS::newInstance()->getStatus( $status_id );
    $status = ModelLS::newInstance()->getStatus(Params::getParam('bo_mgr_status'));
  }

  if(isset($detail['pk_i_id']) && $detail['pk_i_id'] > 0) {
    ModelBO::newInstance()->updateItem( $item['pk_i_id'], $detail['republish_times'], $detail['form_used'], Params::getParam('bo_mgr_passwrd'), Params::getParam('bo_mgr_mobile'), Params::getParam('bo_mgr_status'), Params::getParam('bo_mgr_autorepublish') );

    //if status is "Sold" status, set item to expired
    if(isset($status['status_sold']) && $status['status_sold'] == 1) {
      $today = date('Y-m-d', strtotime(' -1 day', time()));
      ModelLS::newInstance()->itemToExpired($item['pk_i_id'], $today);
    }
  } else {
    ModelBO::newInstance()->addItem( $item['pk_i_id'], 0, 0, Params::getParam('bo_mgr_passwrd'), Params::getParam('bo_mgr_mobile'), Params::getParam('bo_mgr_status'), Params::getParam('bo_mgr_autorepublish') );

    if($status_email == 1) {
      email_status($item['pk_i_id']); 
    }
  } 
}

function bo_mgr_pre_item_post() {
  Session::newInstance()->_setForm('pp_bo_mgr_passwrd' , Params::getParam('bo_mgr_passwrd'));
  Session::newInstance()->_setForm('pp_bo_mgr_mobile' , Params::getParam('bo_mgr_mobile'));
  Session::newInstance()->_setForm('pp_bo_mgr_autorepublish' , Params::getParam('bo_mgr_autorepublish'));
  Session::newInstance()->_setForm('pp_bo_mgr_status' , Params::getParam('bo_mgr_status'));
	
  // keep values on session
  Session::newInstance()->_keepForm('pp_bo_mgr_passwrd');
  Session::newInstance()->_keepForm('pp_bo_mgr_mobile');
  Session::newInstance()->_keepForm('pp_bo_mgr_autorepublish');
  Session::newInstance()->_keepForm('pp_bo_mgr_status');
}

// Keep values in session
osc_add_hook('pre_item_post', 'bo_mgr_pre_item_post') ;

// To add password, mobile & status new information to our custom table
osc_add_hook('posted_item', 'bo_mgr_form_post');
osc_add_hook('edited_item', 'bo_mgr_form_post');


// When publishing an item we show input for password, mobile & status
$autohook_pass = osc_get_preference('bo_mgr_autohook_password', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_autohook_password', 'plugin-bo_mgr') : 1;
$autohook_mobile = osc_get_preference('bo_mgr_autohook_mobile', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_autohook_mobile', 'plugin-bo_mgr') : 1;
$autohook_status = osc_get_preference('bo_mgr_autohook_status', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_autohook_status', 'plugin-bo_mgr') : 1;
$autohook_autorepublish = osc_get_preference('bo_mgr_autohook_autorepublish', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_autohook_autorepublish', 'plugin-bo_mgr') : 1;
$allow_autorepublish = osc_get_preference('bo_mgr_allow_autorepublish', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_allow_autorepublish', 'plugin-bo_mgr') : 1;

if($autohook_pass == 1) {
  osc_add_hook('item_form', 'bo_mgr_pass_form');
  osc_add_hook('item_edit', 'bo_mgr_pass_form');
}

if($autohook_mobile == 1) {
  osc_add_hook('item_form', 'bo_mgr_mobile_form');
  osc_add_hook('item_edit', 'bo_mgr_mobile_form');
}

if($autohook_status == 1) {
  osc_add_hook('item_form', 'bo_mgr_status_post_form');
  osc_add_hook('item_edit', 'bo_mgr_status_edit_form');
}

if($autohook_autorepublish == 1 && $allow_autorepublish == 1) {
  osc_add_hook('item_form', 'bo_mgr_autorepublish_form');
  osc_add_hook('item_edit', 'bo_mgr_autorepublish_form');
}

//Show mobile number
function bo_mgr_show_mobile( $item_id = NULL) {
  if($item_id == '') {
    $item_id = osc_item_id();
  }

  $item = ModelBO::newInstance()->getItem( $item_id );
  return $item['mobile'];
}

//Show status
function bo_mgr_show_status( $item_id = NULL) {
  if($item_id == '') {
    $item_id = osc_item_id();
  }

  $status = ModelLS::newInstance()->getStatusByItemId($item_id); 
  return '<div class="bo_mgr_status_'. strtolower($status['status_name']) . '" id="bo_mgr_status" style="' . $status['status_style'] . '">' . $status['status_name'] . '</div>';
}

//Verification if entered password is correct and item can be edited / deleted
function bo_mgr_edit_delete_pass($item_id, $pass, $action) {
  $item = ModelBO::newInstance()->getItem( $item_id );
  $item_full = Item::newInstance()->findByPrimaryKey( $item_id );

  if($pass <> $item['passwrd']) {
    osc_add_flash_error_message( __('You have entered incorrect password.', 'backoffice_manager'));
    header('Location: ' . osc_item_url_ns($item_id));
  } else {
    if($action == 'delete') {
      header('Location: ' . osc_base_url() . 'index.php?page=item&action=item_delete&id=' . $item_id . '&secret=' . $item_full['s_secret']);
    } else {
      header('Location: ' . osc_base_url() . 'index.php?page=item&action=item_edit&id=' . $item_id . '&secret=' . $item_full['s_secret']);
    }
  }
}

//Generate Status Select Box
function bo_mgr_status_list($item_id = null, $sold = null) {
  $status_list = ModelLS::newInstance()->getStatusList('', '', '', $sold);

  if($item_id <> '') {
    $item_status = ModelLS::newInstance()->getStatusByItemId($item_id);
    $item_status_id = isset($item_status['status_id']) ? $item_status['status_id'] : '';
  }

  if(!empty($status_list)) {
    $text  = '';
    $text .= '<select id="bo_mgr_status" name="bo_mgr_status">';

    if($item_status_id <> '' and $item_status_id <> 0) {
      $text .= '<option value="0">' . __('No status', 'backoffice_manager') . '</option>';
    } else {
      $text .= '<option value="0">' . __('Select status ...', 'backoffice_manager') . '</option>';
    }

    foreach($status_list as $status) {
      $text .= '<option value=' . $status['status_id'] . ' ' . ( $item_status_id == $status['status_id'] ? 'selected="selected"' : (($status['status_default'] == 1 and $item_status_id == '') ? 'selected="selected"' : '')) . '>' . $status['status_name'] . '</option>';
    }

    $text .= '</select>';
    return $text;
  } else {
    return false;
  }
}

//Generate Status Select Box for search page
function bo_mgr_status_search_list() {
  $status_list = ModelLS::newInstance()->getStatusList('', '', '', '0');

  if(!empty($status_list)) {
    $text  = '';
    $text .= '<select id="bo_mgr_status_to_search" name="bo_mgr_status_to_search">';
    $text .= '<option value="">' . __('Select status ...', 'backoffice_manager') . '</option>';

    foreach($status_list as $status) {
      $selected = '';
      
      if(osc_is_search_page()) {
        if(Params::getParam('bo_mgr_status_to_search') == $status['status_id']) {
          $selected = ' selected="selected"';
        }
      } else {
        if($status['status_default'] == 1) {
          $selected = ' selected="selected"';
        }
      }
    
      $text .= '<option value=' . $status['status_id'] . $selected . '>' . $status['status_name'] . '</option>';
    }

    $text .= '</select>';
    return $text;
  } else {
    return false;
  }
}

function bo_mgr_status_search_conditions() {
  if(bo_mgr_status_search_list()) {
    $status_selected = Params::getParam('bo_mgr_status_to_search');

    if($status_selected <> '') {
      Search::newInstance()->addConditions(sprintf("%st_item_bo_mgr.status_id = %s", DB_TABLE_PREFIX, $status_selected));
      Search::newInstance()->addConditions(sprintf("%st_item.pk_i_id = %st_item_bo_mgr.item_id ", DB_TABLE_PREFIX, DB_TABLE_PREFIX));
      Search::newInstance()->addTable(sprintf("%st_item_bo_mgr", DB_TABLE_PREFIX));
    }
  }
}

// Hook for adding new search conditions
osc_add_hook('search_conditions', 'bo_mgr_status_search_conditions');

function bo_mgr_status_search_form($catId = null) {
  $status_to_filter = osc_get_preference('bo_mgr_status_to_filter', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_status_to_filter', 'plugin-bo_mgr') : 1;

  if($status_to_filter == 1) {
    include_once 'form/form_status_search.php';
  }
}

// Add status select to search form
$autohook_status_search = osc_get_preference('bo_mgr_autohook_status_search', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_autohook_status_search', 'plugin-bo_mgr') : 1;
if($autohook_status_search == 1) {
  osc_add_hook('search_form', 'bo_mgr_status_search_form');
}

/* ----------------------------------------------------------------------------------------------*/


/* ------------------------------ User account delete link --------------------------------------*/
function bo_delete_user() {
  $allow_delete = osc_get_preference('bo_mgr_allow_delete_user_account', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_allow_delete_user_account', 'plugin-bo_mgr') : 1;

  if($allow_delete == 1) {
    $user_id = osc_logged_user_id();
    $user = User::newInstance()->findByPrimaryKey( $user_id );

    if($user_id > 0 && isset($user['s_secret'])) {
      //echo '<li class="opt_del_user"><a href="' . osc_base_url() . 'oc-content/plugins/backoffice_manager/delete_user.php?user_id=' . $user_id . '&secret=' . $user['s_secret'] . '" onclick="return confirm(\''  . osc_esc_js(__('Are you sure you want to delete your account? \nNote that all your listings will be deleted too! \n\nWould you like to continue', 'backoffice_manager')) . '?\')">' . __('Delete account', 'backoffice_manager') . '</a></li>';
      echo '<li class="opt_del_user"><a href="' . osc_base_url(true) . '?page=user&action=delete&id='.$user_id.'&secret='.$user['s_secret'] . '" onclick="return confirm(\''  . osc_esc_js(__('Are you sure you want to delete your account? Note that all your listings will be deleted too! Would you like to continue?', 'backoffice_manager')) . '\')">' . __('Delete account', 'backoffice_manager') . '</a></li>';
    }
  }
}

osc_add_hook('user_menu', 'bo_delete_user');
/* ----------------------------------------------------------------------------------------------*/

/* ------------------------------ Item is Expired -----------------------------------------------*/
//there is strict condition that div/block that keeps item details has class="item"

function bo_mgr_item_is_expired($item) {
  if(osc_item_is_expired()) {
    osc_add_flash_ok_message( __('This listing is expired and is not valid anymore.', 'backoffice_manager'));

    include_once 'form/form_item_expired.php';
  }
}

$improve_expired_item = osc_get_preference('bo_mgr_improve_expired_item', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_improve_expired_item', 'plugin-bo_mgr') : 1;
if($improve_expired_item == 1) {
  osc_add_hook('item_detail', 'bo_mgr_item_is_expired');
}
/* ----------------------------------------------------------------------------------------------*/


/* ------------------------------ Contact form user counter -------------------------------------*/
function bo_mgr_contact_count() {
  ModelBO::newInstance()->contact_form_times( Params::getParam('id') );
}

osc_add_hook('hook_email_item_inquiry', 'bo_mgr_contact_count');
/* ----------------------------------------------------------------------------------------------*/


/* ------------------------------ Extend User Registration fields, Item Required Fields ---------*/
function bo_mgr_user_reg_form() {
  include_once 'form/form_user_reg.php';
}

function bo_mgr_item_required_form() {
  if(osc_is_publish_page()) {
    include_once 'form/form_item_required.php'; 
  }
}

function bo_mgr_pre_user_post() {
  Session::newInstance()->_setForm('pp_bo_mgr_user_phone' , Params::getParam('bo_mgr_user_phone'));
  Session::newInstance()->_setForm('pp_b_company' , Params::getParam('b_company'));
  Session::newInstance()->_setForm('pp_bo_mgr_user_web' , Params::getParam('bo_mgr_user_web'));
  Session::newInstance()->_setForm('pp_countryId' , Params::getParam('countryId'));
  Session::newInstance()->_setForm('pp_country' , Params::getParam('country'));
  Session::newInstance()->_setForm('pp_regionId' , Params::getParam('regionId'));
  Session::newInstance()->_setForm('pp_region' , Params::getParam('region'));
  Session::newInstance()->_setForm('pp_cityId' , Params::getParam('cityId'));
  Session::newInstance()->_setForm('pp_city' , Params::getParam('city'));
	
  // keep values on session
  Session::newInstance()->_keepForm('pp_bo_mgr_user_phone');
  Session::newInstance()->_keepForm('pp_b_company');
  Session::newInstance()->_keepForm('pp_bo_mgr_user_web');
  Session::newInstance()->_keepForm('pp_countryId');
  Session::newInstance()->_keepForm('pp_country');
  Session::newInstance()->_keepForm('pp_regionId');
  Session::newInstance()->_keepForm('pp_region');
  Session::newInstance()->_keepForm('pp_cityId');
  Session::newInstance()->_keepForm('pp_city');
}

osc_add_hook('pre_user_post', 'bo_mgr_pre_user_post');
osc_add_hook('user_register_completed', 'bo_mgr_user_reg_post');
osc_add_hook('user_register_form', 'bo_mgr_user_reg_form');
osc_add_hook('footer', 'bo_mgr_item_required_form');


//Add custom fields to user registration
function bo_mgr_user_reg_post( $userId ) {
  $extend_phone = osc_get_preference('bo_mgr_user_extend_phone', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_user_extend_phone', 'plugin-bo_mgr') : 1;
  $extend_type = osc_get_preference('bo_mgr_user_extend_type', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_user_extend_type', 'plugin-bo_mgr') : 1;
  $extend_web = osc_get_preference('bo_mgr_user_extend_web', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_user_extend_web', 'plugin-bo_mgr') : 1;
  $extend_country = osc_get_preference('bo_mgr_user_extend_country', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_user_extend_country', 'plugin-bo_mgr') : 1;
  $extend_region = osc_get_preference('bo_mgr_user_extend_region', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_user_extend_region', 'plugin-bo_mgr') : 1;
  $extend_city = osc_get_preference('bo_mgr_user_extend_city', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_user_extend_city', 'plugin-bo_mgr') : 1;

  if($extend_phone == 1) {
    $phone = Params::getParam('bo_mgr_user_phone');
    ModelBO::newInstance()->updateUserDetails( $userId, 's_phone_mobile', $phone );
  }

  if($extend_type == 1) {
    $type = Params::getParam('b_company');
    ModelBO::newInstance()->updateUserDetails( $userId, 'b_company', $type );
  }

  if($extend_web == 1) {
    $web = Params::getParam('bo_mgr_user_web');
    ModelBO::newInstance()->updateUserDetails( $userId, 's_website', $web );
  }

  if($extend_country == 1) {
    $country_name = Params::getParam('country');
    $country_code = Params::getParam('countryId');

    if($country_name <> '') {
      $country = Country::newInstance()->findByName($country_name);
    }

    if($country_code <> '') {
      $country = Country::newInstance()->findByCode($country_code);
    }

    if($country_name <> '' or $country_code <> '') {
      ModelBO::newInstance()->updateUserDetails( $userId, 'fk_c_country_code', $country['pk_c_code'] );
      ModelBO::newInstance()->updateUserDetails( $userId, 's_country', $country['s_name'] );
    }
  }

  if($extend_region == 1) {
    $region_id = Params::getParam('regionId');
    $region_name = Params::getParam('region');

    if($region_id <> '') {
      $region = Region::newInstance()->findByPrimaryKey($region_id);
    }

    if($region_name <> '') {
      $region = Region::newInstance()->findByName($region_name);
    }

    ModelBO::newInstance()->updateUserDetails( $userId, 'fk_i_region_id', $region['pk_i_id'] );
    ModelBO::newInstance()->updateUserDetails( $userId, 's_region', $region['s_name'] );
  }

  if($extend_city == 1 and $extend_region == 1) {
    $city_id = Params::getParam('cityId');
    $city_name = Params::getParam('city');

    if($city_id <> '') {
      $city = City::newInstance()->findByPrimaryKey($city_id);
    }

    if($city_name <> '') {
      $city = City::newInstance()->findByName($city_name);
    }

    ModelBO::newInstance()->updateUserDetails( $userId, 'fk_i_city_id', $city['pk_i_id'] );
    ModelBO::newInstance()->updateUserDetails( $userId, 's_city', $city['s_name'] );
  }
}

//Generate Javascript Required Fields Validation
function bo_mgr_generate_validation($form_name, $field_id, $field_name, $field_type) { 
  $field_size = count($field_id);
  osc_register_script('bo_mgr_validation_js', osc_base_url() . 'oc-content/plugins/backoffice_manager/js/js_validation.js', 'jquery');
  osc_enqueue_script('bo_mgr_validation_js');


  $text  = '';
  $text .= '<script type="text/javascript">' . PHP_EOL;
  $text .= '$(document).ready(function() {' . PHP_EOL;
  $text .= 'if( $("form[name=' . $form_name . ']").length > 0 ) {' . PHP_EOL;

  for($i = 0; $i < $field_size; $i++) {
    $text .= '$(\'' . $field_type[$i] . '[id="' . $field_id[$i] . '"]\').addClass("{required: true, messages: { required: \'' . $field_name[$i] . ': ' . __("this field is required", "backoffice_manager") . '\'}}")' . PHP_EOL;
  }

  $text .= '}' . PHP_EOL;
  $text .= '});' . PHP_EOL;
  $text .= '</script>' . PHP_EOL;

  echo $text;
}

/* ----------------------------------------------------------------------------------------------*/


/* ------------------------------ Delete inactive and banned users ------------------------------*/
//Users that did not activated their account for XX days
function bo_mgr_control_inactive_users() {
  $user_delete_days = osc_get_preference('bo_mgr_inactive_user_del_days', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_inactive_user_del_days', 'plugin-bo_mgr') : 7;
  $user_delete_days = $user_delete_days + 1;
  $user_delete_date = date('Ymd', strtotime(' -'. $user_delete_days .' day', time()));

  $user_list = ModelBO::newInstance()->getInactiveUsersToDelete( $user_delete_date );

  if(!empty($user_list)) {
    foreach($user_list as $user) {
      User::newInstance()->deleteUser( $user['pk_i_id'] );
    }
  }
}

//Users that has did not logged in for XX days
function bo_mgr_control_not_logged_users() {
  $user_delete_days = osc_get_preference('bo_mgr_not_logged_user_del_days', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_not_logged_user_del_days', 'plugin-bo_mgr') : 365;
  $user_delete_days = $user_delete_days + 1;
  $user_delete_date = date('Ymd', strtotime(' -'. $user_delete_days .' day', time()));

  $user_list = ModelBO::newInstance()->getNotLoggedUsersToDelete( $user_delete_date );

  if(!empty($user_list)) {
    foreach($user_list as $user) {
      User::newInstance()->deleteUser( $user['pk_i_id'] );
    }
  }
}

//Users that are Disabled
function bo_mgr_control_disabled_users() {
  $user_list = ModelBO::newInstance()->getDisabledUsersToDelete();

  if(!empty($user_list)) {
    foreach($user_list as $user) {
      User::newInstance()->deleteUser( $user['pk_i_id'] );
    }
  }
}


//Run user control once a day
osc_add_hook('cron_daily', 'bo_mgr_control_inactive_users');
osc_add_hook('cron_daily', 'bo_mgr_control_not_logged_users');

$delete_disabled_users = osc_get_preference('bo_mgr_del_disabled_users', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_del_disabled_users', 'plugin-bo_mgr') : 0;
if($delete_disabled_users == 1) {
  osc_add_hook('cron_daily', 'bo_mgr_control_disabled_users');
} elseif ($delete_disabled_users == 2) {
  osc_add_hook('cron_weekly', 'bo_mgr_control_disabled_users');
}
/* ----------------------------------------------------------------------------------------------*/



/* ------------------------------ Store original IDs to not get them messed ---------------------*/
function bo_mgr_store() {
  GLOBAL $bo_mgr_item;
  $bo_mgr_item = osc_item();
}

osc_add_hook('header', 'bo_mgr_store');

function bo_mgr_js() {
  echo '<script>';
  echo 'var boMgrBaseUrl = "' . osc_base_url(true) . '";';
  echo '</script>';
}

osc_add_hook('header', 'bo_mgr_js');


/* ----------------------------------------------------------------------------------------------*/



/* ------------------------------ Delete inactive and spam comments -----------------------------*/
//Comments that were not activated for XX days
function bo_mgr_control_inactive_comments() {
  $com_delete_days = osc_get_preference('bo_mgr_inactive_comments_del_days', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_inactive_comments_del_days', 'plugin-bo_mgr') : 7;
  $com_delete_days = $com_delete_days + 1;
  $com_delete_date = date('Ymd', strtotime(' -'. $com_delete_days .' day', time()));

  $com_list = ModelBO::newInstance()->getInactiveCommentsToDelete( $com_delete_date );

  if(!empty($com_list)) {
    foreach($com_list as $com) {
      ItemComment::newInstance()->deleteByPrimaryKey( $com['pk_i_id'] );
    }
  }
}

//Comments that are Disabled
function bo_mgr_control_disabled_comments() {
  $com_list = ModelBO::newInstance()->getDisabledSpamCommentsToDelete();

  if(!empty($com_list)) {
    foreach($com_list as $com) {
      ItemComment::newInstance()->deleteByPrimaryKey( $com['pk_i_id'] );
    }
  }
}

//Run comments control once a day
osc_add_hook('cron_daily', 'bo_mgr_control_inactive_comments');

$delete_disabled_comments = osc_get_preference('bo_mgr_del_disabled_comments', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_del_disabled_comments', 'plugin-bo_mgr') : 0;
if($delete_disabled_comments == 1) {
  osc_add_hook('cron_daily', 'bo_mgr_control_disabled_comments');
} elseif ($delete_disabled_comments == 2) {
  osc_add_hook('cron_weekly', 'bo_mgr_control_disabled_comments');
}
/* ----------------------------------------------------------------------------------------------*/


/* ------------------------------ Delete inactive and spam listings -----------------------------*/
//Listings that were not activated for XX days
function bo_mgr_control_inactive_listings() {
  $listing_delete_days = osc_get_preference('bo_mgr_inactive_listings_del_days', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_inactive_listings_del_days', 'plugin-bo_mgr') : 7;
  $listing_delete_days = $listing_delete_days + 1;
  $listing_delete_date = date('Ymd', strtotime(' -'. $listing_delete_days .' day', time()));

  $listing_list = ModelBO::newInstance()->getInactiveListingsToDelete( $listing_delete_date );

  if(!empty($listing_list)) {
    foreach($listing_list as $listing) {
      Item::newInstance()->deleteByPrimaryKey( $listing['pk_i_id'] );
    }
  }
}

//Listings that are Disabled
function bo_mgr_control_disabled_listings() {
  $listing_list = ModelBO::newInstance()->getDisabledSpamListingsToDelete();

  if(!empty($listing_list)) {
    foreach($listing_list as $listing) {
      Item::newInstance()->deleteByPrimaryKey( $listing['pk_i_id'] );
    }
  }
}

//Run listings control once a day
osc_add_hook('cron_daily', 'bo_mgr_control_inactive_listings');

$delete_disabled_listings = osc_get_preference('bo_mgr_del_disabled_listings', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_del_disabled_listings', 'plugin-bo_mgr') : 0;
if($delete_disabled_listings == 1) {
  osc_add_hook('cron_daily', 'bo_mgr_control_disabled_listings');
} elseif ($delete_disabled_listings == 2) {
  osc_add_hook('cron_weekly', 'bo_mgr_control_disabled_listings');
}
/* ----------------------------------------------------------------------------------------------*/


/* ------------------------------ Advanced premium sorting -------------------------------------*/
//modify search to be able to sort listings first by premium (is / not) and then by date

function bo_mgr_sort_by_premium() {
  Search::newInstance()->order('b_premium DESC, dt_pub_date DESC', '');
}

$enchance_search = osc_get_preference('bo_mgr_enchance_premium_search', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_enchance_premium_search', 'plugin-bo_mgr') : 1;
if($enchance_search == 1 && strlen(strstr(@$_SERVER['REQUEST_URI'], 'sOrder')) == 0) {
  osc_add_hook('search_conditions', 'bo_mgr_sort_by_premium');
}
/* ----------------------------------------------------------------------------------------------*/


/* ------------------------------ Payments ------------------------------------------------------*/

$pay_only_republish = osc_get_preference('bo_mgr_pay_only_republish', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_pay_only_republish', 'plugin-bo_mgr') : 0;
$pay_per_post = osc_get_preference('pay_per_post', 'payment') <> '' ? osc_get_preference('pay_per_post', 'payment') : 0;

function bo_mgr_pay_only_republish($item) {
  ModelBO::newInstance()->insertPaymentTable( $item['pk_i_id'], 1 );

  $category = $item['fk_i_category_id'];
  View::newInstance()->_exportVariableToView('category', $category);
  osc_add_flash_ok_message( __('Your listing has been published') );
  header('Location: ' . osc_search_category_url());
}

if($pay_per_post == 1 and $pay_only_republish == 1) {
  osc_add_hook('posted_item', 'bo_mgr_pay_only_republish', 9);
}

function bo_mgr_hide_unpaid() {
  $pay_per_post = osc_get_preference('pay_per_post', 'payment') <> '' ? osc_get_preference('pay_per_post', 'payment') : 0;

  if($pay_per_post == 1 and (osc_is_home_page() or osc_is_search_page() or osc_is_ad_page())) {
    Search::newInstance()->addConditions(sprintf("%st_payments_publish.b_paid <> 0", DB_TABLE_PREFIX));
    Search::newInstance()->addConditions(sprintf("%st_item.pk_i_id = %st_payments_publish.fk_i_item_id", DB_TABLE_PREFIX, DB_TABLE_PREFIX));
    Search::newInstance()->addTable(sprintf("%st_payments_publish", DB_TABLE_PREFIX));
  }
}

//osc_add_hook('search_conditions', 'bo_mgr_hide_unpaid');
osc_add_hook('header', 'bo_mgr_hide_unpaid');

/* ----------------------------------------------------------------------------------------------*/


/* ------------------------------ Plugin Constructor functions ----------------------------------*/

//Add new line if listing is added
function bo_mgr_new_item($item) {
  ModelBO::newInstance()->addItem( $item['pk_i_id']);
}

if(!function_exists('message_ok')) {
  function message_ok( $text ) {
    $final  = '<div style="padding: 1%;width: 98%;margin-bottom: 15px;" class="flashmessage flashmessage-ok flashmessage-inline">';
    $final .= $text;
    $final .= '</div>';
    echo $final;
  }
}

if(!function_exists('message_error')) {
  function message_error( $text ) {
    $final  = '<div style="padding: 1%;width: 98%;margin-bottom: 15px;" class="flashmessage flashmessage-error flashmessage-inline">';
    $final .= $text;
    $final .= '</div>';
    echo $final;
  }
}

//Add JS & CSS to header
function bo_mgr_admin_script() {
  osc_register_script('bo_mgr_feedback_admin_js', osc_base_url() . 'oc-content/plugins/backoffice_manager/js/js_admin.js', 'jquery');
  osc_enqueue_script('bo_mgr_feedback_admin_js');
  osc_enqueue_style('bo_mgr_feedback_css', osc_base_url() . 'oc-content/plugins/backoffice_manager/css/admin.css');
}

function bo_mgr_config_menu() {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/backoffice_manager/css/admin.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/backoffice_manager/css/feedback.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/backoffice_manager/css/jquery_rating.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/backoffice_manager/js/js_admin.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/backoffice_manager/js/js_feedback.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/backoffice_manager/js/js_rating_pack.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/backoffice_manager/js/js_rating_metadata.js"></script>';

  $text  = '';
  $text  = '<fieldset class="round4" style="padding: 0px 10px;">';
  $text .= '<ul class="conf-menu">';
  $text .= '<li class="gray round3">Backoffice Manager Pro</li>';
  $text .= '<li class="blue round3"><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=backoffice_manager/admin/republish.php">republish</a></li>';
  $text .= '<li class="orange round3"><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=backoffice_manager/admin/item.php">listings</a></li>';
  $text .= '<li class="azure round3"><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=backoffice_manager/admin/user.php">users</a></li>';
  $text .= '<li class="green round3"><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=backoffice_manager/admin/status.php">status manager</a></li>';
  $text .= '<li class="yellow round3"><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=backoffice_manager/admin/feedback.php">feedback</a></li>';
  $text .= '<li class="reenable"><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=backoffice_manager/admin/republish.php&reenable=1" title="' . osc_esc_html(__('This action set all settings to default. In case you have upgraded from lower version, it will add also missing variables so reinstall is not required', 'backoffice_manager')) . '" onclick="return confirm(\'' . osc_esc_js(__('This action set all settings to default. In case you have upgraded from lower version, it will add also missing variables so reinstall is not required. Are you sure you want to continue?', 'backoffice_manager')) . '\')"><i class="fa fa-refresh"></i></a></li>';
  $text .= '</ul>';
  $text .= '</fieldset>';
  $text .= '<br /><br />';
  $text .= '<div style="clear:both"></div>';
  return $text;
}

// Add menu link to Plugin list
function bo_mgr_admin_menu() {
echo '<h3><a href="#" style="font-weight:bold">Backoffice Manager Pro</a></h3>
<ul> 
  <li><a style="color:blue;font-weight:bold" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/republish.php') . '">&raquo; ' . __('republish', 'backoffice_manager') . '</a></li>
  <li><a style="color:orange;font-weight:bold" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/item.php') . '">&raquo; ' . __('listings', 'backoffice_manager') . '</a></li>
  <li><a style="color:darkturquoise;font-weight:bold" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/user.php') . '">&raquo; ' . __('users', 'backoffice_manager') . '</a></li>
  <li><a style="color:green;font-weight:bold" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/status.php') . '">&raquo; ' . __('status manager', 'backoffice_manager') . '</a></li>
  <li><a style="color:goldenrod;font-weight:bold" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/feedback.php') . '">&raquo; ' . __('feedback', 'backoffice_manager') . '</a></li>
</ul>';
}

// Display configure link
function bo_mgr_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/republish.php' ) ;
}

// This is a hack to show a Configure link at plugins table (you could also use some other hook to show a custom option panel)
osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'bo_mgr_conf' ) ;	

//Adding sub menu to plugins menu in dashboard
osc_add_hook('admin_menu','bo_mgr_admin_menu', '1');

// This is needed in order to be able to activate the plugin
osc_register_plugin(osc_plugin_path(__FILE__), 'bo_mgr_call_after_install') ;

// This is a hack to show a Uninstall link at plugins table (you could also use some other hook to show a custom option panel)
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'bo_mgr_call_after_uninstall');

// Add row when new listing is added
osc_add_hook('posted_item', 'bo_mgr_new_item');

// Add expired listings into user menu
function bo_mgr_expired_listings_user_menu(){
  echo '<li><a href="' . osc_route_url('bo_mgr-expired-ads') .'" >'.__('Expired listings', 'backoffice_manager').'</a></li>'; 
}

osc_add_route('bo_mgr-expired-ads', 'bo_mgr-expired-ads', 'bo_mgr-expired-ads', osc_plugin_folder(__FILE__).'form/list_expired_listings.php', true, 'custom', 'bomgr-expired', __('Expired listings', 'backoffice_manager'));
osc_add_hook('user_menu', 'bo_mgr_expired_listings_user_menu');

// Add comments on my listings into user menu
function bo_mgr_my_comments_user_menu(){
  if( osc_comments_enabled() ) {
    echo '<li><a href="' . osc_route_url('bo_mgr-comments-my-listings') .'" >'.__('Comments on my items', 'backoffice_manager').'</a></li>';
  } else {
    echo '';
  }
}

osc_add_route('bo_mgr-comments-my-listings', 'bo_mgr-comments-my-listings', 'bo_mgr-comments-my-listings', osc_plugin_folder(__FILE__).'form/list_comments_my_listings.php', true, 'custom', 'bomgr-expired', __('Comments on my listings', 'backoffice_manager'));
osc_add_hook('user_menu', 'bo_mgr_my_comments_user_menu');


// Add comments on other listings into user menu
function bo_mgr_other_comments_user_menu(){
  if( osc_comments_enabled() ) {
    echo '<li><a href="' . osc_route_url('bo_mgr-comments-other-listings') .'" >'.__('Comments on other items', 'backoffice_manager').'</a></li>';
  } else {
    echo '';
  }
}

osc_add_route('bo_mgr-comments-other-listings', 'bo_mgr-comments-other-listings', 'bo_mgr-comments-other-listings', osc_plugin_folder(__FILE__).'form/list_comments_other_listings.php', true, 'custom', 'bomgr-expired', __('My comments on listings', 'backoffice_manager'));
osc_add_hook('user_menu', 'bo_mgr_other_comments_user_menu');


// When comment is added from user area, redirect user back to it's profile
function bo_mgr_comment_from_bo(){
  if(Params::getParam('bo_mgr-from-bo') <> '') {
    if(Params::getParam('bo_mgr-area') == 'my') {
      header('Location: ' . osc_route_url('bo_mgr-comments-my-listings'));
    } else {
      header('Location: ' . osc_route_url('bo_mgr-comments-other-listings'));
    }

    if(osc_moderate_items()>0) {
      $user = User::newInstance()->findByPrimaryKey(osc_logged_user_id());
      if($user['i_items']<osc_moderate_items()) {
        osc_add_flash_ok_message( __('Comment has been successfully published and is awaiting for validation.', 'backoffice_manager'));
      } else {
        osc_add_flash_ok_message( __('Comment has been successfully published.', 'backoffice_manager'));
      }
    } else if(osc_moderate_items() <= 0 ){
      osc_add_flash_ok_message( __('Comment has been successfully published and is awaiting for validation.', 'backoffice_manager'));
    } else {
      osc_add_flash_ok_message( __('Comment has been successfully published2.', 'backoffice_manager'));
    }

    exit;
  }
}

osc_add_hook('add_comment', 'bo_mgr_comment_from_bo');

/* ----------------------------------------------------------------------------------------------*/


// ADD NOTIFICATION TO ADMIN TOOLBAR MENU
function bo_mgr_admin_toolbar(){
  if( !osc_is_moderator() ) {
    $total = ModelFB::newInstance()->countNotValidatedFeedback();
    $total = isset($total['count']) ? $total['count'] : 0;

    if($total > 0) {
      $title = '<i class="circle circle-red">'.$total.'</i>' . ($total == 1 ? __('Feedback to be validated', 'backoffice_manager') : __('Feedbacks to be validated', 'backoffice_manager'));
      AdminToolbar::newInstance()->add_menu(
        array(
          'id' => 'feedback_validation',
          'title' => $title,
          'href'  => osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=backoffice_manager/admin/feedback.php',
          'meta'  => array('class' => 'action-btn action-btn-black')
        )
      );
    }
  }
}

osc_add_hook( 'add_admin_toolbar_menus', 'bo_mgr_admin_toolbar', 1 );
?>