<?php
class ModelLS extends DAO {
  private static $instance;

  public static function newInstance() {
    if( !self::$instance instanceof self ) {
      self::$instance = new self;
    }
    return self::$instance;
  }

  function __construct() { 
    parent::__construct(); 
  }

  public function getTable_Item() {
    return DB_TABLE_PREFIX.'t_item';
  }

  public function getTable_ItemBO() {
    return DB_TABLE_PREFIX.'t_item_bo_mgr';
  }

  public function getTable_Status() {
    return DB_TABLE_PREFIX.'t_item_bo_mgr_status';
  }

  public function addStatus( $name, $style, $order, $default, $email, $sold ) {
    $aSet = array(
      'status_name'  => $name,
      'status_style'  => $style,
      'status_order'  => $order,
      'status_default'  => $default,
      'status_email'  => $email,
      'status_sold'  => $sold
    );

    return $this->dao->insert( $this->getTable_Status(), $aSet);
  }

  public function updateStatus( $id, $name, $style, $order, $default, $email, $sold ) {
    $aSet = array(
      'status_name'  => $name,
      'status_style'  => $style,
      'status_order'  => $order,
      'status_default'  => $default,
      'status_email'  => $email,
      'status_sold'  => $sold
    );

    $aWhere = array( 'status_id' => $id );

    return $this->_update($this->getTable_Status(), $aSet, $aWhere);
  }

  public function itemToExpired( $item_id, $yesterday ) {
    $aSet = array('dt_expiration'  => $yesterday);
    $aWhere = array( 'pk_i_id' => $item_id );

    return $this->_update($this->getTable_Item(), $aSet, $aWhere);
  }


  public function updateStatusDefault( $status_id ) {
    $aSet = array('status_default' => 1);
    $aSetZero = array('status_default' => 0);

    $aWhere = array( 'status_id' => $status_id );
    $aWhereZero = array();

    $this->_update($this->getTable_Status(), $aSetZero, $aWhereZero);
    return $this->_update($this->getTable_Status(), $aSet, $aWhere);
  }

  public function deleteStatus( $status_id ) {
    $this->dao->query('UPDATE '.$this->getTable_ItemBO().' SET status_id=0 WHERE status_id='.$status_id);
    return $this->dao->delete($this->getTable_Status(), array('status_id' => $status_id) ) ;
  }

  public function getStatusByItemId( $item_id ) {
    $this->dao->select('s.*');
    $this->dao->from( $this->getTable_ItemBO() . ' i, ' . $this->getTable_Status() . ' s' );
    $this->dao->where('i.status_id = s.status_id');
    $this->dao->where('i.item_id', $item_id);
    $result = $this->dao->get();

    if( !$result ) { return array(); }
    return $result->row();
  }

  public function getStatus( $status_id ) {
    $this->dao->select();
    $this->dao->from( $this->getTable_Status() );
    $this->dao->where('status_id', $status_id);
    $result = $this->dao->get();

    if( !$result ) { return array(); }
    return $result->row();
  }

  public function getStatusList( $default = null, $email = null, $paid = null, $sold = null ) {
    $this->dao->select();
    $this->dao->from( $this->getTable_Status() );

    if($default <> '') {
      $this->dao->where('status_default = 1' );
    }

    if($email <> '') {
      $this->dao->where('status_email = 1' );
    }

    if($paid <> '') {
      $this->dao->where('status_paid > 0' );
    }

    if($sold <> '') {
      $this->dao->where('status_sold', $sold );
    }

    $this->dao->orderBy('status_order ASC');
    $result = $this->dao->get();

    if( !$result ) { return array(); }
    $prepare = $result->result();
    return $prepare;
  }

  public function getMaxStatus() {
    $this->dao->select('max(status_id) as max_id');
    $this->dao->from( $this->getTable_Status() );
    $result = $this->dao->get();

    if( !$result ) { return array(); }
    $val = $result->row();      
    return $val['max_id'];
  }

          
  // update
  function _update($table, $values, $where) {
    $this->dao->from($table);
    $this->dao->set($values);
    $this->dao->where($where);
    return $this->dao->update();
  }
}
?>