DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_item_bo_mgr;
CREATE TABLE /*TABLE_PREFIX*/t_item_bo_mgr (
  item_id INT(11) UNSIGNED NOT NULL UNIQUE,
  republish_times INT(10) DEFAULT 0,
  republish_auto INT(10) DEFAULT 0,
  form_used INT(11) DEFAULT 0,
  passwrd VARCHAR(50),
  mobile VARCHAR(50),
  status_id INT(10),

  PRIMARY KEY (item_id),
  FOREIGN KEY (item_id) REFERENCES /*TABLE_PREFIX*/t_item (pk_i_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';

INSERT INTO /*TABLE_PREFIX*/t_item_bo_mgr (item_id) SELECT pk_i_id FROM /*TABLE_PREFIX*/t_item;

DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_item_bo_mgr_status;
CREATE TABLE /*TABLE_PREFIX*/t_item_bo_mgr_status (
  status_id INT NOT NULL UNIQUE AUTO_INCREMENT,
  status_name VARCHAR(100),
  status_style VARCHAR(1000),
  status_order INT(10),
  status_default BOOLEAN DEFAULT 0,
  status_email BOOLEAN DEFAULT 0,
  status_sold BOOLEAN DEFAULT 0,
  status_paid DECIMAL(20, 2) DEFAULT 0,

  PRIMARY KEY (status_id)
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';

DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_user_bo_mgr_feedback;
CREATE TABLE /*TABLE_PREFIX*/t_user_bo_mgr_feedback(
  feedback_id INT NOT NULL UNIQUE AUTO_INCREMENT,
  user_id INT(11) UNSIGNED NOT NULL,
  commentator_id INT(11),
  commentator_name VARCHAR(100),
  commentator_title VARCHAR(100),
  commentator_message VARCHAR(1000),
  score_quality INT(1) DEFAULT NULL,
  score_delivery INT(1) DEFAULT NULL,
  score_communication INT(1) DEFAULT NULL,
  active BOOLEAN DEFAULT 0,
  pub_date DATETIME,

  PRIMARY KEY (feedback_id),
  FOREIGN KEY (user_id) REFERENCES /*TABLE_PREFIX*/t_user (pk_i_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';