<?php
if(!defined('ABS_PATH')) {
  define('ABS_PATH', dirname(dirname(dirname(dirname(__FILE__)))) . '/');
}

require_once ABS_PATH . 'oc-load.php';
require_once 'index.php';

//Get ID of listing we are going to work with
$item_id = Params::getParam('item_id');
$item_raw = Item::newInstance()->findByPrimaryKey($item_id);
$secret = Params::getParam('secret');
$redirect = Params::getParam('redirect');

$pay_per_post = osc_get_preference('pay_per_post', 'payment') <> '' ? osc_get_preference('pay_per_post', 'payment') : 0;
$user_mail_notify = osc_get_preference('bo_mgr_user_notify', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_user_notify', 'plugin-bo_mgr') : 0;

if($item_id > 0 && isset($item_raw['pk_i_id'])) {
  $item = ModelBO::newInstance()->getItem( $item_id );
  $discard_premium = osc_get_preference('bo_mgr_discard_premium', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_discard_premium', 'plugin-bo_mgr') : 1;
  $category = Category::newInstance()->findByPrimaryKey( $item['fk_i_category_id'] );

  //Check if listing is infinite or it will expire.
  if(date('Y', strtotime($item['dt_expiration'])) == '1970' or date('Y', strtotime($item['dt_expiration'])) == '9999') {
    $infinite = true;
  } else {
    $infinite = false;
  }

  if($item['pk_i_id'] > 0) {
    if($secret != '' && $secret == $item_raw['s_secret']) {
      $today = date('Y-m-d', strtotime(' -1 day', time()));

      if($infinite) {
        $expire_date = date('Y-m-d', strtotime('9999-12-31'));
      } else {
        $expire_date = date('Y-m-d', strtotime($item['dt_expiration']));
      }

      $user_notify_before = osc_get_preference('bo_mgr_user_notify_before', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_user_notify_before', 'plugin-bo_mgr') : 3;

      if($infinite) {
        $will_expire_date = date('Y-m-d', strtotime('9999-12-31'));
      } else {
        $will_expire_date = date('Y-m-d', strtotime(" - " . $user_notify_before . " day", strtotime($expire_date)));
      }

      if($item['b_premium'] == 1 && $discard_premium == 1) {
        $premium_set = 0;
      } else {
        $premium_set = $item['b_premium'];
      }

      $expiration_days = osc_get_preference('bo_mgr_default_exp_days', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_default_exp_days', 'plugin-bo_mgr') : '';

      if($expiration_days == '' or $expiration_days == 0) {
        $expiration_days = $category['i_expiration_days'] <> 0 ? $category['i_expiration_days'] : 30;
      }

      $pub_date = date('Y-m-d H:i:s', time());

      if($infinite) {
        $exp_date = date('Y-m-d H:i:s', strtotime('9999-12-31 23:59:59'));
      } else {
        $exp_date = date('Y-m-d H:i:s', strtotime($today . ' + ' . $expiration_days . ' day'));
      }

      $republished = $item['republish_times'] <> '' ? $item['republish_times'] : 0;
      $max_republish = osc_get_preference('bo_mgr_max_republish', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_max_republish', 'plugin-bo_mgr') : 10;
      $republish_inactive = osc_get_preference('bo_mgr_republish_inactive', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_republish_inactive', 'plugin-bo_mgr') : 0;
      $republish_inactive = $republish_inactive*(-1)+1;
      $notify_admin = osc_get_preference('bo_mgr_admin_notify', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_admin_notify', 'plugin-bo_mgr') : 0;
      $republish_anytime = osc_get_preference('bo_mgr_republish_anytime', 'plugin-bo_mgr') <> '' ? osc_get_preference('bo_mgr_republish_anytime', 'plugin-bo_mgr') : 0;

      if($today >= $will_expire_date or $republish_anytime == 1) {
        if($republished < $max_republish) {
          if($user_mail_notify == 1) {
            email_confirm($item_id, $expire_date);
          }

          if($notify_admin == 1) {
            email_admin($item_id, $expiration_days);
          }

          //Payment is required
          if($pay_per_post == 1) {
            ModelBO::newInstance()->updatePaymentTable($item_id, 0);
          }

          ModelBO::newInstance()->republish_item( $item_id, $pub_date, $exp_date, $premium_set, $republish_inactive );
          osc_add_flash_ok_message( __('Listing was successfully republished and will expire in', 'backoffice_manager') . ' ' . $expiration_days . ' ' . __('days on', 'backoffice_manager') . ' ' . date('Y-m-d', strtotime($today . ' + ' . $expiration_days . ' day')));
          $published = true;
        } else {
          osc_add_flash_error_message( __('This listing was already republished', 'backoffice_manager') . ' ' . $republished . ' ' . __('times. It cannot be republished again.', 'backoffice_manager')) ;
        }
      } else {
        osc_add_flash_error_message( __('This listing cannot be republished because it is not about expire.', 'backoffice_manager')) ;
      }
    } else {
      osc_add_flash_error_message( __('Incorrect or missing secret code.', 'backoffice_manager')) ;
    }
  } else {
    osc_add_flash_error_message( __('Listing with this ID does not exists or listing is not eligible for republish.', 'backoffice_manager') . ' (' . $item_id . ')') ;
  }
}

//Echo what we got - for control
echo '<strong>Listing details:</strong><br/>';
echo 'Listing ID: <a href="/oc-admin/index.php?page=items&action=item_edit&id=' . $item_id . '" target="_blank">' . $item_id . '</a><br/>';
echo 'Today: ' . $today . '<br/>';
echo 'Publish Date: ' . $pub_date . '<br/>';
echo 'Expiry Date (new): ' . $exp_date . '<br/>';
echo 'Expiry Date (old): ' . $expire_date . '<br/>';
echo 'Will Expire (' . $user_notify_before . ' days before expire): ' . $will_expire_date . '<br/>';
echo 'User Notify Before Expire days: ' . $user_notify_before . '<br/>';
echo 'Expiration Days: ' . $expiration_days . '<br/><br/>';
echo 'Republished (?): <strong>' . ($published ? 'Yes' : 'No') . '</strong><br/>';

//Send user to homepage or payment page with flash message
if($pay_per_post == 1 && $item_id <> '') {
  osc_add_flash_ok_message( __('There is fee for republishing listing. After payment is successful, your listing will be activated. Please continue to payment process.', 'backoffice_manager'));
  header('Location: ' . osc_route_url('payment-publish', array('itemId' => $item_id)));
  exit;
} else {
  if($redirect == '') {
    if(osc_is_web_user_logged_in()) {
      header('Location: ' . osc_user_list_items_url());
      exit;
    } else {
      header('Location: ' . osc_base_url());
      exit;
    }
  }
}

header('Location: ' . osc_base_url());
exit;

?>