<?php
  $identifier = Params::getParam('identifier');
  $seller = ModelBPR::newInstance()->getSellerByIdentifier($identifier);
  $user = User::newInstance()->findByPrimaryKey($seller['fk_i_user_id']);
  $location = implode(', ', array_filter(array($user['s_country'], $user['s_region'], $user['s_city'], $user['s_address'])));
  //$location_alt = implode('<br/>', array_filter(array($user['s_country'], $user['s_region'], $user['s_city'], $user['s_address'])));
  $location_alt = bpr_user_location($user, 2, '<br/>');

  $img_url = osc_base_url() . 'oc-content/plugins/business_profile/img/';
?>

<script type="text/javascript"> 
  var map = null;
  var geocoder = null;
 
  var myOptions = {
    zoom: 13,
    center: new google.maps.LatLng(37.4419, -122.1419),
    mapTypeId: google.maps.MapTypeId.ROADMAP,
    size: new google.maps.Size(480,360),
    scrollwheel: false,
    navigationControl: false,
    mapTypeControl: false,
    scaleControl: false
  }

  map = new google.maps.Map(document.getElementById("sellerMap"), myOptions);
  geocoder = new google.maps.Geocoder();
 
  function showAddress(address) {
    if (geocoder) {
      geocoder.geocode( { 'address': address}, function(results, status) {
        if (status == google.maps.GeocoderStatus.OK) {
          map.setCenter(results[0].geometry.location);
          var marker = new google.maps.Marker({
            map: map,
            position: results[0].geometry.location,
            icon: '<?php echo $img_url . 'marker.png'; ?>',
            title: '<?php echo osc_esc_js(sprintf(__('%s\'s location', 'business_profile'), $user['s_name'])); ?>'
          });

          var infoWindow = new google.maps.InfoWindow({
            content: '<?php echo osc_esc_js(sprintf(__('%s\'s location', 'business_profile'), $user['s_name'])) . '<br/>--<br/>' . $location_alt; ?>'
          });

          google.maps.event.addListener(marker, 'click', function () {
            infoWindow.open(map, marker);
          });

          marker.setMap(map);  
        } else {
          $("#sellerMap").remove();
        }
      });
    }
  }


  $(document).ready(function(){
    showAddress('<?php echo osc_esc_js($location); ?>');
  });

</script>