<?php
  // Create menu
  $title = __('Configure', 'car_attr_pro');
  cap_menu($title);

  $locale = (Params::getParam('capLocale') <> '' ? Params::getParam('capLocale') : cap_get_locale());

  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  $enable_cache = mb_param_update('enable_cache', 'plugin_action', 'check', 'plugin-car_attr_pro');
  $required_validation = mb_param_update('required_validation', 'plugin_action', 'value', 'plugin-car_attr_pro');
  $color_primary = mb_param_update('color_primary', 'plugin_action', 'value', 'plugin-car_attr_pro');
  $color_primary_hover = mb_param_update('color_primary_hover', 'plugin_action', 'value', 'plugin-car_attr_pro');
  $select_box_type = mb_param_update('select_box_type', 'plugin_action', 'value', 'plugin-car_attr_pro');
  $close_after_select = mb_param_update('close_after_select', 'plugin_action', 'check', 'plugin-car_attr_pro');
  $hide_if_no_values = mb_param_update('hide_if_no_values', 'plugin_action', 'check', 'plugin-car_attr_pro');
  $hide_values_ok_btn = mb_param_update('hide_values_ok_btn', 'plugin_action', 'check', 'plugin-car_attr_pro');
  $enable_showcase = mb_param_update('enable_showcase', 'plugin_action', 'check', 'plugin-car_attr_pro');
  $hook_publish = mb_param_update('hook_publish', 'plugin_action', 'check', 'plugin-car_attr_pro');
  $hook_home_search = mb_param_update('hook_home_search', 'plugin_action', 'check', 'plugin-car_attr_pro');
  $hook_search_top = mb_param_update('hook_search_top', 'plugin_action', 'check', 'plugin-car_attr_pro');
  $enable_empty_sections = mb_param_update('enable_empty_sections', 'plugin_action', 'check', 'plugin-car_attr_pro');
  $widget_hide_scroll = mb_param_update('widget_hide_scroll', 'plugin_action', 'check', 'plugin-car_attr_pro');
  $disable_search_hook = mb_param_update('disable_search_hook', 'plugin_action', 'check', 'plugin-car_attr_pro');
  $hide_search_hook_empty_cat = mb_param_update('hide_search_hook_empty_cat', 'plugin_action', 'check', 'plugin-car_attr_pro');
  $more_filters_button = mb_param_update('more_filters_button', 'plugin_action', 'check', 'plugin-car_attr_pro');
  $use_key_instead_id = mb_param_update('use_key_instead_id', 'plugin_action', 'check', 'plugin-car_attr_pro');
  $item_detail_hooks = mb_param_update('item_detail_hooks', 'plugin_action', 'value', 'plugin-car_attr_pro');
  $item_attr_hooks = mb_param_update('item_attr_hooks', 'plugin_action', 'value', 'plugin-car_attr_pro');
  $models_limit = mb_param_update('models_limit', 'plugin_action', 'value', 'plugin-car_attr_pro');
  $item_title_props = mb_param_update('item_title_props', 'plugin_action', 'value', 'plugin-car_attr_pro');

  
  $search_box_design = mb_param_update('search_box_design', 'plugin_action', 'value', 'plugin-car_attr_pro');
  $search_box_menu = mb_param_update('search_box_menu', 'plugin_action', 'value', 'plugin-car_attr_pro');
  $search_box_menu_items = mb_param_update('search_box_menu_items', 'plugin_action', 'value', 'plugin-car_attr_pro');
  $search_box_style = mb_param_update('search_box_style', 'plugin_action', 'value', 'plugin-car_attr_pro');
  $search_box_width = mb_param_update('search_box_width', 'plugin_action', 'value', 'plugin-car_attr_pro');
  $search_box_hooks = mb_param_update('search_box_hooks', 'plugin_action', 'value', 'plugin-car_attr_pro');


  if(Params::getParam('plugin_action') == 'done') {
    osc_add_flash_ok_message(__('Settings were successfully saved.', 'car_attr_pro'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/configure.php');
    exit;
  }
  
  $properties = ModelCAP::newInstance()->getProperties(false, -1, true);
  $item_title_props_arr = explode(',', $item_title_props);
?>

<div class="mb-body">
  <div class="mb-notes">
    <div class="mb-line"><?php _e('Please read documentation before using plugin.', 'car_attr_pro'); ?> <a href="https://osclasspoint.com/images/car-attributes-pro/documentation.pdf"><?php _e('Documentation PDF', 'car_attr_pro'); ?></a></div>
  </div>

  <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
    <?php if(!cap_is_demo()) { ?>
      <input type="hidden" name="page" value="plugins" />
      <input type="hidden" name="action" value="renderplugin" />
      <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
      <input type="hidden" name="plugin_action" value="done" />
    <?php } ?>


    <!-- CONFIGURE SECTION -->
    <div class="mb-box">
      <div class="mb-head"><i class="fa fa-window-maximize"></i> <?php _e('Search Widget Settings', 'car_attr_pro'); ?></div>

      <div class="mb-inside">
        <div class="mb-row mb-color-box">
          <label for="color_primary"><span><?php _e('Primary Color', 'car_attr_pro'); ?></span></label> 
      
          <input name="color_primary" id="color_primary" size="20" type="text" value="<?php echo osc_esc_html($color_primary); ?>" />
          <span class="color-wrap">
            <input name="color-picker" id="" type="color" value="<?php echo osc_esc_html($color_primary); ?>" />
          </span>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Primary color used by plugin.', 'car_attr_pro'); ?></div>
            <div class="mb-line"><?php _e('Enter color in HEX format or select color with picker. Example: #0d9ecc. Keep blank to use default color.', 'car_attr_pro'); ?> (#0d9ecc)</div>
          </div>        
        </div>
          
        <div class="mb-row mb-color-box">
          <label for="color_primary_hover"><span><?php _e('Primary Color on Hover', 'car_attr_pro'); ?></span></label> 
      
          <input name="color_primary_hover" id="color_primary_hover" size="20" type="text" value="<?php echo osc_esc_html($color_primary_hover); ?>" />
          <span class="color-wrap">
            <input name="color-picker" id="" type="color" value="<?php echo osc_esc_html($color_primary_hover); ?>" />
          </span>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Primary hover color used by plugin.', 'car_attr_pro'); ?></div>
            <div class="mb-line"><?php _e('Enter color in HEX format or select color with picker. Example: #0d9ecc. Keep blank to use default color.', 'car_attr_pro'); ?> (#0782a9)</div>
          </div>        
        </div>

        <div class="mb-row">
          <label for="enable_cache" class=""><span><?php _e('Enable Queries Cache', 'car_attr_pro'); ?></span></label> 
          <input name="enable_cache" id="enable_cache" type="checkbox" class="element-slide" <?php echo ($enable_cache == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, plugin will use Osclass query cache when configured (memcache, memcached, APC, ...)', 'car_attr_pro'); ?></div>
            <div class="mb-line"><?php _e('Disable when configuring or debugging plugin, as changes made in database will not reflect in front-office immediately.', 'car_attr_pro'); ?></div>
          </div>
        </div>
        
        
        <div class="mb-row">
          <label for="select_box_type"><span><?php _e('Select Box Type', 'car_attr_pro'); ?></span></label> 
          <select name="select_box_type">
            <option value="" <?php if($select_box_type == '') { ?>selected="selected"<?php } ?>><?php _e('Custom Select Box', 'car_attr_pro'); ?></option>
            <option value="HTML" <?php if($select_box_type == 'HTML') { ?>selected="selected"<?php } ?>><?php _e('HTML Select Box', 'car_attr_pro'); ?></option>
          </select>
          
          <div class="mb-explain"><?php _e('Choose select box type used in plugin. Custom select box has values filter, select all and clear all buttons.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="close_after_select" class=""><span><?php _e('Close Values List after Select', 'car_attr_pro'); ?></span></label> 
          <input name="close_after_select" id="close_after_select" type="checkbox" class="element-slide" <?php echo ($close_after_select == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, values list of custom select box is closed after selecting value (only single-value select).', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="hide_if_no_values" class=""><span><?php _e('Hide Property if No Values', 'car_attr_pro'); ?></span></label> 
          <input name="hide_if_no_values" id="hide_if_no_values" type="checkbox" class="element-slide" <?php echo ($hide_if_no_values == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, pre-defined type of property that has no values defined will not be shown in front (widget). If you enable this option, it might be harder to debug why property is not visible!', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="hide_values_ok_btn" class=""><span><?php _e('Hide Submit Button', 'car_attr_pro'); ?></span></label> 
          <input name="hide_values_ok_btn" id="hide_values_ok_btn" type="checkbox" class="element-slide" <?php echo ($hide_values_ok_btn == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, "OK" submit (close) button will not be visible in values list of custom select box.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="disable_search_hook" class=""><span><?php _e('Disable Search Hook', 'car_attr_pro'); ?></span></label> 
          <input name="disable_search_hook" id="disable_search_hook" type="checkbox" class="element-slide" <?php echo ($disable_search_hook == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, plugin will not use search_form hook no matter what is setting of property.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="hide_search_hook_empty_cat" class=""><span><?php _e('Hide Search Hook for No Category', 'car_attr_pro'); ?></span></label> 
          <input name="hide_search_hook_empty_cat" id="hide_search_hook_empty_cat" type="checkbox" class="element-slide" <?php echo ($hide_search_hook_empty_cat == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, properties will not be visible on search page when no category is selected.', 'car_attr_pro'); ?></div>
        </div>

        
        <div class="mb-row">
          <label for="more_filters_button" class=""><span><?php _e('Enable More Filters Button', 'car_attr_pro'); ?></span></label> 
          <input name="more_filters_button" id="more_filters_button" type="checkbox" class="element-slide" <?php echo ($more_filters_button == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, "More filters" button is added at bottom of search hook.', 'car_attr_pro'); ?></div>
        </div>

        <div class="mb-row">
          <label for="required_validation"><span><?php _e('Required Validation Type', 'car_attr_pro'); ?></span></label> 
          <select name="required_validation">
            <option value="" <?php if($required_validation == '') { ?>selected="selected"<?php } ?>><?php _e('jQuery Validation', 'car_attr_pro'); ?></option>
            <option value="HTML5" <?php if($required_validation == 'HTML5') { ?>selected="selected"<?php } ?>><?php _e('HTML5 Validation', 'car_attr_pro'); ?></option>
          </select>
          
          <div class="mb-explain"><?php _e('Select how are required parameters validated on publish page. jQuery validation is default.', 'car_attr_pro'); ?></div>
        </div>

        <div class="mb-row">
          <label for="models_limit" class=""><span><?php _e('Models Limit', 'car_attr_pro'); ?></span></label> 
          <input name="models_limit" id="models_limit" size="10" type="number" value="<?php echo osc_esc_html($models_limit); ?>" />
          <div class="mb-input-desc"><?php _e('models', 'car_attr_pro'); ?></div>
          
          <div class="mb-explain"><?php _e('Limit maximum number of models retrieved at once.', 'car_attr_pro'); ?></div>
        </div>

        <div class="mb-row">
          <label for="use_key_instead_id" class=""><span><?php _e('Use Keys Instead of IDs', 'car_attr_pro'); ?></span></label> 
          <input name="use_key_instead_id" id="use_key_instead_id" type="checkbox" class="element-slide" <?php echo ($use_key_instead_id == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, primary keys (numbers) are used instead of identifiers/slugs in URLs. This may help to increase maximum length of search URL.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row mb-row-select-multiple">
          <label for="item_title_props"><span><?php _e('Add Properties to Item Title', 'car_attr_pro'); ?></span></label> 
          
          <input type="hidden" name="item_title_props" id="item_title_props" value="<?php echo $item_title_props; ?>"/>
          <select id="item_title_props_multiple" name="item_title_props_multiple" multiple>
            <option value="" <?php if($item_title_props == '') { ?>selected="selected"<?php } ?>><?php _e('None', 'car_attr_pro'); ?></option>

            <?php if(is_array($properties) && count($properties) > 0) { ?>
              <?php foreach($properties as $key => $prop) { ?>
                <option value="<?php echo $key; ?>" <?php if(in_array($key, $item_title_props_arr)) { ?>selected="selected"<?php } ?>><?php echo cap_get_name($prop, true); ?></option>
              <?php } ?>
            <?php } ?>
          </select>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Selected properties values will be added into item title.', 'car_attr_pro'); ?></div>
            <div class="mb-line"><?php _e('You must use function cap_props_to_item_title(osc_item_id()) to add it - manual placement.', 'car_attr_pro'); ?></div>
          </div>
        </div>
        

        <hr/>


        <div class="mb-row">
          <label for="hook_publish" class=""><span><?php _e('Hook Form to Item Publish/Edit', 'car_attr_pro'); ?></span></label> 
          <input name="hook_publish" id="hook_publish" type="checkbox" class="element-slide" <?php echo ($hook_publish == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, plugin attributes form is hooked to item publish & edit page.', 'car_attr_pro'); ?></div>
        </div>

        <div class="mb-row">
          <label for="hook_home_search" class=""><span><?php _e('Hook Search Box to Home Search', 'car_attr_pro'); ?></span></label> 
          <input name="hook_home_search" id="hook_home_search" type="checkbox" class="element-slide" <?php echo ($hook_home_search == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, plugin search box is hooked to home page search box.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="hook_search_top" class=""><span><?php _e('Hook Search Box to Search Top', 'car_attr_pro'); ?></span></label> 
          <input name="hook_search_top" id="hook_search_top" type="checkbox" class="element-slide" <?php echo ($hook_search_top == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, plugin search box is hooked to search page above search results.', 'car_attr_pro'); ?></div>
        </div>

        <div class="mb-row">
          <label for="search_box_hooks" class=""><span><?php _e('Search Box Custom Hooks', 'car_attr_pro'); ?></span></label> 
          <input name="search_box_hooks" id="search_box_hooks" size="60" type="text" value="<?php echo osc_esc_html($search_box_hooks); ?>" />
          
          <div class="mb-explain"><?php _e('Enter one or more hooks where this element will be placed. Delimit hooks by comma. No white spaces.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="item_detail_hooks" class=""><span><?php _e('Item Detail Attributes Hooks', 'car_attr_pro'); ?></span></label> 
          <input name="item_detail_hooks" id="item_detail_hooks" size="60" type="text" value="<?php echo osc_esc_html($item_detail_hooks); ?>" />
          
          <div class="mb-explain"><?php _e('Enter one or more hooks where this element will be placed. Delimit hooks by comma. No white spaces.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="item_attr_hooks" class=""><span><?php _e('Item Attributes Hooks', 'car_attr_pro'); ?></span></label> 
          <input name="item_attr_hooks" id="item_attr_hooks" size="60" type="text" value="<?php echo osc_esc_html($item_attr_hooks); ?>" />
          
          <div class="mb-explain"><?php _e('Enter one or more hooks where this element will be placed. Delimit hooks by comma. No white spaces. Example: item_loop_description', 'car_attr_pro'); ?></div>
        </div>

        <div class="mb-row">
          <label for="widget_hide_scroll" class=""><span><?php _e('Hide Scroll in Widget', 'car_attr_pro'); ?></span></label> 
          <input name="widget_hide_scroll" id="widget_hide_scroll" type="checkbox" class="element-slide" <?php echo ($widget_hide_scroll == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, scroll bar is hidden (horizontal) and only scroll buttons can be used.', 'car_attr_pro'); ?></div>
        </div>
        
        <hr/>
        
        <div class="mb-row">
          <label for="enable_showcase" class=""><span><?php _e('Enable Showcase', 'car_attr_pro'); ?></span></label> 
          <input name="enable_showcase" id="enable_showcase" type="checkbox" class="element-slide" <?php echo ($enable_showcase == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, showcase boxes are shown on item page (item_detail).', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="enable_empty_sections" class=""><span><?php _e('Enable Empty Sections', 'car_attr_pro'); ?></span></label> 
          <input name="enable_empty_sections" id="enable_empty_sections" type="checkbox" class="element-slide" <?php echo ($enable_empty_sections == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, empty sections (with no properties) will be visible in front.', 'car_attr_pro'); ?></div>
            <div class="mb-line"><?php _e('Enable when configuring your plugin, this setting may greatly help you to configure your sections.', 'car_attr_pro'); ?></div>
          </div>
        </div>
        
        
        
        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(cap_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'car_attr_pro')); ?>"><?php _e('Save', 'car_attr_pro');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'car_attr_pro');?></button>
          <?php } ?>
        </div>
      </div>
    </div>
    
    
    <!-- WIDGET SETTINGS SECTION -->
    <div class="mb-box">
      <div class="mb-head"><i class="fa fa-window-maximize"></i> <?php _e('Search Widget Settings', 'car_attr_pro'); ?></div>

      <div class="mb-inside">
        <div class="mb-notes">
          <div class="mb-line"><?php _e('These settings can be overwritten in $options parameter of cap_search_box() function.', 'car_attr_pro'); ?></div>
        </div>
  
        <div class="mb-row">
          <label for="search_box_design"><span><?php _e('Search Widget Design', 'car_attr_pro'); ?></span></label> 
          <select name="search_box_design">
            <option value="SIMPLE" <?php if($search_box_design == '' || $search_box_design == 'SIMPLE') { ?>selected="selected"<?php } ?>><?php _e('Simple', 'car_attr_pro'); ?></option>
            <option value="MEDIUM" <?php if($search_box_design == 'MEDIUM') { ?>selected="selected"<?php } ?>><?php _e('Medium', 'car_attr_pro'); ?></option>
            <option value="COMPLEX" <?php if($search_box_design == 'COMPLEX') { ?>selected="selected"<?php } ?>><?php _e('Complex', 'car_attr_pro'); ?></option>
          </select>
          
          <div class="mb-explain"><?php _e('Design specify how many parameters are visible by default in search widget.', 'car_attr_pro'); ?></div>
        </div>

        <div class="mb-row">
          <label for="search_box_menu"><span><?php _e('Search Widget Menu Design', 'car_attr_pro'); ?></span></label> 
          <select name="search_box_menu">
            <option value="SIMPLE" <?php if($search_box_menu == '' || $search_box_menu == 'SIMPLE') { ?>selected="selected"<?php } ?>><?php _e('Simple (list)', 'car_attr_pro'); ?></option>
            <option value="ADVANCED" <?php if($search_box_menu == 'ADVANCED') { ?>selected="selected"<?php } ?>><?php _e('Advanced', 'car_attr_pro'); ?></option>
          </select>
          
          <div class="mb-explain"><?php _e('Menu design specify layout of types menu (slider) in search widget.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="search_box_menu_items"><span><?php _e('Search Widget Menu Items Design', 'car_attr_pro'); ?></span></label> 
          <select name="search_box_menu_items">
            <option value="STANDARD" <?php if($search_box_menu_items == '' || $search_box_menu_items == 'STANDARD') { ?>selected="selected"<?php } ?>><?php _e('Standard', 'car_attr_pro'); ?></option>
            <option value="CONDENSED" <?php if($search_box_menu_items == 'CONDENSED') { ?>selected="selected"<?php } ?>><?php _e('Condensed', 'car_attr_pro'); ?></option>
          </select>
          
          <div class="mb-explain"><?php _e('Menu items design specify layout of types elements in search widget.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="search_box_style"><span><?php _e('Search Widget Style', 'car_attr_pro'); ?></span></label> 
          <select name="search_box_style">
            <option value="BORDERLESS" <?php if($search_box_style == '' || $search_box_style == 'BORDERLESS') { ?>selected="selected"<?php } ?>><?php _e('Borderless Layout', 'car_attr_pro'); ?></option>
            <option value="BOXED" <?php if($search_box_style == 'BOXED') { ?>selected="selected"<?php } ?>><?php _e('Boxed Layout', 'car_attr_pro'); ?></option>
          </select>
          
          <div class="mb-explain"><?php _e('Style speficy layout / general design of search widget.', 'car_attr_pro'); ?></div>
        </div>

        <div class="mb-row">
          <label for="search_box_width"><span><?php _e('Search Widget Width', 'car_attr_pro'); ?></span></label> 
          <select name="search_box_width">
            <option value="MEDIUM" <?php if($search_box_width == '' || $search_box_width == 'MEDIUM') { ?>selected="selected"<?php } ?>><?php _e('Medium', 'car_attr_pro'); ?></option>
            <option value="LARGE" <?php if($search_box_width == 'LARGE') { ?>selected="selected"<?php } ?>><?php _e('Large', 'car_attr_pro'); ?></option>
          </select>
          
          <div class="mb-explain"><?php _e('Width specify what is area where search widget is placed. If it is full-width (large) or medium size box.', 'car_attr_pro'); ?></div>
        </div>

        
        
        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(cap_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'car_attr_pro')); ?>"><?php _e('Save', 'car_attr_pro');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'car_attr_pro');?></button>
          <?php } ?>
        </div>
      </div>
    </div>
  </form>


</div>


<?php echo cap_footer(); ?>