<?php
  // Create menu
  $title = __('Makes & models', 'car_attr_pro');
  cap_menu($title);

  $locale = (Params::getParam('capLocale') <> '' ? Params::getParam('capLocale') : cap_get_locale());

  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value



  if(Params::getParam('plugin_action') == 'done') {

    // Update Makes
    $makes_data = Params::getParam('capmakes');
    
    if(is_array($makes_data) && count($makes_data) > 0) {
      foreach($makes_data as $id => $data) {
        $data['b_enabled'] = (isset($data['b_enabled']) ? 1 : 0);
        $data['s_section'] = (isset($data['s_section']) ? $data['s_section'] : NULL);

        ModelCAP::newInstance()->updateMake($id, $data);
      }
    }
    
    
    // Update Models
    $model_data = Params::getParam('capmodels');
    
    if(is_array($model_data) && count($model_data) > 0) {
      foreach($model_data as $id => $data) {
        $data['b_enabled'] = (isset($data['b_enabled']) ? 1 : 0);
        
        ModelCAP::newInstance()->updateModel($id, $data);
      }
    }
  
    osc_add_flash_ok_message(__('Settings were successfully saved.', 'car_attr_pro'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/make_model.php&type_selected=' . Params::getParam('type_selected') . '&make_selected=' . Params::getParam('make_selected'));
    exit;
  }
  
  $types = ModelCAP::newInstance()->getTypes(false);
?>

<div class="mb-body">
  <div class="mb-message-js"></div>
  
  <div class="mb-notes">
    <div class="mb-line"><?php _e('Types can be only modified in file oc-content/plugins/car_attr_pro/attr_properties.php', 'car_attr_pro'); ?></div>
  </div>

  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-random"></i> <?php _e('Makes & models', 'car_attr_pro'); ?></div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <?php if(!cap_is_demo()) { ?>
          <input type="hidden" name="page" value="plugins" />
          <input type="hidden" name="action" value="renderplugin" />
          <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>make_model.php" />
          <input type="hidden" name="plugin_action" value="done" />
          <input type="hidden" name="type_selected" value="<?php echo osc_esc_html(Params::getParam('type_selected')); ?>" />
          <input type="hidden" name="make_selected" value="<?php echo osc_esc_html(Params::getParam('make_selected')); ?>" />
        <?php } ?>


        <div id="mb-makes-box" class="mb-row">
          <div class="mb-column mb-types">
            <strong><?php _e('Type', 'car_attr_pro'); ?></strong>
            
            <div class="mb-wrap">
              <?php foreach($types as $type) { ?>
                <?php cap_admin_generate_elem('type', $type['pk_i_id'], cap_get_name($type)); ?>
              <?php } ?>
            </div>
          </div>
          
          
          <div class="mb-column mb-sortable mb-makes">
            <strong>
              <?php _e('Make', 'car_attr_pro'); ?>
              <a href="#" class="mb-add-btn btn mb-add-make mb-disabled" data-id=""><i class="fa fa-plus"></i> <?php _e('Add a new make', 'car_attr_pro'); ?></a>
            </strong>
            
            <div class="mb-wrap">
              <div class="mb-empty-box"><?php _e('Expand type to get list of models', 'car_attr_pro'); ?></div>
            </div>
          </div>
          

          <div class="mb-column mb-sortable mb-models">
            <strong>
              <?php _e('Model', 'car_attr_pro'); ?>
              <a href="#" class="mb-add-btn btn mb-add-model mb-disabled" data-id=""><i class="fa fa-plus"></i> <?php _e('Add a new model', 'car_attr_pro'); ?></a>
            </strong>
            
            <div class="mb-wrap">
              <div class="mb-empty-box"><?php _e('Expand type & model to get list of makes', 'car_attr_pro'); ?></div>
            </div>
          </div>
        </div>


        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(cap_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'car_attr_pro')); ?>"><?php _e('Save', 'car_attr_pro');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'car_attr_pro');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>
</div>



<script type="text/javascript">
  var cap_get_makes_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=cap_admin_get_makes";
  var cap_get_models_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=cap_admin_get_models";

  var cap_delete_make_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=cap_admin_delete_make";
  var cap_delete_model_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=cap_admin_delete_model";

  var cap_update_makes_position_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=cap_admin_update_makes_position";
  var cap_update_models_position_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=cap_admin_update_models_position";

  var cap_message_ok = "<?php echo osc_esc_html(__('Success!', 'attributes')); ?>";
  var cap_message_wait = "<?php echo osc_esc_html(__('Updating, please wait...', 'attributes')); ?>";
  var cap_message_error = "<?php echo osc_esc_html(__('Error!', 'attributes')); ?>";


  // RESTRICT CHARACTERS FOR S_ID INPUTS (identifier)
  $('body').on('keypress', 'input[type="text"].mb-i-slug', function (event) {
    var regexStart = new RegExp("^[a-z]+$");
    var regex = new RegExp("^[a-z0-9\-]+$");
    var key = String.fromCharCode(!event.charCode ? event.which : event.charCode);
    
    if (!regex.test(key) || ($(this)[0].selectionStart == 0 && !regexStart.test(key))) {
      event.preventDefault();
      return false;
    }
  });


  // Delete make
  $('body').on('click', '.mb-column.mb-makes a.mb-delete', function(e){
    e.preventDefault();
    
    var id = $(this).attr('data-id');
    var btn = $(this);
    var elem = $(this).closest('.mb-elem');
    var url = cap_delete_make_url + '&id=' + id;

    btn.find('i.mb-delete-icon').removeClass('fa-trash').addClass('fa-cog fa-spin');
    
    if(window.confirm('<?php echo osc_esc_js(__('Are you sure you want to remove this make? This will remove all linked models as well! Action cannot be undone.', 'car_attr_pro')); ?>')) {
      $.ajax({
        url: url,
        type: "GET",
        success: function(response){
          //console.log(response);
          elem.slideUp(200, function() { elem.remove(); });
          $('.mb-column.mb-models .mb-wrap').html('<div class="mb-empty-box"><?php echo osc_esc_js(__('Expand type & model to get list of makes', 'car_attr_pro')); ?></div>');
          cap_message(cap_message_ok, 'ok');
        },
        error: function(response) {
          cap_message(cap_message_error, 'error');
          console.log(response);
        }
      });
    }
  });


  // Delete model
  $('body').on('click', '.mb-column.mb-models a.mb-delete', function(e){
    e.preventDefault();
    
    var id = $(this).attr('data-id');
    var btn = $(this);
    var elem = $(this).closest('.mb-elem');
    var url = cap_delete_model_url + '&id=' + id;

    btn.find('i.mb-delete-icon').removeClass('fa-trash').addClass('fa-cog fa-spin');
    
    $.ajax({
      url: url,
      type: "GET",
      success: function(response){
        console.log(response);
        elem.slideUp(200, function() { elem.remove(); });
        cap_message(cap_message_ok, 'ok');
      },
      error: function(response) {
        cap_message(cap_message_error, 'error');
        console.log(response);
      }
    });
  });


  // Get makes
  $('body').on('click', '.mb-column.mb-types a.mb-expand, a.mb-add-make', function(e){
    e.preventDefault();
    
    if($(this).hasClass('mb-disabled')) {
      return false;
    }
    
    var id = $(this).attr('data-id');
    var btn = $('.mb-column.mb-types .mb-elem[data-id="' + id + '"]');  
    var elem = $('.mb-column.mb-types .mb-elem[data-id="' + id + '"] a.mb-expand').closest('.mb-elem');
    
    // Update form and url
    $(this).closest('form').find('input[name="type_selected"]').val(id);
    const browserUrl = new URL(window.location.href);
    browserUrl.searchParams.set('type_selected', id);
    browserUrl.searchParams.delete('make_selected');
    window.history.replaceState(null, null, decodeURIComponent(browserUrl));


    btn.find('i.mb-expand-icon').removeClass('fa-chevron-right').addClass('fa-cog fa-spin');

    var url = cap_get_makes_url + '&id=' + id;
    
    if($(this).hasClass('mb-add-make')) {
      url = url + '&new=1';
    } else {
      $('a.mb-add-make').attr('data-id', id);
      $('.mb-column.mb-types .mb-elem').removeClass('mb-active');
      btn.addClass('mb-active');
      $('a.mb-add-make').removeClass('mb-disabled');
    }
    
    $.ajax({
      url: url,
      type: "GET",
      success: function(response){
        //console.log(response);
        $('.mb-column.mb-makes .mb-wrap').html(response);
        
        btn.find('i.mb-expand-icon').removeClass('fa-cog fa-spin').addClass('fa-chevron-right');

        cap_message(cap_message_ok, 'ok');
      },
      error: function(response) {
        cap_message(cap_message_error, 'error');
        console.log(response);
      }
    });
  });


  // Get models
  $('body').on('click', '.mb-column.mb-makes a.mb-expand, a.mb-add-model', function(e){
    e.preventDefault();
    
    if($(this).hasClass('mb-disabled')) {
      return false;
    }
    
    var id = $(this).attr('data-id');
    var btn = $('.mb-column.mb-makes .mb-elem[data-id="' + id + '"]');  
    var elem = $('.mb-column.mb-makes .mb-elem[data-id="' + id + '"] a.mb-expand').closest('.mb-elem');

    // Update form and url
    $(this).closest('form').find('input[name="make_selected"]').val(id);
    const browserUrl = new URL(window.location.href);
    browserUrl.searchParams.set('make_selected', id);
    window.history.replaceState(null, null, decodeURIComponent(browserUrl));
    
    btn.find('i.mb-expand-icon').removeClass('fa-chevron-right').addClass('fa-cog fa-spin');
    $('a.mb-add-make').prop('data-id', id);

    var url = cap_get_models_url + '&id=' + id;
    
    if($(this).hasClass('mb-add-model')) {
      url = url + '&new=1';
    } else {
      $('a.mb-add-model').attr('data-id', id);
      $('.mb-column.mb-makes .mb-elem').removeClass('mb-active');
      btn.addClass('mb-active');
      $('a.mb-add-model').removeClass('mb-disabled');
    }
    
    $.ajax({
      url: url,
      type: "GET",
      success: function(response){
        //console.log(response);
        $('.mb-column.mb-models .mb-wrap').html(response);
        btn.find('i.mb-expand-icon').removeClass('fa-cog fa-spin').addClass('fa-chevron-right');

        cap_message(cap_message_ok, 'ok');
      },
      error: function(response) {
        cap_message(cap_message_error, 'error');
        console.log(response);
      }
    });
  });


  $(document).ready(function() {
    
    // ON LOAD GET SELECTED TYPE AND MAKE
    // Load makes
    var typeId = parseInt($('input[name="type_selected"]').val());
    
    if(typeId > 0) {
      var btnType = $('.mb-column.mb-types .mb-elem[data-id="' + typeId + '"]');  
      var elem = $('.mb-column.mb-types .mb-elem[data-id="' + typeId + '"] a.mb-expand').closest('.mb-elem');
      
      $('a.mb-add-make').attr('data-id', typeId).removeClass('mb-disabled');
      btnType.addClass('mb-active').find('i.mb-expand-icon').removeClass('fa-chevron-right').addClass('fa-cog fa-spin');

      $.ajax({
        url: cap_get_makes_url + '&id=' + typeId,
        type: "GET",
        success: function(response){
          //console.log(response);
          $('.mb-column.mb-makes .mb-wrap').html(response);
          btnType.find('i.mb-expand-icon').removeClass('fa-cog fa-spin').addClass('fa-chevron-right');

          var makeId = parseInt($('input[name="make_selected"]').val());
          
          if(makeId > 0) {
            $('.mb-column.mb-makes .mb-elem[data-id="' + makeId + '"]').addClass('mb-active');
          }

          cap_message(cap_message_ok, 'ok');
        },
        error: function(response) {
          cap_message(cap_message_error, 'error');
          console.log(response);
        }
      });
    }
    
    // Load models
    var makeId = parseInt($('input[name="make_selected"]').val());

    if(makeId > 0) {
      var btnMake = $('.mb-column.mb-makes .mb-elem[data-id="' + makeId + '"]');  
      var elem = $('.mb-column.mb-makes .mb-elem[data-id="' + makeId + '"] a.mb-expand').closest('.mb-elem');

      btnMake.find('i.mb-expand-icon').removeClass('fa-chevron-right').addClass('fa-cog fa-spin');
      $('a.mb-add-make').prop('data-id', makeId);

      $('a.mb-add-model').attr('data-id', makeId).removeClass('mb-disabled');;
      $('.mb-column.mb-makes .mb-elem').removeClass('mb-active');
      btnMake.addClass('mb-active');
      
      $.ajax({
        url: cap_get_models_url + '&id=' + makeId,
        type: "GET",
        success: function(response){
          //console.log(response);
          $('.mb-column.mb-models .mb-wrap').html(response);
          btnMake.find('i.mb-expand-icon').removeClass('fa-cog fa-spin').addClass('fa-chevron-right');

          cap_message(cap_message_ok, 'ok');
        },
        error: function(response) {
          cap_message(cap_message_error, 'error');
          console.log(response);
        }
      });
    }
    
    

    // SORTABLE VALUES - MAKES
    var original_list = '';

    $('.mb-sortable.mb-makes .mb-wrap').sortable({
      axis: "y",
      forcePlaceholderSize: true,
      handle: '.mb-move',
      helper: 'clone',
      items: '> .mb-elem',
      opacity: .8,
      placeholder: 'mb-placeholder',
      revert: 100, 
      tabSize: 5,
      tolerance: 'intersect',
      start: function(event, ui) {
        var original_list = $(this).sortable('serialize');
      },
      stop: function (event, ui) {
        var updated_list = $(this).sortable('serialize');

        cap_message(cap_message_wait, 'info');
        
        if(original_list != updated_list) {
          $.ajax({
            url: cap_update_makes_position_url,
            type: "POST",
            data: updated_list,
            success: function(response){
              //console.log(response);
              cap_message(cap_message_ok, 'ok');
            },
            error: function(response) {
              cap_message(cap_message_error, 'error');
              console.log(response);
            }
          });
        }
      }
    });


    // SORTABLE VALUES - MODELS
    $('.mb-sortable.mb-models .mb-wrap').sortable({
      axis: "y",
      forcePlaceholderSize: true,
      handle: '.mb-move',
      helper: 'clone',
      items: '> .mb-elem',
      opacity: .8,
      placeholder: 'mb-placeholder',
      revert: 100, 
      tabSize: 5,
      tolerance: 'intersect',
      start: function(event, ui) {
        var original_list = $(this).sortable('serialize');
      },
      stop: function (event, ui) {
        var updated_list = $(this).sortable('serialize');

        cap_message(cap_message_wait, 'info');
        
        if(original_list != updated_list) {
          $.ajax({
            url: cap_update_models_position_url,
            type: "POST",
            data: updated_list,
            success: function(response){
              //console.log(response);
              cap_message(cap_message_ok, 'ok');
            },
            error: function(response) {
              cap_message(cap_message_error, 'error');
              console.log(response);
            }
          });
        }
      }
    });
  });
</script>

<?php echo cap_footer(); ?>