<?php
  // Create menu
  $title = __('Properties', 'car_attr_pro');
  cap_menu($title);

  $locale = (Params::getParam('capLocale') <> '' ? Params::getParam('capLocale') : cap_get_locale());

  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value


  if(Params::getParam('plugin_action') == 'done') {
    osc_add_flash_ok_message(__('Settings were successfully saved.', 'car_attr_pro'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/property_old.php');
    exit;
  }
  
  $banned_ids = cap_banned_properties();
  $properties = ModelCAP::newInstance()->getProperties(false, -1, true);
?>

<div class="mb-body">
  <div class="mb-notes">
    <div class="mb-line"><?php _e('There is no limit on number of properties defined by plugin, however there is hard limit set by maximum number of columns in one table. When you reach it, you will not be able to create any more properties until you remove some. Hard limit by MySQL is 4096 columns, but real limit will be much lower. You should not have more than 500 properties at all!', 'car_attr_pro'); ?></div>
  </div>

  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-folder-open"></i> <?php _e('Properties', 'car_attr_pro'); ?>
      <?php echo cap_locale_box('property.php'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <?php if(!cap_is_demo()) { ?>
          <input type="hidden" name="page" value="plugins" />
          <input type="hidden" name="action" value="renderplugin" />
          <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>property.php" />
          <input type="hidden" name="plugin_action" value="done" />
        <?php } ?>


        <div class="mb-table mb-table-property" id="mb-properties">
          <div class="mb-table-head">
            <div class="mb-col-1 mb-align-left">&nbsp;</div>
            <div class="mb-col-1 mb-align-left"><?php _e('ID', 'car_attr_pro'); ?></div>
            <div class="mb-col-5 mb-align-left"><?php _e('Property Name (Identifier)', 'car_attr_pro'); ?></div>
            <div class="mb-col-2 mb-align-left"><?php _e('Enabled', 'car_attr_pro'); ?></div>
            <div class="mb-col-2 mb-align-left"><?php _e('Add to Widget', 'car_attr_pro'); ?></div>
            <div class="mb-col-2 mb-align-left"><?php _e('Hook to Search', 'car_attr_pro'); ?></div>
            <div class="mb-col-2 mb-align-left"><?php _e('Values', 'car_attr_pro'); ?></div>
            <div class="mb-col-5 mb-align-left"><?php _e('Types', 'car_attr_pro'); ?></div>
            <div class="mb-col-4 mb-align-left">&nbsp;</div>
          </div>

          <?php if(is_array($properties) && count($properties) > 0) { ?>
            <?php foreach($properties as $id => $prop) { ?>
              <div class="mb-table-row" id="cap_<?php echo $id; ?>" data-id="<?php echo $id; ?>">
                <div class="mb-col-1 mb-col-move"><i class="fa fa-arrows mb-has-tooltip move ui-sortable-handle" title=""></i></div>
                <div class="mb-col-1 mb-align-left"><?php echo $id; ?></div>
                
                <div class="mb-col-5 mb-align-left">
                  <strong><?php echo ($prop['s_name'] <> '' ? $prop['s_name'] : __('N/A', 'car_attr_pro')); ?></strong>
                  <span>(<?php echo $prop['s_id']; ?>)</span>
                </div>
                
                <div class="mb-col-2 mb-align-left mb-checks">
                  <?php if($prop['b_enabled'] == 1) { ?>
                    <i class="fa fa-check"></i> <span><?php _e('Yes', 'car_attr_pro'); ?></span>
                  <?php } else { ?>
                    <i class="fa fa-times"></i> <span><?php _e('No', 'car_attr_pro'); ?></span>
                  <?php } ?>
                </div>

                <div class="mb-col-2 mb-align-left mb-checks">
                  <?php if($prop['b_enabled_widget'] == 1) { ?>
                    <i class="fa fa-check"></i> <span><?php _e('Yes', 'car_attr_pro'); ?></span>
                  <?php } else { ?>
                    <i class="fa fa-times"></i> <span><?php _e('No', 'car_attr_pro'); ?></span>
                  <?php } ?>
                </div>
                
                <div class="mb-col-2 mb-align-left mb-checks">
                  <?php if($prop['b_enabled_search'] == 1) { ?>
                    <i class="fa fa-check"></i> <span><?php _e('Yes', 'car_attr_pro'); ?></span>
                  <?php } else { ?>
                    <i class="fa fa-times"></i> <span><?php _e('No', 'car_attr_pro'); ?></span>
                  <?php } ?>
                </div>

                <div class="mb-col-2 mb-align-left"><?php echo $prop['values_count']; ?>x <?php echo ($prop['values_count'] > 0 ? ' (' . sprintf(__('Types: %d', 'car_attr_pro'), $prop['values_types_count']) . ')' : ''); ?></div>

                <div class="mb-col-5 mb-align-left"><?php echo implode(', ', array_column($prop['types'], 's_name')); ?></div>
                <div class="mb-col-4 mb-align-right">
                  <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=car_attr_pro/admin/property_edit.php&editId=<?php echo $id; ?>&capLocale=<?php echo cap_get_locale(); ?>" class="mb-btn mb-button-white"><i class="fa fa-pencil"></i> <?php _e('Edit', 'car_attr_pro'); ?></a>

                  <?php if(!cap_is_demo() && !in_array($prop['s_id'], $banned_ids)) { ?>
                    <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=car_attr_pro/admin/property_edit.php&deleteId=<?php echo $id; ?>&capLocale=<?php echo cap_get_locale(); ?>" class="mb-btn mb-button-red" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove this property? Action cannot be undone', 'car_attr_pro')); ?>')"><i class="fa fa-trash-o"></i></a>
                  <?php } ?>
                </div>
              </div>
            <?php } ?>
          <?php } else { ?>
            <div class="mb-table-row mb-row-empty">
              <i class="fa fa-warning"></i><span><?php _e('No properties has been created yet', 'car_attr_pro'); ?></span>
            </div>
          <?php } ?>
        </div>


        <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=car_attr_pro/admin/property_edit.php&editId=-1&capLocale=<?php echo cap_get_locale(); ?>" class="mb-add-button"><i class="fa fa-plus-circle"></i><?php _e('Add a new property', 'car_attr_pro'); ?></a>

        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(cap_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'car_attr_pro')); ?>"><?php _e('Save', 'car_attr_pro');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'car_attr_pro');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>
</div>

<script type="text/javascript">
  var cap_position_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=cap_admin_update_properties_position";

  var cap_message_ok = "<?php echo osc_esc_html(__('Success!', 'car_attr_pro')); ?>";
  var cap_message_wait = "<?php echo osc_esc_html(__('Updating, please wait...', 'car_attr_pro')); ?>";
  var cap_message_error = "<?php echo osc_esc_html(__('Error!', 'car_attr_pro')); ?>";


  $(document).ready(function(){
    var cap_list = '';

    $('#mb-properties').sortable({
      axis: "y",
      forcePlaceholderSize: true,
      handle: '.move',
      helper: 'clone',
      items: '.mb-table-row',
      opacity: .8,
      placeholder: 'placeholder',
      revert: 100,
      tabSize: 5,
      tolerance: 'intersect',
      start: function(event, ui) {
        cap_list = $(this).sortable('serialize');
      },
      stop: function (event, ui) {
        var c_cap_list = $(this).sortable('serialize');

        cap_message(cap_message_wait, 'info');

        if(cap_list != c_cap_list) {
          $.ajax({
            url: cap_position_url,
            type: "GET",
            data: c_cap_list,
            success: function(response){
              //console.log(response);
              cap_message(cap_message_ok, 'ok');
            },
            error: function(response) {
              cap_message(cap_message_error, 'error');
              console.log(response);
            }
          });
        }
      }
    });

  });
</script>

<?php echo cap_footer(); ?>