<?php

  // Create menu
  $title = __('Edit property', 'car_attr_pro');
  cap_menu($title);

  $locale = (Params::getParam('fk_c_locale_code') <> '' ? Params::getParam('fk_c_locale_code') : Params::getParam('capLocale'));
  $locale = ($locale <> '' ? $locale : cap_get_locale());
  $banned_ids = cap_banned_properties();


  if((Params::getParam('editId') > 0 || Params::getParam('editId') == -1) && Params::getParam('plugin_action') == 'done') {
    $id = Params::getParam('editId');

    if($id == -1) {
      $id = ModelCAP::newInstance()->insertProperty(array('i_order' => 9999));
      Params::setParam('editId', $id);
    }

    $properties = ModelCAP::newInstance()->getProperties(false, -1, true);
    $property = isset($properties[$id]) ? $properties[$id] : array();

    if(in_array($property['s_id'], $banned_ids) && $property['s_id'] != osc_sanitizeString(Params::getParam('s_id')) && Params::getParam('s_id') != '') {
      osc_add_flash_error_message(__('Identifier cannot be changed (protected property).', 'car_attr_pro'), 'admin');
      header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/property_edit.php&editId=' . $id);
      exit;      
    }


    $data_property = array(
      //'pk_i_id' => $id,
      //'s_id' => osc_sanitizeString(Params::getParam('s_id')),
      's_style' => Params::getParam('s_style'),
      'fk_i_section_widget_id' => Params::getParam('fk_i_section_widget_id'),
      'fk_i_section_item_id' => Params::getParam('fk_i_section_item_id'),
      'fk_i_section_publish_id' => Params::getParam('fk_i_section_publish_id'),
      's_data_type' => Params::getParam('s_data_type'),
      's_measure_unit' => Params::getParam('s_measure_unit'),
      's_icon' => trim(Params::getParam('s_icon', false, false)),
      'i_order' => Params::getParam('i_order'),
      's_group_list' => Params::getParam('s_group_list'),
      's_search_engine' => Params::getParam('s_search_engine'),
      'b_multi_select' => (Params::getParam('b_multi_select') == 'on' ? 1 : 0),
      'b_required' => (Params::getParam('b_required') == 'on' ? 1 : 0),
      'b_range' => (Params::getParam('b_range') == 'on' ? 1 : 0),
      'b_enabled' => (Params::getParam('b_enabled') == 'on' ? 1 : 0),
      'b_enabled_widget' => (Params::getParam('b_enabled_widget') == 'on' ? 1 : 0),
      's_size' => Params::getParam('s_size'),
      'b_enabled_search' => (Params::getParam('b_enabled_search') == 'on' ? 1 : 0)
    );
    
    if(!in_array($property['s_id'], $banned_ids) || $property['s_id'] == Params::getParam('s_id')) {
      $data_property['s_id'] = osc_sanitizeString(Params::getParam('s_id'));
    }

    $data_locale = array(
      'fk_i_property_id' => (int)$id,
      'fk_c_locale_code' => $locale,
      's_name' => Params::getParam('s_name'),
      's_name_alt' => Params::getParam('s_name_alt'),
      's_description' => Params::getParam('s_description'),
      's_text_search' => Params::getParam('s_text_search'),
      's_text_publish' => Params::getParam('s_text_publish')
    );

    $type_ids = explode(',', Params::getParam('type_ids'));
    $data_type = array();
    
    if(is_array($type_ids) && count($type_ids) > 0) {
      foreach($type_ids as $type_id) {
        $data_type[] = array(
          'fk_i_property_id' => (int)$id,
          'fk_i_type_id' => (int)$type_id
        );
      }
    }

    ModelCAP::newInstance()->updateProperty((int)$id, $locale, $data_property, $data_locale, $data_type);
    ModelCAP::newInstance()->updateItemAttrStructure();
    
    
    if(!in_array(@$property['s_id'], $banned_ids)) {
      $values = Params::getParam('capval');
      
      $style = Params::getParam('s_style');
      $multi = (Params::getParam('b_multi_select') == 'on' ? 1 : 0);
      
      if($style == 'select' || ($style == 'checkbox' || $style == 'slider') && $multi == 1) {
        if(is_array($values) && count($values) > 0) {
          foreach($values as $val_id => $val) {
            if($val['fk_i_type_id'] > 0 && !in_array($val['fk_i_type_id'], $type_ids)) {
              ModelCAP::newInstance()->deletePropertyValue($val['pk_i_id']);
            } else {
              $data_property_value = array(
                'fk_i_type_id' => $val['fk_i_type_id'],
                's_id' => $val['s_id'],
                's_icon' => $val['s_icon']
              );
              
              $data_value_locale = array(
                'fk_i_property_value_id' => (int)$val_id,
                'fk_c_locale_code' => $locale,
                's_name' => $val['s_name']
              );
              
              ModelCAP::newInstance()->updatePropertyValue((int)$val_id, $locale, $data_property_value, $data_value_locale);
            }
          }
        }
      } else {
        // Remove all property values
        if(is_array($values) && count($values) > 0) {
          foreach($values as $val_id => $val) {
            ModelCAP::newInstance()->deletePropertyValue($val_id);
          }
        }
        
        // Make sure none was missed
        ModelCAP::newInstance()->deletePropertyValues((int)$id);
      }
    }

    osc_add_flash_ok_message(__('Property successfully updated', 'car_attr_pro'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/property_edit.php&editId=' . $id);
    exit;
  }


  if(Params::getParam('deleteId') > 0) {
    $prop = ModelCAP::newInstance()->getPropertyRow(Params::getParam('deleteId'));

    if(!in_array($prop['s_id'], $banned_ids)) {
      ModelCAP::newInstance()->deleteProperty(Params::getParam('deleteId'));
      
      osc_add_flash_ok_message(__('Property successfully removed', 'car_attr_pro'), 'admin');
      header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/property.php');
      exit;
    } else {
      osc_add_flash_error_message(__('Property cannot be removed', 'car_attr_pro'), 'admin');
      header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/property.php');
      exit;
    }
  }

  $id = Params::getParam('editId');


  $properties = ModelCAP::newInstance()->getProperties(false, -1, true);
  $property = isset($properties[$id]) ? $properties[$id] : array();
  
  $group_list_arr = isset($property['s_group_list']) ? explode(',', $property['s_group_list']) : array();
  
  $type_ids = ModelCAP::newInstance()->getPropertyTypes($id);
  $type_ids = array_column($type_ids, 'fk_i_type_id');

  $types_all = ModelCAP::newInstance()->getTypes(false);
  
  $type = 'predefined';
  
  if(@$property['s_style'] == 'input' || @$property['s_style'] == 'textarea') {
    $type = 'userdefined';
  } else if(@$property['s_style'] == 'group') {
    $type = 'group';
  }
  
  $sections_item = ModelCAP::newInstance()->getSections(false, -1, false, 'item');
  $sections_publish = ModelCAP::newInstance()->getSections(false, -1, false, 'publish');
  $sections_widget = ModelCAP::newInstance()->getSections(false, -1, false, 'widget');

?>


<div class="mb-body">
  <div class="mb-message-js"></div>

  <?php if(in_array(@$property['s_id'], $banned_ids)) { ?>
    <div class="mb-notes">
      <div class="mb-line"><?php _e('"Reserved" type of property - not all fields are editable and values are not specified here.', 'car_attr_pro'); ?></div>
    </div>
  <?php } ?>

  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-plus-circle"></i> <?php _e('Add/edit property', 'car_attr_pro'); ?>
      <?php echo cap_locale_box('property_edit.php&editId=' . $id); ?>
    </div>

    <div class="mb-inside mb-prop-edit">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>property_edit.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <input type="hidden" name="capLocale" value="<?php echo (@$property['fk_c_locale_code'] <> '' ? $property['fk_c_locale_code'] : $locale); ?>" />
        <input type="hidden" name="editId" value="<?php echo $id; ?>" />

        <div id="mb-prop-box">
          <div id="mb-prop-main">
            <div class="mb-row">
              <label for="s_id"><?php _e('Identifier', 'car_attr_pro'); ?></label>
              <input type="text" id="s_id" name="s_id" size="30" minlength="3" maxlength="50" pattern="^[a-z]{1}[a-z0-9\-]{2,49}$" value="<?php echo @$property['s_id']; ?>" <?php if(in_array(@$property['s_id'], $banned_ids)) { ?>disabled<?php } else { ?>required<?php } ?>/>

              <div class="mb-explain">
                <div class="mb-line"><?php _e('Identifier must start with LETTER and must be UNIQUE across all properties. Identifier is used in URL instead of ID. Not language relevant.', 'car_attr_pro'); ?></div>
                <div class="mb-line"><?php _e('Only letters: a-z (lowercase), 1-9, - (dash).', 'car_attr_pro'); ?></div>
              </div>
            </div>
            
            <div class="mb-row">
              <label for="s_name"><?php _e('Name', 'car_attr_pro'); ?></label>
              <input type="text" id="s_name" name="s_name" size="30" value="<?php echo @$property['s_name']; ?>" required/>

              <div class="mb-explain"><?php _e('Short name of property.', 'car_attr_pro'); ?></div>
            </div>

            <div class="mb-row">
              <label for="s_description"><?php _e('Description', 'car_attr_pro'); ?></label>
              <textarea id="s_description" name="s_description"><?php echo @$property['s_description']; ?></textarea>

              <div class="mb-explain"><?php _e('Description is show as help (question mark) icon next to label.', 'car_attr_pro'); ?></div>
            </div>

            <div class="mb-row">
              <label for="s_text_search"><?php _e('Help Text (Search)', 'car_attr_pro'); ?></label>
              <input type="text" id="s_text_search" name="s_text_search" size="60" value="<?php echo @$property['s_text_search']; ?>"/>

              <div class="mb-explain"><?php _e('Text that helps to understand this property on search page (used in placeholder).', 'car_attr_pro'); ?></div>
            </div>
            
            <div class="mb-row mb-row-text-publish">
              <label for="s_text_publish"><?php _e('Help Text (Publish)', 'car_attr_pro'); ?></label>
              <input type="text" id="s_text_publish" name="s_text_publish" size="60" value="<?php echo @$property['s_text_publish']; ?>"/>

              <div class="mb-explain"><?php _e('Text that helps to understand this property on publish page (used in placeholder).', 'car_attr_pro'); ?></div>
            </div>
            
            <div class="mb-row">
              <label for="s_icon"><?php _e('Icon', 'car_attr_pro'); ?></label>
              <textarea id="s_icon" name="s_icon"><?php echo @$property['s_icon']; ?></textarea>

              <div class="mb-explain"><?php _e('Use SVG, Font-Awesome class or image URL.', 'car_attr_pro'); ?></div>
            </div>
            
            
            <hr/>


            <div class="mb-row mb-row-type">
              <label for="s_style"><span><?php _e('Property Type', 'car_attr_pro'); ?></span></label> 

              <select id="s_type" required>
                <?php foreach(cap_type_styles_list() as $skey => $style) { ?>
                  <option value="<?php echo $skey; ?>" <?php if($skey == $type){ ?>selected="selected"<?php } ?>><?php echo $style; ?></option>
                <?php } ?>
              </select>

              <div class="mb-explain">
                <div class="mb-line"><?php _e('Select type of property.', 'car_attr_pro'); ?></div>
              </div>
            </div>
            
            <div class="mb-row mb-row-style">
              <label for="s_style"><span><?php _e('Default Style', 'car_attr_pro'); ?></span></label> 

              <select id="s_style" name="s_style" required>
                <?php foreach(cap_styles_list2() as $skey => $style) { ?>
                  <option value="<?php echo $skey; ?>" <?php if($skey == @$property['s_style']){ ?>selected="selected"<?php } ?>><?php echo $style; ?></option>
                <?php } ?>
              </select>

              <div class="mb-explain">
                <div class="mb-line"><?php _e('Select front-ent desing in search/widget. Layout on publish page is automatically generated.', 'car_attr_pro'); ?></div>
              </div>
            </div>

            
            <div class="mb-row mb-row-select-multiple mb-row-group" <?php if(@$property['s_group_list'] == '') { ?>style="display:none;"<?php } ?>>
              <label for="s_group_list_multiple"><span><?php _e('Grouped Properties', 'car_attr_pro'); ?></span></label> 

              <input type="hidden" name="s_group_list" id="s_group_list" value="<?php echo implode(',', $group_list_arr); ?>"/>
              <select id="s_group_list_multiple" name="s_group_list_multiple" multiple>
                <?php if(is_array($properties) && count($properties) > 0) { ?>
                  <?php foreach($properties as $xprop) { ?>
                    <?php if($xprop['pk_i_id'] != $id && $xprop['s_group_list'] == '') { ?>
                      <option value="<?php echo $xprop['pk_i_id']; ?>" <?php if(in_array($xprop['pk_i_id'], $group_list_arr)){ ?>selected="selected"<?php } ?>><?php echo cap_get_name($xprop, true); ?></option>
                    <?php } ?>
                  <?php } ?>
                <?php } ?>
              </select>

              <div class="mb-explain">
                <div class="mb-line"><?php _e('Select one or more properties those will be grouped together.', 'car_attr_pro'); ?></div>
                <div class="mb-line"><?php _e('Selected properties will not be shown as standalone attributes anymore.', 'car_attr_pro'); ?></div>
                <div class="mb-line"><?php _e('Groups are only functional in item publish, search & widgets.', 'car_attr_pro'); ?></div>
              </div>
            </div>
            
            <div class="mb-row mb-row-datatype">
              <label for="s_data_type"><span><?php _e('Data Type', 'car_attr_pro'); ?></span></label> 

              <select id="s_data_type" name="s_data_type" required>
                <?php foreach(cap_dbtypes_list() as $dkey => $db_type) { ?>
                  <option value="<?php echo $dkey; ?>" <?php if($dkey == @$property['s_data_type']){ ?>selected="selected"<?php } ?>><?php echo $db_type; ?></option>
                <?php } ?>
              </select>

              <div class="mb-explain">
                <div class="mb-line"><?php _e('Select type of data stored for this property.', 'car_attr_pro'); ?></div>
              </div>
            </div>
            
            <div class="mb-row mb-row-multi">
              <label for="b_multi_select" class=""><span><?php _e('Multi-select in Search/Widget', 'car_attr_pro'); ?></span></label> 
              <input name="b_multi_select" id="b_multi_select" type="checkbox" class="element-slide" <?php echo (@$property['b_multi_select'] == 1 ? 'checked' : ''); ?> />
              
              <div class="mb-explain"><?php _e('It is possible to select more than one property value on search page & widget (select) or it is possible to define multiple values for checkbox/slider.', 'car_attr_pro'); ?></div>
            </div>
            
            <div class="mb-row mb-row-range">
              <label for="b_range" class=""><span><?php _e('Range-select in Search/Widget', 'car_attr_pro'); ?></span></label> 
              <input name="b_range" id="b_range" type="checkbox" class="element-slide" <?php echo (@$property['b_range'] == 1 ? 'checked' : ''); ?> />
              
              <div class="mb-explain"><?php _e('Property is converted to range search on search page & widget.', 'car_attr_pro'); ?></div>
            </div>
            
            <div class="mb-row mb-row-alt-name">
              <label for="s_name"><?php _e('Opposite Name', 'car_attr_pro'); ?></label>
              <input type="text" id="s_name_alt" name="s_name_alt" size="30" value="<?php echo @$property['s_name_alt']; ?>" />

              <div class="mb-explain"><?php _e('Alternative name for boolean sliders (ie. for Rent oppossite name is Sale).', 'car_attr_pro'); ?></div>
            </div>
            
            <div class="mb-row mb-row-meas-unit">
              <label for="s_measure_unit"><?php _e('Measure Unit', 'car_attr_pro'); ?></label>
              <input type="text" id="s_measure_unit" name="s_measure_unit" size="30" value="<?php echo @$property['s_measure_unit']; ?>"/>

              <div class="mb-explain"><?php _e('Measure unit used with this property, ie km, lb, ml,...', 'car_attr_pro'); ?></div>
            </div>
            
            <div class="mb-row mb-row-required-publish">
              <label for="b_required" class=""><span><?php _e('Required on Publish', 'car_attr_pro'); ?></span></label> 
              <input name="b_required" id="b_required" type="checkbox" class="element-slide" <?php echo (@$property['b_required'] == 1 ? 'checked' : ''); ?> />
              
              <div class="mb-explain"><?php _e('This property is required on publish page.', 'car_attr_pro'); ?></div>
            </div>


            
            <div class="mb-row mb-row-select-multiple mb-row-vehicle-types">
              <label for="type_ids_multiple"><span><?php _e('Types', 'car_attr_pro'); ?></span></label> 

              <input type="hidden" name="type_ids" id="type_ids" value="<?php echo implode(',', $type_ids); ?>"/>
              <select id="type_ids_multiple" name="type_ids_multiple" multiple>
                
                <?php if(is_array($types_all) && count($types_all) > 0) { ?>
                  <option value="0" <?php if(in_array(0, $type_ids)){ ?>selected="selected"<?php } ?>><?php _e('All types', 'car_attr_pro'); ?></option>
                  
                  <?php foreach($types_all as $type) { ?>
                    <option value="<?php echo $type['pk_i_id']; ?>" <?php if(in_array($type['pk_i_id'], $type_ids)){ ?>selected="selected"<?php } ?>><?php echo cap_get_name($type); ?></option>
                  <?php } ?>
                <?php } ?>
              </select>

              <div class="mb-explain">
                <div class="mb-line"><?php _e('Select one or more related types.', 'car_attr_pro'); ?></div>
              </div>
            </div>


            <div class="mb-row mb-row-search-engine">
              <label for="s_search_engine"><?php _e('Search Engine', 'car_attr_pro'); ?></label>

              <select id="s_search_engine" name="s_search_engine">
                <option value="" <?php if(@$property['s_search_engine'] == ''){ ?>selected="selected"<?php } ?>><?php _e('Default', 'car_attr_pro'); ?></option>
                <option value="EQUAL" <?php if(@$property['s_search_engine'] == 'EQUAL'){ ?>selected="selected"<?php } ?>><?php _e('Equal (= "word")', 'car_attr_pro'); ?></option>
                <option value="LIKE1" <?php if(@$property['s_search_engine'] == 'LIKE1'){ ?>selected="selected"<?php } ?>><?php _e('Like (like "word%")', 'car_attr_pro'); ?></option>
                <option value="LIKE2" <?php if(@$property['s_search_engine'] == 'LIKE2'){ ?>selected="selected"<?php } ?>><?php _e('Like (like "%word%")', 'car_attr_pro'); ?></option>
              </select>
              
              <div class="mb-explain"><?php _e('Select how searched pattern is applied in database. Equality is most effective from performance point of view.', 'car_attr_pro'); ?></div>
            </div>
            
            <hr/>
            
            <div class="mb-row mb-row-enabled">
              <label for="b_enabled" class=""><span><?php _e('Enable', 'car_attr_pro'); ?></span></label> 
              <input name="b_enabled" id="b_enabled" type="checkbox" class="element-slide" <?php echo (@$property['b_enabled'] == 1 ? 'checked' : ''); ?> />
              
              <div class="mb-explain"><?php _e('Enable or disable property.', 'car_attr_pro'); ?></div>
            </div>

            <div class="mb-row mb-row-section-item">
              <label for="fk_i_section_item_id"><?php _e('Item Detail Section', 'car_attr_pro'); ?></label>

              <select id="fk_i_section_item_id" name="fk_i_section_item_id">
                <option value="" <?php if(@$property['fk_i_section_item_id'] == ""){ ?>selected="selected"<?php } ?>><?php _e('Not assigned (no section)', 'car_attr_pro'); ?></option>
              
                <?php foreach($sections_item as $skey => $section) { ?>
                  <option value="<?php echo $skey; ?>" <?php if($skey == @$property['fk_i_section_item_id']){ ?>selected="selected"<?php } ?>><?php echo cap_get_name($section, true); ?></option>
                <?php } ?>
              </select>

              <div class="mb-explain"><?php _e('Section in item detail hook where property is placed.', 'car_attr_pro'); ?></div>
            </div>
            
            <div class="mb-row mb-row-enabled-widget">
              <label for="b_enabled_widget" class=""><span><?php _e('Add to Widget', 'car_attr_pro'); ?></span></label> 
              <input name="b_enabled_widget" id="b_enabled_widget" type="checkbox" class="element-slide" <?php echo (@$property['b_enabled_widget'] == 1 ? 'checked' : ''); ?> />
              
              <div class="mb-explain"><?php _e('Enable in search widget.', 'car_attr_pro'); ?></div>
            </div>
            
            <div class="mb-row mb-row-section-widget">
              <label for="fk_i_section_widget_id"><?php _e('Widget Section', 'car_attr_pro'); ?></label>

              <select id="fk_i_section_widget_id" name="fk_i_section_widget_id">
                <option value="" <?php if(@$property['fk_i_section_widget_id'] == ""){ ?>selected="selected"<?php } ?>><?php _e('Not assigned (no section)', 'car_attr_pro'); ?></option>

                <?php foreach($sections_widget as $skey => $section) { ?>
                  <option value="<?php echo $skey; ?>" <?php if($skey == @$property['fk_i_section_widget_id']){ ?>selected="selected"<?php } ?>><?php echo cap_get_name($section, true); ?></option>
                <?php } ?>
              </select>

              <div class="mb-explain"><?php _e('Section in widget where property is placed.', 'car_attr_pro'); ?></div>
            </div>
            
            <div class="mb-row mb-row-size">
              <label for="s_size"><?php _e('Maximize Box Size', 'car_attr_pro'); ?></label>

              <select id="s_size" name="s_size">
                <option value="" <?php if(@$property['s_size'] == ''){ ?>selected="selected"<?php } ?>><?php _e('Standard size', 'car_attr_pro'); ?></option>
                <option value="MAX_SEARCH" <?php if(@$property['s_size'] == 'MAX_SEARCH'){ ?>selected="selected"<?php } ?>><?php _e('Maximize in Search hook', 'car_attr_pro'); ?></option>
                <option value="MAX_WIDGET" <?php if(@$property['s_size'] == 'MAX_WIDGET'){ ?>selected="selected"<?php } ?>><?php _e('Maximize in Widget', 'car_attr_pro'); ?></option>
                <option value="MAX_PUBLISH" <?php if(@$property['s_size'] == 'MAX_PUBLISH'){ ?>selected="selected"<?php } ?>><?php _e('Maximize in Publish page', 'car_attr_pro'); ?></option>
                <option value="MAX_ALL" <?php if(@$property['s_size'] == 'MAX_ALL'){ ?>selected="selected"<?php } ?>><?php _e('Maximize in both', 'car_attr_pro'); ?></option>
                <option value="MAX_SEARCH_MOBILE" <?php if(@$property['s_size'] == 'MAX_SEARCH_MOBILE'){ ?>selected="selected"<?php } ?>><?php _e('Maximize in Search hook', 'car_attr_pro'); ?> (<?php _e('Mobile only', 'car_attr_pro'); ?>)</option>
                <option value="MAX_WIDGET_MOBILE" <?php if(@$property['s_size'] == 'MAX_WIDGET_MOBILE'){ ?>selected="selected"<?php } ?>><?php _e('Maximize in Widget', 'car_attr_pro'); ?> (<?php _e('Mobile only', 'car_attr_pro'); ?>)</option>
                <option value="MAX_PUBLISH_MOBILE" <?php if(@$property['s_size'] == 'MAX_PUBLISH_MOBILE'){ ?>selected="selected"<?php } ?>><?php _e('Maximize in Publish page', 'car_attr_pro'); ?> (<?php _e('Mobile only', 'car_attr_pro'); ?>)</option>
                <option value="MAX_ALL_MOBILE" <?php if(@$property['s_size'] == 'MAX_ALL_MOBILE'){ ?>selected="selected"<?php } ?>><?php _e('Maximize in both', 'car_attr_pro'); ?> (<?php _e('Mobile only', 'car_attr_pro'); ?>)</option>
              </select>
              
              <div class="mb-explain"><?php _e('Select if you want to maximize size of this property.', 'car_attr_pro'); ?></div>
            </div>

            
            <div class="mb-row mb-row-enabled-search">
              <label for="b_enabled_search" class=""><span><?php _e('Add to Search Hook', 'car_attr_pro'); ?></span></label> 
              <input name="b_enabled_search" id="b_enabled_search" type="checkbox" class="element-slide" <?php echo (@$property['b_enabled_search'] == 1 ? 'checked' : ''); ?> />
              
              <div class="mb-explain"><?php _e('Add to search_form hook (filters) on search page.', 'car_attr_pro'); ?></div>
            </div>
            
            <div class="mb-row mb-row-section-publish">
              <label for="fk_i_section_publish_id"><?php _e('Publish Section', 'car_attr_pro'); ?></label>

              <select id="fk_i_section_publish_id" name="fk_i_section_publish_id">
                <option value="" <?php if(@$property['fk_i_section_publish_id'] == ""){ ?>selected="selected"<?php } ?>><?php _e('Not assigned (no section)', 'car_attr_pro'); ?></option>
                
                <?php foreach($sections_widget as $skey => $section) { ?>
                  <option value="<?php echo $skey; ?>" <?php if($skey == @$property['fk_i_section_publish_id']){ ?>selected="selected"<?php } ?>><?php echo cap_get_name($section, true); ?></option>
                <?php } ?>
              </select>

              <div class="mb-explain"><?php _e('Section in widget where property is placed. If no section is selected, widget or item section will be used instead.', 'car_attr_pro'); ?></div>
            </div>
            
            <div class="mb-row mb-row-order">
              <label for="i_order"><?php _e('Order', 'car_attr_pro'); ?></label>
              <input type="number" id="i_order" name="i_order" size="30" value="<?php echo (int)(@$property['i_order'] > 0 ? @$property['i_order'] : 9999); ?>" />

              <div class="mb-explain"><?php _e('Position of property. Number between 1-9999.', 'car_attr_pro'); ?></div>
            </div>
          </div>



          <div id="mb-prop-val">
            <strong class="mb-val-head"><?php _e('Property values', 'car_attr_pro'); ?></strong>
            
            <?php if(!in_array(@$property['s_id'], $banned_ids)) { ?>
              <div class="mb-val-subhead"><?php _e('Define values for each type. If no values are defined for selected type, values from "Default" type are used.', 'car_attr_pro'); ?></div>
              <div class="mb-val-subhead"><?php _e('<b>Note:</b> If you use integer data type, identifier of values must be <u>whole number</u> - integer! Otherwise for Values list (FK), identifier must <u>start with letter</u>, not number!', 'car_attr_pro'); ?></div>

              <div class="mb-val-types">
                <a class="mb-sel-type mb-active" data-id="0">
                  <?php _e('Default', 'car_attr_pro'); ?>
                  (<?php echo (isset($property['values'][0]) ? count($property['values'][0]) : 0); ?>)
                </a>

                <?php if(is_array($types_all) && count($types_all) > 0) { ?>
                  <?php foreach($types_all as $type) { ?>
                    <?php if(in_array($type['pk_i_id'], $type_ids)){ ?>
                      <a class="mb-sel-type" data-id="<?php echo $type['pk_i_id']; ?>">
                        <?php echo cap_get_name($type); ?>
                        (<?php echo (isset($property['values'][$type['pk_i_id']]) ? count($property['values'][$type['pk_i_id']]) : 0); ?>)
                      </a>
                    <?php } ?>
                  <?php } ?>
                <?php } ?>
              </div>

              <?php $types_all[] = array('pk_i_id' => 0); ?>
              <?php foreach($types_all as $type) { ?>
                <div class="mb-val-list mb-sortable <?php if($type['pk_i_id'] == 0) { ?>mb-active<?php } ?>" data-id="<?php echo $type['pk_i_id']; ?>">
                  <?php if(isset($property['values'][$type['pk_i_id']]) && is_array($property['values'][$type['pk_i_id']]) && count($property['values'][$type['pk_i_id']]) > 0) { ?>
                    <?php foreach($property['values'][$type['pk_i_id']] as $val) { ?>
                      <?php cap_admin_generate_value_elem($val['pk_i_id'], $val, $property); ?>
                    <?php } ?>
                  <?php } else { ?>
                    <?php cap_admin_generate_value_empty(__('No values defined', 'car_attr_pro')); ?>
                  <?php } ?>
                </div>
                
                <div class="mb-val-foot <?php if($type['pk_i_id'] == 0) { ?>mb-active<?php } ?>" data-id="<?php echo $type['pk_i_id']; ?>">
                  <a href="#" class="mb-val-add mb-btn"><i class="fa fa-plus-circle"></i> <span><?php _e('Add value', 'car_attr_pro'); ?></span></a>
                  
                  <div class="mb-add-box">
                    <input class="mb-add-list" type="text" placeholder="<?php echo osc_esc_html(__('... or create/update from list: val1;val2;val3;...', 'car_attr_pro')); ?>"/>
                    <a href="#" class="mb-add-list-btn"><i class="fa fa-plus-circle"></i> <?php _e('Add', 'car_attr_pro'); ?></a>
                    <a href="#" class="mb-update-list-btn"><i class="fa fa-pencil"></i> <?php _e('Upd', 'car_attr_pro'); ?></a>
                  </div>
                </div>
              <?php } ?>
            <?php } else { ?>
              <div class="mb-val-wrap">
                <div class="mb-notes mb-small">
                  <div class="mb-line"><?php _e('Values for this property are specified on different page.', 'car_attr_pro'); ?></div>
                  
                  <?php 
                    $sid = @$property['s_id'];
                    $val_url = '';
                    
                    switch ($sid) {
                      case 'type': $val_url = osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/type.php';break;
                      case 'make': $val_url = osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/make_model.php';break;
                      case 'model': $val_url = osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/make_model.php';break;
                      case 'category': $val_url = osc_admin_base_url(true) . '?page=categories';break;
                      case 'location': $val_url = osc_admin_base_url(true) . '?page=locations';break;
                      case 'pattern': $val_url = osc_admin_base_url(true) . '?page=settings&action=latestsearches';break;
                      default: $val_url = '#';break;
                    }
                  ?>
                  <div class="mb-line"><a href="<?php echo $val_url; ?>" target="_blank"><?php _e('Edit values', 'car_attr_pro'); ?> <i class="fa fa-angle-double-right"></i></a></div>
                </div>
              </div>

            <?php } ?>
          </div>
        </div>
        
        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(!cap_is_demo()) { ?><button type="submit" class="mb-button"><?php _e('Save', 'car_attr_pro');?></button><?php } ?>
        </div>
      </form>
    </div>
  </div>
</div>

<style>
  .mb-box .mb-inside .mb-row.mb-disabled:hover:before {content:"<?php echo osc_esc_html(__('Setting not available for your combination!', 'car_attr_pro')); ?>";}
  #mb-prop-val.mb-disabled:hover:before {content:"<?php echo osc_esc_html(__('Values not available for your combination!', 'car_attr_pro')); ?>";}
</style>


<script type="text/javascript">
  var cap_add_prop_value_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=cap_admin_add_property_value";
  var cap_delete_prop_value_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=cap_admin_delete_property_value";
  var cap_update_prop_value_position_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=cap_admin_update_property_value_position";

  var cap_message_ok = "<?php echo osc_esc_html(__('Success!', 'attributes')); ?>";
  var cap_message_wait = "<?php echo osc_esc_html(__('Updating, please wait...', 'attributes')); ?>";
  var cap_message_error = "<?php echo osc_esc_html(__('Error!', 'attributes')); ?>";
 


  // RESTRICT CHARACTERS FOR S_ID INPUTS (values)
  $('body').on('keypress', '#mb-prop-val .mb-val-list .mb-col-id input[type="text"]', function (event) {
    var dataType = $('select[name="s_data_type"]').val();
    
    if(dataType == 'INTEGER') {
      var regex = new RegExp("^[0-9]+$");
      var key = String.fromCharCode(!event.charCode ? event.which : event.charCode);
      
      if (!regex.test(key)) {
        event.preventDefault();
        return false;
      }
      
    } else {
      var regexStart = new RegExp("^[a-z]+$");
      var regex = new RegExp("^[a-z0-9\-]+$");
      var key = String.fromCharCode(!event.charCode ? event.which : event.charCode);
      
      if (!regex.test(key) || ($(this)[0].selectionStart == 0 && !regexStart.test(key))) {
        event.preventDefault();
        return false;
      }
    }
  });


  // RESTRICT CHARACTERS FOR S_ID INPUTS (identifier)
  $('body').on('keypress', 'input[name="s_id"]', function (event) {
    var regexStart = new RegExp("^[a-z]+$");
    var regex = new RegExp("^[a-z0-9\-]+$");
    var key = String.fromCharCode(!event.charCode ? event.which : event.charCode);
    
    if (!regex.test(key) || ($(this)[0].selectionStart == 0 && !regexStart.test(key))) {
      event.preventDefault();
      return false;
    }
  });
  

  // CHECK UNIQUENESS OF VALUE SID INSIDE PROPERTY VALUES
  $('body').on('keyup', '#mb-prop-val .mb-val-list .mb-col-id input[type="text"]', function(e){
    var inpt = $(this);
    var currentKey = $(this).closest('.mb-row').attr('data-id');
    var currentId = $(this).closest('.mb-row').attr('data-sid');
    var newId = $(this).val();
    var warnText = '<?php echo osc_esc_js(__('Value is not unique inside property. All value IDs must be unique, no matter what is type!', 'car_attr_pro')); ?>';
    var dataType = $('select[name="s_data_type"]').val(); 
    var shortText = '<?php echo osc_esc_js(__('Minimum length for identifier is {0} characters!', 'car_attr_pro')); ?>';
    var minLength = 3;
    
    if(dataType == 'INTEGER') {
      minLength = 1;
    }
    
    shortText = shortText.replace('{0}', minLength);

    // Check length
    if(newId.length < minLength) {
      inpt[0].setCustomValidity(shortText);
      inpt.removeClass('mb-inpt-ok').addClass('mb-inpt-error').attr('title', shortText);
      inpt.siblings('.mb-quick-tooltip').remove();
      inpt.after('<div class="mb-quick-tooltip">' + shortText + '</div>');

    } else {    
    
      // Check live values
      var checkVals = new Array();
      if(currentId != newId) {
        $('#mb-prop-val .mb-val-list .mb-col-id input[type="text"]').each(function() {
          if($(this).closest('.mb-row').attr('data-id') !== currentKey) {
            checkVals.push($(this).val());
          }
        });
      
        if(checkVals.indexOf(newId) >= 0) {
          inpt[0].setCustomValidity(warnText);
          inpt.removeClass('mb-inpt-ok').addClass('mb-inpt-error').attr('title', warnText);
          inpt.siblings('.mb-quick-tooltip').remove();
          inpt.after('<div class="mb-quick-tooltip">' + warnText + '</div>');
          
        } else {
          inpt[0].setCustomValidity('');
          inpt.removeClass('mb-inpt-error').addClass('mb-inpt-ok').attr('title', '');
          inpt.siblings('.mb-quick-tooltip').remove();
        }
      }
    }
  });

  
  // DELETE PROPERTY VALUE
  $('body').on('click', '#mb-prop-val a.mb-del-value', function(e){
    e.preventDefault();
    
    var id = $(this).attr('data-id');
    var btn = $(this);
    var elem = $(this).closest('.mb-row');
    var url = cap_delete_prop_value_url + '&id=' + id;

    btn.find('i.fa').removeClass('fa-times').addClass('fa-cog fa-spin');
    
    if(window.confirm('<?php echo osc_esc_js(__('Are you sure you want to remove this value? Action cannot be undone.', 'car_attr_pro')); ?>')) {
      $.ajax({
        url: url,
        type: "GET",
        success: function(response){
          //console.log(response);
          elem.slideUp(200, function() { elem.remove(); });
          cap_message(cap_message_ok, 'ok');
        },
        error: function(response) {
          cap_message(cap_message_error, 'error');
          console.log(response);
        }
      });
    }
  });
  
  
  // ADD A NEW PROPERTY VALUE
  $('body').on('click', '#mb-prop-val .mb-val-foot a.mb-val-add, #mb-prop-val .mb-val-foot a.mb-add-list-btn', function(e) {
    e.preventDefault();
    
    var btn = $(this);
    var isList = false;
    
    if(btn.hasClass('mb-add-list-btn')) {
      var isList = true;
    }

    var typeId = $(this).closest('.mb-val-foot').attr('data-id');
    var propId = $(this).closest('form[name="promo_form"]').find('input[name="editId"]').val();
    var locale = $(this).closest('form[name="promo_form"]').find('input[name="capLocale"]').val();
    var list = '';
    
    if(isList) {
      list = btn.siblings('input.mb-add-list').val();  
    }
    
    btn.find('i.fa').removeClass('fa-plus-circle').addClass('fa-cog fa-spin');

    $.ajax({
      url: cap_add_prop_value_url + '&locale=' + locale + '&typeId=' + typeId + '&propId=' + propId + '&list=' + list,
      type: "GET",
      success: function(response){
        //console.log(response);
        btn.closest('#mb-prop-val').find('.mb-val-list[data-id="' + typeId + '"] .mb-empty-box').remove();
        btn.closest('#mb-prop-val').find('.mb-val-list[data-id="' + typeId + '"]').append(response);
        
        btn.find('i.fa').removeClass('fa-cog fa-spin').addClass('fa-plus-circle');
        
        if(isList) {
          btn.siblings('input.mb-add-list').val('');
        }

        cap_message(cap_message_ok, 'ok');
      },
      error: function(response) {
        cap_message(cap_message_error, 'error');
        console.log(response);
      }
    });
  });
  

  // UPDATE EXISTING PROPERTIES
  $('body').on('click', '#mb-prop-val .mb-val-foot a.mb-update-list-btn', function(e) {
    e.preventDefault();
    
    if($(this).siblings('input.mb-add-list').val() == '') {
      return false;
    }
    
    var list = $(this).siblings('input.mb-add-list').val().replaceAll(',', ';').split(';');  
    var i = 0;
    
    $('.mb-val-list.mb-active .mb-row .mb-col-name input[type="text"]').each(function() {
      if(typeof list[i] !== 'undefined') {
        $(this).val(list[i]);
        i++;
      }
    });

  });
  

  $(document).ready(function() {

    // SORTABLE VALUES - MAKES
    var original_list = '';

    $('.mb-val-list.mb-sortable').sortable({
      axis: "y",
      forcePlaceholderSize: true,
      handle: '.mb-col-move',
      helper: 'clone',
      items: '> .mb-row',
      opacity: .8,
      placeholder: 'mb-placeholder',
      revert: 100, 
      tabSize: 5,
      tolerance: 'intersect',
      start: function(event, ui) {
        var original_list = $(this).sortable('serialize');
      },
      stop: function (event, ui) {
        var updated_list = $(this).sortable('serialize');

        cap_message(cap_message_wait, 'info');
        
        if(original_list != updated_list) {
          $.ajax({
            url: cap_update_prop_value_position_url,
            type: "POST",
            data: updated_list,
            success: function(response){
              //console.log(response);
              cap_message(cap_message_ok, 'ok');
            },
            error: function(response) {
              cap_message(cap_message_error, 'error');
              console.log(response);
            }
          });
        }
      }
    });
    
  });
  
  
  
  // UPDATE PROPERTY PARAMETERS
  function capUpdatePropParam(initial = false) {
    var type = $('select#s_type').val(); 

    $('select[name="s_style"]').find('option').prop('disabled', false);

    // MAIN TYPE
    if(type == 'group') {
      $('.mb-row-style').addClass('mb-disabled');
      $('select[name="s_style"]').val('group').find('option:not([value="group"])').prop('disabled', true);;
      
    } else if(type == 'predefined') {
      $('.mb-row-style').removeClass('mb-disabled');
      $('select[name="s_style"]').find('option:not([value="select"]):not([value="slider"]):not([value="checkbox"])').prop('disabled', true);;
      
    } else {
      $('.mb-row-style').removeClass('mb-disabled');
      $('select[name="s_style"]').find('option:not([value="input"]):not([value="textarea"])').prop('disabled', true);;
     
    }
    
    //$('select[name="s_style"]').find('option:not([disabled]):first').prop("selected", true);


    var style = $('select[name="s_style"]').val(); 
    var dataType = $('select[name="s_data_type"]').val(); 
    
    // SUBTYPE
    if(style == 'group') {
      $('.mb-row-group').removeClass('mb-disabled').show(0);
      $('.mb-row-datatype, .mb-row-multi, .mb-row-search-engine, .mb-row-range, .mb-row-required-publish, .mb-row-widget-section, .mb-row-item-detail-section, .mb-row-enabled-search, #mb-prop-val').addClass('mb-disabled');
      
      $('select[name="s_data_type"]').find('option').prop('disabled', false);
      $('select[name="s_data_type"]').val('VARCHAR_50');
      
    } else {
      $('.mb-row-group').addClass('mb-disabled').hide(0);
      $('.mb-row-datatype, .mb-row-multi, .mb-row-search-engine, .mb-row-range, .mb-row-required-publish, .mb-row-widget-section, .mb-row-item-detail-section, .mb-row-enabled-search, #mb-prop-val').removeClass('mb-disabled');

      $('select[name="s_data_type"]').find('option').prop('disabled', false);
      $('input[name="s_group_list"], select[name="s_group_list_multiple"]').val('');

    }


    // MULTI
    if (style == 'select' || style == 'checkbox' || style == 'slider') {
      $('.mb-row-multi').removeClass('mb-disabled');
    } else {
      $('.mb-row-multi').addClass('mb-disabled');
      $('input[name="b_multi_select"]').prop("checked", false).change();
    }
    
    
    // RANGE
    //if (style == 'input' && (dataType == 'integer' || dataType == 'decimal')) {
    if (dataType == 'INTEGER' || dataType == 'DECIMAL') {
      $('.mb-row-range').removeClass('mb-disabled');
    } else {
      $('.mb-row-range').addClass('mb-disabled');
      $('input[name="b_range"]').prop("checked", false).change();
    }
    
    
    // REQUIRED ON PUBLISH
    if (style == 'checkbox' && !$('input[name="b_multi_select"]').bootstrapSwitch('state')) {
      $('.mb-row-required-publish').addClass('mb-disabled');
      $('input[name="b_required"]').prop("checked", false).change();
    } else {
      $('.mb-row-required-publish').removeClass('mb-disabled');
    }

    
    // SELECT OR CHECKBOX/SLIDER WITH MULTI VALUE
    if (style == 'select') {
      $('#mb-prop-val').removeClass('mb-disabled');
      $('.mb-row-datatype').removeClass('mb-disabled');
      $('select[name="s_data_type"]').find('option').prop('disabled', false);
      $('select[name="s_data_type"]').find('option:not([value^="INTEGER"]):not([value="FK_INTEGER"])').prop('disabled', true);
    }

    if ((style == 'checkbox' || style == 'slider') && $('input[name="b_multi_select"]').bootstrapSwitch('state')) {
      $('#mb-prop-val').removeClass('mb-disabled');
      $('.mb-row-datatype').addClass('mb-disabled');
      $('select[name="s_data_type"]').find('option').prop('disabled', false);
      $('select[name="s_data_type"]').find('option:not([value^="FK_INTEGER"])').prop('disabled', true);
      $('select[name="s_data_type"]').val('FK_INTEGER');

    }
    
    // CHECKBOX/SLIDER WITH ONE VALUE
    if ((style == 'checkbox' || style == 'slider') && !$('input[name="b_multi_select"]').bootstrapSwitch('state')) {
      $('#mb-prop-val').addClass('mb-disabled');
      $('.mb-row-datatype').addClass('mb-disabled');
      $('select[name="s_data_type"]').find('option').prop('disabled', false);
      $('select[name="s_data_type"]').find('option:not([value^="BOOLEAN"])').prop('disabled', true);
      $('select[name="s_data_type"]').val('BOOLEAN');
    }

    if (style == 'input') {
      $('#mb-prop-val').addClass('mb-disabled');
      $('.mb-row-datatype').removeClass('mb-disabled');
      $('select[name="s_data_type"]').find('option').prop('disabled', false);
      $('select[name="s_data_type"]').find('option:not([value^="VARCHAR"]):not([value="DECIMAL"]):not([value="INTEGER"])').prop('disabled', true);
    }
    
    
    // DATATYPE FOR TEXTAREA
    if (style == 'textarea') {
      $('#mb-prop-val').addClass('mb-disabled');
      $('.mb-row-datatype').removeClass('mb-disabled');
      $('select[name="s_data_type"]').find('option').prop('disabled', false);
      $('select[name="s_data_type"]').find('option:not([value^="VARCHAR"])').prop('disabled', true);
    }
    

    // ALT NAME FOR SLIDER SINGLE SELECT
    if (style == 'slider' && !$('input[name="b_multi_select"]').bootstrapSwitch('state')) {
      $('.mb-row-alt-name').removeClass('mb-disabled');
    } else {
      $('.mb-row-alt-name').addClass('mb-disabled');
    }
    
    
    // MEASURE UNIT
    if(dataType == 'FK_INTEGER' || dataType == 'INTEGER' || dataType == 'DECIMAL' || dataType == 'VARCHAR_50') {
      $('.mb-row-meas-unit').removeClass('mb-disabled');
    } else {
      $('.mb-row-meas-unit').addClass('mb-disabled');
      $('input[name="s_measure_unit"]').val('');
    }
    
    // SEARCH ENGINE
    if(style != 'group' && (dataType == 'TEXTAREA' || dataType.slice(0, 7) == 'VARCHAR')) {
      $('.mb-row-search-engine').removeClass('mb-disabled');
    } else {
      $('.mb-row-search-engine').addClass('mb-disabled');
      $('select[name="s_search_engine"]').val('');
    }
    
    
    
    // DISABLED HIDE SECTIONS
    if(!$('input[name="b_enabled"]').bootstrapSwitch('state')) {
      $('.mb-row-section-item, .mb-row-section-widget, .mb-row-section-publish, .mb-row-enabled-widget, .mb-row-size, .mb-row-enabled-search').addClass('mb-disabled');
    } else {
      $('.mb-row-section-item, .mb-row-section-widget, .mb-row-section-publish, .mb-row-enabled-widget, .mb-row-size, .mb-row-enabled-search').removeClass('mb-disabled');
    }
    
    
    // DISABLED WIDGET
    if(!$('input[name="b_enabled_widget"]').bootstrapSwitch('state') || !$('input[name="b_enabled"]').bootstrapSwitch('state')) {
      $('.mb-row-section-widget').addClass('mb-disabled');
    } else {
      $('.mb-row-section-widget').removeClass('mb-disabled');
    }
    
    
    // GROUP - FIX CONFLICTS IN DISPLAYS
    if(style == 'group') {
      $('.mb-row-group').removeClass('mb-disabled');
      $('.mb-row-datatype, .mb-row-multi, .mb-row-range, .mb-row-required-publish, .mb-row-widget-section, .mb-row-item-detail-section, .mb-row-enabled-search, #mb-prop-val').addClass('mb-disabled');
      
    } else {
      // $('.mb-row-group').addClass('mb-disabled');
      // $('.mb-row-datatype, .mb-row-multi, .mb-row-range, .mb-row-required-publish, .mb-row-widget-section, .mb-row-item-detail-section, .mb-row-enabled-search, #mb-prop-val').removeClass('mb-disabled');

    }
    
    
    // SET VALUES S_ID PATTERN
    if(dataType == 'INTEGER') {
      $('#mb-prop-val .mb-val-list .mb-col-id input[type="text"]').attr('pattern', "[0-9]{1,50}");
    } else {
      $('#mb-prop-val .mb-val-list .mb-col-id input[type="text"]').attr('pattern', "[a-z]{1}[a-z0-9\\-]{2,49}");
    }
    
    
    // MAKE SURE NO SELECT HAS DISABLED VALUE SELECTED
    $('#mb-prop-main select').each(function() {
      if($(this).find(':selected').prop('disabled')){
        $(this).find('option:not([disabled]):first').prop("selected", true);
        console.log('Select "' + $(this).attr('name') + '" value changed to non-disabled: ' + $(this).find('option:not([disabled]):first').text());
        $(this).change();
      }
    });


    // SPECIFIC SETUP FOR RESERVED PROPERTIES
    var identifier = $('input[name="s_id"]').val();
    
    if(identifier == 'location' || identifier == 'category') {
      $('.mb-row-text-publish, .mb-row-range,.mb-row-multi, .mb-row-meas-unit, .mb-row-required-publish, .mb-row-style, .mb-row-type, .mb-row-datatype').addClass('mb-disabled');
      $('select[name="s_type"]').val('predefined');
      $('select[name="s_style"]').val('select').find('option:not([value="select"])').prop('disabled', true);
      $('select[name="s_data_type"]').val('FK_INTEGER').find('option:not([value="FK_INTEGER"])').prop('disabled', true);
      $('input[name="b_multi_select"]').prop("checked", false);
      $('input[name="b_range"]').prop("checked", false);
      $('input[name="s_measure_unit"]').val('');
    }

    if(identifier == 'price') {
      $('.mb-row-text-publish, .mb-row-multi, .mb-row-meas-unit, .mb-row-required-publish, .mb-row-style, .mb-row-type, .mb-row-datatype').addClass('mb-disabled');
      $('select[name="s_type"]').val('userdefined');
      $('select[name="s_style"]').val('input').find('option:not([value="input"])').prop('disabled', true);
      $('select[name="s_data_type"]').val('INTEGER').find('option:not([value="INTEGER"])').prop('disabled', true);
      $('input[name="b_multi_select"]').prop("checked", false);
      $('input[name="s_measure_unit"]').val('');
    }
  }
  
  // $('input[name="b_multi_select"]').on('change.bootstrapSwitch', function(e) {
    // $(this).change();
  // });
  
  $('input[name="b_multi_select"], input[name="b_enabled_widget"], input[name="b_enabled"]').on('switchChange.bootstrapSwitch', function (event, state) {
    capUpdatePropParam();
  }); 

  
  $('body').on('change', 'select[name="s_style"], select[name="s_data_type"], select#s_type, input[name="b_multi_select"]', function() {
    capUpdatePropParam();
  });
  
  $(document).ready(function() {
    capUpdatePropParam(true);
  });
  
  
  // For every non-focusable (hidden) input, remove required and pattern attributes
  window.setInterval(function() {
    $('input[name^="capval"], select[name^="capval"]').each(function() {
      var elem = $(this);
      
      // input is hidden
      if(elem.is(":hidden") || elem.is(":disabled")) {
        if(elem.is(':required')) {
          elem.attr('data-required', true);
          elem.prop('required', false);
        }
        
        if(elem.attr('pattern') !== 'undefined' && elem.attr('pattern') != '') {
          elem.attr('data-pattern', elem.attr('pattern'));
          elem.removeAttr('pattern');
        }
        
      // input is visible
      } else {
        if(elem.attr('data-required') !== 'undefined' && elem.attr('data-required') == 'true') {
          elem.prop('required', true);
          elem.removeAttr('data-required');
        }
        
        if(elem.attr('data-pattern') !== 'undefined' && elem.attr('data-pattern') == '') {
          elem.attr('pattern', elem.attr('data-pattern'));
          elem.removeAttr('data-pattern', '');
        }
        
      }
    });
  }, 500);
</script>


<?php echo cap_footer(); ?>