<?php
  // Create menu
  $title = __('Sections', 'car_attr_pro');
  cap_menu($title);

  $locale = (Params::getParam('capLocale') <> '' ? Params::getParam('capLocale') : cap_get_locale());

  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value


  if(Params::getParam('plugin_action') == 'done') {
    osc_set_preference('property_config', json_encode(Params::getParam('capproperty')), 'plugin-car_attr_pro', 'STRING');  

    osc_add_flash_ok_message(__('Settings were successfully saved.', 'car_attr_pro'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/section.php');
    exit;
  }
  
  $banned_ids = cap_banned_sections();
  $sections = ModelCAP::newInstance()->getSections(false, -1, true);
?>

<div class="mb-body">

  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-folder-open"></i> <?php _e('Sections', 'car_attr_pro'); ?>
      <?php echo cap_locale_box('section.php'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <?php if(!cap_is_demo()) { ?>
          <input type="hidden" name="page" value="plugins" />
          <input type="hidden" name="action" value="renderplugin" />
          <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>section.php" />
          <input type="hidden" name="plugin_action" value="done" />
        <?php } ?>


        <div class="mb-table mb-table-section" id="mb-sections">
          <div class="mb-table-head">
            <div class="mb-col-1 mb-align-left">&nbsp;</div>
            <div class="mb-col-1 mb-align-left"><?php _e('ID', 'car_attr_pro'); ?></div>
            <div class="mb-col-6 mb-align-left"><?php _e('Section Name (Identifier)', 'car_attr_pro'); ?></div>
            <div class="mb-col-3 mb-align-left"><?php _e('Enabled', 'car_attr_pro'); ?></div>
            <div class="mb-col-4 mb-align-left"><?php _e('Locations', 'car_attr_pro'); ?></div>
            <div class="mb-col-5 mb-align-left"><?php _e('Types', 'car_attr_pro'); ?></div>
            <div class="mb-col-4 mb-align-left">&nbsp;</div>
          </div>

          <?php if(is_array($sections) && count($sections) > 0) { ?>
            <?php foreach($sections as $id => $section) { ?>
              <div class="mb-table-row" id="cap_<?php echo $id; ?>" data-id="<?php echo $id; ?>">
                <div class="mb-col-1 mb-col-move"><i class="fa fa-arrows mb-has-tooltip move ui-sortable-handle" title=""></i></div>
                <div class="mb-col-1 mb-align-left"><?php echo $id; ?></div>
                
                <div class="mb-col-6 mb-align-left">
                  <strong><?php echo ($section['s_name'] <> '' ? $section['s_name'] : __('N/A', 'car_attr_pro')); ?></strong>
                  <span>(<?php echo $section['s_id']; ?>)</span>
                </div>
                
                <div class="mb-col-3 mb-align-left mb-checks">
                  <?php if($section['b_enabled'] == 1) { ?>
                    <i class="fa fa-check"></i> <span><?php _e('Yes', 'car_attr_pro'); ?></span>
                  <?php } else { ?>
                    <i class="fa fa-times"></i> <span><?php _e('No', 'car_attr_pro'); ?></span>
                  <?php } ?>
                </div>
                

                <div class="mb-col-4 mb-align-left"><?php echo cap_get_section_location_names($section); ?></div>
                <div class="mb-col-5 mb-align-left"><?php echo implode(', ', array_column($section['types'], 's_name')); ?></div>
                <div class="mb-col-4 mb-align-right">
                  <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=car_attr_pro/admin/section_edit.php&editId=<?php echo $id; ?>&capLocale=<?php echo cap_get_locale(); ?>" class="mb-btn mb-button-white"><i class="fa fa-pencil"></i> <?php _e('Edit', 'car_attr_pro'); ?></a>

                  <?php if(!cap_is_demo() && !in_array($section['s_id'], $banned_ids)) { ?>
                    <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=car_attr_pro/admin/section_edit.php&deleteId=<?php echo $id; ?>&capLocale=<?php echo cap_get_locale(); ?>" class="mb-btn mb-button-red" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove this section? Action cannot be undone', 'car_attr_pro')); ?>')"><i class="fa fa-trash-o"></i></a>
                  <?php } ?>
                </div>
              </div>
            <?php } ?>
          <?php } else { ?>
            <div class="mb-table-row mb-row-empty">
              <i class="fa fa-warning"></i><span><?php _e('No sections has been created yet', 'car_attr_pro'); ?></span>
            </div>
          <?php } ?>
        </div>


        <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=car_attr_pro/admin/section_edit.php&editId=-1&capLocale=<?php echo cap_get_locale(); ?>" class="mb-add-button"><i class="fa fa-plus-circle"></i><?php _e('Add a new section', 'car_attr_pro'); ?></a>

        <div class="mb-row">&nbsp;</div>

      </form>
    </div>
  </div>
</div>

<script type="text/javascript">
  var cap_position_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=cap_admin_update_sections_position";

  var cap_message_ok = "<?php echo osc_esc_html(__('Success!', 'car_attr_pro')); ?>";
  var cap_message_wait = "<?php echo osc_esc_html(__('Updating, please wait...', 'car_attr_pro')); ?>";
  var cap_message_error = "<?php echo osc_esc_html(__('Error!', 'car_attr_pro')); ?>";


  $(document).ready(function(){
    var cap_list = '';

    $('#mb-sections').sortable({
      axis: "y",
      forcePlaceholderSize: true,
      handle: '.move',
      helper: 'clone',
      items: '.mb-table-row',
      opacity: .8,
      placeholder: 'placeholder',
      revert: 100,
      tabSize: 5,
      tolerance: 'intersect',
      start: function(event, ui) {
        cap_list = $(this).sortable('serialize');
      },
      stop: function (event, ui) {
        var c_cap_list = $(this).sortable('serialize');

        cap_message(cap_message_wait, 'info');

        if(cap_list != c_cap_list) {
          $.ajax({
            url: cap_position_url,
            type: "GET",
            data: c_cap_list,
            success: function(response){
              //console.log(response);
              cap_message(cap_message_ok, 'ok');
            },
            error: function(response) {
              cap_message(cap_message_error, 'error');
              console.log(response);
            }
          });
        }
      }
    });

  });
</script>

<?php echo cap_footer(); ?>