<?php
  // Create menu
  $title = __('Edit section', 'car_attr_pro');
  cap_menu($title);

  $locale = (Params::getParam('fk_c_locale_code') <> '' ? Params::getParam('fk_c_locale_code') : Params::getParam('capLocale'));
  $locale = ($locale <> '' ? $locale : cap_get_locale());
  $banned_ids = cap_banned_sections();


  if((Params::getParam('editId') > 0 || Params::getParam('editId') == -1) && Params::getParam('plugin_action') == 'done') {
    $id = Params::getParam('editId');

    if($id == -1) {
      $id = ModelCAP::newInstance()->insertSection(array('i_order' => 9999));
      Params::setParam('editId', $id);
    }

    $sections = ModelCAP::newInstance()->getSections(false, -1, true);
    $section = isset($sections[$id]) ? $sections[$id] : array();

    if(in_array($section['s_id'], $banned_ids) && $section['s_id'] != osc_sanitizeString(Params::getParam('s_id')) && Params::getParam('s_id') != '') {
      
      osc_add_flash_error_message(__('Identifier cannot be changed (protected section).', 'car_attr_pro'), 'admin');
      header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/section_edit.php&editId=' . $id);
      exit;      
    }

    $data_section = array(
      //'pk_i_id' => $id,
      //'s_id' => osc_sanitizeString(Params::getParam('s_id')),
      's_icon' => trim(Params::getParam('s_icon', false, false)),
      'i_order' => Params::getParam('i_order'),
      's_section_type' => Params::getParam('s_section_type'),
      's_item_style' => Params::getParam('s_item_style'),
      's_widget_style' => Params::getParam('s_widget_style'),
      'b_enabled' => (Params::getParam('b_enabled') == 'on' ? 1 : 0)
    );
    
    if(!in_array($section['s_id'], $banned_ids) || $section['s_id'] == Params::getParam('s_id')) {
      $data_section['s_id'] = osc_sanitizeString(Params::getParam('s_id'));
    }
    
    if($id == 1 || $section['s_id'] == 'main') {
      $data_section['b_enabled'] = 1;
      $data_section['i_order'] = 1;
      $data_section['s_widget_style'] = 'BOX';
    }
    
    if($id == 2 || $section['s_id'] == 'bottom') {
      $data_section['i_order'] = 2;
    }

    $data_locale = array(
      'fk_i_section_id' => (int)$id,
      'fk_c_locale_code' => $locale,
      's_name' => Params::getParam('s_name'),
      's_description' => Params::getParam('s_description'),
      's_text_search' => Params::getParam('s_text_search'),
      's_text_publish' => Params::getParam('s_text_publish'),
      's_text_item' => Params::getParam('s_text_item')
    );

    $type_ids = explode(',', Params::getParam('type_ids'));
    $data_type = array();
    
    if(is_array($type_ids) && count($type_ids) > 0) {
      foreach($type_ids as $type_id) {
        $data_type[] = array(
          'fk_i_section_id' => (int)$id,
          'fk_i_type_id' => (int)$type_id
        );
      }
    }

    ModelCAP::newInstance()->updateSection((int)$id, $locale, $data_section, $data_locale, $data_type);

    osc_add_flash_ok_message(__('Section successfully updated', 'car_attr_pro'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/section_edit.php&editId=' . $id);
    exit;
  }


  if(Params::getParam('deleteId') > 0) {
    $prop = ModelCAP::newInstance()->getSectionRow(Params::getParam('deleteId'));

    if(!in_array($prop['s_id'], $banned_ids)) {
      ModelCAP::newInstance()->deleteSection(Params::getParam('deleteId'));
      
      osc_add_flash_ok_message(__('Section successfully removed', 'car_attr_pro'), 'admin');
      header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/section.php');
      exit;
    } else {
      osc_add_flash_error_message(__('Section cannot be removed', 'car_attr_pro'), 'admin');
      header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/section.php');
      exit;
    }
  }

  $id = Params::getParam('editId');


  $sections = ModelCAP::newInstance()->getSections(false, -1, true);
  $section = isset($sections[$id]) ? $sections[$id] : array();
  
  $section_type_arr = isset($section['s_section_type']) ? explode(',', $section['s_section_type']) : array();
  
  $type_ids = ModelCAP::newInstance()->getSectionTypes($id);
  $type_ids = array_column($type_ids, 'fk_i_type_id');

  $types_all = ModelCAP::newInstance()->getTypes(false);
  
  
  $section_props_widget = array();
  $section_props_item = array();
  $section_props_publish = array();
  
  if($id > 0) {
    $section_props_widget = cap_get_section_properties('widget', $id, array(), true);
    $section_props_item = cap_get_section_properties('item', $id, array(), true);
    $section_props_publish = cap_get_section_properties('publish', $id, array(), true);
  }
?>


<div class="mb-body">
  <div class="mb-message-js"></div>

  <div class="mb-notes">
    <div class="mb-line"><?php _e('Sections aggregate properties in widget, item detail and publish page.', 'car_attr_pro'); ?></div>
    <div class="mb-line"><?php _e('Sections with no properties assigned will be hidden in front!', 'car_attr_pro'); ?></div>
  </div>
        
  <?php if(in_array(@$section['s_id'], $banned_ids)) { ?>
    <div class="mb-notes">
      <div class="mb-line"><?php _e('"Reserved" type of section - not all fields are editable and values are not specified here.', 'car_attr_pro'); ?></div>
    </div>
  <?php } ?>

  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-plus-circle"></i> <?php _e('Add/edit section', 'car_attr_pro'); ?>
      <?php echo cap_locale_box('section_edit.php&editId=' . $id); ?>
    </div>

    <div class="mb-inside mb-prop-edit">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>section_edit.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <input type="hidden" name="capLocale" value="<?php echo (@$section['fk_c_locale_code'] <> '' ? $section['fk_c_locale_code'] : $locale); ?>" />
        <input type="hidden" name="editId" value="<?php echo $id; ?>" />


        <div class="mb-row">
          <label for="s_id"><?php _e('Identifier', 'car_attr_pro'); ?></label>
          <input type="text" id="s_id" name="s_id" size="30" minlength="3" maxlength="50" pattern="^[a-z]{1}[a-z0-9\-]{2,49}$" value="<?php echo @$section['s_id']; ?>" <?php if(in_array(@$section['s_id'], $banned_ids)) { ?>disabled<?php } else { ?>required<?php } ?>/>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Identifier must start with LETTER and must be UNIQUE across all sections. Identifier is used in URL instead of ID. Not language relevant.', 'car_attr_pro'); ?></div>
            <div class="mb-line"><?php _e('Only letters: a-z (lowercase), 1-9, - (dash).', 'car_attr_pro'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="s_name"><?php _e('Name', 'car_attr_pro'); ?></label>
          <input type="text" id="s_name" name="s_name" size="30" value="<?php echo @$section['s_name']; ?>" required/>

          <div class="mb-explain"><?php _e('Short name of section.', 'car_attr_pro'); ?></div>
        </div>

        <div class="mb-row">
          <label for="s_description"><?php _e('Description', 'car_attr_pro'); ?></label>
          <input type="text" id="s_description" name="s_description" size="60" value="<?php echo @$section['s_description']; ?>"/>

          <div class="mb-explain"><?php _e('Description is shown as help text in widget section button.', 'car_attr_pro'); ?></div>
        </div>

        <div class="mb-row">
          <label for="s_text_search"><?php _e('Help Text (Search)', 'car_attr_pro'); ?></label>
          <input type="text" id="s_text_search" name="s_text_search" size="60" value="<?php echo @$section['s_text_search']; ?>"/>

          <div class="mb-explain"><?php _e('Section header in widget.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row mb-row-text-publish">
          <label for="s_text_publish"><?php _e('Help Text (Publish)', 'car_attr_pro'); ?></label>
          <input type="text" id="s_text_publish" name="s_text_publish" size="60" value="<?php echo @$section['s_text_publish']; ?>"/>

          <div class="mb-explain"><?php _e('Section header on publish page. Set to "-" to disable header.', 'car_attr_pro'); ?></div>
        </div>
       
        <div class="mb-row mb-row-text-item">
          <label for="s_text_item"><?php _e('Help Text (Item Detail)', 'car_attr_pro'); ?></label>
          <input type="text" id="s_text_item" name="s_text_item" size="60" value="<?php echo @$section['s_text_item']; ?>"/>

          <div class="mb-explain"><?php _e('Section header on item detail page. Set to "-" to disable header.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="s_icon"><?php _e('Icon', 'car_attr_pro'); ?></label>
          <textarea id="s_icon" name="s_icon"><?php echo @$section['s_icon']; ?></textarea>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Use SVG, Font-Awesome class or image URL.', 'car_attr_pro'); ?></div>
            <div class="mb-line"><?php _e('Icons are used only in widget.', 'car_attr_pro'); ?></div>
          </div>
        </div>
        
        
        <hr/>

        <div class="mb-row mb-row-select-multiple mb-row-vehicle-types">
          <label for="type_ids_multiple"><span><?php _e('Types', 'car_attr_pro'); ?></span></label> 

          <input type="hidden" name="type_ids" id="type_ids" value="<?php echo implode(',', $type_ids); ?>"/>
          <select id="type_ids_multiple" name="type_ids_multiple" multiple>
            
            <?php if(is_array($types_all) && count($types_all) > 0) { ?>
              <option value="0" <?php if(in_array(0, $type_ids)){ ?>selected="selected"<?php } ?>><?php _e('All types', 'car_attr_pro'); ?></option>
              
              <?php foreach($types_all as $type) { ?>
                <option value="<?php echo $type['pk_i_id']; ?>" <?php if(in_array($type['pk_i_id'], $type_ids)){ ?>selected="selected"<?php } ?>><?php echo cap_get_name($type); ?></option>
              <?php } ?>
            <?php } ?>
          </select>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Select one or more related types.', 'car_attr_pro'); ?></div>
          </div>
        </div>


        <div class="mb-row mb-row-select-multiple mb-row-section-types">
          <label for="s_section_type_multiple"><span><?php _e('Section Type', 'car_attr_pro'); ?></span></label> 

          <input type="hidden" name="s_section_type" id="s_section_type" value="<?php echo implode(',', $section_type_arr); ?>"/>
          <select id="s_section_type_multiple" name="s_section_type_multiple" multiple>
            <option value="widget" <?php if(in_array('widget', $section_type_arr)){ ?>selected="selected"<?php } ?>><?php _e('Widget section', 'car_attr_pro'); ?></option>
            <option value="item" <?php if(in_array('item', $section_type_arr)){ ?>selected="selected"<?php } ?>><?php _e('Item detail section', 'car_attr_pro'); ?></option>
            <option value="publish" <?php if(in_array('publish', $section_type_arr)){ ?>selected="selected"<?php } ?>><?php _e('Publish section', 'car_attr_pro'); ?></option>
          </select>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Select one or more types for this section. Based on selection, section will be visible on widget/publish/item page and in property settings.', 'car_attr_pro'); ?></div>
          </div>
        </div>
        
        <div class="mb-row mb-row-style">
          <label for="s_item_style"><span><?php _e('Properties Style on Item Page', 'car_attr_pro'); ?></span></label> 

          <select id="s_item_style" name="s_item_style">
            <option value="" <?php if(@$section['s_item_style'] == ''){ ?>selected="selected"<?php } ?>><?php _e('Unset', 'car_attr_pro'); ?></option>

            <?php foreach(cap_item_section_styles_list() as $stid => $stname) { ?>
              <option value="<?php echo $stid; ?>" <?php if(@$section['s_item_style'] == $stid){ ?>selected="selected"<?php } ?>><?php echo $stname; ?></option>
            <?php } ?>
          </select>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Select style that will be applied on properties shown in this section on item page (item detail).', 'car_attr_pro'); ?></div>
          </div>
        </div>


        <div class="mb-row mb-row-widget-style<?php if($id == 1 || @$section['s_id'] == 'main') { ?> mb-disabled<?php } ?>">
          <label for="s_widget_style"><span><?php _e('Widget Style', 'car_attr_pro'); ?></span></label> 

          <select id="s_widget_style" name="s_widget_style">
            <option value="BOX" <?php if(@$section['s_widget_style'] == 'BOX'){ ?>selected="selected"<?php } ?>><?php _e('Box', 'car_attr_pro'); ?></option>
            <option value="BUTTON" <?php if(@$section['s_widget_style'] == 'BUTTON' || @$section['s_widget_style'] == ''){ ?>selected="selected"<?php } ?>><?php _e('Button', 'car_attr_pro'); ?></option>
          </select>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Section style in widget. Box means that section properties are visible directly in widget. Button means that section properties are hidden under button.', 'car_attr_pro'); ?></div>
          </div>
        </div>


        <hr/>


        <div class="mb-row mb-row-enabled<?php if($id == 1 || @$section['s_id'] == 'main') { ?> mb-disabled<?php } ?>">
          <label for="b_enabled" class=""><span><?php _e('Enable', 'car_attr_pro'); ?></span></label> 
          <input name="b_enabled" id="b_enabled" type="checkbox" class="element-slide" <?php echo (@$section['b_enabled'] == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('Enable or disable section.', 'car_attr_pro'); ?></div>
        </div>


        <div class="mb-row mb-row-order<?php if(in_array(@$section['s_id'], $banned_ids)) { ?> mb-disabled<?php } ?>">
          <label for="i_order"><?php _e('Order', 'car_attr_pro'); ?></label>
          <input type="number" id="i_order" name="i_order" size="30" value="<?php echo (int)(@$section['i_order'] > 0 ? @$section['i_order'] : 9999); ?>" />

          <div class="mb-explain"><?php _e('Position of section. Number between 1-9999.', 'car_attr_pro'); ?></div>
        </div>


        <hr/>

        <div class="mb-notes">
          <div class="mb-line"><?php _e('Below section with list of linked properties is purely informational and assignment of properties to sections cannot be modified here.', 'car_attr_pro'); ?></div>
          <div class="mb-line"><?php _e('Properties those types assignment does not match to section assignment will be shown only in those types that intersect.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="s_id"><?php _e('Linked Properties (Widget)', 'car_attr_pro'); ?></label>
          <div class="mb-childs">
            <?php if(is_array($section_props_widget) && count($section_props_widget)) { ?>
              <?php foreach($section_props_widget as $key => $prop) { ?>
                <div class="mb-one-child">
                  <?php echo '#' . $prop['pk_i_id'] . ': ' . $prop['s_name'] . ', ' . sprintf(__('%d type(s)', 'car_attr_pro'), count($prop['types'])) . ' - ' . implode(', ', array_column($prop['types'], 's_name')); ?>
                  <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=car_attr_pro/admin/property_edit.php&editId=<?php echo $prop['pk_i_id']; ?>&capLocale=<?php echo cap_get_locale(); ?>" target="_blank"><?php _e('Edit', 'car_attr_pro'); ?></a>
                </div>
              <?php } ?>
            <?php } else { ?>
              <div class="mb-one-child" style="font-style:italic;"><?php _e('No linked properties', 'car_attr_pro'); ?></div>
            <?php } ?>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="s_id"><?php _e('Linked Properties (Item)', 'car_attr_pro'); ?></label>
          <div class="mb-childs">
            <?php if(is_array($section_props_item) && count($section_props_item)) { ?>
              <?php foreach($section_props_item as $key => $prop) { ?>
                <div class="mb-one-child">
                  <?php echo '#' . $prop['pk_i_id'] . ': ' . $prop['s_name'] . ', ' . sprintf(__('%d type(s)', 'car_attr_pro'), count($prop['types'])) . ' - ' . implode(', ', array_column($prop['types'], 's_name')); ?>
                  <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=car_attr_pro/admin/property_edit.php&editId=<?php echo $prop['pk_i_id']; ?>&capLocale=<?php echo cap_get_locale(); ?>" target="_blank"><?php _e('Edit', 'car_attr_pro'); ?></a>
                </div>
              <?php } ?>
            <?php } else { ?>
              <div class="mb-one-child" style="font-style:italic;"><?php _e('No linked properties', 'car_attr_pro'); ?></div>
            <?php } ?>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="s_id"><?php _e('Linked Properties (Publish)', 'car_attr_pro'); ?></label>
          <div class="mb-childs">
            <?php if(is_array($section_props_publish) && count($section_props_publish)) { ?>
              <?php foreach($section_props_publish as $key => $prop) { ?>
                <div class="mb-one-child">
                  <?php echo '#' . $prop['pk_i_id'] . ': ' . $prop['s_name'] . ', ' . sprintf(__('%d type(s)', 'car_attr_pro'), count($prop['types'])) . ' - ' . implode(', ', array_column($prop['types'], 's_name')); ?>
                  <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=car_attr_pro/admin/property_edit.php&editId=<?php echo $prop['pk_i_id']; ?>&capLocale=<?php echo cap_get_locale(); ?>" target="_blank"><?php _e('Edit', 'car_attr_pro'); ?></a>
                </div>
              <?php } ?>
            <?php } else { ?>
              <div class="mb-one-child" style="font-style:italic;"><?php _e('No linked properties', 'car_attr_pro'); ?></div>
            <?php } ?>
          </div>
        </div>

        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(!cap_is_demo()) { ?><button type="submit" class="mb-button"><?php _e('Save', 'car_attr_pro');?></button><?php } ?>
        </div>
      </form>
    </div>
  </div>
</div>

<style>
  .mb-box .mb-inside .mb-row.mb-disabled:hover:before {content:"<?php echo osc_esc_html(__('Setting not available for your combination!', 'car_attr_pro')); ?>";}
</style>

<script type="text/javascript">
  // RESTRICT CHARACTERS FOR S_ID INPUTS (identifier)
  $('body').on('keypress', 'input[name="s_id"]', function (event) {
    var regexStart = new RegExp("^[a-z]+$");
    var regex = new RegExp("^[a-z0-9\-]+$");
    var key = String.fromCharCode(!event.charCode ? event.which : event.charCode);
    
    if (!regex.test(key) || ($(this)[0].selectionStart == 0 && !regexStart.test(key))) {
      event.preventDefault();
      return false;
    }
  });

</script>


<?php echo cap_footer(); ?>