<?php
  // Create menu
  $title = __('Types', 'car_attr_pro');
  cap_menu($title);

  $locale = (Params::getParam('fk_c_locale_code') <> '' ? Params::getParam('fk_c_locale_code') : Params::getParam('capLocale'));
  $locale = ($locale <> '' ? $locale : cap_get_locale());
  
  $types = ModelCAP::newInstance()->getTypes(0);
?>


<div class="mb-body">
  <div class="mb-message-js"></div>


  <!-- TYPES SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-list"></i> <?php echo $title; ?>
      <?php echo cap_locale_box('type.php'); ?>
    </div>

    <div class="mb-inside">

      <div class="mb-row mb-notes">
        <div class="mb-line"><?php _e('List of types.', 'car_attr_pro'); ?></div>
      </div>

      <div class="mb-table mb-table-types" id="mb-types">
        <div class="mb-table-head">
          <div class="mb-col-1"><span>&nbsp;</span></div>
          <div class="mb-col-1"><span><?php _e('ID', 'car_attr_pro');?></span></div>
          <div class="mb-col-3 mb-align-left"><span><?php _e('Name', 'car_attr_pro');?></span></div>
          <div class="mb-col-7 mb-align-left"><span><?php _e('Description', 'car_attr_pro');?></span></div>
          <div class="mb-col-3 mb-align-left"><span><?php _e('Slug', 'car_attr_pro');?></span></div>
          <div class="mb-col-3 mb-align-left"><span><?php _e('Color', 'car_attr_pro');?></span></div>
          <div class="mb-col-2 mb-align-left"><span><?php _e('Enabled', 'car_attr_pro');?></span></div>
          <div class="mb-col-4"><span>&nbsp;</span></div>
        </div>

        <?php if(count($types) <= 0) { ?>
          <div class="mb-table-row mb-row-empty">
            <i class="fa fa-warning"></i><span><?php _e('No types has been found', 'car_attr_pro'); ?></span>
          </div>
        <?php } else { ?>
          <?php foreach($types as $t) { ?>
            <div class="mb-table-row" id="cap_<?php echo $t['pk_i_id']; ?>" data-id="<?php echo $t['pk_i_id']; ?>">
              <div class="mb-col-1 ccolor" <?php echo ($t['s_color'] <> '' ? 'style="border-left-color:' . $t['s_color'] . '"' : ''); ?>><i class="fa fa-arrows mb-has-tooltip move" title="<?php echo osc_esc_html(__('Reorder types', 'car_attr_pro')); ?>"></i></div>
              <div class="mb-col-1"><?php echo $t['pk_i_id']; ?></div>
              <div class="mb-col-3 mb-align-left"><?php echo ($t['s_name'] <> '' ? $t['s_name'] : __('Unnamed', 'car_attr_pro') . ' (' . cap_get_locale() . ')'); ?></div>
              <div class="mb-col-7 mb-align-left"><span class="mb-desc"><?php echo ($t['s_description'] <> '' ? $t['s_description'] : '-'); ?></span></div>
              <div class="mb-col-3 mb-align-left"><?php echo ($t['s_slug'] <> '' ? $t['s_slug'] : '-'); ?></div>
              <div class="mb-col-3 mb-align-left"><?php echo ($t['s_color'] <> '' ? $t['s_color'] : '-'); ?></div>
              <div class="mb-col-2 mb-align-left"><?php echo ($t['b_enabled'] == 1 ? __('Yes', 'car_attr_pro') : __('No', 'car_attr_pro')); ?></div>
              <div class="mb-col-4 mb-align-right">
                <?php if(!cap_is_demo()) { ?>
                  <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=car_attr_pro/admin/type_edit.php&editId=<?php echo $t['pk_i_id']; ?>&capLocale=<?php echo cap_get_locale(); ?>" class="mb-btn mb-button-white"><i class="fa fa-pencil"></i> <?php _e('Edit', 'car_attr_pro'); ?></a>
                  <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=car_attr_pro/admin/type_edit.php&deleteId=<?php echo $t['pk_i_id']; ?>&capLocale=<?php echo cap_get_locale(); ?>" class="mb-btn mb-button-red" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove this type? Action cannot be undone', 'car_attr_pro')); ?>')"><i class="fa fa-trash-o"></i></a>
                <?php } ?>
              </div>
            </div>
          <?php } ?>
        <?php } ?>
      </div>

      <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=car_attr_pro/admin/type_edit.php&editId=-1&capLocale=<?php echo cap_get_locale(); ?>" class="mb-add-button"><i class="fa fa-plus-circle"></i><?php _e('Add a new type', 'car_attr_pro'); ?></a>

      <div class="mb-row">&nbsp;</div>

    </div>
  </div>
</div>


<script type="text/javascript">
  var cap_position_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=cap_admin_update_types_position";

  var cap_message_ok = "<?php echo osc_esc_html(__('Success!', 'car_attr_pro')); ?>";
  var cap_message_wait = "<?php echo osc_esc_html(__('Updating, please wait...', 'car_attr_pro')); ?>";
  var cap_message_error = "<?php echo osc_esc_html(__('Error!', 'car_attr_pro')); ?>";


  $(document).ready(function(){
    var cap_list = '';

    $('#mb-types').sortable({
      axis: "y",
      forcePlaceholderSize: true,
      handle: '.move',
      helper: 'clone',
      items: '.mb-table-row',
      opacity: .8,
      placeholder: 'placeholder',
      revert: 100,
      tabSize: 5,
      tolerance: 'intersect',
      start: function(event, ui) {
        cap_list = $(this).sortable('serialize');
      },
      stop: function (event, ui) {
        var c_cap_list = $(this).sortable('serialize');

        cap_message(cap_message_wait, 'info');

        if(cap_list != c_cap_list) {
          $.ajax({
            url: cap_position_url,
            type: "GET",
            data: c_cap_list,
            success: function(response){
              //console.log(response);
              cap_message(cap_message_ok, 'ok');
            },
            error: function(response) {
              cap_message(cap_message_error, 'error');
              console.log(response);
            }
          });
        }
      }
    });

  });
</script>

<?php echo cap_footer(); ?>