<?php

  // Create menu
  $title = __('Edit type', 'car_attr_pro');
  cap_menu($title);

  $locale = (Params::getParam('fk_c_locale_code') <> '' ? Params::getParam('fk_c_locale_code') : Params::getParam('capLocale'));
  $locale = ($locale <> '' ? $locale : cap_get_locale());


  if((Params::getParam('editId') > 0 || Params::getParam('editId') == -1) && Params::getParam('plugin_action') == 'done') {
    $id = Params::getParam('editId');

    if($id == -1) {
      $id = ModelCAP::newInstance()->insertType(array('s_color' => '#0000FF', 'i_order' => 9999));
      Params::setParam('editId', $id);
    }

    $type = ModelCAP::newInstance()->getType($id);

    $data_type = array(
      //'pk_i_id' => $id,
      //'s_id' => Params::getParam('s_id'),
      's_color' => Params::getParam('s_color'),
      's_icon' => Params::getParam('s_icon', false, false),
      'i_order' => Params::getParam('i_order'),
      'b_enabled' => (Params::getParam('b_enabled') == 'on' ? 1 : 0)
    );

    $data_locale = array(
      'fk_i_type_id' => (int)$id,
      'fk_c_locale_code' => $locale,
      's_name' => Params::getParam('s_name'),
      's_description' => Params::getParam('s_description'),
      's_slug' => Params::getParam('s_slug')
    );

    $cat_ids = explode(',', Params::getParam('category_ids'));
    $data_category = array();
    
    if(is_array($cat_ids) && count($cat_ids) > 0) {
      foreach($cat_ids as $cat_id) {
        $data_category[] = array(
          'fk_i_type_id' => (int)$id,
          'fk_i_category_id' => (int)$cat_id
        );
      }
    }

    ModelCAP::newInstance()->updateType((int)$id, $locale, $data_type, $data_locale, $data_category);

    osc_add_flash_ok_message(__('Type successfully updated', 'car_attr_pro'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/type_edit.php&editId=' . $id);
    exit;
  }


  if(Params::getParam('deleteId') > 0) {
    ModelCAP::newInstance()->deleteType(Params::getParam('deleteId'));
    
    osc_add_flash_ok_message(__('Type successfully removed', 'car_attr_pro'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=car_attr_pro/admin/type.php');
    exit;
  }


  $id = Params::getParam('editId');
  $type = ModelCAP::newInstance()->getType($id);
  $category_ids = ModelCAP::newInstance()->getTypeCategories($id);
  $category_ids = array_column($category_ids, 'fk_i_category_id');

  $category_all = Category::newInstance()->listAll();
  
  $props = array();
  $sections = array();
  
  if($id > 0) {
    $props = ModelCAP::newInstance()->getProperties(false, $id);
    $sections = ModelCAP::newInstance()->getSections(false, $id);
  }
?>


<div class="mb-body">
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-plus-circle"></i> <?php _e('Add/edit type', 'car_attr_pro'); ?>
      <?php echo cap_locale_box('type_edit.php&editId=' . $id); ?>
    </div>

    <div class="mb-inside mb-type-edit">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>type_edit.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <input type="hidden" name="capLocale" value="<?php echo (@$type['fk_c_locale_code'] <> '' ? $type['fk_c_locale_code'] : $locale); ?>" />
        <input type="hidden" name="editId" value="<?php echo $id; ?>" />

        <div class="mb-row">
          <label for="s_name"><?php _e('Name', 'car_attr_pro'); ?></label>
          <input type="text" id="s_name" name="s_name" size="30" value="<?php echo @$type['s_name']; ?>" />

          <div class="mb-explain"><?php _e('Short name of type.', 'car_attr_pro'); ?></div>
        </div>

        <?php if(1==2) { ?>
        <div class="mb-row">
          <label for="s_id"><?php _e('Identifier', 'car_attr_pro'); ?></label>
          <input type="text" id="s_id" name="s_id" size="30" value="<?php echo @$type['s_id']; ?>" disabled/>

          <div class="mb-explain"><?php _e('Identifier for code reference. Cannot be changed.', 'car_attr_pro'); ?></div>
        </div>
        <?php } ?>
        
        <div class="mb-row">
          <label for="s_description"><?php _e('Description', 'car_attr_pro'); ?></label>
          <textarea id="s_description" name="s_description"><?php echo @$type['s_description']; ?></textarea>

          <div class="mb-explain"><?php _e('Description text of type used in search widget.', 'car_attr_pro'); ?></div>
        </div>

        <div class="mb-row">
          <label for="s_slug"><?php _e('Slug', 'car_attr_pro'); ?></label>
          <input type="text" id="s_slug" name="s_slug" size="30" value="<?php echo @$type['s_slug']; ?>" pattern="^[a-z]{1}[a-z0-9\-]{2,49}$" required/>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Identifier must start with LETTER and must be UNIQUE across all properties. Identifier is used in URL instead of ID. Not language relevant.', 'car_attr_pro'); ?></div>
            <div class="mb-line"><?php _e('Only letters: a-z (lowercase), 1-9, - (dash).', 'car_attr_pro'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="s_color"><?php _e('Color', 'car_attr_pro'); ?></label>
          <input type="color" id="s_color" name="s_color" value="<?php echo (@$type['s_color'] <> '' ? @$type['s_color'] : '#0000FF'); ?>" />

          <div class="mb-explain"><?php _e('Primary type color.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="s_icon"><?php _e('Icon', 'car_attr_pro'); ?></label>
          <textarea id="s_icon" name="s_icon"><?php echo @$type['s_icon']; ?></textarea>

          <div class="mb-explain"><?php _e('Use SVG, Font-Awesome class or image URL.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row mb-row-select-multiple">
          <label for="category_ids_multiple"><span><?php _e('Categories', 'car_attr_pro'); ?></span></label> 

          <input type="hidden" name="category_ids" id="category_ids" value="<?php echo implode(',', $category_ids); ?>"/>
          <select id="category_ids_multiple" name="type_category_ids_multiple" multiple>
            <?php echo cap_cat_list($category_ids, $category_all); ?>
          </select>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('If no category selected, type will not be visible on publish page under any category.', 'car_attr_pro'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="b_enabled" class=""><span><?php _e('Enable', 'car_attr_pro'); ?></span></label> 
          <input name="b_enabled" id="b_enabled" type="checkbox" class="element-slide" <?php echo (@$type['b_enabled'] == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('Enable or disable type.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="i_order"><?php _e('Order', 'car_attr_pro'); ?></label>
          <input type="number" id="i_order" name="i_order" size="30" value="<?php echo @$type['i_order']; ?>" />

          <div class="mb-explain"><?php _e('Position of type. Number between 1-9999.', 'car_attr_pro'); ?></div>
        </div>


        <hr/>

        <div class="mb-notes">
          <div class="mb-line"><?php _e('Below section with list of linked properties and sections is purely informational and assignment of properties to sections cannot be modified here.', 'car_attr_pro'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="s_id"><?php _e('Linked Sections', 'car_attr_pro'); ?></label>
          <div class="mb-childs">
            <?php if(is_array($sections) && count($sections)) { ?>
              <?php foreach($sections as $key => $section) { ?>
                <div class="mb-one-child">
                  <?php echo '#' . $section['pk_i_id'] . ': ' . $section['s_name'] . ', ' . sprintf(__('%d type(s)', 'car_attr_pro'), count($section['types'])) . ' - ' . implode(', ', array_column($section['types'], 's_name')); ?>
                  <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=car_attr_pro/admin/section_edit.php&editId=<?php echo $section['pk_i_id']; ?>&capLocale=<?php echo cap_get_locale(); ?>" target="_blank"><?php _e('Edit', 'car_attr_pro'); ?></a>
                </div>
              <?php } ?>
            <?php } else { ?>
              <div class="mb-one-child" style="font-style:italic;"><?php _e('No linked properties', 'car_attr_pro'); ?></div>
            <?php } ?>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="s_id"><?php _e('Linked Properties', 'car_attr_pro'); ?></label>
          <div class="mb-childs">
            <?php if(is_array($props) && count($props)) { ?>
              <?php foreach($props as $key => $prop) { ?>
                <div class="mb-one-child">
                  <?php echo '#' . $prop['pk_i_id'] . ': ' . $prop['s_name'] . ', ' . sprintf(__('%d type(s)', 'car_attr_pro'), count($prop['types'])) . ' - ' . implode(', ', array_column($prop['types'], 's_name')); ?>
                  <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=car_attr_pro/admin/property_edit.php&editId=<?php echo $prop['pk_i_id']; ?>&capLocale=<?php echo cap_get_locale(); ?>" target="_blank"><?php _e('Edit', 'car_attr_pro'); ?></a>
                </div>
              <?php } ?>
            <?php } else { ?>
              <div class="mb-one-child" style="font-style:italic;"><?php _e('No linked properties', 'car_attr_pro'); ?></div>
            <?php } ?>
          </div>
        </div>
        
        
        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(!cap_is_demo()) { ?><button type="submit" class="mb-button"><?php _e('Save', 'car_attr_pro');?></button><?php } ?>
        </div>
      </form>
    </div>
  </div>
</div>

<script type="text/javascript">
  // RESTRICT CHARACTERS FOR S_ID INPUTS (identifier)
  $('body').on('keypress', 'input[name="s_slug"]', function (event) {
    var regexStart = new RegExp("^[a-z]+$");
    var regex = new RegExp("^[a-z0-9\-]+$");
    var key = String.fromCharCode(!event.charCode ? event.which : event.charCode);
    
    if (!regex.test(key) || ($(this)[0].selectionStart == 0 && !regexStart.test(key))) {
      event.preventDefault();
      return false;
    }
  });
</script>

<?php echo cap_footer(); ?>