$(document).ready(function() {
  
  // INITIAL SETUP
  capManageScroll();
  capShowUsefulScrollButtons();

  $(window).on('resize', function(){
    capShowUsefulScrollButtons();
  });
  
  $('.cap-search').each(function() {
    $(this).find('.cap-section-body:not([data-id="' + $(this).find('.cap-section-top a.cap-active').attr('data-id') + '"])').find('input, select').prop('disabled', true);
  });
  

  // ADD UNIQUE CLASS TO SEARCH HOOK FORM
  $('.cap-search-hook').closest('form').addClass('cap-search-hook-form');


  // COPY ALL INPUTS FROM SEARCH HOOK TO FOOTER SEARCH BOX
  capSyncInputs();
  
  $('body').on('change', '.cap-search-hook-form input[type="hidden"], .cap-search-hook-form select, .cap-search-hook-form textarea', function(e) {
    capSyncInputs();
  });
  
  
  // CLOSE PROPERTIES MODAL IN SEARCH HOOK
  $('body').on('click', '.cap-search .cap-section-action a.cap-close', function(e) {
    e.preventDefault();
    capModalClose('', $(this));
  });
  
  
  // SHOW MORE PROPERTIES (MODAL) IN SEARCH HOOK
  $('body').on('click', 'a.cap-search-more-prop', function(e) {
    e.preventDefault();
    var height = 800;
    var closeBtn = false;
    
    if($('.cap-search-more-footer-holder').length) {
      var boxHtml = '<form action="' + capBaseUrl + '" method="GET" class="nocsrf">' + $('.cap-search-more-footer-holder').html() + '</form>';
    } else {
      var boxHtml = '<div class="cap-box-warn"><strong>ERROR</strong><div>Block ".cap-search-more-footer-holder" not found. Make sure you have osc_run_hook(\'footer\') in your theme footer.php and there are no PHP errors</div></div>';
      height = 400;
      closeBtn = true;
    }
    
    capModal({
      width: 800,
      height: height,
      fromUrl: false,
      //referenceSelector: $('.cap-search-more-footer-holder'),
      content: boxHtml, 
      wrapClass: 'cap-search-box',
      closeBtn: closeBtn, 
      iframe: false, 
      fullscreen: 'mobile',
      transition: 200,
      delay: 0,
      lockScroll: true
    });
  });
  
  
  // ON CHANGE VEHICLE TYPE IN SEARCH HOOK, RELOAD WHOLE CONTENT
  $('body').on('change', '.cap-search-hook .cap-input-box[data-id="type"] .cap-input-wrap input[type="hidden"]', function(e) {
    var elem = $(this);
    elem.closest('.cap-search-hook').addClass('cap-loading');
    var catId = parseInt(elem.closest('.cap-search-hook').attr('data-category-id'));
    
    $.ajax({
      type: 'GET',
      url: capBaseAjaxUrl + '&capGetSearchHook=1&' + capGetInputName('type') + '=' + $(this).val() + '&sCategory' + '=' + catId,
      success: function(response) {
        //console.log(response);
        elem.closest('.cap-search-hook').replaceWith(response);
        $('.cap-search-hook').next('fieldset#osc-database-logs').remove();

      },
      error: function(response){
        // There was some problem
        console.log(response);
        elem.closest('.cap-search-hook').removeClass('cap-loading');
      }
    });
  });
  
  
  // SHOW MORE VEHICLE TYPES
  $('body').on('click', '.cap-search .cap-section-top.cap-menu-advanced a.cap-special', function(e) {
    e.preventDefault();
    var currentText = $(this).find('div').text().trim();
    $(this).find('div').text($(this).attr('data-alt-text'));
    $(this).attr('data-alt-text', currentText);
    
    $(this).toggleClass('cap-opened');
    $(this).siblings('.cap-more-types').fadeToggle(100).css('display', 'flex').toggleClass('cap-opened');
  });
  
  
  // HIDE MORE VEHICLE TYPES BOX WHEN CLICK ON "STANDARD" TYPE
  $('body').on('click', '.cap-search .cap-section-top.cap-menu-advanced a:not(.cap-special)', function(e) {
    var btn = $(this);
    var elem = $(this).closest('.cap-section-top').find('a.cap-special');
    
    if(elem.hasClass('cap-opened')) {
      var currentText = elem.find('div').text().trim();
      elem.find('div').text(elem.attr('data-alt-text'));
      elem.attr('data-alt-text', currentText);
      
      elem.toggleClass('cap-opened');
      elem.siblings('.cap-more-types').fadeOut(100).removeClass('cap-opened');
      
        //$(this).closest('.cap-section-top').find('a').removeClass('cap-active');
        //elem.addClass('cap-active');
      if($(this).closest('.cap-more-types').length) {
        if(typeof jqueryVersion !== 'undefined' && jqueryVersion == '1') {
          elem.find('svg').html(btn.find('svg').html());
          elem.find('svg').get(0).setAttribute('viewBox', btn.find('svg').get(0).getAttribute('viewBox'));
        } else {
          elem.find('svg').html(btn.find('svg').html()).attr('viewBox', btn.find('svg').attr('viewBox'));
        }
      }
    }
  });

  
  
  // SHOW MORE FILTERS
  $('body').on('click', '.cap-search .cap-section-action a.cap-more', function(e) {
    if(!$(this).closest('.cap-search').hasClass('cap-complex')) {
      e.preventDefault();
      
      // Switch text
      var currentText = $(this).find('span').text().trim();
      $('.cap-search .cap-section-action a.cap-more').find('span').text($(this).attr('data-alt-text'));
      $('.cap-search .cap-section-action a.cap-more').attr('data-alt-text', currentText);
      
      // Simple view
      $('.cap-search.cap-simple .cap-search .cap-section-mid.cap-bot, .cap-search.cap-simple .cap-section-body .cap-subhead, .cap-search.cap-simple .cap-section-mid.cap-buttons, .cap-search.cap-simple .cap-section-body .cap-text, .cap-search.cap-simple .cap-section-mid.cap-bot').slideToggle(200);
      // Medium view
      $('.cap-search.cap-medium .cap-section-body .cap-subhead, .cap-search.cap-medium .cap-section-mid.cap-buttons').slideToggle(200);
    }
  });
  
  
  // SHOW VALUES LIST
  $('body').on('click', '.cap-input-wrap', function(e) {
    //e.preventDefault();
    if(!$(this).hasClass('cap-opened') && !$(this).closest('.cap-input-box').hasClass('cap-disabled')) {
      $('.cap-input-wrap.cap-opened').siblings('.cap-values-list').fadeOut(0);
      $('.cap-input-wrap.cap-opened, .cap-input-box.cap-opened').removeClass('cap-opened');

      if(!$(this).find('select').length) {
        $(this).addClass('cap-opened');
        $(this).closest('.cap-input-box').addClass('cap-opened');
        $(this).siblings('.cap-values-list').fadeIn(100);
        
        if(($(window).width() + capScrollCompensate()) >= 768) {
          $(this).find('input.cap-filter').focus();
        }
      }
    }
  });
  
  
  // CLOSE VALUES LIST
  $('body').on('click', '.cap-values-ok a.cap-values-ok-btn', function(e) {
    e.preventDefault();
    
    if($(this).closest('.cap-input-box').hasClass('cap-opened')) {
      $('.cap-input-wrap.cap-opened').siblings('.cap-values-list').fadeOut(100);
      $('.cap-input-wrap.cap-opened, .cap-input-box.cap-opened').removeClass('cap-opened');
    }
  });
  
  
  // HIDE VALUES LIST
  $(document).mouseup(function (e){
   var container = $('.cap-input-box.cap-opened');

    if(!container.is(e.target) && container.has(e.target).length === 0) {
      container.find('.cap-input-wrap.cap-opened').siblings('.cap-values-list').fadeOut(0);
      container.find('.cap-input-wrap.cap-opened, .cap-input-box.cap-opened').removeClass('cap-opened');
    }
  });
  
  
  // APPLY SELECTED PROPERTIES TO SEARCH BOX (copy HTML from modal to form)
  $('body').on('click', 'a.cap-details-apply', function(e) {
    e.preventDefault();
    
    var box = $(this).closest('.cap-details-box');
    var cntCheck = box.find('input[type="checkbox"]:checked').length;
    var cntInput = box.find('.cap-input-box:not(.cap-checkbox.cap-multi) input[type="hidden"]').filter(function() { return this.value.trim() != ''; }).length;
    var populatedCount = parseInt(cntCheck) + parseInt(cntInput);
    
    $('.cap-search .cap-details[data-section="' + box.attr('data-section') + '"]').html(box.clone());    // clone copies also "checked" and "value" that was changed
    $('.cap-search .cap-section-mid.cap-buttons > .cap-input-box a[data-section="' + box.attr('data-section') + '"] > em.cap-counter2').text(populatedCount).attr('data-count', populatedCount);

    capModalClose('', $(this));
  });
  

  // MAKE CHANGED, UPDATE MODELS
  //$('body').on('change', 'input[name="' + capGetInputName('make') + '"]', function(e) {
  $('body').on('change', '.cap-input-box[data-id="make"] .cap-input-wrap input[type="hidden"], .cap-input-box[data-id="make"] .cap-input-wrap select', function(e) {
    var elem = $(this);
    var id = elem.val();
    var type = $(this).closest('.cap-input-box').attr('data-type');
    var section = $(this).closest('.cap-input-box').attr('data-section');
    var isPublish = ($(this).closest('.cap-search').hasClass('cap-publish') ? 1 : 0);
    var itemId = $(this).closest('.cap-publish').attr('data-item-id');

    elem.closest('.cap-input-box').addClass('cap-loading');
    
    $.ajax({
      type: 'GET',
      url: capBaseAjaxUrl + '&capGetModels=1&' + capGetInputName('make') + '=' + id + '&' + capGetInputName('type') + '=' + type + '&capIsPublish=' + isPublish + '&capSection=' + section + '&itemId=' + itemId,
      success: function(response) {
        //console.log(response);
        
        elem.closest('.cap-input-box').siblings('.cap-input-box[data-id="model"]').replaceWith(response);
        elem.closest('.cap-input-box').siblings('.cap-input-box[data-id="model"]').next('fieldset#osc-database-logs').remove();
        elem.closest('.cap-input-box').removeClass('cap-loading');
      },
      error: function(response){
        // There was some problem
        console.log(response);
        elem.closest('.cap-input-box').removeClass('cap-loading');
      }
    });
  });
  
  
  // GET ITEM PUBLISH CAR TYPE SECTION
  $('body').on('click', '.cap-search.cap-publish .cap-section-top a:not(.cap-special)', function(e) {
    e.preventDefault();
    
    if($(this).hasClass('cap-active')) {
      return false;
    }
    
    var elem = $(this);
    var id = elem.attr('data-id');
    var type = $(this).closest('.cap-input-box').attr('data-type');
    var itemId = $(this).closest('.cap-publish').attr('data-item-id');
    
    elem.closest('.cap-publish').find('input[name="' + capGetInputName('type') + '"]').val(id);
    elem.addClass('cap-loading');
    elem.closest('.cap-section-top').siblings('.cap-type-wrap').addClass('cap-loading');
    
    $.ajax({
      type: 'GET',
      url: capBaseAjaxUrl + '&capGetItemPublishTypeSection=1&' + capGetInputName('type') + '=' + id + '&itemId=' + itemId,
      success: function(response) {
        //console.log(response);
        
        elem.closest('.cap-section-top').siblings('.cap-type-wrap').replaceWith(response);
        elem.closest('.cap-section-top').siblings('.cap-type-wrap').next('fieldset#osc-database-logs').remove();
        elem.removeClass('cap-loading');
      },
      error: function(response){
        // There was some problem
        console.log(response);
        elem.closest('.cap-section-top').siblings('.cap-type-wrap').removeClass('cap-loading');
        elem.removeClass('cap-loading');
      }
    });
  });
  
  
  
  // CLEAR PROPERTIES
  $('body').on('click', 'a.cap-details-clear', function(e) {
    e.preventDefault();
    $(this).closest('.cap-details-box').find('.cap-details-values').find('input[type="checkbox"]').prop('checked', false).change();
    $(this).closest('.cap-details-box').find('.cap-details-values').find('input[type="text"], input[type="number"], select, input[type="hidden"]').val('').change();
    $(this).closest('.cap-details-box').find('.cap-details-values').find('select option:selected').prop('selected', false).change();
  });
  
  
  // OPEN EXTRA PROPERTIES/ATTRIBUTES IN SEARCH WIDGET
  $('body').on('click', '.cap-search .cap-section-mid.cap-buttons > .cap-input-box a', function(e) {
    e.preventDefault();
    
    capModal({
      width: 800,
      height: 800,
      fromUrl: false,
      referenceSelector: $(this).closest('.cap-input-box').find('.cap-details'),
      content: '', 
      wrapClass: 'cap-detail-box',
      closeBtn: true, 
      iframe: false, 
      fullscreen: 'mobile',
      transition: 200,
      delay: 0,
      lockScroll: true
    });
    
  });
  
  
  // CLOSE MODAL WHEN CLICK ON COVER
  $('body').on('click', '.cap-modal-cover', function(e) {
    e.preventDefault();
    capModalClose('', $(this).parent().find('.modal-box').find('div'));
  });
  
  
  // SWITCH SEARCH BOX NAVIGATION TYPE
  $('body').on('click', '.cap-search .cap-section-top a:not(.cap-special)', function(e) {
    e.preventDefault();
    var id = $(this).attr('data-id');

    $(this).closest('.cap-section-top').find('a').removeClass('cap-active');
    $(this).addClass('cap-active');
    
    $(this).closest('.cap-search').find('.cap-section-body').removeClass('cap-active');
    $(this).closest('.cap-search').find('.cap-section-body[data-id="' + id + '"]').addClass('cap-active');
    
    $(this).closest('.cap-search').find('.cap-section-body').find('input, select').prop('disabled', true).closest('.cap-input-box').addClass('cap-disabled');
    $(this).closest('.cap-search').find('.cap-section-body[data-id="' + id + '"]').find('input, select').prop('disabled', false).closest('.cap-input-box:not([data-id="model"])').removeClass('cap-disabled');
    
    // Handle model
    if($(this).closest('.cap-search').find('.cap-section-body[data-id="' + id + '"]').find('.cap-input-box[data-id="model"] input[type="hidden"]').val() != '') {
      $(this).closest('.cap-search').find('.cap-section-body[data-id="' + id + '"]').find('.cap-input-box[data-id="model"]').removeClass('cap-disabled');
    }


    // Check if this is from sub-section
    if($(this).closest('.cap-more-types').length) {
      $(this).closest('.cap-section-top').find('a.cap-special').addClass('cap-active');
    }
  });
  
  
  // CLOSE MORE TYPES ON CLICK OUTSIDE
  $(document).mouseup(function(e){
    var container = $('.cap-more-types.cap-opened');
    var elem = container.siblings('.cap-special');
    
    if(!$(e.target).hasClass('cap-special') && !$(e.target).closest('.cap-special').length) {
      if(!container.is(e.target) && container.has(e.target).length === 0 && elem.hasClass('cap-opened')) {
        container.removeClass('cap-opened').fadeOut(0);
        elem.removeClass('cap-opened');

        var currentText = elem.find('div').text().trim();
        elem.find('div').text(elem.attr('data-alt-text'));
        elem.attr('data-alt-text', currentText);
      }
    }
  });
  

  // SELECT SINGLE OPTION
  $('body').on('click', '.cap-values-list .cap-value', function(e) {
    //e.preventDefault();
    var multi = $(this).closest('.cap-input-box').hasClass('cap-multi');
    var range = false;
    var loc = false;
    
    if($(this).hasClass('cap-disabled')) {
      return false;
    }
    
    if($(this).closest('.cap-input-box').attr('data-range') == 'from' || $(this).closest('.cap-input-box').attr('data-range') == 'to') {
      range = true;
    }
    
    if($(this).closest('.cap-input-box').attr('data-id') == 'location') {
      loc = true;
    }
    
    // Deselect options
    if($(this).hasClass('cap-deselect')) {
      if(multi == false) {
        $(this).closest('.cap-input-box').find('.cap-input-wrap input[type="hidden"]').val('');
        $(this).closest('.cap-input-box').find('.cap-input-wrap input[type="text"].cap-display').val('');
        $(this).parent().find('.cap-value').removeClass('cap-active');
      } else {
        $(this).closest('.cap-input-box').find('.cap-values-wrap .cap-value input[type="checkbox"]').prop('checked', false).last().change();
      }
      
    } else if(multi == false) {
      // Option is already active, deselect
      if($(this).hasClass('cap-active')) {
        if(loc == false) {
          $(this).closest('.cap-input-box').find('.cap-input-wrap input[type="hidden"]').val('').change();
        }
        
        $(this).closest('.cap-input-box').find('.cap-input-wrap input[type="text"].cap-display').val('');
        $(this).removeClass('cap-active');

        // Location - update sCountry, sRegion and sCity
        if(loc) {
          $(this).closest('.cap-input-box').find('input[name="sCountry"], input[name="sRegion"], input[name="sCity"]').val('');
        }
        
      // Select option
      } else {
        if(loc == false) {
          $(this).closest('.cap-input-box').find('.cap-input-wrap input[type="hidden"]').val($(this).attr('data-id')).change();
        }
        
        $(this).closest('.cap-input-box').find('.cap-input-wrap input[type="text"].cap-display').val($(this).text().replace(/\s\s+/g, ' ').replace(/\·/g, ' ').trim());
        
        $(this).parent().find('.cap-value').removeClass('cap-active');
        $(this).addClass('cap-active');

        // Location - update sCountry, sRegion and sCity
        if(loc) {
          $(this).closest('.cap-input-box').find('input[name="sCountry"]').val($(this).attr('data-country'));
          $(this).closest('.cap-input-box').find('input[name="sRegion"]').val($(this).attr('data-region'));
          $(this).closest('.cap-input-box').find('input[name="sCity"]').val($(this).attr('data-city'));
        }

        // Deselect range counter part if from > to or to < from
        if(range) {
          var rangeType = $(this).closest('.cap-input-box').attr('data-range');
          var valOne = parseFloat($(this).text().replace(/\s\s+/g, ' ').replace(/\·/g, ' ').trim());

          if(rangeType == 'from') {
            var valTwo = $(this).closest('.cap-input-box').siblings('.cap-input-box[data-range="to"]').find('.cap-input-wrap input[type="hidden"]').val();
          } else {
            var valTwo = $(this).closest('.cap-input-box').siblings('.cap-input-box[data-range="from"]').find('.cap-input-wrap input[type="hidden"]').val();
          }
          
          valTwo = parseFloat(valTwo);
          
          // Check if From/To values does not make sense after selection, if yes, remove them
          if(rangeType == 'from' && valTwo < valOne) {
            $(this).closest('.cap-input-box').siblings('.cap-input-box[data-range="to"]').find('.cap-input-wrap input').val('');
            $(this).closest('.cap-input-box').siblings('.cap-input-box[data-range="to"]').find('.cap-value').removeClass('cap-active');
          } else if(rangeType == 'to' && valTwo > valOne) {
            $(this).closest('.cap-input-box').siblings('.cap-input-box[data-range="from"]').find('.cap-input-wrap input').val('');
            $(this).closest('.cap-input-box').siblings('.cap-input-box[data-range="from"]').find('.cap-value').removeClass('cap-active');
          }
        }
        
        // Close box after selecting value
        if(capCloseAfterSelectFx()) {
          if($(this).closest('.cap-input-box').hasClass('cap-opened')) {
            $('.cap-input-wrap.cap-opened').siblings('.cap-values-list').fadeOut(100);
            $('.cap-input-wrap.cap-opened, .cap-input-box.cap-opened').removeClass('cap-opened');
          }
        }
      }
    }
  });


  // RANGE FOR SELECT & INPUT BOX
  // Can be input text/number or select
  $('body').on('change', '.cap-input-box.cap-range .cap-input', function(e) {
    if($(this).closest('.cap-input-box').attr('data-range') == 'from' || $(this).closest('.cap-input-box').attr('data-range') == 'to') {
      var rangeType = $(this).closest('.cap-input-box').attr('data-range');
      var valOne = parseFloat($(this).val());

      if(rangeType == 'from') {
        var valTwo = $(this).closest('.cap-input-box').siblings('.cap-input-box[data-range="to"]').find('.cap-input').val();
      } else {
        var valTwo = $(this).closest('.cap-input-box').siblings('.cap-input-box[data-range="from"]').find('.cap-input').val();
      }
      
      valTwo = parseFloat(valTwo);
      console.log(valOne);
      console.log(valTwo);
      // Check if From/To values does not make sense after selection, if yes, remove them
      if(rangeType == 'from' && valTwo < valOne) {
        $(this).closest('.cap-input-box').siblings('.cap-input-box[data-range="to"]').find('.cap-input').val('');
      } else if(rangeType == 'to' && valTwo > valOne) {
        $(this).closest('.cap-input-box').siblings('.cap-input-box[data-range="from"]').find('.cap-input').val('');
      }
    }
  });
  

  // SELECT MULTI OPTION
  $('body').on('change', '.cap-values-list .cap-value input[type="checkbox"]', function(e) {
    //e.preventDefault();
    
    if($(this).closest('.cap-value').hasClass('cap-disabled')) {
      return false;
    }
    
    var multi = $(this).closest('.cap-input-box').hasClass('cap-multi');
    
    if(multi == true) {
      var selectedVals = [];
      
      $(this).closest('.cap-input-box').find('.cap-values-wrap .cap-value input[type="checkbox"]:checked').each(function() {
        selectedVals.push($(this).val());
      });

      $(this).closest('.cap-input-box').find('.cap-input-wrap input[type="hidden"]').val(selectedVals.join(' ')).change();  // '+'


      // Update counter, input and text
      var displayText = $(this).closest('.cap-input-box').find('.cap-values-wrap .cap-value input[type="checkbox"]:checked:first + span').text().replace(/\s\s+/g, ' ').replace(/\·/g, ' ').trim();
      $(this).closest('.cap-input-box').find('.cap-input-wrap input[type="text"].cap-display').val(displayText);
      $(this).closest('.cap-input-box').find('.cap-counter').attr('data-count', selectedVals.length).text(selectedVals.length - 1);
    }
  });
  
  

  // CHECKBOX MULTI OPTION
  $('body').on('change', '.cap-input-box.cap-checkbox.cap-multi .cap-label input[type="checkbox"]', function(e) {
    //e.preventDefault();
    var box = $(this).closest('.cap-input-box.cap-checkbox.cap-multi');
    
    if($(this).closest('.cap-label').hasClass('cap-disabled') || $(this).is(':disabled')) {
      return false;
    }
    
    var selectedVals = [];
    
    box.find('.cap-label input[type="checkbox"]:checked').each(function() {
      selectedVals.push($(this).val());
    });

    box.find('> input[type="hidden"]').val(selectedVals.join(' ')).change();  // '+'
  });
  
  
  // SELECT ALL OPTION
  $('body').on('click', '.cap-values-list .cap-value.cap-select-all', function(e) {
    $(this).closest('.cap-input-box').find('.cap-values-wrap .cap-value:not(.hide) input[type="checkbox"]').prop('checked', true).last().change();

    // Close box
    if($(this).closest('.cap-input-box').hasClass('cap-opened')) {
      window.setTimeout(function(){
        $('.cap-input-wrap.cap-opened').siblings('.cap-values-list').fadeOut(300);
        $('.cap-input-wrap.cap-opened, .cap-input-box.cap-opened').removeClass('cap-opened');
      }, 200);
    }
  });

  
  // CLEAR INPUT
  $('body').on('click', 'svg.cap-clear', function(e) {
    e.preventDefault();
    $(this).siblings('input[type="text"]').val('').change();
  });
  
  
  // FILTER INPUT VALUES OPTIONS
  $('body').on('keyup change', '.cap-input-wrap input[type="text"].cap-filter', function(e) {
    //e.preventDefault();
    
    var term = ($(this).val()).trim();
    
    // For integer values, copy value to readonly & hidden
    if($(this).closest('.cap-input-box').attr('data-db-type') == 'integer') {
      $(this).siblings('input[type="hidden"], input.cap-display').val(term);
    }
    
    term = term.normalize("NFD").replace(/[\u0300-\u036f]/g, "");   // convert special chars to standard

    var elems = $(this).closest('.cap-input-box').find('.cap-values-list').find('.cap-value:not(.cap-deselect):not(.cap-select-all)');
    if (term == '') {
      elems.removeClass('hide');
      $(this).closest('.cap-input-box').find('.cap-values-list .cap-top-section-end').show(0);

    } else {
      $(this).closest('.cap-input-box').find('.cap-values-list .cap-top-section-end').hide(0);
      
      var hidden = elems.filter(function() {
        var reg = new RegExp(term, "i");
        return !reg.test(($(this).text()).normalize("NFD").replace(/[\u0300-\u036f]/g, ""))
      });
      var visible = elems.filter(function() {
        var reg = new RegExp(term, "i");
        return reg.test(($(this).text()).normalize("NFD").replace(/[\u0300-\u036f]/g, ""))
      });
      hidden.addClass('hide');
      visible.removeClass('hide')
    }
  });
  

  // FILTER PROPERTIES
  $('body').on('keyup change', '.cap-detail-footer .cap-box-filter input[type="text"]', function(e) {
    //e.preventDefault();
    
    var term = ($(this).val()).trim();
    term = term.normalize("NFD").replace(/[\u0300-\u036f]/g, "");   // convert special chars to standard

    var elems = $(this).closest('.cap-details-box').find('.cap-details-values').find('.cap-label, .cap-line');
    if (term == '') {
      elems.removeClass('fade')
    } else {
      var hidden = elems.filter(function() {
        var reg = new RegExp(term, "i");
        return !reg.test(($(this).text()).normalize("NFD").replace(/[\u0300-\u036f]/g, ""))
      });
      var visible = elems.filter(function() {
        var reg = new RegExp(term, "i");
        return reg.test(($(this).text()).normalize("NFD").replace(/[\u0300-\u036f]/g, ""))
      });
      hidden.addClass('fade');
      visible.removeClass('fade')
    }
  });
  
  
  // NICE SCROLL - ACTION BUTTONS
  $('body').on('click', '.cap-nice-scroll-next, .cap-nice-scroll-prev', function(e) {
    e.preventDefault();
    
    if($(this).hasClass('scrolling')) {
      return false;
    }
    
    var scrollCards = 3;
    var btn = $(this);
    var elem = btn.siblings('.cap-nice-scroll');
    var pos = elem.scrollLeft();
    var lenOne = elem.find(' > *').outerWidth() + parseFloat((elem.find(' > *').css('margin-left')).replace('px', '')) +  + parseFloat((elem.find(' > *').css('margin-right')).replace('px', ''));

    $(this).addClass('scrolling');
    
    ($(window).width() - 10 < scrollCards*lenOne ? scrollCards = 2 : '');
    ($(window).width() - 10 < scrollCards*lenOne ? scrollCards = 1 : '');
  
    var len = lenOne*scrollCards;
    
    if($(this).hasClass('cap-nice-scroll-prev')) {
      len = -len;
    }
    
    elem.stop(false,false).animate({scrollLeft: pos + len}, 100 + scrollCards*60, function() {
      btn.removeClass('scrolling');
    });
  });
});




// CUSTOM MODAL BOX
function capModal(opt) {
  width = (typeof opt.width !== 'undefined' ? opt.width : 480);
  height = (typeof opt.height !== 'undefined' ? opt.height : 480);
  content = (typeof opt.content !== 'undefined' ? opt.content : '');
  referenceSelector = (typeof opt.referenceSelector !== 'undefined' ? opt.referenceSelector : '');
  wrapClass = (typeof opt.wrapClass !== 'undefined' ? ' ' + opt.wrapClass : '');
  closeBtn = (typeof opt.closeBtn !== 'undefined' ? opt.closeBtn : true);
  iframe = (typeof opt.iframe !== 'undefined' ? opt.iframe : true); 
  fromUrl = (typeof opt.fromUrl !== 'undefined' ? opt.fromUrl : false); 
  fullscreen = (typeof opt.fullscreen !== 'undefined' ? opt.fullscreen : false); 
  transition = (typeof opt.transition !== 'undefined' ? opt.transition : 200); 
  delay = (typeof opt.delay !== 'undefined' ? opt.delay : 0);
  lockScroll = (typeof opt.lockScroll !== 'undefined' ? opt.lockScroll : true); 

  var id = Math.floor(Math.random() * 100) + 10;
  width = capAdjustModalSize(width, 'width') + 'px';
  height = capAdjustModalSize(height, 'height') + 'px';

  var fullscreenClass = '';
  if(fullscreen === 'mobile') {
    if (($(window).width() + capScrollCompensate()) < 768) {
      width = 'auto'; height = 'auto'; fullscreenClass = ' modal-fullscreen';
    }
  } else if (fullscreen === true) {
    width = 'auto'; height = 'auto'; fullscreenClass = ' modal-fullscreen';
  }

  var html = '';
  html += '<div class="modal-cover cap-modal-cover" data-modal-id="' + id + '"></div>';
  html += '<div id="capModal" class="modal-box' + wrapClass + fullscreenClass + '" style="width:' + width + ';height:' + height + ';" data-modal-id="' + id + '">';
  html += '<div class="modal-inside">';
  
  if(closeBtn) {
    html += '<div class="modal-close" onclick="capModalClose(\'' + id + '\');">';
    html += '<svg viewBox="0 0 352 512" width="18" height="18"><path fill="currentColor" d="M242.72 256l100.07-100.07c12.28-12.28 12.28-32.19 0-44.48l-22.24-22.24c-12.28-12.28-32.19-12.28-44.48 0L176 189.28 75.93 89.21c-12.28-12.28-32.19-12.28-44.48 0L9.21 111.45c-12.28 12.28-12.28 32.19 0 44.48L109.28 256 9.21 356.07c-12.28 12.28-12.28 32.19 0 44.48l22.24 22.24c12.28 12.28 32.2 12.28 44.48 0L176 322.72l100.07 100.07c12.28 12.28 32.2 12.28 44.48 0l22.24-22.24c12.28-12.28 12.28-32.19 0-44.48L242.72 256z"></path></svg>';
    html += '</div>';
  }
    
  html += '<div class="modal-body ' + (iframe === true ? 'modal-is-iframe' : 'modal-is-inline') + '">';
  
  if(iframe === true) {
    html += '<div class="modal-content"><iframe class="modal-iframe" data-modal-id="' + id + '" src="' + content + '"/></div>';
  } else if(fromUrl === true) {
    html += '<div class="modal-content"><div class="modal-loader"></div></div>';
  } else if(referenceSelector !== '') {
    html += '<div class="modal-content"></div>';    // HTML is loaded after
  } else {
    html += '<div class="modal-content">' + content + '</div>';
  }
  
  html += '</div>';
  html += '</div>';
  html += '</div>';
  
  if(lockScroll) {
    $('body').css('overflow', 'hidden');
  }
  
  $('body').append(html);
  
  // Clone referenced object
  if(referenceSelector !== '') { 
    $('.modal-box[data-modal-id="' + id + '"] .modal-content').html(referenceSelector.clone());
  }
  
  $('div[data-modal-id="' + id + '"].modal-cover').fadeIn(transition);
  $('div[data-modal-id="' + id + '"].modal-box').delay(delay).fadeIn(transition);
  
  if(fromUrl === true) {
    $.ajax({
      url: content,
      type: "GET",
      success: function(response){
        $('.modal-box[data-modal-id="' + id + '"] .modal-content').html(response);
      },
      error: function(response){
        $('.modal-box[data-modal-id="' + id + '"] .modal-content').html(response);
      }
    });
  }
}


// Close modal by clicking on close button
function capModalClose(id = '', elem = null) {
  if(id == '') {
    id = $(elem).closest('.modal-box').attr('data-modal-id');
  }
  
  $('body').css('overflow', 'initial');
  $('div[data-modal-id="' + id + '"]').fadeOut(200, function(e) {
    $(this).remove(); 
  });
  
  return false;
}


// Close modal by some action inside iframe
function capModalCloseParent() {
  var boxId = $(window.frameElement, window.parent.document).attr('data-modal-id');
  window.parent.capModalClose(boxId);
}


// Calculate maximum width/height of modal in case original width/height is larger than window width/height
function capAdjustModalSize(size, type = 'width') {
  var size = parseInt(size);
  var windowSize = (type == 'width' ? $(window).width() : $(window).height());
  
  if(size <= 0) {
    size = (type == 'width' ? 640 : 480);  
  }
  
  if(size*0.9 > windowSize) {
    size = windowSize*0.9;
  }
  
  return Math.floor(size);
}


// Sync inputs between search hook and search box (show more)
function capSyncInputs() {
  if($('.cap-search-hook').length && $('.cap-search-more-footer-holder').length) {
    var capSyncTimeoutMs = 0;
    var form = $('.cap-search-hook').closest('form');
    var box = $('.cap-search-more-footer-holder');
    var boxPlaceholder = box.find('input[name="capDummyPlaceholder"]');

    console.log('[CAP] Syncing inputs');

    $(form).find('input:not(:disabled), select:not(:disabled), textarea:not(:disabled)').each(function() {
      var inp = $(this);
      var inpVal = $(this).val();
      var inpName = inp.attr('name');
      var inpHtml = '<input type="hidden" name="' + inpName + '" value="' + inpVal + '"/>';
      var inpCheck = false;
      
      // if(inp.is('input') && ['checkbox','radio','text','number','tel','url','hidden'].indexOf(inp.attr('type')) < 0) {
        // return true; // continue
      // }
      
      if(typeof inpName !== 'undefined' && inpName.substring(0,4) == capGetInputName('')) {
        //console.log(inpName);

        var trgtInp = box.find('.cap-section-body.cap-active').find('[name="' + inpName +'"]');
        
        // After "make" update, delay everything by 500ms. To make it correct, everything after "make" must be delayed.
        // capSyncTimeoutMs += (inpName == capGetInputName('make') ? 100 : 0);
        capSyncTimeoutMs += (inpName == capGetInputName('model') ? 500 : 0);
  
        window.setTimeout(function(){
          
          if(inpName == capGetInputName('type')) {
            box.find('.cap-section-top a[data-id="' + inpVal +'"], .cap-section-top a[data-sid="' + inpVal +'"]').click();
            
          } else {
            trgtInp.val(inpVal);

            // Reload makes if they changed
            if(inpName == capGetInputName('make') && trgtInp.val() != inpVal) {
              trgtInp.change();
            }
            
            // Is custom select box, update selected values, display & filter inputs
            if(trgtInp.siblings('.cap-display').length) {
              trgtInp.siblings('.cap-display').attr('value', inp.siblings('.cap-display').val());
              trgtInp.siblings('.cap-filter').attr('value', inp.siblings('.cap-filter').val());
              trgtInp.siblings('.cap-counter').attr('data-count', inp.siblings('.cap-counter').attr('data-count')).text(inp.siblings('.cap-counter').attr('data-count')-1);
              
              trgtInp.parent().siblings('.cap-values-list').find('.cap-values-wrap .cap-value').removeClass('cap-active');
              trgtInp.parent().siblings('.cap-values-list').find('.cap-values-wrap .cap-label input[type="checkbox"]').attr('checked', false);

              // Single value
              inp.parent().siblings('.cap-values-list').find('.cap-values-wrap .cap-value').each(function() {
                var lab = $(this);

                if(lab.hasClass('cap-active')) {
                  trgtInp.parent().siblings('.cap-values-list').find('.cap-value[data-id="' + lab.attr('data-id') + '"]').addClass('cap-active');
                }
              });

              // Multi value
              inp.parent().siblings('.cap-values-list').find('.cap-values-wrap .cap-label input[type="checkbox"]').each(function() {
                var ilab = $(this);

                if(ilab.is(':checked')) {
                  trgtInp.parent().siblings('.cap-values-list').find('.cap-values-wrap .cap-label input[type="checkbox"][value="' + ilab.val() + '"]').attr('checked', true);
                }
              });
              
              // Resolve Model disabled
              if(trgtInp.closest('.cap-section-body').find('.cap-input-box[data-id="make"] .cap-input-wrap input[type="hidden"]').val() != '') {
                trgtInp.closest('.cap-section-body').find('.cap-input-box[data-id="model"]').removeClass('cap-disabled');
              } else {
                trgtInp.closest('.cap-section-body').find('.cap-input-box[data-id="model"]').addClass('cap-disabled');
              }
            }
          }
        }, capSyncTimeoutMs);
        
      } else {
        
        if(inp.is('input') && ['checkbox','radio'].indexOf(inp.attr('type')) >= 0) {
          inpCheck = true;
        }
        
        if(inpVal != '' && typeof inpName !== "undefined" && inpName != 'iPage') {
          var trgtInp = box.find('[name="' + inpName + '"]:not(:disabled)');

          if(trgtInp.length) {      // exists already
            if(inpCheck && !inp.is(':checked')) {
              if(trgtInp.val() != '') {
                console.log('[CAP] Updating "' + inpName + '", old value: "' + trgtInp.val() + '", new value: ""');
                trgtInp.val('');
              }
              
            } else if(trgtInp.val() != inpVal){
              console.log('[CAP] Updating "' + inpName + '", old value: "' + trgtInp.val() + '", new value: "' + inpVal + '"');
              trgtInp.val(inpVal);
            }
            
          } else {
            if(inpCheck && inp.is(':checked') || !inpCheck) {
              console.log('[CAP] Creating "' + inpName + '", value: "' + inpVal + '"');
              $(inpHtml).insertAfter(boxPlaceholder).addClass('cap-sync-generated');
            }
          }
        }
      }
    });
  }
}


// Generate correct input name from ID
function capGetInputName(id) {
  if(typeof capParamPrefix === 'undefined') {
    var prefix = capParamPrefix;
  } else {
    var prefix = 'cap';
  }
  
  id = id.replace('_', '-');
  id = prefix + '-' + id;
  
  return id;
}


// Check if select box should be closed after selection
function capCloseAfterSelectFx() {
  if(typeof capCloseAfterSelect === 'undefined') {
    var close = false;
  } else {
    var close = (capCloseAfterSelect == 1 ? true : false);
  }
  
  return close;
}


function capIsRtlFx() {
  if(typeof capIsRtl === 'undefined') {
    return false;
  }

  return (capIsRtl == true ? true : false);
}

// CALCULATE SCROLL WIDTH
function capScrollCompensate() {
  var inner = document.createElement('p');
  inner.style.width = "100%";
  inner.style.height = "200px";

  var outer = document.createElement('div');
  outer.style.position = "absolute";
  outer.style.top = "0px";
  outer.style.left = "0px";
  outer.style.visibility = "hidden";
  outer.style.width = "200px";
  outer.style.height = "150px";
  outer.style.overflow = "hidden";
  outer.appendChild(inner);

  document.body.appendChild(outer);
  var w1 = inner.offsetWidth;
  outer.style.overflow = 'scroll';
  var w2 = inner.offsetWidth;
  if (w1 == w2) w2 = outer.clientWidth;

  document.body.removeChild(outer);

  return (w1 - w2);
}


// SHOW/HIDE SCROLL BUTTONS BASED ON SCROLLING
function capManageScroll() {
  // NICE SCROLL - MANAGE FADERS
  $('.cap-nice-scroll').on('scroll', function(e) {
    var box = $(this);
    var scrollLeft = (capIsRtlFx() ? -1 : 1) * box.scrollLeft();
    var padding = parseFloat((box.css('padding-left')).replace('px', '')) + parseFloat((box.css('padding-right')).replace('px', ''));
    var maxScroll = box.prop('scrollWidth') - scrollLeft - box.width() - padding;
    var prev = box.siblings('.cap-nice-scroll-prev');
    var next = box.siblings('.cap-nice-scroll-next');

    if (scrollLeft < 20) {
      (capIsRtlFx() ? next.addClass('cap-disabled') : prev.addClass('cap-disabled'));
    } else {
      (capIsRtlFx() ? next.removeClass('cap-disabled').fadeIn(100) : prev.removeClass('cap-disabled').fadeIn(100));
    }

    if (maxScroll < 20) {
      (capIsRtlFx() ? prev.addClass('cap-disabled') : next.addClass('cap-disabled'));
    } else {
      (capIsRtlFx() ? prev.removeClass('cap-disabled').fadeIn(100) : next.removeClass('cap-disabled').fadeIn(100));
    }
  });
}


// SHOW SCROLL BUTTONS WHEN NEEDED
function capShowUsefulScrollButtons() {
  $('.cap-nice-scroll').each(function() {
    var box = $(this);
    var boxWidth = parseInt($(this).outerWidth());
    var boxInnerWidth = parseInt($(this)[0].scrollWidth);
    var prev = box.siblings('.cap-nice-scroll-prev');
    var next = box.siblings('.cap-nice-scroll-next');
    
    if(boxWidth < boxInnerWidth - 2) {   // 2 is there as buffer for rounding etc
      (capIsRtlFx() ? prev.removeClass('cap-disabled').fadeIn(200) : next.removeClass('cap-disabled').fadeIn(200));
      $(this).parent().addClass('cap-nice-scroll-have-overflow').removeClass('cap-nice-scroll-nothave-overflow');
    } else {
      (capIsRtlFx() ? prev.addClass('cap-disabled') : next.addClass('cap-disabled'));
      $(this).parent().removeClass('cap-nice-scroll-have-overflow').addClass('cap-nice-scroll-nothave-overflow');
    }
  });
}


// HIDE SCROLL BUTTONS WHEN NOT NEEDED
function capHideUselessScrollButtons() {
  // HIDE FADERS WHEN NOT NEEDED
  $('.cap-nice-scroll').each(function() {
    var box = $(this);
 
    if(box.prop('scrollWidth') - box.width() <= 0) {
      box.siblings('.cap-nice-scroll-prev, .cap-nice-scroll-next').hide(0);
    }
  });
}