<?php
  // Create menu
  $title = __('Configure', 'contact_limit');
  cfl_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  $per_hour = mb_param_update('per_hour', 'plugin_action', 'value', 'plugin-contact_limit');
  $per_day = mb_param_update('per_day', 'plugin_action', 'value', 'plugin-contact_limit');
  $per_week = mb_param_update('per_week', 'plugin_action', 'value', 'plugin-contact_limit');
  $per_month = mb_param_update('per_month', 'plugin_action', 'value', 'plugin-contact_limit');
  $ban_limit = mb_param_update('ban_limit', 'plugin_action', 'value', 'plugin-contact_limit');
  $ban_ip = mb_param_update('ban_ip', 'plugin_action', 'check', 'plugin-contact_limit');
  $ban_ip_submask = mb_param_update('ban_ip_submask', 'plugin_action', 'check', 'plugin-contact_limit');
  $ban_email = mb_param_update('ban_email', 'plugin_action', 'check', 'plugin-contact_limit');
  $ban_words = mb_param_update('ban_words', 'plugin_action', 'value', 'plugin-contact_limit');
  $block_words = mb_param_update('block_words', 'plugin_action', 'value', 'plugin-contact_limit');


  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'contact_limit') );
  }
?>


<div class="mb-body">

  <div class="mb-row mb-notes">
    <div class="mb-line"><?php _e('Take care when setting up this section, as unreasonable limits may block your customers!', 'contact_limit'); ?></div>
    <div class="mb-line"><?php _e('Following forms will be protected: Web contact form, Item contact form, Item send friend form.', 'contact_limit'); ?></div>
  </div>
  
  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Configure', 'contact_limit'); ?></div>

    <div class="mb-inside mb-minify">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <?php if(!cfl_is_demo()) { ?>
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <?php } ?>

        <div class="mb-row">
          <label for="per_hour"><span><?php _e('Hourly Form Usage Limit', 'contact_limit'); ?></span></label> 
          <input name="per_hour" size="20" type="text" value="<?php echo $per_hour; ?>" />
          <div class="mb-input-desc"><?php _e('mails', 'contact_limit'); ?></div>
          
          <div class="mb-explain"><?php _e('Block contact form and does not send email, when limit is reached. Enter -1 to disable.', 'contact_limit'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="per_day"><span><?php _e('Daily Form Usage Limit', 'contact_limit'); ?></span></label> 
          <input name="per_day" size="20" type="text" value="<?php echo $per_day; ?>" />
          <div class="mb-input-desc"><?php _e('mails', 'contact_limit'); ?></div>
          
          <div class="mb-explain"><?php _e('Block contact form and does not send email, when limit is reached. Enter -1 to disable.', 'contact_limit'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="per_week"><span><?php _e('Weekly Form Usage Limit', 'contact_limit'); ?></span></label> 
          <input name="per_week" size="20" type="text" value="<?php echo $per_week; ?>" />
          <div class="mb-input-desc"><?php _e('mails', 'contact_limit'); ?></div>
          
          <div class="mb-explain"><?php _e('Block contact form and does not send email, when limit is reached. Enter -1 to disable.', 'contact_limit'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="per_month"><span><?php _e('Monthly Form Usage Limit', 'contact_limit'); ?></span></label> 
          <input name="per_month" size="20" type="text" value="<?php echo $per_month; ?>" />
          <div class="mb-input-desc"><?php _e('mails', 'contact_limit'); ?></div>
          
          <div class="mb-explain"><?php _e('Block contact form and does not send email, when limit is reached. Enter -1 to disable.', 'contact_limit'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="ban_limit"><span><?php _e('Ban Trigger Limit', 'contact_limit'); ?></span></label> 
          <input name="ban_limit" size="20" type="text" value="<?php echo $ban_limit; ?>" />
          <div class="mb-input-desc"><?php _e('mails', 'contact_limit'); ?></div>
          
          <div class="mb-explain"><?php _e('Ban email/IP of customer, if this customer use contact form XY times and in all these attempts, form is blocked due to hourly, daily, weekly or monthly limit. Enter -1 to disable.', 'contact_limit'); ?></div>
        </div>

        <div class="mb-row">
          <label for="ban_email"><span><?php _e('Ban Email on Trigger', 'contact_limit'); ?></span></label> 
          <input name="ban_email" id="ban_email" type="checkbox" class="element-slide" <?php echo ($ban_email == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, customer\'s email is banned on ban trigger.', 'contact_limit'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="ban_ip"><span><?php _e('Ban IP on Trigger', 'contact_limit'); ?></span></label> 
          <input name="ban_ip" id="ban_ip" type="checkbox" class="element-slide" <?php echo ($ban_ip == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, customer\'s IP is banned on ban trigger.', 'contact_limit'); ?></div>
        </div>        

        <div class="mb-row">
          <label for="ban_ip_submask"><span><?php _e('Ban IP Submask on Trigger', 'contact_limit'); ?></span></label> 
          <input name="ban_ip_submask" id="ban_ip_submask" type="checkbox" class="element-slide" <?php echo ($ban_ip_submask == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled and IP ban is created, whole submask will get banned. Example: customer has IP 192.168.1.13, submask is 192.168.1.*', 'contact_limit'); ?></div>
        </div>    

        <div class="mb-row">
          <label for="block_words"><span><?php _e('Block Words', 'contact_limit'); ?></span></label> 
          <textarea name="block_words" id="block_words"><?php echo osc_esc_html($block_words); ?></textarea>
          
          <div class="mb-explain"><?php _e('Enter words those will block sending email. Delimit by comma. No additional white space. Words are case insensitive. Enter word with whitespaces at start & end to check only whole word (and not subword).', 'contact_limit'); ?></div>
        </div>

        <div class="mb-row">
          <label for="ban_words"><span><?php _e('Ban Words', 'contact_limit'); ?></span></label> 
          <textarea name="ban_words" id="ban_words"><?php echo osc_esc_html($ban_words); ?></textarea>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Enter words those will ban sender. Delimit by comma. No additional white space. Words are case insensitive. Enter word with whitespaces at start & end to check only whole word (and not subword).', 'contact_limit'); ?></div>
            <div class="mb-line"><?php _e('Use "Ban Email on Trigger", "Ban IP on Trigger", "Ban IP Submask on Trigger" settings to create ban rule.', 'contact_limit'); ?></div>
            <div class="mb-line"><strong><?php _e('Warning!', 'contact_limit'); ?></strong> <?php _e('Carefully with ban words, do not ban regular customers! Make sure to check from time to time Ban rules.', 'contact_limit'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(cfl_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'contact_limit')); ?>"><?php _e('Save', 'contact_limit');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'contact_limit');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>

</div>


<?php echo cfl_footer(); ?>