<?php
  // Create menu
  $title = __('Item logs', 'contact_limit');
  cfl_menu($title);

  $params = Params::getParamsAsArray();
  $logs = ModelCFL::newInstance()->searchLogs($params);
  $count_all = ModelCFL::newInstance()->searchLogs($params, true);
?>

<div class="mb-body">

  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-search"></i> <?php _e('Logs', 'contact_limit'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=contact_limit/admin/logs.php" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="logSearch" value="1"/>

        <div id="mb-search-table">
          <div class="mb-col-3">
            <label for="email"><?php _e('Email', 'contact_limit'); ?></label>
            <input type="text" name="email" value="<?php echo osc_esc_html(Params::getParam('email')); ?>" />
          </div>
          
          <div class="mb-col-3">
            <label for="ip"><?php _e('IP', 'contact_limit'); ?></label>
            <input type="text" name="ip" value="<?php echo osc_esc_html(Params::getParam('ip')); ?>" />
          </div>
          
          <div class="mb-col-4">
            <label for="text"><?php _e('Title/Description', 'contact_limit'); ?></label>
            <input type="text" name="text" value="<?php echo osc_esc_html(Params::getParam('text')); ?>" />
          </div>

          <div class="mb-col-3">
            <label for="error"><?php _e('Error', 'contact_limit'); ?></label>
            <input type="text" name="error" value="<?php echo osc_esc_html(Params::getParam('error')); ?>" />
          </div>
          
          <div class="mb-col-2">
            <label for="date"><?php _e('Date', 'contact_limit'); ?></label>
            <input type="text" name="date" value="<?php echo osc_esc_html(Params::getParam('date')); ?>" />
          </div>

          <div class="mb-col-2">
            <label for="type"><?php _e('Type', 'contact_limit'); ?></label>
            <select name="type">
              <option value="" <?php if(Params::getParam('type') == '') { ?>selected="selected"<?php } ?>><?php _e('All', 'contact_limit'); ?></option>
              <option value="WEB" <?php if(Params::getParam('type') == 'WEB') { ?>selected="selected"<?php } ?>><?php _e('Web form', 'contact_limit'); ?></option>
              <option value="ITEM" <?php if(Params::getParam('type') == 'ITEM') { ?>selected="selected"<?php } ?>><?php _e('Item forms', 'contact_limit'); ?></option>
            </select>
          </div>

          <div class="mb-col-2">
            <label for="status"><?php _e('Status', 'contact_limit'); ?></label>
            <select name="status">
              <option value="" <?php if(Params::getParam('status') == '') { ?>selected="selected"<?php } ?>><?php _e('All', 'contact_limit'); ?></option>
              <option value="SENT" <?php if(Params::getParam('status') == 'SENT') { ?>selected="selected"<?php } ?>><?php _e('Sent', 'contact_limit'); ?></option>
              <option value="BLOCKED" <?php if(Params::getParam('status') == 'BLOCKED') { ?>selected="selected"<?php } ?>><?php _e('Blocked', 'contact_limit'); ?></option>
            </select>
          </div>
          
          <div class="mb-col-2">
            <label for="sort"><?php _e('Sort', 'contact_limit'); ?></label>
            <select name="sort">
              <option value="" <?php if(Params::getParam('sort') == '') { ?>selected="selected"<?php } ?>><?php _e('By ID descending', 'contact_limit'); ?></option>
              <option value="ID_ASC" <?php if(Params::getParam('sort') == 'ID_ASC') { ?>selected="selected"<?php } ?>><?php _e('By ID ascending', 'contact_limit'); ?></option>
              <option value="DATE_ASC" <?php if(Params::getParam('sort') == 'DATE_ASC') { ?>selected="selected"<?php } ?>><?php _e('By log date ascending', 'contact_limit'); ?></option>
              <option value="DATE_DESC" <?php if(Params::getParam('sort') == 'DATE_DESC') { ?>selected="selected"<?php } ?>><?php _e('By log date descending', 'contact_limit'); ?></option>
            </select>
          </div>    
         
          <div class="mb-col-2">
            <label for="">&nbsp;</label>
            <button type="submit" class="mb-button mb-button-black"><i class="fa fa-search"></i> <?php _e('Search', 'contact_limit'); ?></button>
          </div>
        </div>
      </form>    

      <div class="mb-table mb-table-cflogs">
        <div class="mb-table-head">
          <div class="mb-col-1 mb-align-left"><?php _e('ID', 'contact_limit');?></div>
          <div class="mb-col-3 mb-align-left"><?php _e('Email', 'contact_limit'); ?></div>
          <div class="mb-col-2 mb-align-left"><?php _e('IP address', 'contact_limit');?></div>
          <div class="mb-col-2 mb-align-left"><?php _e('Status', 'contact_limit');?></div>
          <div class="mb-col-1 mb-align-left"><?php _e('Type', 'contact_limit');?></div>
          <div class="mb-col-1 mb-align-left"><?php _e('Item ID', 'contact_limit');?></div>
          <div class="mb-col-3 mb-align-left"><?php _e('Title', 'contact_limit');?></div>
          <div class="mb-col-4 mb-align-left"><?php _e('Message', 'contact_limit');?></div>
          <div class="mb-col-2 mb-align-left"><?php _e('Recipient', 'contact_limit');?></div>
          <div class="mb-col-3 mb-align-left"><?php _e('Error', 'contact_limit');?></div>
          <div class="mb-col-2 mb-align-left"><?php _e('Log Date', 'contact_limit');?></div>
        </div>

        <?php if(count($logs) <= 0) { ?>
          <div class="mb-table-row mb-row-empty">
            <i class="fa fa-warning"></i><span><?php _e('No logs has been found', 'contact_limit'); ?></span>
          </div>
        <?php } else { ?>
          <?php foreach($logs as $log) { ?>
            <div class="mb-table-row">
              <div class="mb-col-1 mb-align-left"><?php echo $log['pk_i_id']; ?></div>
              <div class="mb-col-3 mb-align-left"><?php echo $log['s_email']; ?></div>
              <div class="mb-col-2 mb-align-left"><?php echo $log['s_ip']; ?></div>
              <div class="mb-col-2 mb-align-left mb-row-st"><span class="mb-<?php echo strtolower($log['s_status']); ?>"><?php echo ucwords(strtolower($log['s_status'])); ?></span></div>
              <div class="mb-col-1 mb-align-left mb-row-tp"><?php echo $log['s_type']; ?></div>
              <div class="mb-col-1 mb-align-left"><?php echo ($log['fk_i_item_id'] <> '' ? $log['fk_i_item_id'] : '-'); ?></div>
              <div class="mb-col-3 mb-align-left"><span><?php echo ($log['s_title'] <> '' ? $log['s_title'] : '-'); ?></span></div>
              <div class="mb-col-4 mb-align-left mb-has-tooltip-light" title="<?php echo osc_esc_html(trim($log['s_message'])); ?>"><span><?php echo ($log['s_message'] <> '' ? $log['s_message'] : '-'); ?></span></div>
              <div class="mb-col-2 mb-align-left"><?php echo ($log['s_recipient'] <> '' ? $log['s_recipient'] : '-'); ?></div>
              <div class="mb-col-3 mb-align-left"><span><?php echo ($log['s_error'] <> '' ? $log['s_error'] : '-'); ?></span></div>
              <div class="mb-col-2 mb-align-left mb-row-dt"><?php echo $log['dt_date']; ?></div>
            </div>
          <?php } ?>

          <?php 
            $param_string = '&itemId=' . Params::getParam('itemId') . '&email=' . Params::getParam('email') . '&text=' . Params::getParam('text') . '&error=' . Params::getParam('error') . '&ip=' . Params::getParam('ip') . '&date=' . Params::getParam('date') . '&status=' . Params::getParam('status') . '&type=' . Params::getParam('type') . '&sort=' . Params::getParam('sort');
            echo cfl_admin_paginate('contact_limit/admin/logs.php', Params::getParam('pageId'), (cfl_param('per_page') > 0 ? cfl_param('per_page') : 30), $count_all, '', $param_string); 
          ?>
        <?php } ?>
      </div>
    </div>
  </div>
</div>