<?php
/*
  Plugin Name: Contact Form Limits Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/protection-and-spam/contact-form-limits-plugin-i181
  Description: Protects web contact form, item contact form and item send to friend forms from misuse.
  Version: 1.0.4
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: contact_limit
  Plugin update URI: contact_limit
  Support URI: https://forums.osclasspoint.com/
  Product Key: dI2zdwnHWj1TnMldUVji
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelCFL.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';



// INSTALL FUNCTION - DEFINE VARIABLES
function cfl_call_after_install() {
  osc_set_preference('per_hour', 5, 'plugin-contact_limit', 'INTEGER');
  osc_set_preference('per_day', 15, 'plugin-contact_limit', 'INTEGER');
  osc_set_preference('per_week', 50, 'plugin-contact_limit', 'INTEGER');
  osc_set_preference('per_month', 150, 'plugin-contact_limit', 'INTEGER');
  
  osc_set_preference('ban_limit', -1, 'plugin-contact_limit', 'INTEGER');
  osc_set_preference('ban_ip', 0, 'plugin-contact_limit', 'INTEGER');
  osc_set_preference('ban_ip_submask', 0, 'plugin-contact_limit', 'INTEGER');
  osc_set_preference('ban_email', 0, 'plugin-contact_limit', 'INTEGER');

  osc_set_preference('block_words', '', 'plugin-contact_limit', 'INTEGER');
  osc_set_preference('ban_words', '', 'plugin-contact_limit', 'INTEGER');

  ModelCFL::newInstance()->install();
}


function cfl_call_after_uninstall() {
  ModelCFL::newInstance()->uninstall();
}



// ADMIN MENU
function cfl_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/contact_limit/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/contact_limit/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/contact_limit/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/contact_limit/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/contact_limit/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/contact_limit/js/bootstrap-switch.js"></script>';

  if( $title == '') { $title = __('Configure', 'contact_limit'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Contact Form Limits Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=contact_limit/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'contact_limit') . '</span></a></li>';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=contact_limit/admin/logs.php"><i class="fa fa-database"></i><span>' . __('Logs', 'contact_limit') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function cfl_footer() {
  $pluginInfo = osc_plugin_get_info('contact_limit/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint Market" /> OsclassPoint Market</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'contact_limit') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'contact_limit') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'contact_limit') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}


// PLUGIN UPDATE
function cfl_update_version() {
  ModelCFL::newInstance()->versionUpdate();
}

osc_add_hook(osc_plugin_path(__FILE__) . '_enable', 'cfl_update_version');


// ADD MENU LINK TO PLUGIN LIST
function cfl_admin_menu() {
echo '<h3><a href="#">Contact Form Limits Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'contact_limit') . '</a></li>
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/logs.php') . '">&raquo; ' . __('Logs', 'contact_limit') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','cfl_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function cfl_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'cfl_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'cfl_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'cfl_call_after_uninstall');

?>