<?php
  // Create menu
  $title = __('Configure', 'content_protect');
  cnp_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  $disable_rightclick = mb_param_update('disable_rightclick', 'plugin_action', 'check', 'plugin-content_protect');
  $enable_rightclick_inputs = mb_param_update('enable_rightclick_inputs', 'plugin_action', 'check', 'plugin-content_protect');
  $disable_selection = mb_param_update('disable_selection', 'plugin_action', 'check', 'plugin-content_protect');
  $disable_selection_custom = mb_param_update('disable_selection_custom', 'plugin_action', 'value', 'plugin-content_protect');
  $warning_console = mb_param_update('warning_console', 'plugin_action', 'check', 'plugin-content_protect');
  $cover_type = mb_param_update('cover_type', 'plugin_action', 'check', 'plugin-content_protect');
  $cover_title = mb_param_update('cover_title', 'plugin_action', 'check', 'plugin-content_protect');
  $cover_description = mb_param_update('cover_description', 'plugin_action', 'check', 'plugin-content_protect');
  $cover_custom = mb_param_update('cover_custom', 'plugin_action', 'value', 'plugin-content_protect');
  $trim_copied_text = mb_param_update('trim_copied_text', 'plugin_action', 'check', 'plugin-content_protect');


  if(Params::getParam('plugin_action') == 'done') {
    osc_add_flash_ok_message(__('Settings were successfully saved.', 'content_protect'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=content_protect/admin/configure.php');
    exit;
  }
?>


<div class="mb-body">
  
  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Configure', 'content_protect'); ?></div>

    <div class="mb-inside mb-minify">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <?php if(!cnp_is_demo()) { ?>
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <?php } ?>


        <div class="mb-row">
          <label for="trim_copied_text" class=""><span><?php _e('Trim & Enrich Copied Text', 'content_protect'); ?></span></label> 
          <input name="trim_copied_text" type="checkbox" class="element-slide" <?php echo ($trim_copied_text == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled and customer copy any text from your website, it get trimmed to max 240 characters and at the end of copied text is added "Read more at: {URL}".', 'content_protect'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="disable_rightclick" class=""><span><?php _e('Disable Right-Clicks', 'content_protect'); ?></span></label> 
          <input name="disable_rightclick" type="checkbox" class="element-slide" <?php echo ($disable_rightclick == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, right-click on your website will not work and will not show context menu.', 'content_protect'); ?></div>
        </div>

        <div class="mb-row">
          <label for="enable_rightclick_inputs" class=""><span><?php _e('Enable Right-Clicks on Inputs', 'content_protect'); ?></span></label> 
          <input name="enable_rightclick_inputs" type="checkbox" class="element-slide" <?php echo ($enable_rightclick_inputs == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, right-click on inputs, select boxes and text areas is enabled, even you disabled right-clicks across website.', 'content_protect'); ?></div>
        </div>

        <div class="mb-row">
          <label for="disable_selection" class=""><span><?php _e('Disable Selection', 'content_protect'); ?></span></label> 
          <input name="disable_selection" type="checkbox" class="element-slide" <?php echo ($disable_selection == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, text on your website cannot be selected by holding mouse or arrow keys.', 'content_protect'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="disable_selection_custom" class=""><span><?php _e('Disable Selection on Selectors', 'content_protect'); ?></span></label> 
          <input name="disable_selection_custom" type="text" size="80" value="<?php echo osc_esc_html($disable_selection_custom); ?>"/>

          <div class="mb-explain"><?php _e('Specify CSS selectors to disable text selection on particular blocks only.', 'content_protect'); ?></div>
        </div>
        
        
        <div class="mb-row">
          <label for="warning_console" class=""><span><?php _e('Warning in Console', 'content_protect'); ?></span></label> 
          <input name="warning_console" type="checkbox" class="element-slide" <?php echo ($warning_console == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, in browser console will be shown bold message that copying of content from your website is forbidden.', 'content_protect'); ?></div>
        </div>

        <div class="mb-row">
          <label for="cover_title" class=""><span><?php _e('Cover Item Title', 'content_protect'); ?></span></label> 
          <input name="cover_title" type="checkbox" class="element-slide" <?php echo ($cover_title == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, span element is added to start & end of item title on item page in order to cover it with empty box.', 'content_protect'); ?></div>
            <div class="mb-line"><?php _e('WARNING: Test well before using it in production. Generally not recommended to use it until you know what you are doing.', 'content_protect'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="cover_description" class=""><span><?php _e('Cover Item Description', 'content_protect'); ?></span></label> 
          <input name="cover_description" type="checkbox" class="element-slide" <?php echo ($cover_description == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, span element is added to start & end of item description on item page in order to cover it with empty box.', 'content_protect'); ?></div>
            <div class="mb-line"><?php _e('WARNING: Test well before using it in production. Generally not recommended to use it until you know what you are doing.', 'content_protect'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="cover_custom" class=""><span><?php _e('Create Covers on Selectors', 'content_protect'); ?></span></label> 
          <input name="cover_custom" type="text" size="80" value="<?php echo osc_esc_html($cover_custom); ?>"/>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Specify CSS selectors those will be covered by empty blocks and text selection will be more complicated.', 'content_protect'); ?></div>
            <div class="mb-line"><?php _e('WARNING: Test well before using it in production. Generally not recommended to use it until you know what you are doing.', 'content_protect'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="cover_type" class=""><span><?php _e('Cover as Wrap', 'content_protect'); ?></span></label> 
          <input name="cover_type" type="checkbox" class="element-slide" <?php echo ($cover_type == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, span element is added to start & end of item title on item page in order to cover it with empty box. Otherwise only cover box is added at the end of text.', 'content_protect'); ?></div>
            <div class="mb-line"><?php _e('Recommended is to keep this setting disabled.', 'content_protect'); ?></div>
          </div>
        </div>

        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(cnp_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'content_protect')); ?>"><?php _e('Save', 'content_protect');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'content_protect');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>


  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'content_protect'); ?></div>

    <div class="mb-inside">
      <div class="mb-row"><?php _e('Plugin does not require modifications in files.', 'content_protect'); ?></div>
    </div>
  </div>
</div>


<?php echo cnp_footer(); ?>