<?php

// ADD JAVASCRIPT TO FOOTER
function cnp_javascript() {
  if(defined('OC_ADMIN') && OC_ADMIN === true) {
    return false;
  }

  // Set position to relative for parent cover block
  ?><script type="text/javascript">$('.cnp-nocopy').parent().css('position', 'relative');</script><?php 

  // Trim and enrich copied text with link
  if(cnp_param('trim_copied_text') == 1) {
  ?><script type="text/javascript">
    const copyListener = (event) => {
      const range = window.getSelection().getRangeAt(0),
        rangeContents = range.cloneContents(),
        pageLink = '<?php echo osc_esc_js(__('Read more at:', 'content_protect')); ?> ' + document.location.href,
        helper = document.createElement('div'),
        maxChar = 240;

      helper.appendChild(rangeContents);

      event.clipboardData.setData('text/plain', (helper.innerText.trim()).substring(0, maxChar) + ((helper.innerText.trim()).length > maxChar ? '...' : '') + '\n\n' + pageLink);
      //event.clipboardData.setData('text/html', helper.innerHTML + '<br><br>' + pageLink);
      event.preventDefault();
    };
    document.addEventListener('copy', copyListener);
  </script><?php 
  }
  
  
  // Add warning to browser console
  if(cnp_param('warning_console') == 1) {
    ?><script type="text/javascript">console.log("%c<?php echo osc_esc_html(__('Content on this website is copyrighted, copy is FORBIDDEN !!!', 'content_protect')); ?>", "background: red; color: yellow; font-size: x-large; font-weight: 800;");</script><?php
  }
  
  // Disable right clicks
  if(cnp_param('disable_rightclick') == 1) {
    if(cnp_param('enable_rightclick_inputs') == 1) {
      ?><script type="text/javascript">
          document.addEventListener("contextmenu", function (e){
            if(!$(e.target).is(':input')) {
              e.preventDefault();
              return false;
            }
          }, false);        
        </script>
      <?php
    } else {
      ?><script type="text/javascript">document.addEventListener('contextmenu', event => event.preventDefault());</script><?php
    }
  }
  
  
  // Disable ability to select text on page
  if(cnp_param('disable_selection') == 1) {
    ?><style>body, html {-webkit-user-select: none;-ms-user-select: none;user-select: none;}</style><?php
  }

  // Disable ability to select text on specific elements only
  if(trim(cnp_param('disable_selection_custom')) <> '') {
    ?><style><?php echo trim(cnp_param('disable_selection_custom')); ?> {-webkit-user-select: none;-ms-user-select: none;user-select: none;}</style><?php
  }
  
  // Add cover on selected elements
  if(trim(cnp_param('cover_custom')) <> '') {
    $list = array_filter(array_unique(explode(',', trim(cnp_param('cover_custom')))));
    $selectors = array();
    
    if(count($list) > 0) {
      foreach($list as $l) {
        if($l <> '') {
          $selectors[] = $l . ':before';
        }
      }
    }
    
    ?><style><?php echo trim(cnp_param('cover_custom')); ?> {position:relative;} <?php echo implode(',', $selectors); ?> {z-index:1;position:absolute;top:0;left:0;bottom:0;right:0;content:"";}</style><?php
  }
  
  // Add cover on title & description
  if(cnp_param('cover_title') == 1 || cnp_param('cover_description') == 1) {
    ?><style>.cnp-cover {position:relative;display:inline-block;width:100%;} .cnp-nocopy {z-index:1;position:absolute;top:0;left:0;bottom:0;right:0;content:"";}</style><?php
  }
}

osc_add_hook('footer', 'cnp_javascript', 1);


// COVER FUNCTION
function cnp_add_cover($text = '') {
  $type = (cnp_param('cover_type') == 1 ? true : false);
  
  if(strpos($text, 'class="cnp-cover"') === false && strpos($text, 'class="cnp-nocopy"') === false) {
    if($type) {
      return '<span class="cnp-cover"><span class="cnp-box">' . $text . '</span><span class="cnp-nocopy"></span></span>';
    } else {
      return $text . '<span class="cnp-nocopy"></span>';
    }
  } 
  
  return $text;
}

// ADD COVER TO TITLE
function cnp_add_cover_title($text = '') {
  if(cnp_param('cover_title') == 1) {
    return cnp_add_cover($text);
  }
  
  return $text;
}

osc_add_filter('item_title', 'cnp_add_cover_title', 10);


// ADD COVER TO DESCRIPTION
function cnp_add_cover_description($text = '') {
  if(cnp_param('cover_description') == 1) {
    return cnp_add_cover($text);
  }
  
  return $text;
}

osc_add_filter('item_description', 'cnp_add_cover_description', 10);



// CORE FUNCTIONS
function cnp_param($name) {
  return osc_get_preference($name, 'plugin-content_protect');
}


if(!function_exists('mb_param_update')) {
  function mb_param_update( $param_name, $update_param_name, $type = NULL, $plugin_var_name = NULL ) {
  
    $val = '';
    if( $type == 'check') {

      // Checkbox input
      if( Params::getParam( $param_name ) == 'on' ) {
        $val = 1;
      } else {
        if( Params::getParam( $update_param_name ) == 'done' ) {
          $val = 0;
        } else {
          $val = ( osc_get_preference( $param_name, $plugin_var_name ) != '' ) ? osc_get_preference( $param_name, $plugin_var_name ) : '';
        }
      }
    } else {

      // Other inputs (text, password, ...)
      if( Params::getParam( $update_param_name ) == 'done' && Params::existParam($param_name)) {
        $val = Params::getParam( $param_name );
      } else {
        $val = ( osc_get_preference( $param_name, $plugin_var_name) != '' ) ? osc_get_preference( $param_name, $plugin_var_name ) : '';
      }
    }


    // If save button was pressed, update param
    if( Params::getParam( $update_param_name ) == 'done' ) {

      if(osc_get_preference( $param_name, $plugin_var_name ) == '') {
        osc_set_preference( $param_name, $val, $plugin_var_name, 'STRING');  
      } else {
        $dao_preference = new Preference();
        $dao_preference->update( array( "s_value" => $val ), array( "s_section" => $plugin_var_name, "s_name" => $param_name ));
        osc_reset_preferences();
        unset($dao_preference);
      }
    }

    return $val;
  }
}


// CHECK IF RUNNING ON DEMO
function cnp_is_demo() {
  if(osc_logged_admin_username() == 'admin') {
    return false;
  } else if(isset($_SERVER['HTTP_HOST']) && (strpos($_SERVER['HTTP_HOST'],'mb-themes') !== false || strpos($_SERVER['HTTP_HOST'],'abprofitrade') !== false)) {
    return true;
  } else {
    return false;
  }
}


if(!function_exists('message_ok')) {
  function message_ok( $text ) {
    $final  = '<div class="flashmessage flashmessage-ok flashmessage-inline">';
    $final .= $text;
    $final .= '</div>';
    echo $final;
  }
}


if(!function_exists('message_error')) {
  function message_error( $text ) {
    $final  = '<div class="flashmessage flashmessage-error flashmessage-inline">';
    $final .= $text;
    $final .= '</div>';
    echo $final;
  }
}



// COOKIES WORK
if(!function_exists('mb_set_cookie')) {
  function mb_set_cookie($name, $val) {
    Cookie::newInstance()->set_expires( 86400 * 30 );
    Cookie::newInstance()->push($name, $val);
    Cookie::newInstance()->set();
  }
}


if(!function_exists('mb_get_cookie')) {
  function mb_get_cookie($name) {
    return Cookie::newInstance()->get_value($name);
  }
}

if(!function_exists('mb_drop_cookie')) {
  function mb_drop_cookie($name) {
    Cookie::newInstance()->pop($name);
  }
}


if(!function_exists('mb_generate_rand_string')) {
  function mb_generate_rand_string($length = 10) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $charactersLength = strlen($characters);
    $randomString = '';

    for ($i = 0; $i < $length; $i++) {
      $randomString .= $characters[rand(0, $charactersLength - 1)];
    }

    return $randomString;
  }
}

if(!function_exists('osc_get_current_url')) {
  function osc_get_current_url() {
    $actual_link = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
    return $actual_link;
  }
}

?>