<?php
/*
  Plugin Name: Content Protection Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/protection-and-spam/content-protection-plugin-i198
  Description: Helps to safe your content by not allowing to copy text from your website.
  Version: 1.1.1
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: content_protect
  Plugin update URI: content_protect
  Support URI: https://forums.osclasspoint.com/general-plugins-discussion/
  Product Key: pTVnP2nGEyjqdFb2gbkg
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelCNP.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';



// INSTALL FUNCTION - DEFINE VARIABLES
function cnp_call_after_install() {
  osc_set_preference('disable_rightclick', 0, 'plugin-content_protect', 'INTEGER');
  osc_set_preference('enable_rightclick_inputs', 0, 'plugin-content_protect', 'INTEGER');
  osc_set_preference('disable_selection', 0, 'plugin-content_protect', 'INTEGER');
  osc_set_preference('cover_type', 0, 'plugin-content_protect', 'INTEGER');
  osc_set_preference('cover_title', 0, 'plugin-content_protect', 'INTEGER');
  osc_set_preference('cover_description', 0, 'plugin-content_protect', 'INTEGER');
  osc_set_preference('cover_custom', '', 'plugin-content_protect', 'STRING');
  osc_set_preference('warning_console', 0, 'plugin-content_protect', 'INTEGER');
  
  ModelCNP::newInstance()->install();
}


function cnp_call_after_uninstall() {
  ModelCNP::newInstance()->uninstall();
}


// ADMIN MENU
function cnp_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/content_protect/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/content_protect/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/content_protect/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/content_protect/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/content_protect/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/content_protect/js/bootstrap-switch.js"></script>';



  if( $title == '') { $title = __('Configure', 'content_protect'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Content Protection Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_base_url() . 'oc-admin/index.php?page=plugins&action=renderplugin&file=content_protect/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'content_protect') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function cnp_footer() {
  $pluginInfo = osc_plugin_get_info('content_protect/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint Market" /> OsclassPoint Market</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'content_protect') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'content_protect') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'content_protect') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function cnp_admin_menu() {
echo '<h3><a href="#">Content Protection Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'content_protect') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','cnp_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function cnp_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'cnp_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'cnp_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'cnp_call_after_uninstall');

?>