<?php
  // Create menu
  $title = __('Configure', 'cookie_consent');
  ckc_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  $enable = mb_param_update('enable', 'plugin_action', 'check', 'plugin-cookie_consent');
  $border = mb_param_update('border', 'plugin_action', 'value', 'plugin-cookie_consent');
  $corners = mb_param_update('corners', 'plugin_action', 'value', 'plugin-cookie_consent');
  $colors_popup_background = mb_param_update('colors_popup_background', 'plugin_action', 'value', 'plugin-cookie_consent');
  $colors_popup_text = mb_param_update('colors_popup_text', 'plugin_action', 'value', 'plugin-cookie_consent');
  $colors_popup_border = mb_param_update('colors_popup_border', 'plugin_action', 'value', 'plugin-cookie_consent');
  $colors_button_background = mb_param_update('colors_button_background', 'plugin_action', 'value', 'plugin-cookie_consent');
  $colors_button_text = mb_param_update('colors_button_text', 'plugin_action', 'value', 'plugin-cookie_consent');
  $position = mb_param_update('position', 'plugin_action', 'value', 'plugin-cookie_consent');
  $content_href = mb_param_update('content_href', 'plugin_action', 'value', 'plugin-cookie_consent');
  $content_message = mb_param_update('content_message', 'plugin_action', 'value', 'plugin-cookie_consent');
  $content_link = mb_param_update('content_link', 'plugin_action', 'value', 'plugin-cookie_consent');
  $content_button = mb_param_update('content_button', 'plugin_action', 'value', 'plugin-cookie_consent');
  $padding = mb_param_update('padding', 'plugin_action', 'value', 'plugin-cookie_consent');
  $margin = mb_param_update('margin', 'plugin_action', 'value', 'plugin-cookie_consent');
  $fontsize = mb_param_update('fontsize', 'plugin_action', 'value', 'plugin-cookie_consent');
  $transparency = mb_param_update('transparency', 'plugin_action', 'value', 'plugin-cookie_consent');


  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'cookie_consent') );
  }
?>


<div class="mb-body">
 
  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Configure', 'cookie_consent'); ?></div>

    <div class="mb-inside mb-minify">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <?php if(!ckc_is_demo()) { ?>
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <?php } ?>

        <div class="mb-row">
          <label for="enable" class="h0"><span><?php _e('Enable Cookie Consent Box', 'cookie_consent'); ?></span></label> 
          <input name="enable" type="checkbox" class="element-slide" <?php echo ($enable == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, cookie consent bar will be visible to all users', 'cookie_consent'); ?></div>
        </div>
        
        
        <!-- LAYOUT SETUP -->
        <div class="mb-row"><h3 class="sec"><?php _e('Layout settings', 'cookie_consent'); ?></h3></div>

        
        <div class="mb-row">
          <label for="position" class="h1"><span><?php _e('Layout / Position', 'cookie_consent'); ?></span></label> 
          <select name="position" id="position">
            <option value="bottom" <?php echo ($position == "bottom" ? 'selected="selected"' : ''); ?>><?php _e('Box : bottom', 'cookie_consent'); ?></option>
            <option value="top" <?php echo ($position == "top" ? 'selected="selected"' : ''); ?>><?php _e('Box : top', 'cookie_consent'); ?></option>
            <option value="bottom-left" <?php echo ($position == "bottom-left" ? 'selected="selected"' : ''); ?>><?php _e('Tooltip : bottom left', 'cookie_consent'); ?></option>
            <option value="bottom-right" <?php echo ($position == "bottom-right" ? 'selected="selected"' : ''); ?>><?php _e('Tooltip : bottom right', 'cookie_consent'); ?></option>
            <option value="top-left" <?php echo ($position == "top-left" ? 'selected="selected"' : ''); ?>><?php _e('Tooltip : top left', 'cookie_consent'); ?></option>
            <option value="top-right" <?php echo ($position == "top-right" ? 'selected="selected"' : ''); ?>><?php _e('Tooltip : top right', 'cookie_consent'); ?></option>
          </select>

          <div class="mb-explain"><?php _e('Select layout type and position', 'cookie_consent'); ?></div>
        </div>
               

     
        <div class="mb-row">
          <label for="border" class="h2"><span><?php _e('Border', 'cookie_consent'); ?></span></label> 
          <select name="border" id="border">
            <option value="" <?php echo ($border == "" ? 'selected="selected"' : ''); ?>><?php _e('None', 'cookie_consent'); ?></option>
            <option value="thin" <?php echo ($border == "thin" ? 'selected="selected"' : ''); ?>><?php _e('Thin', 'cookie_consent'); ?></option>
            <option value="normal" <?php echo ($border == "normal" ? 'selected="selected"' : ''); ?>><?php _e('Normal', 'cookie_consent'); ?></option>
            <option value="thick" <?php echo ($border == "thick" ? 'selected="selected"' : ''); ?>><?php _e('Thick', 'cookie_consent'); ?></option>
          </select>

          <div class="mb-explain"><?php _e('Select box border height', 'cookie_consent'); ?></div>
        </div>
        
        
        <div class="mb-row">
          <label for="corners" class="h3"><span><?php _e('Corners', 'cookie_consent'); ?></span></label> 
          <select name="corners" id="corners">
            <option value="" <?php echo ($corners == "" ? 'selected="selected"' : ''); ?>><?php _e('None', 'cookie_consent'); ?></option>
            <option value="small" <?php echo ($corners == "small" ? 'selected="selected"' : ''); ?>><?php _e('Small', 'cookie_consent'); ?></option>
            <option value="normal" <?php echo ($corners == "normal" ? 'selected="selected"' : ''); ?>><?php _e('Normal', 'cookie_consent'); ?></option>
            <option value="large" <?php echo ($corners == "large" ? 'selected="selected"' : ''); ?>><?php _e('Large', 'cookie_consent'); ?></option>
          </select>

          <div class="mb-explain"><?php _e('Select box border radius', 'cookie_consent'); ?></div>
        </div>
        
        
        <div class="mb-row">
          <label for="padding" class="h4"><span><?php _e('Padding', 'cookie_consent'); ?></span></label> 
          <select name="padding" id="padding">
            <option value="" <?php echo ($padding == "" ? 'selected="selected"' : ''); ?>><?php _e('None', 'cookie_consent'); ?></option>
            <option value="small" <?php echo ($padding == "small" ? 'selected="selected"' : ''); ?>><?php _e('Small', 'cookie_consent'); ?></option>
            <option value="normal" <?php echo ($padding == "normal" ? 'selected="selected"' : ''); ?>><?php _e('Normal', 'cookie_consent'); ?></option>
            <option value="large" <?php echo ($padding == "large" ? 'selected="selected"' : ''); ?>><?php _e('Large', 'cookie_consent'); ?></option>
          </select>

          <div class="mb-explain"><?php _e('Select box padding', 'cookie_consent'); ?></div>
        </div>
        
        
         <div class="mb-row">
          <label for="margin" class="h5"><span><?php _e('Margin', 'cookie_consent'); ?></span></label> 
          <select name="margin" id="margin">
            <option value="" <?php echo ($margin == "" ? 'selected="selected"' : ''); ?>><?php _e('None', 'cookie_consent'); ?></option>
            <option value="small" <?php echo ($margin == "small" ? 'selected="selected"' : ''); ?>><?php _e('Small', 'cookie_consent'); ?></option>
            <option value="normal" <?php echo ($margin == "normal" ? 'selected="selected"' : ''); ?>><?php _e('Normal', 'cookie_consent'); ?></option>
            <option value="large" <?php echo ($margin == "large" ? 'selected="selected"' : ''); ?>><?php _e('Large', 'cookie_consent'); ?></option>
          </select>

          <div class="mb-explain"><?php _e('Select box margin', 'cookie_consent'); ?></div>
        </div>       
        
        
         <div class="mb-row">
          <label for="transparency" class="h6"><span><?php _e('Transparency', 'cookie_consent'); ?></span></label> 
          <select name="transparency" id="transparency">
            <option value="" <?php echo ($transparency == "" ? 'selected="selected"' : ''); ?>><?php _e('None', 'cookie_consent'); ?></option>
            <option value="5" <?php echo ($transparency == "5" ? 'selected="selected"' : ''); ?>><?php _e('5%', 'cookie_consent'); ?></option>
            <option value="10" <?php echo ($transparency == "10" ? 'selected="selected"' : ''); ?>><?php _e('10%', 'cookie_consent'); ?></option>
            <option value="15" <?php echo ($transparency == "15" ? 'selected="selected"' : ''); ?>><?php _e('15%', 'cookie_consent'); ?></option>
            <option value="20" <?php echo ($transparency == "20" ? 'selected="selected"' : ''); ?>><?php _e('20%', 'cookie_consent'); ?></option>
            <option value="25" <?php echo ($transparency == "25" ? 'selected="selected"' : ''); ?>><?php _e('25%', 'cookie_consent'); ?></option>
          </select>

          <div class="mb-explain"><?php _e('Select box transparency', 'cookie_consent'); ?></div>
        </div>               
        
        
         <div class="mb-row">
          <label for="fontsize" class="h7"><span><?php _e('Font size', 'cookie_consent'); ?></span></label> 
          <select name="fontsize" id="fontsize">
            <option value="tiny" <?php echo ($fontsize == "tiny" ? 'selected="selected"' : ''); ?>><?php _e('Tiny', 'cookie_consent'); ?></option>
            <option value="small" <?php echo ($fontsize == "small" ? 'selected="selected"' : ''); ?>><?php _e('Small', 'cookie_consent'); ?></option>
            <option value="default" <?php echo ($fontsize == "default" ? 'selected="selected"' : ''); ?>><?php _e('Default', 'cookie_consent'); ?></option>
            <option value="large" <?php echo ($fontsize == "large" ? 'selected="selected"' : ''); ?>><?php _e('Large', 'cookie_consent'); ?></option>
          </select>

          <div class="mb-explain"><?php _e('Select box font size', 'cookie_consent'); ?></div>
        </div>             
        
        
        
        
        <!-- COLORS SETUP -->
        <div class="mb-row"><h3 class="sec"><?php _e('Colors settings', 'cookie_consent'); ?></h3></div>

        <div class="mb-row">
          <label for="colors_popup_background" class="h8"><span><?php _e('Popup background', 'cookie_consent'); ?></span></label> 
      
          <input name="colors_popup_background" id="colors_popup_background" size="20" type="text" value="<?php echo $colors_popup_background; ?>" />
          <span class="color-wrap">
            <input name="color-picker" id="" type="color" value="<?php echo osc_esc_html($colors_popup_background); ?>" />
          </span>
          <div class="mb-explain"><?php _e('Enter color in HEX format or select color with picker. Example: #f29c12', 'cookie_consent'); ?></div>
        </div>
        
      
        <div class="mb-row">
          <label for="colors_popup_text" class="h9"><span><?php _e('Popup text', 'cookie_consent'); ?></span></label> 
      
          <input name="colors_popup_text" id="colors_popup_text" size="20" type="text" value="<?php echo $colors_popup_text; ?>" />
          <span class="color-wrap">
            <input name="color-picker" id="" type="color" value="<?php echo $colors_popup_text; ?>" />
          </span>
          <div class="mb-explain"><?php _e('Enter color in HEX format or select color with picker. Example: #f29c12', 'cookie_consent'); ?></div>
        </div>
        
        
        <div class="mb-row">
          <label for="colors_popup_border" class="h10"><span><?php _e('Popup border', 'cookie_consent'); ?></span></label> 
      
          <input name="colors_popup_border" id="colors_popup_border" size="20" type="text" value="<?php echo $colors_popup_border; ?>" />
          <span class="color-wrap">
            <input name="color-picker" id="" type="color" value="<?php echo $colors_popup_border; ?>" />
          </span>
          <div class="mb-explain"><?php _e('Enter color in HEX format or select color with picker. Example: #f29c12', 'cookie_consent'); ?></div>
        </div>
        
        
        <div class="mb-row">
          <label for="colors_button_background" class="h11"><span><?php _e('Button background', 'cookie_consent'); ?></span></label> 
      
          <input name="colors_button_background" id="colors_button_background" size="20" type="text" value="<?php echo $colors_button_background; ?>" />
          <span class="color-wrap">
            <input name="color-picker" id="" type="color" value="<?php echo $colors_button_background; ?>" />
          </span>
          <div class="mb-explain"><?php _e('Enter color in HEX format or select color with picker. Example: #f29c12', 'cookie_consent'); ?></div>
        </div>
        
        
        <div class="mb-row">
          <label for="colors_button_text" class="h12"><span><?php _e('Button text', 'cookie_consent'); ?></span></label> 
      
          <input name="colors_button_text" id="colors_button_text" size="20" type="text" value="<?php echo $colors_button_text; ?>" />
          <span class="color-wrap">
            <input name="color-picker" id="" type="color" value="<?php echo $colors_button_text; ?>" />
          </span>
          <div class="mb-explain"><?php _e('Enter color in HEX format or select color with picker. Example: #f29c12', 'cookie_consent'); ?></div>
        </div>
        
        
      
        <!-- CONTENT SETUP -->
        <div class="mb-row"><h3 class="sec"><?php _e('Content settings', 'cookie_consent'); ?></h3></div>

        <div class="mb-row">
          <label for="content_href" class="h13"><span><?php _e('Cookie policy URL', 'cookie_consent'); ?></span></label> 
          <input name="content_href" size="80" type="url" value="<?php echo osc_esc_html($content_href); ?>" />

          <div class="mb-explain"><?php _e('Enter URL of your cookie policy page.', 'cookie_consent'); ?></div>
        </div>
        

        <div class="mb-row">
          <label for="content_message" class="h14"><span><?php _e('Box text', 'cookie_consent'); ?></span></label> 
          <input name="content_message" size="120" type="text" value="<?php echo osc_esc_html($content_message); ?>" />

          <div class="mb-explain"><?php _e('Main message content. Leave blank/empty to use message from translation PO file for multilingual support. If blank, message can be changed from translation file.', 'cookie_consent'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="content_link" class="h15"><span><?php _e('Cookie policy link text', 'cookie_consent'); ?></span></label> 
          <input name="content_link" type="text" value="<?php echo osc_esc_html($content_link); ?>" />

          <div class="mb-explain"><?php _e('Cookie policy link text. Leave blank/empty to use message from translation PO file for multilingual support. If blank, message can be changed from translation file.', 'cookie_consent'); ?></div>
        </div>        
        
        <div class="mb-row">
          <label for="content_button" class="h16"><span><?php _e('Consent button text', 'cookie_consent'); ?></span></label> 
          <input name="content_button" type="text" value="<?php echo osc_esc_html($content_button); ?>" />

          <div class="mb-explain"><?php _e('Accept/consent button text. Leave blank/empty to use message from translation PO file for multilingual support. If blank, message can be changed from translation file.', 'cookie_consent'); ?></div>
        </div>     
        

        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(ckc_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'cookie_consent')); ?>"><?php _e('Save', 'cookie_consent');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'cookie_consent');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>


  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'cookie_consent'); ?></div>

    <div class="mb-inside">

      <div class="mb-row">
        <div class="mb-line"><?php _e('Plugin does not require any modifications in theme files.', 'cookie_consent'); ?></div>
      </div>
    </div>
  </div>
</div>


<?php echo ckc_footer(); ?>