<?php

// ENABLE cookie_consent FOR ITEM/LISTING IMAGES
function ckc_generate_box() {
  if(ckc_param('enable') == 1) {
  ?>
    <link rel="stylesheet" type="text/css" href="<?php echo osc_base_url(); ?>oc-content/plugins/cookie_consent/css/cc.min.css"/>
    <script type="text/javascript" src="<?php echo osc_base_url(); ?>oc-content/plugins/cookie_consent/js/cc.min.js"></script>

    <script>
      window.addEventListener("load", function() {
        window.wpcc.init({
          "border": "<?php echo ckc_param('border'); ?>",
          "corners": "<?php echo ckc_param('corners'); ?>",
          "colors": {
            "popup": {
              "background": "<?php echo ckc_param('colors_popup_background'); ?>",
              "text": "<?php echo ckc_param('colors_popup_text'); ?>",
              "border": "<?php echo ckc_param('colors_popup_border'); ?>"
            },
            "button": {
              "background": "<?php echo ckc_param('colors_button_background'); ?>",
              "text": "<?php echo ckc_param('colors_button_text'); ?>"
            }
          },
          "position": "<?php echo ckc_param('position'); ?>",
          "content": {
            "href": "<?php echo osc_esc_html(ckc_param('content_href')); ?>",
            "message": "<?php echo osc_esc_html(ckc_param('content_message') <> '' ? ckc_param('content_message') : __('This website uses cookies to ensure you get the best experience on our website.', 'cookie_consent')); ?>",
            "link":"<?php echo osc_esc_html(ckc_param('content_link') <> '' ? ckc_param('content_link') : __('Learn more', 'cookie_consent')); ?>",
            "button":"<?php echo osc_esc_html(ckc_param('content_button') <> '' ? ckc_param('content_button') : __('Got it!', 'cookie_consent')); ?>"
          },
          "padding": "<?php echo ckc_param('padding'); ?>",
          "margin": "<?php echo ckc_param('margin'); ?>",
          "fontsize": "<?php echo ckc_param('fontsize'); ?>",
          "transparency": "<?php echo ckc_param('transparency'); ?>"
        })
      });
    </script>
  <?php
  }
}

osc_add_hook('footer', 'ckc_generate_box', 10);  



// CORE FUNCTIONS
function ckc_param($name) {
  return osc_get_preference($name, 'plugin-cookie_consent');
}


if(!function_exists('mb_param_update')) {
  function mb_param_update( $param_name, $update_param_name, $type = NULL, $plugin_var_name = NULL ) {
  
    $val = '';
    if( $type == 'check') {

      // Checkbox input
      if( Params::getParam( $param_name ) == 'on' ) {
        $val = 1;
      } else {
        if( Params::getParam( $update_param_name ) == 'done' ) {
          $val = 0;
        } else {
          $val = ( osc_get_preference( $param_name, $plugin_var_name ) != '' ) ? osc_get_preference( $param_name, $plugin_var_name ) : '';
        }
      }
    } else {

      // Other inputs (text, password, ...)
      if( Params::getParam( $update_param_name ) == 'done' && Params::existParam($param_name)) {
        $val = Params::getParam( $param_name );
      } else {
        $val = ( osc_get_preference( $param_name, $plugin_var_name) != '' ) ? osc_get_preference( $param_name, $plugin_var_name ) : '';
      }
    }


    // If save button was pressed, update param
    if( Params::getParam( $update_param_name ) == 'done' ) {

      if(osc_get_preference( $param_name, $plugin_var_name ) == '') {
        osc_set_preference( $param_name, $val, $plugin_var_name, 'STRING');  
      } else {
        $dao_preference = new Preference();
        $dao_preference->update( array( "s_value" => $val ), array( "s_section" => $plugin_var_name, "s_name" => $param_name ));
        osc_reset_preferences();
        unset($dao_preference);
      }
    }

    return $val;
  }
}


// CHECK IF RUNNING ON DEMO
function ckc_is_demo() {
  if(osc_logged_admin_username() == 'admin') {
    return false;
  } else if(isset($_SERVER['HTTP_HOST']) && (strpos($_SERVER['HTTP_HOST'],'mb-themes') !== false || strpos($_SERVER['HTTP_HOST'],'abprofitrade') !== false)) {
    return true;
  } else {
    return false;
  }
}


if(!function_exists('message_ok')) {
  function message_ok( $text ) {
    $final  = '<div class="flashmessage flashmessage-ok flashmessage-inline">';
    $final .= $text;
    $final .= '</div>';
    echo $final;
  }
}


if(!function_exists('message_error')) {
  function message_error( $text ) {
    $final  = '<div class="flashmessage flashmessage-error flashmessage-inline">';
    $final .= $text;
    $final .= '</div>';
    echo $final;
  }
}



// COOKIES WORK
if(!function_exists('mb_set_cookie')) {
  function mb_set_cookie($name, $val) {
    Cookie::newInstance()->set_expires( 86400 * 30 );
    Cookie::newInstance()->push($name, $val);
    Cookie::newInstance()->set();
  }
}


if(!function_exists('mb_get_cookie')) {
  function mb_get_cookie($name) {
    return Cookie::newInstance()->get_value($name);
  }
}

if(!function_exists('mb_drop_cookie')) {
  function mb_drop_cookie($name) {
    Cookie::newInstance()->pop($name);
  }
}


if(!function_exists('mb_generate_rand_string')) {
  function mb_generate_rand_string($length = 10) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $charactersLength = strlen($characters);
    $randomString = '';

    for ($i = 0; $i < $length; $i++) {
      $randomString .= $characters[rand(0, $charactersLength - 1)];
    }

    return $randomString;
  }
}


?>