<?php
/*
  Plugin Name: Cookie Consent Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/extra-fields-and-other/cookie-consent-osclass-plugin-i111
  Description: Cookie consent plugin shows pop-up to accept cookies
  Version: 1.2.0
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: cookie_consent
  Plugin update URI: cookie_consent
  Support URI: https://forums.osclasspoint.com/cookie-consent-osclass-plugin/
  Product Key: 58jeUWqcBCc9AyKktvph
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelCKC.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';



// INSTALL FUNCTION - DEFINE VARIABLES
function ckc_call_after_install() {
  osc_set_preference('enable', 1, 'plugin-cookie_consent', 'INTEGER');
  osc_set_preference('border', 'normal', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('corners', 'normal', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('colors_popup_background', '#000000', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('colors_popup_text', '#ffffff', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('colors_popup_border', '#000000', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('colors_button_background', '#fffc26', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('colors_button_text', '#000000', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('position', 'bottom', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('content_href', '#', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('content_message', '', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('content_link', '', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('content_button', '', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('padding', 'small', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('margin', 'small', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('fontsize', 'small', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('position', 'bottom', 'plugin-cookie_consent', 'STRING');
  osc_set_preference('transparency', '', 'plugin-cookie_consent', 'STRING');

  ModelCKC::newInstance()->install();
}


function ckc_call_after_uninstall() {
  ModelCKC::newInstance()->uninstall();
}



// ADMIN MENU
function ckc_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/cookie_consent/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/cookie_consent/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/cookie_consent/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/cookie_consent/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/cookie_consent/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/cookie_consent/js/bootstrap-switch.js"></script>';



  if( $title == '') { $title = __('Configure', 'cookie_consent'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Cookie Consent Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=cookie_consent/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'cookie_consent') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function ckc_footer() {
  $pluginInfo = osc_plugin_get_info('cookie_consent/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint Market" /> OsclassPoint Market</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'cookie_consent') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'cookie_consent') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'cookie_consent') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function ckc_admin_menu() {
echo '<h3><a href="#">Cookie Consent Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'cookie_consent') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','ckc_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function ckc_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'ckc_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'ckc_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'ckc_call_after_uninstall');

?>