<?php
  // Create menu
  $title = __('Configure', 'email_template');
  emt_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  $active_template = mb_param_update('active_template', 'plugin_action', 'value', 'plugin-email_template');
  $from_email = mb_param_update('from_email', 'plugin_action', 'value', 'plugin-email_template');
  $from_name = mb_param_update('from_name', 'plugin_action', 'value', 'plugin-email_template');
  $title = mb_param_update('title', 'plugin_action', 'value', 'plugin-email_template');
  $support = mb_param_update('support', 'plugin_action', 'check', 'plugin-email_template');


  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'email_template') );
  }

  if(Params::getParam('removeId') > 0) {
    ModelEMT::newInstance()->deletePage(Params::getParam('removeId'));
    message_ok( __('Template successfully removed', 'email_template') );
  }

  if(Params::getParam('plugin_what') == 'template') {
    ModelEMT::newInstance()->updateTemplateById(Params::getParam('templateId'), Params::getParam('emtCode', false, false));
    message_ok( __('Template successfully updated', 'email_template') );
  }



  $templates = ModelEMT::newInstance()->getTemplates();
  $template_id = Params::existParam('templateId') ? Params::getParam('templateId') : $active_template;
  $template = ModelEMT::newInstance()->getTemplateById($template_id);
?>


<div class="mb-body">

  <div class="mb-row mb-notes">
    <div class="mb-line"><strong>{{{TITLE}}}</strong> - <?php _e('Email title, use this tag on place where you want to show title.', 'email_template'); ?></div>
    <div class="mb-line"><strong>{{{CONTENT}}}</strong> - <?php _e('Email content, use this tag on place where you want to show content of email.', 'email_template'); ?></div>
  </div>

  <!-- TEMPLATES MODIFICATOR -->
  <div class="mb-box" id="mb-code-edit">
    <div class="mb-head">
      <i class="fa fa-cog"></i> <?php _e('Template Preview', 'email_template'); ?>

      <select id="templateId" name="templateId">
        <option value="" <?php if($template_id <= 0) { ?>selected="selected"<?php } ?>><?php echo __('Create new template', 'email_template'); ?></option>

        <?php if($templates) { ?>
          <?php foreach($templates as $t) { ?>
            <option value="<?php echo $t['pk_i_id']; ?>" <?php if($template_id == $t['pk_i_id']) { ?>selected="selected"<?php } ?>><?php echo sprintf(__('Template #%d', 'email_template'), $t['pk_i_id']); ?></option>
          <?php } ?>
        <?php } ?>
      </select>

      <?php echo emt_locale_box('configure.php'); ?>
    </div>

    <div class="mb-inside mb-template">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_what" value="template" />
        <input type="hidden" name="emtLocale" value="<?php echo Params::getParam('emtLocale'); ?>" />
        <input type="hidden" name="templateId" value="<?php echo $template_id; ?>" />
        <textarea style="display:none;opacity:0;" id="emtCode" name="emtCode"><?php echo @$template['locales'][emt_get_locale()]; ?></textarea>


        <div class="mb-row">
          <div class="emt-left">
            <div class="mb-row">
              <iframe id="emt-preview" src="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=email_template/admin/template.php&templateId=<?php echo $template_id; ?>&emtLocale=<?php echo emt_get_locale(); ?>"></iframe>
            </div>
          </div>

          <div class="emt-right">
            <div class="mb-row">
              <h3> 
                <?php echo __('Code', 'email_template'); ?>
                <i class="emt-expand fa fa-expand mb-has-tooltip" title="<?php echo osc_esc_html(__('Click to expand/collapse', 'email_template')); ?>"></i>
              </h3>
            </div>

            <div class="mb-row-code" id="mb-row-code"><textarea><?php echo @$template['locales'][emt_get_locale()]; ?></textarea></div>

            <div class="mb-actions">
              <?php if(!emt_is_demo()) { ?><button type="submit" class="mb-button save"><?php _e('Save', 'email_template');?></button><?php } ?>

              <?php if($template_id > 0) { ?>
                <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=email_template/admin/template.php&emtLocale=<?php echo emt_get_locale(); ?>&templateId=<?php echo $template_id; ?>" class="mb-button open" target="_blank"><?php _e('Open in new window', 'email_template'); ?></a>
                <?php if(!emt_is_demo()) { ?><a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=email_template/admin/configure.php&removeId=<?php echo $template_id; ?>" class="mb-button remove" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove this template? Action cannot be undone', 'email_template')); ?>')"><?php _e('Remove', 'email_template');?></a><?php } ?>
              <?php } ?>
            </div>
          </div>
        </div>
      </form>
    </div>
  </div>



  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Configure', 'email_template'); ?></div>

    <div class="mb-inside mb-minify">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />

        <div class="mb-row">
          <label for="active_template" class="h1"><span><?php _e('Active Template', 'email_template'); ?></span></label> 

          <select id="active_template" name="active_template">
            <option value="" <?php if($active_template <= 0) { ?>selected="selected"<?php } ?>><?php echo __('No template', 'email_template'); ?></option>

            <?php if($templates) { ?>
              <?php foreach($templates as $t) { ?>
                <option value="<?php echo $t['pk_i_id']; ?>" <?php if($active_template == $t['pk_i_id']) { ?>selected="selected"<?php } ?>><?php echo sprintf(__('Template #%d', 'email_template'), $t['pk_i_id']); ?></option>
              <?php } ?>
            <?php } ?>
          </select>
          
          <div class="mb-explain"><?php _e('Selected template will be used on all emails. Leave blank to disable.', 'email_template'); ?></div>
        </div>

        <div class="mb-row">
          <label for="from_email" class="h2"><span><?php _e('From Email', 'email_template'); ?></span></label> 
          <input type="text" size="60" name="from_email" id="from_email" value="<?php echo $from_email; ?>"/>
          
          <div class="mb-explain"><?php _e('Change sender email address. Each email send from your osclass will have this email address as source. Leave blank to disable.', 'email_template'); ?></div>
        </div>

        <div class="mb-row">
          <label for="from_name" class="h3"><span><?php _e('From Name', 'email_template'); ?></span></label> 
          <input type="text" size="50" name="from_name" id="from_name" value="<?php echo $from_name; ?>"/>
          
          <div class="mb-explain"><?php _e('Change sender. Each email send from your osclass will have this name as sender. Leave blank to disable.', 'email_template'); ?></div>
        </div>

        <div class="mb-row">
          <label for="title" class="h4"><span><?php _e('Replace Page Title', 'email_template'); ?></span></label> 
          <input type="text" size="80" name="title" id="title" value="<?php echo $title; ?>"/>
          
          <div class="mb-explain"><?php echo sprintf(__('Your osclass title "%s" will be replaced in email title with entered value. Leave blank to disable.', 'email_template'), osc_page_title()); ?></div>
        </div>


        <div class="mb-row">
          <label for="support" class="h5"><span><?php _e('Support Author', 'email_template'); ?></span></label> 
          <input type="checkbox" name="support" id="support" class="element-slide" <?php echo ($support == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain"><?php _e('Author put a lot of effort to build this plugin, give author some credit.', 'email_template'); ?></div>
        </div>


        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(!emt_is_demo()) { ?><button type="submit" class="mb-button"><?php _e('Save', 'email_template');?></button><?php } ?>
        </div>
      </form>
    </div>
  </div>
</div>


<script>
  var emt_reload_url = '<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=email_template/admin/configure.php&emtLocale=<?php echo emt_get_locale(); ?>&templateId=';
</script>

<script src="https://ace.c9.io/build/src/ace.js" type="text/javascript" charset="utf-8"></script>


<script>
    var editor = ace.edit("mb-row-code");
    editor.setTheme("ace/theme/github");
    editor.session.setMode("ace/mode/html");

    var textarea = $('textarea[name="emtCode"]');
    editor.getSession().on("change", function() {
      textarea.val(editor.getSession().getValue()).change();
    });
</script>



<?php echo emt_footer(); ?>