<?php

// MODIFY EMAIL BEFORE IT IS SENT
function emt_send_email($mail, $params) {
  $active = emt_param('active_template');

  if($active <= 0) {
    return $mail;
  }

  $template = ModelEMT::newInstance()->getTemplateById($active);

  if(!$template || emt_email_text(@$template['locales']) == '') {
    return $mail;
  }

  if(emt_param('title') <> '') {
    $mail->Subject = str_replace(osc_page_title(), emt_param('title'), $mail->Subject);
  }


  //$html = file_get_contents(osc_base_path() . 'oc-content/plugins/email_template/template.php');

  $template = ModelEMT::newInstance()->getTemplateById($active);
  $html = emt_email_text(@$template['locales']);

  $mail->Body = str_replace('{{{CONTENT}}}', $mail->Body, $html);
  $mail->Body = str_replace('{{{TITLE}}}', $mail->Subject, $mail->Body);


  if(emt_param('from_name') <> '') {
    $mail->FromName = emt_param('from_name');
  }

  if(emt_param('from_email') <> '') {
    $mail->From = emt_param('from_email');
  }

  return $mail;
}

osc_add_filter('pre_send_mail', 'emt_send_email', 1);





// GET CURRENT OR DEFAULT ADMIN LOCALE
function emt_get_locale() {
  $locales = OSCLocale::newInstance()->listAllEnabled();

  if(Params::getParam('emtLocale') <> '') {
    $current = Params::getParam('emtLocale');
  } else {
    $current = (osc_current_user_locale() <> '' ? osc_current_user_locale() : osc_current_admin_locale());
    $current_exists = false;

    // check if current locale exist in front-office
    foreach( $locales as $l ) {
      if($current == $l['pk_c_code']) {
        $current_exists = true;
      }
    }

    if( !$current_exists ) {
      $i = 0;
      foreach( $locales as $l ) {
        if( $i==0 ) {
          $current = $l['pk_c_code'];
        }

        $i++;
      }
    }
  }

  return $current;
}


// GET NOT EMPTY TEXT
function emt_email_text($field, $locale = '') {
  if ($locale == '') {
    $locale = osc_current_user_locale();
  }
 
  $text = @$field[$locale];

  if($text == '') {
    $text = @$field[osc_language()];

    if($text == '') {
      $aLocales = osc_get_locales();
      foreach($aLocales as $locale) {
        $text = @$field[@$locale['pk_c_code']];
        if($text != '') {
          break;
        }
      }
    }
  }

  return (string) $text;
}


// CHECK IF RUNNING ON DEMO
function emt_is_demo() {
  if(osc_logged_admin_username() == 'admin') {
    return false;
  } else if(isset($_SERVER['HTTP_HOST']) && (strpos($_SERVER['HTTP_HOST'],'mb-themes') !== false || strpos($_SERVER['HTTP_HOST'],'abprofitrade') !== false)) {
    return true;
  } else {
    return false;
  }
}


// CREATE LOCALE SELECT BOX
function emt_locale_box( $file ) {
  $html = '';
  $locales = OSCLocale::newInstance()->listAllEnabled();
  $current = emt_get_locale();

  $html .= '<select rel="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&templateId=' . Params::getParam('templateId') . '&file=email_template/admin/' . $file . '" class="mb-select mb-select-locale" id="emtLocale" name="emtLocale">';

  foreach( $locales as $l ) {
    $html .= '<option value="' . $l['pk_c_code'] . '" ' . ($current == $l['pk_c_code'] ? 'selected="selected"' : '') . '>' . $l['s_name'] . '</option>';
  }
 
  $html .= '</select>';
  return $html;
}


// CORE FUNCTIONS
function emt_param($name) {
  return osc_get_preference($name, 'plugin-email_template');
}


// SUPPORT AUTHOR
function emt_support() {
  if(osc_is_ad_page()) {
    if(osc_get_preference('support', 'plugin-email_template') == 1) {
      echo '<div class="mnf-support"><a href="https://osclasspoint.com/" style="display:block;width:auto;margin:15px auto;clear:both;text-align:center;font-size:11px;color:#999;">Osclass Theme</a></div>';
    }
  }
}

osc_add_hook('footer', 'emt_support');


if(!function_exists('mb_param_update')) {
  function mb_param_update( $param_name, $update_param_name, $type = NULL, $plugin_var_name = NULL ) {
  
    $val = '';
    if( $type == 'check') {

      // Checkbox input
      if( Params::getParam( $param_name ) == 'on' ) {
        $val = 1;
      } else {
        if( Params::getParam( $update_param_name ) == 'done' ) {
          $val = 0;
        } else {
          $val = ( osc_get_preference( $param_name, $plugin_var_name ) != '' ) ? osc_get_preference( $param_name, $plugin_var_name ) : '';
        }
      }
    } else {

      // Other inputs (text, password, ...)
      if( Params::getParam( $update_param_name ) == 'done' && Params::existParam($param_name)) {
        $val = Params::getParam( $param_name );
      } else {
        $val = ( osc_get_preference( $param_name, $plugin_var_name) != '' ) ? osc_get_preference( $param_name, $plugin_var_name ) : '';
      }
    }


    // If save button was pressed, update param
    if( Params::getParam( $update_param_name ) == 'done' ) {

      if(osc_get_preference( $param_name, $plugin_var_name ) == '') {
        osc_set_preference( $param_name, $val, $plugin_var_name, 'STRING');  
      } else {
        $dao_preference = new Preference();
        $dao_preference->update( array( "s_value" => $val ), array( "s_section" => $plugin_var_name, "s_name" => $param_name ));
        osc_reset_preferences();
        unset($dao_preference);
      }
    }

    return $val;
  }
}



if(!function_exists('message_ok')) {
  function message_ok( $text ) {
    $final  = '<div class="flashmessage flashmessage-ok flashmessage-inline">';
    $final .= $text;
    $final .= '</div>';
    echo $final;
  }
}


if(!function_exists('message_error')) {
  function message_error( $text ) {
    $final  = '<div class="flashmessage flashmessage-error flashmessage-inline">';
    $final .= $text;
    $final .= '</div>';
    echo $final;
  }
}


if( !function_exists('osc_is_contact_page') ) {
  function osc_is_contact_page() {
    $location = Rewrite::newInstance()->get_location();
    $section = Rewrite::newInstance()->get_section();
    if( $location == 'contact' ) {
      return true ;
    }

    return false ;
  }
}


// COOKIES WORK
if(!function_exists('mb_set_cookie')) {
  function mb_set_cookie($name, $val) {
    Cookie::newInstance()->set_expires( 86400 * 30 );
    Cookie::newInstance()->push($name, $val);
    Cookie::newInstance()->set();
  }
}


if(!function_exists('mb_get_cookie')) {
  function mb_get_cookie($name) {
    return Cookie::newInstance()->get_value($name);
  }
}

if(!function_exists('mb_drop_cookie')) {
  function mb_drop_cookie($name) {
    Cookie::newInstance()->pop($name);
  }
}

?>