<?php
/*
  Plugin Name: Email Template Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/messaging-and-communication/email-template-osclass-plugin-i82
  Description: Convert your emails into fancy and modern form
  Version: 1.2.0
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: email_template
  Plugin update URI: email_template
  Support URI: https://forums.osclasspoint.com/email-template-plugin/
  Product Key: UkjJPIxfbNfYCxuTfm2N
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelEMT.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';


// INSTALL FUNCTION - DEFINE VARIABLES
function emt_call_after_install() {
  osc_set_preference('active_template', 0, 'plugin-email_template', 'INTEGER');
  osc_set_preference('from_email', '', 'plugin-email_template', 'STRING');
  osc_set_preference('from_name', '', 'plugin-email_template', 'STRING');
  osc_set_preference('title', '', 'plugin-email_template', 'STRING');
  osc_set_preference('support', 1, 'plugin-email_template', 'INTEGER');

  ModelEMT::newInstance()->install();
}


function emt_call_after_uninstall() {
  osc_delete_preference('active_template', 'plugin-email_template');
  osc_delete_preference('from_email', 'plugin-email_template');
  osc_delete_preference('from_name', 'plugin-email_template');
  osc_delete_preference('title', 'plugin-email_template');
  osc_delete_preference('support', 'plugin-email_template');

  ModelEMT::newInstance()->uninstall();
}



// ADMIN MENU
function emt_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/email_template/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/email_template/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/email_template/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/email_template/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/email_template/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/email_template/js/bootstrap-switch.js"></script>';



  if( $title == '') { $title = __('Configure', 'email_template'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Email Template Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=email_template/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'email_template') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function emt_footer() {
  $pluginInfo = osc_plugin_get_info('email_template/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="MB Themes" /> osclasspoint.com</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'email_template') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'email_template') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'email_template') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function emt_admin_menu() {
echo '<h3><a href="#">Email Template Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'email_template') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','emt_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function emt_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'emt_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'emt_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'emt_call_after_uninstall');

?>