<?php
  // Create menu
  $title = __('Configure', 'exchange_rate');
  exr_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  $rate_to_item = mb_param_update('rate_to_item', 'plugin_action', 'check', 'plugin-exchange_rate');
  $service = mb_param_update('service', 'plugin_action', 'value', 'plugin-exchange_rate');
  $amdoren_api_key = mb_param_update('amdoren_api_key', 'plugin_action', 'value', 'plugin-exchange_rate');
  $cca_api_key = mb_param_update('cca_api_key', 'plugin_action', 'value', 'plugin-exchange_rate');
  //$exchangerates_api_key = mb_param_update('exchangerates_api_key', 'plugin_action', 'value', 'plugin-exchange_rate');
  $coinpaprika_api_key = mb_param_update('coinpaprika_api_key', 'plugin_action', 'value', 'plugin-exchange_rate');
  $disable_currencies = mb_param_update('disable_currencies', 'plugin_action', 'value', 'plugin-exchange_rate');
  $apilayer_api_key = mb_param_update('apilayer_api_key', 'plugin_action', 'value', 'plugin-exchange_rate');
  $custom_currencies = mb_param_update('custom_currencies', 'plugin_action', 'value', 'plugin-exchange_rate');


  if(Params::getParam('plugin_action') == 'done') {
    osc_add_flash_ok_message(__('Settings were successfully saved', 'exchange_rate'), 'admin');
    
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=exchange_rate/admin/configure.php');
    exit;
  }

  if(Params::getParam('what') == 'refresh') {
    exr_update_rate();
    osc_add_flash_ok_message(__('Rates refreshed', 'exchange_rate'), 'admin');
    
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=exchange_rate/admin/configure.php');
    exit;
  }

  if(Params::getParam('what') == 'delete' && Params::getParam('from') <> '' && Params::getParam('to') <> '') {
    ModelEXR::newInstance()->deleteCurrency(Params::getParam('from'), Params::getParam('to'));
    osc_add_flash_ok_message(__('Rate removed successfully', 'exchange_rate'), 'admin');
    
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=exchange_rate/admin/configure.php');
    exit;
  }

  $rates = ModelEXR::newInstance()->getRates();
?>


<div class="mb-body">

  <div class="mb-notes">
    <div class="mb-line"><?php _e('CoinPaprika API will only convert crypto currencies from and to USD. If you do not have USD currency, no action will be made.', 'exchange_rate'); ?></div>
    <div class="mb-line"><?php _e('CoinPaprika API will search for currency based on currency code, name or symbol (description). One of these must match.', 'exchange_rate'); ?></div>
  </div>
  
  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Configure', 'exchange_rate'); ?></div>

    <div class="mb-inside mb-rate">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />

        <div class="mb-row">
          <label for="rate_to_item" class="h0"><span><?php _e('Add to price', 'exchange_rate'); ?></span></label> 
          <input name="rate_to_item" id="rate_to_item" type="checkbox" class="element-slide" <?php echo ($rate_to_item == 1 ? 'checked="checked"' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, conversions will be automatically added to item price.', 'exchange_rate'); ?></div>
        </div>


        <div class="mb-row">
          <label for="service" class=""><span><?php _e('Service', 'exchange_rate'); ?></span></label> 
          <select name="service">
            <option value="" <?php if($service == '') { ?>selected="selected"<?php } ?>><?php _e('No service selected', 'exchange_rate'); ?></option>
            <option value="amdoren" <?php if($service == 'amdoren') { ?>selected="selected"<?php } ?>><?php _e('Amdoren.com', 'exchange_rate'); ?></option>
            <option value="currencyconverterapi" <?php if($service == 'currencyconverterapi') { ?>selected="selected"<?php } ?>><?php _e('CurrencyConverterApi.com', 'exchange_rate'); ?></option>
            <option value="apilayer" <?php if($service == 'apilayer') { ?>selected="selected"<?php } ?>><?php _e('APILayer.com', 'exchange_rate'); ?></option>
            <option value="coinpaprika" <?php if($service == 'coinpaprika') { ?>selected="selected"<?php } ?>><?php _e('CoinPaprika.com', 'exchange_rate'); ?></option>
          </select>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Please select service - API you want to use to feed exchange rates. Exchange rates are refreshed once per day via CRON.', 'exchange_rate'); ?></div>
            <div class="mb-line"><a href="https://www.amdoren.com/currency-api/" target="_blank">Amdoren.com</a></div>
            <div class="mb-line"><a href="https://free.currencyconverterapi.com/" target="_blank">CurrencyConverterApi.com</a></div>
            <div class="mb-line"><a href="https://apilayer.com/marketplace/exchangerates_data-api?txn=free&live_demo=show" target="_blank">APILayer.com</a></div>
            <div class="mb-line"><a href="https://api.coinpaprika.com/#section/Introduction" target="_blank">CointPaprika.com</a></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="amdoren_api_key" class=""><span><?php _e('Amdoren API Key', 'exchange_rate'); ?></span></label> 
          <input name="amdoren_api_key" size="60" id="amdoren_api_key" type="text"  value="<?php echo $amdoren_api_key; ?>" />
          
          <div class="mb-explain"><?php _e('Amdoren service require to put backlink into your site, when using free plan.', 'exchange_rate'); ?></div>
        </div>

        <div class="mb-row">
          <label for="cca_api_key" class=""><span><?php _e('CurrencyConverterApi API Key', 'exchange_rate'); ?></span></label> 
          <input name="cca_api_key" size="60" id="cca_api_key" type="text"  value="<?php echo $cca_api_key; ?>" />
          
          <div class="mb-explain"><?php _e('You can request your free api key here:', 'exchange_rate'); ?> https://free.currencyconverterapi.com/free-api-key</div>
        </div>
        
        <div class="mb-row">
          <label for="apilayer_api_key" class=""><span><?php _e('APILayer.com API Key', 'exchange_rate'); ?></span></label> 
          <input name="apilayer_api_key" size="60" id="apilayer_api_key" type="text"  value="<?php echo $apilayer_api_key; ?>" />
          
          <div class="mb-explain"><?php _e('You can request your free api key here:', 'exchange_rate'); ?> https://apilayer.com/</div>
        </div>
        
        <div class="mb-row">
          <label for="coinpaprika_api_key" class=""><span><?php _e('CoinPaprika.com API Key', 'exchange_rate'); ?></span></label> 
          <input name="coinpaprika_api_key" size="60" id="coinpaprika_api_key" type="text"  value="<?php echo $coinpaprika_api_key; ?>" />
          
          <div class="mb-explain"><?php _e('API is not needed for free plan:', 'exchange_rate'); ?> https://coinpaprika.com/api/panel/</div>
        </div>
        
        <div class="mb-row">
          <label for="disable_currencies" class=""><span><?php _e('Disable Currencies', 'exchange_rate'); ?></span></label> 
          <input name="disable_currencies" size="60" id="disable_currencies" type="text"  value="<?php echo $disable_currencies; ?>" />
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Curencies will be removed from currency select box on publish/edit item page.', 'exchange_rate'); ?></div>
            <div class="mb-line"><?php _e('Enter currency codes (USD, EUR, ...).', 'exchange_rate'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="custom_currencies" class=""><span><?php _e('Custom Currencies', 'exchange_rate'); ?></span></label> 
          <input name="custom_currencies" size="90" id="custom_currencies" type="text"  value="<?php echo $custom_currencies; ?>" />
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Define own extra currencies those are not installed in your Osclass.', 'exchange_rate'); ?></div>
            <div class="mb-line"><?php _e('Enter currency code in format CODE-Symbol, delimit by comma.', 'exchange_rate'); ?></div>
            <div class="mb-line"><?php _e('Code must be 3 letter upper case. Dash is delimiter between code and symbol. No whitespaces.', 'exchange_rate'); ?></div>
            <div class="mb-line"><?php _e('Example: CZK-Kč,PLN-Złoty,HUF-Ft', 'exchange_rate'); ?></div>
          </div>
        </div>


        <div class="mb-row">
          <a style="margin-left:25%;" class="mb-button-green" href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=exchange_rate/admin/configure.php&what=refresh"><?php _e('Refresh rates', 'exchange_rate'); ?></a>
        </div>



        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(exr_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'exchange_rate')); ?>"><?php _e('Save', 'exchange_rate');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'exchange_rate');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>



  <!-- RATES SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-list"></i> <?php _e('Exchange rates', 'exchange_rate'); ?></div>

    <div class="mb-inside mb-rate-list">
 
      <div class="mb-table mb-table-rates">
        <div class="mb-table-head">
          <div class="mb-col-3 mb-align-left"><span><?php _e('Base currency', 'exchange_rate');?></span></div>
          <div class="mb-col-3 mb-align-left"><span><?php _e('To currency', 'exchange_rate');?></span></div>
          <div class="mb-col-3 mb-align-left"><span><?php _e('Rate', 'exchange_rate');?></span></div>
          <div class="mb-col-11 mb-align-left"><span><?php _e('Interpretation', 'exchange_rate');?></span></div>
          <div class="mb-col-3 mb-align-left"><span><?php _e('Updated on', 'exchange_rate');?></span></div>
          <div class="mb-col-1 mb-align-left"><span><?php _e('Del', 'exchange_rate');?></span></div>
        </div>

        <?php if(count($rates) > 0) { ?>
          <?php foreach($rates as $r) { ?>
            <div class="mb-table-row">
              <div class="mb-col-3 mb-align-left"><?php echo $r['s_from']; ?></div>
              <div class="mb-col-3 mb-align-left"><?php echo $r['s_to']; ?></div>
              <div class="mb-col-3 mb-align-left"><?php echo number_format($r['f_rate'], 5); ?></div>
              <div class="mb-col-11 mb-col-inter mb-align-left">1 <?php echo $r['s_from']; ?> = <?php echo number_format($r['f_rate'], 3); ?> <?php echo $r['s_to']; ?></div>
              <div class="mb-col-3 mb-align-left mb-date"><span class="mb-has-tooltip-light" title="<?php echo date('Y-m-d h:i:s', strtotime($r['dt_date'])); ?>"><?php echo date('Y-m-d', strtotime($r['dt_date'])); ?></span></div>
              <div class="mb-col-1"><a class="mb-delete mb-button-red" href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=exchange_rate/admin/configure.php&what=delete&from=<?php echo $r['s_from']; ?>&to=<?php echo $r['s_to']; ?>"><i class="fa fa-trash"></i></a></div>

            </div>
          <?php } ?>
        <?php } else { ?>
          <div class="mb-table-row mb-row-empty">
            <i class="fa fa-warning"></i><span><?php _e('No exchange rates has been found', 'exchange_rate'); ?></span>
          </div>
        <?php } ?>

      </div>
    </div>
  </div>


  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'exchange_rate'); ?></div>

    <div class="mb-inside">

      <div class="mb-row">
        <div class="mb-line"><?php _e('By default, plugin does not require any modifications in theme, however you may use it\'s functions:', 'exchange_rate'); ?>:</div>
        <div class="mb-line"><br/></div>

        <div class="mb-line"><strong><?php echo __('Get rates (array) based on base currency', 'exchange_rate'); ?></strong></div>
        <span class="mb-code">&lt;?php if(function_exists('exr_get_rates')) { echo exr_get_rates($base_currency); } ?&gt;</span>
        <div class="mb-line"><br/></div>

        <div class="mb-line"><strong><?php echo __('Get rate based on base and target currency', 'exchange_rate'); ?></strong></div>
        <span class="mb-code">&lt;?php if(function_exists('exr_get_rate')) { echo exr_get_rate($base, $target); } ?&gt;</span>
        <div class="mb-line"><br/></div>

        <div class="mb-line"><strong><?php echo __('Convert amount', 'exchange_rate'); ?></strong></div>
        <span class="mb-code">&lt;?php if(function_exists('exr_convert')) { echo exr_convert($base, $target, $amount); } ?&gt;</span>
        <div class="mb-line"><br/></div>


      </div>
    </div>
  </div>
</div>


<?php echo exr_footer(); ?>