<?php
/*
  Plugin Name: Exchange Rate Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/payments-and-shopping/exchange-rate-multicurrency-plugin-i92
  Description: Plugin enables to show listing price in multiple currencies
  Version: 1.3.0
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: exchange_rate
  Plugin update URI: exchange_rate
  Support URI: https://forums.osclasspoint.com/exchange-rate-plugin/
  Product Key: Z0hyzNqGCzOmCfC4NGVn
*/



require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelEXR.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';



// INSTALL FUNCTION - DEFINE VARIABLES
function exr_call_after_install() {
  osc_set_preference('rate_to_item', 0, 'plugin-exchange_rate', 'INTEGER');
  osc_set_preference('service', '', 'plugin-exchange_rate', 'STRING');
  osc_set_preference('custom_currencies', '', 'plugin-exchange_rate', 'STRING');
  osc_set_preference('amdoren_api_key', '', 'plugin-exchange_rate', 'STRING');
  osc_set_preference('cca_api_key', '', 'plugin-exchange_rate', 'STRING');
  osc_set_preference('exchangerates_api_key', '', 'plugin-exchange_rate', 'STRING');    // sunset already
  osc_set_preference('cointpaprika_api_key', '', 'plugin-exchange_rate', 'STRING');
  osc_set_preference('disable_currencies', '', 'plugin-exchange_rate', 'STRING');
  osc_set_preference('apilayer_api_key', '', 'plugin-exchange_rate', 'STRING');

  ModelEXR::newInstance()->install();
}


function exr_call_after_uninstall() {
  ModelEXR::newInstance()->uninstall();
}



// ADMIN MENU
function exr_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/exchange_rate/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/exchange_rate/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/exchange_rate/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/exchange_rate/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/exchange_rate/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/exchange_rate/js/bootstrap-switch.js"></script>';



  if( $title == '') { $title = __('Configure', 'exchange_rate'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Exchange Rate Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=exchange_rate/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'exchange_rate') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function exr_footer() {
  $pluginInfo = osc_plugin_get_info('exchange_rate/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint Market" /> OsclassPoint Market</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'exchange_rate') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'exchange_rate') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'exchange_rate') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}


// ADD MENU LINK TO PLUGIN LIST
function exr_admin_menu() {
echo '<h3><a href="#">Exchange Rate Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'exchange_rate') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','exr_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function exr_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'exr_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'exr_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'exr_call_after_uninstall');

?>