<?php

  // Create menu
  $title = __('FAQ categories', 'faq');
  faq_menu($title);

  $locale = (Params::getParam('fk_c_locale_code') <> '' ? Params::getParam('fk_c_locale_code') : Params::getParam('faqLocale'));
  $locale = ($locale <> '' ? $locale : faq_get_locale());


  if(Params::getParam('removeImageId') > 0 && !faq_is_demo()) {
    $id = Params::getParam('removeImageId');
    $category = ModelFAQ::newInstance()->getCategory($id);
    $upload_dir = osc_plugins_path() . 'faq/img/category/';

    if(@$category['s_image'] <> '') {
      if(file_exists($upload_dir . $category['s_image'])) {
        unlink($upload_dir . $category['s_image']);
      }
    }
      
    osc_add_flash_ok_message( __('Category image removed successfully', 'faq'), 'admin');
    header('Location: ' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=faq/admin/category.php&editId=' . $id . '&faqLocale=' . Params::getParam('faqLocale'));
    exit;
  }

  $categories = ModelFAQ::newInstance()->getCategoriesDetail();
  

  if((Params::getParam('editId') > 0 || Params::getParam('editId') == -1) && Params::getParam('plugin_action') == 'done') {
    $id = Params::getParam('editId');

    if($id == -1) {
      $id = ModelFAQ::newInstance()->insertCategory(array('i_order' => Params::getParam('i_order')));
      Params::setParam('editId', $id);
    }

    $category = ModelFAQ::newInstance()->getCategoryDetail($id);

    $data_cat = array(
      'pk_i_id' => $id,
      'i_order' => Params::getParam('i_order')
    );


    $data_locale = array(
      'fk_i_category_id' => $id,
      'fk_c_locale_code' => Params::getParam('faqLocale'),
      's_title' => Params::getParam('s_title'),
      's_description' => Params::getParam('s_description')
    );


    ModelFAQ::newInstance()->updateCategory($data_cat, $data_locale);
    

    // UPLOAD IMAGE
    $upload_status = false;
    if(isset($_FILES['image']) && $_FILES['image']['name'] <> ''){
      $upload_dir = osc_plugins_path() . 'faq/img/category/';

      if(@$category['s_image'] <> '') {
        if(file_exists($upload_dir . $category['s_image'])) {
          unlink($upload_dir . $category['s_image']);
        }
      }


      $file_ext = $ext = strtolower(pathinfo($_FILES['image']['name'])['extension']);
      $file_name  = $id . '.' . $file_ext;
      $file_tmp   = $_FILES['image']['tmp_name'];
      $file_type  = $_FILES['image']['type'];   
      $extensions = array('jpg', 'jpeg', 'png', 'gif', 'svg', 'webp');

      if(in_array($file_ext,$extensions) === false) {
        $errors = sprintf(__('extension not allowed, allowed image extensions are %s', 'faq'), implode(', ', $extensions));
      }

      if(empty($errors)==true){
        move_uploaded_file($file_tmp, $upload_dir.$file_name);
        $upload_status = true;
        ModelFAQ::newInstance()->updateCategoryImage($id, $file_name);
      } else {
        message_error(__('There was error when uploading image', 'faq') . ': ' . $errors);
      }
    }

    message_ok( __('Category successfully updated', 'faq') );
  }


  if(Params::getParam('deleteId') > 0 && !faq_is_demo()) {
    ModelFAQ::newInstance()->removeCategory(Params::getParam('deleteId'));
    message_ok( __('Category removed successfully', 'faq') );
  }

  $categories = ModelFAQ::newInstance()->getCategoriesDetail();
?>

<div class="mb-body">
  <div class="mb-message-js"></div>

  <?php if(Params::getParam('editId') > 0 || Params::getParam('editId') == -1) { ?>
    <?php 
      $category = ModelFAQ::newInstance()->getCategoryDetail(Params::getParam('editId'));
    ?>

    <div class="mb-box">
      <div class="mb-head">
        <i class="fa fa-plus-circle"></i> <?php _e('Add/edit category', 'faq'); ?>
        <?php echo faq_locale_box('category.php&editId=' . Params::getParam('editId')); ?>
      </div>

      <div class="mb-inside mb-category-edit">
        <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
          <input type="hidden" name="page" value="plugins" />
          <input type="hidden" name="action" value="renderplugin" />
          <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>category.php" />
          <input type="hidden" name="plugin_action" value="done" />
          <input type="hidden" name="faqLocale" value="<?php echo (@$category['fk_c_locale_code'] <> '' ? $category['fk_c_locale_code'] : $locale); ?>" />
          <input type="hidden" name="editId" value="<?php echo Params::getParam('editId'); ?>" />

          <div class="mb-row">
            <label for="s_title"><?php _e('Name', 'faq'); ?></label>
            <input type="text" id="s_title" name="s_title" size="30" value="<?php echo @$category['s_title']; ?>" />

            <div class="mb-explain"><?php _e('Short name or title of category.', 'faq'); ?></div>
          </div>

          <div class="mb-row">
            <label for="s_description"><?php _e('Description', 'faq'); ?></label>
            <textarea id="s_description" name="s_description"><?php echo @$category['s_description']; ?></textarea>

            <div class="mb-explain"><?php _e('Detail description or summary of category.', 'faq'); ?></div>
          </div>

          <div class="mb-row">
            <label for="i_order"><?php _e('Order', 'faq'); ?></label>
            <input type="number" id="i_order" name="i_order" size="10" value="<?php echo @$category['i_order']; ?>" />

            <div class="mb-explain"><?php _e('Category order/position number.', 'faq'); ?></div>
          </div>
          
          <div class="mb-row image">
            <label for="image"><span><?php _e('Image', 'faq'); ?></span></label> 
     
            <div class="mb-image-right-box">
              <?php $img = faq_category_img($category, false, date('YmdHis')); ?>
              <?php if($img !== false) { ?>
                <?php if(!faq_is_demo()) { ?>
                  <a class="mb-remove-image mb-has-tooltip-light" href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=faq/admin/category.php&removeImageId=<?php echo @$category['pk_i_id']; ?>&faqLocale=<?php echo (@$category['fk_c_locale_code'] <> '' ? $category['fk_c_locale_code'] : $locale); ?>" title="<?php echo osc_esc_html(__('Remove image', 'faq')); ?>"><i class="fa fa-trash"></i></a>
                <?php } ?>
                
                <a class="mb-img-preview" href="<?php echo $img; ?>" target="_blank"><img class="mb-faq-img" src="<?php echo $img; ?>" /></a>
              <?php } ?>

              <div class="mb-file">
                <label class="file-label">
                  <span class="wrap"><i class="fa fa-paperclip"></i> <span><?php echo ($img === false ? __('Upload image', 'faq') : __('Replace image', 'faq')); ?></span></span>
                  <input type="file" id="image" name="image" />
                </label>

                <div class="file-text"><?php _e('Allowed extensions', 'faq'); ?>: .png, .jpg, .gif</div>
              </div>
            </div>
          </div>

          <div class="mb-row">&nbsp;</div>

          <div class="mb-foot">
            <?php if(faq_is_demo()) { ?>
              <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'faq')); ?>"><?php _e('Save', 'faq');?></a>
            <?php } else { ?>
              <button type="submit" class="mb-button"><?php _e('Save', 'faq');?></button>
            <?php } ?>
          </div>
        </form>
      </div>
    </div>
  <?php } ?>



  <!-- CATEGORIES SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-list"></i> <?php echo $title; ?>
      <?php echo faq_locale_box('category.php'); ?>
    </div>

    <div class="mb-inside mb-faq-category">

      <div class="mb-row mb-notes">
        <div class="mb-line"><?php _e('List of categories to which FAQ items can be assigned.', 'faq'); ?></div>
      </div>

      <div class="mb-table mb-table-category" id="mb-faq-categories">
        <div class="mb-table-head">
          <div class="mb-col-1"><span>&nbsp;</span></div>
          <div class="mb-col-1"><span><?php _e('ID', 'faq');?></span></div>
          <div class="mb-col-2 mb-align-left"><span><?php _e('Image', 'faq');?></span></div>
          <div class="mb-col-5 mb-align-left"><span><?php _e('Name', 'faq');?></span></div>
          <div class="mb-col-9 mb-align-left"><span><?php _e('Description', 'faq');?></span></div>
          <div class="mb-col-4 mb-align-left"><span><?php _e('FAQ Items', 'faq');?></span></div>
          <div class="mb-col-2"><span>&nbsp;</span></div>
        </div>

        <?php if(count($categories) <= 0) { ?>
          <div class="mb-table-row mb-row-empty">
            <i class="fa fa-warning"></i><span><?php _e('No categories has been found', 'faq'); ?></span>
          </div>
        <?php } else { ?>
          <?php foreach($categories as $c) { ?>
            <div class="mb-table-row" id="cat_<?php echo $c['pk_i_id']; ?>" data-id="<?php echo $c['pk_i_id']; ?>">
              <div class="mb-col-1 cmove"><i class="fa fa-arrows mb-has-tooltip move" title="<?php echo osc_esc_html(__('Reorder categories', 'faq')); ?>"></i></div>
              <div class="mb-col-1"><?php echo $c['pk_i_id']; ?></div>
              <div class="mb-col-2 cimg mb-align-left"><img src="<?php echo faq_category_img($c, true, date('YmdHis')); ?>"/></div>
              <div class="mb-col-5 mb-align-left cnowrap"><?php echo ($c['s_title'] <> '' ? $c['s_title'] : __('New category', 'faq') . ' (' . faq_get_locale() . ')'); ?></div>
              <div class="mb-col-9 mb-align-left cnowrap"><?php echo ($c['s_description'] <> '' ? $c['s_description'] : '-'); ?></div>
              <div class="mb-col-4 mb-align-left"><a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=faq/admin/item_list.php&categoryId=<?php echo $c['pk_i_id']; ?>"><?php echo ($c['item_count'] == 1 ? __('1 item', 'faq') : sprintf(__('%d items', 'faq'), $c['item_count'])); ?></a></div>
              <div class="mb-col-2">
                <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=faq/admin/category.php&editId=<?php echo $c['pk_i_id']; ?>&faqLocale=<?php echo faq_get_locale(); ?>" class="mb-btn mb-button-white"><i class="fa fa-pencil"></i></a>

                <?php if(!faq_is_demo()) { ?>
                  <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=faq/admin/category.php&deleteId=<?php echo $c['pk_i_id']; ?>&faqLocale=<?php echo faq_get_locale(); ?>" class="mb-btn mb-button-red" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove this category? Action cannot be undone', 'faq')); ?>')"><i class="fa fa-trash-o"></i></a>
                <?php } ?>
              </div>
            </div>
          <?php } ?>
        <?php } ?>
      </div>

      <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=faq/admin/category.php&editId=-1&faqLocale=<?php echo faq_get_locale(); ?>" class="mb-add-user mb-add-category"><i class="fa fa-plus-circle"></i><?php _e('Add a new category', 'faq'); ?></a>

      <div class="mb-row">&nbsp;</div>

    </div>
  </div>
</div>


<script type="text/javascript">
  var faq_position_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=faq_category_position";

  var faq_message_ok = "<?php echo osc_esc_html(__('Success!', 'faq')); ?>";
  var faq_message_wait = "<?php echo osc_esc_html(__('Updating, please wait...', 'faq')); ?>";
  var faq_message_error = "<?php echo osc_esc_html(__('Error!', 'faq')); ?>";


  $(document).ready(function(){
    var faq_list = '';

    $('#mb-faq-categories').sortable({
      axis: "y",
      forcePlaceholderSize: true,
      handle: '.move',
      helper: 'clone',
      items: '.mb-table-row',
      opacity: .8,
      placeholder: 'placeholder',
      revert: 100,
      tabSize: 5,
      tolerance: 'intersect',
      start: function(event, ui) {
        faq_list = $(this).sortable('serialize');
      },
      stop: function (event, ui) {
        var c_faq_list = $(this).sortable('serialize');

        faq_message(faq_message_wait, 'info');

        if(faq_list != c_faq_list) {
          $.ajax({
            url: faq_position_url,
            type: "GET",
            data: c_faq_list,
            success: function(response){
              //console.log(response);
              faq_message(faq_message_ok, 'ok');
            },
            error: function(response) {
              faq_message(faq_message_error, 'error');
              console.log(response);
            }
          });
        }
      }
    });

  });
</script>


<?php echo faq_footer(); ?>