<?php
  // Create menu
  $title = __('Configure', 'faq');
  faq_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value
  $home_search_block = mb_param_update('home_search_block', 'plugin_action', 'check', 'plugin-faq');
  $home_category_block = mb_param_update('home_category_block', 'plugin_action', 'check', 'plugin-faq');
  $home_post_block = mb_param_update('home_post_block', 'plugin_action', 'check', 'plugin-faq');
  $home_post_type = mb_param_update('home_post_type', 'plugin_action', 'value', 'plugin-faq');
  $home_post_limit = mb_param_update('home_post_limit', 'plugin_action', 'value', 'plugin-faq');
  $helpful_enabled = mb_param_update('helpful_enabled', 'plugin_action', 'check', 'plugin-faq');
  $helpful_enabled_only_logged = mb_param_update('helpful_enabled_only_logged', 'plugin_action', 'check', 'plugin-faq');

  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'faq') );
  }
?>


<div class="mb-body">

  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-wrench"></i> <?php _e('Configure', 'faq'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />


        <div class="mb-row">
          <label for="home_search_block"><span><?php _e('Enable Search Block', 'faq'); ?></span></label> 
          <input type="checkbox" name="home_search_block" id="home_search_block" class="element-slide" <?php echo ($home_search_block == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain"><?php _e('When enabled, search block is available at FAQ home page.', 'faq'); ?></div>
        </div>

        <div class="mb-row">
          <label for="home_category_block"><span><?php _e('Enable Category Block', 'faq'); ?></span></label> 
          <input type="checkbox" name="home_category_block" id="home_category_block" class="element-slide" <?php echo ($home_category_block == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain"><?php _e('When enabled, category block is available at FAQ home page.', 'faq'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="home_post_block"><span><?php _e('Enable FAQ Items Block', 'faq'); ?></span></label> 
          <input type="checkbox" name="home_post_block" id="home_post_block" class="element-slide" <?php echo ($home_post_block == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain"><?php _e('When enabled, FAQ items block is available at FAQ home page.', 'faq'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="home_post_type"><span><?php _e('FAQ Items Type', 'faq'); ?></span></label> 
          <select name="home_post_type">
            <option value="HELPFUL" <?php if($home_post_type == 'HELPFUL' || $home_post_type == '') { ?>selected="selected"<?php } ?>><?php _e('Most helpful items', 'faq'); ?></option>
            <option value="VIEW" <?php if($home_post_type == 'VIEW') { ?>selected="selected"<?php } ?>><?php _e('Most viewed items', 'faq'); ?></option>
            <option value="LATEST" <?php if($home_post_type == 'LATEST') { ?>selected="selected"<?php } ?>><?php _e('Lately created items', 'faq'); ?></option>
            <option value="DEFAULT" <?php if($home_post_type == 'DEFAULT') { ?>selected="selected"<?php } ?>><?php _e('Defaulty sorted items', 'faq'); ?></option>
          </select>
          
          <div class="mb-explain"><?php _e('Select in what way are FAQ items on home page generated/sorted', 'faq'); ?></div>
        </div>

        <div class="mb-row">
          <label for="home_post_limit"><span><?php _e('Home Page Items Limit', 'faq'); ?></span></label> 
          <input type="number" size="10" name="home_post_limit" id="home_post_limit" value="<?php echo $home_post_limit; ?>"/>
          <div class="mb-input-desc"><?php _e('items', 'faq'); ?></div>

          <div class="mb-explain"><?php _e('Limit number of items shown in home page block.', 'faq'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="helpful_enabled"><span><?php _e('Enable Helpful Block', 'faq'); ?></span></label> 
          <input type="checkbox" name="helpful_enabled" id="helpful_enabled" class="element-slide" <?php echo ($helpful_enabled == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain"><?php _e('When enabled, under each item will be shown section with how many users marked item as helpful or not helpful', 'faq'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="helpful_enabled_only_logged"><span><?php _e('Helpful Voting For Logged Users Only', 'faq'); ?></span></label> 
          <input type="checkbox" name="helpful_enabled_only_logged" id="helpful_enabled_only_logged" class="element-slide" <?php echo ($helpful_enabled_only_logged == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <?php _e('When enabled, only logged in users can mark item as helpful or not helpful.', 'faq'); ?><br/>
            <?php _e('Every user can vote only once and this is secured via user cookies.', 'faq'); ?>
          </div>
        </div>


        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(faq_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'faq')); ?>"><?php _e('Save', 'faq');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'faq');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>




  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'faq'); ?></div>

    <div class="mb-inside">
      <div class="mb-row"><?php _e('No theme modification are required to use all functions of plugin, it is required only to show link/button to your FAQ page', 'faq'); ?></div>
      <div class="mb-row">
        <strong><?php _e('Button', 'faq'); ?></strong>
        <span class="mb-code">&lt;?php if(function_exists('faq_home_button')) { echo faq_home_button($text = ''); } ?&gt;</span>
      </div>

      <div class="mb-row">
        <strong><?php _e('Raw link', 'faq'); ?></strong>
        <span class="mb-code">&lt;?php if(function_exists('faq_home_link')) { echo faq_home_link(); } ?&gt;</span>
      </div>

      <div class="mb-row"><?php _e('Link to your FAQ home page is:', 'faq'); ?> <a href="<?php echo osc_route_url('faq-home'); ?>"><?php echo osc_route_url('faq-home'); ?></a></div>
    </div>
  </div>
</div>


<?php echo faq_footer(); ?>