<?php
  $id = Params::getParam('itemId') > 0 ? Params::getParam('itemId') : Params::getParam('pk_i_id');
  $id = $id > 0 ? $id : Params::getParam('editId');
  $locale = Params::getParam('faqLocale');

  if($id > 0) {
    $item = ModelFAQ::newInstance()->getItemDetail($id);
  }

  // Create menu
  if($id > 0) {
    $title = __('Update FAQ item', 'faq');
  } else {
    $title = __('Create a new FAQ item', 'faq');
  }

  faq_menu($title);

  $categories = ModelFAQ::newInstance()->getCategoriesDetail();


  if(Params::getParam('plugin_action') == 'done') {
 
    $data_faq = array(
      'pk_i_id' => Params::getParam('pk_i_id'),
      'b_enabled' => Params::getParam('b_enabled'),
      'fk_i_category_id' => Params::getParam('fk_i_category_id'),
      'i_view' => Params::getParam('i_view'),
      'i_helpful' => Params::getParam('i_helpful'),
      'i_nothelpful' => Params::getParam('i_nothelpful'),
      'i_order' => Params::getParam('i_order')
    );

    $data_locale = array(
      'fk_i_item_id' => Params::getParam('pk_i_id'),
      'fk_c_locale_code' => Params::getParam('fk_c_locale_code'),
      's_title' => Params::getParam('s_title'),
      's_description' => Params::getParam('s_description', false, false)
    );


    ModelFAQ::newInstance()->updateItem($data_faq, $data_locale);

    $id = Params::getParam('itemId');
    $item = ModelFAQ::newInstance()->getItemDetail($id);

    message_ok( __('Updates were successfully saved', 'faq') );
  }
?>

<!--<script type="text/javascript" src="<?php echo osc_assets_url('js/tinymce/tinymce.min.js'); ?>"></script>-->
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/tinymce/5.2.0/tinymce.min.js"></script>


<script type="text/javascript">
  tinyMCE.init({
    selector: "textarea#s_description",
    mode : "textareas",
    width: "100%",
    height: "440px",
    theme: "silver",
    images_upload_url: '<?php echo osc_base_url(); ?>oc-content/plugins/faq/tinyMceImageUploader.php',
    images_upload_base_path: '<?php echo osc_content_path(); ?>plugins/faq/img/tinymce/',
    images_upload_credentials: true,

    language: "en",
    content_css : ["//fonts.googleapis.com/css?family=Open+Sans:300,600&amp;subset=latin,latin-ext"],
    content_style: ".mce-content-body {font-family:'Open Sans',Helvetica,Arial,sans-serif;font-size:13px;}",
    theme_advanced_toolbar_align : "left",
    theme_advanced_toolbar_location : "top",
    toolbar: "undo redo paste | bold italic underline strikethrough | forecolor backcolor casechange removeformat | insertfile image media pageembed template link anchor codesample | fontsizeselect fontselect formatselect styleselect |  numlist bullist checklist | charmap pagebreak | alignleft aligncenter alignright alignjustify | outdent indent | fullscreen  preview save print | ltr rtl",
    plugins : [
      "advlist autolink lists link image charmap preview anchor",
      "searchreplace visualblocks code fullscreen",
      "insertdatetime media table paste pagebreak imagetools wordcount"
    ],
    entity_encoding : "raw",
    theme_advanced_buttons1_add : "forecolorpicker,fontsizeselect",
    theme_advanced_buttons2_add: "media",
    theme_advanced_buttons3: "",
    theme_advanced_disable : "styleselect,anchor",
    relative_urls : false,
    remove_script_host : false,
    convert_urls : false,
    paste_data_images: true,

    images_upload_handler: function (blobInfo, success, failure) {
      var xhr, formData;
      xhr = new XMLHttpRequest();
      xhr.withCredentials = false;
      xhr.open('POST', '<?php echo osc_base_url(); ?>oc-content/plugins/faq/tinyMceImageUploader.php');
      xhr.onload = function() {
        var json;

        if (xhr.status != 200) {
        failure('HTTP Error: ' + xhr.status);
        return;
        }
        json = JSON.parse(xhr.responseText);

        if (!json || typeof json.location != 'string') {
        failure('Invalid JSON: ' + xhr.responseText);
        return;
        }
        success(json.location);
      };
      formData = new FormData();
      //formData.append('file', blobInfo.blob(), fileName(blobInfo));

      if( typeof(blobInfo.blob().name) !== undefined )
        fileName = blobInfo.blob().name;
      else
        fileName = blobInfo.filename();
      formData.append('file', blobInfo.blob(), fileName);

      xhr.send(formData);
    }
  });
</script>

<div class="mb-body">

  <!-- NEW POST SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-plus-circle"></i> <?php echo $title; ?>
      <?php echo faq_locale_box('item.php', 'itemId', $id); ?>
    </div>

    <div class="mb-inside mb-faq">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>item.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <input type="hidden" name="faqLocale" value="<?php echo faq_get_locale(); ?>" />
        <input type="hidden" name="fk_c_locale_code" value="<?php echo faq_get_locale(); ?>" />
        <input type="hidden" name="pk_i_id" value="<?php echo $id; ?>" />

        <?php if(count($categories) > 0) { ?>
          <div class="mb-row w20">
            <label for="fk_i_category_id"><?php _e('Category', 'faq'); ?></label>

            <select name="fk_i_category_id" id="fk_i_category_id">
              <option value="" <?php if(@$item['fk_i_category_id'] <= 0) { ?>selected="selected"<?php } ?>><?php _e('Uncategorized', 'faq'); ?></option>

              <?php foreach($categories as $c) { ?>
                <option value="<?php echo $c['pk_i_id']; ?>" <?php if(@$item['fk_i_category_id'] == $c['pk_i_id']) { ?>selected="selected"<?php } ?>><?php echo $c['pk_i_id']; ?> - <?php echo ($c['s_title'] <> '' ? $c['s_title'] : __('New category', 'faq') . ' (' . faq_get_locale() . ')'); ?></option>
              <?php } ?>
            </select>
          </div>
        <?php } ?>

        <div class="mb-row w20">
          <label for="b_enabled"><?php _e('Status', 'faq'); ?></label>

          <select name="b_enabled" id="i_status">
            <option value="1" <?php if(!isset($item) || @$item['b_enabled'] == 1) { ?>selected="selected"<?php } ?>><?php _e('Enabled', 'faq'); ?></option>
            <option value="0" <?php if(isset($item) && @$item['b_enabled'] == 0) { ?>selected="selected"<?php } ?>><?php _e('Disabled', 'faq'); ?></option>
          </select>
        </div>

        <div class="mb-row">
          <label for="s_title"><?php _e('Question / Title', 'faq'); ?></label>
          <input type="text" id="s_title" name="s_title" size="100" value="<?php echo @$item['s_title']; ?>" required />
        </div>

        <div class="mb-row">
          <label for="s_description"><?php _e('Answer / Description', 'faq'); ?></label>
          <div class="mb-desc-box">
            <textarea id="s_description" name="s_description"><?php echo @$item['s_description']; ?></textarea>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="i_view"><?php _e('Views count', 'faq'); ?></label>
          <input type="number" min="0" id="i_view" name="i_view" size="10" value="<?php echo @$item['i_view']; ?>" />
          <div class="mb-input-desc"><?php _e('views', 'faq'); ?></div>
        </div>

        <div class="mb-row">
          <label for="i_helpful"><?php _e('Helpful count', 'faq'); ?></label>
          <input type="number" min="0" id="i_helpful" name="i_helpful" size="10" value="<?php echo @$item['i_helpful']; ?>" />
          <div class="mb-input-desc"><?php _e('checks', 'faq'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="i_nothelpful"><?php _e('Not helpful count', 'faq'); ?></label>
          <input type="number" min="0" id="i_nothelpful" name="i_nothelpful" size="10" value="<?php echo @$item['i_nothelpful']; ?>" />
          <div class="mb-input-desc"><?php _e('checks', 'faq'); ?></div>
       </div>

        <div class="mb-row">
          <label for="i_order"><?php _e('Order/Position', 'faq'); ?></label>
          <input type="number" min="0" id="i_order" name="i_order" size="10" value="<?php echo @$item['i_order']; ?>" />
          <div class="mb-input-desc"><?php _e('position', 'faq'); ?></div>
        </div>
        
        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(faq_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'faq')); ?>"><?php _e('Save', 'faq');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'faq');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>


</div>



<?php echo faq_footer(); ?>