<?php
  // Create menu
  $title = __('FAQ Items', 'faq');
  faq_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value
  $active_template = mb_param_update('active_template', 'plugin_action', 'value', 'plugin-faq');


  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'faq') );
  }


  if(Params::getParam('deleteId') > 0 && !faq_is_demo()) {
    ModelFAQ::newInstance()->removeItem(Params::getParam('deleteId'));
    message_ok( __('Post removed successfully', 'faq') );
  }
?>

<div class="mb-body">
  <div class="mb-message-js"></div>

  <!-- FAQ SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-list"></i> <?php _e('FAQ Items', 'faq'); ?>
    </div>

    <div class="mb-inside mb-faq" id="mb-faq">
      <?php 
        $status_id = (Params::getParam('statusId') <> '' ? Params::getParam('statusId') : -1);
        $category_id = (Params::getParam('categoryId') <> '' ? Params::getParam('categoryId') : -1);

        $items = ModelFAQ::newInstance()->getItemsDetail('STANDARD', $category_id, '', 0, $status_id); 
      ?>
      
      <div class="mb-table mb-faq-category" id="mb-faq-items">
        <div class="mb-table-head">
          <div class="mb-col-1"><span>&nbsp;</span></div>
          <div class="mb-col-1"><span><?php _e('ID', 'faq');?></span></div>
          <div class="mb-col-4 mb-align-left"><span><?php _e('Question', 'faq');?></span></div>
          <div class="mb-col-8 mb-align-left"><span><?php _e('Answer', 'faq');?></span></div>
          <div class="mb-col-2"><span><?php _e('Views', 'faq');?></span></div>
          <div class="mb-col-2"><span><?php _e('Helpful', 'faq');?></span></div>
          <div class="mb-col-2"><span><?php _e('Not helpful', 'faq');?></span></div>
          <div class="mb-col-2"><span><?php _e('Status', 'faq');?></span></div>
          <div class="mb-col-2"><span>&nbsp;</span></div>
        </div>

        <?php if(count($items) > 0) { ?>
          <?php foreach($items as $item) { ?>
            <div class="mb-table-row" id="item_<?php echo $item['pk_i_id']; ?>" data-id="<?php echo $item['pk_i_id']; ?>">
              <div class="mb-col-1 cmove"><i class="fa fa-arrows mb-has-tooltip move" title="<?php echo osc_esc_html(__('Reorder items', 'faq')); ?>"></i></div>
              <div class="mb-col-1"><?php echo $item['pk_i_id']; ?></div>
              <div class="mb-col-4 mb-align-left"><span class="mb-wrapped-text"><?php echo osc_highlight(($item['s_title'] <> '' ? $item['s_title'] : __('New item', 'faq') . ' (' . faq_get_locale() . ')'), 120); ?></span></div>
              <div class="mb-col-8 mb-align-left"><span class="mb-wrapped-text"><?php echo osc_highlight(($item['s_description'] <> '' ? $item['s_description'] : '-'), 160); ?></span></div>
              <div class="mb-col-2"><?php echo ($item['i_view'] > 0 ? $item['i_view'] : 0); ?>x</div>
              <div class="mb-col-2"><?php echo ($item['i_helpful'] > 0 ? $item['i_helpful'] : 0); ?>x</div>
              <div class="mb-col-2"><?php echo ($item['i_nothelpful'] > 0 ? $item['i_nothelpful'] : 0); ?>x</div>
              <div class="mb-col-2 cstatus"><?php echo ($item['b_enabled'] == 1 ? '<i class="fa fa-check"></i> ' . __('Enabled', 'faq') : '<i class="fa fa-times"></i> ' . __('Disabled', 'faq')); ?></div>

              <div class="mb-col-2">
                <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=faq/admin/item.php&editId=<?php echo $item['pk_i_id']; ?>&faqLocale=<?php echo faq_get_locale(); ?>" class="mb-btn mb-button-white"><i class="fa fa-pencil"></i></a>

                <?php if(!faq_is_demo()) { ?>
                  <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=faq/admin/item_list.php&deleteId=<?php echo $item['pk_i_id']; ?>&faqLocale=<?php echo faq_get_locale(); ?>" class="mb-btn mb-button-red" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove this item? Action cannot be undone', 'faq')); ?>')"><i class="fa fa-trash-o"></i></a>
                <?php } ?>
              </div>
            </div>
        
          <?php } ?>
        <?php } else { ?>
          <div class="mb-table-row mb-row-empty">
            <i class="fa fa-warning"></i>
            <span>
              <?php 
                if($status_id >= 0) {
                  _e('No FAQ items with selected status found', 'faq');
                } else if($category_id >= 0) {
                  _e('You have not created any FAQ items in this category yet', 'faq');
                } else {
                  _e('You have not created any FAQ items yet', 'faq');
                } 
              ?>
            </span>
          </div>
          

        <?php } ?>

      </div>
      
      <?php if($status_id == -1) { ?>
        <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=faq/admin/item.php" class="mb-add-faq"><i class="fa fa-plus-circle"></i><?php _e('Add a new FAQ item', 'faq'); ?></a>
      <?php } ?>
    </div>
  </div>
</div>


<script type="text/javascript">
  var faq_position_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=faq_item_position";

  var faq_message_ok = "<?php echo osc_esc_html(__('Success!', 'faq')); ?>";
  var faq_message_wait = "<?php echo osc_esc_html(__('Updating, please wait...', 'faq')); ?>";
  var faq_message_error = "<?php echo osc_esc_html(__('Error!', 'faq')); ?>";


  $(document).ready(function(){
    var faq_list = '';

    $('#mb-faq-items').sortable({
      axis: "y",
      forcePlaceholderSize: true,
      handle: '.move',
      helper: 'clone',
      items: '.mb-table-row',
      opacity: .8,
      placeholder: 'placeholder',
      revert: 100,
      tabSize: 5,
      tolerance: 'intersect',
      start: function(event, ui) {
        faq_list = $(this).sortable('serialize');
      },
      stop: function (event, ui) {
        var c_faq_list = $(this).sortable('serialize');

        faq_message(faq_message_wait, 'info');

        if(faq_list != c_faq_list) {
          $.ajax({
            url: faq_position_url,
            type: "GET",
            data: c_faq_list,
            success: function(response){
              //console.log(response);
              faq_message(faq_message_ok, 'ok');
            },
            error: function(response) {
              faq_message(faq_message_error, 'error');
              console.log(response);
            }
          });
        }
      }
    });

  });
</script>


<?php echo faq_footer(); ?>