<?php
$item_limit = (int)faq_param('home_post_limit');
$item_limit = ($item_limit > 0 ? $item_limit : 10);

$categories = ModelFAQ::newInstance()->getCategoriesDetail();
$items = ModelFAQ::newInstance()->getItemsDetail(faq_param('home_post_type'), '', '', $item_limit);
?>

<div id="faq-body" class="faq-home faq-theme-<?php echo osc_current_web_theme(); ?>">
  <?php if(faq_param('home_search_block') == 1) { ?>
    <div id="faq-search-block">
      <h1><?php _e('How can we help you?', 'faq'); ?></h1>
      
      <form class="faq-search-form" class="nocsrf" method="POST" action="<?php echo osc_route_url('faq-search'); ?>">
        <div class="faq-search-inside">
          <input type="text" name="pattern" placeholder="<?php echo osc_esc_html(__('Describe your question', 'faq')); ?>"/>
          <button class="faq-search-submit" type="submit" title="<?php echo osc_esc_html(__('Search', 'faq')); ?>"><svg viewBox="0 0 24 24"><path d="M20.49 19l-5.73-5.73C15.53 12.2 16 10.91 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.41 0 2.7-.47 3.77-1.24L19 20.49 20.49 19zM5 9.5C5 7.01 7.01 5 9.5 5S14 7.01 14 9.5 11.99 14 9.5 14 5 11.99 5 9.5z"></path><path d="M0 0h24v24H0V0z" fill="none"></path></svg></button>
        </div>
      </form>
    </div>
  <?php } ?>

  <?php if(faq_param('home_category_block') == 1 && is_array($categories) && count($categories) > 0) { ?>
    <div id="faq-category-block">
      <h2><?php _e('Choose a category to find the help you need', 'faq'); ?></h2>
      <div class="faq-category-inside">
        <?php foreach($categories as $cat) { ?>
          <a href="<?php echo osc_route_url('faq-category', array('categoryId' => $cat['pk_i_id'], 'categorySlug' => faq_category_slug($cat))); ?>" class="faq-category">
            <img src="<?php echo faq_category_img($cat); ?>" alt="<?php echo osc_esc_html(faq_category_title($cat)); ?>" />
            <strong><?php echo faq_category_title($cat); ?></strong>
            <span><?php echo faq_category_description($cat); ?></span>
          </a>
        <?php } ?>
      </div>
    </div>
  <?php } ?>

  <?php if(faq_param('home_post_block') == 1) { ?>
    <div id="faq-post-block">
      <h2><?php _e('Most helpful questions', 'faq'); ?></h2>

      <div class="faq-post-inside">
        <?php if(is_array($items) && count($items) > 0) { ?>
          <?php foreach($items as $item) { ?>
            <?php faq_item($item); ?>
          <?php } ?>
        <?php } else { ?>
          <div class="faq-post-empty"><?php _e('We didn\'t find any results', 'faq'); ?></div>
        <?php } ?>
      </div>
    </div>
  <?php } ?>
  
  <?php if(faq_param('home_search_block') != 1 && faq_param('home_category_block') != 1 && faq_param('home_post_block') != 1) { ?>
    <div class="faq-home-empty"><?php _e('All blocks are disabled, go to plugin configuration and enable at least one block on home page', 'faq'); ?></div>
  <?php } ?> 
</div>