<?php 
  $keyword = trim(Params::getParam('pattern')); 
?>
<div class="faq-row<?php echo (trim($class) <> '' ? ' ' . $class : ''); ?>" data-post-id="<?php echo $item['pk_i_id']; ?>">
  <a href="#" class="faq-top" data-post-id="<?php echo $item['pk_i_id']; ?>">
    <div class="faq-title">
      <?php
        if($keyword != '') {
          echo str_ireplace($keyword, '<u class="faq-highlight">' . $keyword . '</u>', strip_tags(faq_item_title($item)));
        } else {
          echo faq_item_title($item);
        }
      ?>    
    </div>
    
    <div class="faq-collapse-icon">
      <svg class="faq-up" viewBox="0 0 24 24" aria-label=""><path d="M7.41 15.41L12 10.83l4.59 4.58L18 14l-6-6-6 6z"></path></svg>
      <svg class="faq-down" viewBox="0 0 24 24" aria-label=""><path d="M7.41 7.84L12 12.42l4.59-4.58L18 9.25l-6 6-6-6z"></path></svg>
    </div>
  </a>
  
  <div class="faq-bottom" style="display:none;">
    <div class="faq-bottom-inside">
      <div class="faq-description">
        <?php echo faq_item_description($item); ?>
      </div>
      
      <?php if(faq_param('helpful_enabled') == 1) { ?>
        <div class="faq-item-footer">
          <div class="faq-helpful">
            <span><?php _e('Was this helpful for you?', 'faq'); ?></span>
            
            <?php if(faq_param('helpful_enabled_only_logged') == 1 && !osc_is_web_user_logged_in()) { ?>
              <a href="#" class="faq-helpful-icon faq-positive faq-voting-disabled" onclick="return false;" title="<?php echo osc_esc_html(__('Login to vote', 'faq')); ?>">
            <?php } else { ?>
              <a href="#" class="faq-helpful-icon faq-positive" data-type="1" data-post-id="<?php echo $item['pk_i_id']; ?>">
            <?php } ?>
              <svg viewBox="0 0 24 24" class="faq-icon-help"><g class="style-scope yt-icon"><path d="M1 21h4V9H1v12zm22-11c0-1.1-.9-2-2-2h-6.31l.95-4.57.03-.32c0-.41-.17-.79-.44-1.06L14.17 1 7.59 7.59C7.22 7.95 7 8.45 7 9v10c0 1.1.9 2 2 2h9c.83 0 1.54-.5 1.84-1.22l3.02-7.05c.09-.23.14-.47.14-.73v-1.91l-.01-.01L23 10z" class="style-scope yt-icon"></path></g></svg>
              <span><?php echo ($item['i_helpful'] > 0 ? $item['i_helpful'] : 0); ?></span>
            </a> 
            
            <?php if(faq_param('helpful_enabled_only_logged') == 1 && !osc_is_web_user_logged_in()) { ?>
              <a href="#" class="faq-helpful-icon faq-negative faq-voting-disabled" onclick="return false;" title="<?php echo osc_esc_html(__('Login to vote', 'faq')); ?>">
            <?php } else { ?>
              <a href="#" class="faq-helpful-icon faq-negative" data-type="-1" data-post-id="<?php echo $item['pk_i_id']; ?>">
            <?php } ?>
              <svg viewBox="0 0 24 24" class="faq-icon-nothelp"><g class="style-scope yt-icon"><path d="M15 3H6c-.83 0-1.54.5-1.84 1.22l-3.02 7.05c-.09.23-.14.47-.14.73v1.91l.01.01L1 14c0 1.1.9 2 2 2h6.31l-.95 4.57-.03.32c0 .41.17.79.44 1.06L9.83 23l6.59-6.59c.36-.36.58-.86.58-1.41V5c0-1.1-.9-2-2-2zm4 0v12h4V3h-4z" class="style-scope yt-icon"></path></g></svg>
              <span><?php echo ($item['i_nothelpful'] > 0 ? $item['i_nothelpful'] : 0); ?></span>
            </a>     
          </div>
        </div>
      <?php } ?>

    </div>
  </div>
</div> 