<?php
$pattern = trim(Params::getParam('pattern'));
$items = ModelFAQ::newInstance()->getItemsDetail('', '', $pattern);

?>

<div id="faq-body" class="faq-search faq-theme-<?php echo osc_current_web_theme(); ?>">
  <div id="faq-search-block">
    <h1><?php _e('Search results', 'faq'); ?></h1>
    <form class="faq-search-form" class="nocsrf" method="POST" action="<?php echo osc_route_url('faq-search'); ?>">
      <div class="faq-search-inside">
        <input type="text" name="pattern" placeholder="<?php echo osc_esc_html(__('Describe your issue', 'faq')); ?>" value="<?php echo osc_esc_html(Params::getParam('pattern')); ?>"/>
        <button class="faq-search-submit" type="submit" title="<?php echo osc_esc_html(__('Search', 'faq')); ?>"><svg viewBox="0 0 24 24"><path d="M20.49 19l-5.73-5.73C15.53 12.2 16 10.91 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.41 0 2.7-.47 3.77-1.24L19 20.49 20.49 19zM5 9.5C5 7.01 7.01 5 9.5 5S14 7.01 14 9.5 11.99 14 9.5 14 5 11.99 5 9.5z"></path><path d="M0 0h24v24H0V0z" fill="none"></path></svg></button>
      </div>
    </form>
  </div>

  <div id="faq-post-block">
    <h2>
      <?php 
        if($pattern <> '') {
          echo sprintf(__('We\'ve found %d results matching your search "%s"', 'faq'), count($items), $pattern); 
        } else {
          echo sprintf(__('We\'ve found %d results', 'faq'), count($items)); 
        }
      ?>
    </h2>

    <div class="faq-post-inside">
      <?php if(is_array($items) && count($items) > 0) { ?>
        <?php foreach($items as $item) { ?>
          <?php faq_item($item); ?>
        <?php } ?>
      <?php } else { ?>
        <div class="faq-post-empty"><?php _e('We didn\'t find any help results for this search', 'faq'); ?></div>
      <?php } ?>
    </div>
  </div>
  
  
  <div id="faq-link-block">
    <div class="faq-link-inside">
      <a href="<?php echo osc_route_url('faq-home'); ?>" class="faq-link-back"><?php _e('Back to FAQ home', 'faq'); ?></a>
    </div>
  </div>
</div>