<?php
/*
  Plugin Name: FAQ Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/messaging-and-communication/frequently-asked-questions-faq-plugin-i169
  Description: Plugin generate frequently asked questions section in osclass
  Version: 1.0.7
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: faq
  Plugin update URI: faq
  Support URI: https://forums.osclasspoint.com/faq-plugin/
  Product Key: EIvSTp3NyIdV6Dto1Qhx
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelFAQ.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';

osc_enqueue_style('faq-user-style', osc_base_url() . 'oc-content/plugins/faq/css/user.css?v=' . date('YmdHis'));
osc_register_script('faq-user', osc_base_url() . 'oc-content/plugins/faq/js/user.js?v=' . date('YmdHis'), array('jquery'));
osc_enqueue_script('faq-user');

osc_add_route('faq-category', 'faq/(.+)-c([0-9]+)', 'faq/{categorySlug}-c{categoryId}', osc_plugin_folder(__FILE__).'form/category.php', false, 'faq', 'category');
osc_add_route('faq-search', 'faq/search/', 'faq/search/', osc_plugin_folder(__FILE__).'form/search.php', false, 'faq', 'search');
osc_add_route('faq-home', 'faq/', 'faq/', osc_plugin_folder(__FILE__).'form/home.php', false, 'faq', 'home');


// INSTALL FUNCTION - DEFINE VARIABLES
function faq_call_after_install() {
  osc_set_preference('home_search_block', 1, 'plugin-faq', 'INTEGER');
  osc_set_preference('home_category_block', 1, 'plugin-faq', 'INTEGER');
  osc_set_preference('home_post_block', 1, 'plugin-faq', 'INTEGER');
  osc_set_preference('home_post_type', 'HELPFUL', 'plugin-faq', 'STRING');
  osc_set_preference('home_post_limit', 10, 'plugin-faq', 'INTEGER');
  osc_set_preference('helpful_enabled', 1, 'plugin-faq', 'INTEGER');
  osc_set_preference('helpful_enabled_only_logged', 0, 'plugin-faq', 'INTEGER');

  ModelFAQ::newInstance()->install();
}


function faq_call_after_uninstall() {
  ModelFAQ::newInstance()->uninstall();
}


// ADMIN MENU
function faq_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/faq/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/faq/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/faq/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://fonts.googleapis.com/css?family=Open+Sans:300,600&amp;subset=latin,latin-ext" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/faq/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/faq/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/faq/js/bootstrap-switch.js"></script>';

  if( $title == '') { $title = __('Configure', 'faq'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>FAQ Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=faq/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'faq') . '</span></a></li>';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=faq/admin/item_list.php"><i class="fa fa-reorder"></i><span>' . __('FAQ Items', 'faq') . '</span></a></li>';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=faq/admin/item.php"><i class="fa fa-plus-circle"></i><span>' . __('Add FAQ Item', 'faq') . '</span></a></li>';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=faq/admin/category.php"><i class="fa fa-gears"></i><span>' . __('Categories', 'faq') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function faq_footer() {
  $pluginInfo = osc_plugin_get_info('faq/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint Market" /> OsclassPoint Market</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'faq') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'faq') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'faq') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function faq_admin_menu() {
echo '<h3><a href="#">FAQ Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'faq') . '</a></li>
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/item_list.php') . '">&raquo; ' . __('FAQ Items', 'faq') . '</a></li>
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/item.php') . '">&raquo; ' . __('Add Item', 'faq') . '</a></li>
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/category.php') . '">&raquo; ' . __('Categories', 'faq') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','faq_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function faq_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'faq_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'faq_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'faq_call_after_uninstall');

?>