$(document).ready(function() {
  
  // CHECK IF USER SOME ITEMS LIKED/DISLIKED
  if($('.faq-row').length) {
    $('.faq-row').each(function() {
      itemId = $(this).attr('data-post-id');
      //if(faqReadCookie('faq_' + itemId) == 'positive') {
      if(faqReadVoteCookie(itemId) == 'positive') {
        $(this).find('.faq-helpful-icon.faq-positive').addClass('faq-active');
        
      //} else if(faqReadCookie('faq_' + itemId) == 'negative') {
      } else if(faqReadVoteCookie(itemId) == 'negative') {
        $(this).find('.faq-helpful-icon.faq-negative').addClass('faq-active');
      }
    });
  }

  
  $('body').on('click', 'a.faq-helpful-icon', function(e) {
    e.preventDefault();
    
    var itemId = parseInt($(this).closest('.faq-row').attr('data-post-id'));
    var rowElem = $(this).closest('.faq-row');
    
    if(rowElem.find('.faq-helpful').hasClass('faq-disabled') || $(this).hasClass('faq-voting-disabled') || itemId <= 0) {
      return false;
    }

    var iconSelected = '';
    if($(this).hasClass('faq-positive')) {
      iconSelected = 'positive';
    } else if ($(this).hasClass('faq-negative')) {
      iconSelected = 'negative';
    }

    var iconAlreadySelected = '';
    if($(this).closest('.faq-helpful').find('a.faq-helpful-icon.faq-positive').hasClass('faq-active')) {
      iconAlreadySelected = 'positive';
    } else if($(this).closest('.faq-helpful').find('a.faq-helpful-icon.faq-negative').hasClass('faq-active')) {
      iconAlreadySelected = 'negative';
    }
    
    $(this).closest('.faq-helpful').find('a.faq-helpful-icon').removeClass('faq-active');
    $(this).addClass('faq-active');

    if(iconAlreadySelected == 'negative' && iconSelected == 'positive') {
      // substract one negative, add one positive
      //faqCreateCookie('faq_' + itemId, iconSelected);
      faqCreateVoteCookie(itemId, iconSelected);
      faqAdjustVote(rowElem, 1, -1); 
      
    } else if(iconAlreadySelected == 'positive' && iconSelected == 'negative') {
      // substract one positive, add one negative
      //faqCreateCookie('faq_' + itemId, iconSelected);
      faqCreateVoteCookie(itemId, iconSelected);
      faqAdjustVote(rowElem, -1, 1); 

    } else if(iconAlreadySelected == 'positive' && iconSelected == 'positive') {
      // substract one positive, remove class
      $(this).removeClass('faq-active');
      //faqEraseCookie('faq_' + itemId);
      faqEraseVoteCookie(itemId);
      faqAdjustVote(rowElem, -1, 0); 

    } else if(iconAlreadySelected == 'negative' && iconSelected == 'negative') {
      // substract one negative, remove class
      $(this).removeClass('faq-active');
      //faqEraseCookie('faq_' + itemId);
      faqEraseVoteCookie(itemId);
      faqAdjustVote(rowElem, 0, -1); 

    } else if(iconAlreadySelected == '' && iconSelected == 'positive') {
      // add one positive
      //faqCreateCookie('faq_' + itemId, iconSelected);
      faqCreateVoteCookie(itemId, iconSelected);
      faqAdjustVote(rowElem, 1, 0); 

    } else if(iconAlreadySelected == '' && iconSelected == 'negative') {
      // add one negative
      //faqCreateCookie('faq_' + itemId, iconSelected);
      faqCreateVoteCookie(itemId, iconSelected);
      faqAdjustVote(rowElem, 0, 1); 

    }
  });
  
  
  $('body').on('click', '#faq-post-block .faq-row .faq-top', function(e) {
    e.preventDefault();
    
    var itemId = $(this).closest('.faq-row').attr('data-post-id');
    
    if(!$(this).closest('.faq-row').hasClass('faq-expanded')) {
      $('#faq-post-block').find('.faq-row').not(this).removeClass('faq-expanded');
      $('#faq-post-block').find('.faq-bottom').not(this).slideUp(200);
    }
    
    if(!$(this).closest('.faq-row').hasClass('faq-expanded')) {
      // add view counter +1
      faqAdjustView(itemId);
    }
    
    $(this).closest('.faq-row').toggleClass('faq-expanded');
    $(this).siblings('.faq-bottom').slideToggle(200);
  });
  
});


function faqAdjustView(itemId) {
  var cookieString = faqReadCookie('faqViewed');
  var cookie = '';
  
  if(cookieString === null || cookieString == '') {
    cookie = itemId;
  } else {
    cookie = cookieString + ',' + itemId;
  }
  
  cookie = (faqUniqueArray(cookie.split(','))).join(',');
  faqCreateCookie('faqViewed', cookie);

  var cookieCheck = (faqUniqueArray(cookieString.split(','))).join(',');

  if($.inArray(itemId, cookieCheck) == -1) {
    $.ajax({
      type: "POST",
      url: faqBaseUrl + '?faqAction=increaseView&itemId=' + itemId,
      cache: false,
      success: function(data) {},
      error: function(req, err){ console.log('ERROR on AJAX: ' + err); }
    });
  }
}


function faqAdjustVote(rowElem, posVal, negVal) {
  var itemId = $(rowElem).attr('data-post-id');
  elemPos = $(rowElem).find('.faq-helpful-icon.faq-positive');
  elemNeg = $(rowElem).find('.faq-helpful-icon.faq-negative');
  
  var newPosVal = parseInt($(elemPos).find('span').text()) + parseInt(posVal);
  var newNegVal = parseInt($(elemNeg).find('span').text()) + parseInt(negVal);
  
  if(newPosVal < 0) { newPosVal = 0; }
  if(newNegVal < 0) { newNegVal = 0; }
  
  $('.faq-row[data-post-id="' + itemId + '"]').find('.faq-helpful-icon.faq-positive span').text(newPosVal); 
  $('.faq-row[data-post-id="' + itemId + '"]').find('.faq-helpful-icon.faq-negative span').text(newNegVal);
  
  // ajax update data
  //$(rowElem).find('.faq-helpful').addClass('faq-disabled');

  // now update database
  $.ajax({
    type: "POST",
    url: faqBaseUrl + '?faqAction=updateHelpful&itemId=' + itemId + '&positive=' + posVal + '&negative=' + negVal,
    cache: false,
    success: function(data) {
      //$(rowElem).find('.faq-helpful').removeClass('faq-disabled');
    },
    error: function(req, err){ 
      //$(rowElem).find('.faq-helpful').removeClass('faq-disabled');
      console.log('ERROR on AJAX: ' + err); 
    }
  });

}


function faqCreateCookie(name, value) {
  var expires;
  var date = new Date();
  date.setTime(date.getTime() + (365 * 24 * 60 * 60 * 1000));
  expires = "; expires=" + date.toGMTString();

  document.cookie = encodeURIComponent(name) + "=" + encodeURIComponent(value) + expires + "; path=/";
}


function faqReadCookie(name) {
  var nameEQ = encodeURIComponent(name) + "=";
  var ca = document.cookie.split(';');
  for (var i = 0; i < ca.length; i++) {
    var c = ca[i];
    while (c.charAt(0) === ' ')
      c = c.substring(1, c.length);
    if (c.indexOf(nameEQ) === 0)
      return decodeURIComponent(c.substring(nameEQ.length, c.length));
  }
  
  return '';
}


function faqEraseCookie(name) {
  faqCreateCookie(name, "", -1);
}


function faqUniqueArray(list) {
  var result = [];
  $.each(list, function(i, e) {
    if ($.inArray(e, result) == -1 && e !== '') result.push(e);
  });
  
  return result;
}


function faqReadVoteCookie(id) {
  id = String(id);
  var ckpos = faqReadCookie('faqVotedP').split(',');
  var ckneg = faqReadCookie('faqVotedN').split(',');
  
  if ($.inArray(id, ckpos) !== -1 && id !== '') {
    return 'positive';
  } else if ($.inArray(id, ckneg) !== -1 && id !== '') {
    return 'negative';
  }

  return '';
}


function faqCreateVoteCookie(itemId, type) {
  if(type == 'positive') {
    var ckarr = faqReadCookie('faqVotedP') + ',' + itemId;
    var cookie = (faqUniqueArray(ckarr.split(','))).join(',');
    faqCreateCookie('faqVotedP', cookie);
    faqEraseVoteCookie(itemId, 'negative');

  } else if(type == 'negative') {
    var ckarr = faqReadCookie('faqVotedN') + ',' + itemId;
    var cookie = (faqUniqueArray(ckarr.split(','))).join(',');
    faqCreateCookie('faqVotedN', cookie);
    faqEraseVoteCookie(itemId, 'positive');
    
  } else {
    faqEraseVoteCookie(itemId, type);
  }
}
  

function faqEraseVoteCookie(itemId, type) {
  if(type == 'positive') {
    ckarr = faqReadCookie('faqVotedP').split(',');
    ckarr = $.grep(ckarr, function(value) { return value != itemId; }).join(',');
    faqCreateCookie('faqVotedP', ckarr);
    
  } else if (type == 'negative') {
    ckarr = faqReadCookie('faqVotedN').split(',');
    ckarr = $.grep(ckarr, function(value) { return value != itemId; }).join(',');
    faqCreateCookie('faqVotedN', ckarr);
    
  } else {
    ckarr = faqReadCookie('faqVotedP').split(',');
    ckarr = $.grep(ckarr, function(value) { return value != itemId; }).join(',');
    faqCreateCookie('faqVotedP', ckarr);

    ckarr = faqReadCookie('faqVotedN').split(',');
    ckarr = $.grep(ckarr, function(value) { return value != itemId; }).join(',');
    faqCreateCookie('faqVotedN', ckarr);
  }
}
  