SET FOREIGN_KEY_CHECKS=0;

DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_faq_category;
CREATE TABLE /*TABLE_PREFIX*/t_faq_category (
  pk_i_id INT NOT NULL AUTO_INCREMENT,
  s_slug VARCHAR(200),
  s_image VARCHAR(200),
  s_icon VARCHAR(50),
  i_order INT(10) DEFAULT 9999,

  PRIMARY KEY (pk_i_id)
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_faq_category_locale;
CREATE TABLE /*TABLE_PREFIX*/t_faq_category_locale (
  fk_i_category_id INT NOT NULL,
  fk_c_locale_code CHAR(5) NOT NULL,
  s_title VARCHAR(100),
  s_description VARCHAR(500),

  PRIMARY KEY(fk_i_category_id, fk_c_locale_code),
  FOREIGN KEY (fk_i_category_id) REFERENCES /*TABLE_PREFIX*/t_faq_category (pk_i_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_faq_item;
CREATE TABLE /*TABLE_PREFIX*/t_faq_item (
  pk_i_id INT NOT NULL AUTO_INCREMENT,
  fk_i_category_id INT NOT NULL,
  b_enabled TINYINT(1) DEFAULT 1,
  b_expanded TINYINT(1) DEFAULT 0,
  i_order INT(10) DEFAULT 9999,
  i_view INT(10) DEFAULT 0,
  i_helpful INT(10) DEFAULT 0,
  i_nothelpful INT(10) DEFAULT 0,
  dt_date TIMESTAMP DEFAULT CURRENT_TIMESTAMP,

  PRIMARY KEY (pk_i_id)
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_faq_item_locale;
CREATE TABLE /*TABLE_PREFIX*/t_faq_item_locale (
  fk_i_item_id INT NOT NULL,
  fk_c_locale_code CHAR(5) NOT NULL,
  s_title VARCHAR(500),
  s_description VARCHAR(10000),

  PRIMARY KEY(fk_i_item_id, fk_c_locale_code),
  FOREIGN KEY (fk_i_item_id) REFERENCES /*TABLE_PREFIX*/t_faq_item (pk_i_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';

SET FOREIGN_KEY_CHECKS=1;