<?php
  // Create menu
  $title = __('Configure', 'follow');
  flw_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  $limit_users = mb_param_update('limit_users', 'plugin_action', 'value', 'plugin-follow');
  $button_design = mb_param_update('button_design', 'plugin_action', 'value', 'plugin-follow');
  $hook_item = mb_param_update('hook_item', 'plugin_action', 'check', 'plugin-follow');
  $hook_user_menu = mb_param_update('hook_user_menu', 'plugin_action', 'check', 'plugin-follow');
  $user_details = mb_param_update('user_details', 'plugin_action', 'value', 'plugin-follow');
  $per_page = mb_param_update('per_page', 'plugin_action', 'value', 'plugin-follow');
  $subscribe = mb_param_update('subscribe', 'plugin_action', 'check', 'plugin-follow');



  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'follow') );
  }
?>


<div class="mb-body">  
  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Configure', 'follow'); ?></div>

    <div class="mb-inside mb-minify">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <?php if(!flw_is_demo()) { ?>
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <?php } ?>

        <div class="mb-row">
          <label for="limit_users" class="h1"><span><?php _e('Limit users in modal', 'follow'); ?></span></label> 
          <input name="limit_users" size="20" type="text" value="<?php echo $limit_users; ?>" />

          <div class="mb-explain"><?php _e('Enter 0 or keep blank to disable limit. Default limit is 100.', 'follow'); ?></div>
        </div>

        <div class="mb-row">
          <label for="button_design" class="h2"><span><?php _e('Follow button design for non-logged users', 'follow'); ?></span></label> 
          <select name="button_design">
            <option value="DISABLED" <?php if($button_design == 'DISABLED') { ?>selected="selected"<?php } ?>><?php _e('Disable button, text is unchanged (Follow)', 'follow'); ?></option>
            <option value="DISABLED_ALT" <?php if($button_design == 'DISABLED_ALT') { ?>selected="selected"<?php } ?>><?php _e('Disable button, text is changed to "Log in"', 'follow'); ?></option>
            <option value="HIDE" <?php if($button_design == 'HIDE') { ?>selected="selected"<?php } ?>><?php _e('Hide button', 'follow'); ?></option>
          
          </select>

          <div class="mb-explain"><?php _e('Select what design will be used for users those are not logged-in and follow button is not available to them.', 'follow'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="user_details" class="h2"><span><?php _e('User details in modal', 'follow'); ?></span></label> 
          <select name="user_details">
            <option value="LOCATION" <?php if($user_details == 'LOCATION') { ?>selected="selected"<?php } ?>><?php _e('Location', 'follow'); ?></option>
            <option value="TYPE" <?php if($user_details == 'TYPE') { ?>selected="selected"<?php } ?>><?php _e('User type', 'follow'); ?></option>
            <option value="COUNT" <?php if($user_details == 'COUNT') { ?>selected="selected"<?php } ?>><?php _e('User items count', 'follow'); ?></option>
          
          </select>

          <div class="mb-explain"><?php _e('Select what design will be used for users those are not logged-in and follow button is not available to them.', 'follow'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="hook_item" class=""><span><?php _e('Hook buttons', 'follow'); ?></span></label> 
          <input name="hook_item" type="checkbox" class="element-slide" <?php echo ($hook_item == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, all buttons (following, followers, follow) are automatically hooked to listing detail (item_detail hook).', 'follow'); ?></div>
        </div>

        <div class="mb-row">
          <label for="hook_user_menu" class=""><span><?php _e('Followers list in My account', 'follow'); ?></span></label> 
          <input name="hook_user_menu" type="checkbox" class="element-slide" <?php echo ($hook_user_menu == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, new link in user menu is created and user can see list of its followers/following users.', 'follow'); ?></div>
        </div>

        <div class="mb-row">
          <label for="per_page" class="h1"><span><?php _e('Users per page in My account', 'follow'); ?></span></label> 
          <input name="per_page" size="20" type="text" value="<?php echo $per_page; ?>" />

          <div class="mb-explain"><?php _e('Pagination, how many users to show per page. Default is 20.', 'follow'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="subscribe" class=""><span><?php _e('Subscribe for New Items', 'follow'); ?></span></label> 
          <input name="subscribe" type="checkbox" class="element-slide" <?php echo ($subscribe == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, follow/unfollow is automatically linked with subscribe/unsubscribe action to receive notifications when new items are added by following user.', 'follow'); ?></div>
        </div>

        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(flw_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'follow')); ?>"><?php _e('Save', 'follow');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'follow');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>




  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'follow'); ?></div>

    <div class="mb-inside">
      <div class="mb-row"><?php _e('No theme modification are required to use all functions of plugin, but you may want to customize positions of buttons', 'follow'); ?></div>
      <div class="mb-row">
        <strong><?php _e('Followers counts (button)', 'follow'); ?></strong>
        <span class="mb-code">&lt;?php if(function_exists('flw_show_count')) { echo flw_show_count($user_id = osc_item_user_id(), $action = 'follower', $type = 'button'); } ?&gt;</span>
      </div>

      <div class="mb-row">
        <strong><?php _e('Following counts (button)', 'follow'); ?></strong>
        <span class="mb-code">&lt;?php if(function_exists('flw_show_count')) { echo flw_show_count($user_id = osc_item_user_id(), $action = 'following', $type = 'button'); } ?&gt;</span>
      </div>
      
      <div class="mb-row"><?php _e('In order to get raw link/url instead of button, change $type = "raw"', 'follow'); ?></div>
        
      <div class="mb-row">
        <strong><?php _e('Follow/unfollow button', 'follow'); ?></strong>
        <span class="mb-code">&lt;?php if(function_exists('flw_create_link')) { echo flw_create_link($user_id = osc_item_user_id(), $action = 'auto', $type = 'button'); } ?&gt;</span>
      </div>

      <div class="mb-row">
        <?php _e('In order to get raw link/url instead of button, change $type = "raw"', 'follow'); ?><br/>
        <?php _e('$action = "auto" cause that button is automatically generated as "Follow" or "Following". You may change it to $action = "follow" or $action = "unfollow"', 'follow'); ?>
      </div>

    </div>
  </div>

</div>


<?php echo flw_footer(); ?>