<?php
/*
  Plugin Name: Followers Osclass Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/social-and-authentication/followers-osclass-plugin-i171
  Description: Plugin enrich osclass with functionality to follow other users
  Version: 1.1.2
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: follow
  Plugin update URI: follow
  Support URI: https://forums.osclasspoint.com/followers-plugin/
  Product Key: qcj6opM6HtKfMtlsbAdv
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelFLW.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';

osc_enqueue_style('flw-user-style', osc_base_url() . 'oc-content/plugins/follow/css/user.css?v=' . date('YmdHis'));
osc_register_script('flw-user', osc_base_url() . 'oc-content/plugins/follow/js/user.js?v=' . date('YmdHis'), array('jquery'));
osc_enqueue_script('flw-user');


osc_add_route('flw-paginate', 'user/followers/(.+)-p([0-9]+)', 'user/followers/{pageType}-p{pageId}', osc_plugin_folder(__FILE__).'user/list.php', true, 'flw', 'list', __('Followers & Following users', 'follow'));
osc_add_route('flw-list', 'user/followers', 'user/followers', osc_plugin_folder(__FILE__).'user/list.php', true, 'flw', 'list', __('Followers & Following users', 'follow'));



// INSTALL FUNCTION - DEFINE VARIABLES
function flw_call_after_install() {
  osc_set_preference('limit_users', 100, 'plugin-follow', 'INTEGER');
  osc_set_preference('button_design', 'DISABLE', 'plugin-follow', 'STRING');
  osc_set_preference('hook_item', '', 'plugin-follow', 'STRING');
  osc_set_preference('hook_user_menu', '', 'plugin-follow', 'STRING');
  osc_set_preference('user_details', 'LOCATION', 'plugin-follow', 'STRING');
  osc_set_preference('per_page', 20, 'plugin-follow', 'INTEGER');
  osc_set_preference('subscribe', 1, 'plugin-follow', 'INTEGER');

  ModelFLW::newInstance()->install();
}


function flw_call_after_uninstall() {
  ModelFLW::newInstance()->uninstall();
}


// CREATE LINK IN USER MENU
function flw_user_sidebar() {
  if(flw_param('hook_user_menu') == 1) {
    if(osc_current_web_theme() == 'veronika' || osc_current_web_theme() == 'stela' || osc_current_web_theme() == 'starter' || (defined('USER_MENU_ICONS') && USER_MENU_ICONS == 1) ) {
      echo '<li class="opt_flw_list"><a href="' . osc_route_url('flw-list') . '"><i class="fa fa-users"></i> ' . __('Followers', 'follow') . '</a></li>';
    } else {
      echo '<li class="opt_flw_list"><a href="' . osc_route_url('flw-list') . '">' . __('Followers', 'follow') . '</a></li>';
    }
  }
}

osc_add_hook('user_menu', 'flw_user_sidebar');


// ADMIN MENU
function flw_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/follow/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/follow/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/follow/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="//fonts.googleapis.com/css?family=Open+Sans:300,600&amp;subset=latin,latin-ext" rel="stylesheet" type="text/css" />';
  echo '<link href="//maxfollow.bootstrapfollow.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/follow/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/follow/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/follow/js/bootstrap-switch.js"></script>';

  if( $title == '') { $title = __('Configure', 'follow'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Followers Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=follow/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'follow') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function flw_footer() {
  $pluginInfo = osc_plugin_get_info('follow/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint Market" /> OsclassPoint Market</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'follow') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'follow') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'follow') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function flw_admin_menu() {
echo '<h3><a href="#">Followers Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'follow') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','flw_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function flw_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'flw_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'flw_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'flw_call_after_uninstall');

?>