<?php
$per_page = (flw_param('per_page') > 0 ? flw_param('per_page') : 20);
$page_id = (Params::getParam('pageId') > 0 ? Params::getParam('pageId') : 0);

$type = (Params::getParam('pageType') <> '' ? Params::getParam('pageType') : 'follower');

$page_id_follower = ($type == 'follower' ? $page_id : 0);
$page_id_following = ($type == 'following' ? $page_id : 0);

$followers = ModelFLW::newInstance()->getFollowerList(osc_logged_user_id(), 'follower', $active = true, $limit = array($page_id_follower, flw_param('per_page')), $order = 'date_desc');
$following = ModelFLW::newInstance()->getFollowerList(osc_logged_user_id(), 'following', $active = true, $limit = array($page_id_following, flw_param('per_page')), $order = 'date_desc');
$already_following = ModelFLW::newInstance()->getFollowerIds(osc_logged_user_id(), 'following');

$count_followers = ModelFLW::newInstance()->countFollowers(osc_logged_user_id(), 'follower', $active = true);
$count_following = ModelFLW::newInstance()->countFollowers(osc_logged_user_id(), 'following', $active = true);
?>

<div class="flw-body">
  <div class="flw-nav">
    <a href="#" data-tab="follower" class="<?php if($type == 'follower') { ?>active<?php } ?>"><?php _e('Your followers', 'follow'); ?></a>
    <a href="#" data-tab="following" class="<?php if($type == 'following') { ?>active<?php } ?>"><?php _e('You are following', 'follow'); ?></a>
  </div>
  
  <div class="flw-tabs">
    <div class="flw-tab" data-tab="follower" <?php if($type != 'follower') { ?>style="display:none;"<?php } ?>>
      <?php if(is_array($followers) && count($followers) > 0) { ?>
        <?php 
          foreach($followers as $f) { 
            flw_draw_user($f, $already_following);
          }
          
          echo flw_paginate('follower', $page_id, $per_page, $count_followers);
        ?>
      <?php } else { ?>
        <div class="flw-users-empty">
          <?php _e('You have no followers yet', 'follow'); ?>
        </div>
      <?php } ?>
    </div>

    <div class="flw-tab" data-tab="following" <?php if($type != 'following') { ?>style="display:none;"<?php } ?>>
      <?php if(is_array($following) && count($following) > 0) { ?>
        <?php 
          foreach($following as $f) { 
            flw_draw_user($f, $already_following);
          }
          
          echo flw_paginate('following', $page_id, $per_page, $count_following);
        ?>
      <?php } else { ?>
        <div class="flw-users-empty">
          <?php _e('You are not following yet', 'follow'); ?>
        </div>
      <?php } ?>
    </div>
  </div>
</div>
