<?php
  // Create menu
  $title = __('Configure', 'google_onetap_login');
  got_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update('param_name', 'form_name', 'input_type', 'plugin_var_name');
  // input_type: check or value

  $enabled = mb_param_update('enabled', 'plugin_action', 'check', 'plugin-google_onetap_login');
  $client_id = mb_param_update('client_id', 'plugin_action', 'value', 'plugin-google_onetap_login');
  $exclude_pages = mb_param_update('exclude_pages', 'plugin_action', 'value', 'plugin-google_onetap_login');
 
  $exclude_pages_array = explode(',', $exclude_pages);

  if(Params::getParam('plugin_action') == 'done') {
    osc_add_flash_ok_message(__('Settings were successfully saved.', 'google_onetap_login'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=google_onetap_login/admin/configure.php');
    exit;
  }
  
  $tutorial_img_path = 'https://osclasspoint.com/images/google-onetap-login/';
?>


<div class="mb-body">
  <div class="mb-notes">
    <div class="mb-line"><?php _e('Please read how to get API keys in section below.', 'google_onetap_login'); ?></div>
    <div class="mb-line"><?php _e('Client secret is not needed.', 'google_onetap_login'); ?></div>
  </div>

  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-cog"></i> <?php _e('Configure', 'google_onetap_login'); ?></div>

    <div class="mb-inside">
      <form name="promo_form" id="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />

        <div class="mb-row">
          <label for="enabled" class=""><span><?php _e('Enable Google OneTap Login', 'google_onetap_login'); ?></span></label> 
          <input name="enabled" id="enabled" type="checkbox" class="element-slide" <?php echo ($enabled == 1 ? 'checked' : ''); ?> />
          <div class="mb-explain"><?php _e('When enabled, floating login box will be shown in front for non-logged users.', 'google_onetap_login'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="client_id" class=""><span><?php _e('OAuth Client Id', 'google_onetap_login'); ?></span></label> 
          <input name="client_id" size="90" type="text" value="<?php echo (got_is_demo() ? '' : $client_id); ?>" />
          <div class="mb-explain"><?php _e('Follow instructions in section below.', 'google_onetap_login'); ?></div>
        </div>

        <div class="mb-row mb-row-select-multiple">
          <label for="exclude_pages_multiple"><span><?php _e('Hide Login Box', 'auto_renewal'); ?></span></label> 

          <input type="hidden" name="exclude_pages" id="exclude_pages" value="<?php echo $exclude_pages; ?>"/>
          <select id="exclude_pages_multiple" name="exclude_pages_multiple" multiple>
            <?php foreach(got_pages() as $key => $val) { ?>
              <option value="<?php echo $key; ?>" <?php if(in_array($key, $exclude_pages_array)) { ?>selected="selected"<?php } ?>><?php echo $val; ?></option>
            <?php } ?>
          </select>

          <div class="mb-explain">
            <?php _e('Select pages where login popup will not be shown. Note that login popup is never shown to logged-in user.', 'auto_renewal'); ?><br/>
          </div>
        </div>
        
        <?php if(!got_is_demo()) { ?>
          <div class="mb-foot">
            <button type="submit" class="mb-button"><?php _e('Save', 'google_onetap_login');?></button>
          </div>
        <?php } ?>
      </form>
    </div>
  </div>


  <!-- GOOGLE APPLICATION SETUP -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-key"></i> <?php _e('Create Google OAuth API keys', 'google_onetap_login'); ?></div>

    <div class="mb-inside">
      <div class="mb-row">
        <ul class="mb-ul-num">
          <li><?php _e('Go to the', 'google_onetap_login'); ?> <a href="https://console.cloud.google.com/apis/dashboard"><?php _e('Google Cloud Console.', 'google_onetap_login'); ?></a>.</li>

          <li><?php _e('Select an existing project from the projects list, or click <b>NEW PROJECT</b> to create a new project:', 'google_onetap_login'); ?></li>
 
          <ul class="mb-ul-txt">
            <li><?php _e('Enter the <b>Project Name</b>. You can also define organisation', 'google_onetap_login'); ?></li>
            <li><?php _e('Click on the <b>CREATE</b> button and the project will be created in some seconds.', 'google_onetap_login'); ?></li>
          </ul>
          <img class="mb-tutorial-img" alt="<?php echo osc_esc_html(__('Create project', 'google_onetap_login')); ?>" src="<?php echo $tutorial_img_path; ?>1-create-project.jpg" />

          <li><?php _e('When you have not configured consent screen yet, click on <b>OAuth consent screen</b> and configure consent screen settings.', 'google_onetap_login'); ?></li>

          <ul class="mb-ul-txt">
            <li><?php _e('In <b>Application name</b> field, enter the name of your Application.', 'google_onetap_login'); ?></li>
            <li><?php _e('In <b>Support email</b> field, choose an email address for user support.', 'google_onetap_login'); ?></li>
            <li><?php _e('In the <b>Authorized domains</b>, specify the domains which will be allowed to authenticate using login - your domain.', 'google_onetap_login'); ?></li>
            <li><?php _e('Click the <b>Save</b> button.', 'google_onetap_login'); ?></li>
          </ul>

          <li><?php _e('Following scopes are required for correct plugin functionality.', 'google_onetap_login'); ?></li>

          <ul class="mb-ul-txt">
            <li>.../auth/userinfo.email	</li>
            <li>.../auth/userinfo.profile</li>
            <li>openid</li>
          </ul>

          <li><?php _e('In the left side navigation panel, select <b>Credentials</b> under the <b>APIs and Services</b> section.', 'google_onetap_login'); ?></li>
          <li><?php _e('Click on <b>CREATE CREDENTIALS</b> and select <b>OAuth client ID</b> option.', 'google_onetap_login'); ?></li>
          <img class="mb-tutorial-img" alt="<?php echo osc_esc_html(__('Create credentials', 'google_onetap_login')); ?>" src="<?php echo $tutorial_img_path; ?>2-create-credentials.jpg" />
 
          <ul class="mb-ul-txt">
            <li><?php _e('In the <b>Application type</b> section, select <b>Web application</b>.', 'google_onetap_login'); ?></li>
           <img class="mb-tutorial-img" alt="<?php echo osc_esc_html(__('Select application', 'google_onetap_login')); ?>" src="<?php echo $tutorial_img_path; ?>3-select-application.jpg" />

            <li>
              <?php _e('In the <b>Authorised JavaScript origins</b> field, enter the following redirect URL:', 'google_onetap_login'); ?><br/>
              <span class="mb-gray"><?php echo osc_base_url(); ?></span>
            </li>
            
            <li>
              <?php _e('In the <b>Authorised redirect URIs</b> field, enter the following redirect URLs:', 'google_onetap_login'); ?><br/>
              <span class="mb-gray"><?php echo osc_base_url(); ?></span><br/>
              <span class="mb-gray"><?php echo osc_base_url(); ?>index.php?gotRedirect=1</span>
            </li>
            <img class="mb-tutorial-img" alt="<?php echo osc_esc_html(__('URI settings', 'google_onetap_login')); ?>" src="<?php echo $tutorial_img_path; ?>4-uri-setting.jpg" />


            <li><?php _e('Click the <b>CREATE</b> button. Your credentials are ready to be used', 'google_onetap_login'); ?></li>
          </ul>

          <li><?php _e('A dialog box will appear with OAuth client details, note the <b>Client ID</b> and <b>Client secret</b>. This Client ID is only required for plugin.', 'google_onetap_login'); ?></li>
          <img class="mb-tutorial-img" alt="<?php echo osc_esc_html(__('Save client ID', 'google_onetap_login')); ?>" src="<?php echo $tutorial_img_path; ?>5-save-client-id.jpg" />

        </ul>
      </div>


    </div>
  </div>  
  
  
  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'google_onetap_login'); ?></div>

    <div class="mb-inside">
      <div class="mb-row"><?php _e('Plugin does not require any modifications in theme files.', 'google_onetap_login'); ?></div>
    </div>
  </div>
</div>

<?php echo got_footer(); ?>