<?php
  // Create menu
  $title = __('Configure', 'history_logger');
  hsl_menu($title);


  if(Params::getParam('what') == 'purgeItemLogs' && !hsl_is_demo()) {
    hsl_purge_item_logs(true);
    
    osc_add_flash_ok_message(__('Item logs has been cleaned', 'history_logger'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=history_logger/admin/configure.php');
    exit;
  }
  

  if(Params::getParam('what') == 'purgeUserLogs' && !hsl_is_demo()) {
    hsl_purge_user_logs(true);
    
    osc_add_flash_ok_message(__('User logs has been cleaned', 'history_logger'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=history_logger/admin/configure.php');
    exit;
  }


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value
  $log_item_data = mb_param_update('log_item_data', 'plugin_action', 'check', 'plugin-history_logger');
  $log_user_data = mb_param_update('log_user_data', 'plugin_action', 'check', 'plugin-history_logger');
  $retention = mb_param_update('retention', 'plugin_action', 'value', 'plugin-history_logger');



  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'history_logger') );
  }
?>


<div class="mb-body">
  <!-- CONFIGURE SECTION -->
  
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-wrench"></i> <?php _e('Configure', 'history_logger'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />

        <div class="mb-row">
          <label for="log_item_data"><span><?php _e('Log Item Data', 'history_logger'); ?></span></label> 
          <input name="log_item_data" type="checkbox" class="element-slide" <?php echo ($log_item_data == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, logs for listings are created.', 'history_logger'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="log_user_data"><span><?php _e('Log User Data', 'history_logger'); ?></span></label> 
          <input name="log_user_data" type="checkbox" class="element-slide" <?php echo ($log_user_data == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, logs for users are created.', 'history_logger'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="retention"><span><?php _e('Retention Period', 'history_logger'); ?></span></label> 
          <input type="number" size="10" name="retention" id="retention" value="<?php echo $retention; ?>" min="1"/>
          <div class="mb-input-desc"><?php _e('months', 'history_logger'); ?></div>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Enter after how many months are logs automatically removed. Require proper setup of CRON. Default value is 24 months.', 'history_logger'); ?></div>
          </div>
        </div>
        

        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(hsl_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'history_logger')); ?>"><?php _e('Save', 'history_logger');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'history_logger');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>



  <!-- PLUGIN STATISTICS -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-dashboard"></i> <?php _e('Statistics', 'history_logger'); ?></div>
    <div class="mb-inside">
      <strong class="mb-row"><?php echo sprintf(__('%d item logs stored by plugin.', 'history_logger'), hsl_count_item_logs()); ?></strong>

      <div class="mb-row" style="margin-top:12px;">
        <?php if(hsl_is_demo()) { ?>
          <a href="#" class="mb-button-blue mb-add mb-disabled" style="cursor:not-allowed;opacity:0.5;" onclick="return false;" disabled><i class="fa fa-trash" title="<?php echo osc_esc_html(__('This action cannot be done as this is demo site', 'history_logger')); ?>"></i><?php _e('Clean item logs', 'history_logger'); ?></a>
        <?php } else { ?>
          <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=history_logger/admin/configure.php&what=purgeItemLogs" class="mb-button-blue mb-add" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove all item logs? Action cannot be undone', 'history_logger')); ?>');"><i class="fa fa-trash"></i><?php _e('Clean item logs', 'history_logger'); ?></a>
        <?php } ?>
      </div>
      
      <div class="mb-row">&nbsp;</div>
      
      <strong class="mb-row"><?php echo sprintf(__('%d user logs stored by plugin.', 'history_logger'), hsl_count_user_logs()); ?></strong>

      <div class="mb-row" style="margin-top:12px;">
        <?php if(hsl_is_demo()) { ?>
          <a href="#" class="mb-button-blue mb-add mb-disabled" style="cursor:not-allowed;opacity:0.5;" onclick="return false;" disabled><i class="fa fa-trash" title="<?php echo osc_esc_html(__('This action cannot be done as this is demo site', 'history_logger')); ?>"></i><?php _e('Clean user logs', 'history_logger'); ?></a>
        <?php } else { ?>
          <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=history_logger/admin/configure.php&what=purgeUserLogs" class="mb-button-blue mb-add" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove all user logs? Action cannot be undone', 'history_logger')); ?>');"><i class="fa fa-trash"></i><?php _e('Clean user logs', 'history_logger'); ?></a>
        <?php } ?>
      </div>

    </div>
  </div>


  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'history_logger'); ?></div>

    <div class="mb-inside">
      <div class="mb-row"><?php _e('No theme modification are required to use all functions of plugin.', 'history_logger'); ?></div>
    </div>
  </div>
</div>


<?php echo hsl_footer(); ?>