<?php
  // Create menu
  $title = __('Log details', 'history_logger');
  hsl_menu($title);

  $id = Params::getParam('logId');
  $type = Params::getParam('logType');

  if($id == '' || $id <= 0) {
    osc_add_flash_error_message(__('Invalid Log ID.', 'history_logger'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=history_logger/admin/configure.php');
    exit;
  }

  if($type == 'item') {
    $log = ModelHSL::newInstance()->getItemLog($id);
  } else if ($type == 'user') {
    $log = ModelHSL::newInstance()->getUserLog($id);
  } else {
    osc_add_flash_error_message(__('Invalid Log Type.', 'history_logger'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=history_logger/admin/configure.php');
    exit;
  }


  // REMOVE LOG
  if(Params::getParam('what') == 'remove') { 
    if($type == 'item') {
      ModelHSL::newInstance()->removeItemLog($id);
     
      osc_add_flash_ok_message(__('Log successfully removed', 'history_logger'), 'admin');
      header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=history_logger/admin/logs_item.php');
      exit;
    
    } else if($type == 'user') {
      ModelHSL::newInstance()->removeUserLog($id);
      
      osc_add_flash_ok_message(__('Log successfully removed', 'history_logger'), 'admin');
      header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=history_logger/admin/logs_user.php');
      exit;
      
    } else {
      osc_add_flash_error_message(__('Invalid Log Type.', 'history_logger'), 'admin');
      header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=history_logger/admin/configure.php');
      exit;
    }
  }
?>


<div class="mb-body">
  <!-- CONFIGURE SECTION -->
  <div class="mb-box mb-log-detail">
    <div class="mb-head">
      <i class="fa fa-search"></i> <?php _e('Log details', 'history_logger'); ?>
    </div>

    <div class="mb-inside">
      <div class="mb-row">
        <textarea readonly id="mb-log-det"><?php 
            foreach($log as $key => $val) {
              echo str_pad(hsl_key_name($key) . ':', 20, ' ') . (trim($val) != '' ? trim($val) : '-') . PHP_EOL;
            }
          ?></textarea>
      </div>
      
      <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=history_logger/admin/log_details.php&what=remove&logType=<?php echo $type; ?>&logId=<?php echo $id; ?>" class="mb-button-red mb-add"><i class="fa fa-trash"></i><?php _e('Remove log', 'account_sync'); ?></a>
    </div>
  </div>
</div>

<?php echo hsl_footer(); ?>