<?php
  // Create menu
  $title = __('Item logs', 'history_logger');
  hsl_menu($title);

  $params = Params::getParamsAsArray();
  $logs = ModelHSL::newInstance()->searchItemLogs($params);
  $count_all = ModelHSL::newInstance()->searchItemLogs($params, true);
?>

<div class="mb-body">

  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-search"></i> <?php _e('Item logs', 'history_logger'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=history_logger/admin/logs_item.php" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="logSearch" value="1"/>

        <div id="mb-search-table">
          <div class="mb-col-2">
            <label for="itemId"><?php _e('ID', 'history_logger'); ?></label>
            <input type="text" name="itemId" value="<?php echo osc_esc_html(Params::getParam('itemId')); ?>" />
          </div>

          <div class="mb-col-3">
            <label for="user"><?php _e('User', 'history_logger'); ?></label>
            <input type="text" name="user" value="<?php echo osc_esc_html(Params::getParam('user')); ?>" />
          </div>
          
          <div class="mb-col-3">
            <label for="text"><?php _e('Text', 'history_logger'); ?></label>
            <input type="text" name="text" value="<?php echo osc_esc_html(Params::getParam('text')); ?>" />
          </div>
          
          <div class="mb-col-3">
            <label for="location"><?php _e('Location', 'history_logger'); ?></label>
            <input type="text" name="location" value="<?php echo osc_esc_html(Params::getParam('location')); ?>" />
          </div>

          <div class="mb-col-3">
            <label for="status"><?php _e('Status', 'history_logger'); ?></label>
            <input type="text" name="status" value="<?php echo osc_esc_html(Params::getParam('status')); ?>" />
          </div>

          <div class="mb-col-2">
            <label for="date"><?php _e('Log Date', 'history_logger'); ?></label>
            <input type="text" name="date" value="<?php echo osc_esc_html(Params::getParam('date')); ?>" />
          </div>
          
          <div class="mb-col-2">
            <label for="pubDate"><?php _e('Publish Date', 'history_logger'); ?></label>
            <input type="text" name="pubDate" value="<?php echo osc_esc_html(Params::getParam('pubDate')); ?>" />
          </div>
          


          <div class="mb-col-2">
            <label for="logAction"><?php _e('Action', 'history_logger'); ?></label>
            <select name="logAction" value="<?php echo Params::getParam('logAction'); ?>">
              <option value="" <?php if(Params::getParam('logAction') == '') { ?>selected="selected"<?php } ?>><?php _e('All', 'history_logger'); ?></option>
              <option value="CREATE" <?php if(Params::getParam('logAction') == 'CREATE') { ?>selected="selected"<?php } ?>><?php _e('Create', 'history_logger'); ?></option>
              <option value="EDIT" <?php if(Params::getParam('logAction') == 'EDIT') { ?>selected="selected"<?php } ?>><?php _e('Edit', 'history_logger'); ?></option>
              <option value="ACTIVATE" <?php if(Params::getParam('logAction') == 'ACTIVATE') { ?>selected="selected"<?php } ?>><?php _e('Activate', 'history_logger'); ?></option>
              <option value="DEACTIVATE" <?php if(Params::getParam('logAction') == 'DEACTIVATE') { ?>selected="selected"<?php } ?>><?php _e('Deactivate', 'history_logger'); ?></option>
              <option value="ENABLE" <?php if(Params::getParam('logAction') == 'ENABLE') { ?>selected="selected"<?php } ?>><?php _e('Enable', 'history_logger'); ?></option>
              <option value="DISABLE" <?php if(Params::getParam('logAction') == 'DISABLE') { ?>selected="selected"<?php } ?>><?php _e('Disable', 'history_logger'); ?></option>
              <option value="RENEW" <?php if(Params::getParam('logAction') == 'RENEW') { ?>selected="selected"<?php } ?>><?php _e('Renew', 'history_logger'); ?></option>
              <option value="DELETE" <?php if(Params::getParam('logAction') == 'DELETE') { ?>selected="selected"<?php } ?>><?php _e('Delete', 'history_logger'); ?></option>
              <option value="SPAM_ON" <?php if(Params::getParam('logAction') == 'SPAM_ON') { ?>selected="selected"<?php } ?>><?php _e('Mark as Spam', 'history_logger'); ?></option>
              <option value="SPAM_OFF" <?php if(Params::getParam('logAction') == 'SPAM_OFF') { ?>selected="selected"<?php } ?>><?php _e('Unmark as Spam', 'history_logger'); ?></option>
              <option value="PREMIUM_ON" <?php if(Params::getParam('logAction') == 'PREMIUM_ON') { ?>selected="selected"<?php } ?>><?php _e('Mark as Premium', 'history_logger'); ?></option>
              <option value="PREMIUM_OFF" <?php if(Params::getParam('logAction') == 'PREMIUM_OFF') { ?>selected="selected"<?php } ?>><?php _e('Unmark as Premium', 'history_logger'); ?></option>
            </select>
          </div>
          
          <div class="mb-col-2">
            <label for="sort"><?php _e('Sort', 'history_logger'); ?></label>
            <select name="sort" value="<?php echo Params::getParam('sort'); ?>">
              <option value="" <?php if(Params::getParam('sort') == '') { ?>selected="selected"<?php } ?>><?php _e('By ID descending', 'history_logger'); ?></option>
              <option value="ID_ASC" <?php if(Params::getParam('sort') == 'ID_ASC') { ?>selected="selected"<?php } ?>><?php _e('By ID ascending', 'history_logger'); ?></option>
              <option value="DATE_ASC" <?php if(Params::getParam('sort') == 'DATE_ASC') { ?>selected="selected"<?php } ?>><?php _e('By log date ascending', 'history_logger'); ?></option>
              <option value="DATE_DESC" <?php if(Params::getParam('sort') == 'DATE_DESC') { ?>selected="selected"<?php } ?>><?php _e('By log date descending', 'history_logger'); ?></option>
              <option value="PUBDATE_ASC" <?php if(Params::getParam('sort') == 'PUBDATE_ASC') { ?>selected="selected"<?php } ?>><?php _e('By publish date ascending', 'history_logger'); ?></option>
              <option value="PUBDATE_DESC" <?php if(Params::getParam('sort') == 'PUBDATE_DESC') { ?>selected="selected"<?php } ?>><?php _e('By publish date descending', 'history_logger'); ?></option>
            </select>
          </div>    
         
          <div class="mb-col-2">
            <label for="">&nbsp;</label>
            <button type="submit" class="mb-button mb-button-black"><i class="fa fa-search"></i> <?php _e('Search', 'history_logger'); ?></button>
          </div>
        </div>
      </form>    

      <div class="mb-table mb-table-res">
        <div class="mb-table-head">
          <div class="mb-col-1 mb-align-left"><?php _e('ID', 'history_logger');?></div>
          <div class="mb-col-1 mb-align-left"><?php _e('Item ID', 'history_logger');?></div>
          <div class="mb-col-4 mb-align-left"><?php _e('User', 'history_logger'); ?></div>
          <div class="mb-col-4 mb-align-left"><?php _e('Title/Price', 'history_logger');?></div>
          <div class="mb-col-3 mb-align-left"><?php _e('Location', 'history_logger');?></div>
          <div class="mb-col-2 mb-align-left"><?php _e('Pub. Date', 'history_logger');?></div>
          <div class="mb-col-4 mb-align-left"><?php _e('Status', 'history_logger');?></div>
          <div class="mb-col-2 mb-align-left"><?php _e('Log Date', 'history_logger');?></div>
          <div class="mb-col-2 mb-align-left"><?php _e('Action', 'history_logger');?></div>
          <div class="mb-col-1 mb-align-right">&nbsp;</div>
        </div>

        <?php if(count($logs) <= 0) { ?>
          <div class="mb-table-row mb-row-empty">
            <i class="fa fa-warning"></i><span><?php _e('No logs has been found', 'history_logger'); ?></span>
          </div>
        <?php } else { ?>
          <?php foreach($logs as $log) { ?>
            <div class="mb-table-row">
              <div class="mb-col-1 mb-align-left"><?php echo $log['pk_i_id']; ?></div>
              <div class="mb-col-1 mb-align-left"><?php echo $log['fk_i_item_id']; ?></div>
              <div class="mb-col-4 mb-align-left"><span class="mb-log-limit"><?php echo implode(PHP_EOL, array_filter(array('<strong>' . $log['s_contact_name'] . '</strong>', $log['s_contact_email'], $log['s_contact_phone']))); ?></span></div>
              <div class="mb-col-4 mb-align-left">
                <div class="mb-log-limit"><?php echo $log['s_title']; ?></div>
                <div class="mb-log-limit"><?php echo round($log['i_price']/1000000); ?></div>
              </div>
              <div class="mb-col-3 mb-align-left"><span class="mb-log-limit"><?php echo $log['s_location']; ?></span></div>
              <div class="mb-col-2 mb-align-left"><span class="mb-has-tooltip" title="<?php echo osc_esc_html($log['dt_pub_date']); ?>"><?php echo date('Y-m-d', strtotime($log['dt_pub_date'])); ?></span></div>
              <div class="mb-col-4 mb-align-left"><?php echo $log['s_status']; ?></div>
              <div class="mb-col-2 mb-align-left"><span class="mb-has-tooltip" title="<?php echo osc_esc_html($log['dt_date']); ?>"><?php echo date('Y-m-d', strtotime($log['dt_date'])); ?></span></div>
              <div class="mb-col-2 mb-align-left"><span class="mb-action mb-log-<?php echo $log['s_action']; ?>"><?php echo ucfirst($log['s_action']); ?></span></div>
              <div class="mb-col-1 mb-align-right">
                <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=history_logger/admin/log_details.php&logType=item&logId=<?php echo $log['pk_i_id']; ?>" class="mb-btn mb-button-blue"><i class="fa fa-search"></i></a>
              </div>
            </div>
          <?php } ?>

          <?php 
            $param_string = '&itemId=' . Params::getParam('itemId') . '&user=' . Params::getParam('user') . '&text=' . Params::getParam('text') . '&location=' . Params::getParam('location') . '&status=' . Params::getParam('status') . '&date=' . Params::getParam('date') . '&pubDate=' . Params::getParam('pubDate') . '&sort=' . Params::getParam('sort') . '&logAction=' . Params::getParam('logAction');
            echo hsl_admin_paginate('history_logger/admin/logs_item.php', Params::getParam('pageId'), (hsl_param('per_page') > 0 ? hsl_param('per_page') : 30), $count_all, '', $param_string); 
          ?>
        <?php } ?>
      </div>
    </div>
  </div>
</div>