<?php
  // Create menu
  $title = __('User logs', 'history_logger');
  hsl_menu($title);

  $params = Params::getParamsAsArray();
  $logs = ModelHSL::newInstance()->searchUserLogs($params);
  $count_all = ModelHSL::newInstance()->searchUserLogs($params, true);
?>

<div class="mb-body">

  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-search"></i> <?php _e('User logs', 'history_logger'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=history_logger/admin/logs_user.php" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="logSearch" value="1"/>

        <div id="mb-search-table">
          <div class="mb-col-2">
            <label for="userId"><?php _e('ID', 'history_logger'); ?></label>
            <input type="text" name="userId" value="<?php echo osc_esc_html(Params::getParam('userId')); ?>" />
          </div>

          <div class="mb-col-3">
            <label for="name"><?php _e('Name', 'history_logger'); ?></label>
            <input type="text" name="name" value="<?php echo osc_esc_html(Params::getParam('name')); ?>" />
          </div>
          
          <div class="mb-col-2">
            <label for="email"><?php _e('Email', 'history_logger'); ?></label>
            <input type="text" name="email" value="<?php echo osc_esc_html(Params::getParam('email')); ?>" />
          </div>
          
          <div class="mb-col-2">
            <label for="phone"><?php _e('Phone', 'history_logger'); ?></label>
            <input type="text" name="phone" value="<?php echo osc_esc_html(Params::getParam('phone')); ?>" />
          </div>

          <div class="mb-col-2">
            <label for="location"><?php _e('Location', 'history_logger'); ?></label>
            <input type="text" name="location" value="<?php echo osc_esc_html(Params::getParam('location')); ?>" />
          </div>
          
          <div class="mb-col-3">
            <label for="text"><?php _e('Description', 'history_logger'); ?></label>
            <input type="text" name="text" value="<?php echo osc_esc_html(Params::getParam('text')); ?>" />
          </div>
          
          <div class="mb-col-2">
            <label for="date"><?php _e('Log Date', 'history_logger'); ?></label>
            <input type="text" name="date" value="<?php echo osc_esc_html(Params::getParam('date')); ?>" />
          </div>
          
          <div class="mb-col-2">
            <label for="regDate"><?php _e('Register Date', 'history_logger'); ?></label>
            <input type="text" name="regDate" value="<?php echo osc_esc_html(Params::getParam('regDate')); ?>" />
          </div>
          


          <div class="mb-col-2">
            <label for="logAction"><?php _e('Action', 'history_logger'); ?></label>
            <select name="logAction" value="<?php echo Params::getParam('logAction'); ?>">
              <option value="" <?php if(Params::getParam('logAction') == '') { ?>selected="selected"<?php } ?>><?php _e('All', 'history_logger'); ?></option>
              <option value="CREATE" <?php if(Params::getParam('logAction') == 'CREATE') { ?>selected="selected"<?php } ?>><?php _e('Create', 'history_logger'); ?></option>
              <option value="EDIT" <?php if(Params::getParam('logAction') == 'EDIT') { ?>selected="selected"<?php } ?>><?php _e('Edit', 'history_logger'); ?></option>
              <option value="ACTIVATE" <?php if(Params::getParam('logAction') == 'ACTIVATE') { ?>selected="selected"<?php } ?>><?php _e('Activate', 'history_logger'); ?></option>
              <option value="DEACTIVATE" <?php if(Params::getParam('logAction') == 'DEACTIVATE') { ?>selected="selected"<?php } ?>><?php _e('Deactivate', 'history_logger'); ?></option>
              <option value="ENABLE" <?php if(Params::getParam('logAction') == 'ENABLE') { ?>selected="selected"<?php } ?>><?php _e('Enable', 'history_logger'); ?></option>
              <option value="DISABLE" <?php if(Params::getParam('logAction') == 'DISABLE') { ?>selected="selected"<?php } ?>><?php _e('Disable', 'history_logger'); ?></option>
              <option value="DELETE" <?php if(Params::getParam('logAction') == 'DELETE') { ?>selected="selected"<?php } ?>><?php _e('Delete', 'history_logger'); ?></option>
            </select>
          </div>
          
          <div class="mb-col-2">
            <label for="sort"><?php _e('Sort', 'history_logger'); ?></label>
            <select name="sort" value="<?php echo Params::getParam('sort'); ?>">
              <option value="" <?php if(Params::getParam('sort') == '') { ?>selected="selected"<?php } ?>><?php _e('By ID descending', 'history_logger'); ?></option>
              <option value="ID_ASC" <?php if(Params::getParam('sort') == 'ID_ASC') { ?>selected="selected"<?php } ?>><?php _e('By ID ascending', 'history_logger'); ?></option>
              <option value="DATE_ASC" <?php if(Params::getParam('sort') == 'DATE_ASC') { ?>selected="selected"<?php } ?>><?php _e('By log date ascending', 'history_logger'); ?></option>
              <option value="DATE_DESC" <?php if(Params::getParam('sort') == 'DATE_DESC') { ?>selected="selected"<?php } ?>><?php _e('By log date descending', 'history_logger'); ?></option>
              <option value="PUBDATE_ASC" <?php if(Params::getParam('sort') == 'REGDATE_ASC') { ?>selected="selected"<?php } ?>><?php _e('By register date ascending', 'history_logger'); ?></option>
              <option value="PUBDATE_DESC" <?php if(Params::getParam('sort') == 'REGDATE_DESC') { ?>selected="selected"<?php } ?>><?php _e('By register date descending', 'history_logger'); ?></option>
            </select>
          </div>    
         
          <div class="mb-col-2">
            <label for="">&nbsp;</label>
            <button type="submit" class="mb-button mb-button-black"><i class="fa fa-search"></i> <?php _e('Search', 'history_logger'); ?></button>
          </div>
        </div>
      </form>    

      <div class="mb-table mb-table-res">
        <div class="mb-table-head">
          <div class="mb-col-2 mb-align-left"><?php _e('ID', 'history_logger');?></div>
          <div class="mb-col-2 mb-align-left"><?php _e('User ID', 'history_logger');?></div>
          <div class="mb-col-6 mb-align-left"><?php _e('User', 'history_logger'); ?></div>
          <div class="mb-col-5 mb-align-left"><?php _e('Location', 'history_logger');?></div>
          <div class="mb-col-2 mb-align-left"><?php _e('Reg. Date', 'history_logger');?></div>
          <div class="mb-col-2 mb-align-left"><?php _e('Status', 'history_logger');?></div>
          <div class="mb-col-2 mb-align-left"><?php _e('Log Date', 'history_logger');?></div>
          <div class="mb-col-2 mb-align-left"><?php _e('Action', 'history_logger');?></div>
          <div class="mb-col-1 mb-align-right">&nbsp;</div>
        </div>

        <?php if(count($logs) <= 0) { ?>
          <div class="mb-table-row mb-row-empty">
            <i class="fa fa-warning"></i><span><?php _e('No logs has been found', 'history_logger'); ?></span>
          </div>
        <?php } else { ?>
          <?php foreach($logs as $log) { ?>
            <div class="mb-table-row">
              <div class="mb-col-2 mb-align-left"><?php echo $log['pk_i_id']; ?></div>
              <div class="mb-col-2 mb-align-left"><?php echo $log['fk_i_user_id']; ?></div>
              <div class="mb-col-6 mb-align-left"><span class="mb-log-limit"><?php echo implode(PHP_EOL, array_filter(array('<strong>' . $log['s_name'] . '</strong>', $log['s_email'], $log['s_phone']))); ?></span></div>
              <div class="mb-col-5 mb-align-left"><span class="mb-log-limit"><?php echo $log['s_location']; ?></span></div>
              <div class="mb-col-2 mb-align-left"><span class="mb-has-tooltip" title="<?php echo osc_esc_html($log['dt_reg_date']); ?>"><?php echo date('Y-m-d', strtotime($log['dt_reg_date'])); ?></span></div>
              <div class="mb-col-2 mb-align-left"><?php echo $log['s_status']; ?></div>
              <div class="mb-col-2 mb-align-left"><span class="mb-has-tooltip" title="<?php echo osc_esc_html($log['dt_date']); ?>"><?php echo date('Y-m-d', strtotime($log['dt_date'])); ?></span></div>
              <div class="mb-col-2 mb-align-left"><span class="mb-action mb-log-<?php echo $log['s_action']; ?>"><?php echo ucfirst($log['s_action']); ?></span></div>
              <div class="mb-col-1 mb-align-right">
                <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=history_logger/admin/log_details.php&logType=user&logId=<?php echo $log['pk_i_id']; ?>" class="mb-btn mb-button-blue"><i class="fa fa-search"></i></a>
              </div>
            </div>
          <?php } ?>

          <?php 
            $param_string = '&userId=' . Params::getParam('userId') . '&name=' . Params::getParam('name') . '&email=' . Params::getParam('email') . '&phone=' . Params::getParam('phone') . '&text=' . Params::getParam('text') . '&location=' . Params::getParam('location') . '&status=' . Params::getParam('status') . '&date=' . Params::getParam('date') . '&regDate=' . Params::getParam('regDate') . '&sort=' . Params::getParam('sort') . '&logAction=' . Params::getParam('logAction');
            echo hsl_admin_paginate('history_logger/admin/logs_user.php', Params::getParam('pageId'), (hsl_param('per_page') > 0 ? hsl_param('per_page') : 30), $count_all, '', $param_string); 
          ?>
        <?php } ?>
      </div>
    </div>
  </div>
</div>