<?php
  // Create menu
  $title = __('Configure', 'hooks');
  hkm_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value


  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'hooks') );
  }

  if(Params::getParam('plugin_action') == 'hooks' && !hkm_is_demo()) {
    $params = Params::getParamsAsArray();

    $hook = isset($params['hook_name']) ? $params['hook_name'] : '';
    $functions_enabled_ar = array();
    $functions_disabled_ar = array();

    foreach($params as $p => $d) {
      $name = explode('|', $p);

      if(@$name[0] == 'hook_function') {
        //$enabled = $params['hook_function|enabled|' . $d];
        $enabled = isset($params['hook_function|enabled|' . @$name[2]]) ? $params['hook_function|enabled|' . @$name[2]] : 0;
        $enabled = ($enabled == 'on' ? 1 : 0);

        if($enabled == 1) {
          $functions_enabled_ar[] = @$name[2];
        } else {
          $functions_disabled_ar[] = @$name[2];
        }
      }
    }

    $functions_enabled = implode('|', array_unique($functions_enabled_ar));
    $functions_disabled = implode('|', array_unique($functions_disabled_ar));


    ModelHKM::newInstance()->updateHook($hook, $functions_enabled, $functions_disabled);

    osc_add_flash_ok_message( __('Hook configuration saved', 'hooks'), 'admin' );
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=hooks/admin/configure.php&updatedHook=' . $hook);
  }


  if(Params::getParam('removeHook') <> '') {
    ModelHKM::newInstance()->removeHook(Params::getParam('removeHook'));

    osc_add_flash_ok_message( __('Hook reseted to defaults', 'hooks'), 'admin' );
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=hooks/admin/configure.php&updatedHook=' . Params::getParam('removeHook'));
  }


  if(Params::getParam('updatedHook') <> '' || Params::getParam('removeHook') <> '') {
    ?>
      <script>
        $(document).ready(function(){ 
          $('.mb-field[data-hook="<?php echo Params::getParam('updatedHook'); ?>"] .mb-top-line').click(); 
          $('html, body').animate({ scrollTop: $('.mb-field[data-hook="<?php echo Params::getParam('updatedHook'); ?>"]').offset().top - 60 }, 0);
        });         
      </script>
    <?php
  }


  $hook_list = array_keys(Plugins::getActive());
  $hook_list = array_filter($hook_list, 'hkm_array_filter');
  $hook_full = Plugins::getActive();

  $hooks_plugin = ModelHKM::newInstance()->getHooks();
  
  if($hooks_plugin) {
    foreach($hooks_plugin as $hp) {
      if($hp['s_disabled'] <> '') {
        if(isset($hook_full[$hp['pk_s_hook']][10]) && is_array($hook_full[$hp['pk_s_hook']][10]) && !empty($hook_full[$hp['pk_s_hook']][10])) {
          $hook_full[$hp['pk_s_hook']][10] = array_merge($hook_full[$hp['pk_s_hook']][10], explode('|', $hp['s_disabled']));
        } else {
          $hook_full[$hp['pk_s_hook']][10] = explode('|', $hp['s_disabled']);
        }
      }
    }
  }
?>

<div class="mb-body">
  <div class="mb-message-js"></div>

  <!-- HOOKS SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-list"></i> <?php _e('Hooks', 'hooks'); ?>
    </div>

    <div class="mb-inside mb-hooks">
      <div id="mb-hooks">
        <?php if(count($hook_list) > 0) { ?>
          <?php $i = 0; ?>
          <?php foreach($hook_full as $hook => $functions) { ?>
            <?php if(in_array($hook, $hook_list)) { ?>
              <?php 
                $hook_conf = ModelHKM::newInstance()->getHook($hook);
                $hook_conf_enabled = array();
                $hook_conf_disabled = array();
                
                if($hook_conf !== false && isset($hook_conf['s_enabled']) && isset($hook_conf['s_disabled'])) {
                  $hook_conf_enabled = explode('|', (string)$hook_conf['s_enabled']);
                  $hook_conf_disabled = explode('|', (string)$hook_conf['s_disabled']);
                }
              ?> 

              <form name="promo_form" id="hkm_<?php echo $hook; ?>" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
                <input type="hidden" name="page" value="plugins" />
                <input type="hidden" name="action" value="renderplugin" />
                <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
                <input type="hidden" name="plugin_action" value="hooks" />
                <input type="hidden" name="hook_name" value="<?php echo $hook; ?>" />

                <div class="mb-field" data-hook="<?php echo $hook; ?>">
                  <div class="mb-top-line">
                    <span class="name">
                      <?php echo $hook; ?>
                      <?php if($hook_conf) { ?>
                        <i class="fa fa-pencil enabled mb-has-tooltip" title="<?php echo osc_esc_html(__('Modified', 'hooks')); ?>"></i>
                      <?php } ?>
                    </span>
                    <span class="count"><?php echo array_sum(array_map("count", $functions)) . ' '  . (array_sum(array_map("count", $functions)) == 1 ? __('function', 'hooks') : __('functions', 'hooks')); ?></span>
                    <span class="show"><i class="fa fa-angle-down"></i></span>
                  </div>

                  <div class="mb-details">
                    <div class="mb-values">
                      <div class="mb-val-title"><?php _e('Hook functions', 'hooks'); ?></div>
                      <div class="mb-val-subtitle"><?php _e('Drag and drop function into expected position. Functions will be executed in selected order.', 'hooks'); ?></div>

                      <ol class="sortable">
                        <?php if(count($functions) > 0) { ?>
                          <?php foreach($functions as $priority => $list) { ?>
                            <?php foreach($list as $l) { ?>
                              <?php if($l <> 'hkm_manage' && !is_array($l) && $l <> '' && !is_object($l)) { ?>
                                <div>
                                  <i class="fa fa-arrows move"></i>
                                  <input name="hook_function|name|<?php echo $l; ?>" type="text" class="val-field val-name" value="<?php echo $l; ?>" readonly />

                                  <div class="mb-val-right">
                                    <label><?php _e('Enabled', 'hooks'); ?>:</label>
                                    <input name="hook_function|enabled|<?php echo $l; ?>" type="checkbox" class="element-slide val-field val-enabled" <?php if(!(!empty($hook_conf_disabled) && in_array($l, $hook_conf_disabled))) { ?>checked<?php } ?>/>
                                  </div>
                                </div>
                              <?php } ?>
                            <?php } ?>
                          <?php } ?>
                        <?php } ?>
                      </ol>
                    </div>
                  </div>

                  <div class="mb-foot">
                    <?php if($hook_conf) { ?>
                      <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=hooks/admin/configure.php&removeHook=<?php echo $hook; ?>" class="mb-button remove" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove configuration? Action cannot be undone', 'hooks')); ?>')"><?php _e('Reset hook', 'hooks');?></a>
                    <?php } ?>

                    <?php if(hkm_is_demo()) { ?>
                      <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'hooks')); ?>"><?php _e('Update hook', 'hooks');?></a>
                    <?php } else { ?>
                      <button type="submit" class="mb-button"><?php _e('Update hook', 'hooks');?></button>
                    <?php } ?>
                  </div>
                </div>
              </form>

            <?php } ?>
          <?php } ?>
        <?php } ?>
      </div>
    </div>
  </div>
</div>


<script type="text/javascript">
  // SORTABLE VALUES
  $(document).ready(function(){
    $('ol.sortable').sortable({
      forcePlaceholderSize: true,
      axis: "y",
      forcePlaceholderSize: true,
      handle: '.move',
      helper: 'clone',
      items: '> div',
      listType: 'ol',
      opacity: .8,
      placeholder: 'placeholder',
      revert: 100,
      tabSize: 5,
      tolerance: 'intersect',
      toleranceElement: '> div'
    });

  });
</script>


<?php echo hkm_footer(); ?>