<?php


// HOOKS MANAGEMENT IN FRONT & BACK
function hkm_manage() {
  $hooks = ModelHKM::newInstance()->getHooks();

  $hook_list = array_keys(Plugins::getActive());
  $hook_full = Plugins::getActive();

  if($hooks) {
    if(is_array($hooks) && count($hooks) > 0) {
      foreach($hooks as $hook) {
        $name = $hook['pk_s_hook'];
        $functions_e = explode('|', $hook['s_enabled']);
        $functions_d = explode('|', $hook['s_disabled']);

        $hook_functions = isset($hook_full[$name]) ? $hook_full[$name] : array();
        $orig_functions = array();

        if(is_array($hook_functions) && count($hook_functions) > 0) {
          foreach($hook_functions as $i => $functions) {
            if(count($functions) > 0) {
              foreach($functions as $f) {
                $orig_functions[] = $f;
              }
            }
          }
        }

        if(is_array($orig_functions) && count($orig_functions) > 0) {
          foreach($orig_functions as $of) {
            if(!in_array($of, $functions_d) && !in_array($of, $functions_e)) {
              osc_remove_hook($name, $of);
              osc_add_hook($name, $of, 7);
            }
          }
        }

        if(is_array($functions_d) && count($functions_d) > 0) {
          foreach($functions_d as $fd) {
            osc_remove_hook($name, $fd);
          }
        }

        if(is_array($functions_e) && count($functions_e) > 0) {
          foreach($functions_e as $fe) {
            osc_remove_hook($name, $fe);
            osc_add_hook($name, $fe, 3);
          }
        }
      }
  }
  }
}

osc_add_hook('init', 'hkm_manage', 0);
osc_add_hook('init_admin', 'hkm_manage', 0);


// CHECK IF RUNNING ON DEMO
function hkm_is_demo() {
  if(osc_logged_admin_username() == 'admin') {
    return false;
  } else if(isset($_SERVER['HTTP_HOST']) && (strpos($_SERVER['HTTP_HOST'],'mb-themes') !== false || strpos($_SERVER['HTTP_HOST'],'abprofitrade') !== false)) {
    return true;
  } else {
    return false;
  }
}


// REMOVE UNWANTED (INSTALLATION) HOOKS
function hkm_array_filter($string) {
  return (strpos($string, 'index.php') === false && strpos($string, 'hkm_manage') === false && strpos($string, 'ajax_') === false);
}


// CORE FUNCTIONS
if(!function_exists('mb_param_update')) {
  function mb_param_update( $param_name, $update_param_name, $type = NULL, $plugin_var_name = NULL ) {
  
    $val = '';
    if( $type == 'check') {

      // Checkbox input
      if( Params::getParam( $param_name ) == 'on' ) {
        $val = 1;
      } else {
        if( Params::getParam( $update_param_name ) == 'done' ) {
          $val = 0;
        } else {
          $val = ( osc_get_preference( $param_name, $plugin_var_name ) != '' ) ? osc_get_preference( $param_name, $plugin_var_name ) : '';
        }
      }
    } else {

      // Other inputs (text, password, ...)
      if( Params::getParam( $update_param_name ) == 'done' && Params::existParam($param_name)) {
        $val = Params::getParam( $param_name );
      } else {
        $val = ( osc_get_preference( $param_name, $plugin_var_name) != '' ) ? osc_get_preference( $param_name, $plugin_var_name ) : '';
      }
    }


    // If save button was pressed, update param
    if( Params::getParam( $update_param_name ) == 'done' ) {

      if(osc_get_preference( $param_name, $plugin_var_name ) == '') {
        osc_set_preference( $param_name, $val, $plugin_var_name, 'STRING');  
      } else {
        $dao_preference = new Preference();
        $dao_preference->update( array( "s_value" => $val ), array( "s_section" => $plugin_var_name, "s_name" => $param_name ));
        osc_reset_preferences();
        unset($dao_preference);
      }
    }

    return $val;
  }
}



if(!function_exists('message_ok')) {
  function message_ok( $text ) {
    $final  = '<div class="flashmessage flashmessage-ok flashmessage-inline">';
    $final .= $text;
    $final .= '</div>';
    echo $final;
  }
}


if(!function_exists('message_error')) {
  function message_error( $text ) {
    $final  = '<div class="flashmessage flashmessage-error flashmessage-inline">';
    $final .= $text;
    $final .= '</div>';
    echo $final;
  }
}


if( !function_exists('osc_is_contact_page') ) {
  function osc_is_contact_page() {
    $location = Rewrite::newInstance()->get_location();
    $section = Rewrite::newInstance()->get_section();
    if( $location == 'contact' ) {
      return true ;
    }

    return false ;
  }
}


// COOKIES WORK
if(!function_exists('mb_set_cookie')) {
  function mb_set_cookie($name, $val) {
    Cookie::newInstance()->set_expires( 86400 * 30 );
    Cookie::newInstance()->push($name, $val);
    Cookie::newInstance()->set();
  }
}


if(!function_exists('mb_get_cookie')) {
  function mb_get_cookie($name) {
    return Cookie::newInstance()->get_value($name);
  }
}

if(!function_exists('mb_drop_cookie')) {
  function mb_drop_cookie($name) {
    Cookie::newInstance()->pop($name);
  }
}

?>