<?php
/*
  Plugin Name: Hooks Manager Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/backoffice/hooks-manager-plugin-i78
  Description: Manage and reorder functions in hooks
  Version: 1.2.2
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@mb-themes.com
  Short Name: hooks
  Plugin update URI: hooks
  Support URI: https://forums.osclasspoint.com/hooks-manager-plugin/
  Product Key: FCovG0JwLwogaSRGLSAW
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelHKM.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';



// INSTALL FUNCTION - DEFINE VARIABLES
function hkm_call_after_install() {
  ModelHKM::newInstance()->install();
}


function hkm_call_after_uninstall() {
  ModelHKM::newInstance()->uninstall();
}




// DATA FOR TESTING
//function hkm_item_detail1($item = '') {  echo '<div style="float:left;clear:both;width:100%;padding:15px;margin:8px 0;text-align:center;font-size:13px;font-weight:600;color:#333;background:#bbe4aa;">Hooks Manager Plugin - Function #1</div>';}
//function hkm_item_detail2($item = '') { echo '<div style="float:left;clear:both;width:100%;padding:15px;margin:8px 0;text-align:center;font-size:13px;font-weight:600;color:#333;background:#bbe4aa;">Hooks Manager Plugin - Function #2</div>';}
//function hkm_item_detail3($item = '') { echo '<div style="float:left;clear:both;width:100%;padding:15px;margin:8px 0;text-align:center;font-size:13px;font-weight:600;color:#333;background:#bbe4aa;">Hooks Manager Plugin - Function #3</div>';}
//osc_add_hook('item_detail', 'hkm_item_detail1');
//osc_add_hook('item_detail', 'hkm_item_detail2');
//osc_add_hook('item_detail', 'hkm_item_detail3');



// ADMIN MENU
function hkm_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/hooks/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/hooks/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/hooks/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/hooks/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/hooks/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/hooks/js/bootstrap-switch.js"></script>';



  if( $title == '') { $title = __('Configure', 'hooks'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Hooks Manager Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=hooks/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'hooks') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function hkm_footer() {
  $pluginInfo = osc_plugin_get_info('hooks/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://mb-themes.com"><img src="https://mb-themes.com/favicon.ico" alt="MB Themes" /> MB-Themes.com</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'hooks') . '</a>';
  $text .= '<a target="_blank" href="https://forums.mb-themes.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'hooks') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@mb-themes.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'hooks') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function hkm_admin_menu() {
echo '<h3><a href="#">Hooks Manager Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'hooks') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','hkm_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function hkm_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'hkm_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'hkm_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'hkm_call_after_uninstall');

?>