<?php
class ModelHKM extends DAO {
private static $instance;

public static function newInstance() {
  if( !self::$instance instanceof self ) {
    self::$instance = new self;
  }
  return self::$instance;
}

function __construct() {
  parent::__construct();
}


public function getTable_hook() {
  return DB_TABLE_PREFIX.'t_hook';
}


public function import($file) {
  $path = osc_plugin_resource($file);
  $sql = file_get_contents($path);

  if(!$this->dao->importSQL($sql) ){
    throw new Exception("Error importSQL::ModelHKM<br>" . $file . "<br>" . $this->dao->getErrorLevel() . " - " . $this->dao->getErrorDesc() );
  }
}


public function install() {
  $this->import('hooks/model/struct.sql');
}


public function uninstall() {
  // DELETE ALL TABLES
  $this->dao->query(sprintf('DROP TABLE %s', $this->getTable_hook()));

  // DELETE ALL PREFERENCES
  $db_prefix = DB_TABLE_PREFIX;
  $query = "DELETE FROM {$db_prefix}t_preference WHERE s_section = 'plugin-hooks'";
  $this->dao->query($query);
}




// GET HOOK
public function getHook($hook) {
  $this->dao->select('*');
  $this->dao->from($this->getTable_hook());
  $this->dao->where('pk_s_hook', $hook);

  $result = $this->dao->get();
  
  if($result) {
    return $result->row();
  }

  return false;
}


// GET HOOKS
public function getHooks() {
  $this->dao->select('*');
  $this->dao->from($this->getTable_hook());

  $result = $this->dao->get();
  
  if($result) {
    return $result->result();
  }

  return false;
}


// REMOVE HOOK SETTINGS
public function removeHook($hook) {
  return $this->dao->delete($this->getTable_hook(), array('pk_s_hook' => $hook));
}



// UPDATE HOOK
public function updateHook($hook, $enabled, $disabled) {
  if(trim((string)$hook) == '') { return false; }
  return $this->dao->replace($this->getTable_hook(), array('pk_s_hook' => $hook, 's_enabled' => $enabled, 's_disabled' => $disabled));
}


}
?>