<?php
  // Create menu
  $title = __('Configure', 'image_required');
  ir_menu($title);


  // PROMOTE FUNCTIONALITY
  $image_required = ir_param_update( 'image_required', 'plugin_action', 'check' );
  $image_min = ir_param_update( 'image_min', 'plugin_action' );

  if( Params::getParam( 'plugin_action' ) == 'done' && Params::existParam( 'image_max' )) {
    $image_max = Params::getParam( 'image_max' );
  } else {
    $image_max = ( osc_get_preference('numImages@items', 'osclass') != '' ) ? osc_get_preference('numImages@items', 'osclass') : '';
  }


  if(Params::getParam('plugin_action') == 'done') {
    if(osc_get_preference( 'numImages@items' ) == '') {
      osc_set_preference( 'numImages@items', 0, 'osclass');  
    } else {
      $dao_preference = new Preference();
      $dao_preference->update( array( "s_value" => $image_max ), array( "s_section" => "osclass", "s_name" => 'numImages@items' ));
      osc_reset_preferences();
      unset($dao_preference);
    }

    message_ok( __('Settings for Image Required successfully saved', 'image_required') );
  }
    
?>

<div class="mb-body">

  <!-- PROMOTE FUNCTIONALITY -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-cog"></i> <?php _e('Image required settings', 'image_required'); ?></div>

    <div class="mb-inside">
      <form name="promo_form" id="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />

        <div class="mb-row">
          <label for="image_required" class="h1"><span><?php _e('Enable Image Required', 'image_required'); ?></span></label> 
          <input name="image_required" id="image_required" class="element-slide" type="checkbox" <?php echo ($image_required == 1 ? 'checked' : ''); ?> />
        </div>
        
        <div class="mb-row">
          <label for="image_min" class="h2"><span><?php _e('Minimum Images Count', 'image_required'); ?></span></label> 
          <input size="3" name="image_min" id="image_min" type="text" class="mb-short" value="<?php echo $image_min; ?>" />
          <div class="mb-input-desc"><?php _e('image(s)', 'image_required'); ?></div>

          <div class="mb-explain"><?php _e('Leave blank or set 0 to disable.', 'image_required'); ?></div>
        </div>

        <div class="mb-row">
          <label for="image_max" class="h3"><span><?php _e('Maximum Images Count', 'image_required'); ?></span></label> 
          <input size="3" name="image_max" id="image_max" type="text" class="mb-short" value="<?php echo $image_max; ?>" />
          <div class="mb-input-desc"><?php _e('image(s)', 'image_required'); ?></div>

          <div class="mb-explain"><?php _e('Leave blank or set 0 to disable.', 'image_required'); ?></div>
        </div>
        
      </div>

      <div class="mb-foot">
        <?php if(!ir_is_demo()) { ?>
          <button type="submit" class="mb-button"><?php _e('Save', 'image_required');?></button>
        <?php } else { ?>
          <a href="#" onclick="return false" class="mb-button"><?php _e('Save (demo - disabled)', 'image_required');?></button>
        <?php } ?>
      </div>
    </form>
  </div>


  
  <!-- HELP TOPICS -->
  <div class="mb-box" id="mb-help">
    <div class="mb-head"><i class="fa fa-question-circle"></i> <?php _e('Help', 'image_required'); ?></div>

    <div class="mb-inside">
      <div class="mb-row mb-help"><span class="sup">(1)</span> <div class="h1"><?php _e('Set to Yes if you want to enable Image Required functionality.', 'image_required'); ?></div></div>
      <div class="mb-row mb-help"><span class="sup">(2)</span> <div class="h2"><?php _e('Set minimum count of pictures that user must upload during listing publish. Leave empty or set to 0 to disable.', 'image_required'); ?></div></div>
      <div class="mb-row mb-help"><span class="sup">(3)</span> <div class="h3"><?php _e('Set maximum count of pictures that user can upload during listing publish. Leave empty or set to 0 to disable. Note that this functionality is handled by osclass core and can be found in oc-admin > Listings > Settings section.', 'image_required'); ?></div></div>
      <div class="mb-row mb-help"><div><?php _e('Note that image control via javascript will be active after category is selected (in time of category selection, checking form is uploaded to site).', 'image_required'); ?></div></div>
    </div>
  </div>
</div>

<?php echo ir_footer(); ?>
