<?php
  // Create menu
  $title = __('Configure', 'infinite');
  inf_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value
  
  $enable = mb_param_update('enable', 'plugin_action', 'check', 'plugin-infinite');
  $report_errors = mb_param_update('report_errors', 'plugin_action', 'check', 'plugin-infinite');
  $preload = mb_param_update('preload', 'plugin_action', 'check', 'plugin-infinite');
  $content_block = mb_param_update('content_block', 'plugin_action', 'value', 'plugin-infinite');
  $listings_parent_block = mb_param_update('listings_parent_block', 'plugin_action', 'value', 'plugin-infinite');
  $pagination_block = mb_param_update('pagination_block', 'plugin_action', 'value', 'plugin-infinite');
  $pagination_next = mb_param_update('pagination_next', 'plugin_action', 'value', 'plugin-infinite');
  $loaded_listings_count = mb_param_update('loaded_listings_count', 'plugin_action', 'value', 'plugin-infinite');


  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'infinite') );
  }
?>


<div class="mb-body">
 
  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Configure', 'infinite'); ?></div>

    <div class="mb-inside mb-infinite">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <?php if(!inf_is_demo()) { ?>
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <?php } ?>

        <div class="mb-row">
          <label for="enable" class=""><span><?php _e('Enable Infinite Scroll', 'infinite'); ?></span></label> 
          <input name="enable" type="checkbox" class="element-slide" <?php echo ($enable == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, ininite scroll will work on search page.', 'infinite'); ?></div>
        </div>

        <div class="mb-row">
          <label for="report_errors" class=""><span><?php _e('Show Errors in Console', 'infinite'); ?></span></label> 
          <input name="report_errors" type="checkbox" class="element-slide" <?php echo ($report_errors == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, problems with infinite scroll will be reported to browser console. It is recommended to have it enabled as you may find information why infinite scoll does not work.', 'infinite'); ?></div>
        </div>

        <div class="mb-row">
          <label for="preload" class=""><span><?php _e('Preload Next Page', 'infinite'); ?></span></label> 
          <input name="preload" type="checkbox" class="element-slide" <?php echo ($preload == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, plugin will try to preload next page in order to reduce loading time to user and provide better user experience.', 'infinite'); ?></div>
        </div>

        <div class="mb-row">
          <label for="content_block" class=""><span><?php _e('Content Block Selector', 'infinite'); ?></span></label> 
          <input name="content_block" size="60" type="text" value="<?php echo $content_block; ?>" required />

          <div class="mb-explain"><?php _e('Enter selector that holds items & pagination content on search page (except sidebar). Enter only 1 selector! Most common values across themes', 'infinite'); ?>: #main</div>
        </div>
        
        <div class="mb-row">
          <label for="listings_parent_block" class=""><span><?php _e('Listings Parent Block Selector', 'infinite'); ?></span></label> 
          <input name="listings_parent_block" size="60" type="text" value="<?php echo $listings_parent_block; ?>" required />

          <div class="mb-explain"><?php _e('Enter selector that is closest parent block on search page (in this block all search listings are located, nothing else). Enter only 1 selector! Most common values across themes', 'infinite'); ?>: #listing-card-list, #search-items .products, #search-items .block > .wrap, .ad_list table tbody</div>
        </div>
        
        <div class="mb-row">
          <label for="pagination_block" class=""><span><?php _e('Pagination Block Selector', 'infinite'); ?></span></label> 
          <input name="pagination_block" size="60" type="text" value="<?php echo $pagination_block; ?>" required />

          <div class="mb-explain"><?php _e('Enter selector that holds pagination content on search page. Enter only 1 selector! Most common values across themes', 'infinite'); ?>: .paginate, .pagination, #pagination</div>
        </div>        
        
        <div class="mb-row">
          <label for="pagination_next" class=""><span><?php _e('Pagination Next Button Selector', 'infinite'); ?></span></label> 
          <input name="pagination_next" size="60" type="text" value="<?php echo $pagination_next; ?>" required />

          <div class="mb-explain"><?php _e('Enter selector that holds "next" button in pagination content on search page. Enter only 1 selector! Most common values across themes', 'infinite'); ?>: a.searchPaginationNext</div>
        </div>
        
        <div class="mb-row">
          <label for="loaded_listings_count" class=""><span><?php _e('Loaded Listings Counter Selector', 'infinite'); ?></span></label> 
          <input name="loaded_listings_count" size="60" type="text" value="<?php echo $loaded_listings_count; ?>" />

          <div class="mb-explain"><?php _e('Optional. Enter selector that holds loaded listings count content on search page (I.e. if you have text like loaded 1-12 listings and number 12 has own box). Enter only 1 selector!', 'infinite'); ?></div>
        </div>    
        


        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(inf_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'infinite')); ?>"><?php _e('Save', 'infinite');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'infinite');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>


  <!-- THEME CONFIG SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup on Theme', 'infinite'); ?></div>

    <div class="mb-inside mb-infinite">
      <div class="mb-row mb-notes">
        <div class="mb-line"><?php _e('Infinite Scroll Plugin does not require theme modifications, however require you to enter selectors for different elements precisely.', 'infinite'); ?></div>
        <div class="mb-line"><?php _e('You can use browser inspector to find proper selectors, if you are not sure, contact your theme author or use support forums', 'infinite'); ?></div>
        <div class="mb-line"><?php _e('Majority of themes (99%) has Content Block Selector, Pagination Block Selector and Pagination Next Button Selector same!', 'infinite'); ?></div>
      </div>

      <div class="mb-table mb-table-log">
        <div class="mb-table-head">
          <div class="mb-col-3 mb-align-left"><?php _e('Theme', 'osclass_pay');?></div>
          <div class="mb-col-4"><?php _e('Content Block Selector', 'osclass_pay');?></div>
          <div class="mb-col-9"><?php _e('Listings Parent Block Selector', 'osclass_pay');?></div>
          <div class="mb-col-4"><?php _e('Pagination Block Selector', 'osclass_pay');?></div>
          <div class="mb-col-4"><?php _e('Pagination Next Button Selector', 'osclass_pay');?></div>
        </div>

        <div class="mb-table-row">
          <div class="mb-col-3 mb-align-left" style="font-weight:bold;">Bender</div>
          <div class="mb-col-4">#main</div>
          <div class="mb-col-9">.listing-card-list</div>
          <div class="mb-col-4">.paginate</div>
          <div class="mb-col-4">a.searchPaginationNext</div>
        </div>
        
        <div class="mb-table-row">
          <div class="mb-col-3 mb-align-left" style="font-weight:bold;">Tatiana</div>
          <div class="mb-col-4">#main</div>
          <div class="mb-col-9">.ad_list .regular-offer + table:not(.premium-table)</div>
          <div class="mb-col-4">.paginate</div>
          <div class="mb-col-4">a.searchPaginationNext</div>
        </div>
        
        <div class="mb-table-row">
          <div class="mb-col-3 mb-align-left" style="font-weight:bold;">Zara</div>
          <div class="mb-col-4">#main</div>
          <div class="mb-col-9">#search-items > div</div>
          <div class="mb-col-4">.paginate</div>
          <div class="mb-col-4">a.searchPaginationNext</div>
        </div>
        
        <div class="mb-table-row">
          <div class="mb-col-3 mb-align-left" style="font-weight:bold;">Veronika</div>
          <div class="mb-col-4">#main</div>
          <div class="mb-col-9">#search-items .block > .wrap</div>
          <div class="mb-col-4">.paginate</div>
          <div class="mb-col-4">a.searchPaginationNext</div>
        </div>
        
        <div class="mb-table-row">
          <div class="mb-col-3 mb-align-left" style="font-weight:bold;">Starter</div>
          <div class="mb-col-4">#main</div>
          <div class="mb-col-9">#search-items .block > .wrap</div>
          <div class="mb-col-4">.paginate</div>
          <div class="mb-col-4">a.searchPaginationNext</div>
        </div>
        
        <div class="mb-table-row">
          <div class="mb-col-3 mb-align-left" style="font-weight:bold;">CareerJob</div>
          <div class="mb-col-4">#main</div>
          <div class="mb-col-9">#search-items .block > .wrap</div>
          <div class="mb-col-4">.paginate</div>
          <div class="mb-col-4">a.searchPaginationNext</div>
        </div>
        
        <div class="mb-table-row">
          <div class="mb-col-3 mb-align-left" style="font-weight:bold;">Stela</div>
          <div class="mb-col-4">#main</div>
          <div class="mb-col-9">#search-items .block > .wrap</div>
          <div class="mb-col-4">.paginate</div>
          <div class="mb-col-4">a.searchPaginationNext</div>
        </div>
        
        <div class="mb-table-row">
          <div class="mb-col-3 mb-align-left" style="font-weight:bold;">Alpha</div>
          <div class="mb-col-4">#main</div>
          <div class="mb-col-9">#search-items .block > .wrap</div>
          <div class="mb-col-4">.paginate</div>
          <div class="mb-col-4">a.searchPaginationNext</div>
        </div>
        
        <div class="mb-table-row">
          <div class="mb-col-3 mb-align-left" style="font-weight:bold;">Beta</div>
          <div class="mb-col-4">#main</div>
          <div class="mb-col-9">#search-items .block > .wrap</div>
          <div class="mb-col-4">.paginate</div>
          <div class="mb-col-4">a.searchPaginationNext</div>
        </div>
        
        <div class="mb-table-row">
          <div class="mb-col-3 mb-align-left" style="font-weight:bold;">Gamma</div>
          <div class="mb-col-4">#main</div>
          <div class="mb-col-9">#search-items .products</div>
          <div class="mb-col-4">.paginate</div>
          <div class="mb-col-4">a.searchPaginationNext</div>
        </div>

        <div class="mb-table-row">
          <div class="mb-col-3 mb-align-left" style="font-weight:bold;">Delta</div>
          <div class="mb-col-4">#main</div>
          <div class="mb-col-9">#search-items .block > .wrap > .products.standard</div>
          <div class="mb-col-4">.paginate</div>
          <div class="mb-col-4">a.searchPaginationNext</div>
        </div>
        
        <div class="mb-table-row">
          <div class="mb-col-3 mb-align-left" style="font-weight:bold;">Epsilon</div>
          <div class="mb-col-4">#search-main</div>
          <div class="mb-col-9">#search-items > .products</div>
          <div class="mb-col-4">.paginate</div>
          <div class="mb-col-4">a.searchPaginationNext</div>
        </div>
        
        <div class="mb-table-row">
          <div class="mb-col-3 mb-align-left" style="font-weight:bold;">Sigma</div>
          <div class="mb-col-4">#main</div>
          <div class="mb-col-9">.listing-card-list</div>
          <div class="mb-col-4">.paginate</div>
          <div class="mb-col-4">a.searchPaginationNext</div>
        </div>
        
      </div>
    </div>
  </div>        
</div>


<?php echo inf_footer(); ?>