<?php
  $content_block = htmlspecialchars_decode(inf_param('content_block'));
  $listings_parent_block = htmlspecialchars_decode(inf_param('listings_parent_block'));
  $pagination_block = htmlspecialchars_decode(inf_param('pagination_block'));
  $pagination_next = htmlspecialchars_decode(inf_param('pagination_next'));
  $loaded_listings_count = htmlspecialchars_decode(inf_param('loaded_listings_count'));
  $report_errors = htmlspecialchars_decode(inf_param('report_errors'));
  $preload = (inf_param('preload') == 1 ? 1 : 0);
?>

<style>
  <?php echo $pagination_block; ?> {display:none!important;}
  .inf-loader {display:none;width:100%;padding:25px 5px;margin:20px 0;background:#eee;border-radius:6px;color:#777;font-size:16px;text-align:center;line-height:20px;}
  .inf-loader > div {display:inline-block;width:auto;position:relative;padding-left:44px;}
  .inf-loader img {position:absolute;display:inline-block;top:-6px;left:0;width:32px;height:32px;max-height:32px;max-width:32px;}
  .inf-loader span {display:inline-block;font-weight:bold;line-height:20px;font-size:14px;}
  <?php echo $content_block; ?>.loading .inf-loader {display:inline-block;}
</style>

<script async type="text/javascript">
var infScollTimeout = '';
var currentPag = 1;
var isLoading = false;
var pagUrl = '';
var newUrl = '';
var oldUrl = '';
var loadingBlock = '<div class="inf-loader"><div><img src="<?php echo osc_base_url(); ?>oc-content/plugins/infinite/img/loader.gif"/><span><?php echo osc_esc_js(__('Loading items...', 'infinite')); ?></span></div></div>';
var infCache = [];
var isCacheLoading = false;
var infScollCacheTimeout = '';

$(document).ready(function() {
  // ADD LOADING BLOCK ABOVE PAGINATION
  $(window).scroll(function(e) {
    infScoll(e);
  });
  
  // INSTANTLY PRELOAD NEXT PAGE
  setTimeout(function() {
    infScollToCache();
  }, 200);
});


// EXECUTE INFINITE SCROLL
function infScoll(e) {
  (typeof(infScollTimeout) !== undefined) ? clearTimeout(infScollTimeout) : '';  

  infScollTimeout = setTimeout(function() {
    var scroll = $(window).scrollTop();
    var threshold = $('<?php echo $content_block; ?>').position().top + $('<?php echo $content_block; ?>').innerHeight() - 100;
    var position = $(window).scrollTop() + $(window).innerHeight();

    if($('<?php echo $pagination_next; ?>').length) {
      pagUrl = $('<?php echo $pagination_next; ?>').attr('href');
    } else {
      pagUrl = '';  
    }

    var urlId = encodeURI(pagUrl);

    //console.log(oldUrl + '--->' + pagUrl );

    // loading block add above pagination now
    if(!$('<?php echo $content_block; ?>').find('.inf-loader').length) {
      $(loadingBlock).insertBefore($('<?php echo $pagination_block; ?>'));
    }

    if(!$('<?php echo $content_block; ?>').length || !$('<?php echo $listings_parent_block; ?>').length || !$('<?php echo $pagination_block; ?>').length || !$('<?php echo $pagination_next; ?>').length) {
      infCheckBlocks();
     
    } else if(position > threshold && isLoading == false && pagUrl != oldUrl && pagUrl != '' && pagUrl != '#') {

      isLoading = true;
      $('<?php echo $content_block; ?>').addClass('loading');

      if(infCache[urlId] === undefined) {
        $.ajax({
          url: pagUrl,
          type: "GET",
          success: function(response){
            var length = response.length;
            var data = $(response).contents().find('<?php echo $listings_parent_block ; ?>').last().html();
            var pagBlock = $(response).contents().find('<?php echo $pagination_block; ?>');
            var currItemCount = $(response).contents().find('<?php echo $loaded_listings_count; ?>').text();

            oldUrl = pagUrl;

            $('<?php echo $pagination_block; ?>').html(pagBlock);
            $('<?php echo $listings_parent_block; ?>').last().append(data);
            

            if($('<?php echo $loaded_listings_count; ?>').length) {
              $('<?php echo $loaded_listings_count; ?>').text(currItemCount);
            }

            // lazy load if exists
            if(typeof $.fn.Lazy !== 'undefined') { 
              $('<?php echo $listings_parent_block; ?>').last().find('img.lazy').Lazy({
                appendScroll: window,
                scrollDirection: 'both',
                effect: 'fadeIn',
                effectTime: 200,
                afterLoad: function(element) {
                  setTimeout(function() {
                    element.css('transition', '0.2s');
                  }, 200);
                }
              });
            }

            isLoading = false;
            currentPag = currentPag + 1;
            $('<?php echo $content_block; ?>').removeClass('loading');
            
            $(window).scrollTop(scroll);
          }, 
          
          error: function(response){
            hasPag = false;
            $('<?php echo $content_block; ?>').removeClass('loading');

            response = response.responseText;

            console.log(response);
            console.log(data);
          }
        });
        
      } else {
        
        var data = infCache[urlId]['data'];
        var pagBlock = infCache[urlId]['pagination'];
        var currItemCount = infCache[urlId]['item_count'];

        oldUrl = pagUrl;

        $('<?php echo $pagination_block; ?>').html(pagBlock);
        $('<?php echo $listings_parent_block; ?>').last().append(data);

        if($('<?php echo $loaded_listings_count; ?>').length) {
          $('<?php echo $loaded_listings_count; ?>').text(currItemCount);
        }

        // lazy load if exists
        if(typeof $.fn.Lazy !== 'undefined') { 
          $('<?php echo $listings_parent_block; ?>').last().find('img.lazy').Lazy({
            appendScroll: window,
            scrollDirection: 'both',
            effect: 'fadeIn',
            effectTime: 200,
            afterLoad: function(element) {
              setTimeout(function() {
                element.css('transition', '0.2s');
              }, 200);
            }
          });
        }

        isLoading = false;
        currentPag = currentPag + 1;
        $('<?php echo $content_block; ?>').removeClass('loading');
        
        $(window).scrollTop(scroll);
      }
      

      // Preload next page
      setTimeout(function() {
        infScollToCache();
      }, 200);
      
    }
  }, 200);
}


// PRELOAD NEXT PAGE AND STORE IT INTO CACHE
function infScollToCache() {
  if(<?php echo $preload; ?> != 1) {
    return false;
  }
  
  (typeof(infScollCacheTimeout) !== undefined) ? clearTimeout(infScollCacheTimeout) : '';  

  infScollCacheTimeout = setTimeout(function() {
    if($('<?php echo $pagination_next; ?>').length) {
      pagUrl = $('<?php echo $pagination_next; ?>').attr('href');
    } else {
      pagUrl = '';  
    }

    var urlId = encodeURI(pagUrl);

    if(!$('<?php echo $content_block; ?>').length || !$('<?php echo $listings_parent_block; ?>').length || !$('<?php echo $pagination_block; ?>').length || !$('<?php echo $pagination_next; ?>').length) {
      infCheckBlocks();
     
    } else if(isCacheLoading == false && pagUrl != oldUrl && pagUrl != '' && pagUrl != '#') {
      if(infCache[urlId] === undefined) {
        isCacheLoading = true;

        $.ajax({
          url: pagUrl,
          type: "GET",
          success: function(response){
            var length = response.length;
            var data = $(response).contents().find('<?php echo $listings_parent_block ; ?>').last().html();
            var pagBlock = $(response).contents().find('<?php echo $pagination_block; ?>');
            var currItemCount = $(response).contents().find('<?php echo $loaded_listings_count; ?>').text();

            if(data != '') {
              infCache[urlId] = [];
              infCache[urlId]['pagination'] = pagBlock;
              infCache[urlId]['item_count'] = currItemCount;
              infCache[urlId]['data'] = data;
            }
            
            //console.log(infCache);
            
            isCacheLoading = false;
          }, 
          error: function(response){
          }
        });
      }
    }
  }, 200);
}


// CHECK IF ALL REQUIRED BLOCKS EXISTS
function infCheckBlocks() {
  <?php if($report_errors == 1) { ?>
    console.log('<?php echo osc_esc_js(__('Infinite scroll failed to load next items, check message bellow!', 'infinite')); ?>');
    
    if(!$('<?php echo $content_block; ?>').length) {
      console.log('<?php echo osc_esc_js(sprintf(__('Content block does not exists, make sure selector is correct. Current selector: %s', 'infinite'), $content_block)); ?>');
    }

    if(!$('<?php echo $listings_parent_block; ?>').length) {
      console.log('<?php echo osc_esc_js(sprintf(__('Listing parent block does not exists, make sure selector is correct. Current selector: %s', 'infinite'), $listings_parent_block)); ?>');
    }
    
    if(!$('<?php echo $pagination_block; ?>').length) {
      console.log('<?php echo osc_esc_js(sprintf(__('Pagination block does not exists, maybe there are no other pages. Make sure selector is correct. Current selector: %s', 'infinite'), $pagination_block)); ?>');
    }
    
    if(!$('<?php echo $pagination_next; ?>').length) {
      console.log('<?php echo osc_esc_js(sprintf(__('Pagination next button does not exists, maybe there are no other pages. Make sure selector is correct. Current selector: %s', 'infinite'), $pagination_next)); ?>');
    }
  <?php } ?>
}
</script>