<?php
/*
  Plugin Name: Infinite Scroll Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/design-and-appearance/infinite-scroll-osclass-plugin_i113
  Description: Plugin removes pagination and will automatically load new listings on scroll when reaching bottom of page.
  Version: 1.3.1
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: infinite
  Plugin update URI: infinite
  Support URI: https://forums.osclasspoint.com/infinite-scroll-osclass-plugin/
  Product Key: P2xUxTzHUv8LMkGB14BV
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelINF.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';



// INSTALL FUNCTION - DEFINE VARIABLES
function inf_call_after_install() {
  osc_set_preference('enable', 0, 'plugin-infinite', 'INTEGER');
  osc_set_preference('report_errors', 1, 'plugin-infinite', 'INTEGER');
  osc_set_preference('preload', 1, 'plugin-infinite', 'INTEGER');
  osc_set_preference('content_block', '#main', 'plugin-infinite', 'STRING');
  osc_set_preference('listings_parent_block', '#search-items .block > .wrap', 'plugin-infinite', 'STRING');
  osc_set_preference('pagination_block', '.paginate', 'plugin-infinite', 'STRING');
  osc_set_preference('pagination_next', 'a.searchPaginationNext', 'plugin-infinite', 'STRING');
  osc_set_preference('loaded_listings_count', '', 'plugin-infinite', 'STRING');

  ModelINF::newInstance()->install();
}


function inf_call_after_uninstall() {
  ModelINF::newInstance()->uninstall();
}

// ADD CSS & JS TO FOOTER
function inf_css_js_footer() {
  if(inf_param('enable') == 1 && osc_is_search_page()) {
    require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'form/css_js.php';
  }
}

osc_add_hook('footer', 'inf_css_js_footer');


// ADMIN MENU
function inf_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/infinite/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/infinite/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/infinite/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/infinite/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/infinite/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/infinite/js/bootstrap-switch.js"></script>';



  if( $title == '') { $title = __('Configure', 'infinite'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Infinite Scroll Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=infinite/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'infinite') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function inf_footer() {
  $pluginInfo = osc_plugin_get_info('infinite/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint Market" /> OsclassPoint Market</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'infinite') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'infinite') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'infinite') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function inf_admin_menu() {
echo '<h3><a href="#">Infinite Scroll Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'infinite') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','inf_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function inf_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'inf_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'inf_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'inf_call_after_uninstall');

?>