<?php
  // Create menu
  $title = __('Configure', 'invisible_recaptcha');
  inr_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  $site_key = mb_param_update('site_key', 'plugin_action', 'value', 'plugin-invisible_recaptcha');
  $secret_key = mb_param_update('secret_key', 'plugin_action', 'value', 'plugin-invisible_recaptcha');
  $logged_hide = mb_param_update('logged_hide', 'plugin_action', 'check', 'plugin-invisible_recaptcha');
  $register_enabled = mb_param_update('register_enabled', 'plugin_action', 'check', 'plugin-invisible_recaptcha');
  $login_enabled = mb_param_update('login_enabled', 'plugin_action', 'check', 'plugin-invisible_recaptcha');
  $admin_login_enabled = mb_param_update('admin_login_enabled', 'plugin_action', 'check', 'plugin-invisible_recaptcha');
  $comment_enabled = mb_param_update('comment_enabled', 'plugin_action', 'check', 'plugin-invisible_recaptcha');
  $friend_enabled = mb_param_update('friend_enabled', 'plugin_action', 'check', 'plugin-invisible_recaptcha');
  $item_contact_enabled = mb_param_update('item_contact_enabled', 'plugin_action', 'check', 'plugin-invisible_recaptcha');
  $publish_enabled = mb_param_update('publish_enabled', 'plugin_action', 'check', 'plugin-invisible_recaptcha');
  $badge_position = mb_param_update('badge_position', 'plugin_action', 'value', 'plugin-invisible_recaptcha');
  $report = mb_param_update('report', 'plugin_action', 'check', 'plugin-invisible_recaptcha');

  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'invisible_recaptcha') );
  }
?>


<div class="mb-body">

  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Configure', 'invisible_recaptcha'); ?></div>

    <div class="mb-inside mb-minify">
      <div class="mb-row mb-notes">
        <div class="mb-line"><?php _e('Get your recaptcha keys there:', 'invisible_recaptcha'); ?> <a href="https://www.google.com/recaptcha/admin#list">https://www.google.com/recaptcha/admin#list</a></div>
        <div class="mb-line"><?php _e('Make sure to disable Osclass ReCaptcha in oc-admin > Settings > Spam and Protection.', 'invisible_recaptcha'); ?></div>
        <div class="mb-line"><?php _e('When invisible recaptcha is active, you will see it\'s logo in right bottom corner.', 'invisible_recaptcha'); ?></div>
      </div>

      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />

        <div class="mb-row">
          <label for="site_key" class="h1"><span><?php _e('Site Key', 'invisible_recaptcha'); ?></span></label> 
          <input name="site_key" size="55" id="site_key" type="text" class="" value="<?php echo $site_key; ?>" />
          
          <div class="mb-explain"><?php _e('Used in the HTML code your site serves to users.', 'invisible_recaptcha'); ?></div>
        </div>


        <div class="mb-row">
          <label for="secret_key" class="h2"><span><?php _e('Secret Key', 'invisible_recaptcha'); ?></span></label> 
          <input name="secret_key" size="55" id="secret_key" type="password" class="" value="<?php echo $secret_key; ?>" />
          
          <div class="mb-explain"><?php _e('Used for communication between your site and Google. Be sure to keep it a secret.', 'invisible_recaptcha'); ?></div>
        </div>


        <div class="mb-row">
          <label for="badge_position" class="h2"><span><?php _e('Badge Position', 'invisible_recaptcha'); ?></span></label> 
          <select name="badge_position">
            <option value="inline" <?php if($badge_position == 'inline' or $badge_position == '') { ?>selected="selected"<?php } ?>><?php _e('Inline - in form', 'invisible_recaptcha'); ?></option>
            <option value="bottomright" <?php if($badge_position == 'bottomright') { ?>selected="selected"<?php } ?>><?php _e('Bottom right', 'invisible_recaptcha'); ?></option>
            <option value="bottomleft" <?php if($badge_position == 'bottomleft') { ?>selected="selected"<?php } ?>><?php _e('Bottom left', 'invisible_recaptcha'); ?></option>
          </select>

          <div class="mb-explain"><?php _e('Position of google recaptcha badge. Use "inline" for testing. Badges except inline may not be visible all the time, however it does not mean recaptcha is not functional..', 'invisible_recaptcha'); ?></div>
        </div>

        <div class="mb-row">
          <label for="report" class="h3"><span><?php _e('Configuration report', 'invisible_recaptcha'); ?></span></label> 
          <input name="report" id="report" type="checkbox" class="element-slide" <?php echo ($report == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('Enable when configuring plugin, it will add message to form telling if setup is correct or no. It is recommended to have badge position set to inline while configuring plugin. Disable when configuration is done.', 'invisible_recaptcha'); ?></div>
        </div>

        <div class="mb-row">
          <label for="logged_hide" class="h3"><span><?php _e('Hide ReCaptcha for Logged-in Users', 'invisible_recaptcha'); ?></span></label> 
          <input name="logged_hide" id="logged_hide" type="checkbox" class="element-slide" <?php echo ($logged_hide == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, recaptcha is not shown to users that are logged in.', 'invisible_recaptcha'); ?></div>
        </div>




        <div class="mb-row">
          <label for="register_enabled" class="h5"><span><?php _e('Registration Form Enabled', 'invisible_recaptcha'); ?></span></label> 
          <input name="register_enabled" id="register_enabled" type="checkbox" class="element-slide" <?php echo ($register_enabled == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('ReCaptcha will be added to registration form. No theme modifications are required.', 'invisible_recaptcha'); ?></div>
        </div>


        <div class="mb-row">
          <label for="login_enabled" class="h6"><span><?php _e('Login Form Enabled', 'invisible_recaptcha'); ?></span></label> 
          <input name="login_enabled" id="login_enabled" type="checkbox" class="element-slide" <?php echo ($login_enabled == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('ReCaptcha will be added to login form. It is required to update user-login.php in your theme.', 'invisible_recaptcha'); ?></div>
        </div>


        <div class="mb-row">
          <label for="admin_login_enabled" class="h7"><span><?php _e('Admin Login Form Enabled', 'invisible_recaptcha'); ?></span></label> 
          <input name="admin_login_enabled" id="admin_login_enabled" type="checkbox" class="element-slide" <?php echo ($admin_login_enabled == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('ReCaptcha will be added to admin login form. Based on your osclass version, it may be required to update oc-admin/gui/login.php.', 'invisible_recaptcha'); ?></div>
        </div>


        <div class="mb-row">
          <label for="comment_enabled" class="h8"><span><?php _e('New Comment Form Enabled', 'invisible_recaptcha'); ?></span></label> 
          <input name="comment_enabled" id="comment_enabled" type="checkbox" class="element-slide" <?php echo ($comment_enabled == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('ReCaptcha will be added to new comment form. It is required to update your theme.', 'invisible_recaptcha'); ?></div>
        </div>


        <div class="mb-row">
          <label for="friend_enabled" class="h9"><span><?php _e('Send Friend Form Enabled', 'invisible_recaptcha'); ?></span></label> 
          <input name="friend_enabled" id="friend_enabled" type="checkbox" class="element-slide" <?php echo ($friend_enabled == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('ReCaptcha will be added to new comment form. It is required to update your theme.', 'invisible_recaptcha'); ?></div>
        </div>

        <div class="mb-row">
          <label for="item_contact_enabled" class="h10"><span><?php _e('Item Contact Form Enabled', 'invisible_recaptcha'); ?></span></label> 
          <input name="item_contact_enabled" id="item_contact_enabled" type="checkbox" class="element-slide" <?php echo ($item_contact_enabled == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('ReCaptcha will be added to item contact form. It is required to update your theme.', 'invisible_recaptcha'); ?></div>
        </div>

        <div class="mb-row">
          <label for="publish_enabled" class="h11"><span><?php _e('New Item Form', 'invisible_recaptcha'); ?></span></label> 
          <input name="publish_enabled" id="publish_enabled" type="checkbox" class="element-slide" <?php echo ($publish_enabled == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('ReCaptcha will be added to new item form. It is required to update your theme.', 'invisible_recaptcha'); ?></div>
        </div>


        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(inr_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'invisible_recaptcha')); ?>"><?php _e('Save', 'invisible_recaptcha');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'invisible_recaptcha');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>


  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'invisible_recaptcha'); ?></div>

    <div class="mb-inside">

      <div class="mb-row">
        <div class="mb-line"><?php _e('For some forms you must update your theme. There is list of files and their forms (common for most of themes), files are located in your theme folder (oc-content/{your-theme}/}', 'invisible_recaptcha'); ?>:</div>
        <div class="mb-line"><i class="fa fa-angle-right"></i> <strong><?php _e('Login form', 'invisible_recaptcha'); ?></strong> - user-login.php, user-register.php or inc.auth.php</div>
        <div class="mb-line"><i class="fa fa-angle-right"></i> <strong><?php _e('Admin login form', 'invisible_recaptcha'); ?></strong> - oc-admin/themes/omega/gui/login.php or oc-admin/gui/login.php</div>
        <div class="mb-line"><i class="fa fa-angle-right"></i> <strong><?php _e('New comment form', 'invisible_recaptcha'); ?></strong> - item.php or item-send-friend.php</div>
        <div class="mb-line"><i class="fa fa-angle-right"></i> <strong><?php _e('Send friend form', 'invisible_recaptcha'); ?></strong> - item-send-friend.php</div>
        <div class="mb-line"><i class="fa fa-angle-right"></i> <strong><?php _e('Item contact form', 'invisible_recaptcha'); ?></strong> - item.php, item-contact.php or item-send-friend.php</div>
        <div class="mb-line"><i class="fa fa-angle-right"></i> <strong><?php _e('Contact form', 'invisible_recaptcha'); ?></strong> - contact.php</div>
        <div class="mb-line"><i class="fa fa-angle-right"></i> <strong><?php _e('New item form', 'invisible_recaptcha'); ?></strong> - item-post.php</div>
        <div class="mb-line"><br/></div>

        <div class="mb-line"><?php echo sprintf(__('Following code must be placed after %s attribute:', 'invisible_recaptcha'), '<a target="_blank" href="https://www.w3schools.com/tags/att_form.asp">&lt;form&gt;</a>'); ?></div>
        <span class="mb-code">&lt;?php osc_run_hook('invisible_recaptcha'); ?&gt;</span>
      </div>
    </div>
  </div>
</div>


<?php echo inr_footer(); ?>