<?php
/*
  Plugin Name: Invisible ReCaptcha Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/protection-and-spam/invisible-recaptcha-plugin_i80
  Description: Secure your forms with Google Invisible ReCaptcha v2
  Version: 1.2.1
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: invisible_recaptcha
  Plugin update URI: invisible_recaptcha
  Support URI: https://forums.osclasspoint.com/invisible-recaptcha-plugin/
  Product Key: aP0ReAUMbQqpEZUi6H1R
*/


require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';


// INSTALL FUNCTION - DEFINE VARIABLES
function inr_call_after_install() {
  osc_set_preference('site_key', '', 'plugin-invisible_recaptcha', 'STRING');
  osc_set_preference('secret_key', '', 'plugin-invisible_recaptcha', 'STRING');
  osc_set_preference('logged_hide', 1, 'plugin-invisible_recaptcha', 'INTEGER');
  osc_set_preference('register_enabled', 0, 'plugin-invisible_recaptcha', 'INTEGER');
  osc_set_preference('login_enabled', 0, 'plugin-invisible_recaptcha', 'INTEGER');
  osc_set_preference('admin_login_enabled', 0, 'plugin-invisible_recaptcha', 'INTEGER');
  osc_set_preference('comment_enabled', 0, 'plugin-invisible_recaptcha', 'INTEGER');
  osc_set_preference('friend_enabled', 0, 'plugin-invisible_recaptcha', 'INTEGER');
  osc_set_preference('item_contact_enabled', 0, 'plugin-invisible_recaptcha', 'INTEGER');
  osc_set_preference('publish_enabled', 0, 'plugin-invisible_recaptcha', 'INTEGER');
  osc_set_preference('badge_position', 'inline', 'plugin-invisible_recaptcha', 'STRING');
  osc_set_preference('report', 0, 'plugin-invisible_recaptcha', 'INTEGER');

}


function inr_call_after_uninstall() {
  osc_delete_preference('site_key', 'plugin-invisible_recaptcha');
  osc_delete_preference('secret_key', 'plugin-invisible_recaptcha');
  osc_delete_preference('logged_hide', 'plugin-invisible_recaptcha');
  osc_delete_preference('register_enabled', 'plugin-invisible_recaptcha');
  osc_delete_preference('login_enabled', 'plugin-invisible_recaptcha');
  osc_delete_preference('admin_login_enabled', 'plugin-invisible_recaptcha');
  osc_delete_preference('comment_enabled', 'plugin-invisible_recaptcha');
  osc_delete_preference('friend_enabled', 'plugin-invisible_recaptcha');
  osc_delete_preference('item_contact_enabled', 'plugin-invisible_recaptcha');
  osc_delete_preference('publish_enabled', 'plugin-invisible_recaptcha');
  osc_delete_preference('badge_position', 'plugin-invisible_recaptcha');
  osc_delete_preference('report', 'plugin-invisible_recaptcha');
}


// HOOK CAPTCHA FIELDS INTO FORMS
if(inr_param('register_enabled') == 1) {
  osc_add_hook('user_register_form', 'inr_generate_fields');
  osc_add_hook('before_user_register', 'inr_verify_register'); 
}

if(inr_param('login_enabled') == 1) {
  osc_add_hook('user_login_form', 'inr_generate_fields');
  osc_add_hook('before_login', 'inr_verify_login'); 
}

if(inr_param('admin_login_enabled') == 1 && 1==2) {  // temporary disabled
  osc_add_hook('login_admin_form', 'inr_generate_fields', 9);
  osc_add_hook('login_admin_form', 'inr_footer_scripts', 10);

  osc_add_hook('before_login_admin', 'inr_verify_admin_login'); 
}

if(inr_param('comment_enabled') == 1) {
  osc_add_hook('add_comment_form', 'inr_generate_fields');
  osc_add_hook('before_add_comment', 'inr_verify_comment'); 
}

if(inr_param('friend_enabled') == 1) {
  osc_add_hook('item_send_friend_form', 'inr_generate_fields');
  osc_add_hook('pre_item_send_friend_post', 'inr_verify_friend'); 
}

if(inr_param('item_contact_enabled') == 1) {
  osc_add_hook('contact_form', 'inr_generate_fields');
  osc_add_hook('init', 'inr_verify_item_contact'); 
}

if(inr_param('publish_enabled') == 1) {
  //osc_add_hook('item_form', 'inr_generate_fields');
  osc_add_hook('pre_item_add', 'inr_verify_publish'); 
}



// ADMIN MENU
function inr_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/invisible_recaptcha/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/invisible_recaptcha/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/invisible_recaptcha/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="//fonts.googleapis.com/css?family=Open+Sans:300,600&amp;subset=latin,latin-ext" rel="stylesheet" type="text/css" />';
  echo '<link href="//maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/invisible_recaptcha/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/invisible_recaptcha/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/invisible_recaptcha/js/bootstrap-switch.js"></script>';



  if( $title == '') { $title = __('Configure', 'invisible_recaptcha'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Invisible Recaptcha Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=invisible_recaptcha/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'invisible_recaptcha') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function inr_footer() {
  $pluginInfo = osc_plugin_get_info('invisible_recaptcha/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="MB Themes" /> osclasspoint.com</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'invisible_recaptcha') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'invisible_recaptcha') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'invisible_recaptcha') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function inr_admin_menu() {
echo '<h3><a href="#">Invisible Recaptcha Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'invisible_recaptcha') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','inr_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function inr_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'inr_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'inr_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'inr_call_after_uninstall');

?>