<?php
  // Create menu
  $title = __('Category limits', 'item_limit');
  itl_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value


  // UPDATE CATEGORY PRICES
  if(Params::getParam('plugin_action') == 'category') {
    $params = Params::getParamsAsArray();

    foreach(array_keys($params) as $p) {
      $detail = explode('_', $p);
     
      if($detail[0] == 'limit') {
        // detail[1] - category ID
        // detail[2] - type of limit - NONLOGGED, PERSONAL, BUSINESS
        // $params[$p] - value of input
        
        ModelITL::newInstance()->updateCategoryLimit($detail[1], itl_map_category_limit_options($detail[2]), $params[$p]);
      }
    }

    message_ok( __('Limits for categories were successfully saved', 'item_limit') );
  }
 
  $categories = itl_category_list();
?>


<div class="mb-body">

  <div class="mb-row mb-notes">
    <div class="mb-line"><?php echo sprintf(__('You can setup limit for each user individually at %s', 'item_limit'), '<a style="text-decoration:underline;" href="' . osc_admin_base_url(true) . '?page=users">' . __('User profile page', 'item_limit') . '</a>'); ?></div>
  </div>
  
  <!-- CATEGORY SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Category limits', 'item_limit'); ?></div>

    <div class="mb-inside mb-minify">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <?php if(!itl_is_demo()) { ?>
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>category.php" />
        <input type="hidden" name="plugin_action" value="category" />
        <?php } ?>



        <a href="#" class="mb-button-green mb-category-difference"><?php _e('Show only limits different to default', 'item_limit'); ?></a>
        <a href="#" class="mb-button-white mb-category-all"><?php _e('Show all limits', 'item_limit'); ?></a>
        <a href="#" class="mb-button-white mb-category-clear"><?php _e('Clear limits', 'item_limit'); ?></a>

        <?php
          $cols = 3;
          $options = array('NONLOGGED', 'PERSONAL', 'BUSINESS');
          $limits = ModelITL::newInstance()->getAllCategoryLimits();
        ?>

        <div class="mb-table mb-table-category">
          <div class="mb-table-head">
            <div class="mb-col-1"><?php _e('ID', 'item_limit');?></div>
            <div class="mb-col-5 mb-align-left"><?php _e('Category', 'item_limit'); ?></div>

            <?php foreach($options as $opt) { ?>
              <div class="mb-col-<?php echo $cols; ?> mb-align-center">
                <?php 
                  if($opt == 'NONLOGGED') {
                    echo __('Non-logged users', 'item_limit');
                  } else if($opt == 'PERSONAL') {
                    echo __('Personal users', 'item_limit');
                  } else if($opt == 'BUSINESS') {
                    echo __('Business users', 'item_limit');
                  }
                ?>
              </div>
            <?php } ?>
          </div>

          <?php if(count($categories) <= 0) { ?>
            <div class="mb-table-row mb-row-empty">
              <i class="fa fa-warning"></i><span><?php _e('No categories has been added yet', 'item_limit'); ?></span>
            </div>
          <?php } else { ?>
            <?php foreach($categories as $c) { ?>
              <?php
                if(isset($limits[$c['pk_i_id']])) {
                  $limit_row = $limits[$c['pk_i_id']];
                } else {
                  $limit_row = array(
                    'fk_i_category_id' => $c['pk_i_id'],
                    'i_limit_nonlogged' => null,
                    'i_limit_personal' => null,
                    'i_limit_business' => null
                  );
                }
              ?>
              
              <div class="mb-table-row" data-level="<?php echo $c['level']; ?>" data-category-id="<?php echo $c['pk_i_id']; ?>" data-parent-id="<?php echo $c['fk_i_parent_id']; ?>">
                <div class="mb-col-1"><?php echo $c['pk_i_id']; ?></div>
                <div class="mb-col-5 mb-align-left mb-category-name">
                  <?php if( $c['level'] == 1 ) { ?>
                    <strong title="<?php _e('Main category', 'item_limit');?>"><?php echo $c['s_name']; ?></strong>
                  <?php } else { ?>
                    <?php echo itl_category_tabs($c['level']); ?><?php echo $c['s_name']; ?>
                  <?php } ?>
                </div>

                <?php foreach($options as $opt) { ?>
                  <?php 
                    $limit = $limit_row[itl_map_category_limit_options($opt)];
                    
                    $class2 = '';
                    $title2 = '';

                    if($limit == 0 || $limit == '') {
                      $title2 = osc_esc_html(__('Default limit is used', 'item_limit')) . '. <br/>';
                    }
                    
                    $class = ''; 
                  ?>

                  <div class="mb-col-<?php echo $cols; ?> mb-category-price mb-has-tooltip-light <?php echo $class2; ?>" data-opt="<?php echo $opt; ?>" data-limit="<?php echo $limit; ?>" title="<?php echo $title2 . osc_esc_html(__('Click to unlock field', 'item_limit')); ?>">
                    <input class="<?php echo $class; ?>" type="text" disabled="disabled" id="category-fee" name="limit_<?php echo $c['pk_i_id']; ?>_<?php echo $opt; ?>" value="<?php echo $limit; ?>" /><div class="mb-input-desc"><?php _e('items', 'item_limit'); ?></div>
                  </div>
                <?php } ?>
              </div>
            <?php } ?>
          <?php } ?>
        </div>


        <div class="mb-foot">
          <?php if(itl_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'item_limit')); ?>"><?php _e('Save', 'item_limit');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'item_limit');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>




</div>


<?php echo itl_footer(); ?>