<?php
  // Create menu
  $title = __('Configure', 'item_limit');
  itl_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  $limit_nonlogged = mb_param_update('limit_nonlogged', 'plugin_action', 'value', 'plugin-item_limit');
  $limit_personal = mb_param_update('limit_personal', 'plugin_action', 'value', 'plugin-item_limit');
  $limit_business = mb_param_update('limit_business', 'plugin_action', 'value', 'plugin-item_limit');
  $disable_membership = mb_param_update('disable_membership', 'plugin_action', 'check', 'plugin-item_limit');
  $count_inactive = mb_param_update('count_inactive', 'plugin_action', 'check', 'plugin-item_limit');
  $count_spam = mb_param_update('count_spam', 'plugin_action', 'check', 'plugin-item_limit');
  $count_disabled = mb_param_update('count_disabled', 'plugin_action', 'check', 'plugin-item_limit');
  $count_expired = mb_param_update('count_expired', 'plugin_action', 'check', 'plugin-item_limit');


  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'item_limit') );
  }
?>


<div class="mb-body">

  <div class="mb-row mb-notes">
    <div class="mb-line"><?php echo sprintf(__('You can setup limit for each user individually at %s', 'item_limit'), '<a style="text-decoration:underline;" href="' . osc_admin_base_url(true) . '?page=users">' . __('User profile page', 'item_limit') . '</a>'); ?></div>
  </div>
  
  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Configure', 'item_limit'); ?></div>

    <div class="mb-inside mb-minify">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <?php if(!itl_is_demo()) { ?>
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <?php } ?>

        <div class="mb-row">
          <label for="limit_nonlogged" class=""><span><?php _e('Item limit for Non-logged users', 'item_limit'); ?></span></label> 
          <input name="limit_nonlogged" size="20" type="text" value="<?php echo $limit_nonlogged; ?>" />

          <div class="mb-explain"><?php _e('Enter -1, 0 or keep blank to disable', 'item_limit'); ?></div>
        </div>

        <div class="mb-row">
          <label for="limit_personal" class=""><span><?php _e('Item limit for Personal users', 'item_limit'); ?></span></label> 
          <input name="limit_personal" size="20" type="text" value="<?php echo $limit_personal; ?>" />

          <div class="mb-explain"><?php _e('Enter -1, 0 or keep blank to disable', 'item_limit'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="limit_business" class=""><span><?php _e('Item limit for Business users', 'item_limit'); ?></span></label> 
          <input name="limit_business" size="20" type="text" value="<?php echo $limit_business; ?>" />

          <div class="mb-explain"><?php _e('Enter -1, 0 or keep blank to disable', 'item_limit'); ?></div>
        </div>

        <div class="mb-row">
          <label for="disable_membership"><span><?php _e('Disable for Members of Groups', 'item_limit'); ?></span></label> 
          <input name="disable_membership" id="disable_membership" type="checkbox" class="element-slide" <?php echo ($disable_membership == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Enable if you want to disable plugin limits for members of one of Osclass Pay membership groups.', 'item_limit'); ?></div>
            <div class="mb-line"><?php _e('Reason to disable limits in this plugin is, that Osclass Pay Membership feature has also ability to limit number of items those can member of group publish.', 'item_limit'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="count_inactive"><span><?php _e('User Count Include Inactive', 'item_limit'); ?></span></label> 
          <input name="count_inactive" id="count_inactive" type="checkbox" class="element-slide" <?php echo ($count_inactive == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, inactive (not activated or pending admin validation) listings are also counted towards user listing count.', 'item_limit'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="count_spam"><span><?php _e('User Count Include Spam', 'item_limit'); ?></span></label> 
          <input name="count_spam" id="count_spam" type="checkbox" class="element-slide" <?php echo ($count_spam == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, spam listings are also counted towards user listing count.', 'item_limit'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="count_disabled"><span><?php _e('User Count Include Disabled', 'item_limit'); ?></span></label> 
          <input name="count_disabled" id="count_disabled" type="checkbox" class="element-slide" <?php echo ($count_disabled == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, disabled listings are also counted towards user listing count.', 'item_limit'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="count_expired"><span><?php _e('User Count Include Expired', 'item_limit'); ?></span></label> 
          <input name="count_expired" id="count_expired" type="checkbox" class="element-slide" <?php echo ($count_expired == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, expired listings are also counted towards user listing count.', 'item_limit'); ?></div>
          </div>
        </div>


        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(itl_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'item_limit')); ?>"><?php _e('Save', 'item_limit');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'item_limit');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>




</div>


<?php echo itl_footer(); ?>