<?php
  // Create menu
  $title = __('Configure', 'item_online_users');
  iou_menu($title);


  if(Params::getParam('what') == 'purgeViews' && !iou_is_demo()) {
    iou_purge_views();
    
    osc_add_flash_ok_message(__('Listing views has been cleaned', 'item_online_users'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=item_online_users/admin/configure.php');
    exit;
  }
  


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value
  $limit = mb_param_update('limit', 'plugin_action', 'value', 'plugin-item_online_users');
  $category = mb_param_update('category', 'plugin_action', 'value', 'plugin-item_online_users');
  $type = mb_param_update('type', 'plugin_action', 'value', 'plugin-item_online_users');
  $color = mb_param_update('color', 'plugin_action', 'value', 'plugin-item_online_users');
  $position = mb_param_update('position', 'plugin_action', 'value', 'plugin-item_online_users');
  $fade = mb_param_update('fade', 'plugin_action', 'value', 'plugin-item_online_users');
  $hook = mb_param_update('hook', 'plugin_action', 'check', 'plugin-item_online_users');
  $only_logged = mb_param_update('only_logged', 'plugin_action', 'check', 'plugin-item_online_users');
  $multiplier = mb_param_update('multiplier', 'plugin_action', 'value', 'plugin-item_online_users');
  $minimum = mb_param_update('minimum', 'plugin_action', 'value', 'plugin-item_online_users');
  $base = mb_param_update('base', 'plugin_action', 'value', 'plugin-item_online_users');
  $demo = mb_param_update('demo', 'plugin_action', 'check', 'plugin-item_online_users');

  $category_all = Category::newInstance()->listAll();
  $category_array = explode(',', $category);

  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'item_online_users') );
  }
?>


<div class="mb-body">
  <!-- CONFIGURE SECTION -->
  
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-wrench"></i> <?php _e('Configure', 'item_online_users'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />


        <div class="mb-row mb-row-select-multiple">
          <label for="category_multiple"><span><?php _e('Available in Categories', 'item_online_users'); ?></span></label> 

          <input type="hidden" name="category" id="category" value="<?php echo $category; ?>"/>
          <select id="category_multiple" name="category_multiple" multiple>
            <?php echo iou_cat_list($category_array, $category_all); ?>
          </select>

          <div class="mb-explain"><?php _e('Select categories where online users count message will be shown.', 'item_online_users'); ?></div>
        </div>
        
        
        <div class="mb-row">
          <label for="limit"><span><?php _e('Online Threshold', 'item_online_users'); ?></span></label> 
          <input type="number" size="10" name="limit" id="limit" value="<?php echo $limit; ?>" min="1" max="360"/>
          <div class="mb-input-desc"><?php _e('minutes', 'item_online_users'); ?></div>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('For how many minutes is user considered as online on listing. If you enter i.e. 30 minutes and user leave viewed listing 08:30, this user is considered as online on listing until 09:00. Enter value in range 1-360.', 'item_online_users'); ?></div>
          </div>
        </div>


        <div class="mb-row">
          <label for="type"><span><?php _e('Type of Box', 'item_online_users'); ?></span></label> 
          <select name="type">
            <option value="FLOATING" <?php if($type == 'FLOATING' || $type == '') { ?>selected="selected"<?php } ?>><?php _e('Floating', 'item_online_users'); ?></option>
            <option value="INLINE" <?php if($type == 'INLINE') { ?>selected="selected"<?php } ?>><?php _e('Inline', 'item_online_users'); ?></option>
          </select>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Select type of message box.', 'item_online_users'); ?></div>
          </div>
        </div>


        <div class="mb-row">
          <label for="color"><span><?php _e('Color Scheme of Box', 'item_online_users'); ?></span></label> 
          <select name="color">
            <option value="LIGHT" <?php if($color == 'LIGHT' || $color == '') { ?>selected="selected"<?php } ?>><?php _e('Light', 'item_online_users'); ?></option>
            <option value="DARK" <?php if($color == 'DARK') { ?>selected="selected"<?php } ?>><?php _e('Dark', 'item_online_users'); ?></option>
          </select>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Select color scheme of message box.', 'item_online_users'); ?></div>
          </div>
        </div>


        <div class="mb-row">
          <label for="position"><span><?php _e('Message Box Position', 'item_online_users'); ?></span></label> 
          <select name="position">
            <option value="TOP-RIGHT" <?php if($position == 'TOP-RIGHT' || $position == '') { ?>selected="selected"<?php } ?>><?php _e('Top Right', 'item_online_users'); ?></option>
            <option value="TOP-LEFT" <?php if($position == 'TOP-LEFT') { ?>selected="selected"<?php } ?>><?php _e('Top Left', 'item_online_users'); ?></option>
            <option value="BOTTOM-RIGHT" <?php if($position == 'BOTTOM-RIGHT') { ?>selected="selected"<?php } ?>><?php _e('Bottom Right', 'item_online_users'); ?></option>
            <option value="BOTTOM-LEFT" <?php if($position == 'BOTTOM-LEFT') { ?>selected="selected"<?php } ?>><?php _e('Bottom Left', 'item_online_users'); ?></option>
          </select>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Select position of message box (only applicable for Floating type).', 'item_online_users'); ?></div>
          </div>
        </div>


        <div class="mb-row">
          <label for="fade"><span><?php _e('Fade Out', 'item_online_users'); ?></span></label> 
          <input type="number" size="10" name="fade" id="fade" value="<?php echo $fade; ?>" min="0" max="60"/>
          <div class="mb-input-desc"><?php _e('seconds', 'item_online_users'); ?></div>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Select after how many seconds message box will be hidden (only applicable for Floating type). Enter value in range 0-60. Enter 0 to disable.', 'item_online_users'); ?></div>
          </div>
        </div>


        <div class="mb-row">
          <label for="hook"><span><?php _e('Hook Message Box', 'item_online_users'); ?></span></label> 
          <input name="hook" id="hook" type="checkbox" class="element-slide" <?php echo ($hook == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, automatically hook/add message box to listing page. Floating type - hook to header, Inline type - hook to item_detail.', 'item_online_users'); ?></div>
          </div>
        </div>


        <div class="mb-row">
          <label for="only_logged"><span><?php _e('Only Logged-in Users', 'item_online_users'); ?></span></label> 
          <input name="only_logged" id="only_logged" type="checkbox" class="element-slide" <?php echo ($only_logged == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, views/statistics are collected only for logged-in users.', 'item_online_users'); ?></div>
          </div>
        </div>


        <div class="mb-row">
          <label for="multiplier"><span><?php _e('Multiplier of Users', 'item_online_users'); ?></span></label> 
          <input type="number" size="10" name="multiplier" id="multiplier" value="<?php echo $multiplier; ?>" min="1" step="0.1"/>
          <div class="mb-input-desc"><?php _e('times', 'item_online_users'); ?></div>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Multiply number of views in order to present higher statistics. Enter value 1 or higher (1 is default).', 'item_online_users'); ?></div>
          </div>
        </div>
        
        
        <div class="mb-row">
          <label for="base"><span><?php _e('Base Value', 'item_online_users'); ?></span></label> 
          <input type="number" size="10" name="base" id="base" value="<?php echo $base; ?>" min="0"/>
          <div class="mb-input-desc"><?php _e('views', 'item_online_users'); ?></div>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Base number of views to be added into real views in order to present higher statistics. Enter value 0 or higher (0 is default).', 'item_online_users'); ?></div>
          </div>
        </div>
        
        
        <div class="mb-row">
          <label for="minimum"><span><?php _e('Minimum Number of Users', 'item_online_users'); ?></span></label> 
          <input type="number" size="10" name="minimum" id="minimum" value="<?php echo $minimum; ?>" min="0"/>
          <div class="mb-input-desc"><?php _e('views', 'item_online_users'); ?></div>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Minimum number of views in order to show message box. Based on raw value from database. Enter value 0 or higher (0 is default).', 'item_online_users'); ?></div>
          </div>
        </div>


        <div class="mb-row">
          <label for="demo"><span><?php _e('Enable Demo Mode', 'item_online_users'); ?></span></label> 
          <input name="demo" id="demo" type="checkbox" class="element-slide" <?php echo ($demo == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, number of views will be randomly generated.', 'item_online_users'); ?></div>
          </div>
        </div>
        

        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(iou_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'item_online_users')); ?>"><?php _e('Save', 'item_online_users');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'item_online_users');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>



  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-dashboard"></i> <?php _e('Statistics', 'item_online_users'); ?></div>
    <div class="mb-inside">
      <strong class="mb-row"><?php echo sprintf(__('%d views stored by plugin. Clean views if this number is too high (over 100 000) and make sure your daily cron works OK.', 'item_online_users'), iou_count_item_online_users()); ?></strong>

      <div class="mb-row" style="margin-top:12px;">
        <?php if(iou_is_demo()) { ?>
          <a href="#" class="mb-button-blue mb-add mb-disabled" style="cursor:not-allowed;opacity:0.5;" onclick="return false;" disabled><i class="fa fa-trash" title="<?php echo osc_esc_html(__('This action cannot be done as this is demo site', 'item_online_users')); ?>"></i><?php _e('Clean views', 'item_online_users'); ?></a>
        <?php } else { ?>
          <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=item_online_users/admin/configure.php&what=purgeViews" class="mb-button-blue mb-add" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove all views? Action cannot be undone', 'item_online_users')); ?>');"><i class="fa fa-trash"></i><?php _e('Clean views', 'item_online_users'); ?></a>
        <?php } ?>
      </div>

    </div>
  </div>


  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'item_online_users'); ?></div>

    <div class="mb-inside">
      <div class="mb-row"><?php _e('No theme modification are required to use all functions of plugin, but in order to provide more integrated view of plugin, followimg functions are available.', 'item_online_users'); ?></div>
      <div class="mb-row">
        <strong><?php _e('Listing views message:', 'item_online_users'); ?></strong>
        <span class="mb-code">&lt;?php echo iou_show_counts(); ?&gt;</span>

        <span class="mb-line">&nbsp;</span>

        <strong><?php _e('Listing views count:', 'item_online_users'); ?></strong>
        <span class="mb-code">&lt;?php echo iou_item_count(); ?&gt;</span>
      </div>
    </div>
  </div>
</div>


<?php echo iou_footer(); ?>