<?php
/*
  Plugin Name: Visitors Checking Item Counter Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/design-and-appearance/visitors-checking-item-counter-plugin-i179
  Description: Calculate how many visitors are currently checking and are interested in particular listing.
  Version: 1.0.2
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: item_online_users
  Plugin update URI: item-online-users
  Support URI: https://forums.osclasspoint.com/
  Product Key: vliNRyxVet2OKwvL6b9L
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelIOU.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';


osc_enqueue_style('iou-user-style', osc_base_url() . 'oc-content/plugins/item_online_users/css/user.css?v=' . date('YmdHis'));
osc_register_script('iou-user', osc_base_url() . 'oc-content/plugins/item_online_users/js/user.js?v=' . date('YmdHis'), array('jquery'));
osc_enqueue_script('iou-user');


// REMOVE OLD VIEWS ON DAILY BASE
function iou_purge_views() {
  $limit = (iou_param('limit') > 0 ? iou_param('limit') : 30);
  $limit_date = date('Y-m-d H:i:s', strtotime('-' . $limit . ' minutes'));

  ModelIOU::newInstance()->purgeViews($limit_date);
}

osc_add_hook('cron_daily', 'iou_purge_views');


// INSTALL FUNCTION - DEFINE VARIABLES
function iou_call_after_install() {
  osc_set_preference('limit', 30, 'plugin-item_online_users', 'INTEGER');
  osc_set_preference('category', '', 'plugin-item_online_users', 'STRING');
  osc_set_preference('type', 'FLOATING', 'plugin-item_online_users', 'STRING');
  osc_set_preference('color', 'LIGHT', 'plugin-item_online_users', 'STRING');
  osc_set_preference('position', 'TOP-RIGHT', 'plugin-item_online_users', 'STRING');
  osc_set_preference('fade', 0, 'plugin-item_online_users', 'INTEGER');
  osc_set_preference('hook', 1, 'plugin-item_online_users', 'INTEGER');
  osc_set_preference('only_logged', 0, 'plugin-item_online_users', 'INTEGER');
  osc_set_preference('multiplier', 1, 'plugin-item_online_users', 'INTEGER');
  osc_set_preference('minimum', 1, 'plugin-item_online_users', 'INTEGER');
  osc_set_preference('base', 0, 'plugin-item_online_users', 'INTEGER');
  osc_set_preference('demo', 0, 'plugin-item_online_users', 'INTEGER');

  ModelIOU::newInstance()->install();
}


function iou_call_after_uninstall() {
  ModelIOU::newInstance()->uninstall();
}


// ADMIN MENU
function iou_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/item_online_users/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/item_online_users/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/item_online_users/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/item_online_users/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/item_online_users/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/item_online_users/js/bootstrap-switch.js"></script>';

  if( $title == '') { $title = __('Configure', 'item_online_users'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Visitors Checking Item Counter Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=item_online_users/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'item_online_users') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function iou_footer() {
  $pluginInfo = osc_plugin_get_info('item_online_users/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint Market" /> OsclassPoint Market</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'item_online_users') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'item_online_users') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'item_online_users') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function iou_admin_menu() {
echo '<h3><a href="#">Visitors Checking Item Counter Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'item_online_users') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','iou_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function iou_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'iou_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'iou_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'iou_call_after_uninstall');

?>