<?php
class ModelIOU extends DAO {
private static $instance;

public static function newInstance() {
  if( !self::$instance instanceof self ) {
    self::$instance = new self;
  }
  return self::$instance;
}

function __construct() {
  parent::__construct();
}

public function getTable_item() {
  return DB_TABLE_PREFIX.'t_iou_item';
}


public function import($file) {
  $path = osc_plugin_resource($file);
  $sql = file_get_contents($path);

  if(!$this->dao->importSQL($sql) ){
    throw new Exception("Error importSQL::ModelIOU<br>" . $file . "<br>" . $this->dao->getErrorLevel() . " - " . $this->dao->getErrorDesc() );
  }
}


public function install($version = '') {
  if($version == '') {
    $this->import('item_online_users/model/struct.sql');
    osc_set_preference('version', 100, 'plugin-item_online_users', 'INTEGER');
  }

}


public function uninstall() {
  // DELETE ALL TABLES
  $this->dao->query(sprintf('DROP TABLE %s', $this->getTable_item()));


  // DELETE ALL PREFERENCES
  $db_prefix = DB_TABLE_PREFIX;
  $query = "DELETE FROM {$db_prefix}t_preference WHERE s_section = 'plugin-item_online_users'";
  $this->dao->query($query);
}



// GET ITEM IPs/VIEWS
public function getViews($item_id, $limit_date, $not_ip = '') {
  $this->dao->select('count(*) as i_count');
  $this->dao->from($this->getTable_item());
  $this->dao->where('fk_i_item_id', $item_id);
  $this->dao->where('dt_date > "' . $limit_date . '"');
  
  if($not_ip != '') {
    $this->dao->where('s_ip != "' . $not_ip . '"');
  }
  
  $result = $this->dao->get();
  
  if($result) {
    $data = $result->row();
    return isset($data['i_count']) ? $data['i_count'] : 0;
  }
  
  return 0;
}



// COUNT ALL
public function countAll() {
  $this->dao->select('count(*) as i_count');
  $this->dao->from($this->getTable_item());
  $result = $this->dao->get();
  
  if($result) {
    $data = $result->row();
    return isset($data['i_count']) ? $data['i_count'] : 0;
  }
  
  return 0;
}


// UPDATE VIEWS
public function updateViews($data) {
  $this->dao->replace($this->getTable_item(), $data);
}


// REMOVE OLD VIEWS
public function purgeViews($limit_date) {
  $query = sprintf('DELETE FROM %s WHERE dt_date < "%s"', $this->getTable_item(), $limit_date);
  $this->dao->query($query);
}

}
?>