<?php
  // Create menu
  $title = __('Configure', 'item_validation');
  iv_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update('param_name', 'form_name', 'input_type', 'plugin_var_name');
  // input_type: check or value

  $enable = mb_param_update('enable', 'plugin_action', 'check', 'plugin-item_validation');
  $validate_edit = mb_param_update('validate_edit', 'plugin_action', 'check', 'plugin-item_validation');
  $edit_reapproval = mb_param_update('edit_reapproval', 'plugin_action', 'check', 'plugin-item_validation');
  $min_auto_validated = mb_param_update('min_auto_validated', 'plugin_action', 'value', 'plugin-item_validation');
  $notify_reject = mb_param_update('notify_reject', 'plugin_action', 'check', 'plugin-item_validation');
  $notify_approve = mb_param_update('notify_approve', 'plugin_action', 'check', 'plugin-item_validation');


  if(Params::getParam('plugin_action') == 'done') {
    osc_add_flash_ok_message(__('Settings were successfully saved.', 'item_validation'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=item_validation/admin/configure.php');
    exit;
  }
?>

<div class="mb-body">
  <?php if(osc_moderate_items() != -1) { ?>
    <div class="mb-error-box" style="margin:0 0 25px 0;">
      <div class="mb-line"><?php _e('For correct functionality of <strong>Item Validation Plugin</strong> you must disable option <strong>"Users have to validate their listings"</strong>', 'item_validation'); ?></div>
      <div class="mb-line"><?php _e('Go to', 'item_validation'); ?> <a style="font-weight:bold;" href="<?php echo osc_admin_base_url(true); ?>?page=items&action=settings" target="_blank"><?php _e('Listings Settings', 'item_validation'); ?></a> <?php _e('and uncheck/disable this function.', 'item_validation'); ?></div>
    </div>
  <?php } ?>

  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-cog"></i> <?php _e('Configure', 'item_validation'); ?></div>

    <div class="mb-inside">
      <form name="promo_form" id="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <?php if(!iv_is_demo()) { ?>
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <?php } ?>
                     
        <div class="mb-row">
          <label for="enable" class="h1"><span><?php _e('Enable validation of listings', 'item_validation'); ?></span></label> 
          <input name="enable" id="enable" class="element-slide" type="checkbox" <?php echo ($enable== 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('Admin will need to validate every posted listing.', 'item_validation'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="validate_edit" class="h2"><span><?php _e('Listing Edit Needs to be Validated', 'item_validation'); ?></span></label> 
          <input name="validate_edit" id="validate_edit" class="element-slide" type="checkbox" <?php echo ($validate_edit == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('Admin will need to validate every edited listing.', 'item_validation'); ?></div>
        </div>

        <div class="mb-row">
          <label for="edit_reapproval" class="h3"><span><?php _e('Edited Listing Re-Validation', 'item_validation'); ?></span></label> 
          <input name="edit_reapproval" id="edit_reapproval" class="element-slide" type="checkbox" <?php echo ($edit_reapproval == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When rejected listing is edited, it will be again send to admin for re-validation.', 'item_validation'); ?></div>
        </div>


        <div class="mb-row">
          <label for="min_auto_validated" class="h4"><span><?php _e('Minimum Items for Auto-Validation', 'item_validation'); ?></span></label> 
          <input size="6" name="min_auto_validated" id="min_auto_validated" class="mb-short" type="text" value="<?php echo $min_auto_validated; ?>" />
          <div class="mb-input-desc"><?php _e('items', 'item_validation'); ?></div>

          <div class="mb-explain"><?php _e('Set 0 or leave blank to disable.', 'item_validation'); ?></div>
        </div>   

        <div class="mb-row">
          <label for="notify_approve" class="h7"><span><?php _e('Notify User about Approval', 'item_validation'); ?></span></label> 
          <input name="notify_approve" id="notify_approve" class="element-slide" type="checkbox" <?php echo ($notify_approve == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When set to YES, user will be notified by email when listing has been approved by admin.', 'item_validation'); ?></div>
        </div>

        <div class="mb-row">
          <label for="notify_reject" class="h6"><span><?php _e('Notify User about Rejection', 'item_validation'); ?></span></label> 
          <input name="notify_reject" id="notify_reject" class="element-slide" type="checkbox" <?php echo ($notify_reject == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When set to YES, user will be notified by email when listing has been rejected by admin.', 'item_validation'); ?></div>
        </div>

      </div>

      <div class="mb-foot">
        <?php if(!iv_is_demo()) { ?>
          <button type="submit" class="mb-button"><?php _e('Save', 'item_validation');?></button>
        <?php } else { ?>
          <a href="#" onclick="return false" class="mb-button"><?php _e('Save (demo - disabled)', 'item_validation');?></button>
        <?php } ?>
      </div>
    </form>
  </div>


  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'item_validation'); ?></div>
    <div class="mb-inside">
      <div class="mb-line"><?php _e('Only what is required to do is to delete', 'item_validation'); ?> <strong><?php _e('Activation link', 'item_validation'); ?></strong> <?php _e('in user profile (user items).', 'item_validation'); ?>.</div>
      <div class="mb-line"><?php _e('Go to your theme folder (oc-content/themes/{YOUR_THEME_NAME}/) and open file', 'item_validation'); ?> <strong>loop-single.php</strong> <?php _e('or', 'item_validation'); ?> <strong>user-items.php</strong> <?php _e('if loop-single.php does not exists in your theme', 'item_validation'); ?>.</div>
      <div class="mb-line"><?php _e('Find line that contains code', 'item_validation'); ?>: <strong>&lt;?php echo osc_item_activate_url(); ?&gt;</strong> <?php _e('and remove whole line', 'item_validation'); ?>.</div>
      <div class="mb-line"><?php _e('Save changes and you are done.', 'item_validation'); ?></div>
    </div>
  </div>



  <!-- HELP TOPICS -->
  <div class="mb-box" id="mb-help">
    <div class="mb-head"><i class="fa fa-question-circle"></i> <?php _e('Help', 'item_validation'); ?></div>

    <div class="mb-inside">
      <div class="mb-row mb-help"><span class="sup">(1)</span> <div class="h1"><?php _e('When enabled, all listings will needs to be validated by admin. (existing listings does not need to be validated).', 'item_validation'); ?></div></div>
      <div class="mb-row mb-help"><span class="sup">(2)</span> <div class="h2"><?php _e('When set to YES, edited listings needs to be validated by admin as well. This means when user edit listing, it is required by admin to validate this listing before it goes live.', 'item_validation'); ?></div></div>
      <div class="mb-row mb-help"><span class="sup">(3)</span> <div class="h3"><?php _e('When set to YES and user edit listing that has been rejected by admin, after edit it will be sent to admin for re-validation again. If set to NO, this listing will be still marked as rejected.', 'item_validation'); ?></div></div>
      <div class="mb-row mb-help"><span class="sup">(4)</span> <div class="h4"><?php _e('When user reach this number, listings of this user does not need to be validated by admin.', 'item_validation'); ?></div></div>
      <div class="mb-row mb-help"><span class="sup">(5)</span> <div class="h5"><?php _e('Filter listings by it\'s current status. Latest 100 listings is shown.', 'item_validation'); ?></div></div>
      <div class="mb-row mb-help"><span class="sup">(6)</span> <div class="h6"><?php _e('When enabled, user will recieve email notification that listing of this user has been rejected by admin and it is required to modify it to make it visible.', 'item_validation'); ?></div></div>
      <div class="mb-row mb-help"><span class="sup">(7)</span> <div class="h7"><?php _e('When enabled, user will recieve email notification that listing of this user has been approved by admin.', 'item_validation'); ?></div></div>

      <div class="mb-row mb-help" style="margin-top:20px;">
         <div class="mb-row" style="display:block;"><span class="mb-u"><?php _e('Status explanation', 'item_validation'); ?></span>:</div>
         <div class="mb-row" style="display:block;"><strong><?php _e('0 - Not validated', 'item_validation'); ?></strong> - <?php _e('Listing is waiting for admin validation, not visible in front-office', 'item_validation'); ?></div>
         <div class="mb-row" style="display:block;"><strong><?php _e('1 - Validated', 'item_validation'); ?></strong> - <?php _e('Listing has been validated by admin and is visible in front-office', 'item_validation'); ?></div>
         <div class="mb-row" style="display:block;"><strong><?php _e('2 - Valid - Older listing', 'item_validation'); ?></strong> - <?php _e('Listing has been created before plugin installation, but it is visible in front-office', 'item_validation'); ?></div>
         <div class="mb-row" style="display:block;"><strong><?php _e('9 - Rejected', 'item_validation'); ?></strong> - <?php _e('Listing has been rejected by admin. Item has not been removed, but it is not visible in front-office (only user can see it in it\'s account)', 'item_validation'); ?></div>
      </div>
    </div>
  </div>
</div>

<?php echo iv_footer(); ?>