<?php
  // Create menu
  $title = __('Item Validation', 'item_validation');
  iv_menu($title);


  $notify_reject = iv_param('notify_reject');
  $notify_approve = iv_param('notify_approve');


  // VALIDATE LISTINGS
  if(Params::getParam('plugin_action') == 'validate') {

    // APPROVE SINGLE
    $params_array = Params::getParamsAsArray();

    $approved = '';
    foreach($params_array as $key => $value){
      $exp_key = explode('_', $key);
      if($exp_key[0] == 'approve-single'){
        // ID of prompted listing stored in $value
        $approved .= $exp_key[1] . ', ';
        osc_add_flash_ok_message(__('Listings with following IDs were approved:', 'item_validation') . ' ' .  substr($approved, 0, strlen($approved)-2), 'admin');

        $item = Item::newInstance()->findByPrimaryKey($exp_key[1]);
        ModelValidation::newInstance()->updateValid($exp_key[1], 1, $params_array['comment_' . $exp_key[1]]);
        ModelValidation::newInstance()->activateItem($exp_key[1]);
        iv_update_stats($item, 1);  //increase stats


        // Notify user by email when enabled
        if($notify_approve == 1) {
          iv_email_notify_approved($exp_key[1], $params_array['comment_' . $exp_key[1]]);
          osc_add_flash_ok_message(__('Users has been notified about approval by email.', 'item_validation'), 'admin');
        }
      }
    }



    // REJECT SINGLE
    $params_array = Params::getParamsAsArray();

    $rejected = '';
    foreach($params_array as $key => $value){
      $exp_key = explode('_', $key);
      if($exp_key[0] == 'reject-single'){
        // ID of prompted listing stored in $value
        $rejected .= $exp_key[1] . ', ';
        osc_add_flash_ok_message(__('Listings with following IDs were rejected:', 'item_validation') . ' ' .  substr($rejected, 0, strlen($rejected)-2), 'admin');

        $item = Item::newInstance()->findByPrimaryKey($exp_key[1]);
        ModelValidation::newInstance()->updateValid($exp_key[1], 9, $params_array['comment_' . $exp_key[1]]);
        ModelValidation::newInstance()->deactivateItem($exp_key[1]);
        iv_update_stats($item, 0);  //decrease stats


        // Notify user by email when enabled
        if($notify_reject == 1) {
          iv_email_notify_rejected($exp_key[1], $params_array['comment_' . $exp_key[1]]);
          osc_add_flash_ok_message(__('Users has been notified about rejection by email.', 'item_validation'), 'admin');
        }
      }
    }



    // APPROVE SELECTED
    if(Params::getParam('item_action') == __('Approve Selected', 'item_validation')) {
      $params_array = Params::getParamsAsArray();

      if(is_array($params_array) && !empty($params_array)) { 
        $approved = '';
        foreach($params_array as $key => $value){
          $exp_key = explode('_', $key);
          if($exp_key[0] == 'valid'){
            // ID of prompted listing stored in $value
            $approved .= $value . ', ';

            $item = Item::newInstance()->findByPrimaryKey($value);
            ModelValidation::newInstance()->updateValid($value, 1, $params_array['comment_' . $value]);
            ModelValidation::newInstance()->activateItem($value);
            iv_update_stats($item, 1);  //increase stats

            // Notify user by email when enabled
            if($notify_approve == 1) {
              iv_email_notify_approved($value, $params_array['comment_' . $value]);
            }
          }
        }

        if($notify_approve == 1) {
          osc_add_flash_ok_message(__('Users has been notified about approval by email.', 'item_validation'), 'admin');
        }
      }

      osc_add_flash_ok_message(__('Listings with following IDs were approved:', 'item_validation') . ' ' .  substr($approved, 0, strlen($approved)-2), 'admin');
    }


    // REJECT SELECTED
    if(Params::getParam('item_action') == __('Reject Selected', 'item_validation')) {
      $params_array = Params::getParamsAsArray();

      if(is_array($params_array) && !empty($params_array)) { 
        $rejected = '';
        foreach($params_array as $key => $value){
          $exp_key = explode('_', $key);
          if($exp_key[0] == 'valid'){
            // ID of prompted listing stored in $value
            $rejected .= $value . ', ';

            $item = Item::newInstance()->findByPrimaryKey($value);
            ModelValidation::newInstance()->updateValid($value, 9, $params_array['comment_' . $value]);
            ModelValidation::newInstance()->deactivateItem($value);
            iv_update_stats($item, 0);  //decrease stats

            // Notify user by email when enabled
            if($notify_reject == 1) {
              iv_email_notify_rejected($value, $params_array['comment_' . $value]);
            }
          }
        }

        if($notify_reject == 1) {
          osc_add_flash_ok_message(__('Users has been notified about rejection by email.', 'item_validation'), 'admin');
        }
      }

      osc_add_flash_ok_message(__('Listings with following IDs were rejected:', 'item_validation') . ' ' .  substr($rejected, 0, strlen($rejected)-2), 'admin');
    }


    // REMOVE SELECTED
    if(Params::getParam('item_action') == __('Remove Selected', 'item_validation')) {
      $params_array = Params::getParamsAsArray();

      if(is_array($params_array) && !empty($params_array)) { 
        $removed = '';
        foreach($params_array as $key => $value){
          $exp_key = explode('_', $key);
          if($exp_key[0] == 'valid'){
            // ID of prompted listing stored in $value
            $removed .= $value . ', ';

            Item::newInstance()->deleteByPrimaryKey($value);
          }
        }
      }

      osc_add_flash_ok_message(__('Listings with following IDs were removed:', 'item_validation') . ' ' .  substr($removed, 0, strlen($removed)-2), 'admin');
    }
    
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=item_validation/admin/validation.php');
    exit;
  }
?>

<div class="mb-body">
  <?php if(osc_moderate_items() != -1) { ?>
    <div class="mb-error-box" style="margin:0 0 25px 0;">
      <div class="mb-line"><?php _e('For correct functionality of <strong>Item Validation Plugin</strong> you must disable option <strong>"Users have to validate their listings"</strong>', 'item_validation'); ?></div>
      <div class="mb-line"><?php _e('Go to', 'item_validation'); ?> <a style="font-weight:bold;" href="<?php echo osc_admin_base_url(true); ?>?page=items&action=settings" target="_blank"><?php _e('Listings Settings', 'item_validation'); ?></a> <?php _e('and uncheck/disable this function.', 'item_validation'); ?></div>
    </div>
  <?php } ?>


  <!-- VALIDATION SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-mark"></i> <?php _e('Item Validation', 'item_validation'); ?></div>

    <div class="mb-inside">
      <form name="promo_form" id="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data">
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>validation.php" />
        <input type="hidden" name="plugin_action" value="change_status" />

        <?php $show_status = Params::getParam('show_status') > 0 ? Params::getParam('show_status') : 0; ?>

        <div class="mb-row">
          <label for="show_status" class="h5"><span><?php _e('Browse listings by status', 'item_validation'); ?></span></label> 
          <select name="show_status" id="show_status" onchange="this.form.submit();">
            <option value="99" <?php if($show_status == 99) { ?>selected="selected"<?php } ?>><?php _e('Show all', 'item_validation'); ?></option>
            <option value="0" <?php if($show_status == 0) { ?>selected="selected"<?php } ?>><?php _e('Pending validation', 'item_validation'); ?></option>
            <option value="1" <?php if($show_status == 1) { ?>selected="selected"<?php } ?>><?php _e('Approved', 'item_validation'); ?></option>
            <option value="2" <?php if($show_status == 2) { ?>selected="selected"<?php } ?>><?php _e('Valid - Older listing', 'item_validation'); ?></option>
            <option value="9" <?php if($show_status == 9) { ?>selected="selected"<?php } ?>><?php _e('Rejected', 'item_validation'); ?></option>
          </select>
        </div>
      </form>

      <?php 
        if($show_status <> 99) { 
          $items = ModelValidation::newinstance()->getValidByStatus($show_status); 
        } else {
          $items = ModelValidation::newinstance()->getValidByStatus(); 
        }
      ?>

      <form name="promo_form" id="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data">
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>validation.php" />
        <input type="hidden" name="plugin_action" value="validate" />
        <input type="hidden" name="show_status" value="<?php echo osc_esc_html(Params::getParam('show_status')); ?>" />

        <div class="mb-info-box" style="margin-top:20px;margin-bottom:25px;">
          <div class="mb-line"><?php _e('Only latest 100 listings are shown!', 'item_validation'); ?></div>
        </div>

        <div id="table-validate" class="mb-table" style="margin-bottom:30px;">
          <div class="mb-table-head">
            <div class="mb-col-1 stat"><input type="checkbox" class="mb_mark_all" name="mb_mark_all" id="mb_mark_all" value="valid_" /></div>
            <div class="mb-col-1"><?php _e('ID', 'item_validation'); ?></div>
            <div class="mb-col-5 mb-align-left titl"><?php _e('Title', 'item_validation'); ?></div>
            <div class="mb-col-4 mb-align-left"><?php _e('Current status', 'item_validation'); ?></div>
            <div class="mb-col-5 mb-align-left"><?php _e('Message', 'item_validation'); ?></div>
            <div class="mb-col-9 mb-align-left">&nbsp;</div>
          </div>

          <?php if(count($items) <= 0) { ?>
            <div class="mb-table-row mb-row-empty">
              <i class="fa fa-warning"></i><span><?php _e('No listing requires validation!', 'item_validation'); ?></span>
            </div>
          <?php } else { ?>
            <?php foreach($items as $i) { ?>
              <?php $i['fk_i_item_id'] = isset($i['fk_i_item_id']) ? $i['fk_i_item_id'] : ''; ?>
              <?php $detail = Item::newInstance()->findByPrimaryKey($i['fk_i_item_id']); ?>

              <?php 
                $status = isset($i['i_status']) ? $i['i_status'] : '';
                $revalidate = isset($i['b_revalidate']) ? $i['b_revalidate'] : 0;
                $status_name = '';
                $status_class = '';
                switch ($status) {
                  case 0: 
                    if($revalidate == 1) {
                      $status_name = __('Revalidation', 'item_validation'); 
                      $status_class = 'mb-dark-blue'; 
                    } else {
                      $status_name = __('Not validated', 'item_validation'); 
                      $status_class = 'mb-blue'; 
                    }
                    break;
                  case 1: 
                    $status_name = __('Approved', 'item_validation'); 
                    $status_class = 'mb-green'; 
                    break;
                  case 2: 
                    $status_name = __('Valid - Older listing', 'item_validation'); 
                    $status_class = 'mb-green-disabled'; 
                    break;
                  case 9: 
                    $status_name = __('Rejected', 'item_validation'); 
                    $status_class = 'mb-red'; 
                    break;
                }

                $empty = '<span class="mb-i mb-gray">' . __('No comment', 'item_validation') . '</span>';
              ?>

              <div class="mb-table-row">
                <div class="mb-col-1 stat <?php echo osc_esc_html($status_class); ?>" title="<?php echo osc_esc_html($status_name); ?>" style="margin-bottom:-1px;"><input type="checkbox" name="valid_<?php echo $i['fk_i_item_id']; ?>" id="valid_<?php echo $i['fk_i_item_id']; ?>" value="<?php echo $i['fk_i_item_id']; ?>" /></div>
                <div class="mb-col-1"><?php echo $i['fk_i_item_id']; ?></div>
                <div class="mb-col-5 mb-align-left titl"><a href="<?php echo osc_admin_base_url(true); ?>?page=items&action=item_edit&id=<?php echo $i['fk_i_item_id']; ?>" target="_blank"><?php echo isset($detail['s_title']) ? osc_highlight($detail['s_title'], 35) : ''; ?></a></div>
                <div class="mb-col-4 mb-align-left"><?php echo $status_name; ?></div>
                <div class="mb-col-5 mb-align-left"><?php echo isset($i['s_comment']) ? $i['s_comment'] : $empty; ?></div>
                <div class="mb-col-9 mb-align-left">
                  <?php if($status == 0 || $status == 1 || $status == 2 || $status == 9){ ?>
                    <input type="text" name="comment_<?php echo $i['fk_i_item_id']; ?>" class="mb-comment" style="float:left;margin: -4px 5px -5px 0; height: 27px; line-height: 13px;width:260px;" placeholder="<?php echo osc_esc_html(__('Comment on validation', 'item_validation')); ?>" />
                  <?php } ?>
                  
                  <?php if($status == 0 || $status == 9){ ?>
                    <input type="submit" name="approve-single_<?php echo $i['fk_i_item_id']; ?>" class="mb-button-blue" style="float:left;margin: -4px 5px -5px 0; height: 27px; line-height: 12px;" value="<?php _e('Approve', 'item_validation'); ?>" />
                  <?php } ?>

                  <?php if($status == 0 || $status == 1 || $status == 2){ ?>
                    <input type="submit" name="reject-single_<?php echo $i['fk_i_item_id']; ?>" class="mb-button-red" style="float:left;margin: -4px 5px -5px 0; height: 27px; line-height: 12px;" value="<?php _e('Reject', 'item_validation'); ?>" />
                  <?php } ?>
                </div>
              </div>
            <?php } ?>
          <?php } ?>
        </div>
            
        <?php if(count($items) > 0) { ?>
          <div class="mb-row mb-bulk-buttons">
            <input type="submit" name="item_action" class="mb-btn mb-button-blue" style="float:left;margin-right:10px;" value="<?php _e('Approve Selected', 'item_validation'); ?>" />
            <input type="submit" name="item_action" class="mb-btn mb-button-red" style="float:left;margin-right:10px;" value="<?php _e('Reject Selected', 'item_validation'); ?>" />

            <?php if(!iv_is_demo()) { ?>
              <input type="submit" name="item_action" class="mb-btn mb-button-white" style="margin-left:20px;float:left" value="<?php _e('Remove Selected', 'item_validation'); ?>" />
            <?php } ?>
          </div>
        <?php } ?>

      </div>
    </form>

  </div>
</div>

<?php echo iv_footer(); ?>