<?php

// Create email when listing is approved by admin
function iv_email_notify_approved($item_id, $comment = '') {
  iv_include_mailer();

  $page = new Page() ;
  $page = $page->findByInternalName('iv_email_notify_approved');
  if(empty($page)) { exit(); }

  $locale = osc_current_user_locale() ;
  $content = array();
  if(isset($page['locale'][$locale]['s_title'])) {
    $content = $page['locale'][$locale];
  } else {
    $content = current($page['locale']);
  }
  
  $item = Item::newInstance()->findByPrimaryKey($item_id);

  $item_title = stripslashes(strip_tags($item['s_title']));
  $item_url  = '<a href="' . osc_item_url_ns($item_id) . '" >' . $item_title . '</a>';
  $item_edit_url = osc_item_edit_url($item['s_secret'], $item_id);
  $account_url = '<a href="' . osc_register_account_url() . '" target="_blank">' . __('User Account', 'item_validation') . '</a>';


  $words   = array();
  $words[] = array('{CONTACT_NAME}', '{ITEM_ID}', '{ITEM_TITLE}', '{ITEM_URL}', '{ITEM_EDIT_URL}', '{WEB_TITLE}', '{ACCOUNT_URL}', '{COMMENT}');
  $words[] = array($item['s_contact_name'], $item_id, $item_title, $item_url, $item_edit_url, stripslashes(strip_tags(osc_page_title())), $account_url, $comment) ;

  $title = osc_mailBeauty($content['s_title'], $words) ;
  $body  = osc_mailBeauty($content['s_text'], $words) ;


  $email_build = array(
    'subject'  => $title, 
    'to' => $item['s_contact_email'], 
    'to_name'  => $item['s_contact_name'],
    'body' => $body,
    'alt_body' => $body
 );

  osc_sendMail($email_build);
}



// Create email when listing is rejected by admin
function iv_email_notify_rejected($item_id, $comment = '') {
  iv_include_mailer();

  $page = new Page() ;
  $page = $page->findByInternalName('iv_email_notify_rejected');
  if(empty($page)) { exit(); }

  $locale = osc_current_user_locale() ;
  $content = array();
  if(isset($page['locale'][$locale]['s_title'])) {
    $content = $page['locale'][$locale];
  } else {
    $content = current($page['locale']);
  }
  
  $item = Item::newInstance()->findByPrimaryKey($item_id);

  $item_title = stripslashes(strip_tags($item['s_title']));
  $item_url  = '<a href="' . osc_item_url_ns($item_id) . '" >' . $item_title . '</a>';
  $item_edit_url = osc_item_edit_url($item['s_secret'], $item_id);
  $account_url = '<a href="' . osc_register_account_url() . '" target="_blank">' . __('User Account', 'item_validation') . '</a>';


  $words   = array();
  $words[] = array('{CONTACT_NAME}', '{ITEM_ID}', '{ITEM_TITLE}', '{ITEM_URL}', '{ITEM_EDIT_URL}', '{WEB_TITLE}', '{ACCOUNT_URL}', '{COMMENT}');
  $words[] = array($item['s_contact_name'], $item_id, $item_title, $item_url, $item_edit_url, stripslashes(strip_tags(osc_page_title())), $account_url, $comment) ;

  $title = osc_mailBeauty($content['s_title'], $words) ;
  $body  = osc_mailBeauty($content['s_text'], $words) ;


  $email_build = array(
    'subject'  => $title, 
    'to' => $item['s_contact_email'], 
    'to_name'  => $item['s_contact_name'],
    'body' => $body,
    'alt_body' => $body
 );

  osc_sendMail($email_build);
}

?>