<?php
  // Create menu
  $title = __('Configure', 'login_notification');
  lnt_menu($title);
 

  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value
  $enable = mb_param_update('enable', 'plugin_action', 'check', 'plugin-login_notification');
  $ip_check = mb_param_update('ip_check', 'plugin_action', 'check', 'plugin-login_notification');
  $ip_submask = mb_param_update('ip_submask', 'plugin_action', 'check', 'plugin-login_notification');
  $ip_old_months = mb_param_update('ip_old_months', 'plugin_action', 'value', 'plugin-login_notification');
  $date_check = mb_param_update('date_check', 'plugin_action', 'check', 'plugin-login_notification');
  $date_months = mb_param_update('date_months', 'plugin_action', 'value', 'plugin-login_notification');
  $retention_months = mb_param_update('retention_months', 'plugin_action', 'value', 'plugin-login_notification');

  
  if(Params::getParam('plugin_action') == 'done') {
    message_ok(__('Settings were successfully saved', 'login_notification'));
  }
?>


<div class="mb-body">
  <!-- CONFIGURE SECTION -->
  
  <div class="mb-notes">
    <div class="mb-line"><?php _e('Plugin sends security warning notifications/emails to users those did not logged for several months into their account or used to login from different IP address.', 'login_notification'); ?></div>
  </div>

  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-wrench"></i> <?php _e('Configure', 'login_notification'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />

        <div class="mb-row">
          <label for="enable"><span><?php _e('Enable Notification Emails', 'login_notification'); ?></span></label> 
          <input name="enable" id="enable" type="checkbox" class="element-slide" <?php echo ($enable == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, users may receive security warning notification email if suspicious login has been identified.', 'login_notification'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="ip_check"><span><?php _e('Enable IP Check', 'login_notification'); ?></span></label> 
          <input name="ip_check" id="ip_check" type="checkbox" class="element-slide" <?php echo ($ip_check == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, IP of user will be checked with IP of last successful login.', 'login_notification'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="ip_submask"><span><?php _e('Check IP\'s Submask', 'login_notification'); ?></span></label> 
          <input name="ip_submask" id="ip_submask" type="checkbox" class="element-slide" <?php echo ($ip_submask == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, on IP check plugin will not check IP directly, but submask of IP. In case user use dynamical IP where last part of IP is chaning, this will avoid sending unfounded notifications. (converts 192.168.1.13 to 192.168.1).', 'login_notification'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="ip_old_months"><span><?php _e('IP Retention Period', 'login_notification'); ?></span></label> 
          <input type="number" name="ip_old_months" id="ip_old_months" value="<?php echo osc_esc_html($ip_old_months); ?>" size="30"/>
          <div class="mb-input-desc"><?php _e('months', 'login_notification'); ?></div>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Enter number of months after those IP is considered as not used by user. Example: enter 3 months, when user login using IP that was used last time more than 3 months ago, IP is considered as not used and IP check fails, notification is sent to user.', 'login_notification'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="date_check"><span><?php _e('Enable Date Check', 'login_notification'); ?></span></label> 
          <input name="date_check" id="date_check" type="checkbox" class="element-slide" <?php echo ($date_check == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, email notification is sent to user when he login to its account after XY months.', 'login_notification'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="date_months"><span><?php _e('Date Check Months', 'login_notification'); ?></span></label> 
          <input type="number" name="date_months" id="date_months" value="<?php echo osc_esc_html($date_months); ?>" size="30"/>
          <div class="mb-input-desc"><?php _e('months', 'login_notification'); ?></div>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Enter number of months used to consider user login as suspicious. Example: enter 6 months to send warning email to user that was logged in account more than 6 months ago.', 'login_notification'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="retention_months"><span><?php _e('Data Retention Period', 'login_notification'); ?></span></label> 
          <input type="number" name="retention_months" id="retention_months" value="<?php echo osc_esc_html($retention_months); ?>" size="30"/>
          <div class="mb-input-desc"><?php _e('months', 'login_notification'); ?></div>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Automatically remove plugin data after entered number of months.', 'login_notification'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="last_logs"><span><?php _e('Last 25 Notifications', 'login_notification'); ?></span></label> 
          <textarea style="font-family:monospace;"><?php echo implode(PHP_EOL, lnt_get_warnings()); ?></textarea>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('List of last 25 security warnings sent to users.', 'login_notification'); ?></div>
          </div>
        </div>

        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(lnt_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'login_notification')); ?>"><?php _e('Save', 'login_notification');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'login_notification');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>



  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'login_notification'); ?></div>

    <div class="mb-inside">
      <div class="mb-row"><?php _e('No theme modification are required to use all functions of plugin.', 'login_notification'); ?></div>
    </div>
  </div>
</div>


<?php echo lnt_footer(); ?>