<?php
/*
  Plugin Name: Login Notification Plugin
  Plugin URI: https://osclasspoint.com/
  Description: Plugin helps to secure user accounts and notify account owner in case unusual login has been identified.
  Version: 1.0.0
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: login_notification
  Plugin update URI: login-notification
  Support URI: https://forums.osclasspoint.com/
  Product Key: IDzeo3EbACMp7NXeb0DA
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelLNT.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'email.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';


// REMOVE OLD  DATA
function lnt_purge_data($all = false) {
  $limit = (lnt_param('retention_months') > 0 ? lnt_param('retention_months') : 24);
  $limit_date = date('Y-m-d H:i:s', strtotime('-' . $limit . ' months'));

  if($all === true) {
    $limit_date = date('Y-m-d H:i:s');
  }
  
  ModelLNT::newInstance()->purgeLogs($limit_date);
}

osc_add_hook('cron_daily', 'lnt_purge_data');


// INSTALL FUNCTION - DEFINE VARIABLES
function lnt_call_after_install() {
  osc_set_preference('enable', 1, 'plugin-login_notification', 'INTEGER');
  osc_set_preference('ip_check', 1, 'plugin-login_notification', 'INTEGER');
  osc_set_preference('ip_submask', 1, 'plugin-login_notification', 'INTEGER');
  osc_set_preference('ip_old_months', 6, 'plugin-login_notification', 'INTEGER');
  osc_set_preference('date_check', 1, 'plugin-login_notification', 'INTEGER');
  osc_set_preference('date_months', 3, 'plugin-login_notification', 'INTEGER');
  osc_set_preference('retention_months', 24, 'plugin-login_notification', 'INTEGER');
  osc_set_preference('last_warnings', '', 'plugin-login_notification', 'STRING');

  ModelLNT::newInstance()->install();
}


function lnt_call_after_uninstall() {
  ModelLNT::newInstance()->uninstall();
}


// ADMIN MENU
function lnt_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/login_notification/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/login_notification/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/login_notification/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/login_notification/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/login_notification/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/login_notification/js/bootstrap-switch.js"></script>';

  if( $title == '') { $title = __('Configure', 'login_notification'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Login Notification Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=login_notification/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'login_notification') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function lnt_footer() {
  $pluginInfo = osc_plugin_get_info('login_notification/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint Market" /> OsclassPoint Market</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'login_notification') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'login_notification') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'login_notification') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function lnt_admin_menu() {
echo '<h3><a href="#">Login Notification Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'login_notification') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','lnt_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function lnt_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'lnt_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'lnt_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'lnt_call_after_uninstall');

?>