<?php
  // Create menu
  $title = __('Configure', 'moderator');
  mdr_menu($title);
 

  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value
  $enable_archive = mdr_param_update('enable_archive', 'plugin_action', 'check', 'plugin-moderator');
  $show_opened = mdr_param_update('show_opened', 'plugin_action', 'check', 'plugin-moderator');
  $default_notify = mdr_param_update('default_notify', 'plugin_action', 'check', 'plugin-moderator');
  $show_in_front = mdr_param_update('show_in_front', 'plugin_action', 'check', 'plugin-moderator');
  $shown_reasons = mdr_param_update('shown_reasons', 'plugin_action', 'value', 'plugin-moderator');
  $custom_reasons = mdr_param_update('custom_reasons', 'plugin_action', 'value', 'plugin-moderator');

  
  if(Params::getParam('plugin_action') == 'done') {
    osc_add_flash_ok_message(__('Settings were successfully saved.', 'moderator'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=moderator/admin/configure.php');
    exit;
  }

?>


<div class="mb-body">
  <!-- CONFIGURE SECTION -->

  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-wrench"></i> <?php _e('Configure', 'moderator'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />

        <div class="mb-row">
          <label for="enable_archive"><span><?php _e('Enable Item Versioning', 'moderator'); ?></span></label> 
          <input name="enable_archive" id="enable_archive" type="checkbox" class="element-slide" <?php echo ($enable_archive == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, item versions will be stored and it will be possible to restore to previous version or check list of changes made comparing to previous version.', 'moderator'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="show_opened"><span><?php _e('Expand Moderate Box', 'moderator'); ?></span></label> 
          <input name="show_opened" id="show_opened" type="checkbox" class="element-slide" <?php echo ($show_opened == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, moderate box is expanded by default in backoffice and moderation options enabled.', 'moderator'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="default_notify"><span><?php _e('Notify Checkbox Enabled', 'moderator'); ?></span></label> 
          <input name="default_notify" id="default_notify" type="checkbox" class="element-slide" <?php echo ($default_notify == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, notify user checkbox in moderate box is pre-selected (enabled) by default.', 'moderator'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="show_in_front"><span><?php _e('Show in Front', 'moderator'); ?></span></label> 
          <input name="show_in_front" id="show_in_front" type="checkbox" class="element-slide" <?php echo ($show_in_front == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, moderate button & options will be visible for logged-in administrator on each listing page.', 'moderator'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="shown_reasons"><span><?php _e('Number of Reasons Visible', 'moderator'); ?></span></label> 
          <input name="shown_reasons" id="shown_reasons" type="number" size="6" value="<?php echo osc_esc_html($shown_reasons); ?>"/>
          <div class="mb-input-desc"><?php _e('reasons', 'moderator'); ?></div>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Select how many reasons are visible by default. Other reasons are hidden and can be unhide by clicking on button.', 'moderator'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="custom_reasons"><span><?php _e('Custom Reasons', 'moderator'); ?></span></label> 
          <input name="custom_reasons" id="custom_reasons" type="text" size="100" value="<?php echo osc_esc_html($custom_reasons); ?>"/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Enter list of custom reasons if you need it. Delimit by comma.', 'moderator'); ?></div>
          </div>
        </div>


       
        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(mdr_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'moderator')); ?>"><?php _e('Save', 'moderator');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'moderator');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>



  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'moderator'); ?></div>

    <div class="mb-inside">
      <div class="mb-row"><?php _e('No theme modification are required to use all functions of plugin.', 'moderator'); ?></div>
    </div>
  </div>
</div>


<?php echo mdr_footer(); ?>