<?php

// CONTACT COMPANY MAIL
function mdr_email_user($item_id, $params) {
  $mPages = new Page() ;
  $aPage = $mPages->findByInternalName('mdr_email_user_notify') ;
  $locale = osc_current_user_locale();
  $content = array();

  if(isset($aPage['locale'][$locale]['s_title'])) {
    $content = $aPage['locale'][$locale];
  } else {
    $content = current($aPage['locale'] <> '' ? $aPage['locale'] : array());
  }

  $item = Item::newInstance()->findByPrimaryKey($item_id);
  
  if($item === false || !isset($item['pk_i_id'])) {
    return false;
  }

  $email = $item['s_contact_email'];
  
  $reason = mdr_reason_name($params['mdrReason']);
  $reason = (trim($reason) == '' ? '-' : $reason);
  
  $comment = nl2br($params['mdrComment']);
  $comment = (trim($comment) == '' ? '-' : $comment);

  $is_removal = false;
  if(isset($params['mdrRemove']) && $params['mdrRemove'] == 1) {
    $is_removal = true;
  }
  
  $changes = '';
  $old_data = '';
  
  $last_row = ModelMDR::newInstance()->getLastestItemArchive($item_id, Params::getParam('mdrArchiveUniqueHash'));

  if($last_row !== false && isset($last_row['s_data'])) {
    $old_data = $last_row['s_data'];
  }
  
  if($is_removal) {
    $changes = __('Item has been removed from our website', 'moderator');
    
  } else if($old_data != '') {
    $data = mdr_prepare_archive_data($item_id, 'EDIT');
    $mods = @json_decode(mdr_get_diff($old_data, $data), true);
    
    if(is_array($mods) && count($mods) > 0) { 
      foreach($mods as $m) {
        $top_key = explode('/', $m['full_key'])[0];
        
        if(in_array($m['key'], mdr_email_whitelisted_keys()) || in_array($m['parent_key'], mdr_email_whitelisted_keys()) || in_array($top_key, mdr_email_whitelisted_keys())) {
          if(Params::getParam('mdrFormGenerated') != 1 || (Params::getParam('mdrFormGenerated') == 1 && $m['type'] != 'REMOVED')) {
            $name = ($m['name'] <> '' ? $m['name'] : __('Other', 'moderator'));
            $type = $m['type'];
            $old = osc_highlight($m['old'], 50);
            $new = osc_highlight($m['new'], 50);
            
            if($type == 'NEW') {
              $changes .= sprintf(__('Value for "%s" has been set to "%s".', 'moderator'), $name, $new);
            } else if ($type == 'REMOVED') {
              $changes .= sprintf(__('Value for "%s" has been removed from "%s".', 'moderator'), $name, $old);
            } else if ($type == 'MODIFIED') {
              $changes .= sprintf(__('Value for "%s" has been changed from "%s" into "%s".', 'moderator'), $name, $old, $new);
            }
            
            $changes .= '<br/>';
          }
        }
      }
    }
  }

  $changes = (trim($changes) == '' ? '-' : $changes);
  
  
  $words = array();
  $words[] = array('{CONTACT_NAME}', '{CONTACT_EMAIL}', '{COMMENT}', '{REASON}', '{CHANGES}', '{WEB_URL}', '{WEB_TITLE}');
  $words[] = array($item['s_contact_name'], $email, $comment, $reason, $changes, osc_base_url(), osc_page_title());

  $title = osc_mailBeauty($content['s_title'], $words);
  $body  = osc_mailBeauty($content['s_text'], $words);

  $emailParams = array(
    'subject' => $title,
    'to' => $email,
    'to_name' => $item['s_contact_name'],
    'reply_to' => $email,
    'body' => $body,
    'alt_body' => $body
  );

  osc_sendMail($emailParams);
}

?>