<?php
/*
  Plugin Name: Advanced Moderating Options Plugin
  Plugin URI: https://osclasspoint.com/
  Description: Enhance admin features and options when editing and moderating listing, allows to automatically mail customer and add details what has been moderated
  Version: 1.0.0
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: moderator
  Plugin update URI: moderator
  Support URI: https://forums.osclasspoint.com/general-plugins-discussion/
  Product Key: NHXRYmx3R3XbvXyOAZsB
*/


require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelMDR.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'email.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';



// INSTALL FUNCTION - DEFINE VARIABLES
function mdr_call_after_install() {
  osc_set_preference('enable_archive', 1, 'plugin-moderator', 'INTEGER');
  osc_set_preference('show_opened', 1, 'plugin-moderator', 'INTEGER');
  osc_set_preference('default_notify', 1, 'plugin-moderator', 'INTEGER');
  osc_set_preference('show_in_front', 1, 'plugin-moderator', 'INTEGER');
  osc_set_preference('shown_reasons', 5, 'plugin-moderator', 'INTEGER');
  osc_set_preference('custom_reasons', '', 'plugin-moderator', 'STRING');

  ModelMDR::newInstance()->install();
}


function mdr_call_after_uninstall() {
  ModelMDR::newInstance()->uninstall();
}


// ADMIN MENU
function mdr_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/moderator/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/moderator/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/moderator/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/moderator/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/moderator/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/moderator/js/bootstrap-switch.js"></script>';

  if( $title == '') { $title = __('Configure', 'moderator'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Advanced Moderating Options Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=moderator/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'moderator') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function mdr_footer() {
  $pluginInfo = osc_plugin_get_info('moderator/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint Market" /> OsclassPoint Market</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'moderator') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'moderator') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'moderator') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function mdr_admin_menu() {
echo '<h3><a href="#">Advanced Moderating Options Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'moderator') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','mdr_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function mdr_conf() {
  osc_admin_render_plugin(osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php');
}

osc_add_hook(osc_plugin_path( __FILE__ ) . '_configure', 'mdr_conf');	

// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'mdr_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'mdr_call_after_uninstall');

?>