SET FOREIGN_KEY_CHECKS=0;


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_mdr_action;
CREATE TABLE /*TABLE_PREFIX*/t_mdr_action (
  pk_i_id INT NOT NULL AUTO_INCREMENT,
  fk_i_item_id INT UNSIGNED NOT NULL,
  fk_i_archive_id INT UNSIGNED NULL,
  fk_i_admin_id INT UNSIGNED NULL,
  s_admin VARCHAR(100) DEFAULT NULL,
  s_status VARCHAR(50) DEFAULT NULL,
  b_notify TINYINT(1) DEFAULT 0,
  s_reason VARCHAR(500) DEFAULT NULL,
  s_comment VARCHAR(5000) DEFAULT NULL,
  s_comment_internal VARCHAR(2000) DEFAULT NULL,
  dt_date TIMESTAMP,

  PRIMARY KEY (pk_i_id),
  FOREIGN KEY (fk_i_item_id) REFERENCES /*TABLE_PREFIX*/t_item (pk_i_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_mdr_item_archive;
CREATE TABLE /*TABLE_PREFIX*/t_mdr_item_archive (
  pk_i_id INT NOT NULL AUTO_INCREMENT,
  fk_i_item_id INT UNSIGNED NOT NULL,
  i_version INT(10) DEFAULT 1,
  s_action VARCHAR(50) DEFAULT NULL,
  s_data MEDIUMTEXT NULL,
  s_data_changed MEDIUMTEXT NULL,
  s_item_data MEDIUMTEXT NULL,
  s_hash VARCHAR(20) DEFAULT NULL,
  dt_date TIMESTAMP,

  PRIMARY KEY (pk_i_id),
  FOREIGN KEY (fk_i_item_id) REFERENCES /*TABLE_PREFIX*/t_item (pk_i_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';



SET FOREIGN_KEY_CHECKS=1;