<?php
  $id = Params::getParam('campaignId') > 0 ? Params::getParam('campaignId') : Params::getParam('pk_i_id');

  if($id > 0) {
    $campaign = ModelNSL::newInstance()->getCampaign($id);
  }

  // Create menu
  if($id > 0) {
    $title = __('Update campaign', 'newsletter');
  } else {
    $title = __('Create new campaign', 'newsletter');
  }

  nsl_menu($title);


  if(Params::getParam('plugin_action') == 'done') {
 
    $data = array(
      'pk_i_id' => Params::getParam('pk_i_id'),
      's_name' => Params::getParam('s_name'),
      's_subject' => Params::getParam('s_subject'),
      's_preview' => Params::getParam('s_preview'),
      's_from_name' => Params::getParam('s_from_name'),
      's_from_email' => Params::getParam('s_from_email'),
      's_content' => Params::getParam('s_content', false, false),
      'i_status' => Params::getParam('i_status'),
      'dt_create_date' => Params::getParam('dt_create_date')
    );

    ModelNSL::newInstance()->updateCampaign($data);

    $id = Params::getParam('campaignId');
    $campaign = ModelNSL::newInstance()->getCampaign($id);


    message_ok( __('Updates were successfully saved', 'newsletter') );
  }
?>

<script type="text/javascript" src="<?php echo osc_assets_url('js/tinymce/tinymce.min.js'); ?>"></script>

<script type="text/javascript">
  tinyMCE.init({
    selector: "textarea#s_content",
    mode : "textareas",
    width: "65%",
    height: "440px",
    language: "en",
    content_css : ["//fonts.googleapis.com/css?family=Open+Sans:300,600&amp;subset=latin,latin-ext"],
    content_style: ".mce-content-body {font-family:'Open Sans',Helvetica,Arial,sans-serif;font-size:13px;}",
    theme_advanced_toolbar_align : "left",
    theme_advanced_toolbar_location : "top",
    plugins : [
      "advlist autolink lists link image charmap preview anchor",
      "searchreplace visualblocks code fullscreen",
      "insertdatetime media table contextmenu paste"
    ],
    entity_encoding : "raw",
    theme_advanced_buttons1_add : "forecolorpicker,fontsizeselect",
    theme_advanced_buttons2_add: "media",
    theme_advanced_buttons3: "",
    theme_advanced_disable : "styleselect,anchor",
    relative_urls : false,
    remove_script_host : false,
    convert_urls : false
  });
</script>

<div class="mb-body">

  <!-- NEW CAMPAIGN SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-plus-circle"></i> <?php echo $title; ?>
    </div>

    <div class="mb-inside mb-campaign">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>campaign.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <input type="hidden" name="pk_i_id" value="<?php echo $id; ?>" />
        <input type="hidden" name="i_status" value="<?php echo (@$campaign['i_status'] <> '' ? $campaign['i_status'] : 0); ?>" />
        <input type="hidden" name="dt_create_date" value="<?php echo @$campaign['dt_create_date'] <> '' ? date("Y-m-d h:i:s", strtotime(@$campaign['dt_create_date'])): date("Y-m-d h:i:s"); ?>" />


        <div class="mb-row">
          <label for="s_name"><?php _e('Campaign Name', 'newsletter'); ?></label>
          <input type="text" id="s_name" name="s_name" size="80" value="<?php echo @$campaign['s_name']; ?>" required />

          <div class="mb-explain"><?php _e('Name is used for internal purpose only.', 'newsletter'); ?></div>
        </div>

        <div class="mb-row">
          <label for="s_subject"><?php _e('Subject', 'newsletter'); ?></label>
          <input type="text" id="s_subject" name="s_subject" size="80" value="<?php echo @$campaign['s_subject']; ?>" required />

          <div class="mb-explain"><?php _e('Mail subject.', 'newsletter'); ?></div>
        </div>

        <div class="mb-row">
          <label for="s_preview"><?php _e('Preview Text', 'newsletter'); ?></label>
          <input type="text" id="s_preview" name="s_preview" size="80" value="<?php echo @$campaign['s_preview']; ?>" />

          <div class="mb-explain"><?php _e('Short preview text shown in some email clients.', 'newsletter'); ?></div>
        </div>

        <div class="mb-row">
          <label for="s_from_name"><?php _e('From Name', 'newsletter'); ?></label>
          <input type="text" id="s_from_name" name="s_from_name" size="80" value="<?php echo @$campaign['s_from_name']; ?>" required />

          <div class="mb-explain"><?php _e('Sender\'s name', 'newsletter'); ?></div>
        </div>

        <div class="mb-row">
          <label for="s_from_email"><?php _e('From Email', 'newsletter'); ?></label>
          <input type="text" id="s_from_email" name="s_from_email" size="80" value="<?php echo @$campaign['s_from_email']; ?>" required />

          <div class="mb-explain"><?php _e('Sender\'s email. Email domain should match to your site domain, otherwise your mails can be marked as spam and untrusted.', 'newsletter'); ?></div>
        </div>

        <div class="mb-row">
          <label for="s_content"><?php _e('Content', 'newsletter'); ?></label>
          <textarea id="s_content" name="s_content"><?php echo @$campaign['s_content']; ?></textarea>

          <div class="mb-explain"><?php _e('Available variables:', 'newsletter'); ?> {USER_NAME}, {USER_EMAIL}, {WEB_TITLE}, {UNSUBSCRIBE}</div>
        </div>


        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(!nsl_is_demo()) { ?><button type="submit" class="mb-button"><?php _e('Save', 'newsletter');?></button><?php } ?>
        </div>
      </form>
    </div>
  </div>
</div>


<?php echo nsl_footer(); ?>