<?php
  // Create menu
  $title = __('Campaigns', 'newsletter');
  nsl_menu($title);


  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'newsletter') );
  }


  if(Params::getParam('removeId') > 0) {
    ModelNSL::newInstance()->removeCampaign(Params::getParam('removeId'));
    message_ok( __('Campaign removed successfully', 'newsletter') );
  }

?>



<div class="mb-body">

  <!-- CAMPAIGNS SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-list"></i> <?php _e('Campaigns', 'newsletter'); ?>
    </div>

    <div class="mb-inside mb-newsletter" id="mb-newsletter">
      <?php 
        $status_id = (Params::getParam('statusId') <> '' ? Params::getParam('statusId') : -1);
        $campaigns = ModelNSL::newInstance()->getCampaigns($status_id); 
      ?>

      <?php if(count($campaigns) > 0) { ?>
        <?php foreach($campaigns as $c) { ?>
          <?php 
            $mail_sent = ModelNSL::newInstance()->countList($c['pk_i_id'], 1); 
            $mail_failed = ModelNSL::newInstance()->countList($c['pk_i_id'], -1, 1); 
            $mail_pending = ModelNSL::newInstance()->countList($c['pk_i_id'], 0); 
          ?>

          <div class="mb-one" data-id="<?php echo $c['pk_i_id']; ?>" id="nsl_<?php echo $c['pk_i_id']; ?>">
            <div class="mb-line">
              <span class="title">
                <?php echo $c['s_name']; ?>
              </span>

              <span class="date"><span class="mb-has-tooltip" title="<?php echo $c['dt_create_date']; ?>"><?php echo date('j. M Y', strtotime($c['dt_create_date'])); ?></span></span>

              <span class="status"><?php echo nsl_status($c['i_status']); ?></span>

              <span class="counter sent">
                <span class="top"><?php echo $mail_sent; ?></span>
                <span class="bot"><?php _e('Sent', 'newsletter'); ?></span>
              </span>

              <span class="counter pending">
                <span class="top"><?php echo $mail_pending; ?></span>
                <span class="bot"><?php _e('Pending', 'newsletter'); ?></span>
              </span>

              <span class="counter failed">
                <span class="top"><?php echo $mail_failed; ?></span>
                <span class="bot"><?php _e('Failed', 'newsletter'); ?></span>
              </span>


              <span class="remove nslbtn"><a class="mb-has-tooltip" title="<?php echo osc_esc_html(__('Delete post', 'newsletter')); ?>" href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=newsletter/admin/campaign_list.php&removeId=<?php echo $c['pk_i_id']; ?>" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove this campaign? Action cannot be undone', 'newsletter')); ?>')"><i class="fa fa-trash-o"></i></a></span>
              <span class="edit nslbtn"><a class="mb-has-tooltip" title="<?php echo osc_esc_html(__('Edit in new window', 'newsletter')); ?>" href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=newsletter/admin/campaign.php&campaignId=<?php echo $c['pk_i_id']; ?>"><i class="fa fa-pencil"></i></a></span>
              <span class="list nslbtn"><a class="mb-has-tooltip" title="<?php echo osc_esc_html(__('Show mailing list', 'newsletter')); ?>" href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=newsletter/admin/mail_list.php&campaignId=<?php echo $c['pk_i_id']; ?>"><i class="fa fa-users"></i></a></span>

              <?php if($c['i_status'] <> 2) { ?>
                <?php if(nsl_test_emails() !== false) { ?>
                  <span class="test nslbtn"><a class="mb-has-tooltip" title="<?php echo osc_esc_html(sprintf(__('Send to test emails: %s', 'newsletter'), nsl_test_emails(true))); ?>" href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=newsletter/admin/campaign_run.php&campaignId=<?php echo $c['pk_i_id']; ?>&testEmail=<?php echo urlencode(nsl_test_emails(true)); ?>&plugin_action=test"><i class="fa fa-flask"></i></a></span>
                <?php } ?>              
              
                <span class="run nslbtn"><a class="mb-has-tooltip" title="<?php echo osc_esc_html(__('Run now', 'newsletter')); ?>" href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=newsletter/admin/campaign_run.php&campaignId=<?php echo $c['pk_i_id']; ?>"><i class="fa fa-rocket"></i></a></span>
              <?php } ?>
            </div>
          </div>
        <?php } ?>
      <?php } else { ?>
        <?php if($status_id >= 0) { ?>
          <div class="mb-no-campaigns"><?php _e('No campaigns with selected status found', 'newsletter'); ?></div>
        <?php } else { ?>
          <div class="mb-no-campaigns"><?php _e('You have not created any campaign yet', 'newsletter'); ?></div>
        <?php } ?>
      <?php } ?>

      <?php if($status_id == -1) { ?>
        <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=newsletter/admin/campaign.php" class="mb-add-campaign"><i class="fa fa-plus-circle"></i><?php _e('Create new campaign', 'newsletter'); ?></a>
      <?php } ?>
    </div>
  </div>
</div>


<?php echo nsl_footer(); ?>