<?php
  // Create menu
  $title = __('Run Campaign', 'newsletter');
  nsl_menu($title);

  $campaign_id = Params::getParam('campaignId');
  $started = (Params::getParam('startCampaign') > 0 ? 1 : 0);
  $initial = (Params::getParam('initial') > 0 ? 1 : 0);
  $reload = (Params::getParam('reload') > 0 ? 1 : 0);


  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'newsletter') );
  }

  if(Params::getParam('plugin_action') == 'test') {
    nsl_email_send($campaign_id, 0, urldecode(Params::getParam('testEmail')), __('Test receiver', 'newsletter'), '', 1);
    message_ok( __('Test email successfully sent', 'newsletter') );
  }

  $wait_time = ceil(3600/nsl_param('mails_per_hour'));
  //$wait_time = ($wait_time > 20 ? $wait_time : 20);  --> this does not work as expected, should be limit

  $finished = (Params::getParam('finished') > 0 ? 1 : 0);

  // UPDATE CAMPAIGN STATUS
  if(Params::getParam('startCampaign') == 1 && $finished == 0) {
    ModelNSL::newInstance()->updateCampaignStatus($campaign_id, 1);
  } else if ($finished == 1) {
    ModelNSL::newInstance()->updateCampaignStatus($campaign_id, 2);
  }


  // START SENDING EMAILS
  $i = 0;
  if(Params::getParam('startCampaign') == 1 && $campaign_id > 0 && $initial <> 1 && $finished == 0) {
    $mails = ModelNSL::newInstance()->getListForSend($campaign_id);

    if(count($mails) > 0) {
      $start = microtime(true);
      $sleep = $wait_time;
      $usleep = round($sleep*1000000);

      foreach($mails as $m) {
        $mail_result = nsl_email_send($m['fk_i_campaign_id'], $m['fk_i_user_id'], $m['s_email'], $m['s_name'], $m['s_secret']);
        
        $data = array(
          'pk_i_id' => $m['pk_i_id'],
          'dt_send_date' => date('Y-m-d H:i:s'),
          'i_status' => 1,
          'i_error' => ($mail_result ? 0 : 1),
          's_comment' => ($mail_result ? '' : __('Email was not sent', 'newsletter'))
        );

        ModelNSL::newInstance()->updateListById($data);
        $i++;

        usleep($usleep);

        if( (microtime(true) - $start) >= $wait_time ) {
          header('Location:' .  osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=newsletter/admin/campaign_run.php&campaignId=' . $campaign_id . '&reload=1&sent=' . $i . '&runtime=' . (microtime(true) - $start));
          exit;
        }
      }
    }

    header('Location:' .  osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=newsletter/admin/campaign_run.php&campaignId=' . $campaign_id . '&finished=1');
    exit;  
  }

  $mail_sent = ModelNSL::newInstance()->countList($campaign_id, 1); 
  $mail_failed = ModelNSL::newInstance()->countList($campaign_id, -1, 1); 
  $mail_pending = ModelNSL::newInstance()->countList($campaign_id, 0); 

?>



<div class="mb-body">
  <div class="mb-box mb-fancy">
    <?php if(($started == 0 || $finished == 1) && $reload == 0) { ?>
      <?php if($mail_pending > 0 && $finished == 0) { ?>
        <h3><?php _e('Ready to run your campaign?', 'newsletter'); ?></h3>

        <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=newsletter/admin/campaign_run.php&initial=1&campaignId=<?php echo $campaign_id; ?>&startCampaign=1" id="mb-run-now">
          <i class="fa fa-rocket"></i>
          <span><?php echo ($mail_sent <= 0 ? __('Run campaign now!', 'newsletter') : __('Finish campaign now!', 'newsletter')); ?></span>
        </a>
      <?php } else { ?>
        <h3><?php _e('All emails has been sent already', 'newsletter'); ?></h3>

        <a href="#" id="mb-run-now" class="disabled" disabled onclick="return false;">
          <i class="fa fa-rocket"></i>
          <span><?php echo __('Campaign is completed', 'newsletter'); ?></span>
        </a>
      <?php } ?>

      <div class="mb-run-stats">
        <div class="stat sent">
          <span class="top"><?php echo $mail_sent; ?></span>
          <span class="bot"><?php _e('Sent', 'newsletter'); ?></span>
        </div>

        <div class="stat pending">
          <span class="top"><?php echo $mail_pending; ?></span>
          <span class="bot"><?php _e('Pending', 'newsletter'); ?></span>
        </div>

        <div class="stat failed">
          <span class="top"><?php echo $mail_failed; ?></span>
          <span class="bot"><?php _e('Failed', 'newsletter'); ?></span>
        </div>
      </div>

      <?php if($mail_pending > 0 && $finished == 0) { ?>
        <div class="mb-run-del"></div>

        <h4><?php _e('Send test email(s)', 'newsletter'); ?></h4>
        <form class="mb-test-form" name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
          <input type="hidden" name="page" value="plugins" />
          <input type="hidden" name="action" value="renderplugin" />
          <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>campaign_run.php" />
          <input type="hidden" name="plugin_action" value="test" />
          <input type="hidden" name="campaignId" value="<?php echo $campaign_id; ?>" />

          <input type="text" name="testEmail" value="<?php echo osc_esc_html(urldecode(Params::getParam('testEmail'))); ?>" />
          <button class="mb-button mb-button-white" type="submit"><?php _e('Send', 'newsletter'); ?></button>
        </form>
      <?php } ?>

    <?php } else { ?>
      <div class="mb-camp-running">
        <div class="mail-animation-wrap"><img src="<?php echo osc_base_url(); ?>oc-content/plugins/newsletter/img/mail-send.gif" class="mail-animation" /></div>

        <h3><?php _e('Sending your emails now!', 'newsletter'); ?></h3>

        <div class="mb-notes">
          <span class="mb-line"><?php _e('Do not close this page, wait until all emails are sent.', 'newsletter'); ?></span>
          <span class="mb-line"><?php echo sprintf(__('This page will refresh every %d seconds.', 'newsletter'), $wait_time); ?></span>
        </div>


        <div class="mb-run-stats">
          <div class="stat sent">
            <span class="top"><?php echo $mail_sent; ?></span>
            <span class="bot"><?php _e('Sent', 'newsletter'); ?></span>
          </div>

          <div class="stat pending">
            <span class="top"><?php echo $mail_pending; ?></span>
            <span class="bot"><?php _e('Pending', 'newsletter'); ?></span>
          </div>

          <div class="stat failed">
            <span class="top"><?php echo $mail_failed; ?></span>
            <span class="bot"><?php _e('Failed', 'newsletter'); ?></span>
          </div>
        </div>

        <?php if($reload == 1) { ?>
          <?php $sent = (Params::getParam('sent') > 0 ?Params::getParam('sent') : 0); ?>
          <div class="mb-row"><?php echo sprintf(__('%d emails sent in previous step', 'newsletter'), $sent); ?></div>
        <?php } ?>

        <div class="mb-row"><?php echo sprintf(__('%d emails left to be send', 'newsletter'), $mail_pending); ?></div>
        <div class="mb-row"><?php echo sprintf(__('Estimated run time is %s minute(s)', 'newsletter'), '<strong>' . round(($mail_pending/nsl_param('mails_per_hour'))*60, 1) . '</strong>'); ?></div>
        <div class="mb-row"><?php echo sprintf(__('Sending %d emails per minute', 'newsletter'), round(nsl_param('mails_per_hour')/60, 1)); ?></div>
        <div class="mb-row"><?php _e('You can interupt sending emails and continue later', 'newsletter'); ?></div>
      </div>
    <?php } ?>
  </div>
</div>


<?php echo nsl_footer(); ?>


<?php if($initial == 1 || $reload == 1) { ?>
  <script>
    console.log('Reload. Run time: <?php echo (Params::getParam('runtime') <> '' ? Params::getParam('runtime') : 0); ?>s. Mails sent: <?php echo (Params::getParam('sent') <> '' ? Params::getParam('sent') : 0); ?>.');
    window.location.href = "<?php echo osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=newsletter/admin/campaign_run.php&campaignId=' . $campaign_id . '&startCampaign=1'; ?>";
  </script>
  <?php exit; ?>
<?php } ?>