<?php
  // Create menu
  $title = __('Configure', 'newsletter');
  nsl_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value
  $mails_per_hour = mb_param_update('mails_per_hour', 'plugin_action', 'value', 'plugin-newsletter');
  $test_email = mb_param_update('test_email', 'plugin_action', 'value', 'plugin-newsletter');
  $ignore_gdpr = mb_param_update('ignore_gdpr', 'plugin_action', 'check', 'plugin-newsletter');


  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'newsletter') );
  }

?>



<div class="mb-body">

  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-wrench"></i> <?php _e('Configure', 'newsletter'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />


        <div class="mb-notes">
          <span class="mb-line"><?php _e('Consult with your hosting provider what is your limit of sending emails per hour.', 'newsletter'); ?></span>
          <span class="mb-line"><?php _e('Plugin sends email one by one, not all at once or in batch.', 'newsletter'); ?></span>
          <span class="mb-line"><?php _e('If you have GDPR plugin installed, Newsletter plugin will only select users those consent with sending newsletters.', 'newsletter'); ?></span>
        </div>


        <div class="mb-row">
          <label for="newsletter_order"><span><?php _e('Mails per Hour', 'newsletter'); ?></span></label> 
          <input min="1" type="number" name="mails_per_hour" id="mails_per_hour" style="width:80px;" value="<?php echo $mails_per_hour; ?>" required/>
          
          <div class="mb-explain"><?php _e('Enter limit on how many emails can be send per hour. Example: If you enter 60 mails per hour, each minute will be sent 1 email.', 'newsletter'); ?></div>
        </div>

        <div class="mb-row">
          <label for="test_email"><span><?php _e('Test Email(s)', 'newsletter'); ?></span></label> 
          <input type="text" name="test_email" id="test_email" size="100" value="<?php echo $test_email; ?>"/>
          
          <div class="mb-explain"><?php _e('Enter one or more email accounts those will be used for testing purpose. You can enter more emails, delimit them by comma. Example: john@doe.com,john@dot.com', 'newsletter'); ?></div>
        </div>

        <div class="mb-row">
          <label for="ignore_gdpr" class=""><span><?php _e('Ignore GDPR Plugin', 'newsletter'); ?></span></label> 
          <input name="ignore_gdpr" type="checkbox" class="element-slide" <?php echo ($ignore_gdpr == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('If you have GDPR plugin installled, you can disable users filtering and include all users into newsletter audience, no matter if they consent with newsletters.', 'newsletter'); ?></div>
        </div>
        
        
        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(!nsl_is_demo()) { ?><button type="submit" class="mb-button"><?php _e('Save', 'newsletter');?></button><?php } ?>
        </div>
      </form>
    </div>
  </div>
</div>


<?php echo nsl_footer(); ?>