<?php

  // Create menu
  $title = __('Mailing list', 'newsletter');
  nsl_menu($title);


  if(Params::getParam('plugin_action') == 'add') {
    // b_company, b_active, b_has_phone, b_has_location, i_items
    ModelNSL::newInstance()->addUsersToListSpecial(Params::getParam('campaignId'), Params::getParam('b_company'), Params::getParam('b_active'), Params::getParam('b_has_phone'), Params::getParam('b_has_location'), Params::getParam('i_items'));
    message_ok( __('Users successfully added, no duplicated entries created', 'newsletter') );
  }


  if(Params::getParam('deleteId') > 0) {
    ModelNSL::newInstance()->removeUser(Params::getParam('campaignId'), Params::getParam('deleteId'));
    message_ok( __('User successfully removed from mailing list', 'newsletter') );
  }

  if(Params::getParam('deleteCampaignId') > 0) {
    ModelNSL::newInstance()->removeListByCampaignId(Params::getParam('deleteCampaignId'));
    message_ok( __('Mailing list cleared successfully', 'newsletter') );
  }
  

  if(Params::getParam('resetAll') == 1) {
    ModelNSL::newInstance()->resetList(Params::getParam('campaignId'));
    ModelNSL::newInstance()->updateCampaignStatus(Params::getParam('campaignId'), 0);

    message_ok( __('All recipients has been set to pending state, campaign status to pending as well. You can send campaign again.', 'newsletter') );
  }


  $campaign_id = Params::getParam('campaignId');

  if(Params::getParam('status') <> '' && Params::getParam('status') > 0) {
    $status_id = Params::getParam('status');
  } else {
    $status_id = -1;
  }

  if(Params::getParam('error') <> '' && Params::getParam('error') > 0) {
    $error_id = Params::getParam('error');
  } else {
    $error_id = -1;
  }

 
  $num_all = ModelNSL::newInstance()->countList($campaign_id, $status_id, $error_id);
  $num_list = 500;

  //Start position for pagination
  if(Params::getParam('start')) {
    $start = intval(Params::getParam('start'));
    if ($start > 0) {
      $start--;
    }
  } else {
    $start = 0;
  }



  $list = ModelNSL::newInstance()->getList($campaign_id, $status_id, $error_id, $num_list, $start);
?>


<div class="mb-body">

  <!-- ADD TO MAILING LIST SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-plus"></i> <?php _e('Add users to mailing list', 'newsletter'); ?>
    </div>

    <div class="mb-inside mb-add">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>mail_list.php" />
        <input type="hidden" name="plugin_action" value="add" />
        <input type="hidden" name="campaignId" value="<?php echo Params::getParam('campaignId'); ?>" />

        <div class="mb-row mb-adding">
          <div class="mb-col-4 mb-cl">
            <label for="b_company"><?php _e('User type', 'newsletter'); ?></label>
            <select name="b_company" id="b_company">
              <option value="" selected="selected"><?php _e('All users', 'newsletter'); ?></option>
              <option value="0"><?php _e('Personal', 'newsletter'); ?></option>
              <option value="1"><?php _e('Company', 'newsletter'); ?></option>
            </select>
          </div>

          <div class="mb-col-4 mb-cl">
            <label for="b_active"><?php _e('Active', 'newsletter'); ?></label>
            <select name="b_active" id="b_active">
              <option value="" selected="selected"><?php _e('All users', 'newsletter'); ?></option>
              <option value="0"><?php _e('Inactive', 'newsletter'); ?></option>
              <option value="1"><?php _e('Active', 'newsletter'); ?></option>
            </select>
          </div>

          <div class="mb-col-4 mb-cl">
            <label for="b_has_phone"><?php _e('With Phone Number', 'newsletter'); ?></label>
            <select name="b_has_phone" id="b_has_phone">
              <option value="" selected="selected"><?php _e('All users', 'newsletter'); ?></option>
              <option value="0"><?php _e('No phone number', 'newsletter'); ?></option>
              <option value="1"><?php _e('Has phone number (phone or land)', 'newsletter'); ?></option>
            </select>
          </div>

          <div class="mb-col-4 mb-cl">
            <label for="b_has_location"><?php _e('With Location', 'newsletter'); ?></label>
            <select name="b_has_location" id="b_has_location">
              <option value="" selected="selected"><?php _e('All users', 'newsletter'); ?></option>
              <option value="0"><?php _e('No location', 'newsletter'); ?></option>
              <option value="1"><?php _e('Has location (region or city)', 'newsletter'); ?></option>
            </select>
          </div>

          <div class="mb-col-4 mb-cl">
            <label for="i_items"><?php _e('Has Items', 'newsletter'); ?></label>
            <select name="i_items" id="i_items">
              <option value="" selected="selected"><?php _e('All users', 'newsletter'); ?></option>
              <option value="0"><?php _e('No items', 'newsletter'); ?></option>
              <option value="1"><?php _e('1 or more items', 'newsletter'); ?></option>
            </select>
          </div>

          <div class="mb-col-4 mb-cl mb-cl-last">
            <label>&nbsp;</label>
            <button type="submit" class="mb-button mb-button-green"><i class="fa fa-plus-circle"></i> <?php _e('Add users', 'newsletter'); ?></button>
          </div>

        </form>
      </div>
    </div>
  </div>


  <!-- MAILING LIST SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-comments"></i> <?php echo $title; ?>
    </div>

    <div class="mb-inside mb-mails">

      <div class="mb-row mb-filters">
        <select id="status" name="status" rel="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=newsletter/admin/mail_list.php&campaignId=<?php echo Params::getParam('campaignId'); ?>&errorId=<?php echo Params::getParam('errorId'); ?>">
          <option value="-1" <?php if($status_id == -1) { ?>selected="selected"<?php } ?>><?php _e('Show all', 'newsletter'); ?></option>
          <option value="0" <?php if($status_id == 0) { ?>selected="selected"<?php } ?>><?php _e('Pending only', 'newsletter'); ?></option>
          <option value="1" <?php if($status_id == 1) { ?>selected="selected"<?php } ?>><?php _e('Sent only', 'newsletter'); ?></option>
          <option value="2" <?php if($status_id == 2) { ?>selected="selected"<?php } ?>><?php _e('Unsubscribed only', 'newsletter'); ?></option>
        </select>

        <select id="error" name="error" rel="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=newsletter/admin/mail_list.php&campaignId=<?php echo Params::getParam('campaignId'); ?>&statusId=<?php echo Params::getParam('statusId'); ?>">
          <option value="" <?php if($error_id == -1) { ?>selected="selected"<?php } ?>><?php _e('Show all', 'newsletter'); ?></option>
          <option value="1" <?php if($error_id == 1) { ?>selected="selected"<?php } ?>><?php _e('Not sent due to error', 'newsletter'); ?></option>
        </select>

        <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=newsletter/admin/mail_list.php&start=<?php echo $start; ?>&campaignId=<?php echo Params::getParam('campaignId'); ?>&resetAll=1" class="mb-button mb-button-white" style="float:right;"><i class="fa fa-refresh"></i> &nbsp;<?php _e('Set recipients all to pending', 'newsletter'); ?></a>
        <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=newsletter/admin/mail_list.php&campaignId=<?php echo Params::getParam('campaignId'); ?>&deleteCampaignId=<?php echo Params::getParam('campaignId'); ?>" class="mb-button mb-button-white" style="float:right;margin-right:10px;"><i class="fa fa-trash"></i> &nbsp;<?php _e('Remove all recipients', 'newsletter'); ?></a>



      </div>

      <div class="mb-table mb-table-mails">
        <div class="mb-table-head">
          <div class="mb-col-1"><span><?php _e('ID', 'newsletter');?></span></div>
          <div class="mb-col-3 mb-align-left"><span><?php _e('User', 'newsletter');?></span></div>
          <div class="mb-col-6 mb-align-left"><span><?php _e('Email', 'newsletter');?></span></div>
          <div class="mb-col-4 mb-align-left"><span><?php _e('Status', 'newsletter');?></span></div>
          <div class="mb-col-3"><span><?php _e('Sent Date', 'newsletter');?></span></div>
          <div class="mb-col-4 mb-align-left"><span><?php _e('Note', 'newsletter');?></span></div>
          <div class="mb-col-3"><span>&nbsp;</span></div>
        </div>

        <?php if(count($list) <= 0) { ?>
          <div class="mb-table-row mb-row-empty">
            <i class="fa fa-warning"></i><span><?php _e('No users in mailing list', 'newsletter'); ?></span>
          </div>
        <?php } else { ?>
          <?php foreach($list as $l) { ?>
            <div class="mb-table-row">
              <?php 
                $user = User::newInstance()->findByPrimaryKey($l['fk_i_user_id']);
              ?>

              <div class="mb-col-1 st st<?php echo $l['i_status']; ?> er<?php echo $l['i_error']; ?>"><?php echo $l['pk_i_id']; ?></div>
              <div class="mb-col-3 mb-align-left">
                <a target="_blank" href="<?php echo osc_admin_base_url(true); ?>?page=users&action=edit&id=<?php echo $l['fk_i_user_id']; ?>" class="ouser"><?php echo (@$user['s_name'] <> '' ? $user['s_name'] : __('Unknown', 'newsletter')); ?></a>
              </div>
              <div class="mb-col-6 mb-align-left"><?php echo nsl_mask_email(@$user['s_email']); ?></div>
              <div class="mb-col-4 mb-align-left status"><?php echo nsl_mail_status($l['i_status'], $l['i_error']); ?></div>
              <div class="mb-col-3">
                <?php if($l['dt_send_date'] <> NULL) { ?>
                  <span class="mb-has-tooltip odate" title="<?php echo $l['dt_send_date']; ?>"><?php echo date('j. M Y', strtotime($l['dt_send_date'])); ?></span>
                <?php } ?>
              </div>

              <div class="mb-col-4 mb-align-left">
                <?php 
                  if($l['i_error'] > 0) {
                    echo __('ERROR', 'newsletter') . ': ' . $l['s_comment'];
                  } else if($l['s_comment'] <> '') {
                    echo $l['s_comment'];
                  }

                ?>
              </div>

              <div class="mb-col-3 ubtns">
                <?php if($l['i_status'] == 0) { ?>
                  <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=newsletter/admin/mail_list.php&start=<?php echo $start; ?>&campaignId=<?php echo $l['fk_i_campaign_id']; ?>&deleteId=<?php echo $l['pk_i_id']; ?>" class="mb-btn mb-button-red" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove this user from mailing list? Action cannot be undone', 'newsletter')); ?>')"><i class="fa fa-trash-o"></i></a>
                <?php } ?>
              </div>
            </div>
          <?php } ?>
        <?php } ?>
      </div>

      <?php if($num_all > $num_list) { ?>
        <div id="mb-pagination">
          <div class="mb-pagination-wrap">
            <?php 
              $file_path = 'newsletter/admin/mail_list.php&campaignId=' . $campaign_id . '&status=' . $status_id . '&error=' . $error_id;
            ?>

            <div><?php _e('Page', 'newsletter'); ?>:</div> <?php echo nsl_add_pagination($num_all, $num_list, $file_path); ?>
          </div>
        </div>
      <?php } ?>

      <div class="mb-row">&nbsp;</div>

    </div>
  </div>
</div>

<?php echo nsl_footer(); ?>