<?php

function nsl_email_send($campaign_id, $to_id, $to_email, $to_name, $to_secret, $is_test = 0) {
  nsl_include_mailer();

  if(nsl_is_demo()) {
    return false;
  }

  $content = '{CONTENT}';
  $campaign = ModelNSL::newInstance()->getCampaign($campaign_id);

  $unsub_link = osc_route_url('nsl-unsubscribe', array('userId' => $to_id, 'secret' => $to_secret));

  $ulink = '';
  if($to_id > 0 && $to_secret <> '') {
    $ulink = '<a href="' . $unsub_link . '">' . __('Unsubscribe', 'newsletter') . '</a>';
  }

  $words   = array();
  $words[] = array('{USER_NAME}', '{USER_EMAIL}', '{WEB_TITLE}', '{UNSUBSCRIBE}');
  $words[] = array($to_name, $to_email, stripslashes(strip_tags(osc_page_title())), $ulink) ;

  
  $title = $campaign['s_subject'];
  $body = '';

  if($campaign['s_preview'] <> '') {
    $body = '<div style="display:none;font-size:1px;color:#333333;line-height:1px;max-height:0px;max-width:0px;opacity:0;overflow:hidden;">' . $campaign['s_preview'] . '</div>';
  }


  $body .= $campaign['s_content'];


  $title = osc_mailBeauty($title, $words) ;
  $body  = osc_mailBeauty($body, $words) ;


  if($is_test == 1) {
    $title = '[TEST] ' . $title;
  }

  $to_email = array_filter(array_unique(array_map('trim', explode(',', $to_email))));
  $mails = array();
  
  if(count($to_email) > 1) {
    foreach($to_email as $mail) {
      $mails[$mail] = $to_name;
    }
    
    $to_email = $mails;
  } else {
    $to_email = $to_email[0];
  }
  
  $email_build = array(
    'subject'  => $title, 
    'to' => $to_email,
    'to_name'  => $to_name,
    'from' => $campaign['s_from_email'],
    'from_name' => $campaign['s_from_name'],
    'body' => $body,
    'alt_body' => $body
  );

  $return = osc_sendMail($email_build);
  return $return;
}

?>