<?php
/*
  Plugin Name: Newsletter Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/advertisement-and-monetize/newsletter-osclass-plugin_i85
  Description: Send mass newsletters to your users, define target audience by different criteria.
  Version: 1.3.1
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: newsletter
  Plugin update URI: newsletter
  Support URI: https://forums.osclasspoint.com.com/newsletter-plugin/
  Product Key: 3aVxfB6ACekqc6ZUDbVw
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelNSL.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'email.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'admin/pagination.php';


function nsl_styles() {
  if(osc_get_osclass_section() == 'nsl-unsubscribe') {
    osc_enqueue_style('nsl-user-style', osc_base_url() . 'oc-content/plugins/newsletter/css/user.css?v=' . date('YmdHis'));
  }
}

osc_add_hook('header', 'nsl_styles');


osc_add_route('nsl-unsubscribe', 'newsletter/unsubscribe/([0-9]+)/(.+)', 'newsletter/unsubscribe/{userId}/{secret}', osc_plugin_folder(__FILE__).'form/unsubscribe.php', false, 'custom', 'nsl-unsubscribe', __('Unsubscribe', 'newsletter'));



// INSTALL FUNCTION - DEFINE VARIABLES
function nsl_call_after_install() {
  osc_set_preference('ignore_gdpr', 0, 'plugin-newsletter', 'INTEGER');
  osc_set_preference('mails_per_hour', 200, 'plugin-newsletter', 'INTEGER');
  osc_set_preference('test_email', '', 'plugin-newsletter', 'STRING');

  ModelNSL::newInstance()->install();
}


function nsl_call_after_uninstall() {
  ModelNSL::newInstance()->uninstall();
}



// ADMIN MENU
function nsl_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/newsletter/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/newsletter/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/newsletter/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/newsletter/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/newsletter/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/newsletter/js/bootstrap-switch.js"></script>';



  if( $title == '') { $title = __('Configure', 'newsletter'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Newsletter Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=newsletter/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'newsletter') . '</span></a></li>';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=newsletter/admin/campaign_list.php"><i class="fa fa-at"></i><span>' . __('Campaigns', 'newsletter') . '</span></a></li>';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=newsletter/admin/campaign.php"><i class="fa fa-plus-circle"></i><span>' . __('Create Campaign', 'newsletter') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function nsl_footer() {
  $pluginInfo = osc_plugin_get_info('newsletter/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="MB Themes" /> osclasspoint.com</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'newsletter') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'newsletter') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'newsletter') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function nsl_admin_menu() {
echo '<h3><a href="#">Newsletter Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'newsletter') . '</a></li>
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/campaign_list.php') . '">&raquo; ' . __('Campaigns', 'newsletter') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','nsl_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function nsl_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'nsl_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'nsl_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'nsl_call_after_uninstall');

?>