SET FOREIGN_KEY_CHECKS=0;


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_nsl_campaign;
CREATE TABLE /*TABLE_PREFIX*/t_nsl_campaign (
  pk_i_id INT NOT NULL AUTO_INCREMENT,
  s_name VARCHAR(200),
  s_subject VARCHAR(200),
  s_preview VARCHAR(500),
  s_from_name VARCHAR(200),
  s_from_email VARCHAR(200),
  s_content VARCHAR(20000),
  i_list_to INT(10),
  i_status TINYINT(1) DEFAULT 0,
  dt_create_date TIMESTAMP DEFAULT CURRENT_TIMESTAMP,

  PRIMARY KEY (pk_i_id)
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_nsl_list;
CREATE TABLE /*TABLE_PREFIX*/t_nsl_list (
  pk_i_id INT NOT NULL AUTO_INCREMENT,
  fk_i_campaign_id INT,
  fk_i_user_id INT(11),
  s_name VARCHAR(100),
  s_email VARCHAR(200),
  s_secret VARCHAR(200),
  i_status TINYINT(1) DEFAULT 0,
  i_error TINYINT(1) DEFAULT 0,
  s_comment VARCHAR(500),
  dt_send_date TIMESTAMP NULL,

  PRIMARY KEY (pk_i_id)
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_nsl_unsubscribed;
CREATE TABLE /*TABLE_PREFIX*/t_nsl_unsubscribed (
  pk_i_id INT NOT NULL AUTO_INCREMENT,
  fk_i_user_id INT(11),
  dt_date TIMESTAMP DEFAULT CURRENT_TIMESTAMP,

  PRIMARY KEY (pk_i_id)
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';



SET FOREIGN_KEY_CHECKS=1;
