<?php
  $height = (osm_param('height_item') <= 0 ? 240 : osm_param('height_item'));
  $zoom = (osm_param('zoom') <= 0 ? 13 : osm_param('zoom'));
  
  $item = osc_item();
  $img = ItemResource::newInstance()->getResource($item['pk_i_id']);

  if(isset($img['pk_i_id']) && $img['pk_i_id'] > 0) {
    $img_link = osc_base_url() . $img['s_path'] . $img['pk_i_id'] . '_thumbnail.' . $img['s_extension'];
  } else {
    $img_link = false;
  }

  
  $lat = 0;
  $lng = 0;
  
  $query = osm_query_string2($item);
  $location = implode(', ', array_filter(array(@$item['s_country'], @$item['s_region'], @$item['s_city'], @$item['s_address'])));

  if(@$item['d_coord_lat'] <> '' && @$item['d_coord_long'] <> '') {
    $lat = $item['d_coord_lat'];
    $lng = $item['d_coord_long'];
    
  } else if($query <> '') {
    $cords = osm_cords_insert($item);

    $lat = $cords['lat'];
    $lng = $cords['lng'];
  }
?>


<?php if($lat <> 0 && $lng <> 0) { ?>
  <link rel="stylesheet" href="<?php echo osc_base_url(); ?>oc-content/plugins/openstreetmaps/css/user.css" crossorigin="anonymous" />
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/leaflet/1.4.0/leaflet.css" integrity="sha256-YR4HrDE479EpYZgeTkQfgVJq08+277UXxMLbi/YP69o=" crossorigin="anonymous" />
  <script src="https://cdnjs.cloudflare.com/ajax/libs/leaflet/1.4.0/leaflet.js" integrity="sha256-6BZRSENq3kxI4YYBDqJ23xg0r1GwTHEpvp3okdaIqBw=" crossorigin="anonymous"></script>

  <?php if(osm_param('fullscreen_item') == 1) { ?>
    <script src='https://api.mapbox.com/mapbox.js/plugins/leaflet-fullscreen/v1.0.1/Leaflet.fullscreen.min.js'></script>
    <link href='https://api.mapbox.com/mapbox.js/plugins/leaflet-fullscreen/v1.0.1/leaflet.fullscreen.css' rel='stylesheet' />
  <?php } ?>

  <div id="itemMap" style="width: 100%; height:<?php echo $height; ?>px;"></div>

  <script>
    var mainIcon = L.icon({ iconUrl: '<?php echo osc_base_url(); ?>oc-content/plugins/openstreetmaps/img/icon-main.png', iconSize: [25, 41], iconAnchor: [13,41], popupAnchor: [0, -45], shadowUrl: '<?php echo osc_base_url(); ?>oc-content/plugins/openstreetmaps/img/icon-shadow.png', shadowSize: [41,41], shadowAnchor: [13,41]});

    var osmMap = L.map('itemMap'<?php if(osm_param('fullscreen_item') == 1) { ?>, {fullscreenControl:{pseudoFullscreen:true}}<?php } ?>).setView([<?php echo $lat; ?>, <?php echo $lng; ?>], <?php echo $zoom; ?>);

    var osmItemCard = '<a href="<?php echo osc_item_url(); ?>"><?php if($img_link) { ?><img src="<?php echo $img_link; ?>" /><?php } ?><strong><?php echo osc_esc_js(osc_item_title()); ?></strong><span><?php echo osc_item_formatted_price(); ?></span></a>';
    L.marker([<?php echo $lat; ?>, <?php echo $lng; ?>], {icon: mainIcon, zIndexOffset: 5}).addTo(osmMap).bindPopup(osmItemCard, {minWidth: 150,maxWidth: 150});
    L.tileLayer('https://api.mapbox.com/styles/v1/{id}/tiles/{z}/{x}/{y}?access_token=<?php echo osm_param('token'); ?>', {maxZoom: 18, id: 'mapbox/streets-v12', attribution: '&copy; <a href="https://www.mapbox.com/about/maps/">Mapbox</a> &copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a>'}).addTo(osmMap);


    <?php 
      $lats = array($lat);
      $lngs = array($lng);

      if(osm_param('rel_enable') == 1) {
        $limit = osm_param('rel_max');

        $mSearch = new Search();

        if(osm_param('rel_cat') == 1) {
          $mSearch->addCategory(osc_item_category_id());
        }

        $item_country = osc_item_country_code() <> '' ? osc_item_country_code() : osc_item_country();
        $item_region = osc_item_region_id() <> '' ? osc_item_region_id() : osc_item_region();
        $item_city = osc_item_city_id() <> '' ? osc_item_city_id() : osc_item_city();

        if($item_country <> '') {
          $mSearch->addCountry($item_country);
        }

        if($item_region <> '' && osm_param('rel_loc') >= 2) {
          $mSearch->addRegion($item_region);
        }

        if($item_city <> '' && osm_param('rel_loc') >= 3) {
          $mSearch->addCity($item_city);
        }


        $mSearch->limit(1, $limit);
        $mSearch->addItemConditions(sprintf("%st_item.pk_i_id <> %d", DB_TABLE_PREFIX, osc_item_id()));
        $mSearch->addItemConditions(sprintf("%st_item_location.d_coord_lat <> 0 AND %st_item_location.d_coord_long <> 0", DB_TABLE_PREFIX, DB_TABLE_PREFIX));

        $aItems = $mSearch->doSearch(); 


        GLOBAL $osm_items;
        $osm_items = View::newInstance()->_get('items');
        View::newInstance()->_exportVariableToView('items', $aItems); 

        while(osc_has_items()) {
          if(osc_item_latitude() <> 0 && osc_item_longitude() <> 0) {
            $lats[] = osc_item_latitude();
            $lngs[] = osc_item_longitude();
          }

          $item = osc_item();
          $img = ItemResource::newInstance()->getResource($item['pk_i_id']);

          if(isset($img['pk_i_id']) && $img['pk_i_id'] > 0) {
            $img_link = osc_base_url() . $img['s_path'] . $img['pk_i_id'] . '_thumbnail.' . $img['s_extension'];
          } else {
            $img_link = false;
          }

          ?>
            var osmItemCard = '<a href="<?php echo osc_item_url(); ?>"><?php if($img_link) { ?><img src="<?php echo $img_link; ?>" /><?php } ?><strong><?php echo osc_esc_js(osc_item_title()); ?></strong><span><?php echo osc_item_formatted_price(); ?></span></a>';
            L.marker([<?php echo osc_item_latitude(); ?>, <?php echo osc_item_longitude(); ?>]).addTo(osmMap).bindPopup(osmItemCard, {minWidth: 150,maxWidth: 150});
          <?php
        }


        GLOBAL $stored_items;
        View::newInstance()->_exportVariableToView('items', $osm_items);
      } 
    ?>

    <?php if(osm_param('rel_enable') == 1 && count($lats) > 1) { ?>
      osmMap.fitBounds([[<?php echo min($lats); ?>, <?php echo min($lngs); ?>],[<?php echo max($lats); ?>, <?php echo max($lngs); ?>]]);
    <?php } ?>
  </script>
<?php } ?>
  
	