<?php
/*
  Plugin Name: Mobile Theme Plugin
  Plugin URI: https://osclasspoint.com/
  Description: Plugin enable to use different theme on mobile and desktop
  Version: 1.1.0
  Author: OsclassPoint
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: osc_mobile
  Plugin update URI: osc_mobile
  Support URI: https://forums.osclasspoint.com/free-plugins/
  Product Key: gKtMIByCxLvGXOytRysh
*/


function load_mobile_theme( ) 
{
  
  if(Params::getParam('desktop') != '') {
    if(Params::getParam('desktop') == 1) {
      Cookie::newInstance()->push('osc-mobile-desktop', 'desktop') ;
      Cookie::newInstance()->set() ;
      if(isset($_SERVER['HTTP_REFERER'])) {
        header('Location: ' . $_SERVER['HTTP_REFERER']);
        exit;
      } 
      header('Location: ' . osc_base_url());
      exit;
    } else {
      Cookie::newInstance()->pop('osc-mobile-desktop', 'mobile') ;
      Cookie::newInstance()->set() ;
      if(isset($_SERVER['HTTP_REFERER'])) {
        header('Location: ' . $_SERVER['HTTP_REFERER']);
        exit;
      } 
      header('Location: ' . osc_base_url());
      exit;
    }
  }
  
  require_once dirname( osc_plugin_path(__FILE__) ) . '/UserAgentClass.php' ;
  $userAgent = new UserAgent() ;
  
  $desktopVersion = Cookie::newInstance()->get_value('osc-mobile-desktop');
  
  if ( $userAgent->is_mobile() && $desktopVersion != 'desktop' ) {
    WebThemes::newInstance()->setPath( dirname( osc_plugin_path(__FILE__) ) . '/themes/' ) ;
    WebThemes::newInstance()->setCurrentTheme('mobile') ;
    $functions_path = WebThemes::newInstance()->getCurrentThemePath() . 'functions.php';
    if(file_exists($functions_path)) {
      require_once $functions_path;
    }
  }
}

function show_switch() 
{
  require_once dirname( osc_plugin_path(__FILE__) ) . '/UserAgentClass.php' ;
  $userAgent = new UserAgent() ;
  
  if ( $userAgent->is_mobile() ) {
    $url = osc_base_url(true).'?desktop=mobile'; 
    echo '<a href="'.$url.'" data-role="none" class="ui-link">'. __('Switch to Mobile version','mobile').'</a>';
  }   
}  

// This is needed in order to be able to activate the plugin
osc_register_plugin(osc_plugin_path(__FILE__), '') ;
// This is a hack to show a Uninstall link at plugins table (you could also use some other hook to show a custom option panel)
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', '') ;

osc_add_hook('before_html', 'load_mobile_theme') ;

?>