<?php
/*
  Plugin Name: Piwik Web Analytics Plugin
  Plugin URI: https://osclasspoint.com/
  Description: Enable Piwik web analytics in Osclass
  Version: 1.1.0
  Author: OsclassPoint
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: piwik
  Plugin update URI: piwik
  Support URI: https://forums.osclasspoint.com/free-plugins/
  Product Key: FPTeGnz8PxBhqC86O2a8
*/

function piwik_install() {
  osc_set_preference('js_code', '', 'piwik', 'STRING');
}

function piwik_uninstall() {
  osc_delete_preference('js_code', 'piwik');
}

function piwik_footer() {
  echo osc_get_preference('js_code', 'piwik');
}

function piwik_admin_menu() {
  osc_add_admin_submenu_divider('plugins', __('Piwik Analytics', 'piwik'), 'piwik_divider', 'administrator');
  osc_add_admin_submenu_page('plugins', __('Settings', 'piwik'), osc_route_admin_url('piwik-conf'), 'piwik_conf', 'administrator');
}

osc_add_route('piwik-conf', 'piwik/help', 'piwik/help', osc_plugin_folder(__FILE__).'admin/conf.php');

/**
 * ADD HOOKS
 */
osc_register_plugin(osc_plugin_path(__FILE__), 'piwik_install');
osc_add_hook(osc_plugin_path(__FILE__)."_uninstall", 'piwik_uninstall');

osc_add_hook('admin_menu_init', 'piwik_admin_menu');
osc_add_hook('footer', 'piwik_footer');
?>