SET FOREIGN_KEY_CHECKS=0;


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_poll;
CREATE TABLE /*TABLE_PREFIX*/t_poll (
  pk_i_id INT NOT NULL AUTO_INCREMENT,
  b_active TINYINT(1) DEFAULT 0,
  s_pages VARCHAR(1000) DEFAULT 'all',
  s_type VARCHAR(20) DEFAULT 'RADIO-HORIZONTAL',
  s_position VARCHAR(20) DEFAULT 'BOTTOM-LEFT',

  PRIMARY KEY (pk_i_id)
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_poll_value;
CREATE TABLE /*TABLE_PREFIX*/t_poll_value (
  pk_i_id INT NOT NULL AUTO_INCREMENT,
  fk_i_poll_id INT NOT NULL,
  i_order INT(10) DEFAULT 1,

  PRIMARY KEY (pk_i_id),
  FOREIGN KEY (fk_i_poll_id) REFERENCES /*TABLE_PREFIX*/t_poll (pk_i_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_poll_locale;
CREATE TABLE /*TABLE_PREFIX*/t_poll_locale (
  pk_i_id INT NOT NULL AUTO_INCREMENT,
  fk_i_poll_id INT NOT NULL,
  fk_c_locale_code CHAR(5) NOT NULL,
  s_name VARCHAR(200) NULL,
  s_description VARCHAR(500) NULL,
  s_successful VARCHAR(500) NULL,

  PRIMARY KEY (pk_i_id),
  FOREIGN KEY (fk_i_poll_id) REFERENCES /*TABLE_PREFIX*/t_poll (pk_i_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_poll_value_locale;
CREATE TABLE /*TABLE_PREFIX*/t_poll_value_locale (
  pk_i_id INT NOT NULL AUTO_INCREMENT,
  fk_i_poll_value_id INT NOT NULL,
  fk_c_locale_code CHAR(5) NOT NULL,
  s_name VARCHAR(200) NULL,
  s_description VARCHAR(500) NULL,

  PRIMARY KEY (pk_i_id),
  FOREIGN KEY (fk_i_poll_value_id) REFERENCES /*TABLE_PREFIX*/t_poll_value (pk_i_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_poll_result;
CREATE TABLE /*TABLE_PREFIX*/t_poll_result (
  pk_i_id INT NOT NULL AUTO_INCREMENT,
  i_user_id INT(11) DEFAULT NULL,
  i_cookie_id VARCHAR(20) DEFAULT NULL,
  fk_i_poll_id INT NOT NULL,
  fk_i_poll_value_id INT NOT NULL,
  dt_date TIMESTAMP DEFAULT CURRENT_TIMESTAMP,

  PRIMARY KEY (pk_i_id),
  FOREIGN KEY (fk_i_poll_id) REFERENCES /*TABLE_PREFIX*/t_poll (pk_i_id) ON DELETE CASCADE ON UPDATE CASCADE,
  FOREIGN KEY (fk_i_poll_value_id) REFERENCES /*TABLE_PREFIX*/t_poll_value (pk_i_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';


SET FOREIGN_KEY_CHECKS=1;
