<?php
  // Create menu
  $title = __('Configure', 'push');
  psh_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

   $enable = mb_param_update('enable', 'plugin_action', 'check', 'plugin-push');
   $hook = mb_param_update('hook', 'plugin_action', 'value', 'plugin-push');
   $home = mb_param_update('home', 'plugin_action', 'check', 'plugin-push');
   $item = mb_param_update('item', 'plugin_action', 'check', 'plugin-push');
   $search = mb_param_update('search', 'plugin_action', 'check', 'plugin-push');
   $contact = mb_param_update('contact', 'plugin_action', 'check', 'plugin-push');
   $app_id = mb_param_update('app_id', 'plugin_action', 'value', 'plugin-push');


  if(Params::getParam('plugin_action') == 'done') {
    message_ok(__('Settings were successfully saved', 'push'));
  }

?>



<div class="mb-body">
  <div class="mb-notes">
    <div class="mb-line"><?php _e('This plugin use OneSignal.com services, please register on', 'push'); ?> <a target="_blank" href="https://onesignal.com/">https://onesignal.com</a></div>
  </div>

  <!-- CONFIGURATION SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-wrench"></i> <?php _e('Configuration', 'push'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" id="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />


        <div class="mb-row">
          <label for="enable" class="h1"><span><?php _e('Enable Push Notifications', 'push'); ?></span></label> 
          <input name="enable" id="enable" class="element-slide" type="checkbox" <?php echo ($enable == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, visitors will be prompted to allow push messages on their devices.', 'push'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="hook" class="h1"><span><?php _e('Tracking Code Placement', 'push'); ?></span></label> 
          <select name="hook">
            <option value="header" <?php echo ($hook == 'header' ? 'selected="selected"' : ''); ?>><?php _e('Head (recommended)', 'push'); ?></option>
            <option value="footer" <?php echo ($hook == 'footer' ? 'selected="selected"' : ''); ?>><?php _e('Footer', 'push'); ?></option>
          </select>
          
          <div class="mb-explain"><?php _e('Choose where to place small code snippet, recommended is to put it into head but for speed optimization you may want to move javascript into footer.', 'push'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="home" class="h1"><span><?php _e('Prompt on Home Page', 'push'); ?></span></label> 
          <input name="home" id="home" class="element-slide" type="checkbox" <?php echo ($home == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, visitors will get push notifications prompt on home page.', 'push'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="item" class="h1"><span><?php _e('Prompt on Listing Page', 'push'); ?></span></label> 
          <input name="item" id="item" class="element-slide" type="checkbox" <?php echo ($item == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, visitors will get push notifications prompt on listing page.', 'push'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="search" class="h1"><span><?php _e('Prompt on Search Page', 'push'); ?></span></label> 
          <input name="search" id="search" class="element-slide" type="checkbox" <?php echo ($search == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, visitors will get push notifications prompt on search page.', 'push'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="contact" class="h1"><span><?php _e('Prompt on Contact Page', 'push'); ?></span></label> 
          <input name="contact" id="contact" class="element-slide" type="checkbox" <?php echo ($contact == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, visitors will get push notifications prompt on contact page.', 'push'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="app_id" class="h1"><span><?php _e('OneSignal App ID', 'push'); ?></span></label> 
          <input name="app_id" id="app_id" type="password" size="100" autocomplete="new-pass" value="<?php echo $app_id; ?>" />
          
          <div class="mb-explain"><?php _e('Enter OneSignal.com App ID (can be found at Settings > Keys & IDs).', 'push'); ?></div>
        </div>
        

        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(psh_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'push')); ?>"><?php _e('Save', 'push');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'push');?></button>
          <?php } ?>
        </div>

      </form>
    </div>
  </div>
  
  

  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'push'); ?></div>

    <div class="mb-inside">

      <div class="mb-row"><?php _e('For correct functionality and statistics, follow these 3 simple steps', 'push'); ?>:</div>
      <div class="mb-row">
        <strong>1.</strong> Download & unzip following archive:<br/>
        <a href="https://github.com/OneSignal/OneSignal-Website-SDK/releases/download/https-integration-files/OneSignal-Web-SDK-HTTPS-Integration-Files.zip">https://github.com/OneSignal/OneSignal-Website-SDK/releases/download/https-integration-files/OneSignal-Web-SDK-HTTPS-Integration-Files.zip</a>
      </div>
      
      <div class="mb-row">
        <strong>2.</strong> There should be 2 files: OneSignalSDKWorker.js and OneSignalSDKUpdaterWorker.js, upload these files to your osclass root directory (<?php echo osc_base_url(); ?>)
      </div>
      
      <div class="mb-row">
        <strong>3.</strong> Everything is setup, make sure files are publicly accessible:
        <br/><?php echo osc_base_url(); ?>OneSignalSDKWorker.js
        <br/><?php echo osc_base_url(); ?>OneSignalSDKUpdaterWorker.js
      </div>
    </div>
  </div>

</div>


<?php echo psh_footer(); ?>