<?php
/*
  Plugin Name: Push Notifications Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/advertisement-and-monetize/push-notifications-osclass-plugin_i109
  Description: Web and Mobile push notifications to more engage your visitors
  Version: 1.1.0
  Author: OsclassPoint
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: push
  Plugin update URI: push
  Support URI: https://forums.osclasspoint.com/
  Product Key: 7wMRIzqJbL8LIILv56Fu
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelPSH.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';

//osc_enqueue_style('font-awesome47', '//maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css');
//osc_enqueue_style('tipped', osc_base_url() . 'oc-content/plugins/push/css/tipped.css');
//osc_register_script('tipped', osc_base_url() . 'oc-content/plugins/push/js/tipped.js', array('jquery'));
//osc_enqueue_script('tipped');


// ROUTES
osc_add_route('psh-admin-edit', 'push/admin/edit/([0-9]+)', 'osclasspay/admin/edit/{pushId}', osc_plugin_folder(__FILE__).'admin/configure.php');
osc_add_route('psh-admin-delete', 'push/admin/delete/([0-9]+)', 'osclasspay/admin/delete/{pushDeleteId}', osc_plugin_folder(__FILE__).'admin/configure.php');


// INSTALL FUNCTION - DEFINE VARIABLES
function psh_call_after_install() {
  osc_set_preference('enable', 0, 'plugin-push', 'INTEGER');
  osc_set_preference('hook', 'header', 'plugin-push', 'STRING');

  //ModelPSH::newInstance()->install();
}


function psh_call_after_uninstall() {
  ModelPSH::newInstance()->uninstall();
}



// ADMIN MENU
function psh_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/push/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/push/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/push/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="//fonts.googleapis.com/css?family=Open+Sans:300,600&amp;subset=latin,latin-ext" rel="stylesheet" type="text/css" />';
  echo '<link href="//maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/push/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/push/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/push/js/bootstrap-switch.js"></script>';



  if( $title == '') { $title = __('Configure', 'push'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Push Notifications Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=push/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'push') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function psh_footer() {
  $pluginInfo = osc_plugin_get_info('push/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint.com" /> OsclassPoint.com</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'push') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'push') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'push') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function psh_admin_menu() {
echo '<h3><a href="#">Push Notification Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'push') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','psh_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function psh_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'psh_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'psh_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'psh_call_after_uninstall');

?>