<?php
  // Create menu
  $title = __('Configure', 'pwa');
  pwa_menu($title);
 

  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value
  $mode = pwa_param_update('mode', 'plugin_action', 'value', 'plugin-pwa');
  $debug = pwa_param_update('debug', 'plugin_action', 'check', 'plugin-pwa');
  $meta_tags = pwa_param_update('meta_tags', 'plugin_action', 'check', 'plugin-pwa');
  $hook_manifest = pwa_param_update('hook_manifest', 'plugin_action', 'check', 'plugin-pwa');
  $hook_worker = pwa_param_update('hook_worker', 'plugin_action', 'check', 'plugin-pwa');
  $add_schema = pwa_param_update('add_schema', 'plugin_action', 'check', 'plugin-pwa');
  $offline_image = pwa_param_update('offline_image', 'plugin_action', 'value', 'plugin-pwa');
  $favicon_ico = pwa_param_update('favicon_ico', 'plugin_action', 'value', 'plugin-pwa');
  $favicon_16 = pwa_param_update('favicon_16', 'plugin_action', 'value', 'plugin-pwa');
  $favicon_32 = pwa_param_update('favicon_32', 'plugin_action', 'value', 'plugin-pwa');
  $mask_icon = pwa_param_update('mask_icon', 'plugin_action', 'value', 'plugin-pwa');
  $apple_icon = pwa_param_update('apple_icon', 'plugin_action', 'value', 'plugin-pwa');

  
  if(Params::getParam('plugin_action') == 'done') {
    message_ok(__('Settings were successfully saved', 'pwa'));
  }
?>


<div class="mb-body">
  <!-- CONFIGURE SECTION -->

  <div class="mb-notes">
    <div class="mb-line"><?php _e('Key parts of the Progressive Web Apps platform, such as Service Workers, require using HTTPS. When your PWA goes live, you must publish it to an HTTPS URL. Many hosts now offer HTTPS by default, but if your host doesn\'t, Let\'s Encrypt offers a free alternative for creating the necessary certificates.', 'pwa'); ?></a></div>
    <div class="mb-line"><?php echo sprintf(__('If your PWA setup is complete, you can use %s to generate app file for Microsoft Store, Google Play Store and iOS App Store if you would like to upload your app here.', 'pwa'), '<a href="https://www.pwabuilder.com/" target="_blank">PWA Builder</a>'); ?></a></div>
  </div>
        
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-wrench"></i> <?php _e('Configure', 'pwa'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />

       
        <div class="mb-row">
          <label for="mode"><span><?php _e('Mode', 'pwa'); ?></span></label> 
          <select name="mode">
            <option value="ADVANCED" <?php if($mode == 'ADVANCED' || $mode == '') { ?>selected="selected"<?php } ?>><?php _e('Advanced', 'pwa'); ?></option>
            <option value="BASIC" <?php if($mode == 'BASIC') { ?>selected="selected"<?php } ?>><?php _e('Basic (simplified)', 'pwa'); ?></option>
          </select>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Basic mode will hide advanced manifest parameters.', 'pwa'); ?></div>
          </div>
        </div>


        <div class="mb-row">
          <label for="debug"><span><?php _e('Debug Mode', 'pwa'); ?></span></label> 
          <input name="debug" id="debug" type="checkbox" class="element-slide" <?php echo ($debug == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, service workers and other parts of plugin will report different information to console. When changed, workers must be refreshed to take effect.', 'pwa'); ?></div>
          </div>
        </div>
        
        
        <div class="mb-row">
          <label for="meta_tags"><span><?php _e('Generate Extra Meta Tags', 'pwa'); ?></span></label> 
          <input name="meta_tags" id="meta_tags" type="checkbox" class="element-slide" <?php echo ($meta_tags == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, extra meta tags like theme-color will be generated based on manifest settings and added to head.', 'pwa'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="hook_manifest"><span><?php _e('Hook Manifest to Head', 'pwa'); ?></span></label> 
          <input name="hook_manifest" id="hook_manifest" type="checkbox" class="element-slide" <?php echo ($hook_manifest == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, manifest.webmanifest will be automatically added to head.', 'pwa'); ?></div>
            <div class="mb-line"><?php _e('<b>WARNING:</b> Make sure you already does not have manifest.webmanifest added by theme in head.', 'pwa'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="hook_worker"><span><?php _e('Hook Service Worker to Head', 'pwa'); ?></span></label> 
          <input name="hook_worker" id="hook_worker" type="checkbox" class="element-slide" <?php echo ($hook_worker == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, pwa-service-worker.js will be automatically added to head.', 'pwa'); ?></div>
          </div>
        </div>
        
       
        <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=pwa/admin/manifest.php&generate=1" class="mb-button-blue mb-add"><i class="fa fa-file-text-o"></i><?php _e('Generate manifest.webmanifest', 'pwa'); ?></a>
        <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=pwa/admin/worker.php&generate=1" style="margin-left:8px;" class="mb-button-blue mb-add"><i class="fa fa-gears"></i><?php _e('Generate service workers and offline page', 'pwa'); ?></a>


        <div class="mb-row">&nbsp;</div>

        <div class="mb-subtitle" style="padding-left:25%;"><?php _e('Additional settings', 'pwa'); ?></div>
        
        <div class="mb-row">
          <label for="offline_image"><span><?php _e('Offline Page Logo (PWA)', 'pwa'); ?></span></label> 
          <div class="mb-relative">
            <input type="text" name="offline_image" id="offline_image" size="80" value="<?php echo osc_esc_html($offline_image); ?>" placeholder="https://domain.com/icon.png"/>
            <?php pwa_select_icons(); ?>  
          </div>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Select logo/image on offline page, in case you do not want to use default icon.', 'pwa'); ?></div>
          </div>
        </div>
        

        <div class="mb-row">
          <label for="favicon_ico"><span><?php _e('Favicon (ICO)', 'pwa'); ?></span></label> 
          <div class="mb-relative">
            <input type="text" name="favicon_ico" id="favicon_ico" size="80" value="<?php echo osc_esc_html($favicon_ico); ?>" placeholder="https://domain.com/icon.png"/>
            <?php pwa_select_icons(); ?>  
          </div>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Use only in case your theme does not have it, or you have removed it from theme head.php. "Generate Extra Meta Tags" must be enabled.', 'pwa'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="favicon_16"><span><?php _e('Favicon (16x16)', 'pwa'); ?></span></label> 
          <div class="mb-relative">
            <input type="text" name="favicon_16" id="favicon_16" size="80" value="<?php echo osc_esc_html($favicon_16); ?>" placeholder="https://domain.com/icon.png"/>
            <?php pwa_select_icons(); ?>  
          </div>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Use only in case your theme does not have it, or you have removed it from theme head.php. "Generate Extra Meta Tags" must be enabled.', 'pwa'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="favicon_32"><span><?php _e('Favicon (32x32)', 'pwa'); ?></span></label> 
          <div class="mb-relative">
            <input type="text" name="favicon_32" id="favicon_32" size="80" value="<?php echo osc_esc_html($favicon_32); ?>" placeholder="https://domain.com/icon.png"/>
            <?php pwa_select_icons(); ?>  
          </div>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Use only in case your theme does not have it, or you have removed it from theme head.php. "Generate Extra Meta Tags" must be enabled.', 'pwa'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="mask_icon"><span><?php _e('Mask Icon (SVG, for Safari)', 'pwa'); ?></span></label> 
          <div class="mb-relative">
            <input type="text" name="mask_icon" id="mask_icon" size="80" value="<?php echo osc_esc_html($mask_icon); ?>" placeholder="https://domain.com/icon.png"/>
            <?php pwa_select_icons(); ?>  
          </div>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Use only in case your theme does not have it, or you have removed it from theme head.php. "Generate Extra Meta Tags" must be enabled.', 'pwa'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="apple_icon"><span><?php _e('Apple Touch Icon (180x180)', 'pwa'); ?></span></label> 
          <div class="mb-relative">
            <input type="text" name="apple_icon" id="apple_icon" size="80" value="<?php echo osc_esc_html($apple_icon); ?>" placeholder="https://domain.com/icon.png"/>
            <?php pwa_select_icons(); ?>  
          </div>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Use only in case your theme does not have it, or you have removed it from theme head.php. "Generate Extra Meta Tags" must be enabled.', 'pwa'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(pwa_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'pwa')); ?>"><?php _e('Save', 'pwa');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'pwa');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>



  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'pwa'); ?></div>

    <div class="mb-inside">
      <div class="mb-row"><?php _e('No theme modification are required to use all functions of plugin.', 'pwa'); ?></div>
    </div>
  </div>
</div>


<?php echo pwa_footer(); ?>