<?php
  // Create menu
  $title = __('Generate manifest', 'pwa');
  pwa_menu($title);
 

  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  $name = pwa_param_update('name', 'plugin_action', 'value', 'plugin-pwa');
  $short_name = pwa_param_update('short_name', 'plugin_action', 'value', 'plugin-pwa');
  $description = pwa_param_update('description', 'plugin_action', 'value', 'plugin-pwa');
  $display = pwa_param_update('display', 'plugin_action', 'value', 'plugin-pwa');
  $display_override = pwa_param_update('display_override', 'plugin_action', 'value', 'plugin-pwa');
  $orientation = pwa_param_update('orientation', 'plugin_action', 'value', 'plugin-pwa');
  $scope = pwa_param_update('scope', 'plugin_action', 'value', 'plugin-pwa');
  $start_url = pwa_param_update('start_url', 'plugin_action', 'value', 'plugin-pwa');
  $dir = pwa_param_update('dir', 'plugin_action', 'value', 'plugin-pwa');
  $lang = pwa_param_update('lang', 'plugin_action', 'value', 'plugin-pwa');
  $background_color = pwa_param_update('background_color', 'plugin_action', 'value', 'plugin-pwa');
  $theme_color = pwa_param_update('theme_color', 'plugin_action', 'value', 'plugin-pwa');
  $prefer_related_applications = pwa_param_update('prefer_related_applications', 'plugin_action', 'check', 'plugin-pwa');
  $categories = pwa_param_update('categories', 'plugin_action', 'value', 'plugin-pwa');
  $iarc_rating_id = pwa_param_update('iarc_rating_id', 'plugin_action', 'value', 'plugin-pwa');

  $icons = pwa_param_update('icons', 'plugin_action', 'array', 'plugin-pwa');
  $shortcuts = pwa_param_update('shortcuts', 'plugin_action', 'array', 'plugin-pwa');
  $apps = pwa_param_update('apps', 'plugin_action', 'array', 'plugin-pwa');
  $screenshots = pwa_param_update('screenshots', 'plugin_action', 'array', 'plugin-pwa');



  if(Params::getParam('generate') == '1') {
    $res = pwa_generate_manifest();
    
    if($res) {
      osc_add_flash_ok_message(sprintf(__('Manifest has been successfully generated. Link: %s', 'pwa'), '<a target="_blank" href="' . osc_base_url() . 'manifest.webmanifest">' . osc_base_url() . 'manifest.webmanifest</a>'), 'admin');
    } else {
      osc_add_flash_error_message(sprintf(__('There was problem saving manifest.webmanifest file into root directory (may be permission issue). Path: %s', 'pwa'), osc_base_path() . 'manifest.webmanifest'), 'admin');
    }

    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=pwa/admin/manifest.php');
    exit;
  }
  
  if(Params::getParam('plugin_action') == 'done') {
    message_ok(__('Settings were successfully saved', 'pwa'));
  }
  
  $generators_list = 'https://favicon-generator.org,https://appicon.co,https://realfavicongenerator.net';
  
  $generators_list = explode(',', $generators_list);
  $generators = '';
  
  foreach($generators_list as $gl) {
    $generators .= '<a href="' . $gl . '" target="_blank">' . str_replace('https://', '', $gl) . '</a>, ';
  }
?>

<?php if(pwa_param('mode') == 'BASIC') { ?><style>.mb-advanced {display:none!important;}</style><?php } ?>

<div class="mb-body">
  <!-- MANIFEST SECTION -->

  <div class="mb-notes">
    <div class="mb-line"><?php _e('The web app manifest is a JSON file that tells the browser about your Progressive Web App and how it should behave when installed on the user\'s desktop or mobile device. A typical manifest file includes the app name, the icons the app should use, and the URL that should be opened when the app is launched.', 'pwa'); ?></div>
    <div class="mb-line"><?php echo sprintf(__('You can %s before you start to setup manifest file. List of services where you can generate icons (there is much more of them): %s.', 'pwa'), '<a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=pwa/admin/upload.php">' . __('Upload icons & screenshots', 'pwa') . '</a>', $generators); ?></div>

    <?php if(pwa_param('mode') == 'BASIC') { ?>
      <div class="mb-line"><?php _e('Basic mode of plugin enabled - advanced parameters of manifest are hidden.', 'pwa'); ?></div>
    <?php } else { ?>
      <div class="mb-line"><?php _e('Advanced mode of plugin enabled - all parameters are available.', 'pwa'); ?></div>
    <?php } ?>
  </div>


  <div class="mb-box mb-manifest">
    <div class="mb-head">
      <i class="fa fa-file-text-o"></i> <?php _e('Manifest.webmanifest configuration', 'pwa'); ?>
      
      <a class="mb-btn mb-button-blue" href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=pwa/admin/manifest.php&generate=1"><i class="fa fa-refresh"></i><?php _e('Generate manifest.webmanifest', 'pwa'); ?></a>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>manifest.php" />
        <input type="hidden" name="plugin_action" value="done" />

        
        <div class="mb-row">
          <label for="name"><span><?php _e('Name', 'pwa'); ?></span></label> 
          <input required name="name" id="name" size="50" type="text" value="<?php echo osc_esc_html($name); ?>" />
          
          <div class="mb-explain"><?php _e('Name of the web application as it is usually displayed to the user (e.g., amongst a list of other applications, or as a label for an icon).', 'pwa'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="short_name"><span><?php _e('Short Name', 'pwa'); ?></span></label> 
          <input name="short_name" id="short_name" size="30" type="text" value="<?php echo osc_esc_html($short_name); ?>" />
          
          <div class="mb-explain"><?php _e('Name of the web application displayed to the user if there is not enough space to display name (e.g., as a label for an icon on the phone home screen).', 'pwa'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="description"><span><?php _e('Description', 'pwa'); ?></span></label> 
          <input name="description" id="description" size="100" type="text" value="<?php echo osc_esc_html($description); ?>" />
          
          <div class="mb-explain"><?php _e('Description should explain or describe what application does and what is its primary purpose.', 'pwa'); ?></div>
        </div>
        
        <div class="mb-row">
          <label for="display"><span><?php _e('Display', 'pwa'); ?></span></label> 
          <select name="display">
            <option value="standalone" <?php if($display == 'standalone' || $display == '') { ?>selected="selected"<?php } ?>><?php _e('Standalone (An app-like experience, no browser UI, only system UI)', 'pwa'); ?></option>
            <option value="fullscreen" <?php if($display == 'fullscreen') { ?>selected="selected"<?php } ?>><?php _e('Fullscreen (No browser or system UI shown)', 'pwa'); ?></option>
            <option value="minimalui" <?php if($display == 'minimalui') { ?>selected="selected"<?php } ?>><?php _e('Miminal UI', 'pwa'); ?></option>
            <option value="browser" <?php if($display == 'browser') { ?>selected="selected"<?php } ?>><?php _e('Browser', 'pwa'); ?></option>
          </select>
          
          <div class="mb-explain">
            <div class="mb-line"><strong><?php _e('Standalone', 'pwa'); ?>:</strong> <?php _e('The application will look and feel like a standalone application. This can include the application having a different window, its own icon in the application launcher, etc. In this mode, the user agent will exclude UI elements for controlling navigation, but can include other UI elements such as a status bar.', 'pwa'); ?></div>
            <div class="mb-line"><strong><?php _e('Fullscreen', 'pwa'); ?>:</strong> <?php _e('All of the available display area is used and no user agent chrome is shown.', 'pwa'); ?></div>
            <div class="mb-line"><strong><?php _e('Minimal UI', 'pwa'); ?>:</strong> <?php _e('The application will look and feel like a standalone application, but will have a minimal set of UI elements for controlling navigation. The elements will vary by browser.', 'pwa'); ?></div>
            <div class="mb-line"><strong><?php _e('Browser', 'pwa'); ?>:</strong> <?php _e('The application opens in a conventional browser tab or new window, depending on the browser and platform. This is the default.	', 'pwa'); ?></div>
          </div>
        </div>

        <div class="mb-row mb-advanced">
          <label for="display_override"><span><?php _e('Display Override', 'pwa'); ?></span></label> 
          <input name="display_override" id="display_override" size="80" type="text" value="<?php echo osc_esc_html($display_override); ?>" />
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('The display member is used to determine the developer\'s preferred display mode for a website. It follows a process where the browser falls back to the next display mode if the requested one is not supported. In some advanced use cases, this fallback process might not be enough..', 'pwa'); ?></div>
            <div class="mb-line"><?php _e('The display_override member solves this by letting the developer provide a sequence of display modes that the browser will consider before using the display member. Its value is an array of display modes that are considered in-order, and the first supported display mode is applied..', 'pwa'); ?></div>
            <div class="mb-line"><?php _e('Examples: ["window-control-overlay", "minimal-ui"], ["fullscreen", "minimal-ui"]', 'pwa'); ?></div>
          </div>   
        </div>


        <div class="mb-row mb-advanced">
          <label for="orientation"><span><?php _e('Orientation', 'pwa'); ?></span></label> 
          <select name="orientation">
            <option value="" <?php if($orientation == '') { ?>selected="selected"<?php } ?>><?php _e('Not set (default)', 'pwa'); ?></option>
            <option value="any" <?php if($orientation == 'any') { ?>selected="selected"<?php } ?>><?php _e('Any', 'pwa'); ?></option>
            <option value="natural" <?php if($orientation == 'natural') { ?>selected="selected"<?php } ?>><?php _e('Natural', 'pwa'); ?></option>
            <option value="landscape" <?php if($orientation == 'landscape') { ?>selected="selected"<?php } ?>><?php _e('Landscape', 'pwa'); ?></option>
            <option value="landscape-primary" <?php if($orientation == 'landscape-primary') { ?>selected="selected"<?php } ?>><?php _e('Landscape (Primary)', 'pwa'); ?></option>
            <option value="landscape-secondary" <?php if($orientation == 'landscape-secondary') { ?>selected="selected"<?php } ?>><?php _e('Landscape (Secondary)', 'pwa'); ?></option>
            <option value="portrait" <?php if($orientation == 'portrait') { ?>selected="selected"<?php } ?>><?php _e('Portrait', 'pwa'); ?></option>
            <option value="portrait-primary" <?php if($orientation == 'portrait-primary') { ?>selected="selected"<?php } ?>><?php _e('Portrait (Primary)', 'pwa'); ?></option>
            <option value="portrait-secondary" <?php if($orientation == 'portrait-secondary') { ?>selected="selected"<?php } ?>><?php _e('Portrait (Secondary)', 'pwa'); ?></option>
          </select>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Defines the default orientation for all the website\'s top-level browsing contexts.', 'pwa'); ?></div>
          </div>
        </div>        
        
        <div class="mb-row">
          <label for="scope"><span><?php _e('Application Scope', 'pwa'); ?></span></label> 
          <input name="scope" id="scope" size="30" type="text" value="<?php echo osc_esc_html($scope); ?>" />
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Defines the navigation scope of this web application\'s application context. It restricts what web pages can be viewed while the manifest is applied. If the user navigates outside the scope, it reverts to a normal web page inside a browser tab or window.', 'pwa'); ?></div>
            <div class="mb-line"><?php _e('If the scope is relative, the manifest URL is used as a base URL.', 'pwa'); ?></div>
            <div class="mb-line"><?php _e('Examples: /, /app/, https://example.com/, https://example.com/subdirectory/', 'pwa'); ?></div>
          </div>        
        </div>        
        
        <div class="mb-row">
          <label for="start_url"><span><?php _e('Start URL', 'pwa'); ?></span></label> 
          <input name="start_url" id="start_url" size="60" type="text" value="<?php echo osc_esc_html($start_url); ?>" />
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Represents the start URL of the web application — the preferred URL that should be loaded when the user launches the web application (e.g., when the user taps on the web application\'s icon from a device\'s application menu or homescreen).', 'pwa'); ?></div>
            <div class="mb-line"><?php _e('Start URL is purely advisory, and a user agent may ignore it or allow the user to alter it at install time or afterwards..', 'pwa'); ?></div>
            <div class="mb-line"><?php _e('Examples: https://example.com, ../startpoint.html, /?source=pwa', 'pwa'); ?></div>
          </div>        
        </div>          
        
        <div class="mb-row mb-advanced">
          <label for="dir"><span><?php _e('Text Direction', 'pwa'); ?></span></label> 
          <select name="dir">
            <option value="" <?php if($dir == '') { ?>selected="selected"<?php } ?>><?php _e('Not selected (default)', 'pwa'); ?></option>
            <option value="auto" <?php if($dir == 'auto') { ?>selected="selected"<?php } ?>><?php _e('Auto', 'pwa'); ?></option>
            <option value="ltr" <?php if($dir == 'ltr') { ?>selected="selected"<?php } ?>><?php _e('Left to Right', 'pwa'); ?></option>
            <option value="rtl" <?php if($dir == 'rtl') { ?>selected="selected"<?php } ?>><?php _e('Right to Left', 'pwa'); ?></option>
          </select>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('The base direction in which to display direction-capable members of the manifest. Together with the language attribute, it helps to correctly display right-to-left languages.', 'pwa'); ?></div>
          </div>
        </div>

        <div class="mb-row mb-advanced">
          <label for="lang"><span><?php _e('Language', 'pwa'); ?></span></label> 
          <input name="lang" id="lang" size="20" type="text" value="<?php echo osc_esc_html($lang); ?>" />
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('It specifies the primary language for the values of the manifest\'s directionality-capable members, and together with text direction determines their directionality.', 'pwa'); ?></div>
            <div class="mb-line"><?php _e('Examples: en, ar, sa, sk, cz, fr-CA, en-US, en-AU.', 'pwa'); ?></div>
          </div>        
        </div>    

        <div class="mb-row mb-color-box">
          <label for="background_color"><span><?php _e('Background Color', 'pwa'); ?></span></label> 
      
          <input name="background_color" id="background_color" size="20" type="text" value="<?php echo osc_esc_html($background_color); ?>" />
          <span class="color-wrap">
            <input name="color-picker" id="" type="color" value="<?php echo osc_esc_html($background_color); ?>" />
          </span>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Placeholder background color for the application page to display before its stylesheet is loaded. This value is used by the user agent to draw the background color of a shortcut when the manifest is available before the stylesheet has loaded.', 'pwa'); ?></div>
            <div class="mb-line"><?php _e('Enter color in HEX format or select color with picker. Example: #0d9ecc. Keep blank to use default color.', 'pwa'); ?></div>
          </div>        
        </div>        


        <div class="mb-row mb-color-box">
          <label for="theme_color"><span><?php _e('Theme Color', 'pwa'); ?></span></label> 
      
          <input name="theme_color" id="theme_color" size="20" type="text" value="<?php echo osc_esc_html($theme_color); ?>" />
          <span class="color-wrap">
            <input name="color-picker" id="" type="color" value="<?php echo osc_esc_html($theme_color); ?>" />
          </span>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Defines the default theme color for the application. This sometimes affects how the OS displays the site (e.g., on Android\'s task switcher, the theme color surrounds the site).', 'pwa'); ?></div>
            <div class="mb-line"><?php _e('Enter color in HEX format or select color with picker. Example: #0d9ecc. Keep blank to use default color.', 'pwa'); ?></div>
          </div>    
        </div>

        <div class="mb-row mb-advanced">
          <label for="categories"><span><?php _e('Categories', 'pwa'); ?></span></label> 
          <input name="categories" id="categories" size="100" type="text" value="<?php echo osc_esc_html($categories); ?>" />
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Define the names of categories that the application supposedly belongs to. There is no standard list of possible values, but the W3C maintains a list of known categories.', 'pwa'); ?></div>
            <div class="mb-line"><?php _e('Examples: "social", ["books", "education", "medical"].', 'pwa'); ?></div>
            <div class="mb-line"><?php _e('List of know categories:', 'pwa'); ?> "books", "business", "education", "entertainment", "finance", "fitness", "food", "games", "government", "health", "kids", "lifestyle", "magazines", "medical", "music", "navigation", "news", "personalization", "photo", "politics", "productivity", "security", "shopping", "social", "sports", "travel", "utilities", "weather"</div>
          </div>        
        </div>    
        
        <div class="mb-row mb-advanced">
          <label for="iarc_rating_id"><span><?php _e('International Age Rating Coalition (IARC)', 'pwa'); ?></span></label> 
          <input name="iarc_rating_id" id="iarc_rating_id" size="50" type="text" value="<?php echo osc_esc_html($iarc_rating_id); ?>" />
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Represents the International Age Rating Coalition (IARC) certification code of the web application. It is intended to be used to determine which ages the web application is appropriate for.', 'pwa'); ?></div>
            <div class="mb-line"><?php _e('Example: e84b072d-71b3-4d3e-86ae-31a8ce4e53b7', 'pwa'); ?></div>
          </div>        
        </div>   



        <div class="mb-subtitle"><?php _e('Icons', 'pwa'); ?></div>
        <div class="mb-notes mb-small">
          <div class="mb-line"><?php _e('Select image files that can serve as application icons for different contexts. For example, they can be used to represent the web application amongst a list of other applications, or to integrate the web application with an OS\'s task switcher and/or system preferences.', 'pwa'); ?></div>
        </div>
        
        <div class="mb-line mb-icons mb-spec mb-hd">
          <strong class="mb-src"><?php _e('Source', 'pwa'); ?></strong>
          <strong class="mb-sizes"><?php _e('Sizes', 'pwa'); ?></strong>
          <strong class="mb-type"><?php _e('Type', 'pwa'); ?></strong>
          <strong class="mb-purpose mb-advanced"><?php _e('Purpose', 'pwa'); ?></strong>
        </div>
        
        <?php for($i=1;$i<=8;$i++) { ?>
          <div class="mb-line mb-icons mb-spec">
            <div class="mb-src">
              <input type="text" name="icons[<?php echo $i; ?>][src]" value="<?php echo @$icons[$i]['src'];  ?>" placeholder="https://domain.com/icon.png"/>
              <?php pwa_select_icons(); ?>  
            </div>
            <div class="mb-sizes">
              <input type="text" name="icons[<?php echo $i; ?>][sizes]" value="<?php echo @$icons[$i]['sizes'];  ?>" placeholder="512x512"/>
              <?php pwa_select_sizes(); ?>  
            </div>
            <div class="mb-type">
              <input type="text" name="icons[<?php echo $i; ?>][type]" value="<?php echo @$icons[$i]['type'];  ?>" placeholder="image/png"/>
              <?php pwa_select_types(); ?>  
            </div>
            <div class="mb-purpose mb-advanced">
              <input type="text" name="icons[<?php echo $i; ?>][purpose]" value="<?php echo @$icons[$i]['purpose'];  ?>" placeholder="maskable"/>
              <?php pwa_select_purposes(); ?>  
            </div>
          </div>
        <?php } ?>
        
        
        <div class="mb-subtitle mb-advanced"><?php _e('Related Applications', 'pwa'); ?></div>
        <div class="mb-notes mb-small mb-advanced">
          <div class="mb-line"><?php _e('Specifying native applications that are installable by, or accessible to, the underlying platform — for example, a native Android application obtainable through the Google Play Store. Such applications are intended to be alternatives to the manifest\'s website that provides similar/equivalent functionality — like the native app equivalent.', 'pwa'); ?></div>
        </div>

        <div class="mb-row mb-x mb-advanced">
          <input name="prefer_related_applications" id="prefer_related_applications" type="checkbox" <?php echo ($prefer_related_applications == 1 ? 'checked' : ''); ?>/>
          <label for="prefer_related_applications"><span><?php _e('Prefer related applications', 'pwa'); ?></span></label> 

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Specifies that applications listed in "Related applications" should be preferred over the web application.', 'pwa'); ?></div>
          </div>
        </div>

        <div class="mb-line mb-apps mb-spec mb-hd mb-advanced">
          <strong class="mb-platform"><?php _e('Platform', 'pwa'); ?></strong>
          <strong class="mb-id"><?php _e('ID', 'pwa'); ?></strong>
          <strong class="mb-url"><?php _e('URL', 'pwa'); ?></strong>
        </div>
        
        <?php for($i=1;$i<=3;$i++) { ?>
          <div class="mb-line mb-apps mb-spec mb-advanced">
            <div class="mb-platform">
              <input type="text" name="apps[<?php echo $i; ?>][platform]" value="<?php echo @$apps[$i]['platform'];  ?>" placeholder="play"/>
              <?php pwa_select_platforms(); ?>  
            </div>
            <div class="mb-id"><input type="text" name="apps[<?php echo $i; ?>][id]" value="<?php echo @$apps[$i]['id'];  ?>" placeholder="com.example.app"/></div>
            <div class="mb-url"><input type="text" name="apps[<?php echo $i; ?>][url]" value="<?php echo @$apps[$i]['url'];  ?>" placeholder="https://website.com"/></div>
          </div>
        <?php } ?>


        <div class="mb-subtitle mb-advanced"><?php _e('Shortcuts', 'pwa'); ?></div>
        <div class="mb-notes mb-small mb-advanced">
          <div class="mb-line"><?php _e('Shortcuts or links to key tasks or pages within a web app. A user agent can use these values to assemble a context menu to be displayed by the operating system when a user engages with the web app\'s icon.', 'pwa'); ?></div>
        </div>
        
        <div class="mb-line mb-shortcuts mb-spec mb-hd mb-advanced">
          <strong class="mb-name"><?php _e('Name', 'pwa'); ?></strong>
          <strong class="mb-short_name"><?php _e('Short Name', 'pwa'); ?></strong>
          <strong class="mb-description"><?php _e('Description', 'pwa'); ?></strong>
          <strong class="mb-url"><?php _e('URL', 'pwa'); ?></strong>
        </div>
          
        <?php for($i=1;$i<=5;$i++) { ?>
          <div class="mb-line mb-shortcuts mb-spec mb-advanced">
            <div class="mb-name"><input type="text" name="shortcuts[<?php echo $i; ?>][name]" value="<?php echo @$shortcuts[$i]['name'];  ?>" placeholder="<?php echo osc_esc_html(__('Displayed to the user in a context menu', 'pwa')); ?>"/></div>
            <div class="mb-short_name"><input type="text" name="shortcuts[<?php echo $i; ?>][short_name]" value="<?php echo @$shortcuts[$i]['short_name'];  ?>" placeholder="<?php echo osc_esc_html(__('Displayed when there is insufficient space to display the full name of the shortcut', 'pwa')); ?>"/></div>
            <div class="mb-description"><input type="text" name="shortcuts[<?php echo $i; ?>][description]" value="<?php echo @$shortcuts[$i]['description'];  ?>" placeholder="<?php echo osc_esc_html(__('Describes the purpose of the shortcut', 'pwa')); ?>"/></div>
            <div class="mb-url"><input type="text" name="shortcuts[<?php echo $i; ?>][url]" value="<?php echo @$shortcuts[$i]['url'];  ?>" placeholder="/today?source=pwa"/></div>
          </div>
          
          <div class="mb-line mb-line-extra mb-spec mb-icons mb-advanced">
            <strong class="mb-describe"><?php _e('Shortcut icon', 'pwa'); ?></strong>
            
            <div class="mb-src">
              <input type="text" name="shortcuts[<?php echo $i; ?>][icon][src]" value="<?php echo @$shortcuts[$i]['icon']['src'];  ?>" placeholder="https://domain.com/icon.png"/>
              <?php pwa_select_icons(); ?>
            </div>
            <div class="mb-sizes">
              <input type="text" name="shortcuts[<?php echo $i; ?>][icon][sizes]" value="<?php echo @$shortcuts[$i]['icon']['sizes'];  ?>" placeholder="512x512"/>
              <?php pwa_select_sizes(); ?>
            </div>
            <div class="mb-type">
              <input type="text" name="shortcuts[<?php echo $i; ?>][icon][type]" value="<?php echo @$shortcuts[$i]['icon']['type'];  ?>" placeholder="image/png"/>
              <?php pwa_select_types(); ?>
            </div>
            <div class="mb-purpose">
              <input type="text" name="shortcuts[<?php echo $i; ?>][icon][purpose]" value="<?php echo @$shortcuts[$i]['icon']['purpose'];  ?>" placeholder="maskable"/>
              <?php pwa_select_purposes(); ?>
            </div>
          </div>
        <?php } ?>


        <div class="mb-subtitle mb-advanced"><?php _e('Screenshots', 'pwa'); ?></div>
        <div class="mb-notes mb-small mb-advanced">
          <div class="mb-line"><?php _e('Image objects, representing your app in common usage scenarios. Each object must include the src, a sizes property, and the type of image.', 'pwa'); ?></div>
          <div class="mb-line"><?php _e('In Chrome, the image must respond to certain criteria:', 'pwa'); ?></div>
          <div class="mb-line">- <?php _e('Width and height must be at least 320px and at most 3840px.', 'pwa'); ?></div>
          <div class="mb-line">- <?php _e('The maximum dimension can\'t be more than 2.3 times as long as the minimum dimension.', 'pwa'); ?></div>
          <div class="mb-line">- <?php _e('Screenshots must have the same aspect ratio.', 'pwa'); ?></div>
          <div class="mb-line">- <?php _e('Only JPEG and PNG image formats are supported.', 'pwa'); ?></div>
        </div>

        <div class="mb-line mb-screenshots mb-spec mb-hd mb-advanced">
          <strong class="mb-src"><?php _e('Source', 'pwa'); ?></strong>
          <strong class="mb-sizes"><?php _e('Sizes', 'pwa'); ?></strong>
          <strong class="mb-type"><?php _e('Type', 'pwa'); ?></strong>
          <strong class="mb-platform"><?php _e('Platform', 'pwa'); ?></strong>
          <strong class="mb-label2"><?php _e('Label', 'pwa'); ?></strong>
        </div>
        
        <?php for($i=1;$i<=10;$i++) { ?>
          <div class="mb-line mb-screenshots mb-spec mb-advanced">
            <div class="mb-src">
              <input type="text" name="screenshots[<?php echo $i; ?>][src]" value="<?php echo @$screenshots[$i]['src'];  ?>" placeholder="https://domain.com/screenshot.jpg"/>
              <?php pwa_select_screenshots(); ?>  
            </div>
            <div class="mb-sizes">
              <input type="text" name="screenshots[<?php echo $i; ?>][sizes]" value="<?php echo @$screenshots[$i]['sizes'];  ?>" placeholder="1280x720"/>
              <?php pwa_select_sizes2(); ?>  
            </div>
            <div class="mb-type">
              <input type="text" name="screenshots[<?php echo $i; ?>][type]" value="<?php echo @$screenshots[$i]['type'];  ?>" placeholder="image/jpeg"/>
              <?php pwa_select_types(); ?>  
            </div>
            <div class="mb-platform">
              <input type="text" name="screenshots[<?php echo $i; ?>][platform]" value="<?php echo @$screenshots[$i]['platform'];  ?>" placeholder="wide"/>
              <?php pwa_select_platforms2(); ?>  
            </div>
            <div class="mb-label2"><input type="text" name="screenshots[<?php echo $i; ?>][label]" value="<?php echo @$screenshots[$i]['label'];  ?>" placeholder="<?php echo osc_esc_html(__('Sort description of screenshot', 'pwa')); ?>"/></div>
          </div>
        <?php } ?>

        
        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(pwa_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'pwa')); ?>"><?php _e('Save', 'pwa');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'pwa');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>

</div>


<?php echo pwa_footer(); ?>