<?php
  // Create menu
  $title = __('Upload icons and screenshots', 'pwa');
  pwa_menu($title);
 

  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  $type = Params::getParam('type');
  
  if(Params::getParam('plugin_action') == 'done') {
    message_ok(__('Settings were successfully saved', 'pwa'));
  }
  
  if(!file_exists(osc_uploads_path() . 'pwa')) {
    mkdir(osc_uploads_path() . 'pwa', 0755, true);
  }
  
  if(!file_exists(osc_uploads_path() . 'pwa/icons')) {
    mkdir(osc_uploads_path() . 'pwa/icons', 0755, true);
  }
  
  if(!file_exists(osc_uploads_path() . 'pwa/screenshots')) {
    mkdir(osc_uploads_path() . 'pwa/screenshots', 0755, true);
  }

  
  if($type != '' && Params::getParam('plugin_action') == 'done') {
    $path = osc_uploads_path() . 'pwa';
    
    if($type == 'ICON') {
      $folder = 'icons';
    } else {
      $folder = 'screenshots';
    }
    
    $path .= '/' . $folder;
    
    $files = (isset($_FILES['images']) ? $_FILES['images'] : array());
    $count = count(is_array(@$files['name']) ? $files['name'] : array());
    $ok = array();

    if($count > 0) {
      for($i=0;$i<$count;$i++) {
        // Upload icon
        $allowed_extensions = array('png','jpg','jpeg','gif','webp','avif','svg','ico');

        $extension = strtolower(pathinfo($files['name'][$i], PATHINFO_EXTENSION));
        $max_file_size = 16384 * 1000;  //(in bytes)
        $file_size = $files['size'][$i];
        $file_name = $files['name'][$i];
        
        if($files['name'][$i] <> '') {
          if($files['error'][$i] == UPLOAD_ERR_OK) {
            if(in_array($extension, $allowed_extensions)) {
              if($file_size < $max_file_size) {
                if(move_uploaded_file($files['tmp_name'][$i], $path . '/' . $file_name ) ) {
                  $ok[] = $files['name'][$i];
                } else {
                  osc_add_flash_error_message(sprintf(__('An error with image upload has occurred, please try again (%s)', 'pwa'), $file_name), 'admin');
                }
              } else {
                osc_add_flash_error_message(sprintf(__('Image (%s) is too big and was not uploaded. Maximum file size is: %s', 'pwa'), $file_name, round($max_file_size/1000) . 'kb'), 'admin');
              }
            } else {
              osc_add_flash_error_message(sprintf(__('Image extension is not allowed, file was not uploaded (%s). Only files with following extensions are allowed: %s', 'pwa'), $file_name, implode(',', $allowed_extensions)), 'admin');
            }
          } else {
            osc_add_flash_error_message(sprintf(__('An error with image upload has occurred, please try again (%s).', 'pwa'), $file_name), 'admin');
          }
        }
      }
    }
    
    if(count($ok) > 0) {
      osc_add_flash_ok_message(sprintf(__('Images successfully uploaded: %s', 'pwa'), implode(', ', $ok)), 'admin');
    }
    
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=pwa/admin/upload.php');
    exit;
  }
  
  if(Params::getParam('what') == 'remove') {
    $rem_type = Params::getParam('removeType');
    $rem_name = Params::getParam('removeName');
   
    if(($rem_type == 'icon' || $rem_type == 'screenshot') && $rem_name != ''){
      if($rem_type == 'icon') {
        $fld = 'icons';
      } else {
        $fld = 'screenshots';  
      }
      
      if(unlink(osc_uploads_path() . 'pwa/' . $fld . '/' . $rem_name)) {
        osc_add_flash_ok_message(__('Image successfully removed.', 'pwa'), 'admin');
        
        header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=pwa/admin/upload.php');
        exit;
      }
    }
    
    osc_add_flash_error_message(__('There was problem with removing image.', 'pwa'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=pwa/admin/upload.php');
    exit;
  }
  
  $errors = array();

  if(!file_exists(osc_uploads_path() . 'pwa')) { 
    $errors[] = sprintf(__('Folder %s does not exists, create it manually.', 'pwa'), osc_uploads_path() . 'pwa');
  }
  
  if(!file_exists(osc_uploads_path() . 'pwa/icons')) { 
    $errors[] = sprintf(__('Folder %s does not exists, create it manually.', 'pwa'), osc_uploads_path() . 'pwa/icons');
  }
  
  if(!file_exists(osc_uploads_path() . 'pwa/screenshots')) { 
    $errors[] = sprintf(__('Folder %s does not exists, create it manually.', 'pwa'), osc_uploads_path() . 'pwa/screenshots');
  }
?>


<div class="mb-body">
  <!-- UPLOAD SECTION -->

  <div class="mb-notes">
    <div class="mb-line"><?php _e('Upload icons and screenshots for easier setup of manifest file.', 'pwa'); ?></div>
  </div>
  
  <?php if(count($errors) > 0) { ?>
    <div class="mb-errors">
      <?php foreach($errors as $err) { ?>
        <div class="mb-line"><?php echo $err; ?></div>
      <?php } ?>
    </div>  
  <?php } ?>

  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-upload"></i> <?php _e('Upload icons and screenshots', 'pwa'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>upload.php" />
        <input type="hidden" name="plugin_action" value="done" />

        <div class="mb-row">
          <label for="type"><span><?php _e('Image Type', 'pwa'); ?></span></label> 
          <select name="type">
            <option value="ICON" <?php if($type == 'ICON' || $type == '') { ?>selected="selected"<?php } ?>><?php _e('Icons', 'pwa'); ?></option>
            <option value="SCREENSHOT" <?php if($type == 'SCREENSHOT') { ?>selected="selected"<?php } ?>><?php _e('Screeenshots', 'pwa'); ?></option>
          </select>
        </div>
        
        <div class="mb-row">
          <label for="images"><span><?php _e('Upload Images', 'pwa'); ?></span></label> 
          <input name="images[]" id="images" type="file" multiple/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('You can upload one or more images at same time. If you upload image with same name that already exists, it will be replaced.', 'pwa'); ?></div>
            <div class="mb-line"><?php _e('Images are stored in oc-content/uploads/pwa/icons and oc-content/uploads/pwa/screenshots folders. In case plugin cannot create them, you must create them manually.', 'pwa'); ?></div>
            <div class="mb-line"><?php _e('Supported extensions: png, jpg, jpeg, gif, webp, avif, svg. Maximum file size is 16MB.', 'pwa'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(pwa_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'pwa')); ?>"><?php _e('Upload', 'pwa');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Upload', 'pwa');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>



  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-list"></i> <?php _e('List of uploaded images', 'pwa'); ?></div>

    <div class="mb-inside">
      <div class="mb-row"><strong><?php _e('List of uploaded icons', 'pwa'); ?></strong></div>

      <div class="mb-table">
        <div class="mb-table-head">
          <div class="mb-col-4 mb-align-left"><?php _e('Image', 'pwa');?></div>
          <div class="mb-col-4 mb-align-left"><?php _e('Name', 'pwa');?></div>
          <div class="mb-col-3"><?php _e('Size', 'pwa');?></div>
          <div class="mb-col-3"><?php _e('Extension', 'pwa'); ?></div>
          <div class="mb-col-7 mb-align-left"><?php _e('Path', 'pwa'); ?></div>
          <div class="mb-col-3">&nbsp;</div>
        </div>

        <?php $files = pwa_get_files('icons'); ?>
        
        <?php if(count($files) <= 0) { ?>
          <div class="mb-table-row mb-row-empty">
            <i class="fa fa-warning"></i><span><?php _e('No icons uploaded yet', 'pwa'); ?></span>
          </div>
        <?php } else { ?>
          <?php foreach($files as $f) { ?>
            <div class="mb-table-row">
              <div class="mb-col-4 mb-align-left"><img src="<?php echo $f['url']; ?>" alt="icon" height="36" style="width:auto;max-width:100%;max-height:32px;"/></div>
              <div class="mb-col-4 mb-align-left"><a href="<?php echo $f['url']; ?>" target="_blank"><?php echo $f['name']; ?></a></div>
              <div class="mb-col-3">
                <?php $size = @getimagesize($f['path']);?>
                <?php echo (isset($size[0]) ? @$size[0] . 'x' . @$size[1] : '-'); ?>
              </div>
              <div class="mb-col-3"><?php echo $f['ext']; ?></div>
              <div class="mb-col-7 mb-align-left"><?php echo str_replace(osc_base_path(), '', $f['path']); ?></div>
              <div class="mb-col-3 mb-align-right">
                <?php if(!pwa_is_demo()) { ?>
                  <a class="mb-btn mb-button-red" href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=pwa/admin/upload.php&what=remove&removeType=icon&removeName=<?php echo $f['name']; ?>" onclick="return confirm('<?php echo osc_esc_html(__('Are you sure you want to delete this image?', 'pwa')); ?>')"><i class="fa fa-trash"></i></a>
                <?php } ?>              
              </div>
            </div>
          <?php } ?>
        <?php } ?>
      </div>
    
      <div class="mb-row">&nbsp;</div>
    
      <div class="mb-row"><strong><?php _e('List of uploaded screenshots', 'pwa'); ?></strong></div>

      <div class="mb-table">
        <div class="mb-table-head">
          <div class="mb-col-4 mb-align-left"><?php _e('Image', 'pwa');?></div>
          <div class="mb-col-4 mb-align-left"><?php _e('Name', 'pwa');?></div>
          <div class="mb-col-3"><?php _e('Size', 'pwa');?></div>
          <div class="mb-col-3"><?php _e('Extension', 'pwa'); ?></div>
          <div class="mb-col-7 mb-align-left"><?php _e('Path', 'pwa'); ?></div>
          <div class="mb-col-3">&nbsp;</div>
        </div>

        <?php $files = pwa_get_files('screenshots'); ?>
        
        <?php if(count($files) <= 0) { ?>
          <div class="mb-table-row mb-row-empty">
            <i class="fa fa-warning"></i><span><?php _e('No screenshots uploaded yet', 'pwa'); ?></span>
          </div>
        <?php } else { ?>
          <?php foreach($files as $f) { ?>
            <div class="mb-table-row">
              <div class="mb-col-4 mb-align-left"><img src="<?php echo $f['url']; ?>" alt="screenshot" height="36" style="width:auto;max-width:100%;max-height:32px;"/></div>
              <div class="mb-col-4 mb-align-left"><a href="<?php echo $f['url']; ?>" target="_blank"><?php echo $f['name']; ?></a></div>
              <div class="mb-col-3">
                <?php $size = @getimagesize($f['path']); ?>
                <?php echo (isset($size[0]) ? @$size[0] . 'x' . @$size[1] : '-'); ?>
              </div>
              <div class="mb-col-3"><?php echo $f['ext']; ?></div>
              <div class="mb-col-7 mb-align-left"><?php echo str_replace(osc_base_path(), '', $f['path']); ?></div>
              <div class="mb-col-3 mb-align-right">
                <?php if(!pwa_is_demo()) { ?>
                  <a class="mb-btn mb-button-red" href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=pwa/admin/upload.php&what=remove&removeType=screenshot&removeName=<?php echo $f['name']; ?>" onclick="return confirm('<?php echo osc_esc_html(__('Are you sure you want to delete this image?', 'pwa')); ?>')"><i class="fa fa-trash"></i></a>
                <?php } ?>              
              </div>
            </div>
          <?php } ?>
        <?php } ?>
      </div>
    </div>
  </div>
</div>


<?php echo pwa_footer(); ?>