<?php
  // Create menu
  $title = __('Generate service workers', 'pwa');
  pwa_menu($title);
 

  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  $sw_version = pwa_param_update('sw_version', 'plugin_action', 'value', 'plugin-pwa');
  $background_sync = pwa_param_update('background_sync', 'plugin_action', 'check', 'plugin-pwa');
  $periodic_sync = pwa_param_update('periodic_sync', 'plugin_action', 'check', 'plugin-pwa');
  $strategy = pwa_param_update('strategy', 'plugin_action', 'value', 'plugin-pwa');
  $assets = pwa_param_update('assets', 'plugin_action', 'array', 'plugin-pwa');


  if(Params::getParam('generate') == '1') {
    $res = pwa_generate_service_worker();
    
    if($res) {
      osc_add_flash_ok_message(sprintf(__('Service workers has been successfully generated. Link: %s', 'pwa'), '<a target="_blank" href="' . osc_base_url() . 'pwa-service-worker.js">' . osc_base_url() . 'pwa-service-worker.js</a>'), 'admin');
    } else {
      osc_add_flash_error_message(sprintf(__('There was problem saving pwa-service-worker.js file into root directory (may be permission issue). Path: %s', 'pwa'), osc_base_path() . 'pwa-service-worker.js'), 'admin');
    }
    
    $res = pwa_generate_offline_page();
    
    if($res) {
      osc_add_flash_ok_message(sprintf(__('Offline page has been successfully generated. Link: %s', 'pwa'), '<a target="_blank" href="' . osc_base_url() . 'offline.html">' . osc_base_url() . 'offline.html</a>'), 'admin');
    } else {
      osc_add_flash_error_message(sprintf(__('There was problem saving offline.html file into root directory (may be permission issue). Path: %s', 'pwa'), osc_base_path() . 'offline.html'), 'admin');
    }


    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=pwa/admin/worker.php');
    exit;
  }
  
  if(Params::getParam('plugin_action') == 'done') {
    message_ok(__('Settings were successfully saved', 'pwa'));
  }
?>

<?php if(pwa_param('mode') == 'BASIC') { ?><style>.mb-advanced {display:none!important;}</style><?php } ?>

<div class="mb-body">
  <!-- WORKER SECTION -->
  <?php if (strpos(osc_base_url(), 'https://') === false) { ?>
    <div class="mb-errors">
      <div class="mb-line"><?php _e('Service workers require HTTPS (SSL) to be active, otherwise cannot be used!', 'pwa'); ?></div>
    </div>
  <?php } ?>
  
  <div class="mb-notes">
    <div class="mb-line"><?php _e('Service workers are a fundamental part of a PWA. They enable fast loading (regardless of the network), offline access, push notifications, and other capabilities.', 'pwa'); ?></div>
    <div class="mb-line"><?php _e('You can <b>disable service workers</b> in your browser (chrome) in Developer tools (console) > Application > Service Workers > "Bypass for network". Option "Update on reload" will force update workers, "Offline" will imitate offline mode.', 'pwa'); ?></div>
    <div class="mb-line"><?php _e('In order to properly test workers, test them in browser where you do not access backoffice, as in backoffice when you refresh page, worker get unregistered.', 'pwa'); ?></div>
  </div>

  <div class="mb-box mb-manifest">
    <div class="mb-head">
      <i class="fa fa-gears"></i> <?php _e('Service workers and offline page configuration', 'pwa'); ?>
      
      <a class="mb-btn mb-button-blue" href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=pwa/admin/worker.php&generate=1"><i class="fa fa-refresh"></i><?php _e('Generate service workers and offline page', 'pwa'); ?></a>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>worker.php" />
        <input type="hidden" name="plugin_action" value="done" />


        <div class="mb-row">
          <label for="strategy"><span><?php _e('Cache Strategy', 'pwa'); ?></span></label> 
          <select name="strategy">
            <option value="NOCACHE" <?php if($strategy == 'NOCACHE' || $strategy == '') { ?>selected="selected"<?php } ?>><?php _e('No cache', 'pwa'); ?></option>
            <option value="NETWORK-FIRST" <?php if($strategy == 'NETWORK-FIRST') { ?>selected="selected"<?php } ?>><?php _e('Network first (with pages caching)', 'pwa'); ?></option>
            <option value="NETWORK-FIRST2" <?php if($strategy == 'NETWORK-FIRST2') { ?>selected="selected"<?php } ?>><?php _e('Network first (no caching)', 'pwa'); ?></option>
            <option value="CACHE-FIRST" <?php if($strategy == 'CACHE-FIRST') { ?>selected="selected"<?php } ?>><?php _e('Cache first (not recommended)', 'pwa'); ?></option>
          </select>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('Select type of caching strategy. We recommend not to use cache or use network first, as "Cache first" may block flash messages and form features.', 'pwa'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="background_sync"><span><?php _e('Background Sync', 'pwa'); ?></span></label> 
          <input name="background_sync" id="background_sync" type="checkbox" class="element-slide" <?php echo ($background_sync == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, service worker uses Background Sync for a rich offline experience.', 'pwa'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="periodic_sync"><span><?php _e('Periodic Sync', 'pwa'); ?></span></label> 
          <input name="periodic_sync" id="periodic_sync" type="checkbox" class="element-slide" <?php echo ($periodic_sync == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, service worker uses Periodic Sync for a rich offline experience.', 'pwa'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="sw_version"><span><?php _e('Worker Version', 'pwa'); ?></span></label> 
          <input required name="sw_version" id="sw_version" size="10" type="number" value="<?php echo osc_esc_html(intval($sw_version) + 1); ?>" />
          
          <div class="mb-explain">
            <div><?php _e('When changed, cache in PWA / workers will be purged and application "reinstalled" on background. Must be integer.', 'pwa'); ?></div>
            <div><?php _e('<b>WARNING:</b> Plugin automatically increase version each time you update preferences here, so you do not need to do it. Version you see now is current version + 1.', 'pwa'); ?></div>
          </div>
        </div>
        
       
        <div class="mb-subtitle"><?php _e('Pre-Cache Assets and Images', 'pwa'); ?></div>
        <div class="mb-notes mb-small">
          <div class="mb-line"><?php _e('Enter relative/absolute links to statical assets (css, js, png, jpeg, ...) or website links (absolute/relative) those you would like to cache. Keep in mind, if you enter i.e. contact page to cache, form may not work properly, therefore use with care!', 'pwa'); ?></div>
          <div class="mb-line"><?php _e('All CSS and JS files are automatically pulled to cache and is not required to list them.', 'pwa'); ?></div>
          <div class="mb-line"><?php _e('It is recommended to not version your scripts and styles (?v= in url) in order to use full potential of cache.', 'pwa'); ?></div>
          <div class="mb-line"><?php _e('You can enter multiple URLs/entries into each input, delimited by comma.', 'pwa'); ?></div>
        </div>
        
        <div class="mb-line mb-assets mb-spec mb-hd">
          <strong class="mb-src"><?php _e('Source', 'pwa'); ?></strong>
        </div>
        
        <?php for($i=1;$i<=8;$i++) { ?>
          <div class="mb-line mb-assets mb-spec">
            <div class="mb-src">
              <input type="text" name="assets[<?php echo $i; ?>]" value="<?php echo @$assets[$i];  ?>" placeholder="https://domain.com/logo.png"/>
            </div>
          </div>
        <?php } ?>
        
        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(pwa_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'pwa')); ?>"><?php _e('Save', 'pwa');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'pwa');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>

</div>


<?php echo pwa_footer(); ?>