<?php
  // Create menu
  $title = __('Configure', 'share');
  sr_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value


  $hook = mb_param_update( 'hook', 'plugin_action', 'value', 'plugin-share' );
  $button_type = mb_param_update( 'button_type', 'plugin_action', 'value', 'plugin-share' );
  $button_size = mb_param_update( 'button_size', 'plugin_action', 'value', 'plugin-share' );
  $facebook = mb_param_update( 'facebook', 'plugin_action', 'check', 'plugin-share' );
  $viber = mb_param_update( 'viber', 'plugin_action', 'check', 'plugin-share' );
  $whatsapp = mb_param_update( 'whatsapp', 'plugin_action', 'check', 'plugin-share' );
  $show_stats = mb_param_update( 'show_stats', 'plugin_action', 'value', 'plugin-share' );
  $category = mb_param_update( 'category', 'plugin_action', 'value', 'plugin-share' );

  $category_array = explode(',', $category);

  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'share') );
  }

?>



<div class="mb-body">
  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-cog"></i> <?php _e('Configure', 'share'); ?></div>

    <div class="mb-inside">
      <form name="promo_form" id="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />

        
        <div class="mb-row">
          <label for="hook" class="h1"><span><?php _e('Position for buttons', 'share'); ?></span></label> 

          <select name="hook">
            <option value="" <?php if($hook == '') { ?>selected="selected"<?php } ?>><?php _e('Do not hook', 'share'); ?></option>
            <option value="item_detail" <?php if($hook == 'item_detail') { ?>selected="selected"<?php } ?>>item_detail</option>
            <option value="footer" <?php if($hook == 'footer') { ?>selected="selected"<?php } ?>>footer</option>
            <option value="header" <?php if($hook == 'header') { ?>selected="selected"<?php } ?>>header</option>
          </select>
          
          <div class="mb-explain"><?php _e('Which hook will be used to show buttons. You can disable this and put buttons manually into item.php of your theme.', 'share'); ?></div>
        </div>

        <div class="mb-row">
          <label for="button_size" class="h2"><span><?php _e('Button size', 'share'); ?></span></label> 

          <select name="button_size">
            <option value="1" <?php if($button_size == 1) { ?>selected="selected"<?php } ?>><?php _e('Small (height: 24px)', 'share'); ?></option>
            <option value="2" <?php if($button_size == 2) { ?>selected="selected"<?php } ?>><?php _e('Medium (height: 36px)', 'share'); ?></option>
            <option value="3" <?php if($button_size == 3) { ?>selected="selected"<?php } ?>><?php _e('Large (height: 48px)', 'share'); ?></option>
            <option value="4" <?php if($button_size == 4) { ?>selected="selected"<?php } ?>><?php _e('Extra large (height: 80px)', 'share'); ?></option>
          </select>
          
          <div class="mb-explain"><?php _e('Define size for share buttons.', 'share'); ?></div>
        </div>

        <div class="mb-row">
          <label for="button_type" class="h3"><span><?php _e('Button type', 'share'); ?></span></label> 

          <select name="button_type">
            <option value="1" <?php if($button_type == 1) { ?>selected="selected"<?php } ?>><?php _e('Square icons', 'share'); ?></option>
            <option value="2" <?php if($button_type == 2) { ?>selected="selected"<?php } ?>><?php _e('Circle icons', 'share'); ?></option>
            <option value="3" <?php if($button_type == 3) { ?>selected="selected"<?php } ?>><?php _e('Buttons', 'share'); ?></option>
          </select>
          
          <div class="mb-explain"><?php _e('Select graphics for buttons.', 'share'); ?></div>
        
          <div class="mb-row mb-graphics">
            <div>
              <span><?php _e('Square icons', 'share'); ?></span>
              <span>
                <img src="<?php echo osc_base_url(); ?>oc-content/plugins/share/img/button_fb_1.png"/>
                <img src="<?php echo osc_base_url(); ?>oc-content/plugins/share/img/button_wa_1.png"/>
                <img src="<?php echo osc_base_url(); ?>oc-content/plugins/share/img/button_vb_1.png"/>
              </span>
            </div>

            <div>
              <span><?php _e('Circle icons', 'share'); ?></span>
              <span>
                <img src="<?php echo osc_base_url(); ?>oc-content/plugins/share/img/button_fb_2.png"/>
                <img src="<?php echo osc_base_url(); ?>oc-content/plugins/share/img/button_wa_2.png"/>
                <img src="<?php echo osc_base_url(); ?>oc-content/plugins/share/img/button_vb_2.png"/>
              </span>
            </div>

            <div>
              <span><?php _e('Buttons', 'share'); ?></span>
              <span>
                <img src="<?php echo osc_base_url(); ?>oc-content/plugins/share/img/button_fb_3.png"/>
                <img src="<?php echo osc_base_url(); ?>oc-content/plugins/share/img/button_wa_3.png"/>
                <img src="<?php echo osc_base_url(); ?>oc-content/plugins/share/img/button_vb_3.png"/>
              </span>
            </div>
          </div>
        </div>

        <div class="mb-row">
          <label for="facebook" class="h4"><span><?php _e('Enable Facebook button', 'share'); ?></span></label> 
          <input name="facebook" id="facebook" class="element-slide" type="checkbox" <?php echo ($facebook == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, facebook share button will be visible.', 'share'); ?></div>
        </div>

        <div class="mb-row">
          <label for="whatsapp" class="h5"><span><?php _e('Enable WhatsApp button', 'share'); ?></span></label> 
          <input name="whatsapp" id="whatsapp" class="element-slide" type="checkbox" <?php echo ($whatsapp == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, whatsapp share button will be visible.', 'share'); ?></div>
        </div>


        <div class="mb-row">
          <label for="viber" class="h8"><span><?php _e('Enable Viber button', 'share'); ?></span></label> 
          <input name="viber" id="viber" class="element-slide" type="checkbox" <?php echo ($viber == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain"><?php _e('When enabled, viber share button will be visible.', 'share'); ?></div>
        </div>


        <div class="mb-row">
          <label for="show_stats" class="h6"><span><?php _e('Show click statistics', 'share'); ?></span></label> 

          <select name="show_stats">
            <option value="1" <?php if($show_stats == 1) { ?>selected="selected"<?php } ?>><?php _e('Admin only', 'share'); ?></option>
            <option value="2" <?php if($show_stats == 2) { ?>selected="selected"<?php } ?>><?php _e('Admin & Owner only', 'share'); ?></option>
            <option value="3" <?php if($show_stats == 3) { ?>selected="selected"<?php } ?>><?php _e('Everyone', 'share'); ?></option>
          </select>
          
          <div class="mb-explain"><?php _e('Plugin tracks clicks from facebook, viber and whatsapp, select who is eligible to see these data (on item page).', 'share'); ?></div>
        </div>

        <div class="mb-row mb-row-select-multiple">
          <label for="category_multiple" class="h7"><span><?php _e('Category', 'share'); ?></span></label> 

          <input type="hidden" name="category" id="category" value="<?php echo $category; ?>"/>
          <select id="category_multiple" name="category_multiple" multiple>
            <?php while(osc_has_categories()) { ?>
              <option value="<?php echo osc_category_id(); ?>" <?php if(in_array(osc_category_id(), $category_array)) { ?>selected="selected"<?php } ?>><?php echo osc_category_name(); ?></option>
            <?php } ?>
          </select>

          <div class="mb-explain"><?php _e('If no category selected, share buttons are enabled in all categories.', 'share'); ?></div>
        </div>

        <div class="mb-foot">
          <button type="submit" class="mb-button"><?php _e('Save', 'share');?></button>
        </div>
      </form>
    </div>
  </div>




  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'share'); ?></div>

    <div class="mb-inside">

      <div class="mb-row">
        <div class="mb-line"><?php _e('In case position of buttons using hooks is not suitable for you, you can put following code into item.php located in your theme folder:', 'share'); ?>:</div>
        <span class="mb-code">&lt;?php if(function_exists('sr_buttons')) { echo sr_buttons(); } ?&gt;</span>
      </div>
    </div>
  </div>
</div>

<?php echo sr_footer(); ?>
	