<?php
  // Create menu
  $title = __('Statistics', 'share');
  sr_menu($title);
?>


<div class="mb-body">
  <!-- STATS SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-line-chart"></i> <?php _e('Statistics', 'share'); ?></div>

    <div class="mb-inside">
       <div id="chart"></div>
    </div>
  </div>
</div>


<?php echo sr_footer(); ?>


<?php
  // CHART FUNCTIONALITY
  $prepare = ModelSR::newInstance()->getStats(-1, 1);

  $date_string = '';
  $date_array = array();
  for ($date = date('Y-m-d', strtotime(' -12 month', time())); $date <= date("Y-m-d"); $date = date('Y-m-d', strtotime($date . ' + 1 month'))) {
    $date_array[] = date('Ym', strtotime($date));
    $date_string .= date('Ym', strtotime($date)) . ', '; 
  }

  $date_string = substr($date_string, 0, -2);


  $fb = '';
  $wa = '';
  $vb = '';

  foreach( $date_array as $d ) {
    $found = false;
    foreach( $prepare as $p ) {
      if( $p['year']*100 + $p['month'] == $d ) {
        $fb .= $p['i_fb_clicks'] . ', '; 
        $wa .= $p['i_wa_clicks'] . ', '; 
        $vb .= $p['i_vb_clicks'] . ', '; 
        $found = true;
      }
    }

    if(!$found) {
      $fb .= '0, '; 
      $wa .= '0, '; 
      $vb .= '0, '; 
    }
  }

  $fb = substr($fb, 0, -2);
  $wa = substr($wa, 0, -2);
  $vb = substr($vb, 0, -2);
?>

<script src="https://code.highcharts.com/highcharts.js"></script>

<script>
  $(document).ready(function(){
    Highcharts.chart('chart', {
      title: {
        text: '<?php echo osc_esc_js(__('Social clicks in last 12 months', 'share')); ?>',
        x: -20 //center
      },

      responsive: {
        rules: [{
          condition: { maxWidth: 480 },
          chartOptions: {
            legend: { enabled: false },
            title: { text: '<?php echo osc_esc_js(__('Views in last 12 months', 'share')); ?>', style: {"font-size": "14px"}},
            xAxis: { labels: { enabled: false } },
            yAxis: { title: { text: null } }
          }
        }, {
          condition: { minWidth: 481, maxWidth: 1024 },
          chartOptions: {
            title: { style: {"font-size": "15px"}},
            yAxis: { title: { text: null } }
          }
        }]
      },

      xAxis: {
        categories: [<?php echo $date_string; ?>]
      },

      yAxis: [{
        title: {
          text: '<?php echo osc_esc_js(__('# clicks', 'share')); ?>'
        },
        plotLines: [{
          value: 0,
          width: 1,
          color: '#808080'
        }]
      }],

      legend: {
        layout: 'vertical',
        align: 'right',
        verticalAlign: 'middle',
        borderWidth: 0,
        itemStyle: {"fontWeight": "normal" }
      },

      colors: ['#03a9f4', '#8BC34A', '#7c519b'],

      series: [{
        yAxis: 0,
        name: '<?php echo osc_esc_js(__('Facebook', 'share')); ?>',
        data: [<?php echo $fb; ?>],
        tooltip: {
          valueSuffix: 'x <?php echo osc_esc_js(__('clicks', 'share')); ?>'
        }
      }, {
        yAxis: 0,
        name: '<?php echo osc_esc_js(__('WhatsApp', 'share')); ?>',
        data: [<?php echo $wa; ?>],
        tooltip: {
          valueSuffix: 'x <?php echo osc_esc_js(__('clicks', 'share')); ?>'
        }
      }, {
        yAxis: 0,
        name: '<?php echo osc_esc_js(__('Viber', 'share')); ?>',
        data: [<?php echo $vb; ?>],
        tooltip: {
          valueSuffix: 'x <?php echo osc_esc_js(__('clicks', 'share')); ?>'
        }
      }]
    });
  });
</script>