<?php

// GENERATE BUTTONS
function sr_buttons($item_id = NULL) {
  if($item_id <= 0) {
    $item_id = osc_item_id();
  }
  
  $item = Item::newInstance()->findByPrimaryKey($item_id);
  $category = osc_get_preference('category', 'plugin-share');
  $category_array = explode(',', $category);
  
  $root = Category::newInstance()->findRootCategory($item['fk_i_category_id']);
  $root_id = $root['pk_i_id'];

  if(in_array($root_id, $category_array) || in_array($item['fk_i_category_id'], $category_array) || trim($category) == '') {
    $button = '';
    $button_type = osc_get_preference('button_type', 'plugin-share');
    $button_img_type = ($button_type == 3 ? 2 : $button_type);
    $button_size = osc_get_preference('button_size', 'plugin-share');
    $whatsapp = osc_get_preference('whatsapp', 'plugin-share');
    $facebook = osc_get_preference('facebook', 'plugin-share');
    $viber = osc_get_preference('viber', 'plugin-share');

    if($whatsapp == 1) {
      if(sr_is_mobile()) {
        $button .= '<a class="sr-button sr-whatsapp sr-size' . $button_size . ' sr-type' . $button_type . '" href="whatsapp://send?text=' . osc_esc_html(__('Check this out', 'share')) . ': ' . urlencode(osc_route_url('share-redirect', array('sharesrc' => 'wa', 'item' => $item_id))) . '" title="' . osc_esc_html(__('Share on WhatsApp', 'share')) . '" data-action="share/whatsapp/share"><img src="' . osc_base_url() . 'oc-content/plugins/share/img/button_wa_' . $button_img_type . '.png" alt="' . osc_esc_html(__('Share on WhatsApp', 'share')) . '"/></a>';
      } else {
        $button .= '<a class="sr-button sr-whatsapp sr-size' . $button_size . ' sr-type' . $button_type . '" href="https://api.whatsapp.com/send?phone=r&text=' . osc_esc_html(__('Check this out', 'share')) . ': ' . urlencode(osc_route_url('share-redirect', array('sharesrc' => 'wa', 'item' => $item_id))) . '" title="' . osc_esc_html(__('Share on WhatsApp', 'share')) . '" data-action="share/whatsapp/share"><img src="' . osc_base_url() . 'oc-content/plugins/share/img/button_wa_' . $button_img_type . '.png" alt="' . osc_esc_html(__('Share on WhatsApp', 'share')) . '"/></a>';
      }
    }

    if($facebook == 1) {
      $button .= '<a class="sr-button sr-facebook sr-size' . $button_size . ' sr-type' . $button_type . '" href="https://www.facebook.com/sharer/sharer.php?u=' . urlencode(osc_route_url('share-redirect', array('sharesrc' => 'fb', 'item' => $item_id))) . '" title="' . osc_esc_html(__('Share on Facebook', 'share')) . '"><img src="' . osc_base_url() . 'oc-content/plugins/share/img/button_fb_' . $button_img_type . '.png" alt="' . osc_esc_html(__('Share on Facebook', 'share')) . '"/></a>';
    }

    if($viber == 1) {
      $v_link = 'https://3p3x.adj.st/?adjust_t=u783g1_kw9yml&adjust_fallback=https%3A%2F%2Fwww.viber.com%2F%3Futm_source%3DPartner%26utm_medium%3DSharebutton%26utm_campaign%3DDefault&adjust_campaign=Sharebutton&adjust_deeplink=' . urlencode('viber://forward?text=' . urlencode(osc_esc_html(__('Check this out', 'share')) . ': ' . osc_route_url('share-redirect', array('sharesrc' => 'vb', 'item' => $item_id))));
      $button .= '<a class="sr-button sr-viber sr-size' . $button_size . ' sr-type' . $button_type . '" href="' . $v_link . '" title="' . osc_esc_html(__('Share on Viber', 'share')) . '"><img src="' . osc_base_url() . 'oc-content/plugins/share/img/button_vb_' . $button_img_type . '.png" alt="' . osc_esc_html(__('Share on Viber', 'share')) . '"/></a>';
    }

    if($button <> '') {
      return '<div class="sr-buttons">' . $button . '</div>';
    }
  }
}



// SHOW STATS
function sr_show_item_stats($item_id = NULL) {
  if($item_id <= 0) {
    $item_id = osc_item_id();
  }
  
  $item = Item::newInstance()->findByPrimaryKey($item_id);
  $stats_data = ModelSR::newInstance()->getStats($item_id);
  $stats = (isset($stats_data[0]) ? $stats_data[0] : array());
  $show = osc_get_preference('show_stats', 'plugin-share');
  $facebook = osc_get_preference('facebook', 'plugin-share');
  $viber = osc_get_preference('viber', 'plugin-share');
  $whatsapp = osc_get_preference('whatsapp', 'plugin-share');
  $text = array();

  if($show == 3 || ($show == 2 && (osc_is_admin_user_logged_in() || (isset($item['fk_i_user_id']) && $item['fk_i_user_id'] == osc_logged_user_id() && osc_is_web_user_logged_in()))) || ($show == 1 && osc_is_admin_user_logged_in())) {
    if($facebook == 1) {
      $text[] = (@$stats['i_fb_clicks'] == '' ? 0 : $stats['i_fb_clicks']) . ' ' . __('Facebook clicks', 'share');
    }

    if($whatsapp == 1) {
      $text[] = (@$stats['i_wa_clicks'] == '' ? 0 : $stats['i_wa_clicks']) . ' ' . __('WhatsApp clicks', 'share');
    }

    if($viber == 1) {
      $text[] = (@$stats['i_vb_clicks'] == '' ? 0 : $stats['i_vb_clicks']) . ' ' . __('Viber clicks', 'share');
    }

    $text = array_filter($text);

    if(!empty($text)) {
      echo '<div class="sr-stats">' . implode(' / ', $text) . '</div>';
    }
  }
}

osc_add_hook('item_detail', 'sr_show_item_stats');


// CHECK IF DEVICE IS MOBILE
function sr_is_mobile() {
  $useragent=$_SERVER['HTTP_USER_AGENT'];

  if(preg_match('/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i',$useragent)||preg_match('/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i',substr($useragent,0,4))) {
    return true;
  }

  return false;
}


// CORE FUNCTIONS
if(!function_exists('mb_param_update')) {
  function mb_param_update( $param_name, $update_param_name, $type = NULL, $plugin_var_name = NULL ) {
  
    $val = '';
    if( $type == 'check') {

      // Checkbox input
      if( Params::getParam( $param_name ) == 'on' ) {
        $val = 1;
      } else {
        if( Params::getParam( $update_param_name ) == 'done' ) {
          $val = 0;
        } else {
          $val = ( osc_get_preference( $param_name, $plugin_var_name ) != '' ) ? osc_get_preference( $param_name, $plugin_var_name ) : '';
        }
      }
    } else {

      // Other inputs (text, password, ...)
      if( Params::getParam( $update_param_name ) == 'done' && Params::existParam($param_name)) {
        $val = Params::getParam( $param_name );
      } else {
        $val = ( osc_get_preference( $param_name, $plugin_var_name) != '' ) ? osc_get_preference( $param_name, $plugin_var_name ) : '';
      }
    }


    // If save button was pressed, update param
    if( Params::getParam( $update_param_name ) == 'done' ) {

      if(osc_get_preference( $param_name, $plugin_var_name ) == '') {
        osc_set_preference( $param_name, $val, $plugin_var_name, 'STRING');  
      } else {
        $dao_preference = new Preference();
        $dao_preference->update( array( "s_value" => $val ), array( "s_section" => $plugin_var_name, "s_name" => $param_name ));
        osc_reset_preferences();
        unset($dao_preference);
      }
    }

    return $val;
  }
}


if(!function_exists('message_ok')) {
  function message_ok( $text ) {
    $final  = '<div class="flashmessage flashmessage-ok flashmessage-inline">';
    $final .= $text;
    $final .= '</div>';
    echo $final;
  }
}


if(!function_exists('message_error')) {
  function message_error( $text ) {
    $final  = '<div class="flashmessage flashmessage-error flashmessage-inline">';
    $final .= $text;
    $final .= '</div>';
    echo $final;
  }
}


if( !function_exists('osc_is_contact_page') ) {
  function osc_is_contact_page() {
    $location = Rewrite::newInstance()->get_location();
    $section = Rewrite::newInstance()->get_section();
    if( $location == 'contact' ) {
      return true ;
    }

    return false ;
  }
}


?>