<?php
/*
  Plugin Name: WhatsApp / Facebook / Viber Share Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/social-and-authentication/social-share-osclass-plugin-i73
  Description: Allow your users to share their listings with friends on WhatsApp, Facebook and Viber
  Version: 1.1.5
  Author: MB Themes
  Author URI: https://www.mb-themes.com
  Author Email: info@mb-themes.com
  Short Name: share
  Plugin update URI: share-plugin
  Support URI: http://forums.mb-themes.com/whatsapp-facebook-viber-share-plugin/
  Product Key: 4EdXqRi5wzbIYKjXPhQ1
*/


require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelSR.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';

osc_enqueue_style('font-awesome47', '//maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css');
osc_enqueue_style('sr-user-style', osc_base_url() . 'oc-content/plugins/share/css/user.css');


// AUTO HOOK BUTTON
function sr_hook_buttons() {
  if(osc_is_ad_page()) {
    echo sr_buttons();
  }
}

$hook = osc_get_preference('hook', 'plugin-share');

if($hook <> '') {
  osc_add_hook($hook, 'sr_hook_buttons');
}


// STATISTICS
function sr_track_stats() {
  $share_src = Params::getParam('sharesrc');
  $item_id = Params::getParam('item');

  if($item_id > 0) {
    if($share_src == 'fb') {
      ModelSR::newInstance()->increaseStats($item_id, 'fb');
    }

    if($share_src == 'wa') {
      ModelSR::newInstance()->increaseStats($item_id, 'wa');
    }
  }
}

osc_add_hook('init', 'sr_track_stats');


// ROUTES
osc_add_route('share-redirect', 'share-redirect/(.+)/(.+)', 'share-redirect/{sharesrc}/{item}', osc_plugin_folder(__FILE__).'form/redirect.php');


// INSTALL FUNCTION - DEFINE VARIABLES
function sr_call_after_install() {
  ModelSR::newInstance()->import('share/model/struct.sql');
  
  // General settings
  osc_set_preference('hook', 'item_detail', 'plugin-share', 'STRING');
  osc_set_preference('button_type', 1, 'plugin-share', 'INTEGER');
  osc_set_preference('button_size', 1, 'plugin-share', 'INTEGER');
  osc_set_preference('facebook', 1, 'plugin-share', 'INTEGER');
  osc_set_preference('viber', 1, 'plugin-share', 'INTEGER');
  osc_set_preference('whatsapp', 1, 'plugin-share', 'INTEGER');
  osc_set_preference('category', '', 'plugin-share', 'STRING');
  osc_set_preference('show_stats', 2, 'plugin-share', 'INTEGER');
}


function sr_call_after_uninstall() {
  ModelSR::newInstance()->uninstall();
  osc_delete_preference('hook', 'plugin-share');
  osc_delete_preference('button_type', 'plugin-share');
  osc_delete_preference('button_size', 'plugin-share');
  osc_delete_preference('category', 'plugin-share');
  osc_delete_preference('show_stats', 'plugin-share');
  osc_delete_preference('facebook', 'plugin-share');
  osc_delete_preference('viber', 'plugin-share');
  osc_delete_preference('whatsapp', 'plugin-share');
}



// ADMIN MENU
function sr_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/share/css/admin.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/share/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/share/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="//fonts.googleapis.com/css?family=Open+Sans:300,600&amp;subset=latin,latin-ext" rel="stylesheet" type="text/css" />';
  echo '<link href="//maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/share/js/admin.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/share/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/share/js/bootstrap-switch.js"></script>';



  if( $title == '') { $title = __('Configure', 'share'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Whatsapp, Facebook and Viber Share Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=share/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'share') . '</span></a></li>';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=share/admin/stats.php"><i class="fa fa-line-chart"></i><span>' . __('Statistics', 'share') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function sr_footer() {
  $pluginInfo = osc_plugin_get_info('share/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://mb-themes.com"><img src="https://mb-themes.com/favicon.ico" alt="MB Themes" /> MB-Themes.com</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'share') . '</a>';
  $text .= '<a target="_blank" href="https://forums.mb-themes.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'share') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@mb-themes.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'share') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function sr_admin_menu() {
echo '<h3><a href="#">WA/FB/VB Share Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'share') . '</a></li>
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/stats.php') . '">&raquo; ' . __('Statistics', 'share') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','sr_admin_menu', 1);


// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function sr_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'sr_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'sr_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'sr_call_after_uninstall');

?>