<?php

class ModelSR extends DAO {
private static $instance;

public static function newInstance() {
  if( !self::$instance instanceof self ) {
    self::$instance = new self ;
  }
  return self::$instance ;
}

function __construct() {
  parent::__construct();
}


public function import($file) {
  $path = osc_plugin_resource($file);
  $sql = file_get_contents($path);

  if(!$this->dao->importSQL($sql) ){
    throw new Exception("Error importSQL::ModelSR<br>" . $file . "<br>" . $this->dao->getErrorLevel() . " - " . $this->dao->getErrorDesc() );
  }
}

 
public function uninstall() {
  $this->dao->query('DROP TABLE '. $this->getTable_stats());
}


public function getTable_stats() {
  return DB_TABLE_PREFIX.'t_item_share_stats';
}


public function getTable_item() {
  return DB_TABLE_PREFIX.'t_item';
}


// INCREASE STATS
public function increaseStats($item_id, $type) {
  if($type == 'fb') {
    $col = 'i_fb_clicks';
  } else if ($type == 'wa') {
    $col = 'i_wa_clicks';
  } else if ($type == 'vb') {
    $col = 'i_vb_clicks';
  } else {    return false;
  }

  $this->dao->query('INSERT INTO ' . $this->getTable_stats() . ' (fk_i_item_id, dt_date, ' . $col . ') VALUES (' . $item_id. ', "' . date('Y-m-d') . '", 1) ON DUPLICATE KEY UPDATE  ' . $col . ' = ' . $col . ' + 1');
}


// REMOVE STATS
public function removeStats($item_id) {
  $this->dao->query('DELETE FROM '. $this->getTable_stats() . ' WHERE fk_i_item_id = ' . $item_id);
}


// GET ITEM STATS
public function getStats($item_id = -1, $month = -1) {
  if($month == -1) {
    $this->dao->select('sum(coalesce(i_fb_clicks, 0)) as i_fb_clicks, sum(coalesce(i_wa_clicks, 0)) as i_wa_clicks, sum(coalesce(i_vb_clicks, 0)) as i_vb_clicks');
  } else {
    $this->dao->select('year(dt_date) as year, month(dt_date) as month, sum(coalesce(i_fb_clicks, 0)) as i_fb_clicks, sum(coalesce(i_wa_clicks, 0)) as i_wa_clicks, sum(coalesce(i_vb_clicks, 0)) as i_vb_clicks');
  }

  $this->dao->from($this->getTable_stats());

  if($item_id > 0) {
    $this->dao->where('fk_i_item_id', $item_id);
  }


  if($month > 0) {
    $this->dao->where('dt_date > CURRENT_DATE() - INTERVAL 12 MONTH');
    $this->dao->groupBy('year(dt_date), month(dt_date)');
  }


  $result = $this->dao->get();
  if( !$result ) { return array(); }
  $prepare = $result->result();
  return $prepare;
}






// update function
function _update($table, $values, $where) {
  $this->dao->from($table);
  $this->dao->set($values);
  $this->dao->where($where);
  return $this->dao->update();
}

// End of DAO Class
}
?>