<?php
  // Create menu
  $title = __('Configure', 'sms_payments');
  sp_menu($title);


  // PROMOTE FUNCTIONALITY
  $promote_service_id = sp_param_update( 'promote_service_id', 'plugin_action_promote' );
  $promote_secret = sp_param_update( 'promote_secret', 'plugin_action_promote' );
  $promote_test_mode = sp_param_update( 'promote_test_mode', 'plugin_action_promote', 'check' );
  $promote_expiration_days = sp_param_update( 'promote_expiration_days', 'plugin_action_promote' );
  $promote_button = sp_param_update( 'promote_button', 'plugin_action_promote', 'check' );


  if(Params::getParam('plugin_action_promote') == 'done') {
    message_ok( __('Settings for Promote functionality successfully saved', 'sms_payments') );
  }


  // MOVE TO TOP FUNCTIONALITY
  $movetop_service_id = sp_param_update( 'movetop_service_id', 'plugin_action_movetop' );
  $movetop_secret = sp_param_update( 'movetop_secret', 'plugin_action_movetop' );
  $movetop_test_mode = sp_param_update( 'movetop_test_mode', 'plugin_action_movetop', 'check' );
  $movetop_button = sp_param_update( 'movetop_button', 'plugin_action_movetop', 'check' );

  if(Params::getParam('plugin_action_movetop') == 'done') {
    message_ok( __('Settings for Move to top functionality successfully saved', 'sms_payments') );
  }

    
?>

<div class="mb-body">

  <!-- PROMOTE FUNCTIONALITY -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-cog"></i> <?php _e('Promote functionality settings', 'sms_payments'); ?></div>

    <div class="mb-inside">
      <form name="promo_form" id="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action_promote" value="done" />

        <div class="mb-row">
          <label for="promote_service_id" class="h1"><span><?php _e('Fortumo Service ID', 'sms_payments'); ?></span></label> 
          <input size="40" name="promote_service_id" id="promote_service_id" type="text" value="<?php echo $promote_service_id; ?>" placeholder="<?php _e('Fortumo Service ID', 'sms_payments'); ?>" />
        </div>

        <div class="mb-row">
          <label for="promote_secret" class="h2"><span><?php _e('Fortumo Secret Code', 'sms_payments'); ?></span></label> 
          <input size="40" name="promote_secret" id="promote_secret" type="password" value="<?php echo !sp_is_demo() ? $promote_secret : ''; ?>" placeholder="<?php _e('Fortumo Secret Code', 'sms_payments'); ?>" />
        </div>

        <div class="mb-row">
          <label for="promote_expiration_days" class="h3"><span><?php _e('Expire in', 'sms_payments'); ?></span></label> 
          <input size="3" name="promote_expiration_days" id="promote_expiration_days" class="mb-short" type="text" value="<?php echo $promote_expiration_days; ?>" />
          <div class="mb-input-desc"><?php _e('days', 'sms_payments'); ?></div>
        </div>

        <div class="mb-row">
          <label for="promote_test_mode" class="h4"><span><?php _e('Test Mode', 'sms_payments'); ?></span></label> 
          <input name="promote_test_mode" id="promote_test_mode" class="element-slide" type="checkbox" <?php echo ($promote_test_mode == 1 ? 'checked' : ''); ?> />
        </div>

        <div class="mb-row">
          <label for="promote_button" class="h5"><span><?php _e('Show Promote Button', 'sms_payments'); ?></span></label> 
          <input name="promote_button" id="promote_button" class="element-slide" type="checkbox" <?php echo ($promote_button == 1 ? 'checked' : ''); ?> />
        </div>
      </div>

      <div class="mb-foot">
        <?php if(!sp_is_demo()) { ?>
          <button type="submit" class="mb-button"><?php _e('Save', 'sms_payments');?></button>
        <?php } else { ?>
          <a href="#" onclick="return false" class="mb-button"><?php _e('Save (demo - disabled)', 'sms_payments');?></button>
        <?php } ?>
      </div>
    </form>
  </div>


  <!-- MOVE TO TOP FUNCTIONALITY -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-cog"></i> <?php _e('Move to Top functionality settings', 'sms_payments'); ?></div>

    <div class="mb-inside">
      <form name="promo_form" id="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action_movetop" value="done" />

        <div class="mb-row">
          <label for="movetop_service_id" class="h1"><span><?php _e('Fortumo Service ID', 'sms_payments'); ?></span></label> 
          <input size="40" name="movetop_service_id" id="movetop_service_id" type="text" value="<?php echo $movetop_service_id; ?>" placeholder="<?php _e('Fortumo Service ID', 'sms_payments'); ?>" />
        </div>

        <div class="mb-row">
          <label for="movetop_secret" class="h2"><span><?php _e('Fortumo Secret Code', 'sms_payments'); ?></span></label> 
          <input size="40" name="movetop_secret" id="movetop_secret" type="password" value="<?php echo !sp_is_demo() ? $movetop_secret : ''; ?>" placeholder="<?php _e('Fortumo Secret Code', 'sms_payments'); ?>" />
        </div>

        <div class="mb-row">
          <label for="movetop_test_mode" class="h4"><span><?php _e('Test Mode', 'sms_payments'); ?></span></label> 
          <input name="movetop_test_mode" id="movetop_test_mode" type="checkbox" class="element-slide" <?php echo ($movetop_test_mode == 1 ? 'checked' : ''); ?> />
        </div>

        <div class="mb-row">
          <label for="movetop_button" class="h5"><span><?php _e('Show Move to Top Button', 'sms_payments'); ?></span></label> 
          <input name="movetop_button" id="movetop_button" class="element-slide" type="checkbox" <?php echo ($movetop_button == 1 ? 'checked' : ''); ?> />
        </div>
      </div>

      <div class="mb-foot">
        <?php if(!sp_is_demo()) { ?>
          <button type="submit" class="mb-button"><?php _e('Save', 'sms_payments');?></button>
        <?php } else { ?>
          <a href="#" onclick="return false" class="mb-button"><?php _e('Save (demo - disabled)', 'sms_payments');?></button>
        <?php } ?>
      </div>
    </form>
  </div>


  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'sms_payments'); ?></div>

    <div class="mb-inside">

      <div class="mb-row">
        <div class="mb-line">1. <?php _e('First you need to create new service on', 'sms_payments'); ?> <a href="https://fortumo.com/" target="_blank">https://fortumo.com/</a>.</div>
        <div class="mb-line">2. <?php _e('It is reqired to create 2 services, one for "Promotion" and one for "Move to Top" function.', 'sms_payments'); ?></div>
        <div class="mb-line">3. <?php _e('Service type:', 'sms_payments'); ?> <strong>Cross-Platform Mobile Payments</strong></div>
        <div class="mb-line">4. <?php _e('Define countries you want to allow your service in, in section "Do you want to sell single item or virtual credits?" choose "Single item".', 'sms_payments'); ?></div>
        <div class="mb-line">5. <?php _e('Set price for your service.', 'sms_payments'); ?></div>
        <div class="mb-line">6. <?php _e('Define name of your application (i.e. Promotion or Move to Top) and also name of website where service will be used.', 'sms_payments'); ?></div>

        <div class="mb-row">&nbsp;</div>

        <div class="mb-line">
          <div class="mb-line">7. <?php _e('To which URL will your payment requests be forwarded to?', 'sms_payments'); ?>:</div>
          <div class="mb-line"><strong><?php echo osc_base_url(); ?></strong></div>
        </div>

        <div class="mb-row">&nbsp;</div>

        <div class="mb-line">
          <div class="mb-line">8. <?php _e('Where to redirect the user after completing the payment?', 'sms_payments'); ?></div>
          <div class="mb-line"><span class="mb-u"><?php _e('For promote function, enter', 'sms_payments'); ?>:</span></div>
          <div class="mb-line"><strong><?php echo osc_base_url(); ?>index.php?page=sms-payment&action=promote&item_id=CUID</strong></div>

          <div class="mb-row">&nbsp;</div>

          <div class="mb-line"><span class="mb-u"><?php _e('For move to top function, enter', 'sms_payments'); ?>:</span></div>
          <div class="mb-line"><strong><?php echo osc_base_url(); ?>index.php?page=sms-payment&action=movetop&item_id=CUID</strong></div>
        </div>

        <div class="mb-row">&nbsp;</div>

        <div class="mb-line">9. <?php _e('Define additional information about service.', 'sms_payments'); ?></div>
        <div class="mb-line">10. <?php _e('When everything is set and working properly, do not forget to click on "Go live" on fortumo page and disable test in plugin settings.', 'sms_payments'); ?></div>
      </div>

      <div class="mb-row">&nbsp;</div>

      <div class="mb-row">
        <?php echo __('To show', 'sms_payments') . ' <strong>' . __('Promote', 'sms_payments') . '</strong> ' . __('and', 'sms_payments') . ' <strong>' . __('Move to Top', 'sms_payments') . '</strong> ' . __('buttons, place following code to item.php of your theme:', 'sms_payments'); ?>
        <span class="mb-code">&lt;?php if(function_exists('sp_buttons')) { echo sp_buttons( osc_item_id() ); } ?&gt;</span>
      </div>
    </div>
  </div>



  <!-- HELP TOPICS -->
  <div class="mb-box" id="mb-help">
    <div class="mb-head"><i class="fa fa-question-circle"></i> <?php _e('Help', 'sms_payments'); ?></div>

    <div class="mb-inside">
      <div class="mb-row mb-help"><span class="sup">(1)</span> <div class="h1"><?php _e('Service ID of your Fortumo service. Note that you need to create 2 services, one for promotion and one for move to top.', 'sms_payments'); ?></div></div>
      <div class="mb-row mb-help"><span class="sup">(2)</span> <div class="h2"><?php _e('Secret code of Fortumo service', 'sms_payments'); ?></div></div>
      <div class="mb-row mb-help"><span class="sup">(3)</span> <div class="h3"><?php _e('Set in how many days will promoted item expire. I.e. if set for 10 days, after 10 days will be premium label removed from item automatically. When premium label is removed, email to user is send to inform him about this change', 'sms_payments'); ?></div></div>
      <div class="mb-row mb-help"><span class="sup">(4)</span> <div class="h4"><?php _e('Set to Yes if you are in development phase - you will not need to pay for testing.', 'sms_payments'); ?></div></div>
      <div class="mb-row mb-help"><span class="sup">(5)</span> <div class="h5"><?php _e('Set to Yes if you want to show button to promote or move to top on page where is placed function sp_buttons.', 'sms_payments'); ?></div></div>
      <div class="mb-row mb-help"><div><?php _e('Note that user can promote listing multiple times, then expiration date is extended by expire days. I.e. if expire days is set to 10 days and user promote listing 3 times, premium label will be removed from item after 30 days. When premium label is removed, mail to user about this action is sent.', 'sms_payments'); ?></div></div>
      <div class="mb-row mb-help"><div><strong><?php _e('Do not forget to set CRON for your osclass !', 'sms_payments'); ?></strong></div></div>
    </div>
  </div>
</div>

<?php echo sp_footer(); ?>
