<?php
  // Create menu
  $title = __('Payment Logs', 'sms_payments');
  sp_menu($title);


  // PROMOTE FUNCTIONALITY
  $log_history_days = sp_param_update( 'log_history_days', 'plugin_action' );


  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings for logs has been successfully saved.', 'sms_payments') );
  }
?>

<div class="mb-body">

  <!-- STATISTICS -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-dashboard"></i> <?php _e('Statistics', 'sms_payments'); ?>
    </div>

    <div class="mb-inside">
      <div class="mb-table">
        <div class="mb-table-head">
          <div class="mb-col-2">Year</div>
          <div class="mb-col-2">Month</div>
          <div class="mb-col-2">Currency</div>
          <div class="mb-col-2">Amount</div>
          <div class="mb-col-2">Price</div>
          <div class="mb-col-2">Revenue</div>
        </div>

        <?php $stats = ModelSP::newInstance()->getLogsStats(); ?>
        <?php $total = ModelSP::newInstance()->getLogsSummary(); ?>

        <?php if(count($stats) > 0) { ?>
          <?php foreach($stats as $s) { ?>
            <div class="mb-table-row">
              <div class="mb-col-2"><?php echo $s['log_year']; ?></div>
              <div class="mb-col-2"><?php echo date('F', mktime(0, 0, 0, $s['log_month'], 10)); ?></div>
              <div class="mb-col-2"><?php echo $s['currency']; ?></div>
              <div class="mb-col-2"><?php echo $s['amount']; ?>x</div>
              <div class="mb-col-2"><?php echo $s['price']; ?></div>
              <div class="mb-col-2"><strong><?php echo $s['revenue']; ?></strong></div>
            </div>
          <?php } ?>

          <?php foreach($total as $t) { ?>
            <div class="mb-table-row mb-table-row-summary">
              <div class="mb-col-2"><?php _e('Summary', 'sms_payments'); ?> - <?php echo $t['currency']; ?></div>
              <div class="mb-col-2">&nbsp;</div>
              <div class="mb-col-2">&nbsp;</div>
              <div class="mb-col-2"><?php echo $t['amount']; ?>x</div>
              <div class="mb-col-2"><?php echo $t['price']; ?></div>
              <div class="mb-col-2"><strong><?php echo $t['revenue']; ?></strong></div>
            </div>
          <?php } ?>
        <?php } else { ?>
          <div class="mb-table-row mb-row-empty"><i class="fa fa-warning"></i><span><?php _e('No records found', 'sms_payments'); ?></span></div>
        <?php } ?>
      </div>
    </div>
  </div>



  <!-- HISTORY SETTINGS -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-cog"></i> <?php _e('History settings', 'sms_payments'); ?></div>

    <div class="mb-inside">
      <form name="promo_form" id="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>logs.php" />
        <input type="hidden" name="plugin_action" value="done" />

        <div class="mb-row">
          <label for="log_history_days" class="h1"><span><?php _e('Keep Log History for', 'sms_payments'); ?></span></label> 
          <input size="3" name="log_history_days" id="log_history_days" class="mb-short" type="text" value="<?php echo $log_history_days; ?>" />
          <div class="mb-input-desc"><?php _e('days', 'sms_payments'); ?></div>
        </div>
      </div>

      <div class="mb-foot">
        <button type="submit" class="mb-button"><?php _e('Save', 'sms_payments');?></button>
      </div>
    </form>
  </div>



  <!-- PAYMENT LOGS -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-list-ol"></i> <?php _e('Payment Logs', 'sms_payments'); ?>
      <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=sms_payments/admin/logs.php" class="mb-first"><?php _e('All Logs', 'sms_payments'); ?></a>
      <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=sms_payments/admin/logs.php&log_type=promote"><?php _e('Promote Logs', 'sms_payments'); ?></a>
      <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=sms_payments/admin/logs.php&log_type=movetop"><?php _e('Move to Top Logs', 'sms_payments'); ?></a>
    </div>

    <div class="mb-inside">
      <div class="mb-table">
        <div class="mb-table-head">
          <div class="mb-col-1_2">ID</div>
          <div class="mb-col-1_2">Item</div>
          <div class="mb-col-1">Successful</div>
          <div class="mb-col-1">Type</div>
          <div class="mb-col-3 mb-align-left">Payment</div>
          <div class="mb-col-1">Customer</div>
          <div class="mb-col-1">Country</div>
          <div class="mb-col-2">Message</div>
          <div class="mb-col-1">Expire Date</div>
          <div class="mb-col-1">Log Date</div>
        </div>

        <?php $logs = ModelSP::newInstance()->getLogs( Params::getParam('log_type') ); ?>

        <?php if(count($logs) > 0) { ?>
          <?php foreach($logs as $l) { ?>
            <div class="mb-table-row">
              <div class="mb-col-1_2"><?php echo $l['record_id']; ?></div>
              <div class="mb-col-1_2"><a href="<?php echo osc_item_url_ns($l['item_id']); ?>" target="_blank"><?php echo $l['item_id']; ?></a></div>
              <div class="mb-col-1 <?php echo ($l['successful'] == 0 ? 'mb-red' : ''); ?>"><?php echo ($l['successful'] == 1 ? __('Yes', 'sms_payments') : __('No', 'sms_payments')); ?></div>
              <div class="mb-col-1"><?php echo $l['payment_type']; ?></div>
              <div class="mb-col-3 mb-align-left">
                <span class="mb-has-tooltip" title="<?php _e('Amount', 'sms_payments'); ?>: <?php echo $l['amount']; ?>x<br/><?php _e('Price', 'sms_payments'); ?>: <?php echo $l['price']; ?><br/><?php _e('Revenue', 'sms_payments'); ?>: <?php echo $l['revenue']; ?><br/><?php _e('Currency', 'sms_payments'); ?>: <?php echo $l['currency']; ?>"><?php echo $l['payment_id']; ?></span>
              </div>
              <div class="mb-col-1">+<?php echo substr($l['customer_id'], 0, -3) . 'XXX'; ?></div>
              <div class="mb-col-1"><?php echo $l['country']; ?></div>
              <div class="mb-col-2">
                <?php if(strlen($l['message']) >= 20) { ?>
                  <span class="mb-has-tooltip" title="<?php echo osc_esc_html($l['message']); ?>"><?php echo osc_esc_html(osc_highlight($l['message'], 20)); ?></span>
                <?php } else { ?>
                  <?php echo osc_esc_html($l['message']); ?>
                <?php } ?>
              </div>
              <div class="mb-col-1"><?php echo $l['expire_date']; ?></div>
              <div class="mb-col-1"><span class="mb-has-tooltip" title="<?php _e('Log datetime', 'sms_payments'); ?>: <?php echo date('Y-m-d H:i:s', strtotime($l['log_date'])); ?>"><?php echo date('Y-m-d', strtotime($l['log_date'])); ?></span></div>
            </div>
          <?php } ?>
        <?php } else { ?>
          <div class="mb-table-row mb-row-empty"><i class="fa fa-warning"></i><span><?php _e('No records found', 'sms_payments'); ?></span></div>
        <?php } ?>
      </div>
    </div>
  </div>



  <!-- HELP TOPICS -->
  <div class="mb-box" id="mb-help">
    <div class="mb-head"><i class="fa fa-question-circle"></i> <?php _e('Help', 'sms_payments'); ?></div>

    <div class="mb-inside">
      <div class="mb-row mb-help"><span class="sup">(1)</span> <div class="h1"><?php _e('Enter how many days will be kept payment logs. After selected number of days, logs will be removed via CRON.', 'sms_payments'); ?></div></div>
    </div>
  </div>
</div>

<?php echo sp_footer(); ?>