DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_item_sms_premium_expire;
CREATE TABLE /*TABLE_PREFIX*/t_item_sms_premium_expire (
  record_id INT NOT NULL UNIQUE AUTO_INCREMENT,
  item_id INT(10) UNSIGNED NOT NULL,
  expire_date DATE,
  
  PRIMARY KEY (record_id),
  FOREIGN KEY (item_id) REFERENCES /*TABLE_PREFIX*/t_item (pk_i_id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';

INSERT INTO /*TABLE_PREFIX*/t_item_sms_premium_expire (item_id) SELECT pk_i_id FROM /*TABLE_PREFIX*/t_item;


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_log_sms_payment;
CREATE TABLE /*TABLE_PREFIX*/t_log_sms_payment (
  record_id INT NOT NULL UNIQUE AUTO_INCREMENT,
  item_id INT(10) UNSIGNED NOT NULL,
  successful BOOLEAN,
  payment_type VARCHAR(100),
  payment_id VARCHAR(100),
  customer_id VARCHAR(100),
  country VARCHAR(100),
  amount INT,
  price VARCHAR(100),
  revenue VARCHAR(100),
  currency VARCHAR(100),
  message VARCHAR(2000),
  expire_date DATE,
  log_date DATETIME,
  
  PRIMARY KEY (record_id)
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';