<?php
$user = User::newInstance()->findByPrimaryKey(Params::getParam('userId'));
$data = ModelTFA::newInstance()->getUserData($user['pk_i_id']);

tfa_load_libs();

// construct($issuer = null, $digits = 6, $period = 30, $algorithm = 'sha1', IQRCodeProvider $qrcodeprovider = null, IRNGProvider $rngprovider = null, ITimeProvider $timeprovider = null)
$tfa = new RobThree\Auth\TwoFactorAuth(tfa_app_name());
$secret = @$data['s_secret'];

if(!isset($user['pk_i_id']) || @$user['s_secret'] != Params::getParam('secret')) {
  osc_add_flash_error_message(__('Authentication data mismatch.', 'two_factor_auth'));
  header('Location:' . osc_base_url());
  exit;
}

if(@$data['b_enabled'] == 0 || $secret == '') {
  osc_add_flash_error_message(__('Two-factor authentication is not enabled or configured.', 'two_factor_auth'));
  header('Location:' . osc_base_url());
  exit;
}
?>

<div class="tfa-wrap tfa-body">
  <div class="tfa-inside">
    <div class="tfa-box">
      <form class="tfa-form nocsrf" action="<?php echo osc_base_url(true); ?>" method="POST">
        <input type="hidden" name="tfa" value="AUTH"/>
        <input type="hidden" name="userId" value="<?php echo osc_esc_html(Params::getParam('userId')); ?>"/>
        <input type="hidden" name="secret" value="<?php echo osc_esc_html(Params::getParam('secret')); ?>"/>

        <strong class="tfa-header"><?php _e('Two-factor Authentication', 'two_factor_auth'); ?></strong>
        <div class="tfa-row">
          <?php _e('Security is on first place, therefore we need you to verify your login. Please enter 6-digits code from your authentication application.', 'two_factor_auth'); ?>
          <?php if(defined('TFA_DEMO') && TFA_DEMO == true) { echo ' (' . $tfa->getCode($secret) . ')'; } ?>
        </div>

        <div class="tfa-row tfa-row-code">
          <div class="tfa-left">
            <input name="code1" type="text" maxlength="1" required autocomplete="off" data-id="1"/>
            <input name="code2" type="text" maxlength="1" required autocomplete="off" data-id="2"/>
            <input name="code3" type="text" maxlength="1" required autocomplete="off" data-id="3"/>
          </div>
          
          <div class="tfa-center">-</div>
          
          <div class="tfa-right">
            <input name="code4" type="text" maxlength="1" required autocomplete="off" data-id="4"/>
            <input name="code5" type="text" maxlength="1" required autocomplete="off" data-id="5"/>
            <input name="code6" type="text" maxlength="1" required autocomplete="off" data-id="6"/>
          </div>
        </div>
        
        <div class="tfa-row tfa-row-buttons">
          <button type="submit" class="tfa-btn"><?php _e('Submit', 'two_factor_auth'); ?></button>
          <div class="tfa-btn-cancel-wrap">
            <a href="<?php echo osc_base_url(); ?>" class="tfa-btn-cancel"><?php _e('Cancel', 'two_factor_auth'); ?></a>
          </div>
        </div>
      </form>
    </div>
  </div>
</div>