<?php
class ModelTFA extends DAO {
private static $instance;

public static function newInstance() {
  if( !self::$instance instanceof self ) {
    self::$instance = new self;
  }
  return self::$instance;
}

function __construct() {
  parent::__construct();
}

public function getTable_user() {
  return DB_TABLE_PREFIX.'t_tfa_user';
}


public function import($file) {
  $path = osc_plugin_resource($file);
  $sql = file_get_contents($path);

  if(!$this->dao->importSQL($sql) ){
    throw new Exception("Error importSQL::ModelTFA<br>" . $file . "<br>" . $this->dao->getErrorLevel() . " - " . $this->dao->getErrorDesc() );
  }
}


public function install($version = '') {
  if($version == '') {
    $this->import('two_factor_auth/model/struct.sql');
    osc_set_preference('version', 100, 'plugin-two_factor_auth', 'INTEGER');
  }

}


public function uninstall() {
  // DELETE ALL TABLES
  $this->dao->query(sprintf('DROP TABLE %s', $this->getTable_user()));


  // DELETE ALL PREFERENCES
  $db_prefix = DB_TABLE_PREFIX;
  $query = "DELETE FROM {$db_prefix}t_preference WHERE s_section = 'plugin-two_factor_auth'";
  $this->dao->query($query);
}



// GET ITEM PASSWORD
public function getUserData($user_id) {
  if($user_id <= 0) {
    return false;
  }
  
  $this->dao->select();
  $this->dao->from($this->getTable_user());
  $this->dao->where('fk_i_user_id', $user_id);
  $result = $this->dao->get();
  
  if($result) {
    $data = $result->row();
    
    if(isset($data['fk_i_user_id'])) {
      return $data;
    }
  }
  
  return false;
}


public function insertData($data) {
  $this->dao->insert($this->getTable_user(), $data);
}

public function replaceData($data) {
  $this->dao->replace($this->getTable_user(), $data);
}

// UPDATE DATA
public function updateData($id, $data) {
  $this->dao->update($this->getTable_user(), $data, array('fk_i_user_id' => $id));
}


}
?>