<?php
$user_id = osc_logged_user_id();

tfa_load_libs();

// construct($issuer = null, $digits = 6, $period = 30, $algorithm = 'sha1', IQRCodeProvider $qrcodeprovider = null, IRNGProvider $rngprovider = null, ITimeProvider $timeprovider = null)
$tfa = new RobThree\Auth\TwoFactorAuth(tfa_app_name());

$secret = '';
$message = '';

try {
  $secret = $tfa->createSecret();
  
  if($secret != '') {
    ModelTFA::newInstance()->replaceData(array(
      'fk_i_user_id' => $user_id,
      'b_enabled' => 0,
      's_secret' => $secret,
      's_code' => null,
      'dt_last_auth_date' => null
    ));
  }
} catch (RobThree\Auth\TwoFactorAuthException $e) {
  $message = $e->getMessage();
}

if($secret == '') {
  osc_add_flash_error_message(sprintf(__('There was problem generating secret code for your profile %s', 'two_factor_auth'), trim($message) <> '' ? '(' . trim($message) . ')' : ''));
  header('Location:' . osc_route_url('tfa-overview'));
  exit;
} else {
  osc_add_flash_ok_message(__('Your configuration has been reset, new secret code has been generated. Please configure authentication in your device.', 'two_factor_auth'));
  header('Location:' . osc_route_url('tfa-overview'));
  exit;
}

?>