<?php
$user_id = osc_logged_user_id();
$data = ModelTFA::newInstance()->getUserData($user_id);
?>

<div class="tfa-account tfa-overview tfa-body">
  <h2><?php _e('Two-factor Authentication', 'two_factor_auth'); ?></h2>
  <div class="tfa-row"><?php echo sprintf(__('Enable two-factor authentication to increase security of your account. You will need %s (or similar 2FA) application installed on your mobile device to complete two-factor authentication setup.', 'two_factor_auth'), '<a href="https://play.google.com/store/apps/details?id=com.google.android.apps.authenticator2" class="tfa-app">' . __('Google authenticator', 'two_factor_auth') . '</a>'); ?></div>
  <div class="tfa-row">
    <?php echo sprintf(__('Two-factor authentication is %s in your account.', 'two_factor_auth'), '<strong class="tfa-enabled">' . strtoupper(@$data['b_enabled'] == 1 ? __('Enabled', 'two_factor_auth') : __('Disabled', 'two_factor_auth')) . '</strong>'); ?>
  </div>
  
  <div class="tfa-row tfa-row-buttons">
    <a href="<?php echo osc_route_url('tfa-setup'); ?>" class="tfa-btn"><?php _e('Setup authentication', 'two_factor_auth'); ?></a>
    <a href="<?php echo osc_route_url('tfa-reset'); ?>" class="tfa-btn tfa-btn-alt"><?php _e('Reset', 'two_factor_auth'); ?></a>
    <a href="<?php echo osc_route_url('tfa-disable'); ?>" class="tfa-btn tfa-btn-alt"><?php _e('Disable', 'two_factor_auth'); ?></a>
  </div>
</div>