<?php
  // Create menu
  $title = __('Configure', 'url_mask');
  ums_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  $enable = mb_param_update('enable', 'plugin_action', 'check', 'plugin-url_mask');

  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'url_mask') );
  }
?>


<div class="mb-body">

  <div class="mb-row mb-errors">
    <div class="mb-line"><strong><?php _e('Do not miss "PLUGIN SETUP" section below!', 'url_mask'); ?></strong></div>
  </div>
  
  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Configure', 'url_mask'); ?></div>

    <div class="mb-inside mb-minify">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <?php if(!ums_is_demo()) { ?>
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <?php } ?>

        <div class="mb-row">
          <label for="enable" class="h1"><span><?php _e('Enable URL masking', 'url_mask'); ?></span></label> 
          <input name="enable" type="checkbox" class="element-slide" <?php echo ($enable == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, plugin will update all CSS, JS and Image links to follow new folder structure based on defined folders in config.php.', 'url_mask'); ?></div>
        </div>


        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(ums_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'url_mask')); ?>"><?php _e('Save', 'url_mask');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'url_mask');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>


  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'url_mask'); ?></div>

    <div class="mb-inside">

      <div class="mb-row">
        <div class="mb-line"><?php _e('Plugin require basic knowledge of PHP to be fully setup.', 'url_mask'); ?></div>
        <div class="mb-line"><?php _e('Let\'s consider "new-oc-content" and "new-oc-includes" folders as your new folder names.', 'url_mask'); ?></div>
        <br/><br/>
        
        <div class="mb-line"><strong><?php _e('Step #1: Update config.php', 'url_mask'); ?></strong></div>
        <div class="mb-line"><?php _e('Go to your config.php file (osclass installation directory) and add there 2 lines:', 'url_mask'); ?></div>

        <div class="mb-row">
          <span class="mb-code">define('OC_INCLUDES_FOLDER', 'new-oc-includes');
            define('OC_CONTENT_FOLDER', 'new-oc-content');
          </span>
        </div>
        <br/>
        
        <div class="mb-line"><strong><?php _e('Step #2: Rename oc-content and oc-includes folders', 'url_mask'); ?></strong></div>
        <div class="mb-line"><?php _e('Go to osclass installation directory and rename folder:', 'url_mask'); ?></div>

        <div class="mb-row">
          <span class="mb-code">oc-includes ==> new-oc-includes
            oc-content ==> new-oc-content
          </span>
        </div>
        <br/>
        
        <div class="mb-line"><strong><?php _e('Step #3: Update .htaccess file', 'url_mask'); ?></strong></div>
        <div class="mb-line"><?php _e('Go to your .htaccess file (osclass installation directory) and add there following lines at start of document:', 'url_mask'); ?></div>

        <div class="mb-row">
          <span class="mb-code">RewriteEngine on
            RewriteBase /
            RewriteRule ^oc-content/(.*)$ /new-oc-content/$1 [R=301,NC,L]
            RewriteRule ^oc-includes/(.*)$ /new-oc-includes/$1 [R=301,NC,L]
          </span>
        </div>
        <br/>
        
        <div class="mb-line"><strong><?php _e('Step #4: Update old directory names in plugins and theme', 'url_mask'); ?></strong></div>
        <div class="mb-line"><?php _e('Ideally, you will download your oc-content/themes and oc-content/plugins folders to desktop and use tools like Notepad++ to find all occurences of "oc-content" and "oc-includes" and replace them.', 'url_mask'); ?></div>

        <div class="mb-row"><br/></div>

        <div class="mb-line"><?php _e('You have now osclass directories masked.', 'url_mask'); ?></div>

      </div>
    </div>
  </div>
</div>


<?php echo ums_footer(); ?>