<?php
/*
  Plugin Name: URL Masking Plugin
  Plugin URI: 
  Description: Mask your Osclass URL to not expose you are using Osclass, avoid possible attacks on your site.
  Version: 1.0.0
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: url_mask
  Plugin update URI: url_mask
  Support URI: https://forums.osclasspoint.com/general-plugins-discussion/
  Product Key: 2moprwc8UrGgUcSiWF2z
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelUMS.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';



// INSTALL FUNCTION - DEFINE VARIABLES
function ums_call_after_install() {
  osc_set_preference('enable', 0, 'plugin-url_mask', 'INTEGER');
  ModelUMS::newInstance()->install();
}


function ums_call_after_uninstall() {
  ModelUMS::newInstance()->uninstall();
}


// ADMIN MENU
function ums_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/url_mask/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/url_mask/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/url_mask/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/url_mask/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/url_mask/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/url_mask/js/bootstrap-switch.js"></script>';



  if( $title == '') { $title = __('Configure', 'url_mask'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>URL Masking Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_base_url() . 'oc-admin/index.php?page=plugins&action=renderplugin&file=url_mask/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'url_mask') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function ums_footer() {
  $pluginInfo = osc_plugin_get_info('url_mask/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint Market" /> OsclassPoint Market</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'url_mask') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'url_mask') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'url_mask') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function ums_admin_menu() {
echo '<h3><a href="#">URL Masking Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'url_mask') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','ums_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function ums_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'ums_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'ums_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'ums_call_after_uninstall');

?>