<?php
  // Create menu
  $title = __('Configure', 'voucher');
  vcr_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value
  // $enable = mb_param_update('enable', 'plugin_action', 'check', 'plugin-voucher');


  $voucher_id = (Params::getParam('voucherId') > 0 ? Params::getParam('voucherId') : Params::getParam('pk_i_id'));

  if(Params::getParam('plugin_action') == 'update') {
    $params = Params::getParamsAsArray();

    $data = array(
      'pk_i_id' => $params['pk_i_id'],
      's_type' => $params['s_type'],
      's_code' => trim($params['s_code']),
      's_description' => $params['s_description'],
      'i_quantity' => ($params['i_quantity'] <= 1 ? 1 : $params['i_quantity']),
      'i_quantity_per_user' => ($params['i_quantity_per_user'] <= 1 ? 1 : $params['i_quantity_per_user']),
      'd_amount' => ($params['d_amount'] <= 0 ? 0 : $params['d_amount']),
      'd_min_amount' => ($params['d_min_amount'] <= 0 ? 0 : $params['d_min_amount']),
      'i_active' => ($params['i_active'] == 'on' ? 1 : $params['i_active']),
      'dt_date_from' => $params['dt_date_from'],
      'dt_date_to' => $params['dt_date_to'],
      's_user_ids' => implode(',', array_unique(array_filter(explode(',', $params['s_user_ids'])))),
      's_group_ids' => implode(',', array_unique(array_filter(explode(',', $params['s_group_ids'])))),
      's_restricted_products' => implode(',', array_unique(array_filter(explode(',', $params['s_restricted_products']))))
    );

    ModelVCR::newInstance()->updateVoucher($data);



    message_ok(__('Voucher has been updated successfully', 'voucher'));
  }


  if(Params::getParam('voucherDeleteId') > 0) {
    ModelVCR::newInstance()->removeVoucher(Params::getParam('voucherDeleteId'));
    message_ok( __('Voucher successfully removed', 'voucher') );
  }

  if(function_exists('osp_param')) {
    if(osp_param('groups_enabled') == 1) {
      $osp_groups = ModelOSP::newInstance()->getGroups();
    }
  }

  $voucher = ModelVCR::newInstance()->getVoucher($voucher_id);

  $s_group_ids_array = explode(',', $voucher['s_group_ids']);
  $s_restricted_products_array  = explode(',', $voucher['s_restricted_products']);

  $available_products_array = array('101', '201', '401', '501', '801', '601', '301', '701', '1001', '1101');

  $allowed_users = array_filter(explode(',', $voucher['s_user_ids']));
?>



<div class="mb-body">
  <!-- VOUCHER LIST SECTION -->
  <div class="mb-box mb-voucher">
    <div class="mb-head">
      <i class="fa fa-wrench"></i> <?php _e('Edit voucher', 'voucher'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>voucher.php" />
        <input type="hidden" name="plugin_action" value="update" />

        <div class="mb-voucher-left">
          <div class="mb-line">
            <label for="pk_i_id" class="h1"><span><?php _e('ID', 'voucher'); ?></span></label>
            <input name="pk_i_id" id="pk_i_id" type="text" readonly value="<?php echo $voucher['pk_i_id']; ?>" style="opacity: 0.7;">
            <div class="mb-explain"><?php _e('Unique voucher identifier, cannot be changed. Only for internal use.', 'voucher'); ?></div>
          </div>

          <div class="mb-line">
            <label for="s_code" class="h2"><span><?php _e('Code', 'voucher'); ?></span></label>
            <input name="s_code" id="s_code" type="text" value="<?php echo $voucher['s_code']; ?>">
            <div class="mb-explain"><?php _e('Voucher code used by customers to apply discount, is case sensitive. Example: 20PERCENTOFF', 'voucher'); ?></div>
          </div>

          <div class="mb-line">
            <label for="s_description" class="h4"><span><?php _e('Description', 'voucher'); ?></span></label>
            <textarea name="s_description" id="s_description"><?php echo $voucher['s_description']; ?></textarea>
            <div class="mb-explain"><?php _e('Details of voucher/promotion, is only for internal use and will not be shown to customer.', 'voucher'); ?></div>
          </div>


          <div class="mb-line">
            <label for="i_active" class="h14"><span title=""><?php _e('Is Active', 'voucher'); ?></span></label>
            <input type="checkbox" name="i_active" id="i_active" class="element-slide" <?php echo ($voucher['i_active'] == 1 ? 'checked' : ''); ?>/>
            <div class="mb-explain"><?php _e('When enabled, voucher will be available to customers.', 'voucher'); ?></div>
          </div>

          <div class="mb-row">&nbsp;</div>



          <div class="mb-line">
            <label for="i_quantity" class="h6"><span title=""><?php _e('Quantity', 'voucher'); ?></span></label>
            <input name="i_quantity" id="i_quantity" type="number" min="1" required value="<?php echo $voucher['i_quantity']; ?>">
            <div class="mb-input-desc">x</div>

            <div class="mb-explain"><?php _e('Enter how many times voucher can be used in total. Minimum amount is 1.', 'voucher'); ?></div>
          </div>

          <div class="mb-line">
            <label for="i_quantity_per_user" class="h7"><span title=""><?php _e('Quantity per User', 'voucher'); ?></span></label>
            <input name="i_quantity_per_user" id="i_quantity_per_user" type="number" required min="1" value="<?php echo $voucher['i_quantity_per_user']; ?>">
            <div class="mb-input-desc">x</div>

            <div class="mb-explain"><?php _e('Enter how many times voucher can be used by one customer. Minimum amount is 1.', 'voucher'); ?></div>
          </div>

          <div class="mb-line">
            <label for="i_quantity_used" class="h8"><span title=""><?php _e('Quantity Already Used', 'voucher'); ?></span></label>
            <input name="i_quantity_used" id="i_quantity_used" type="number" disabled value="<?php echo $voucher['i_quantity_used']; ?>">
            <div class="mb-input-desc">x</div>

            <div class="mb-explain"><?php _e('Shows current usage of voucher (how many times it has been used). Cannot be changed.', 'voucher'); ?></div>
          </div>

          <div class="mb-row">&nbsp;</div>

          <div class="mb-line">
            <label for="s_type" class="h3"><span><?php _e('Type', 'voucher'); ?></span></label>
            <select name="s_type" id="s_type">
              <option value="PERCENT" <?php if($voucher['s_type'] == 'PERCENT' || $voucher['s_type'] == '') { ?>selected="selected"<?php } ?>><?php _e('Percent', 'voucher'); ?></option>
              <option value="AMOUNT" <?php if($voucher['s_type'] == 'AMOUNT') { ?>selected="selected"<?php } ?>><?php _e('Amount', 'voucher'); ?></option>
              <option value="CREDIT" <?php if($voucher['s_type'] == 'CREDIT') { ?>selected="selected"<?php } ?>><?php _e('Credit', 'voucher'); ?></option>
            </select> 

            <div class="mb-explain"><?php _e('Select type of voucher. Percent voucher provides percentage discount from whole order, Amount voucher provides fixed amount discount, Credit vouchers allows users to increase their wallet funds (cannot be used in cart).', 'voucher'); ?></div>
          </div>

          <div class="mb-line">
            <label for="d_amount" class="h9"><span title=""><?php _e('Reduction Amount', 'voucher'); ?></span></label>
            <input name="d_amount" id="d_amount" type="number" required min="0" value="<?php echo round($voucher['d_amount'], 2); ?>">
            <div class="mb-input-desc">% or <?php if(function_exists('osp_currency')) { echo osp_currency(); } else { echo '$'; } ?></div>

            <div class="mb-explain"><?php _e('For percentage type, enter integer amount of percents (i.e. 25 - means 25% off). For amount type of voucher, enter fixed amount that will be discounted (i.e. 5 - means 5$ off). For credit type of voucher, enter amount that user get signed to their wallet (i.e. 20 - means their wallet will be boosted by 20$).', 'voucher'); ?></div>
          </div>

          <div class="mb-line">
            <label for="d_min_amount" class="h10"><span title=""><?php _e('Minimum Order Amount', 'voucher'); ?></span></label>
            <input name="d_min_amount" id="d_min_amount" type="number" required min="0" value="<?php echo round($voucher['d_min_amount'], 2); ?>">
            <div class="mb-input-desc"><?php if(function_exists('osp_currency')) { echo osp_currency(); } else { echo '$'; } ?></div>

            <div class="mb-explain"><?php _e('Minimum cart/order amount for that voucher can be used. I.e. if customer has 20$ in cart, but minimum voucher amount is 50$, voucher will not be possible to add into cart and if it is in cart already, it will be dropped.', 'voucher'); ?></div>
          </div>

          <div class="mb-row">&nbsp;</div>


          <div class="mb-line">
            <label for="dt_date_from" class="h11"><span title=""><?php _e('Available From', 'voucher'); ?></span></label>
            <input name="dt_date_from" id="dt_date_from" type="date" value="<?php echo @$voucher['dt_date_from'] <> '' ? date("Y-m-d", strtotime(@$voucher['dt_date_from'])): date("Y-m-d"); ?>">
            <div class="mb-explain"><?php _e('Enter date from when is voucher available.', 'voucher'); ?></div>
          </div>

          <div class="mb-line">
            <label for="dt_date_to" class="h12"><span title=""><?php _e('Available Until', 'voucher'); ?></span></label>
            <input name="dt_date_to" id="dt_date_to" type="date" value="<?php echo @$voucher['dt_date_to'] <> '' ? date("Y-m-d", strtotime(@$voucher['dt_date_to'])): date("Y-m-d", strtotime('+1 years')); ?>">
            <div class="mb-explain"><?php _e('Enter date to when is voucher available.', 'voucher'); ?></div>
          </div>

          <div class="mb-line">
            <label for="dt_date_created" class="h13"><span title=""><?php _e('Created On', 'voucher'); ?></span></label>
            <input name="dt_date_created" id="dt_date_created" type="date" disabled value="<?php echo @$voucher['dt_date_created'] <> '' ? date("Y-m-d", strtotime(@$voucher['dt_date_created'])): date("Y-m-d"); ?>">
            <div class="mb-explain"><?php _e('Shows date when voucher has been created.', 'voucher'); ?></div>
          </div>


        </div>


        <div class="mb-voucher-right">

          <div class="mb-row mb-row-select-multiple">
            <label for="s_restricted_products"><span><?php _e('Restricted Products', 'voucher'); ?></span></label> 

            <input type="hidden" name="s_restricted_products" id="s_restricted_products" value="<?php echo $voucher['s_restricted_products']; ?>"/>
            <select id="s_restricted_products_multiple" name="s_restricted_products_multiple" multiple>
              <?php if(!function_exists('osp_product_type_name')) { ?>
                <option value="" selected="selected"><?php _e('Osclass Pay Plugin not installed, cannot get list', 'voucher'); ?></option>
              <?php } else { ?>
                <?php foreach($available_products_array as $p) { ?>
                  <option value="<?php echo $p; ?>" <?php if(in_array($p, $s_restricted_products_array)) { ?>selected="selected"<?php } ?>><?php echo osp_product_type_name($p); ?></option>
                <?php } ?>
              <?php } ?>
            </select>

            <div class="mb-explain"><?php _e('Select product types, that are restricted to be used with this voucher. I.e. if you choose Credit Packs as restricted product, voucher cannot be added into cart that contains any credit pack.', 'voucher'); ?></div>
          </div>

          <div class="mb-row"></div>


          <div class="mb-row mb-row-select-multiple">
            <label for="s_group_ids"><span><?php _e('Enabled Membership Groups', 'voucher'); ?></span></label> 

            <input type="hidden" name="s_group_ids" id="s_group_ids" value="<?php echo $voucher['s_group_ids']; ?>"/>
            <select id="s_group_ids_multiple" name="s_group_ids_multiple" multiple>
              <?php if(count($osp_groups) <= 0) { ?>
                <option value="" selected="selected"><?php _e('No groups in Osclass Pay Plugin', 'voucher'); ?></option>
              <?php } else { ?>
                <?php foreach($osp_groups as $g) { ?>
                  <option value="<?php echo $g['pk_i_id']; ?>" <?php if(in_array($g['pk_i_id'], $s_group_ids_array)) { ?>selected="selected"<?php } ?>><?php echo $g['s_name']; ?></option>
                <?php } ?>
              <?php } ?>
            </select>

            <div class="mb-explain"><?php _e('Select membership groups from Osclass Pay Plugin those are allowed to use this voucher. Customers those are not in selected groups will not be able to use voucher.', 'voucher'); ?></div>
          </div>

          <div class="mb-row"></div>

          <div class="mb-line">
            <label for="" class="h17"><span title=""><?php _e('Enabled Users', 'voucher'); ?></span></label>
            <input name="s_user_ids" id="s_user_ids" type="hidden" value="<?php echo $voucher['s_user_ids']; ?>">
            <input name="vcr-add-user" id="vcr-add-user" type="text" style="margin-right:10px;" size="60" placeholder="<?php echo osc_esc_html(__('Enter user name or email...', 'voucher')); ?>">
            <div class="mb-explain"><?php _e('Select membership groups from Osclass Pay Plugin those are allowed to use this voucher. Customers those are not in selected groups will not be able to use voucher. Keep blank to disable.', 'voucher'); ?></div>
          </div>

          <div class="mb-line">
            <div class="mb-table mb-table-voucher-users">
              <div class="mb-table-head">
                <div class="mb-col-6 mb-align-left"><?php _e('ID', 'voucher');?></div>
                <div class="mb-col-14 mb-align-left"><?php _e('Allowed user', 'voucher');?></div>
                <div class="mb-col-4">&nbsp;</div>
              </div>

              <div class="mb-table-row mb-row-empty" <?php if(count($allowed_users) > 0) { ?>style="display:none"<?php } ?>>
                <i class="fa fa-warning"></i><span><?php _e('No user restriction', 'voucher'); ?></span>
              </div>

              <?php if(count($allowed_users) > 0) { ?>
                <?php foreach($allowed_users as $u) { ?>
                  <?php $user = User::newInstance()->findByPrimaryKey($u); ?>

                  <div class="mb-table-row" data-id="<?php echo $u; ?>">
                    <div class="mb-col-6 mb-align-left"><?php echo $u; ?></div>
                    <div class="mb-col-14 mb-align-left"><?php echo (@$user['s_name'] <> '' ? $user['s_name'] : __('Unknown name')); ?></div>
                    <div class="mb-col-4"><a href="#" class="vcr-remove-user"><i class="fa fa-trash"></i></a></div>
                  </div>
                <?php } ?>
              <?php } ?>
            </div>

          </div>
        </div>


        <div class="mb-row">&nbsp;</div>


        <div class="mb-foot">
          <?php if(!vcr_is_demo()) { ?>
            <a href="<?php echo osc_route_admin_url('vcr-admin-delete', array('voucherDeleteId' => $voucher['pk_i_id'])); ?>" class="mb-button remove" title="<?php echo osc_esc_html(__('Remove voucher', 'voucher')); ?>" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove this voucher? Action cannot be undone.', 'voucher')); ?>')"><?php _e('Remove voucher', 'voucher'); ?></a>
            <button type="submit" class="mb-button"><?php _e('Update', 'voucher');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>

</div>



<script>
  $(document).ready(function() {
    vcrManageType($('select#s_type').val(), 0);

    $('body').on('change', 'select#s_type', function(e) {
      vcrManageType($(this).val(), 200);
    });
  });

  function vcrManageType(vType, vSpeed) {
    if(vType == 'CREDIT') {
      $('#i_quantity_per_user').val(1).prop('readonly', true);
      $('#d_min_amount').val(0).prop('readonly', true);
      $('#s_restricted_products_multiple, #s_restricted_products').val('').prop('readonly', true);
      $('#i_quantity_per_user, #d_min_amount').closest('.mb-line').slideUp(vSpeed);
      $('#s_restricted_products_multiple').closest('.mb-row').slideUp(vSpeed);
    } else {
      $('#i_quantity_per_user').prop('readonly', false);
      $('#d_min_amount').prop('readonly', false);
      $('#s_restricted_products_multiple, #s_restricted_products').prop('readonly', false);
      $('#i_quantity_per_user, #d_min_amount').closest('.mb-line').slideDown(vSpeed);
      $('#s_restricted_products_multiple').closest('.mb-row').slideDown(vSpeed);
    }
  }
</script>


<script type="text/javascript">
  var user_lookup_error = "<?php echo osc_esc_js(__('Error getting data, user not found', 'voucher')); ?>";
  var user_lookup_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=vcr_find_user&id=";
  var user_lookup_base = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=userajax";
</script>


<?php echo vcr_footer(); ?>	