<?php
  // Create menu
  $title = __('List of vouchers', 'voucher');
  vcr_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value
  // $enable = mb_param_update('enable', 'plugin_action', 'check', 'plugin-voucher');


  if(Params::getParam('voucherDeleteId') > 0) {
    ModelVCR::newInstance()->removeVoucher(Params::getParam('voucherDeleteId'));
    message_ok(sprintf(__('Voucher ID #%s successfully removed', 'voucher'), Params::getParam('voucherDeleteId')));
  }

  if(Params::getParam('what') == 'new') {
    $new_voucher_id = ModelVCR::newInstance()->insertVoucher();
    message_ok(sprintf(__('Voucher ID #%s successfully created', 'voucher'), $voucher_id)); 
  }

?>



<div class="mb-body">
  <?php if(!vcr_is_osclasspay_ok()) { ?>
    <div class="mb-row mb-errors">
      <div class="mb-line"><?php _e('This plugin require Osclass Pay Plugin to be installed with at least version 1.8.0!', 'voucher'); ?></div>
    </div>
  <?php } ?>

  <!-- VOUCHER LIST SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-list"></i> <?php _e('List of vouchers', 'voucher'); ?>
    </div>

    <div class="mb-inside">
      <div class="mb-table mb-table-vouchers">
        <div class="mb-table-head">
          <div class="mb-col-1"><?php _e('ID', 'voucher');?></div>
          <div class="mb-col-2"><?php _e('Code', 'voucher'); ?></div>
          <div class="mb-col-1"><?php _e('Type', 'voucher'); ?></div>
          <div class="mb-col-3"><?php _e('Description', 'voucher'); ?></div>
          <div class="mb-col-2"><?php _e('Qty', 'voucher'); ?></div>
          <div class="mb-col-2"><?php _e('Qty per User', 'voucher'); ?></div>
          <div class="mb-col-2"><?php _e('Qty Used', 'voucher'); ?></div>
          <div class="mb-col-2"><?php _e('Reduction / Credits', 'voucher'); ?></div>
          <div class="mb-col-2"><?php _e('Min. Amount', 'voucher'); ?></div>
          <div class="mb-col-2"><?php _e('From', 'voucher'); ?></div>
          <div class="mb-col-2"><?php _e('To', 'voucher'); ?></div>
          <div class="mb-col-1"><?php _e('Status', 'voucher'); ?></div>
          <div class="mb-col-2">&nbsp;</div>
        </div>
      

        <?php $vouchers = ModelVCR::newInstance()->getVouchers(); ?>

        <?php if(count($vouchers) <= 0) { ?>
          <div class="mb-table-row mb-row-empty">
            <i class="fa fa-warning"></i><span><?php _e('No vouchers has been found', 'voucher'); ?></span>
          </div>
        <?php } else { ?>
          <?php foreach($vouchers as $v) { ?>
            <?php $status = vcr_voucher_status($v['pk_i_id']); ?>
            <div class="mb-table-row<?php if($v['pk_i_id'] == @$new_voucher_id) { ?> vcr-highlight<?php } ?>">
              <div class="mb-col-1"><?php echo $v['pk_i_id']; ?></div>
              <div class="mb-col-2"><strong><?php echo $v['s_code']; ?></strong></div>
              <div class="mb-col-1"><?php echo ucfirst(strtolower($v['s_type'])); ?></div>
              <div class="mb-col-3 mb-has-tooltip-user" title="<?php echo osc_esc_html($v['s_description']); ?>"><?php echo osc_highlight($v['s_description'], 20); ?></div>
              <div class="mb-col-2"><?php echo $v['i_quantity']; ?>x</div>
              <div class="mb-col-2">
                <?php
                  if($v['s_type'] == 'CREDIT') {
                    echo '<span class="mb-has-tooltip-user" style="color:#888;" title="' . osc_esc_html(__('Not applicable for this type of voucher', 'voucher')) . '">' . __('n/a', 'voucher') . '</span>';
                  } else {
                    echo $v['i_quantity_per_user'] . 'x';
                  }
                ?>
              </div>

              <div class="mb-col-2"><?php echo $v['i_quantity_used']; ?>x</div>
              <div class="mb-col-2">
                <?php
                  if($v['s_type'] == 'AMOUNT' || $v['s_type'] == 'CREDIT') {
                    echo (function_exists('osp_format_price') ? osp_format_price($v['d_amount']) : $v['d_amount']);
                  } else if($v['s_type'] == 'PERCENT') {
                    echo round($v['d_amount'], 2) . '%';
                  }
                ?>
              </div>
              <div class="mb-col-2">
                <?php
                  if($v['s_type'] == 'CREDIT') {
                    echo '<span class="mb-has-tooltip-user" style="color:#888;" title="' . osc_esc_html(__('Not applicable for this type of voucher', 'voucher')) . '">' . __('n/a', 'voucher') . '</span>';
                  } else {
                    echo (function_exists('osp_format_price') ? osp_format_price($v['d_min_amount']) : $v['d_min_amount']);
                  }
                ?>
              </div>
              <div class="mb-col-2 mb-has-tooltip-user" style="color:#888;" title="<?php echo date('Y-m-d H:i:s', strtotime($v['dt_date_from'])); ?>"><?php echo date('Y-m-d', strtotime($v['dt_date_from'])); ?></div>
              <div class="mb-col-2 mb-has-tooltip-user" style="color:#888;" title="<?php echo date('Y-m-d H:i:s', strtotime($v['dt_date_to'])); ?>"><?php echo date('Y-m-d', strtotime($v['dt_date_to'])); ?></div>
 
              <div class="mb-col-1 mb-has-tooltip-user" title="<?php echo osc_esc_html($status['message']); ?>">
                <?php if($status['error'] <> 'OK') { ?>
                  <i class="fa fa-exclamation-circle" style="color:#d84a4a;font-size:18px;"></i>
                <?php } else { ?>
                  <i class="fa fa-check-circle" style="color:#72C279;font-size:18px;"></i>
                <?php } ?>
              </div>

              <div class="mb-col-2 mb-buttons">
                <a href="<?php echo osc_route_admin_url('vcr-admin-edit', array('voucherId' => $v['pk_i_id'])); ?>" class="mb-vcr-edit mb-button-blue mb-has-tooltip-light" title="<?php echo osc_esc_html(__('Edit voucher', 'voucher')); ?>"><i class="fa fa-pencil"></i></a>
                <a href="<?php echo osc_route_admin_url('vcr-admin-delete', array('voucherDeleteId' => $v['pk_i_id'])); ?>" class="mb-vcr-remove mb-button-red mb-has-tooltip-light" title="<?php echo osc_esc_html(__('Remove voucher', 'voucher')); ?>" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove this voucher? Action cannot be undone.', 'voucher')); ?>')"><i class="fa fa-trash"></i></a>
              </div>
            </div>
          <?php } ?>
        <?php } ?>
      </div>

      <a class="mb-button-green mb-new-voucher" href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=voucher/admin/vouchers.php&what=new"><i class="fa fa-plus-circle"></i> <?php _e('Create a new voucher', 'voucher'); ?></a>
    </div>
  </div>


</div>


<?php echo vcr_footer(); ?>