<?php

// GET USER DATA
function vcr_find_user() {
  $user_id = Params::getParam('id');
  
  if($user_id <> '' && $user_id > 0) {
    $user = User::newInstance()->findByPrimaryKey($user_id);
    echo json_encode(array('user' => array('id' => $user_id, 'name' => $user['s_name'], 'email' => $user['s_email'])));
  } else {
    echo json_encode(array('user' => array('id' => 0, 'name' => '', 'email' =>'')));
  }

  exit;
}

osc_add_hook('ajax_admin_vcr_find_user', 'vcr_find_user');


// CHECK VOUCHER STATUS
function vcr_voucher_status($id) {
  $voucher = ModelOSP::newInstance()->getVoucher($id);

  if($voucher['pk_i_id'] <= 0) {
    return array('error' => 'NOTFOUND', 'message' => __('Invalid code, no voucher has been found', 'voucher'));

  } else if($voucher['dt_date_from'] <> '' && date('Y-m-d H:i:s', strtotime($voucher['dt_date_from'])) > date('Y-m-d H:i:s')) {
    return array('error' => 'NOTSTARTED', 'message' => sprintf(__('Voucher is not valid yet, promotion starts on %s', 'voucher'), date('Y-m-d', strtotime($voucher['dt_date_from']))));

  } else if($voucher['dt_date_to'] <> '' && date('Y-m-d H:i:s', strtotime($voucher['dt_date_to'])) < date('Y-m-d H:i:s')) {
    return array('error' => 'ENDED', 'message' => sprintf(__('Voucher is not valid anymore, promotion has ended on %s', 'voucher'), date('Y-m-d', strtotime($voucher['dt_date_to']))));

  } else if($voucher['i_quantity_used'] >= $voucher['i_quantity']) {
    return array('error' => 'USAGE', 'message' => __('Voucher is not valid anymore, it has reached maximum usage already', 'voucher'));

  } else if($voucher['i_active'] <> 1) {
    return array('error' => 'INACTIVE', 'message' => __('Voucher is not valid anymore, promotion has been cancelled', 'voucher'));

  }


  return array('error' => 'OK', 'message' => __('Voucher is valid/active', 'voucher'));
}


// CHECK IF OSCLASS PAY INSTALLED AND HAS CORRECT VERSION
function vcr_is_osclasspay_ok() {
  if(!function_exists('osp_pay_fee')) {
    return false;
  }
  
  $ospInfo = @osc_plugin_get_info('osclass_pay/index.php');
  $version_id = @$ospInfo['version'];
  
  if($version_id == '') {
    return false;
  }
  
  $version = (int)str_replace('.', '', $version_id);
  
  if($version < 180) {
    return false; 
  }
  
  return true;
}


// GET PLUGIN PARAMETER
function vcr_param($name) {
  return osc_get_preference($name, 'plugin-voucher');
}


// CHECK IF RUNNING ON DEMO
function vcr_is_demo() {
  if(osc_logged_admin_username() == 'admin') {
    return false;
  } else if(isset($_SERVER['HTTP_HOST']) && (strpos($_SERVER['HTTP_HOST'],'mb-themes') !== false || strpos($_SERVER['HTTP_HOST'],'abprofitrade') !== false)) {
    return true;
  } else {
    return false;
  }
}


// CREATE LOCALE SELECT BOX
function vcr_locale_box( $file, $param = '', $id = -1 ) {
  $html = '';
  $locales = OSCLocale::newInstance()->listAllEnabled();
  $current = vcr_get_locale();

  if($id > 0 && $param <> '') {
    $id_string = '&' . $param . '=' . $id;
  } else {
    $id_string = '';
  }

  $html .= '<select rel="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=voucher/admin/' . $file . $id_string . '" class="mb-select mb-select-locale" id="vcrLocale" name="vcrLocale">';

  foreach( $locales as $l ) {
    $html .= '<option value="' . $l['pk_c_code'] . '" ' . ($current == $l['pk_c_code'] ? 'selected="selected"' : '') . '>' . $l['s_name'] . '</option>';
  }
 
  $html .= '</select>';
  return $html;
}



// CORE FUNCTIONS
if(!function_exists('mb_param_update')) {
  function mb_param_update( $param_name, $update_param_name, $type = NULL, $plugin_var_name = NULL ) {
  
    $val = '';
    if( $type == 'check') {

      // Checkbox input
      if( Params::getParam( $param_name ) == 'on' ) {
        $val = 1;
      } else {
        if( Params::getParam( $update_param_name ) == 'done' ) {
          $val = 0;
        } else {
          $val = ( osc_get_preference( $param_name, $plugin_var_name ) != '' ) ? osc_get_preference( $param_name, $plugin_var_name ) : '';
        }
      }
    } else {

      // Other inputs (text, pasword, ...)
      if( Params::getParam( $update_param_name ) == 'done' && Params::existParam($param_name)) {
        $val = Params::getParam( $param_name );
      } else {
        $val = ( osc_get_preference( $param_name, $plugin_var_name) != '' ) ? osc_get_preference( $param_name, $plugin_var_name ) : '';
      }
    }


    // If save button was presed, update param
    if( Params::getParam( $update_param_name ) == 'done' ) {

      if(osc_get_preference( $param_name, $plugin_var_name ) == '') {
        osc_set_preference( $param_name, $val, $plugin_var_name, 'STRING');  
      } else {
        $dao_preference = new Preference();
        $dao_preference->update( array( "s_value" => $val ), array( "s_section" => $plugin_var_name, "s_name" => $param_name ));
        osc_reset_preferences();
        unset($dao_preference);
      }
    }

    return $val;
  }
}



if(!function_exists('mesage_ok')) {
  function mesage_ok( $text ) {
    $final  = '<div clas="flashmesage flashmesage-ok flashmesage-inline">';
    $final .= $text;
    $final .= '</div>';
    echo $final;
  }
}


if(!function_exists('mesage_error')) {
  function mesage_error( $text ) {
    $final  = '<div clas="flashmesage flashmesage-error flashmesage-inline">';
    $final .= $text;
    $final .= '</div>';
    echo $final;
  }
}


if( !function_exists('osc_is_contact_page') ) {
  function osc_is_contact_page() {
    $location = Rewrite::newInstance()->get_location();
    $section = Rewrite::newInstance()->get_section();
    if( $location == 'contact' ) {
      return true ;
    }

    return false ;
  }
}


// COOKIES WORK
if(!function_exists('mb_set_cookie')) {
  function mb_set_cookie($name, $val) {
    Cookie::newInstance()->set_expires( 86400 * 30 );
    Cookie::newInstance()->push($name, $val);
    Cookie::newInstance()->set();
  }
}


if(!function_exists('mb_get_cookie')) {
  function mb_get_cookie($name) {
    return Cookie::newInstance()->get_value($name);
  }
}

if(!function_exists('mb_drop_cookie')) {
  function mb_drop_cookie($name) {
    Cookie::newInstance()->pop($name);
  }
}


if(!function_exists('mb_generate_rand_string')) {
  function mb_generate_rand_string($length = 10) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $charactersLength = strlen($characters);
    $randomString = '';

    for ($i = 0; $i < $length; $i++) {
      $randomString .= $characters[rand(0, $charactersLength - 1)];
    }

    return $randomString;
  }
}


?>