<?php
/*
  Plugin Name: Voucher & Discount Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/payments-and-shopping/voucher-discount-osclass-plugin-i108
  Description: Enables to generate vouchers and discounts for Osclass Pay Plugin
  Version: 1.1.1
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: voucher
  Plugin update URI: voucher
  Support URI: https://forums.osclasspoint.com/voucher-discount-osclass-plugin/
  Product Key: Q3JkTD1eH1LjQKE07IVz
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelVCR.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';

osc_enqueue_style('font-awesome47', '//maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css');
osc_enqueue_style('tipped', osc_base_url() . 'oc-content/plugins/voucher/css/tipped.css');

osc_register_script('tipped', osc_base_url() . 'oc-content/plugins/voucher/js/tipped.js', array('jquery'));
osc_enqueue_script('tipped');


// ROUTES
osc_add_route('vcr-admin-edit', 'voucher/admin/edit/([0-9]+)', 'osclasspay/admin/edit/{voucherId}', osc_plugin_folder(__FILE__).'admin/voucher.php');
osc_add_route('vcr-admin-delete', 'voucher/admin/delete/([0-9]+)', 'osclasspay/admin/delete/{voucherDeleteId}', osc_plugin_folder(__FILE__).'admin/vouchers.php');


// INSTALL FUNCTION - DEFINE VARIABLES
function vcr_call_after_install() {
  //osc_set_preference('enable', 1, 'plugin-voucher', 'INTEGER');

  ModelVCR::newInstance()->install();
}


function vcr_call_after_uninstall() {
  ModelVCR::newInstance()->uninstall();
}


// ADMIN MENU
function vcr_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/voucher/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/voucher/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/voucher/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="//fonts.googleapis.com/css?family=Open+Sans:300,600&amp;subset=latin,latin-ext" rel="stylesheet" type="text/css" />';
  echo '<link href="//maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/voucher/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/voucher/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/voucher/js/bootstrap-switch.js"></script>';



  if( $title == '') { $title = __('Configure', 'voucher'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Voucher & Discount Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=voucher/admin/vouchers.php"><i class="fa fa-list-ul"></i><span>' . __('Vouchers', 'voucher') . '</span></a></li>';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=voucher/admin/vouchers.php&what=new"><i class="fa fa-plus-circle"></i><span>' . __('New voucher', 'voucher') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}


// ADMIN FOOTER
function vcr_footer() {
  $pluginInfo = osc_plugin_get_info('voucher/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint.com" /> OsclassPoint.com</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'voucher') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'voucher') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'voucher') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}


// ADD MENU LINK TO PLUGIN LIST
function vcr_admin_menu() {
echo '<h3><a href="#">Voucher Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/vouchers.php') . '">&raquo; ' . __('Vouchers', 'voucher') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','vcr_admin_menu', 1);


// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function vcr_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/vouchers.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'vcr_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'vcr_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'vcr_call_after_uninstall');

?>