$(document).ready(function(){
  $('body').on('click', '.vcr-remove-user', function(e){
    e.preventDefault();

    var userId = $(this).closest('.mb-table-row').attr('data-id');
    var areIds = ',' + $('#s_user_ids').val() + ',';

    if(userId > 0) {

      areIds = areIds.replace(',' + userId + ',', ',');
      areIds = areIds.replace(',,,', '');
      areIds = areIds.replace(',,', '');

      $('#s_user_ids').val(areIds);
     
      $('.mb-table-voucher-users .mb-table-row[data-id="' + userId + '"]').slideUp(180, function() {
        $(this).remove();

        if($('.mb-table-voucher-users .mb-table-row:not(.mb-row-empty)').length <= 0) {
          $('.mb-table-voucher-users .mb-row-empty').slideDown(200);
        }
      });

    }
  });




  // USER LOOKUP
  var name = $('.mb-box input[name="vcr-add-user"]');

  if(name.length) {
    name.prop('autocomplete', 'off');
    
    name.autocomplete({
      source: user_lookup_base,
      minLength: 0,
      select: function (event, ui) {
        if (ui.item.id == '') {
          return false;
        } else {
          $.getJSON(
            user_lookup_url + ui.item.id,
            {'s_username': name.val()},
            function(data){
              if(data.user.id != 0) {
                $('#s_user_ids').val($('#s_user_ids').val() + ',' + data.user.id);
                $('#vcr-add-user').val(data.user.name);
 
                $('.mb-table-voucher-users .mb-table-row[data-id="' + data.user.id + '"]').remove();   // remove if already exists
 
                var html = '<div class="mb-table-row" data-id="' + data.user.id + '" style="display:none;">';
                html += '<div class="mb-col-6 mb-align-left">' + data.user.id + '</div>';
                html += '<div class="mb-col-14 mb-align-left">' + data.user.name + '</div>';
                html += '<div class="mb-col-4"><a href="#" class="vcr-remove-user"><i class="fa fa-trash"></i></a></div>';
                html += '</div>';


                $('.mb-table-voucher-users').append(html)

                $('.mb-table-voucher-users .mb-row-empty').slideUp(200);
                $('.mb-table-voucher-users .mb-table-row[data-id="' + data.user.id + '"]').slideDown(200);


              } else {
                blg_message(user_lookup_error, 'error');
              }
            }
          );
        }

        $('#fk_i_user_id, #fk_i_os_user_id').val(ui.item.id);
      },
      search: function () {
        $('#fk_i_user_id, #fk_i_os_user_id').val('');
      }
    });

    $('.ui-autocomplete').css('zIndex', 10000);
  }
 

  // HIDE MESSAGE
   $('body').on('click', '.mb-message-js', function(e){
     e.preventDefault();
     $('.mb-message-js > div').fadeOut(300, function() {
       $('.mb-message-js > div').remove();
     });
  });
   

  // CHANGE FILE INPUT NAME
  $('input[name="image"]').change(function() {
    if( $(this)[0].files[0]['name'] != '' ) {
      $('.mb-file .wrap > span').text( $(this)[0].files[0]['name'] );
    }
  });


  // CATEGORY MULTI SELECT
  $('body').on('change', '.mb-row-select-multiple select', function(e){
    $(this).closest('.mb-row-select-multiple').find('input[type="hidden"]').val($(this).val());
  });


  // ON LOCALE CHANGE RELOAD PAGE
  $('body').on('change', 'select.mb-select-locale', function(e){
    window.location.replace($(this).attr('rel') + "&vcrLocale=" + $(this).val());
  });


  // HELP TOPICS
  $('#mb-help > .mb-inside > .mb-row.mb-help > div').each(function(){
    var cl = $(this).attr('class');
    $('label.' + cl + ' span').addClass('mb-has-tooltip').prop('title', $(this).text());
  });

  $('.mb-row label').click(function() {
    var cl = $(this).attr('class');
    
    if($('#mb-help > .mb-inside > .mb-row.mb-help > div.' + cl).length) {
      var pos = $('#mb-help > .mb-inside > .mb-row.mb-help > div.' + cl).offset().top - $('.navbar').outerHeight() - 12;
      $('html, body').animate({
        scrollTop: pos
      }, 1400, function(){
        $('#mb-help > .mb-inside > .mb-row.mb-help > div.' + cl).addClass('mb-help-highlight');
      });

      return false;
    }
  });


  // ON-CLICK ANY ELEMENT REMOVE HIGHLIGHT
  $('body, body *').click(function(){
    $('.mb-help-highlight').removeClass('mb-help-highlight');
  });


  // GENERATE TOOLTIPS
  Tipped.create('.mb-has-tooltip', { maxWidth: 200, radius: false, behavior: 'hide' });
  Tipped.create('.mb-has-tooltip-user', { maxWidth: 350, radius: false, size: 'medium', behavior: 'hide' });


  // CHECKBOX & RADIO SWITCH
  $.fn.bootstrapSwitch.defaults.size = 'small';
  $.fn.bootstrapSwitch.defaults.labelWidth = '0px';
  $.fn.bootstrapSwitch.defaults.handleWidth = '50px';

  $(".element-slide").bootstrapSwitch();



  // MARK ALL
  $('input.mb_mark_all').click(function(){
    if ($(this).is(':checked')) {
      $('input[name^="' + $(this).val() + '"]').prop( "checked", true );
    } else {
      $('input[name^="' + $(this).val() + '"]').prop( "checked", false );
    }
  });

});


var timeoutHandle;

function vcr_message(html, type = '') {
  window.clearTimeout(timeoutHandle);

  $('.mb-message-js').fadeOut(0);
  $('.mb-message-js').attr('class', '').addClass('mb-message-js').addClass(type);
  $('.mb-message-js').fadeIn(200).html('<div>' + html + '</div>');

  var timeoutHandle = setTimeout(function(){
    $('.mb-message-js > div').fadeOut(300, function() {
      $('.mb-message-js > div').remove();
    });
  }, 10000);
}