SET FOREIGN_KEY_CHECKS=0;


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_vcr_voucher;
CREATE TABLE /*TABLE_PREFIX*/t_vcr_voucher (
  pk_i_id int NOT NULL AUTO_INCREMENT,
  s_type varchar(20) DEFAULT 'PERCENT',
  s_code varchar(20) DEFAULT '',
  s_description varchar(200) DEFAULT '',
  i_quantity int NOT NULL DEFAULT '100',
  i_quantity_per_user int DEFAULT '1',
  i_quantity_used int DEFAULT '0',
  d_amount decimal(20,10) NOT NULL DEFAULT '0.0000000000',
  d_min_amount decimal(20,10) NOT NULL DEFAULT '0.0000000000',
  i_active smallint(1) NOT NULL DEFAULT '0',
  dt_date_from datetime,
  dt_date_to datetime,
  s_user_ids varchar(5000) DEFAULT '',
  s_group_ids varchar(200) DEFAULT '',
  s_restricted_products varchar(100) DEFAULT '',
  dt_date_created TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
    
  PRIMARY KEY (pk_i_id)
) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';


DROP TABLE IF EXISTS /*TABLE_PREFIX*/t_vcr_voucher_stats;
CREATE TABLE /*TABLE_PREFIX*/t_vcr_voucher_stats (
  pk_i_id int NOT NULL AUTO_INCREMENT,
  fk_i_voucher_id INT NOT NULL,
  fk_i_user_id INT NOT NULL,
  dt_datetime TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
  
  PRIMARY KEY (pk_i_id),
  FOREIGN KEY (fk_i_voucher_id) REFERENCES /*TABLE_PREFIX*/t_vcr_voucher (pk_i_id) ON DELETE CASCADE ON UPDATE CASCADE

) ENGINE=InnoDB DEFAULT CHARACTER SET 'UTF8' COLLATE 'UTF8_GENERAL_CI';

  

SET FOREIGN_KEY_CHECKS=1;
