<?php
  // Create menu
  $title = __('Configure', 'webp_images');
  wbp_menu($title);


  if(Params::getParam('what') == 'remove' && !wbp_is_demo()) {
    wbp_remove_webp_images();
    
    osc_add_flash_ok_message(__('WebP images has been removed successfully', 'webp_images'), 'admin');
    header('Location:' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=webp_images/admin/configure.php');
    exit;
  }
  

  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value
  $quality = mb_param_update('quality', 'plugin_action', 'value', 'plugin-webp_images');
  $types = mb_param_update('types', 'plugin_action', 'value', 'plugin-webp_images');
  $use_imagemagick = mb_param_update('use_imagemagick', 'plugin_action', 'check', 'plugin-webp_images');
  $replace_resource_thumbnail = mb_param_update('replace_resource_thumbnail', 'plugin_action', 'check', 'plugin-webp_images');
  $replace_resource_preview = mb_param_update('replace_resource_preview', 'plugin_action', 'check', 'plugin-webp_images');
  $replace_resource_normal = mb_param_update('replace_resource_normal', 'plugin_action', 'check', 'plugin-webp_images');
  $generate_if_missing = mb_param_update('generate_if_missing', 'plugin_action', 'check', 'plugin-webp_images');

  $types_array = explode(',', $types);


  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'webp_images') );
  }
?>


<div class="mb-body">
  <!-- CONFIGURE SECTION -->
  
  <?php if(wbp_can_use_imagemagick() == false && wbp_can_use_gd() == false) { ?>
    <div class="mb-errors">
      <div class="mb-line"><?php _e('GD Library & ImageMagick with WebP support are not available on your hosting. Contact them for support.', 'webp_images'); ?></div>
    </div>
  <?php } ?>

  <?php if(!wbp_can_use_imagemagick()) { ?>
    <div class="mb-notes">
      <div class="mb-line"><?php _e('You do not have ImageMagick library installed on your hosting or it does not support WebP images. You may contact your hosting provider for help. Plugin will use GD library instead.', 'webp_images'); ?></div>
    </div>
  <?php } ?>
  
  <div class="mb-notes">
    <div class="mb-line"><?php _e('WebP images are automatically generated on newly created listings.', 'webp_images'); ?></div>
    <div class="mb-line"><?php _e('In order to generate or regenerate WebP images for existing listing, simply go to Settings > Media and regenerate thumbnails.', 'webp_images'); ?></div>
  </div>
  
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-wrench"></i> <?php _e('Configure', 'webp_images'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />


        <div class="mb-row">
          <label for="quality"><span><?php _e('Quality of Images', 'webp_images'); ?></span></label> 
          <input type="number" size="10" name="quality" id="quality" value="<?php echo $quality; ?>" min="0" max="100"/>
          <div class="mb-input-desc"><?php _e('%', 'webp_images'); ?></div>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('Enter in what quality WebP images will be generated. 0 is lowest, means smallest file. 100 is highest, means biggest file.', 'webp_images'); ?></div>
            <div class="mb-line"><?php _e('Recommended value: 70', 'webp_images'); ?></div>
          </div>
        </div>
        
        <div class="mb-row mb-row-select-multiple">
          <label for="types_multiple"><span><?php _e('Image Sizes for those WebP Images will be Generated', 'webp_images'); ?></span></label> 

          <input type="hidden" name="types" id="types" value="<?php echo $types; ?>"/>
          <select id="types_multiple" name="types_multiple" multiple>
            <option value="thumbnail" <?php if(in_array('thumbnail', $types_array)) { ?>selected="selected"<?php } ?>><?php _e('Thumbnail', 'webp_images'); ?></option>
            <option value="preview" <?php if(in_array('preview', $types_array)) { ?>selected="selected"<?php } ?>><?php _e('Preview', 'webp_images'); ?></option>
            <option value="normal" <?php if(in_array('normal', $types_array)) { ?>selected="selected"<?php } ?>><?php _e('Normal', 'webp_images'); ?></option>
          </select>

          <div class="mb-explain"><?php _e('Select for what type of listing images (resources) will be WebP images generated.', 'webp_images'); ?></div>
        </div>
        


        <div class="mb-row">
          <label for="use_imagemagick"><span><?php _e('Use ImageMagick instead of GD library', 'webp_images'); ?></span></label> 
          <input name="use_imagemagick" id="use_imagemagick" type="checkbox" class="element-slide" <?php echo ($use_imagemagick == 1 ? 'checked' : ''); ?> <?php if(!wbp_can_use_imagemagick()) { ?>disabled<?php } ?> />
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, default JPG/PNG url for thumbnails is replaced with URL to WebP image.', 'webp_images'); ?></div>
            
            <?php if(!wbp_can_use_imagemagick()) { ?>
              <strong class="mb-line"><?php _e('WARNING: Your hosting does not support WebP format in ImageMagick or ImageMagick library is not installed on your hosting.', 'webp_images'); ?></strong>
            <?php } ?>
          </div>
        </div>


        <div class="mb-row">
          <label for="generate_if_missing"><span><?php _e('Generate WEBP image if missing', 'webp_images'); ?></span></label> 
          <input name="generate_if_missing" id="generate_if_missing" type="checkbox" class="element-slide" <?php echo ($generate_if_missing == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled and WEBP image that does not exists is requested on listing page (resource), it is automatically generated.', 'webp_images'); ?></div>
            <div class="mb-line"><?php _e('On generation (first load), can cause small delay when loading page - until WEBP is generated. Can be used as alternative to image regeneration when there is too many resources.', 'webp_images'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">
          <label for="replace_resource_thumbnail"><span><?php _e('Replace Thumbnail URL with WebP URL', 'webp_images'); ?></span></label> 
          <input name="replace_resource_thumbnail" id="replace_resource_thumbnail" type="checkbox" class="element-slide" <?php echo ($replace_resource_thumbnail == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, default JPG/PNG url for thumbnail images is replaced with URL to WebP image.', 'webp_images'); ?></div>
            <div class="mb-line"><?php _e('No modifications are required in your theme to use WebP images, but may bring compatilibity issues with old/legacy browsers.', 'webp_images'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="replace_resource_preview"><span><?php _e('Replace Preview URL with WebP URL', 'webp_images'); ?></span></label> 
          <input name="replace_resource_preview" id="replace_resource_preview" type="checkbox" class="element-slide" <?php echo ($replace_resource_preview == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, default JPG/PNG url for preview images is replaced with URL to WebP image.', 'webp_images'); ?></div>
            <div class="mb-line"><?php _e('No modifications are required in your theme to use WebP images, but may bring compatilibity issues with old/legacy browsers.', 'webp_images'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="replace_resource_normal"><span><?php _e('Replace Default URL with WebP URL', 'webp_images'); ?></span></label> 
          <input name="replace_resource_normal" id="replace_resource_normal" type="checkbox" class="element-slide" <?php echo ($replace_resource_normal == 1 ? 'checked' : ''); ?> />
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, default JPG/PNG url for normal images is replaced with URL to WebP image.', 'webp_images'); ?></div>
            <div class="mb-line"><?php _e('No modifications are required in your theme to use WebP images, but may bring compatilibity issues with old/legacy browsers.', 'webp_images'); ?></div>
          </div>
        </div>        
        
        
        
        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(wbp_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'webp_images')); ?>"><?php _e('Save', 'webp_images');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'webp_images');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>



  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-dashboard"></i> <?php _e('WebP Images', 'webp_images'); ?></div>
    <div class="mb-inside">
      <strong class="mb-row"><?php echo sprintf(__('%d WebP images has been generated by plugin.', 'webp_images'), wbp_count_webp_images()); ?></strong>

      <div class="mb-row" style="margin-top:12px;">
        <?php if(wbp_is_demo()) { ?>
          <a href="#" class="mb-button-blue mb-add mb-disabled" style="cursor:not-allowed;opacity:0.5;" onclick="return false;" disabled><i class="fa fa-trash" title="<?php echo osc_esc_html(__('This action cannot be done as this is demo site', 'webp_images')); ?>"></i><?php _e('Remove WebP Images', 'webp_images'); ?></a>
        <?php } else { ?>
          <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=webp_images/admin/configure.php&what=remove" class="mb-button-blue mb-add" onclick="return confirm('<?php echo osc_esc_js(__('Are you sure you want to remove all WebP images? Action cannot be undone', 'webp_images')); ?>');"><i class="fa fa-trash"></i><?php _e('Remove WebP Images', 'webp_images'); ?></a>
        <?php } ?>
      </div>

    </div>
  </div>


  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'webp_images'); ?></div>

    <div class="mb-inside">
      <div class="mb-row"><?php _e('No theme modification are required to use all functions of plugin, but in order to provide compatibility to old browsers, you may use following functions.', 'webp_images'); ?></div>
      <div class="mb-row">
        <strong><?php _e('Use WebP images as thumbnail image, if browser does not support WebP, use original resource/image:', 'webp_images'); ?></strong>

        <span class="mb-line"><?php _e('Find code using osc_resource_thumbnail_url function (may differ based on theme). Usually in files loop-single.php, item.php', 'webp_images'); ?></span>
        <span class="mb-code">&lt;img src="&lt;?php echo osc_resource_thumbnail_url()); ?&gt;"/&gt;</span>
        
        <span class="mb-line"><?php _e('Replace it with:', 'webp_images'); ?></span>
        <span class="mb-code">&lt;php echo wbp_thumbnail_resource_tag()); ?&gt;</span>

        <span class="mb-line">&nbsp;</span>
        

        <strong><?php _e('Use WebP images as preview image, if browser does not support WebP, use original resource/image:', 'webp_images'); ?></strong>

        <span class="mb-line"><?php _e('Find code using osc_resource_preview_url function (may differ based on theme). Usually in files loop-single.php, item.php', 'webp_images'); ?></span>
        <span class="mb-code">&lt;img src="&lt;?php echo osc_resource_preview_url()); ?&gt;"/&gt;</span>
        
        <span class="mb-line"><?php _e('Replace it with:', 'webp_images'); ?></span>
        <span class="mb-code">&lt;php echo wbp_preview_resource_tag()); ?&gt;</span>
        <span class="mb-line">&nbsp;</span>
        
        
        <strong><?php _e('Use WebP images as normal image, if browser does not support WebP, use original resource/image:', 'webp_images'); ?></strong>

        <span class="mb-line"><?php _e('Find code using osc_resource_url function (may differ based on theme). Usually in files loop-single.php, item.php', 'webp_images'); ?></span>
        <span class="mb-code">&lt;img src="&lt;?php echo osc_resource_url()); ?&gt;"/&gt;</span>
        
        <span class="mb-line"><?php _e('Replace it with:', 'webp_images'); ?></span>
        <span class="mb-code">&lt;php echo wbp_normal_resource_tag()); ?&gt;</span>
        <span class="mb-line">&nbsp;</span>
        
        <strong><?php _e('Covert standard image to WEBP variant:', 'webp_images'); ?></strong>
        <span class="mb-code">&lt;?php echo wbp_image_to_webp($source_img_path, $target_img_path = ""); ?&gt;</span>
        <span class="mb-line">&nbsp;</span>
        
        <strong><?php _e('Get WEBP url of standard image. If does not exists, generate WEBP image (return source img if webp could not be created):', 'webp_images'); ?></strong>
        <span class="mb-code">&lt;?php echo wbp_get_webp_img($source_url, $generate_if_missing = true, $generate_force = false); ?&gt;</span>
        
      </div>

    </div>
  </div>
</div>


<?php echo wbp_footer(); ?>