<?php
/*
  Plugin Name: WebP Images Generator Osclass Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/design-and-appearance/webp-images-generator-plugin-i177
  Description: Create WebP listing images copies those can be used as optimized versions of JPG, JPEG, GIF or PNG images
  Version: 1.1.2
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: webp_images
  Plugin update URI: webp-images
  Support URI: https://forums.osclasspoint.com/
  Product Key: nqygcFAScb360OQIyr5L
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelWBP.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';



// INSTALL FUNCTION - DEFINE VARIABLES
function wbp_call_after_install() {
  osc_set_preference('types', 'thumbnail,preview,normal', 'plugin-webp_images', 'STRING');
  osc_set_preference('quality', 70, 'plugin-webp_images', 'INTEGER');
  osc_set_preference('use_imagemagick', '', 'plugin-webp_images', 'STRING');
  osc_set_preference('replace_resource_thumbnail', 0, 'plugin-webp_images', 'INTEGER');
  osc_set_preference('replace_resource_preview', 0, 'plugin-webp_images', 'INTEGER');
  osc_set_preference('replace_resource_normal', 0, 'plugin-webp_images', 'INTEGER');
  osc_set_preference('generate_if_missing', 0, 'plugin-webp_images', 'INTEGER');

  ModelWBP::newInstance()->install();
}


function wbp_call_after_uninstall() {
  ModelWBP::newInstance()->uninstall();
}


// ADMIN MENU
function wbp_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/webp_images/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/webp_images/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/webp_images/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/webp_images/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/webp_images/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/webp_images/js/bootstrap-switch.js"></script>';

  if( $title == '') { $title = __('Configure', 'webp_images'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>WebP Images Generator Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=webp_images/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'webp_images') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function wbp_footer() {
  $pluginInfo = osc_plugin_get_info('webp_images/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint Market" /> OsclassPoint Market</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'webp_images') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'webp_images') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'webp_images') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function wbp_admin_menu() {
echo '<h3><a href="#">WebP Images Generator Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'webp_images') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','wbp_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function wbp_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'wbp_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'wbp_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'wbp_call_after_uninstall');

?>