<?php
class ModelWBP extends DAO {
private static $instance;

public static function newInstance() {
  if( !self::$instance instanceof self ) {
    self::$instance = new self;
  }
  return self::$instance;
}

function __construct() {
  parent::__construct();
}

public function getTable_item() {
  return DB_TABLE_PREFIX.'t_item';
}

public function getTable_resource() {
  return DB_TABLE_PREFIX.'t_item_resource';
}


public function import($file) {
  $path = osc_plugin_resource($file);
  $sql = file_get_contents($path);

  if(!$this->dao->importSQL($sql) ){
    throw new Exception("Error importSQL::ModelWBP<br>" . $file . "<br>" . $this->dao->getErrorLevel() . " - " . $this->dao->getErrorDesc() );
  }
}


public function install($version = '') {
  if($version == '') {
    //$this->import('webp_images/model/struct.sql');
    osc_set_preference('version', 100, 'plugin-webp_images', 'INTEGER');
  }

}


public function uninstall() {
  // DELETE ALL TABLES
  //$this->dao->query(sprintf('DROP TABLE %s', $this->getTable_webp_images()));


  // DELETE ALL PREFERENCES
  $db_prefix = DB_TABLE_PREFIX;
  $query = "DELETE FROM {$db_prefix}t_preference WHERE s_section = 'plugin-webp_images'";
  $this->dao->query($query);
}



// GET webp_images OPTION
public function getResource($id) {
  $this->dao->select();
  $this->dao->from($this->getTable_resource());
  $this->dao->where('pk_i_id', $id);
  $result = $this->dao->get();
  
  if($result) {
    $data = $result->row();
    return $data;
  }
  
  return false;
}


// GET webp_images OPTIONS
public function getItemResources($item_id) {
  $this->dao->select();
  $this->dao->from($this->getTable_resource());
  $this->dao->where('fk_i_item_id', $item_id);
  $result = $this->dao->get();
  
  if($result) {
    $data = $result->result();
    return $data;
  }
  
  return array();
}



}
?>