<?php
  // Create menu
  $title = __('Configure', 'youtube');
  ytb_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  $hook_post = mb_param_update('hook_post', 'plugin_action', 'check', 'plugin-ytb');
  $hook_item = mb_param_update('hook_item', 'plugin_action', 'check', 'plugin-ytb');
  $width = mb_param_update('width', 'plugin_action', 'value', 'plugin-ytb');
  $height = mb_param_update('height', 'plugin_action', 'value', 'plugin-ytb');
  $category = mb_param_update('category', 'plugin_action', 'value', 'plugin-auto_renewal');

  $category_array = explode(',', $category);
  $category_all = Category::newInstance()->listAll();

  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'youtube') );
  }
?>


<div class="mb-body">


  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Configure', 'youtube'); ?></div>

    <div class="mb-inside mb-minify">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <?php if(!ytb_is_demo()) { ?>
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <?php } ?>

        <div class="mb-row">
          <label for="hook_item" class="h1"><span><?php _e('Item Detail Hook', 'youtube'); ?></span></label> 
          <input name="hook_item" type="checkbox" class="element-slide" <?php echo ($hook_item == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, video is placed automatically on listing page to hook item_detail.', 'youtube'); ?></div>
        </div>

        <div class="mb-row">
          <label for="hook_post" class="h2"><span><?php _e('Item Form Hook', 'youtube'); ?></span></label> 
          <input name="hook_post" type="checkbox" class="element-slide" <?php echo ($hook_post == 1 ? 'checked' : ''); ?> />

          <div class="mb-explain"><?php _e('When enabled, video is placed automatically on publish/edit page into hooks item_form/edit_item.', 'youtube'); ?></div>
        </div>

        <div class="mb-row">
          <label for="width" class="h3"><span><?php _e('Default Video Box Size', 'youtube'); ?></span></label> 
          <input name="width" size="10" type="text" value="<?php echo $width; ?>" />
          <div class="mb-input-desc" style="float: left; margin-right: -4px; border-radius: 0;">x</div>

          <input name="height" size="10" type="text" value="<?php echo $height; ?>" />
          <div class="mb-input-desc">px</div>

          <div class="mb-explain"><?php _e('Default size is 560x315 px, video box is responsive', 'youtube'); ?></div>
        </div>


        <div class="mb-row mb-row-select-multiple">
          <label for="category_multiple"><span><?php _e('Restrict Videos by Category', 'youtube'); ?></span></label> 

          <input type="hidden" name="category" id="type_category_ids" value="<?php echo $category; ?>"/>
          <select id="category_multiple" name="category_multiple" multiple>
            <?php echo ytb_cat_list($category_array, $category_all); ?>
          </select>

          <div class="mb-explain">
            <div class="mb-line"><?php _e('If no category selected, videos will be available in categories.', 'youtube'); ?></div>
          </div>
        </div>
        
        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(ytb_is_demo()) { ?>
            <a class="mb-button mb-has-tooltip disabled" onclick="return false;" style="cursor:not-allowed;opacity:0.5;" title="<?php echo osc_esc_html(__('This is demo site', 'youtube')); ?>"><?php _e('Save', 'youtube');?></a>
          <?php } else { ?>
            <button type="submit" class="mb-button"><?php _e('Save', 'youtube');?></button>
          <?php } ?>
        </div>
      </form>
    </div>
  </div>


  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'youtube'); ?></div>

    <div class="mb-inside">

      <div class="mb-row">
        <div class="mb-line"><?php _e('Plugin does not require any modifications in theme files.', 'youtube'); ?></div>
        <div class="mb-line"><?php _e('In case you want show video box on other space than item_detail hook, disable auto-hook above and put into item.php following code:', 'youtube'); ?></div>
        
        <div class="mb-row"><span class="mb-code">&lt;?php echo ytb_video_box(osc_item_id()); ?&gt;</span></div>
        
        <div class="mb-line"><?php _e('In case you want show video box form (input) on other space than item_form/edit_item hook on publish/edit page, disable auto-hook above and put into item-post.php/item-edit.php following code:', 'youtube'); ?></div>
        <div class="mb-row"><span class="mb-code">&lt;?php echo ytb_video_form(); ?&gt;</span></div>

      </div>
    </div>
  </div>
</div>


<?php echo ytb_footer(); ?>