<?php
/*
  Plugin Name: Youtube Video Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/extra-fields-and-other/youtube-video-osclass-plugin-i107
  Description: Youtube Video Plugin allows visitors to place youtube video into their listing
  Version: 1.1.3
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: youtube
  Plugin update URI: osclasspoint-youtube
  Support URI: https://forums.osclasspoint.com/
  Product Key: zyrLNTohHi1nykfew2hM
*/

require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelYTB.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';



// INSTALL FUNCTION - DEFINE VARIABLES
function ytb_call_after_install() {
  osc_set_preference('hook_item', 1, 'plugin-ytb', 'INTEGER');
  osc_set_preference('hook_post', 1, 'plugin-ytb', 'INTEGER');
  osc_set_preference('width', 560, 'plugin-ytb', 'INTEGER');
  osc_set_preference('height', 315, 'plugin-ytb', 'INTEGER');

  ModelYTB::newInstance()->install();
}


function ytb_call_after_uninstall() {
  ModelYTB::newInstance()->uninstall();
}



// ADMIN MENU
function ytb_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/youtube/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/youtube/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/youtube/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="//fonts.googleapis.com/css?family=Open+Sans:300,600&amp;subset=latin,latin-ext" rel="stylesheet" type="text/css" />';
  echo '<link href="//maxytb.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/youtube/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/youtube/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/youtube/js/bootstrap-switch.js"></script>';



  if( $title == '') { $title = __('Configure', 'youtube'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Youtube Video Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=youtube/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'youtube') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function ytb_footer() {
  $pluginInfo = osc_plugin_get_info('youtube/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="OsclassPoint Market" /> OsclassPoint Market</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'youtube') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'youtube') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'youtube') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function ytb_admin_menu() {
echo '<h3><a href="#">Youtube Video Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'youtube') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','ytb_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function ytb_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'ytb_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'ytb_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'ytb_call_after_uninstall');

?>