<?php
class ModelYTB extends DAO {
private static $instance;

public static function newInstance() {
  if( !self::$instance instanceof self ) {
    self::$instance = new self;
  }
  return self::$instance;
}

function __construct() {
  parent::__construct();
}


public function getTable_item() {
  return DB_TABLE_PREFIX.'t_item';
}


public function getTable_youtube() {
  return DB_TABLE_PREFIX.'t_item_youtube';
}


public function import($file) {
  $path = osc_plugin_resource($file);
  $sql = file_get_contents($path);

  if(!$this->dao->importSQL($sql) ){
    throw new Exception("Error importSQL::ModelYTB<br>" . $file . "<br>" . $this->dao->getErrorLevel() . " - " . $this->dao->getErrorDesc() );
  }
}


public function install($version = '') {
  if($version == '') {
    $this->import('youtube/model/struct.sql');

    osc_set_preference('version', 100, 'plugin-ytb', 'INTEGER');
  }
}


public function uninstall() {
  // DELETE ALL TABLES
  $this->dao->query(sprintf('DROP TABLE %s', $this->getTable_youtube()));


  // DELETE ALL PREFERENCES
  $db_prefix = DB_TABLE_PREFIX;
  $query = "DELETE FROM {$db_prefix}t_preference WHERE s_section = 'plugin-ytb'";
  $this->dao->query($query);
}

// GET VIDEO BY ID
public function getVideoByCode($code) {
  $this->dao->select('*');
  $this->dao->from($this->getTable_youtube());
  $this->dao->where('s_code', $code);

  $result = $this->dao->get();
  
  if($result) {
    return $result->row();
  }

  return '';
}

// GET VIDEO FOR ITEM
public function getVideoByItemId($item_id) {
  $this->dao->select('*');
  $this->dao->from($this->getTable_youtube());
  $this->dao->where('fk_i_item_id', $item_id);

  $result = $this->dao->get();
  
  if($result) {
    return $result->row();
  }

  return '';
}

// DELETE VIDEO BY ITEM ID
public function removeVideoByItemId($item_id) {
  return $this->dao->delete($this->getTable_youtube(), array('fk_i_item_id' => $item_id));
}


// UPDATE ITEM VIDEO
public function updateVideoByItemId($item_id, $code, $url) {
  $this->dao->replace($this->getTable_youtube(), array('fk_i_item_id' => $item_id, 's_code' => $code, 's_url' => $url));
}



}
?>